/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/network","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/types","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/base/common/map","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","vs/base/common/performance","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],J=function(V){for(var t=[],T=0,S=V.length;T<S;T++)t[T]=Y[V[T]];return t};define(Y[56],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(S,w){if(!S)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=T}),define(Y[45],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(R){return(L,l,d)=>{let E=null,D=null;if(typeof d.value=="function"?(E="value",D=d.value):typeof d.get=="function"&&(E="get",D=d.get),!D)throw new Error("not supported");d[E]=R(D,l)}}t.createDecorator=T;function S(R,L,l){let d=null,E=null;if(typeof l.value=="function"?(d="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",E=l.get),!E)throw new Error("not supported");const D=`$memoize$${L}`;l[d]=function(...g){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,g)}),this[D]}}t.memoize=S;function w(R,L,l){return T((d,E)=>{const D=`$debounce$${E}`,g=`$debounce$result$${E}`;return function(...b){this[g]||(this[g]=l?l():void 0),clearTimeout(this[D]),L&&(this[g]=L(this[g],...b),b=[this[g]]),this[D]=setTimeout(()=>{d.apply(this,b),this[g]=l?l():void 0},R)}})}t.debounce=w;function P(R,L,l){return T((d,E)=>{const D=`$throttle$timer$${E}`,g=`$throttle$result$${E}`,b=`$throttle$lastRun$${E}`,u=`$throttle$pending$${E}`;return function(...c){if(this[g]||(this[g]=l?l():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),L&&(this[g]=L(this[g],...c)),this[u])return;const y=this[b]+R;y<=Date.now()?(this[b]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0):(this[u]=!0,this[D]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0},y-Date.now()))}})}t.throttle=P}),define(Y[57],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var S;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(S=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var P;(function(e){e.DEFAULT={allowTrailingComma:!0}})(P=t.ParseOptions||(t.ParseOptions={}));function R(e,i=!1){let n=0,r=e.length,a="",m=0,I=16,O=0;function p(te){let ue=0,oe=0;for(;ue<te;){const B=e.charCodeAt(n);if(B>=48&&B<=57)oe=oe*16+B-48;else if(B>=65&&B<=70)oe=oe*16+B-65+10;else if(B>=97&&B<=102)oe=oe*16+B-97+10;else break;n++,ue++}return ue<te&&(oe=-1),oe}function C(te){n=te,a="",m=0,I=16,O=0}function A(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return O=3,e.substring(te,n);let ue=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;ue=n}else O=3;return e.substring(te,ue)}function x(){let te="",ue=n;for(;;){if(n>=r){te+=e.substring(ue,n),O=2;break}const oe=e.charCodeAt(n);if(oe===34){te+=e.substring(ue,n),n++;break}if(oe===92){if(te+=e.substring(ue,n),n++,n>=r){O=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const ne=p(4);ne>=0?te+=String.fromCharCode(ne):O=4;break;default:O=5}ue=n;continue}if(oe>=0&&oe<=31)if(l(oe)){te+=e.substring(ue,n),O=2;break}else O=6;n++}return te}function K(){if(a="",O=0,m=n,n>=r)return m=r,I=17;let te=e.charCodeAt(n);if(L(te)){do n++,a+=String.fromCharCode(te),te=e.charCodeAt(n);while(L(te));return I=15}if(l(te))return n++,a+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),I=14;switch(te){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,a=x(),I=10;case 47:const ue=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(e.charCodeAt(n));)n++;return a=e.substring(ue,n),I=12}if(e.charCodeAt(n+1)===42){n+=2;const oe=r-1;let B=!1;for(;n<oe;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,O=1),a=e.substring(ue,n),I=13}return a+=String.fromCharCode(te),n++,I=16;case 45:if(a+=String.fromCharCode(te),n++,n===r||!d(e.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=A(),I=11;default:for(;n<r&&ee(te);)n++,te=e.charCodeAt(n);if(m!==n){switch(a=e.substring(m,n),a){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return a+=String.fromCharCode(te),n++,I=16}}function ee(te){if(L(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let te;do te=K();while(te>=12&&te<=15);return te}return{setPosition:C,getPosition:()=>n,scan:i?ae:K,getToken:()=>I,getTokenValue:()=>a,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>O}}t.createScanner=R;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var E;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(E||(E={}));function D(e,i){const n=[],r=new Object;let a;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function O(p,C,A,x){m.value=p,m.offset=C,m.length=A,m.type=x,m.colonOffset=void 0,a=m}try{h(e,{onObjectBegin:(p,C)=>{if(i<=p)throw r;a=void 0,I=i>p,n.push("")},onObjectProperty:(p,C,A)=>{if(i<C||(O(p,C,A,"property"),n[n.length-1]=p,i<=C+A))throw r},onObjectEnd:(p,C)=>{if(i<=p)throw r;a=void 0,n.pop()},onArrayBegin:(p,C)=>{if(i<=p)throw r;a=void 0,n.push(0)},onArrayEnd:(p,C)=>{if(i<=p)throw r;a=void 0,n.pop()},onLiteralValue:(p,C,A)=>{if(i<C||(O(p,C,A,s(p)),i<=C+A))throw r},onSeparator:(p,C,A)=>{if(i<=C)throw r;if(p===":"&&a&&a.type==="property")a.colonOffset=C,I=!1,a=void 0;else if(p===","){const x=n[n.length-1];typeof x=="number"?n[n.length-1]=x+1:(I=!0,n[n.length-1]=""),a=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:a,isAtPropertyKey:I,matches:p=>{let C=0;for(let A=0;C<p.length&&A<n.length;A++)if(p[C]===n[A]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}t.getLocation=D;function g(e,i=[],n=P.DEFAULT){let r=null,a=[];const m=[];function I(p){Array.isArray(a)?a.push(p):r!==null&&(a[r]=p)}return h(e,{onObjectBegin:()=>{const p={};I(p),m.push(a),a=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const p=[];I(p),m.push(a),a=p,r=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:I,onError:(p,C,A)=>{i.push({error:p,offset:C,length:A})}},n),a[0]}t.parse=g;function b(e,i=[],n=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function m(p){return r.children.push(p),p}h(e,{onObjectBegin:p=>{r=m({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,C,A)=>{r=m({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:C,length:A,parent:r})},onObjectEnd:(p,C)=>{r.length=p+C-r.offset,r=r.parent,a(p+C)},onArrayBegin:(p,C)=>{r=m({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,C)=>{r.length=p+C-r.offset,r=r.parent,a(p+C)},onLiteralValue:(p,C,A)=>{m({type:s(p),offset:C,length:A,parent:r,value:p}),a(C+A)},onSeparator:(p,C,A)=>{r.type==="property"&&(p===":"?r.colonOffset=C:p===","&&a(C))},onError:(p,C,A)=>{i.push({error:p,offset:C,length:A})}},n);const O=r.children[0];return O&&delete O.parent,O}t.parseTree=b;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===r){n=m.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function c(e){if(!e.parent||!e.parent.children)return[];const i=c(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=c;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=y(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=y;function v(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=v;function f(e,i,n=!1){if(v(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const m=f(r[a],i,n);if(m)return m}return e}}t.findNodeAtOffset=f;function h(e,i,n=P.DEFAULT){const r=R(e,!1);function a(H){return H?()=>H(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(H){return H?Z=>H(Z,r.getTokenOffset(),r.getTokenLength()):()=>!0}const I=a(i.onObjectBegin),O=m(i.onObjectProperty),p=a(i.onObjectEnd),C=a(i.onArrayBegin),A=a(i.onArrayEnd),x=m(i.onLiteralValue),K=m(i.onSeparator),ee=a(i.onComment),ae=m(i.onError),te=n&&n.disallowComments,ue=n&&n.allowTrailingComma;function oe(){for(;;){const H=r.scan();switch(r.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:te||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(H){case 12:case 13:te?B(10):ee();break;case 16:B(1);break;case 15:case 14:break;default:return H}}}function B(H,Z=[],q=[]){if(ae(H),Z.length+q.length>0){let U=r.getToken();for(;U!==17;){if(Z.indexOf(U)!==-1){oe();break}else if(q.indexOf(U)!==-1)break;U=oe()}}}function ne(H){const Z=r.getTokenValue();return H?x(Z):O(Z),oe(),!0}function M(){switch(r.getToken()){case 11:let H=0;try{H=JSON.parse(r.getTokenValue()),typeof H!="number"&&(B(2),H=0)}catch(Z){B(2)}x(H);break;case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return oe(),!0}function F(){return r.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(K(":"),oe(),ie()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function z(){I(),oe();let H=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(H||B(4,[],[]),K(","),oe(),r.getToken()===2&&ue)break}else H&&B(6,[],[]);F()||B(4,[],[2,5]),H=!0}return p(),r.getToken()!==2?B(7,[2],[]):oe(),!0}function G(){C(),oe();let H=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(H||B(4,[],[]),K(","),oe(),r.getToken()===4&&ue)break}else H&&B(6,[],[]);ie()||B(4,[],[4,5]),H=!0}return A(),r.getToken()!==4?B(8,[4],[]):oe(),!0}function ie(){switch(r.getToken()){case 3:return G();case 1:return z();case 10:return ne(!0);default:return M()}}return oe(),r.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):ie()?(r.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}t.visit=h;function o(e,i){let n=R(e),r=[],a,m=0,I;do switch(I=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:m!==I&&r.push(e.substring(m,I)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),m=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function V(w){const P=[];typeof w=="number"&&P.push("code/timeOrigin",w);function R(l){P.push(l,Date.now())}function L(){const l=[];for(let d=0;d<P.length;d+=2)l.push({name:P[d],startTime:P[d+1]});return l}return{mark:R,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const R of performance.getEntriesByType("mark"))P.push({name:R.name,startTime:Math.round(w+R.startTime)});return P}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function T(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=T(S))}(),define(Y[58],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var T;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(T=t.Source||(t.Source={}));var S;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(S=t.TerminateResponseCode||(t.TerminateResponseCode={}));function w(P,...R){const L=R.reduce((E,D)=>(E[D]=!0,E),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(E=>!L[E]).forEach(E=>{for(let D=0;D<l.length;D++)if(E.search(l[D])!==-1){delete P[E];break}})}t.sanitizeProcessEnvironment=w}),function(V,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var S in T)(typeof exports=="object"?exports:V)[S]=T[S]}}(typeof self!="undefined"?self:this,function(){return function(V){var t={};function T(S){if(t[S])return t[S].exports;var w=t[S]={i:S,l:!1,exports:{}};return V[S].call(w.exports,w,w.exports,T),w.l=!0,w.exports}return T.m=V,T.c=t,T.d=function(S,w,P){T.o(S,w)||Object.defineProperty(S,w,{enumerable:!0,get:P})},T.r=function(S){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},T.t=function(S,w){if(1&w&&(S=T(S)),8&w||4&w&&typeof S=="object"&&S&&S.__esModule)return S;var P=Object.create(null);if(T.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:S}),2&w&&typeof S!="string")for(var R in S)T.d(P,R,function(L){return S[L]}.bind(null,R));return P},T.n=function(S){var w=S&&S.__esModule?function(){return S.default}:function(){return S};return T.d(w,"a",w),w},T.o=function(S,w){return Object.prototype.hasOwnProperty.call(S,w)},T.p="",T(T.s=0)}([function(V,t,T){(function(S){var w;t=V.exports=q,w=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var k=Array.prototype.slice.call(arguments,0);k.unshift("SEMVER"),console.log.apply(console,k)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var P=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],l=t.src=[],d=0,E=d++;l[E]="0|[1-9]\\d*";var D=d++;l[D]="[0-9]+";var g=d++;l[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=d++;l[b]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var u=d++;l[u]="("+l[D]+")\\.("+l[D]+")\\.("+l[D]+")";var c=d++;l[c]="(?:"+l[E]+"|"+l[g]+")";var y=d++;l[y]="(?:"+l[D]+"|"+l[g]+")";var v=d++;l[v]="(?:-("+l[c]+"(?:\\."+l[c]+")*))";var f=d++;l[f]="(?:-?("+l[y]+"(?:\\."+l[y]+")*))";var h=d++;l[h]="[0-9A-Za-z-]+";var o=d++;l[o]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var s=d++,e="v?"+l[b]+l[v]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[u]+l[f]+"?"+l[o]+"?",n=d++;l[n]="^"+i+"$";var r=d++;l[r]="((?:<|>)?=?)";var a=d++;l[a]=l[D]+"|x|X|\\*";var m=d++;l[m]=l[E]+"|x|X|\\*";var I=d++;l[I]="[v=\\s]*("+l[m]+")(?:\\.("+l[m]+")(?:\\.("+l[m]+")(?:"+l[v]+")?"+l[o]+"?)?)?";var O=d++;l[O]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[f]+")?"+l[o]+"?)?)?";var p=d++;l[p]="^"+l[r]+"\\s*"+l[I]+"$";var C=d++;l[C]="^"+l[r]+"\\s*"+l[O]+"$";var A=d++;l[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=d++;l[x]="(?:~>?)";var K=d++;l[K]="(\\s*)"+l[x]+"\\s+",L[K]=new RegExp(l[K],"g");var ee=d++;l[ee]="^"+l[x]+l[I]+"$";var ae=d++;l[ae]="^"+l[x]+l[O]+"$";var te=d++;l[te]="(?:\\^)";var ue=d++;l[ue]="(\\s*)"+l[te]+"\\s+",L[ue]=new RegExp(l[ue],"g");var oe=d++;l[oe]="^"+l[te]+l[I]+"$";var B=d++;l[B]="^"+l[te]+l[O]+"$";var ne=d++;l[ne]="^"+l[r]+"\\s*("+i+")$|^$";var M=d++;l[M]="^"+l[r]+"\\s*("+e+")$|^$";var F=d++;l[F]="(\\s*)"+l[r]+"\\s*("+i+"|"+l[I]+")",L[F]=new RegExp(l[F],"g");var z=d++;l[z]="^\\s*("+l[I]+")\\s+-\\s+("+l[I]+")\\s*$";var G=d++;l[G]="^\\s*("+l[O]+")\\s+-\\s+("+l[O]+")\\s*$";var ie=d++;l[ie]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)w(H,l[H]),L[H]||(L[H]=new RegExp(l[H]));function Z(k,j){if(k instanceof q)return k;if(typeof k!="string"||k.length>P||!(j?L[n]:L[s]).test(k))return null;try{return new q(k,j)}catch($){return null}}function q(k,j){if(k instanceof q){if(k.loose===j)return k;k=k.version}else if(typeof k!="string")throw new TypeError("Invalid Version: "+k);if(k.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof q))return new q(k,j);w("SemVer",k,j),this.loose=j;var $=k.trim().match(j?L[n]:L[s]);if(!$)throw new TypeError("Invalid Version: "+k);if(this.raw=k,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var he=+le;if(he>=0&&he<R)return he}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(k,j){var $=Z(k,j);return $?$.version:null},t.clean=function(k,j){var $=Z(k.trim().replace(/^[=v]+/,""),j);return $?$.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(k){return w("SemVer.compare",this.version,this.loose,k),k instanceof q||(k=new q(k,this.loose)),this.compareMain(k)||this.comparePre(k)},q.prototype.compareMain=function(k){return k instanceof q||(k=new q(k,this.loose)),N(this.major,k.major)||N(this.minor,k.minor)||N(this.patch,k.patch)},q.prototype.comparePre=function(k){if(k instanceof q||(k=new q(k,this.loose)),this.prerelease.length&&!k.prerelease.length)return-1;if(!this.prerelease.length&&k.prerelease.length)return 1;if(!this.prerelease.length&&!k.prerelease.length)return 0;var j=0;do{var $=this.prerelease[j],le=k.prerelease[j];if(w("prerelease compare",j,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return N($,le)}while(++j)},q.prototype.inc=function(k,j){switch(k){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",j);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",j);break;case"prepatch":this.prerelease.length=0,this.inc("patch",j),this.inc("pre",j);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",j),this.inc("pre",j);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}j&&(this.prerelease[0]===j?isNaN(this.prerelease[1])&&(this.prerelease=[j,0]):this.prerelease=[j,0]);break;default:throw new Error("invalid increment argument: "+k)}return this.format(),this.raw=this.version,this},t.inc=function(k,j,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new q(k,$).inc(j,le).version}catch(he){return null}},t.diff=function(k,j){if(Q(k,j))return null;var $=Z(k),le=Z(j);if($.prerelease.length||le.prerelease.length){for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==le[he])return"pre"+he;return"prerelease"}for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==le[he])return he},t.compareIdentifiers=N;var U=/^[0-9]+$/;function N(k,j){var $=U.test(k),le=U.test(j);return $&&le&&(k=+k,j=+j),$&&!le?-1:le&&!$?1:k<j?-1:k>j?1:0}function _(k,j,$){return new q(k,$).compare(new q(j,$))}function W(k,j,$){return _(k,j,$)>0}function X(k,j,$){return _(k,j,$)<0}function Q(k,j,$){return _(k,j,$)===0}function se(k,j,$){return _(k,j,$)!==0}function re(k,j,$){return _(k,j,$)>=0}function me(k,j,$){return _(k,j,$)<=0}function ye(k,j,$,le){var he;switch(j){case"===":typeof k=="object"&&(k=k.version),typeof $=="object"&&($=$.version),he=k===$;break;case"!==":typeof k=="object"&&(k=k.version),typeof $=="object"&&($=$.version),he=k!==$;break;case"":case"=":case"==":he=Q(k,$,le);break;case"!=":he=se(k,$,le);break;case">":he=W(k,$,le);break;case">=":he=re(k,$,le);break;case"<":he=X(k,$,le);break;case"<=":he=me(k,$,le);break;default:throw new TypeError("Invalid operator: "+j)}return he}function fe(k,j){if(k instanceof fe){if(k.loose===j)return k;k=k.value}if(!(this instanceof fe))return new fe(k,j);w("comparator",k,j),this.loose=j,this.parse(k),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(k,j){return N(j,k)},t.major=function(k,j){return new q(k,j).major},t.minor=function(k,j){return new q(k,j).minor},t.patch=function(k,j){return new q(k,j).patch},t.compare=_,t.compareLoose=function(k,j){return _(k,j,!0)},t.rcompare=function(k,j,$){return _(j,k,$)},t.sort=function(k,j){return k.sort(function($,le){return t.compare($,le,j)})},t.rsort=function(k,j){return k.sort(function($,le){return t.rcompare($,le,j)})},t.gt=W,t.lt=X,t.eq=Q,t.neq=se,t.gte=re,t.lte=me,t.cmp=ye,t.Comparator=fe;var Ie={};function pe(k,j){if(k instanceof pe)return k.loose===j?k:new pe(k.raw,j);if(k instanceof fe)return new pe(k.value,j);if(!(this instanceof pe))return new pe(k,j);if(this.loose=j,this.raw=k,this.set=k.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+k);this.format()}function Ee(k){return!k||k.toLowerCase()==="x"||k==="*"}function Ae(k,j,$,le,he,De,we,Oe,Pe,Ce,Ne,Re,Le){return((j=Ee($)?"":Ee(le)?">="+$+".0.0":Ee(he)?">="+$+"."+le+".0":">="+j)+" "+(Oe=Ee(Pe)?"":Ee(Ce)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Ce+1)+".0":Re?"<="+Pe+"."+Ce+"."+Ne+"-"+Re:"<="+Oe)).trim()}function Me(k,j){for(var $=0;$<k.length;$++)if(!k[$].test(j))return!1;if(j.prerelease.length){for($=0;$<k.length;$++)if(w(k[$].semver),k[$].semver!==Ie&&k[$].semver.prerelease.length>0){var le=k[$].semver;if(le.major===j.major&&le.minor===j.minor&&le.patch===j.patch)return!0}return!1}return!0}function xe(k,j,$){try{j=new pe(j,$)}catch(le){return!1}return j.test(k)}function ze(k,j,$,le){var he,De,we,Oe,Pe;switch(k=new q(k,le),j=new pe(j,le),$){case">":he=W,De=me,we=X,Oe=">",Pe=">=";break;case"<":he=X,De=re,we=W,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(k,j,le))return!1;for(var Ce=0;Ce<j.set.length;++Ce){var Ne=j.set[Ce],Re=null,Le=null;if(Ne.forEach(function(Fe){Fe.semver===Ie&&(Fe=new fe(">=0.0.0")),Re=Re||Fe,Le=Le||Fe,he(Fe.semver,Re.semver,le)?Re=Fe:we(Fe.semver,Le.semver,le)&&(Le=Fe)}),Re.operator===Oe||Re.operator===Pe||(!Le.operator||Le.operator===Oe)&&De(k,Le.semver)||Le.operator===Pe&&we(k,Le.semver))return!1}return!0}fe.prototype.parse=function(k){var j=this.loose?L[ne]:L[M],$=k.match(j);if(!$)throw new TypeError("Invalid comparator: "+k);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new q($[2],this.loose):this.semver=Ie},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(k){return w("Comparator.test",k,this.loose),this.semver===Ie||(typeof k=="string"&&(k=new q(k,this.loose)),ye(k,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(k,j){if(!(k instanceof fe))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new pe(k.value,j),xe(this.value,$,j);if(k.operator==="")return $=new pe(this.value,j),xe(k.semver,$,j);var le=!(this.operator!==">="&&this.operator!==">"||k.operator!==">="&&k.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||k.operator!=="<="&&k.operator!=="<"),De=this.semver.version===k.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||k.operator!==">="&&k.operator!=="<="),Oe=ye(this.semver,"<",k.semver,j)&&(this.operator===">="||this.operator===">")&&(k.operator==="<="||k.operator==="<"),Pe=ye(this.semver,">",k.semver,j)&&(this.operator==="<="||this.operator==="<")&&(k.operator===">="||k.operator===">");return le||he||De&&we||Oe||Pe},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(k){return k.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(k){var j=this.loose;k=k.trim(),w("range",k,j);var $=j?L[G]:L[z];k=k.replace($,Ae),w("hyphen replace",k),k=k.replace(L[F],"$1$2$3"),w("comparator trim",k,L[F]),k=(k=(k=k.replace(L[K],"$1~")).replace(L[ue],"$1^")).split(/\s+/).join(" ");var le=j?L[ne]:L[M],he=k.split(" ").map(function(De){return function(we,Oe){return w("comp",we),we=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(Re,Le){w("caret",Re,Le);var Fe=Le?L[B]:L[oe];return Re.replace(Fe,function(ke,ge,ve,Se,be){var Te;return w("caret",Re,ke,ge,ve,Se,be),Ee(ge)?Te="":Ee(ve)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Te=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(w("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+be+" <"+(+ge+1)+".0.0"):(w("no pr"),Te=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),w("caret return",Te),Te})}(Ne,Ce)}).join(" ")}(we,Oe),w("caret",we),we=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(Re,Le){var Fe=Le?L[ae]:L[ee];return Re.replace(Fe,function(ke,ge,ve,Se,be){var Te;return w("tilde",Re,ke,ge,ve,Se,be),Ee(ge)?Te="":Ee(ve)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Te=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(w("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0"):Te=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",w("tilde return",Te),Te})}(Ne,Ce)}).join(" ")}(we,Oe),w("tildes",we),we=function(Pe,Ce){return w("replaceXRanges",Pe,Ce),Pe.split(/\s+/).map(function(Ne){return function(Re,Le){Re=Re.trim();var Fe=Le?L[C]:L[p];return Re.replace(Fe,function(ke,ge,ve,Se,be,Te){w("xRange",Re,ke,ge,ve,Se,be,Te);var je=Ee(ve),Ve=je||Ee(Se),We=Ve||Ee(be);return ge==="="&&We&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&We?(Ve&&(Se=0),We&&(be=0),ge===">"?(ge=">=",Ve?(ve=+ve+1,Se=0,be=0):We&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+be):Ve?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":We&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),w("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(we,Oe),w("xrange",we),we=function(Pe,Ce){return w("replaceStars",Pe,Ce),Pe.trim().replace(L[ie],"")}(we,Oe),w("stars",we),we}(De,j)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(De){return!!De.match(le)})),he=he.map(function(De){return new fe(De,j)})},pe.prototype.intersects=function(k,j){if(!(k instanceof pe))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return k.set.some(function(he){return he.every(function(De){return le.intersects(De,j)})})})})},t.toComparators=function(k,j){return new pe(k,j).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(k){if(!k)return!1;typeof k=="string"&&(k=new q(k,this.loose));for(var j=0;j<this.set.length;j++)if(Me(this.set[j],k))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(k,j,$){var le=null,he=null;try{var De=new pe(j,$)}catch(we){return null}return k.forEach(function(we){De.test(we)&&(le&&he.compare(we)!==-1||(he=new q(le=we,$)))}),le},t.minSatisfying=function(k,j,$){var le=null,he=null;try{var De=new pe(j,$)}catch(we){return null}return k.forEach(function(we){De.test(we)&&(le&&he.compare(we)!==1||(he=new q(le=we,$)))}),le},t.validRange=function(k,j){try{return new pe(k,j).range||"*"}catch($){return null}},t.ltr=function(k,j,$){return ze(k,j,"<",$)},t.gtr=function(k,j,$){return ze(k,j,">",$)},t.outside=ze,t.prerelease=function(k,j){var $=Z(k,j);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(k,j,$){return k=new pe(k,$),j=new pe(j,$),k.intersects(j)},t.coerce=function(k){if(k instanceof q)return k;if(typeof k!="string")return null;var j=k.match(L[A]);return j==null?null:Z((j[1]||"0")+"."+(j[2]||"0")+"."+(j[3]||"0"))}}).call(this,T(1))},function(V,t){var T,S,w=V.exports={};function P(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function L(y){if(T===setTimeout)return setTimeout(y,0);if((T===P||!T)&&setTimeout)return T=setTimeout,setTimeout(y,0);try{return T(y,0)}catch(v){try{return T.call(null,y,0)}catch(f){return T.call(this,y,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:P}catch(y){T=P}try{S=typeof clearTimeout=="function"?clearTimeout:R}catch(y){S=R}})();var l,d=[],E=!1,D=-1;function g(){E&&l&&(E=!1,l.length?d=l.concat(d):D=-1,d.length&&b())}function b(){if(!E){var y=L(g);E=!0;for(var v=d.length;v;){for(l=d,d=[];++D<v;)l&&l[D].run();D=-1,v=d.length}l=null,E=!1,function(f){if(S===clearTimeout)return clearTimeout(f);if((S===R||!S)&&clearTimeout)return S=clearTimeout,clearTimeout(f);try{S(f)}catch(h){try{return S.call(null,f)}catch(o){return S.call(this,f)}}}(y)}}function u(y,v){this.fun=y,this.array=v}function c(){}w.nextTick=function(y){var v=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)v[f-1]=arguments[f];d.push(new u(y,v)),d.length!==1||E||L(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=c,w.addListener=c,w.once=c,w.off=c,w.removeListener=c,w.removeAllListeners=c,w.emit=c,w.prependListener=c,w.prependOnceListener=c,w.listeners=function(y){return[]},w.binding=function(y){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(y){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Y[37],J([0,1,9,2]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function w(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=w;function P(h){const o=h;return o?w(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=P;function R(h,o){return new L(h,o)}t.newWriteableStream=R;class L{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function d(h,o,s){const e=[];let i;for(;(i=h.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return h.read()}}}t.peekReadable=d;function E(h,o){return new Promise((s,e)=>{const i=[];D(h,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=E;function D(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=D;function g(h,o){return new Promise((s,e)=>{const i=new S.DisposableStore,n=[],r=I=>{if(n.push(I),n.length>o)return i.dispose(),h.pause(),s({stream:h,buffer:n,ended:!1})},a=I=>e(I),m=()=>s({stream:h,buffer:n,ended:!0});i.add((0,S.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,S.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),i.add((0,S.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}t.peekStream=g;function b(h,o){const s=R(o);return s.end(h),s}t.toStream=b;function u(){const h=R(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=u;function c(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=c;function y(h,o,s){const e=R(s);return D(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=y;function v(h,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([h,i]):h)}}}t.prefixedReadable=v;function f(h,o,s){let e=!1;const i=R(s);return D(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([h,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=f}),define(Y[17],J([0,1,37]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const S=typeof Buffer!="undefined";let w,P;class R{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return S?new R(Buffer.allocUnsafe(r)):new R(new Uint8Array(r))}static wrap(r){return S&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new R(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&S?new R(Buffer.from(r)):(w||(w=new TextEncoder),new R(w.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let O=0,p=r.length;O<p;O++)a+=r[O].byteLength}const m=R.alloc(a);let I=0;for(let O=0,p=r.length;O<p;O++){const C=r[O];m.set(C,I),I+=C.byteLength}return m}toString(){return S?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(r,a){return new R(this.buffer.subarray(r,a))}set(r,a){r instanceof R?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){E(this.buffer,r,a)}readUInt32LE(r){return D(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return b(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=R;function L(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=L;function l(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=l;function d(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=d;function E(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=E;function D(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=D;function g(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=g;function b(n,r){return n[r]}t.readUInt8=b;function u(n,r,a){n[a]=r}t.writeUInt8=u;function c(n){return T.consumeReadable(n,r=>R.concat(r))}t.readableToBuffer=c;function y(n){return T.toReadable(n)}t.bufferToReadable=y;function v(n){return T.consumeStream(n,r=>R.concat(r))}t.streamToBuffer=v;async function f(n){return n.ended?R.concat(n.buffer):R.concat([...n.buffer,await v(n.stream)])}t.bufferedStreamToBuffer=f;function h(n){return T.toStream(n,r=>R.concat(r))}t.bufferToStream=h;function o(n){return T.transform(n,{data:r=>typeof r=="string"?R.fromString(r):R.wrap(r)},r=>R.concat(r))}t.streamToBufferReadableStream=o;function s(n){return T.newWriteableStream(r=>R.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return T.prefixedReadable(n,r,a=>R.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return T.prefixedStream(n,r,a=>R.concat(a))}t.prefixedBufferStream=i}),define(Y[18],J([0,1,11]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const y=Array.isArray(c)?[]:{};return Object.keys(c).forEach(v=>{c[v]&&typeof c[v]=="object"?y[v]=S(c[v]):y[v]=c[v]}),y}t.deepClone=S;function w(c){if(!c||typeof c!="object")return c;const y=[c];for(;y.length>0;){const v=y.shift();Object.freeze(v);for(const f in v)if(P.call(v,f)){const h=v[f];typeof h=="object"&&!Object.isFrozen(h)&&y.push(h)}}return c}t.deepFreeze=w;const P=Object.prototype.hasOwnProperty;function R(c,y){return L(c,y,new Set)}t.cloneAndChange=R;function L(c,y,v){if((0,T.isUndefinedOrNull)(c))return c;const f=y(c);if(typeof f!="undefined")return f;if((0,T.isArray)(c)){const h=[];for(const o of c)h.push(L(o,y,v));return h}if((0,T.isObject)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const h={};for(let o in c)P.call(c,o)&&(h[o]=L(c[o],y,v));return v.delete(c),h}return c}function l(c,y,v=!0){return(0,T.isObject)(c)?((0,T.isObject)(y)&&Object.keys(y).forEach(f=>{f in c?v&&((0,T.isObject)(c[f])&&(0,T.isObject)(y[f])?l(c[f],y[f],v):c[f]=y[f]):c[f]=y[f]}),c):y}t.mixin=l;function d(c,y){if(c===y)return!0;if(c==null||y===null||y===void 0||typeof c!=typeof y||typeof c!="object"||Array.isArray(c)!==Array.isArray(y))return!1;let v,f;if(Array.isArray(c)){if(c.length!==y.length)return!1;for(v=0;v<c.length;v++)if(!d(c[v],y[v]))return!1}else{const h=[];for(f in c)h.push(f);h.sort();const o=[];for(f in y)o.push(f);if(o.sort(),!d(h,o))return!1;for(v=0;v<h.length;v++)if(!d(c[h[v]],y[h[v]]))return!1}return!0}t.equals=d;function E(c){const y=new Set;return JSON.stringify(c,(v,f)=>{if((0,T.isObject)(f)||Array.isArray(f)){if(y.has(f))return"[Circular]";y.add(f)}return f})}t.safeStringify=E;function D(c,y,v){const f=y(c);return typeof f=="undefined"?v:f}t.getOrDefault=D;function g(c,y){const v=Object.create(null);return!c||!y||Object.keys(y).forEach(h=>{const o=c[h],s=y[h];d(o,s)||(v[h]=s)}),v}t.distinct=g;function b(c,y){const v=y.toLowerCase(),f=Object.keys(c).find(h=>h.toLowerCase()===v);return f?c[f]:c[y]}t.getCaseInsensitive=b;function u(c,y){const v=Object.create(null);for(const f of Object.keys(c))y(f,c[f])&&(v[f]=c[f]);return v}t.filter=u}),define(Y[59],J([0,1,7]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function S(d){const E=d;return E&&typeof E.type=="string"&&typeof E.severity=="string"}t.isRemoteConsoleLog=S;function w(d){const E=[];let D;try{const g=JSON.parse(d.arguments),b=g[g.length-1];b&&b.__$stack&&(g.pop(),D=b.__$stack),E.push(...g)}catch(g){E.push("Unable to log remote console arguments",d.arguments)}return{args:E,stack:D}}t.parse=w;function P(d){if(typeof d!="string")return P(w(d).stack);const E=d;if(E){const D=R(E),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(g&&g.length===4)return{uri:T.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=P;function R(d){if(!d)return d;const E=d.indexOf(`
`);return E===-1?d:d.substring(0,E)}function L(d,E){const{args:D,stack:g}=w(d),b=typeof D[0]=="string"&&D.length===1;let u=R(g);u&&(u=`(${u.trim()})`);let c=[];if(typeof D[0]=="string"?u&&b?c=[`%c[${E}] %c${D[0]} %c${u}`,l("blue"),l(""),l("grey")]:c=[`%c[${E}] %c${D[0]}`,l("blue"),l(""),...D.slice(1)]:c=[`%c[${E}]%`,l("blue"),...D],u&&!b&&c.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,c)}t.log=L;function l(d){return`color: ${d}`}}),define(Y[60],J([0,1,17,27,7]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function P(E){return JSON.stringify(E,l)}t.stringify=P;function R(E){let D=JSON.parse(E);return D=d(D),D}t.parse=R;var L;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function l(E,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,S.regExpFlags)(D)}:D}function d(E,D=0){if(!E||D>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return w.URI.revive(E);case 2:return new RegExp(E.source,E.flags)}if(E instanceof T.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let g=0;g<E.length;++g)E[g]=d(E[g],D+1);else for(const g in E)Object.hasOwnProperty.call(E,g)&&(E[g]=d(E[g],D+1))}return E}t.revive=d}),define(Y[61],J([0,1,46,5,8,10,19,27,7]),function(V,t,T,S,w,P,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(r,a,m){if(typeof r=="string"&&(r=l.URI.file(r)),m){const O=m.getWorkspaceFolder(r);if(O){const p=m.getWorkspace().folders.length>1;let C;if((0,R.isEqual)(O.uri,r)?C="":C=(0,R.relativePath)(O.uri,r),p){const A=O.name?O.name:(0,R.basename)(O.uri);C=C?A+" \u2022 "+C:A}return C}}if(r.scheme!==S.Schemas.file&&r.scheme!==S.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(r.fsPath))return(0,w.normalize)(D(r.fsPath));let I=(0,w.normalize)(r.fsPath);return!P.isWindows&&a?.userHome&&(I=b(I,a.userHome.fsPath)),I}t.getPathLabel=d;function E(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,R.basename)(r)||(r.scheme===S.Schemas.file?r.fsPath:r.path);return P.isWindows&&(0,T.isRootOrDriveLetter)(a)?D(a):a}t.getBaseLabel=E;function D(r){return(0,T.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=D;let g=Object.create(null);function b(r,a){if(P.isWindows||!r||!a)return r;let m=g.original===a?g.normalized:void 0;return m||(m=`${(0,L.rtrim)(a,w.posix.sep)}${w.posix.sep}`,g={original:a,normalized:m}),(P.isLinux?r.startsWith(m):(0,L.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}t.tildify=b;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const c="\u2026",y="\\\\",v="~";function f(r,a=w.sep){const m=new Array(r.length);let I=!1;for(let O=0;O<r.length;O++){let p=r[O];if(p===""){m[O]=`.${a}`;continue}if(!p){m[O]=p;continue}I=!0;let C="";p.indexOf(y)===0?(C=p.substr(0,p.indexOf(y)+y.length),p=p.substr(p.indexOf(y)+y.length)):p.indexOf(a)===0?(C=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(v)===0&&(C=p.substr(0,p.indexOf(v)+v.length),p=p.substr(p.indexOf(v)+v.length));const A=p.split(a);for(let x=1;I&&x<=A.length;x++)for(let K=A.length-x;I&&K>=0;K--){I=!1;let ee=A.slice(K,K+x).join(a);for(let ae=0;!I&&ae<r.length;ae++)if(ae!==O&&r[ae]&&r[ae].indexOf(ee)>-1){const te=K+x===A.length,ue=K>0&&r[ae].indexOf(a)>-1?a+ee:ee,oe=r[ae].endsWith(ue);I=!te||oe}if(!I){let ae="";(A[0].endsWith(":")||C!=="")&&(K===1&&(K=0,x++,ee=A[0]+a+ee),K>0&&(ae=A[0]+a),ae=C+ae),K>0&&(ae=ae+c+a),ae=ae+ee,K+x<A.length&&(ae=ae+a+c),m[O]=ae}}I&&(m[O]=p)}return m}t.shorten=f;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const m=[];let I=!1,O="";for(const p of r)if(p==="$"||I&&p==="{")O&&m.push({value:O,type:h.TEXT}),O="",I=!0;else if(p==="}"&&I){const C=a[O];if(typeof C=="string")C.length&&m.push({value:C,type:h.VARIABLE});else if(C){const A=m[m.length-1];(!A||A.type!==h.SEPARATOR)&&m.push({value:C.label,type:h.SEPARATOR})}O="",I=!1}else O+=p;return O&&!I&&m.push({value:O,type:h.TEXT}),m.filter((p,C)=>{if(p.type===h.SEPARATOR){const A=m[C-1],x=m[C+1];return[A,x].every(K=>K&&(K.type===h.VARIABLE||K.type===h.TEXT)&&K.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function s(r,a){return P.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return P.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):P.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?w.posix:w.win32,m=a.basename(r),I=a.dirname(r);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}t.splitName=n}),define(Y[62],J([0,1,126]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class S{constructor(P="utf8"){this.stringDecoder=new T.StringDecoder(P),this.remaining=null}write(P){const R=[],L=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(L.length<1)return R;let l=0,d,E=l;for(;E<L.length;)if(d=L.charCodeAt(E),d===13||d===10){if(R.push(L.substring(l,E)),E++,E<L.length){const D=d;d=L.charCodeAt(E),(D===13&&d===10||D===10&&d===13)&&E++}l=E}else E++;return this.remaining=l<L.length?L.substr(l):null,R}end(){return this.remaining}}t.LineDecoder=S}),define(Y[63],J([0,1,47,8,27,12]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(E){const D=(0,S.dirname)(E);if(E===D)return E;const g=((0,S.basename)(E)||E).toLowerCase();try{const u=(0,P.readdirSync)(D).filter(c=>c.toLowerCase()===g);if(u.length===1){const c=R(D);if(c)return(0,S.join)(c,u[0])}else if(u.length>1){const c=u.indexOf(g);if(c>=0){const y=R(D);if(y)return(0,S.join)(y,u[c])}}}catch(b){}return null}t.realcaseSync=R;async function L(E){try{return await P.Promises.realpath(E)}catch(D){const g=d(E);return await P.Promises.access(g,T.constants.R_OK),g}}t.realpath=L;function l(E){try{return T.realpathSync(E)}catch(D){const g=d(E);return T.accessSync(g,T.constants.R_OK),g}}t.realpathSync=l;function d(E){return(0,w.rtrim)((0,S.normalize)(E),S.sep)}}),define(Y[64],J([0,1,34,8,12]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,R=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class D{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:o});if(!e)return null;const i=S.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const I of await w.Promises.readdir(i)){let O=-1;if(s){const C=I.indexOf("-");if(C<0)continue;const A=I.substring(0,C);if(!P.test(A)||I.substring(C+1)!=="preview")continue;O=parseInt(A,10)}else{if(!P.test(I))continue;O=parseInt(I,10)}if(O<=n)continue;const p=S.join(i,I,"pwsh.exe");!await w.SymlinkSupport.existsFile(p)||(r=p,n=O)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",m=s?" Preview":"";return new D(r,`PowerShell${m}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=S.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await w.Promises.readdir(s))if(e.test(n)){const r=S.join(s,n,"pwsh.exe");return new D(r,i)}return null}function c(){const o=S.join(T.homedir(),".dotnet","tools","pwsh.exe");return new D(o,".NET Core PowerShell Global Tool")}function y(){const o=S.join(process.env.windir,d===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(o,"Windows PowerShell",!0)}async function*v(){let o=await b();o&&(yield o),o=await b({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=c(),o&&(yield o),o=await b({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await b({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=y(),o&&(yield o)}async function*f(){for await(const o of v())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=f;async function h(){for await(const o of f())return o;return null}t.getFirstAvailablePowerShellInstallation=h});var de=this&&this.__decorate||function(V,t,T,S){var w=arguments.length,P=w<3?t:S===null?S=Object.getOwnPropertyDescriptor(t,T):S,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(V,t,T,S);else for(var L=V.length-1;L>=0;L--)(R=V[L])&&(P=(w<3?R(P):w>3?R(t,T,P):R(t,T))||P);return w>3&&P&&Object.defineProperty(t,T,P),P};define(Y[35],J([0,1,20,6,17,24,45,9,13,2,60,27,11]),function(V,t,T,S,w,P,R,L,l,d,E,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var b;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(b=t.RequestType||(t.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function y(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(v||(v={}));class f{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class h{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function s(M){const F=w.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function e(M){return M.read(4).readUInt32BE(0)}function i(M){const F=w.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(M,F){if(typeof F=="undefined")M.write(n.Undefined);else if(typeof F=="string"){const z=w.VSBuffer.fromString(F);M.write(n.String),M.write(s(z.byteLength)),M.write(z)}else if(r&&Buffer.isBuffer(F)){const z=w.VSBuffer.wrap(F);M.write(n.Buffer),M.write(s(z.byteLength)),M.write(z)}else if(F instanceof w.VSBuffer)M.write(n.VSBuffer),M.write(s(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(n.Array),M.write(s(F.length));for(const z of F)a(M,z)}else{const z=w.VSBuffer.fromString(JSON.stringify(F));M.write(n.Object),M.write(s(z.byteLength)),M.write(z)}}function m(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(e(M)).toString();case o.Buffer:return M.read(e(M)).buffer;case o.VSBuffer:return M.read(e(M));case o.Array:{const z=e(M),G=[];for(let ie=0;ie<z;ie++)G.push(m(M));return G}case o.Object:return JSON.parse(M.read(e(M)).toString())}}class I{constructor(F,z,G=null,ie=1e3){this.protocol=F,this.ctx=z,this.logger=G,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger&&this.logger.logOutgoing(z,0,1,y(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(z,F.id,1,y(F.type),F.data);return}}}send(F,z=void 0){const G=new h;return a(G,F),a(G,z),this.sendBuffer(G.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(z){return 0}}onRawMessage(F){const z=new f(F),G=m(z),ie=m(z),H=G[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ie),this.onPromise({type:H,id:G[1],channelName:G[2],name:G[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ie),this.onEventListen({type:H,id:G[1],channelName:G[2],name:G[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const G=new P.CancellationTokenSource;let ie;try{ie=z.call(this.ctx,F.name,F.arg,G.token)}catch(q){ie=Promise.reject(q)}const H=F.id;ie.then(q=>{this.sendResponse({id:H,data:q,type:201}),this.activeRequests.delete(F.id)},q=>{q instanceof Error?this.sendResponse({id:H,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:H,data:q,type:203}),this.activeRequests.delete(F.id)});const Z=(0,d.toDisposable)(()=>G.cancel());this.activeRequests.set(F.id,Z)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const G=F.id,H=z.listen(this.ctx,F.name,F.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(F.id,H)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const G=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:G})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const G of z)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}t.ChannelServer=I;var O;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(O=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=z}getChannel(F){const z=this;return{call(G,ie,H){return z.isDisposed?Promise.reject(L.canceled()):z.requestPromise(F,G,ie,H)},listen(G,ie){return z.isDisposed?Promise.reject(L.canceled()):z.requestEvent(F,G,ie)}}}requestPromise(F,z,G,ie=P.CancellationToken.None){const H=this.lastRequestId++,q={id:H,type:100,channelName:F,name:z,arg:G};if(ie.isCancellationRequested)return Promise.reject(L.canceled());let U;return new Promise((_,W)=>{if(ie.isCancellationRequested)return W(L.canceled());const X=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(H),_(ye.data);break;case 202:this.handlers.delete(H);const fe=new Error(ye.data.message);fe.stack=ye.data.stack,fe.name=ye.data.name,W(fe);break;case 203:this.handlers.delete(H),W(ye.data);break}};this.handlers.set(H,me),this.sendRequest(q)};let Q=null;this.state===v.Idle?X():(Q=(0,S.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,X()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:H,type:101}),W(L.canceled())},re=ie.onCancellationRequested(se);U=(0,d.combinedDisposable)((0,d.toDisposable)(se),re),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(F,z,G){const ie=this.lastRequestId++,Z={id:ie,type:102,channelName:F,name:z,arg:G};let q=null;const U=new l.Emitter({onFirstListenerAdd:()=>{q=(0,S.createCancelablePromise)(_=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(U),this.sendRequest(Z)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(U),this.sendRequest({id:ie,type:103}))}}),N=_=>U.fire(_.data);return this.handlers.set(ie,N),U.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(z,F.id,0,`${u(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(z,F.id,0,u(F.type));return}}}send(F,z=void 0){const G=new h;return a(G,F),a(G,z),this.sendBuffer(G.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(z){return 0}}onBuffer(F){const z=new f(F),G=m(z),ie=m(z),H=G[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,y(H)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,G[1],0,y(H),ie),this.onResponse({type:G[0],id:G[1],data:ie})}}onResponse(F){if(F.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(F.id);z&&z(F)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}de([R.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class C{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:G})=>{l.Event.once(z.onMessage)(H=>{const Z=new f(H),q=m(Z),U=new I(z,q),N=new p(z);this.channels.forEach((W,X)=>U.registerChannel(X,W));const _={channelServer:U,channelClient:N,ctx:q};this._connections.add(_),this._onDidAddConnection.fire(_),G(()=>{U.dispose(),N.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}getChannel(F,z){const G=this;return{call(ie,H,Z){let q;if((0,g.isFunction)(z)){let N=(0,T.getRandomElement)(G.connections.filter(z));q=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,z))}else q=z.routeCall(G,ie,H);const U=q.then(N=>N.channelClient.getChannel(F));return x(U).call(ie,H,Z)},listen(ie,H){if((0,g.isFunction)(z))return G.getMulticastEvent(F,z,ie,H);const Z=z.routeEvent(G,ie,H).then(q=>q.channelClient.getChannel(F));return x(Z).listen(ie,H)}}}getMulticastEvent(F,z,G,ie){const H=this;let Z=new d.DisposableStore;const q=new l.Emitter({onFirstListenerAdd:()=>{Z=new d.DisposableStore;const U=new l.EventMultiplexer,N=new Map,_=X=>{const se=X.channelClient.getChannel(F).listen(G,ie),re=U.add(se);N.set(X,re)},W=X=>{const Q=N.get(X);!Q||(Q.dispose(),N.delete(X))};H.connections.filter(z).forEach(_),l.Event.filter(H.onDidAddConnection,z)(_,void 0,Z),H.onDidRemoveConnection(W,void 0,Z),U.event(q.fire,q,Z),Z.add(U)},onLastListenerRemove:()=>{Z.dispose()}});return q.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach(G=>{G.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class A{constructor(F,z,G=null){const ie=new h;a(ie,z),F.send(ie.buffer),this.channelClient=new p(F,G),this.channelServer=new I(F,z,G)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function x(M){return{call(F,z,G){return M.then(ie=>ie.call(F,z,G))},listen(F,z){const G=new l.Relay;return M.then(ie=>G.input=ie.listen(F,z)),G.event}}}t.getDelayedChannel=x;function K(M){let F=!1;return{call(z,G,ie){return F?M.call(z,G,ie):(0,S.timeout)(0).then(()=>F=!0).then(()=>M.call(z,G,ie))},listen(z,G){if(F)return M.listen(z,G);const ie=new l.Relay;return(0,S.timeout)(0).then(()=>F=!0).then(()=>ie.input=M.listen(z,G)),ie.event}}}t.getNextTickChannel=K;class ee{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await l.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=ee;var ae;(function(M){function F(H,Z){const q=H,U=Z&&Z.disableMarshalling,N=new Map;for(const _ in q)G(_)&&N.set(_,l.Event.buffer(q[_],!0));return new class{listen(_,W,X){const Q=N.get(W);if(Q)return Q;if(ie(W)){const se=q[W];if(typeof se=="function")return se.call(q,X)}throw new Error(`Event not found: ${W}`)}call(_,W,X){const Q=q[W];if(typeof Q=="function"){if(!U&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,E.revive)(X[se]);return Q.apply(q,X)}throw new Error(`Method not found: ${W}`)}}}M.fromService=F;function z(H,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(U,N){if(typeof N=="string")return Z?.properties?.has(N)?Z.properties.get(N):ie(N)?function(_){return H.listen(N,_)}:G(N)?H.listen(N):async function(..._){let W;Z&&!(0,g.isUndefinedOrNull)(Z.context)?W=[Z.context,..._]:W=_;const X=await H.call(N,W);return q?X:(0,E.revive)(X)};throw new Error(`Property not found: ${String(N)}`)}})}M.toService=z;function G(H){return H[0]==="o"&&H[1]==="n"&&D.isUpperAsciiLetter(H.charCodeAt(2))}function ie(H){return/^onDynamic/.test(H)&&D.isUpperAsciiLetter(H.charCodeAt(9))}})(ae=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let F=M.toString();if(F!=="[object Object]")return F}return M}function oe(M){return Array.isArray(M)?M.map(ue):ue(M)}function B(M,F,z,G,ie,H,Z){Z=oe(Z);const q=te[ie],U=q[G%q.length];let N=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(H)?(N=N.concat(Z),N.push(")")):N.push(Z),console.log.apply(console,N)}t.logWithColors=B;class ne{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,G,ie,H){this._totalOutgoing+=F,B(this._outgoingPrefix,this._totalOutgoing,F,z,G,ie,H)}logIncoming(F,z,G,ie,H){this._totalIncoming+=F,B(this._incomingPrefix,this._totalIncoming,F,z,G,ie,H)}}t.IPCLogger=ne}),define(Y[65],J([0,1,6,13,2,11]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var R;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=t.StorageHint||(t.StorageHint={}));function L(D){const g=D;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=L;var l;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(l||(l={}));class d extends w.Disposable{constructor(g,b=Object.create(null)){super();this.database=g,this.options=b,this._onDidChangeStorage=this._register(new S.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((b,u)=>this.accept(u,b)),g.deleted?.forEach(b=>this.accept(b,void 0))}accept(g,b){if(this.state===l.Closed)return;let u=!1;(0,P.isUndefinedOrNull)(b)?u=this.cache.delete(g):this.cache.get(g)!==b&&(this.cache.set(g,b),u=!0),u&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,b){const u=this.cache.get(g);return(0,P.isUndefinedOrNull)(u)?b:u}getBoolean(g,b){const u=this.get(g);return(0,P.isUndefinedOrNull)(u)?b:u==="true"}getNumber(g,b){const u=this.get(g);return(0,P.isUndefinedOrNull)(u)?b:parseInt(u,10)}async set(g,b){if(this.state===l.Closed)return;if((0,P.isUndefinedOrNull)(b))return this.delete(g);const u=String(b);if(this.cache.get(g)!==u)return this.cache.set(g,u),this.pendingInserts.set(g,u),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((b,u)=>this.items.set(u,b)),g.delete&&g.delete.forEach(b=>this.items.delete(b))}async close(){}}t.InMemoryStorageDatabase=E}),define(Y[66],J([3,4]),function(V,t){return V.create("vs/base/common/date",t)}),define(Y[67],J([0,1,66]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const S=60,w=S*60,P=w*24,R=P*7,L=P*30,l=P*365;function d(D,g){typeof D!="number"&&(D=D.getTime());const b=Math.round((new Date().getTime()-D)/1e3);if(b<-30)return(0,T.localize)(0,null,d(new Date().getTime()+b*1e3,!1));if(b<30)return(0,T.localize)(1,null);let u;return b<S?(u=b,g?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):b<w?(u=Math.floor(b/S),g?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):b<P?(u=Math.floor(b/w),g?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):b<R?(u=Math.floor(b/P),g?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):b<L?(u=Math.floor(b/R),g?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):b<l?(u=Math.floor(b/L),g?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(b/l),g?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}t.fromNow=d;function E(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=E}),define(Y[68],J([3,4]),function(V,t){return V.create("vs/base/common/errorMessage",t)}),define(Y[30],J([0,1,20,11,68]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function P(d,E){return E&&(d.stack||d.stacktrace)?w.localize(0,null,L(d),R(d.stack)||R(d.stacktrace)):L(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function L(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?w.localize(1,null,d.message):d.message||w.localize(2,null)}function l(d=null,E=!1){if(!d)return w.localize(3,null);if(Array.isArray(d)){const D=T.coalesce(d),g=l(D[0],E);return D.length>1?w.localize(4,null,g,D.length):g}if(S.isString(d))return d;if(d.detail){const D=d.detail;if(D.error)return P(D.error,E);if(D.exception)return P(D.exception,E)}return d.stack?P(d,E):d.message?d.message:w.localize(5,null)}t.toErrorMessage=l}),define(Y[69],J([3,4]),function(V,t){return V.create("vs/base/node/processes",t)}),define(Y[48],J([0,1,38,46,5,18,8,10,28,58,11,62,12,69]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function u(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(s,e){if(L.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=T.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{n.once("error",a=>{r({success:!1,error:a})}),n.once("exit",(a,m)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(L.isLinux||L.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(n=>{T.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,a,m)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function y(s=l.env){return s.comspec||"cmd.exe"}t.getWindowsShell=y;class v{constructor(e,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=r;else{const a=e;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(l.env).forEach(m=>{a[m]=l.env[m]}),Object.keys(this.options.env).forEach(m=>{a[m]=this.options.env[m]}),this.options.env=a}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(R.sep);return i!==-1&&(e=e.substring(i+1)),v.WellKnowCommands[e]?e:"other"}start(e){return L.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(l.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let n,r;const a=new Promise((m,I)=>{n=m,r=I});if(i){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=T.exec(m,this.options,(I,O,p)=>{this.childProcess=null;const C=I;C&&C.killed?r({killed:this.terminateRequested,stdout:O.toString(),stderr:p.toString()}):this.handleExec(n,e,I,O,p)})}else{let m=null;const I=O=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(O,n,e,r);const p={terminated:this.terminateRequested};E.isNumber(O)&&(p.cmdCode=O),n(p)};if(this.shell&&L.isWindows){const O=P.deepClone(this.options);O.windowsVerbatimArguments=!0,O.detached=!1;let p=!1,C=!1;const A=[];let x=this.ensureQuotes(this.cmd);A.push(x.value),p=x.quoted,this.args&&this.args.forEach(ee=>{x=this.ensureQuotes(ee),A.push(x.value),C=C&&x.quoted});const K=["/s","/c"];p?C?K.push('"'+A.join(" ")+'"'):A.length>1?K.push('"'+A[0]+'" '+A.slice(1).join(" ")):K.push('"'+A[0]+'"'):K.push(A.join(" ")),m=T.spawn(y(),K,O)}else this.cmd&&(m=T.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(E.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",O=>{this.childProcess=null,r({terminated:this.terminateRequested,error:O})}),m.pid&&(this.childProcess.on("close",I),this.handleSpawn(m,n,e,r,!0)))}return a})}handleClose(e,i,n,r){}ensureQuotes(e){return v.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,c(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!L.isWindows)return e(!1);const i=T.spawn(y(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class f extends v{constructor(e,i,n,r){super(e,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,r,a){[r,a].forEach((m,I)=>{const O=new D.LineDecoder;O.write(m).forEach(A=>{i({line:A,source:I===0?0:1})});const C=O.end();C&&i({line:C,source:I===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,r,a){const m=new D.LineDecoder,I=new D.LineDecoder;e.stdout.on("data",O=>{m.write(O).forEach(C=>n({line:C,source:0}))}),e.stderr.on("data",O=>{I.write(O).forEach(C=>n({line:C,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=I}handleClose(e,i,n,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&n({line:m,source:1})}}t.LineProcess=f;function h(s){let e=[],i=!1;const n=function(r){if(i){e.push(r);return}(!s.send(r,m=>{if(m&&console.error(m),i=!1,e.length>0){const I=e.slice(0);e=[],I.forEach(O=>n(O))}})||L.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=h;var o;(function(s){async function e(i,n,r){if(R.isAbsolute(i))return i;if(n===void 0&&(n=l.cwd()),R.dirname(i)!=="."||(r===void 0&&E.isString(l.env.PATH)&&(r=l.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(n,i);async function m(I){if(await g.Promises.exists(I)){let O;try{O=await g.Promises.stat(I)}catch(p){p.message.startsWith("EACCES")&&(O=await g.Promises.lstat(I))}return O?!O.isDirectory():!1}return!1}for(let I of r){let O;if(R.isAbsolute(I)?O=R.join(I,i):O=R.join(n,I,i),await m(O))return O;let p=O+".com";if(await m(p)||(p=O+".exe",await m(p)))return p}return R.join(n,i)}s.findExecutable=e})(o=t.win32||(t.win32={}))}),define(Y[70],J([0,1,34,10,64,48]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function R(b,u){return b===1?S.isWindows?D():P.getWindowsShell(u):d(b,u)}t.getSystemShell=R;function L(b,u){return b===1?S.isWindows?g(u):P.getWindowsShell(u):d(b,u)}t.getSystemShellSync=L;let l=null;function d(b,u){if(S.isLinux&&b===2||S.isMacintosh&&b===3)return"/bin/bash";if(!l){let c;if(S.isWindows)c="/bin/bash";else{if(c=u.SHELL,!c)try{c=(0,T.userInfo)().shell}catch(y){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}l=c}return l}let E=null;async function D(){return E||(E=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),E}function g(b){if(E)return E;const u=S.isWindows&&parseFloat((0,T.release)())>=10,c=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${b.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?y:P.getWindowsShell(b)}}),define(Y[39],J([0,1,38,6,17,24,59,9,13,2,18,10,48,35]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends b.ChannelServer{constructor(v){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch(h){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",f=>w.VSBuffer.wrap(Buffer.from(f,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=u;class c{constructor(v,f){this.modulePath=v,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new S.Delayer(h),this.child=null,this._client=null}getChannel(v){const f=this;return{call(h,o,s){return f.requestPromise(v,h,o,s)},listen(h,o){return f.requestEvent(v,h,o)}}}requestPromise(v,f,h,o=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),e=(0,S.createCancelablePromise)(r=>s.call(f,h,r)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(v,f,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let o;const s=new l.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(v).listen(f,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),D.isMacintosh&&f.env&&delete f.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,v,f);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,R.isRemoteConsoleLog)(a)){(0,R.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=h.event,n={send:e,onMessage:i};this._client=new b.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,m)=>{process.removeListener("exit",r),this.activeRequests.forEach(I=>(0,d.dispose)(I)),this.activeRequests.clear(),a!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:m})})}return this._client}getCachedChannel(v){let f=this.channels.get(v);return f||(f=this.client.getChannel(v),this.channels.set(v,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Y[71],J([3,4]),function(V,t){return V.create("vs/base/node/zip",t)}),define(Y[72],J([3,4]),function(V,t){return V.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[73],J([3,4]),function(V,t){return V.create("vs/platform/environment/node/shellEnv",t)}),define(Y[74],J([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],J([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],J([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],J([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],J([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],J([3,4]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],J([3,4]),function(V,t){return V.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],J([3,4]),function(V,t){return V.create("vs/platform/files/common/fileService",t)}),define(Y[82],J([3,4]),function(V,t){return V.create("vs/platform/files/common/io",t)}),define(Y[83],J([3,4]),function(V,t){return V.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],J([3,4]),function(V,t){return V.create("vs/platform/request/common/request",t)}),define(Y[85],J([3,4]),function(V,t){return V.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],J([0,1,67,45,5,8,28,19,7]),function(V,t,T,S,w,P,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(c,y,v){this._args=c,this.paths=y,this.productService=v}get appRoot(){return(0,P.dirname)(w.FileAccess.asFileUri("",V).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(l.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=R.env.VSCODE_PORTABLE;return c?l.URI.file((0,P.join)(c,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,P.resolve)(c):(0,P.normalize)((0,P.join)(w.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,P.resolve)(c):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,P.resolve)(c);const y=R.env.VSCODE_EXTENSIONS;if(y)return y;const v=R.env.VSCODE_PORTABLE;return v?(0,P.join)(v,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(y=>/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,P.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?l.URI.parse(c):l.URI.file((0,P.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([S.memoize],d.prototype,"appRoot",null),de([S.memoize],d.prototype,"userHome",null),de([S.memoize],d.prototype,"userDataPath",null),de([S.memoize],d.prototype,"appSettingsHome",null),de([S.memoize],d.prototype,"tmpDir",null),de([S.memoize],d.prototype,"userRoamingDataHome",null),de([S.memoize],d.prototype,"settingsResource",null),de([S.memoize],d.prototype,"userDataSyncHome",null),de([S.memoize],d.prototype,"userDataSyncLogResource",null),de([S.memoize],d.prototype,"sync",null),de([S.memoize],d.prototype,"machineSettingsResource",null),de([S.memoize],d.prototype,"globalStorageHome",null),de([S.memoize],d.prototype,"workspaceStorageHome",null),de([S.memoize],d.prototype,"keybindingsResource",null),de([S.memoize],d.prototype,"keyboardLayoutResource",null),de([S.memoize],d.prototype,"argvResource",null),de([S.memoize],d.prototype,"snippetsHome",null),de([S.memoize],d.prototype,"isExtensionDevelopment",null),de([S.memoize],d.prototype,"untitledWorkspacesHome",null),de([S.memoize],d.prototype,"installSourcePath",null),de([S.memoize],d.prototype,"builtinExtensionsPath",null),de([S.memoize],d.prototype,"extensionsPath",null),de([S.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([S.memoize],d.prototype,"extensionDevelopmentKind",null),de([S.memoize],d.prototype,"extensionTestsLocationURI",null),de([S.memoize],d.prototype,"debugExtensionHost",null),de([S.memoize],d.prototype,"serviceMachineIdResource",null),de([S.memoize],d.prototype,"telemetryLogResource",null),de([S.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function E(u,c){return b(u["inspect-extensions"],u["inspect-brk-extensions"],5870,c,u.debugId,u.extensionEnvironment)}t.parseExtensionHostPort=E;function D(u,c){return b(u["inspect-search"],u["inspect-brk-search"],5876,c,u.extensionEnvironment)}t.parseSearchPort=D;function g(u,c){return b(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}t.parsePtyHostPort=g;function b(u,c,y,v,f,h){const s=Number(c||u)||(v?null:y),e=s?Boolean(!!c):!1;let i;if(h)try{i=JSON.parse(h)}catch{}return{port:s,break:e,debugId:f,env:i}}}),function(){"use strict";function V(t,T,S,w){function P(L){const l=R(L),d=[l];return t.isAbsolute(l)||d.unshift(w),t.resolve(...d)}function R(L){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,S);const E=L["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(D,"AppData","Roaming")}break;case"darwin":d=t.join(T.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,S)}return{getUserDataPath:P}}if(typeof define=="function")define(Y[87],J([0,127,34,5,19,28]),function(t,T,S,w,P,R){const L=P.dirname(w.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(P.joinPath(L,"package.json").fsPath);return V(T,S,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),S=require("os");module.exports=V(T,S,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[88],J([0,1,34,86,87]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class P extends S.AbstractNativeEnvironmentService{constructor(L,l){super(L,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,w.getUserDataPath)(L)},l)}}t.NativeEnvironmentService=P}),define(Y[89],J([0,1,18]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const S=/^%([\w\d.-]+)%$/i;function w(P,R){const L=l=>{if(typeof l!="string")return;const d=S.exec(l);if(!d)return;const E=R[d[1]]??l;return typeof E=="string"?E:typeof E.message=="string"?E.message:l};return(0,T.cloneAndChange)(P,L)}t.localizeManifest=w}),define(Y[49],J([0,1,80]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function P(g){return g=g.trim(),g==="*"||S.test(g)}t.isValidVersionStr=P;function R(g){if(!P(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=g.match(S);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}t.parseVersion=R;function L(g){if(!g)return null;let b=g.majorBase,u=g.majorMustEqual,c=g.minorBase,y=g.minorMustEqual,v=g.patchBase,f=g.patchMustEqual;g.hasCaret&&(b===0||(y=!1),f=!1);let h=0;if(g.preRelease){const o=w.exec(g.preRelease);if(o){const[,s,e,i]=o;h=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:b,majorMustEqual:u,minorBase:c,minorMustEqual:y,patchBase:v,patchMustEqual:f,isMinimum:g.hasGreaterEquals,notBefore:h}}t.normalizeVersion=L;function l(g,b,u){let c;typeof g=="string"?c=L(R(g)):c=g;let y;b instanceof Date?y=b.getTime():typeof b=="string"&&(y=new Date(b).getTime());let v;if(typeof u=="string"?v=L(R(u)):v=u,!c||!v)return!1;let f=c.majorBase,h=c.minorBase,o=c.patchBase,s=v.majorBase,e=v.minorBase,i=v.patchBase,n=v.notBefore,r=v.majorMustEqual,a=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?f>s?!0:f<s?!1:h>e?!0:h<e||y&&y<n?!1:o>=i:(f===1&&s===0&&(!r||!a||!m)&&(s=1,e=0,i=0,r=!0,a=!1,m=!1),f<s?!1:f>s?!r:h<e?!1:h>e?!a:o<i?!1:o>i?!m:!(y&&y<n))}t.isValidVersion=l;function d(g,b,u,c){return u.isBuiltin||typeof u.main=="undefined"?!0:D(g,b,u.engines.vscode,c)}t.isValidExtensionVersion=d;function E(g,b,u){return g==="*"||D(b,u,g)}t.isEngineValid=E;function D(g,b,u,c=[]){let y=L(R(u));if(!y)return c.push(T.localize(0,null,u)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return c.push(T.localize(1,null,u)),!1}else if(!y.majorMustEqual)return c.push(T.localize(2,null,u)),!1;return l(g,b,y)?!0:(c.push(T.localize(3,null,g,u)),!1)}}),define(Y[90],J([0,1,2,5,35,39]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends T.Disposable{constructor(l,d,E,D){super();this.requests=l,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=D,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new P.Client(S.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.watch(this.requests)}setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}watch(l){this.requests=l,this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Y[91],J([0,1,2,5,35,39]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends T.Disposable{constructor(l,d,E,D){super();this.requests=l,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=D,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new P.Client(S.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (parcel)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.watch(this.requests)}setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${l}`})}watch(l){this.requests=l,this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Y[92],J([0,1,2,5,35,39]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends T.Disposable{constructor(l,d,E,D,g={}){super();this.folders=l,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=D,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new P.Client(S.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.watch(this.folders)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}setVerboseLogging(l){this.verboseLogging=l,this.service&&this.service.setVerboseLogging(l)}watch(l){this.folders=l,this.service&&this.service.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Y[50],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(w,P=[],R=!1){this.ctor=w,this.staticArguments=P,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=T}),define(Y[93],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}t.Node=T;class S{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let R of this._nodes.values())R.outgoing.size===0&&P.push(R);return P}insertEdge(P,R){const L=this.lookupOrInsertNode(P),l=this.lookupOrInsertNode(R);L.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(P),L)}removeNode(P){const R=this._hashFn(P);this._nodes.delete(R);for(let L of this._nodes.values())L.outgoing.delete(R),L.incoming.delete(R)}lookupOrInsertNode(P){const R=this._hashFn(P);let L=this._nodes.get(R);return L||(L=new T(P),this._nodes.set(R,L)),L}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[R,L]of this._nodes)P.push(`${R}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,R]of this._nodes){const L=new Set([P]),l=this._findCycle(R,L);if(l)return l}}_findCycle(P,R){for(let[L,l]of P.outgoing){if(R.has(L))return[...R,L].join(" -> ");R.add(L);const d=this._findCycle(l,R);if(d)return d;R.delete(L)}}}t.Graph=S}),define(Y[51],J([0,1,15]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[21],J([0,1,15]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],J([0,1,5,75,15]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var P;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(P=t.TargetPlatform||(t.TargetPlatform={}));function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=R;function L(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=L;function l(f,h){switch(f){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function d(f,h){return h==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function E(f,h,o){return d(h,o)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===o?!0:D(o).includes(f)}t.isTargetPlatformCompatible=E;function D(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=D;function g(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=g;var b;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(b=t.SortBy||(t.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var c;(function(f){f.Install="install",f.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var y;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(y=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}t.ExtensionManagementError=v,t.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),t.ExtensionsLabel=(0,S.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,S.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(Y[94],J([0,1,38,8,73,24,30,9,10,31,70,128,6]),function(V,t,T,S,w,P,R,L,l,d,E,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const b=1e4;let u;async function c(v,f,h){return f["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,D.isLaunchedFromCli)(h)&&!f["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,D.isLaunchedFromCli)(h)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=g.Promises.withAsyncBody(async(o,s)=>{const e=new P.CancellationTokenSource,i=setTimeout(()=>{e.dispose(!0),s(new Error((0,w.localize)(0,null)))},b);try{o(await y(v,e.token))}catch(n){!(0,L.isPromiseCanceledError)(n)&&!e.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,R.toErrorMessage)(n)))):o({})}finally{clearTimeout(i),e.dispose()}})),u)}t.resolveShellEnv=c;async function y(v,f){return g.Promises.withAsyncBody(async(h,o)=>{const s=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",s);const e=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",e);const i=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(i+"(.*)"+i),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",r);const a=await(0,E.getSystemShell)(l.OS,r);if(v.trace("getUnixShellEnvironment#shell",a),f.isCancellationRequested)return o((0,L.canceled)());const m=(0,S.basename)(a);let I,O;/^pwsh(-preview)?$/.test(m)?(I=`& '${process.execPath}' -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,O=["-Login","-Command"]):(I=`'${process.execPath}' -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,O=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),I);const p=(0,T.spawn)(a,[...O,I],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});f.onCancellationRequested(()=>(p.kill(),o((0,L.canceled)()))),p.on("error",x=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(x)),o(x)});const C=[];p.stdout.on("data",x=>C.push(x));const A=[];p.stderr.on("data",x=>A.push(x)),p.on("close",(x,K)=>{const ee=Buffer.concat(C).toString("utf8");v.trace("getUnixShellEnvironment#raw",ee);const ae=Buffer.concat(A).toString("utf8");if(ae.trim()&&v.trace("getUnixShellEnvironment#stderr",ae),x||K)return o(new Error((0,w.localize)(2,null,x,K)));const te=n.exec(ee),ue=te?te[1]:"{}";try{const oe=JSON.parse(ue);s?oe.ELECTRON_RUN_AS_NODE=s:delete oe.ELECTRON_RUN_AS_NODE,e?oe.ELECTRON_NO_ATTACH_CONSOLE=e:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",oe),h(oe)}catch(oe){v.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(oe)),o(oe)}})})}}),define(Y[52],J([0,1,10,7,16]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function P(l){return l.map(d=>({type:d.type,resource:S.URI.file(d.path)}))}t.toFileChanges=P;function R(l){const d=new L;for(const E of l)d.processEvent(E);return d.normalize()}t.normalizeFileChanges=R;class L{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(d){return T.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const E=this.mapPathToChange.get(this.toKey(d));let D=!1;if(E){const g=E.type,b=d.type;E.path!==d.path&&d.type===2?D=!0:g===1&&b===2?(this.mapPathToChange.delete(this.toKey(d)),this.normalized.delete(E)):g===2&&b===1?E.type=0:g===1&&b===0||(E.type=b)}else D=!0;D&&(this.normalized.add(d),this.mapPathToChange.set(this.toKey(d),d))}normalize(){const d=[],E=[];return Array.from(this.normalized).filter(D=>D.type!==2?(d.push(D),!1):!0).sort((D,g)=>D.path.length-g.path.length).filter(D=>E.some(g=>(0,w.isParent)(D.path,g,!T.isLinux))?!1:(E.push(D.path),!0)).concat(d)}}}),define(Y[95],J([0,1,6,2,8,63,12,129,52]),function(V,t,T,S,w,P,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends S.Disposable{constructor(D,g,b,u){super();this.path=D,this.onDidFilesChange=g,this.onLogMessage=b,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(D){this.verboseLogging=D}async startWatching(){try{const{stat:D,symbolicLink:g}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(g)try{b=await(0,P.realpath)(b)}catch(u){if(this.onError(u),g.dangling)return}D.isDirectory()?this._register((0,L.watchFolder)(b,(u,c)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(c))})},u=>this.onError(u))):this._register((0,L.watchFile)(b,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(D){D.code!=="ENOENT"&&this.onError(D)}}onFileChange(D){this.fileChangesBuffer.push(D),this.verboseLogging&&this.onVerbose(`${D.type===1?"[ADDED]":D.type===2?"[DELETED]":"[CHANGED]"} ${D.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,l.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of b)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(D){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${D}`})}onVerbose(D){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${D}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Y[53],J([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...w){this._entries=new Map;for(let[P,R]of w)this.set(P,R)}set(w,P){const R=this._entries.get(w);return this._entries.set(w,P),R}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=T}),define(Y[96],J([0,1,6,9,50,93,15,53]),function(V,t,T,S,w,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class E{constructor(u=new L.ServiceCollection,c=!1,y){this._activeInstantiations=new Set,this._services=u,this._strict=c,this._parent=y,this._services.set(R.IInstantiationService,this)}createChild(u){return new E(u,this._strict,this)}invokeFunction(u,...c){let y=g.traceInvocation(u),v=!1;try{return u({get:(h,o)=>{if(v)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,y);if(!s&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...c)}finally{v=!0,y.stop()}}createInstance(u,...c){let y,v;return u instanceof w.SyncDescriptor?(y=g.traceCreation(u.ctor),v=this._createInstance(u.ctor,u.staticArguments.concat(c),y)):(y=g.traceCreation(u),v=this._createInstance(u,c,y)),y.stop(),v}_createInstance(u,c=[],y){let v=R._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),f=[];for(const o of v){let s=this._getOrCreateServiceInstance(o.id,y);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);f.push(s)}let h=v.length>0?v[0].index:c.length;if(c.length!==h){console.warn(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${c.length} static arguments`);let o=h-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,h)}return new u(...[...c,...f])}_setServiceInstance(u,c){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,c);else if(this._parent)this._parent._setServiceInstance(u,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let c=this._services.get(u);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):c}_getOrCreateServiceInstance(u,c){let y=this._getServiceInstanceOrDescriptor(u);return y instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,y,c.branch(u,!0)):(c.branch(u,!1),y)}_safeCreateAndCacheServiceInstance(u,c,y){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,c,y)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,c,y){const v=new P.Graph(o=>o.id.toString());let f=0;const h=[{id:u,desc:c,_trace:y}];for(;h.length;){const o=h.pop();if(v.lookupOrInsertNode(o),f++>1e3)throw new d(v);for(let s of R._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof w.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};v.insertEdge(o,i),h.push(i)}}}for(;;){const o=v.roots();if(o.length===0){if(!v.isEmpty())throw new d(v);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,c,y=[],v,f){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(c,y,v,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,c,y,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(u,c=[],y,v){if(y){const f=new T.IdleValue(()=>this._createInstance(u,c,v));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=f.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return f.value[o]=s,!0}})}else return this._createInstance(u,c,v)}}t.InstantiationService=E;var D;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(D||(D={}));class g{constructor(u,c){this.type=u,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return l?new g(0,u.name):g._None}branch(u,c){let y=new g(2,u.toString());return this._dep.push([u,c,y]),y}stop(){let u=Date.now()-this._start;g._totals+=u;let c=!1;function y(f,h){let o=[],s=new Array(f+1).join("	");for(const[e,i,n]of h._dep)if(i&&n){c=!0,o.push(`${s}CREATES -> ${e}`);let r=y(f+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||c)&&console.log(v.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Y[54],J([0,1,15]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function S(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const P of w.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}t.isValidLocalization=S}),define(Y[14],J([0,1,30,13,2,10,15]),function(V,t,T,S,w,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,R.createDecorator)("logService"),t.ILoggerService=(0,R.createDecorator)("loggerService");function L(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class d extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class E extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=E;class D extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!P.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=D;class g extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=g;class b extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=b;class u extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class c extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=c;class y extends w.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=y;class v{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=v;function f(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=f;function h(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=h;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o});var ce=this&&this.__param||function(V,t){return function(T,S){t(T,S,V)}};define(Y[97],J([0,1,38,6,30,13,2,5,8,12,21,14]),function(V,t,T,S,w,P,R,L,l,d,E,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends R.Disposable{constructor(u,c){super();this.environmentService=u,this.logService=c,this.processesLimiter=new S.Limiter(5)}async postUninstall(u){const c=this.parseScript(u,"uninstall");return c&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${y}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(u,c){const y=`vscode:${c}`;if(u.location.scheme===L.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[y]=="string"){const v=u.manifest.scripts[y].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${y} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(u,c,y,v,f){return new Promise((h,o)=>{const s=this.start(u,c,y,f);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):h(void 0)};s.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),v&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,c,y,v){const f={silent:!0,execArgv:void 0},h=(0,T.fork)(u,[`--type=extension-post-${c}`,...y],f);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=P.Event.fromNodeEventEmitter(h.stdout,"data"),s=P.Event.fromNodeEventEmitter(h.stderr,"data");o(n=>this.logService.info(v.identifier.id,v.manifest.version,`post-${c}`,n)),s(n=>this.logService.error(v.identifier.id,v.manifest.version,`post-${c}`,n));const e=P.Event.any(P.Event.map(o,n=>({data:`%c${n}`,format:[""]})),P.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return P.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(v.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=de([ce(0,E.IEnvironmentService),ce(1,D.ILogService)],g),t.ExtensionsLifecycle=g}),define(Y[98],J([0,1,16,14]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function w(l,d,E,D){try{const g=await new Promise((b,u)=>{V(["spdlog"],b,u)});return g.setFlushOn(S.LogLevel.Trace),g.createAsyncRotatingLogger(l,d,E,D)}catch(g){console.error(g)}return null}function P(l,d,E,D){const g=V.__$__nodeRequire("spdlog");return g.setFlushOn(S.LogLevel.Trace),g.createRotatingLogger(l,d,E,D)}t.createRotatingLogger=P;function R(l,d,E){switch(d){case S.LogLevel.Trace:l.trace(E);break;case S.LogLevel.Debug:l.debug(E);break;case S.LogLevel.Info:l.info(E);break;case S.LogLevel.Warning:l.warn(E);break;case S.LogLevel.Error:l.error(E);break;case S.LogLevel.Critical:l.critical(E);break;default:throw new Error("Invalid log level")}}class L extends S.AbstractMessageLogger{constructor(d,E,D,g){super();this.name=d,this.filepath=E,this.rotating=D,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const d=this.rotating?6:1,E=30/d*T.ByteSize.MB;return w(this.name,this.filepath,E,d).then(D=>{if(D){this._logger=D,this._logger.setLevel(this.getLevel());for(const{level:g,message:b}of this.buffer)R(this._logger,g,b);this.buffer=[]}})}log(d,E){this._logger?R(this._logger,d,E):this.getLevel()<=d&&this.buffer.push({level:d,message:E})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Y[55],J([0,1,17,9,82,16,32]),function(V,t,T,S,w,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(D,g,b,u,c,y){let v;try{await l(D,g,b,u,c,y)}catch(f){v=f}finally{v&&c.errorTransformer&&(v=c.errorTransformer(v)),typeof v!="undefined"&&b.error(v),b.end()}}t.readFileIntoStream=L;async function l(D,g,b,u,c,y){d(y);const v=await D.open(g,{create:!1});try{d(y);let f=0,h=0,o=c&&typeof c.length=="number"?c.length:void 0,s=T.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,i=0;do h=await D.read(v,e,s.buffer,i,s.byteLength-i),e+=h,i+=h,f+=h,typeof o=="number"&&(o-=h),i===s.byteLength&&(await b.write(u(s)),s=T.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&d(y)&&E(f,c));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),b.write(u(s.slice(0,n)))}}catch(f){throw(0,P.ensureFileSystemProviderError)(f)}finally{await D.close(v)}}function d(D){if(D.isCancellationRequested)throw(0,S.canceled)();return!0}function E(D,g){if(g?.limits){if(typeof g.limits.memory=="number"&&D>g.limits.memory)throw(0,P.createFileSystemProviderError)((0,w.localize)(0,null,R.default.nameShort),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&D>g.limits.size)throw(0,P.createFileSystemProviderError)((0,w.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[99],J([0,1,20,6,17,24,13,130,2,100,5,131,19,37,81,16,55,14]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let f=class Ue extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new S.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new S.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new S.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,D.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await S.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return L.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new c.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,m=await e.stat(o);let I;return this.toFileStat(e,o,m,void 0,!!a,(O,p)=>(I||(I=d.TernarySearchTree.forUris(()=>!i),I.set(o,!0),n&&I.fill(!0,n)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&r?p===1:!1))}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),m={resource:s,name:a.basename(s),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&r(m,i)){try{const I=await o.readdir(s),O=await S.Promises.settled(I.map(async([p,C])=>{try{const A=a.joinPath(s,p),x=n?await o.stat(A):{type:C};return await this.toFileStat(o,A,x,I.length,n,r)}catch(A){return this.logService.trace(A),null}}));m.children=(0,T.coalesce)(O)}catch(I){this.logService.trace(I),m.children=[]}return m}return m}async resolveAll(o){return S.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,c.hasReadWriteCapability)(i)&&!(s instanceof w.VSBuffer))if((0,b.isReadableStream)(s)){const m=await(0,b.peekStream)(s,3);m.ended?a=w.VSBuffer.concat(m.buffer):a=m}else a=(0,b.peekReadable)(s,m=>w.VSBuffer.concat(m),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&a instanceof w.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof w.VSBuffer?(0,w.bufferToReadable)(a):a)}catch(r){throw new c.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:n.size}))throw new c.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,w.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new P.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await n,!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,c.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,b.consumeStream)(r);const m=(0,u.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(a).toString());throw a instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(m,a.stat,e):new c.FileOperationError(m,(0,c.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,b.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,y.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,b.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new c.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!m&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const I=await this.resolve(s);I.isDirectory?await this.doCopyFolder(o,I,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await S.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:I,isPathCaseSensitive:O}=this.getExtUri(o);if(O||(a=I.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&I.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const m=await this.exists(i);if(m&&!a){if(!r)throw new c.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:I}=this.getExtUri(o);if(I.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&c.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,c.toFileSystemProviderErrorCode)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new c.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,l.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,l.dispose)(r):n=()=>(0,l.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,l.toDisposable)(()=>{n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,b.isReadableStream)(i)||(0,b.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,b.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise((r,a)=>{(0,b.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(o,s,m,m.byteLength,i,0)}catch(I){return a(I)}i+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>a(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof w.VSBuffer?n=i:(0,b.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,b.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=w.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,I=0,O=0;do O=await o.read(n,m,a.buffer,I,a.byteLength-I),await this.doWriteBuffer(e,r,a,O,m,I),m+=O,I+=O,I===a.byteLength&&(I=0);while(O>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await S.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(o,s,P.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new c.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};f.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},f=de([ce(0,v.ILogService)],f),t.FileService=f}),define(Y[101],J([0,1,20,6,17,13,46,2,8,10,19,37,12,83,16,55,95,90,91,92,52,14,32]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c,y,v,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends L.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:m}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,m),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),m=[];return await Promise.all(a.map(async I=>{try{let O;I.isSymbolicLink()?O=(await this.stat((0,E.joinPath)(r,I.name))).type:O=this.toType(I),m.push([I.name,O])}catch(O){this.logService.trace(O)}})),m}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let m;return a?.dangling?m=u.FileType.Unknown:r.isFile()?m=u.FileType.File:r.isDirectory()?m=u.FileType.Directory:m=u.FileType.Unknown,a&&(m|=u.FileType.SymbolicLink),m}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,m){const I=(0,D.newWriteableStream)(O=>w.VSBuffer.concat(O.map(p=>w.VSBuffer.wrap(p))).buffer);return(0,c.readFileIntoStream)(this,r,I,O=>O.buffer,{...a,bufferSize:this.BUFFER_SIZE},m),I}async writeFile(r,a,m){let I;try{const O=this.toFilePath(r);if(!m.create||!m.overwrite){if(await g.Promises.exists(O)){if(!m.overwrite)throw(0,u.createFileSystemProviderError)((0,b.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,u.createFileSystemProviderError)((0,b.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}I=await this.open(r,{create:!0,unlock:m.unlock}),await this.write(I,0,a,0,a.byteLength)}catch(O){throw await this.toFileSystemProviderWriteError(r,O)}finally{typeof I=="number"&&await this.close(I)}}async open(r,a){try{const m=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await g.SymlinkSupport.stat(m);p.mode&128||await g.Promises.chmod(m,p.mode|128)}catch(p){this.logService.trace(p)}let I;if((0,u.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await g.Promises.truncate(m,0),I="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}I||(I="w")}else I="r";const O=await g.Promises.open(m,I);return this.mapHandleToPos.set(O,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(O,r),O}catch(m){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,m):this.toFileSystemProviderError(m)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,m,I,O){const p=this.normalizePos(r,a);let C=null;try{const A=await g.Promises.read(r,m,I,O,p);return typeof A=="number"?C=A:C=A.bytesRead,C}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(r,p,C)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,m){const I=this.mapHandleToPos.get(r);typeof I=="number"&&(typeof a=="number"||(typeof m=="number"?this.mapHandleToPos.set(r,I+m):this.mapHandleToPos.delete(r)))}async write(r,a,m,I,O){return(0,S.retry)(()=>this.doWrite(r,a,m,I,O),100,3)}async doWrite(r,a,m,I,O){const p=this.normalizePos(r,a);let C=null;try{const A=await g.Promises.write(r,m,I,O,p);return typeof A=="number"?C=A:C=A.bytesWritten,C}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),A)}finally{this.updatePos(r,p,C)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const m=this.toFilePath(r);await this.doDelete(m,a)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,m){const I=this.toFilePath(r),O=this.toFilePath(a);if(I!==O)try{await this.validateTargetDeleted(r,a,"move",m.overwrite),await g.Promises.move(I,O)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,b.localize)(2,null,(0,l.basename)(I),(0,l.basename)((0,l.dirname)(O)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(r,a,m){const I=this.toFilePath(r),O=this.toFilePath(a);if(I!==O)try{await this.validateTargetDeleted(r,a,"copy",m.overwrite),await g.Promises.copy(I,O,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,b.localize)(3,null,(0,l.basename)(I),(0,l.basename)((0,l.dirname)(O)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(r,a,m,I){const O=this.toFilePath(r),p=this.toFilePath(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,R.isEqual)(O,p,!0)),C&&m==="copy")throw(0,u.createFileSystemProviderError)((0,b.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!C&&await g.Promises.exists(p)){if(!I)throw(0,u.createFileSystemProviderError)((0,b.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const m={path:this.toFilePath(r),excludes:a.excludes},I=(0,T.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{I(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher||this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=h.FileWatcher,a=this.options?.watcher;else{let m=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?m=this.options.legacyWatcher==="on":e.default.quality==="stable"&&(m=this.recursiveFoldersToWatch.length===1),m?d.isLinux?r=h.FileWatcher:r=v.FileWatcher:r=f.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,o.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new y.FileWatcher(this.toFilePath(r),I=>this._onDidChangeFile.fire((0,o.toFileChanges)(I)),I=>{I.type==="error"&&this._onDidWatchErrorOccur.fire(I.message),this.logService[I.type](I.message)},this.logService.getLevel()===s.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,L.combinedDisposable)(a,m)}toFilePath(r){return(0,l.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let m=this.toFileSystemProviderError(a);if(r&&m.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:I}=await g.SymlinkSupport.stat(this.toFilePath(r));I.mode&128||(m=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(I){this.logService.trace(I)}return m}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Y[40],J([0,1,15]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(Y[25],J([0,1,56,11]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(R,L){T.ok(S.isString(R)),T.ok(S.isObject(L)),T.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,L)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}t.Registry=new w}),define(Y[102],J([0,1,13,25]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class P{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[w(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new P;S.Registry.add(t.Extensions.JSONContribution,R)}),define(Y[33],J([0,1,20,13,11,72,102,25]),function(V,t,T,S,w,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=L.Registry.as(R.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const s=this.doRegisterConfigurations(h,o);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(h,!1)),E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,T.distinct)(s))}registerDefaultConfigurations(h){const o=[],s=[];for(const e of h)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:P.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(b(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const s of h)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const s=[];return h.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(h){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of h){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(h,o=!0,s,e=3){e=w.isUndefinedOrNull(h.scope)?e:h.scope;let i=[],n=h.properties;if(n)for(let a in n){if(o&&y(a)){delete n[a];continue}const m=n[a];if(this.updatePropertyDefaultValue(a,m),t.OVERRIDE_PROPERTY_PATTERN.test(a)?m.scope=void 0:(m.scope=w.isUndefinedOrNull(m.scope)?e:m.scope,m.restricted=w.isUndefinedOrNull(m.restricted)?!!s?.restrictedConfigurations?.includes(a):m.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=h.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(h)}updateSchema(h,o){switch(t.allSettings.properties[h]=o,o.scope){case 1:t.applicationSettings.properties[h]=o;break;case 2:t.machineSettings.properties[h]=o;break;case 6:t.machineOverridableSettings.properties[h]=o;break;case 3:t.windowSettings.properties[h]=o;break;case 4:t.resourceSettings.properties[h]=o;break;case 5:t.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete t.allSettings.properties[h],o.scope){case 1:delete t.applicationSettings.properties[h];break;case 2:delete t.machineSettings.properties[h];break;case 6:delete t.machineOverridableSettings.properties[h];break;case 3:delete t.windowSettings.properties[h];break;case 4:case 5:delete t.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let s=this.defaultValues[h];w.isUndefined(s)&&(s=o.default),w.isUndefined(s)&&(s=u(o.type)),o.default=s}}const g="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function b(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=b;function u(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const c=new D;L.Registry.add(t.Extensions.Configuration,c);function y(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?P.localize(5,null,f):c.getConfigurationProperties()[f]!==void 0?P.localize(6,null,f):null:P.localize(4,null)}t.validateProperty=y;function v(){const f=[],h=c.getConfigurationProperties();for(const o of Object.keys(h))f.push([o,h[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=v}),define(Y[26],J([0,1,18,11,7,33,15,25]),function(V,t,T,S,w,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,R.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof w.URI)}t.isConfigurationOverrides=l;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function E(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=E;function D(i,n){const r=n?i?n.keys.filter(A=>i.keys.indexOf(A)===-1):[...n.keys]:[],a=i?n?i.keys.filter(A=>n.keys.indexOf(A)===-1):[...i.keys]:[],m=[];if(n&&i){for(const A of i.keys)if(n.keys.indexOf(A)!==-1){const x=v(i.contents,A),K=v(n.contents,A);T.equals(x,K)||m.push(A)}}const I=[],O=A=>{const x={};for(const K of A)for(const ee of K.identifiers)x[s(ee)]=K;return x},p=n?O(n.overrides):{},C=i?O(i.overrides):{};if(Object.keys(p).length)for(const A of r){const x=p[A];x&&I.push([(0,P.overrideIdentifierFromKey)(A),x.keys])}if(Object.keys(C).length)for(const A of a){const x=C[A];x&&I.push([(0,P.overrideIdentifierFromKey)(A),x.keys])}if(Object.keys(p).length&&Object.keys(C).length)for(const A of m){const x=C[A],K=p[A];if(x&&K){const ee=D({contents:x.contents,keys:x.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});I.push([(0,P.overrideIdentifierFromKey)(A),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:a,updated:m,overrides:I}}t.compare=D;function g(i,n){const r=[];for(const a of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(a)){const m={};for(const I in i[a])m[I]=i[a][I];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(m),contents:b(m,n)})}return r}t.toOverrides=g;function b(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=b;function u(i,n,r,a){const m=n.split("."),I=m.pop();let O=i;for(let p=0;p<m.length;p++){let C=m[p],A=O[C];switch(typeof A){case"undefined":A=O[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${m.slice(0,p+1).join(".")} is ${JSON.stringify(A)}`);return}O=A}if(typeof O=="object"&&O!==null)try{O[I]=r}catch(p){a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(O)}`)}else a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(O)}`)}t.addToValueTree=u;function c(i,n){const r=n.split(".");y(i,r)}t.removeFromValueTree=c;function y(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(y(a,n),Object.keys(a).length===0&&delete i[r])}}function v(i,n,r){function a(O,p){let C=O;for(const A of p){if(typeof C!="object"||C===null)return;C=C[A]}return C}const m=n.split("."),I=a(i,m);return typeof I=="undefined"?r:I}t.getConfigurationValue=v;function f(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?S.isObject(i[a])&&S.isObject(n[a])?f(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=f;function h(){const i=L.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),n=L.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,m=>console.error(`Conflict in default settings: ${m}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),m=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Y[103],J([0,1,20,13,57,2,100,18,11,7,26,33,25]),function(V,t,T,S,w,P,R,L,l,d,E,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class b{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,E.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,E.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=L.deepClone(this.contents),n=L.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const m of a.overrides){const[I]=n.filter(O=>T.equals(O.identifiers,m.identifiers));I?this.mergeContents(I.contents,m.contents):n.push(L.deepClone(m))}for(const m of a.keys)r.indexOf(m)===-1&&r.push(m)}return new b(i,r,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],m=i[r];m&&(typeof a=="object"&&typeof m=="object"?(a=L.deepClone(a),this.mergeContents(a,m)):a=m),n[r]=a}return new b(n,this.keys,this.overrides)}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&l.isObject(e[n])&&l.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=L.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?L.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,E.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,E.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=b;class u extends b{constructor(){const e=(0,E.getDefaultValues)(),i=(0,E.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,E.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:m}=this.doParseRaw(e,i);this._configurationModel=new b(n,r,a),this._restrictedConfigurations=m||[]}doParseContent(e){let i={},n=null,r=[],a=[],m=[];function I(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}let O={onObjectBegin:()=>{let p={};I(p),a.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let p=[];I(p),a.push(r),r=p,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:I,onError:(p,C,A)=>{m.push({error:p,offset:C,length:A})}};if(e)try{w.visit(e,O),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const n=g.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,E.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),m=Object.keys(e),I=(0,E.toOverrides)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:a,keys:m,overrides:I,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},m=[];for(let I in e)if(D.OVERRIDE_PROPERTY_PATTERN.test(I)&&n){const O=this.filter(e[I],i,!1,r);a[I]=O.raw,m.push(...O.restricted)}else{const O=i[I],p=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&m.push(I),(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&(r.skipRestricted&&O?.restricted||(a[I]=e[I]))}return{raw:a,restricted:m}}}t.ConfigurationModelParser=c;class y extends P.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(S.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=y;class v{constructor(e,i,n=new b,r=new b,a=new R.ResourceMap,m=new b,I=new R.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=I,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new b,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,I=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),A=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,x=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,K=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(e):m.getValue(e),ee=r.getValue(e),ae=T.distinct(T.flatten(r.overrides.map(te=>te.identifiers))).filter(te=>r.getOverrideValue(e,te)!==void 0);return{defaultValue:I,userValue:O,userLocalValue:p,userRemoteValue:C,workspaceValue:A,workspaceFolderValue:x,memoryValue:K,value:ee,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:m.getValue(e),override:i.overrideIdentifier?m.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,D.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),I=e.getKeysForOverrideIdentifier(a),O=[...I.filter(p=>m.indexOf(p)===-1),...m.filter(p=>I.indexOf(p)===-1),...m.filter(p=>!L.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,O]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.localUserConfiguration,e),m=[...i,...n,...r];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.remoteUserConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.workspaceConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:m,overrides:I}=(0,E.compare)(n,i);let O=[...r,...a,...m];return(O.length||!n)&&this.updateFolderConfiguration(e,i),{keys:O,overrides:I}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:m}=(0,E.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((m,I)=>(m.set(d.URI.revive(I[0]),this.parseConfigurationModel(I[1])),m),new R.ResourceMap);return new v(i,n,new b,r,a,new b,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new b(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v;function f(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,m])=>{const I=(0,R.getOrSet)(i,a,new Set);m.forEach(O=>I.add(O))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=f;class h{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(I=>a.add(I)),e.overrides.forEach(([,I])=>I.forEach(O=>a.add(O))),this.affectedKeys=[...a.values()];const m=new b;this.affectedKeys.forEach(I=>m.setValue(I,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!L.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,E.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Y[104],J([0,1,6,13,2,19,26,103,33,25]),function(V,t,T,S,w,P,R,L,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class E extends w.Disposable{constructor(g,b){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new S.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,b)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,b){const u=typeof g=="string"?g:void 0,c=(0,R.isConfigurationOverrides)(g)?g:(0,R.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(u,c,void 0)}updateValue(g,b,u,c){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,b,1)}onDidDefaultConfigurationChange(g){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,g);this.trigger(u,b,6)}trigger(g,b,u){const c=new L.ConfigurationChangeEvent(g,{data:b},this.configuration);c.source=u,c.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=E}),define(Y[105],J([0,1,5]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function S(d){return d.scheme===T.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=S;function w(d){if(!d)return;const E=d.indexOf("+");return E<0?d:d.substr(0,E)}t.getRemoteName=w;function P(d){return d.scheme!==T.Schemas.file&&d.scheme!==T.Schemas.vscodeRemote}t.isVirtualResource=P;function R(d){if(d.folders.length)return d.folders.every(E=>P(E.uri))?d.folders[0].uri:void 0;if(d.configuration&&P(d.configuration))return d.configuration}t.getVirtualWorkspaceLocation=R;function L(d){return R(d)?.scheme}t.getVirtualWorkspaceScheme=L;function l(d){return R(d)!==void 0}t.isVirtualWorkspace=l}),define(Y[41],J([0,1,27,15,105]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=P;function R(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(L=t.ExtensionType||(t.ExtensionType={}));class l{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,u){if(typeof b=="undefined"||b===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof b=="string"||typeof u=="string"){let c=typeof b=="string"?b:b.value,y=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(c,y)}return b._lower===u._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}t.ExtensionIdentifier=l;function d(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=d;function E(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=E;function D(g,b){if(b&&g.enableProposedApi){const u=`onResolveRemoteAuthority:${(0,w.getRemoteName)(b)}`;return g.activationEvents?.indexOf(u)!==-1}return!1}t.isResolverExtension=D,t.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],J([0,1,27,41]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function w(u,c){return u.uuid&&c.uuid?u.uuid===c.uuid:u.id===c.id?!0:(0,T.compareIgnoreCase)(u.id,c.id)===0}t.areSameExtensions=w;class P{constructor(c,y){this.version=y,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof P?w(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=P;function R(u,c){return`${u}.${c}`}t.getExtensionId=R;function L(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function l(u,c){return L(R(u,c))}t.getGalleryExtensionId=l;function d(u,c){const y=[],v=f=>{for(const h of y)if(h.some(o=>w(c(o),c(f))))return h;return null};for(const f of u){const h=v(f);h?h.push(f):y.push([f])}return y}t.groupByExtension=d;function E(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=E;function D(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=D,t.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function g(u){const c=new Set;for(const y of u)y.malicious&&c.add(y.id.id);return c}t.getMaliciousExtensionsSet=g;function b(u,c){const y=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const f=v.shift();if(f&&y.every(h=>!w(h.identifier,{id:f}))){const h=u.filter(o=>w(o.identifier,{id:f}));h.length===1&&(y.push(h[0]),v.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}t.getExtensionDependencies=b}),define(Y[106],J([0,1,24,9,61,5,42,7,76,22,23,41]),function(V,t,T,S,w,P,R,L,l,d,E,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=f=>(0,l.localize)(0,null,f),b=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(f,h){return h?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function y(f){const h=c.exec(f);return h&&h[1]?[(0,E.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,E.adoptToGalleryExtensionId)(f),void 0]}t.getIdAndVersion=y;let v=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=D.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(m=>m.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,h)))}async installExtensions(h,o,s,e,i=console){const n=[],r=[];h.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),m=(p,C)=>{const A=a.find(x=>(0,E.areSameExtensions)(x.identifier,{id:p}));if(A){if(!C&&!e)return i.log((0,l.localize)(5,null,p,A.manifest.version,p)),!1;if(C&&A.manifest.version===C)return i.log((0,l.localize)(6,null,`${p}@${C}`)),!1}return!0},I=[],O=[];for(const p of h)if(p instanceof L.URI)I.push(p);else{const[C,A]=y(p);m(C,A)&&O.push({id:C,version:A,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const p of o){const[C,A]=y(p);m(C,A)&&O.push({id:C,version:A,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(I.length&&await Promise.all(I.map(async p=>{try{const C=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:s},e,i);C&&r.push(C)}catch(C){i.error(C.message||C.stack||C),n.push(p.toString())}})),O.length){const p=await this.getGalleryExtensions(O);await Promise.all(O.map(async C=>{const A=p.get(C.id.toLowerCase());if(A)try{const x=await this.installFromGallery(C,A,a,e,i);x&&r.push(x)}catch(x){i.error(x.message||x.stack||x),n.push(C.id)}else i.error(`${g(C.version?`${C.id}@${C.version}`:C.id)}
${b}`),n.push(C.id)}))}if(n.length)throw new Error((0,l.localize)(7,null,n.join(", ")))}async installVSIX(h,o,s,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,l.localize)(8,null,(0,w.getBaseLabel)(h))),i}catch(r){if((0,S.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,w.getBaseLabel)(h))),null;throw r}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,T.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const m=i.find(I=>(0,E.areSameExtensions)(I.identifier,e.identifier));if(m){if(e.version===m.manifest.version)return r.log((0,l.localize)(10,null,o?`${h}@${o}`:h)),null;r.log((0,l.localize)(11,null,h,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,h,o):(0,l.localize)(13,null,h)):r.log(o?(0,l.localize)(14,null,h,o):(0,l.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,h,e.version)),a}catch(I){if((0,S.isPromiseCanceledError)(I))return r.log((0,l.localize)(17,null,h)),null;throw I}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,E.getGalleryExtensionId)(h.publisher,h.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,E.areSameExtensions)(e,r.identifier)&&(0,R.gt)(r.manifest.version,h.version));return n&&!o?(s.log((0,l.localize)(18,null,n.identifier.id,n.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async n=>{if(n instanceof L.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of h){const r=await e(n),m=(await this.extensionManagementService.getInstalled()).filter(I=>(0,E.areSameExtensions)(I.identifier,{id:r}));if(!m.length)throw new Error(`${this.notInstalled(r)}
${b}`);if(m.some(I=>I.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&m.some(I=>I.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const I of m)await this.extensionManagementService.uninstall(I),i.push(I);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===P.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,l.localize)(24,null,h,this.location):(0,l.localize)(25,null,h)}};v=de([ce(0,d.IExtensionManagementService),ce(1,d.IExtensionGalleryService)],v),t.ExtensionManagementCLIService=v}),define(Y[107],J([0,1,6,9,2,10,19,42,7,31,12,21,22,23,16,14]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends w.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,R.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,o,s){try{await E.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(P.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const n of h.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,b.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>L.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new b.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(h){const o=y.exec(h);return o&&o[1]&&o[2]?new b.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};v=de([ce(0,D.INativeEnvironmentService),ce(1,u.IFileService),ce(2,g.IExtensionGalleryService),ce(3,c.ILogService)],v),t.ExtensionsDownloader=v}),define(Y[108],J([0,1,2,8,12,41]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class R extends T.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,S.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=R}),define(Y[109],J([0,1,13,2,19,7,21,23,16,14]),function(V,t,T,S,w,P,R,L,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let E=class extends S.Disposable{constructor(g,b,u,c){super();this.extensionsManagementService=g,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(f=>{this.installedExtensions=f.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const y=P.URI.file(u.extensionsPath),v=new w.ExtUri(f=>!b.hasCapability(f,1024));this._register(b.watch(y)),this._register(T.Event.filter(b.onDidChangeFilesRaw,f=>f.changes.some(h=>this.doesChangeAffects(h,y,v)))(()=>this.onDidChange()))}doesChangeAffects(g,b,u){return u.isEqual(u.dirname(g.resource),b)?u.isEqual(g.resource,u.joinPath(b,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const b of g)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(b=>!(0,L.areSameExtensions)(b,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,L.areSameExtensions)(b,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),b=g.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,L.areSameExtensions)(y,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),u=this.installedExtensions.filter(c=>this.installingExtensions.some(y=>(0,L.areSameExtensions)(y,c))?!1:g.every(y=>!(0,L.areSameExtensions)(y.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=g.map(c=>c.identifier),(b.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:u})}}};E=de([ce(1,l.IFileService),ce(2,R.INativeEnvironmentService),ce(3,d.ILogService)],E),t.ExtensionsWatcher=E}),define(Y[110],J([0,1,132,20,6,2,5,8,12,21,22,23,54,14]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends P.Disposable{constructor(v,f,h){super();this.extensionManagementService=v,this.logService=h,this.cache=this._register(new c(f,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),f=["en",...Object.keys(v)];return(0,S.distinct)(f)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const f=await this.cache.getLanguagePacks();Object.keys(f).some(h=>f[h]&&f[h].extensions.some(o=>(0,D.areSameExtensions)(o.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(f);return!(0,S.equals)(Object.keys(v),Object.keys(h))}};u=de([ce(0,E.IExtensionManagementService),ce(1,d.INativeEnvironmentService),ce(2,b.ILogService)],u),t.LocalizationsService=u;let c=class extends P.Disposable{constructor(v,f){super();this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(f=>{Object.keys(f).forEach(h=>delete f[h]),this.createLanguagePacksFromExtensions(f,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...f){for(const h of f)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,h);Object.keys(v).forEach(h=>this.updateHash(v[h]))}createLanguagePacksFromExtension(v,f){const h=f.identifier,o=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const s of o)if(f.location.scheme===R.Schemas.file&&(0,g.isValidLocalization)(s)){let e=v[s.languageId];e||(e={hash:"",extensions:[],translations:{}},v[s.languageId]=e);let i=e.extensions.filter(n=>(0,D.areSameExtensions)(n.extensionIdentifier,h))[0];i?i.version=f.manifest.version:e.extensions.push({extensionIdentifier:h,version:f.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,L.join)(f.location.fsPath,n.path)}}updateHash(v){if(v){const f=(0,T.createHash)("md5");for(const h of v.extensions)f.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);v.hash=f.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(f=v(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>f,h=>this.logService.error(h))})}};c=de([ce(0,d.INativeEnvironmentService),ce(1,b.ILogService)],c)}),define(Y[43],J([0,1,17,84,33,15,25]),function(V,t,T,S,w,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,P.createDecorator)("requestService");function L(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=L;function l(u){return u.res.statusCode===204}async function d(u){if(!L(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}t.asText=d;async function E(u){if(!L(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const y=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(y)}catch(v){throw v.message+=`:
`+y,v}}t.asJson=E;function D(u){b(u)}t.updateProxyConfigurationsScope=D;let g;function b(u){const c=R.Registry.as(w.Extensions.Configuration),y=g;g={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[g],remove:y?[y]:[]})}b(2)}),define(Y[111],J([0,1,24,5,16,43]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let R=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,E=T.CancellationToken.None){if(l.scheme===S.Schemas.file||l.scheme===S.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const D={type:"GET",url:l.toString()},g=await this.requestService.request(D,E);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const b=await(0,P.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${b}`)}}};R=de([ce(0,P.IRequestService),ce(1,w.IFileService)],R),t.DownloadService=R}),define(Y[112],J([0,1,113,11]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(R,L){return R.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:R.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function P(R,L,l={}){const d=(0,T.parse)(R),E=l.proxyUrl||w(d,L);if(!E)return null;const D=(0,T.parse)(E);if(!/^https?:$/.test(D.protocol||""))return null;const g={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:(0,S.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((b,u)=>{V(["http-proxy-agent"],b,u)}))(g):new(await new Promise((b,u)=>{V(["https-proxy-agent"],b,u)}))(g)}t.getProxyAgent=P}),define(Y[114],J([0,1,17,31]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(P,R,L){let l=L&&L.get("storage.serviceMachineId",0)||null;if(l)return l;try{const E=(await R.readFile(P.serviceMachineIdResource)).value.toString();l=(0,S.isUUID)(E)?E:null}catch(d){l=null}if(!l){l=(0,S.generateUuid)();try{await R.writeFile(P.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch(d){}}return L&&L.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=w}),define(Y[115],J([0,1,6,13,2,11,65,15]),function(V,t,T,S,w,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,L.createDecorator)("storageService");var d;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var E;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(E=t.StorageScope||(t.StorageScope={}));var D;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(D=t.StorageTarget||(t.StorageTarget={}));class g extends w.Disposable{constructor(y={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new S.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new S.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new S.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,v){v===l?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:v,target:this.getKeyTargets(y)[v]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,v,f){return this.getStorage(v)?.get(y,f)}getBoolean(y,v,f){return this.getStorage(v)?.getBoolean(y,f)}getNumber(y,v,f){return this.getStorage(v)?.getNumber(y,f)}store(y,v,f,h){if((0,P.isUndefinedOrNull)(v)){this.remove(y,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,f,h),this.getStorage(f)?.set(y,v)})}remove(y,v){this.withPausedEmitters(()=>{this.updateKeyTarget(y,v,void 0),this.getStorage(v)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,v){const f=[],h=this.getKeyTargets(y);for(const o of Object.keys(h))h[o]===v&&f.push(o);return f}updateKeyTarget(y,v,f){const h=this.getKeyTargets(v);typeof f=="number"?h[y]!==f&&(h[y]=f,this.getStorage(v)?.set(l,JSON.stringify(h))):typeof h[y]=="number"&&(delete h[y],this.getStorage(v)?.set(l,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const v=this.get(l,y);if(v)try{return JSON.parse(v)}catch(f){}return Object.create(null)}isNew(y){return this.getBoolean(t.IS_NEW_KEY,y)===!0}async flush(y=d.NONE){this._onWillSaveState.fire({reason:y}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const y=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return u(y,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends g{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}t.InMemoryStorageService=b;async function u(c,y,v,f){const h=a=>{try{return JSON.parse(a)}catch(m){return a}},o=new Map,s=new Map;c.forEach((a,m)=>{o.set(m,a),s.set(m,h(a))});const e=new Map,i=new Map;y.forEach((a,m)=>{e.set(m,a),i.set(m,h(a))}),console.group(`Storage: Global (path: ${v})`);let n=[];o.forEach((a,m)=>{n.push({key:m,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${f})`);let r=[];e.forEach((a,m)=>{r.push({key:m,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Y[116],J([0,1,10,28,7,31]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function R(d){if(T.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function L(d,E,D,g,b,u,c,y,v,f){const h=Object.create(null);h["common.machineId"]=c,h.sessionID=(0,P.generateUuid)()+Date.now(),h.commitHash=b,h.version=u,h["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,T.PlatformToString)(T.platform),h["common.nodePlatform"]=S.platform,h["common.nodeArch"]=g,h["common.product"]=f||"desktop";const o=l(y||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),T.isLinuxSnap&&(h["common.snap"]="true");const i=R(D);i&&(h["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(v));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}t.resolveCommonProperties=L;function l(d){const E=S.env.USERDNSDOMAIN;if(!E)return!1;const D=E.toLowerCase();return d.some(g=>D===g)}t.verifyMicrosoftInternalDomain=l}),define(Y[29],J([0,1,15]),function(V,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var S;(function(P){P[P.NONE=0]="NONE",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(S=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(P){P.OFF="off",P.ERROR="error",P.ON="on"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Y[117],J([0,1,20,6,24,9,13,2,10,7,74,22,23,14,32,29]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let y=class extends L.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,D.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new D.ExtensionManagementError(E.localize(1,null,s.identifier.id,u.default.nameLong,(0,D.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,P.getErrorMessage)(n)),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,w.CancellationToken.None);if(i===null){const n=new D.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new D.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(E.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!d.URI.isUri(e)){let I=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(I)return this.logService.info("Extensions is already requested to install",e.identifier.id),I.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);d.URI.isUri(e)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let m=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:C}of O)if(m=m||!!C.extensionDependencies?.some(A=>(0,g.areSameExtensions)({id:A},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const A=this.createInstallExtensionTask(C,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(A.identifier,C.version).key(),A),this._onInstallExtension.fire({identifier:A.identifier,source:p}),this.logService.info("Installing extension:",A.identifier.id),n.push({task:A,manifest:C})}}catch(O){if(d.URI.isUri(a.source))(0,T.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,O.message),(0,T.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(O),O}const I=n.reduce((O,{task:p,manifest:C})=>(O.set(p.identifier.id.toLowerCase(),{task:p,manifest:C}),O),new Map);for(;I.size;){let O;const p=[...I.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(A=>I.has(A.toLowerCase())));p.length?O=I.size===1?p:p.filter(({task:C})=>!(C===a&&!m)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:C})=>C.identifier.id)),O=[...I.values()]),await this.joinAllSettled(O.map(async({task:C})=>{const A=new Date().getTime();try{const x=await C.run();if(await this.joinAllSettled(this.participants.map(K=>K.postInstall(x,C.source,i,w.CancellationToken.None))),!d.URI.isUri(C.source)&&(f(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-A,void 0),l.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch(K){}r.push({local:x,identifier:C.identifier,operation:C.operation,source:C.source})}catch(x){throw d.URI.isUri(C.source)||f(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-A,x),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(x),x}finally{I.delete(C.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:O})=>(0,g.areSameExtensions)(O,a.identifier))[0].local}catch(I){if(n.forEach(({task:O})=>O.cancel()),r.length)try{const O=await Promise.allSettled(r.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<O.length;p++){const C=O[p],{identifier:A}=r[p];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",A.id):this.logService.warn("Rollback: Error while uninstalling extension",A.id,(0,P.getErrorMessage)(C.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(O),r.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,P.getErrorMessage)(I)),this._onDidInstallExtensions.fire(n.map(({task:O})=>({identifier:O.identifier,operation:1,source:O.source}))),I instanceof Error&&(I.name=I&&I.code?I.code:t.ERROR_UNKNOWN),I}finally{for(const{task:I,manifest:O}of n)if(!d.URI.isUri(I.source)){const p=new g.ExtensionIdentifierWithVersion(I.identifier,O.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw v(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(I=>I.identifier)],a=[],m=async(I,O)=>{const p=O.extensionDependencies||[],C=[...p];if(O.extensionPack){const A=i?n.find(x=>(0,g.areSameExtensions)(x.identifier,I)):void 0;for(const x of O.extensionPack)A&&A.manifest.extensionPack&&A.manifest.extensionPack.some(K=>(0,g.areSameExtensions)({id:K},{id:x}))||C.every(K=>!(0,g.areSameExtensions)({id:K},{id:x}))&&C.push(x)}if(C.length){const A=[...r,...a.map(K=>K.gallery.identifier)],x=C.filter(K=>A.every(ee=>!(0,g.areSameExtensions)(ee,{id:K})));if(x.length){const K=await this.galleryService.query({names:x,pageSize:C.length},w.CancellationToken.None);for(const ee of K.firstPage){if(A.find(oe=>(0,g.areSameExtensions)(oe,ee.identifier)))continue;if(!p.some(oe=>(0,g.areSameExtensions)({id:oe},ee.identifier))&&!await this.canInstall(ee)){this.logService.info("Skipping the packed extension as it cannot be installed",ee.identifier.id);continue}const te=await this.checkAndGetCompatibleVersion(ee,!0),ue=await this.galleryService.getManifest(te,w.CancellationToken.None);if(ue===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${te.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:te,manifest:ue}),await m(te.identifier,ue)}}}};return await m(s,e),n=await this.getInstalled(),a.filter(I=>!n.some(O=>(0,g.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new D.ExtensionManagementError(E.localize(4,null,s.identifier.id),D.INSTALL_ERROR_MALICIOUS);const i=await this.getCompatibleVersion(s,e);if(!i)throw new D.ExtensionManagementError(E.localize(5,null,s.identifier.id,u.default.version),D.INSTALL_ERROR_INCOMPATIBLE);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(I,O)=>{const p=this.createUninstallExtensionTask(I,O);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",I.identifier.id),this._onUninstallExtension.fire(I.identifier),p},r=(I,O)=>{O?this.logService.error("Failed to uninstall extension:",I.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",I.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(I),void 0,O),this._onDidUninstallExtension.fire({identifier:I.identifier,error:O?.code})},a=[],m=[];try{a.push(n(s,{}));const I=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(s,I);for(const p of O)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(n(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(O=>O.extension),I,s),await this.joinAllSettled(a.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(O.extension,e,w.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch(p){}r(O.extension)}catch(p){const C=p instanceof D.ExtensionManagementError?p:new D.ExtensionManagementError((0,P.getErrorMessage)(p),t.ERROR_UNKNOWN);throw r(O.extension,C),C}finally{m.push(O)}}))}catch(I){const O=I instanceof D.ExtensionManagementError?I:new D.ExtensionManagementError((0,P.getErrorMessage)(I),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(C){}m.includes(p)||r(p.extension,O)}throw O}finally{for(const I of a)this.uninstallingExtensions.delete(I.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",I.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(m=>!s.some(I=>(0,g.areSameExtensions)(I.identifier,m.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?E.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?E.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(m=>!m.isBuiltin&&n.some(I=>(0,g.areSameExtensions)({id:I},m.identifier))),a=[];for(const m of r)a.push(...this.getAllPackExtensionsToUninstall(m,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=de([ce(0,D.IExtensionGalleryService),ce(1,c.ITelemetryService),ce(2,b.ILogService)],y),t.AbstractExtensionManagementService=y;function v(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=v;function f(o,s,e,i,n){const r=n?n instanceof D.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=f;class h{constructor(){this.barrier=new S.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,S.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,S.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,P.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(Y[36],J([0,1,18,11,26,29]),function(V,t,T,S,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,f){return Promise.resolve(void 0)}publicLog2(v,f){return this.publicLog(v,f)}publicLogError(v,f){return Promise.resolve(void 0)}publicLogError2(v,f){return this.publicLogError(v,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=R,t.NullTelemetryService=new R;class L{async publicLog(v,f,h){}async publicLogError(v,f,h){}}t.NullEndpointTelemetryService=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(y,v){return v.onDidChangeConfiguration(f=>{f.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(f.source),configurationKeys:u(f.sourceConfig)})})}t.configurationTelemetry=l;function d(y,v){return!(v.disableTelemetry||!y.enableTelemetry)}t.supportsTelemetry=d;function E(y){const v=y.getValue(P.TELEMETRY_SETTING_ID),f=y.getValue(P.TELEMETRY_OLD_SETTING_ID);if(f!==void 0&&f===!1)return 0;switch(v??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}t.getTelemetryLevel=E;function D(y){const v=Object.create(null),f=Object.create(null),h=Object.create(null);b(y,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const s=h[o];typeof s=="number"?f[o]=s:typeof s=="boolean"?f[o]=s?1:0:typeof s=="string"?v[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(v[o]=s)}return{properties:v,measurements:f}}t.validateTelemetryData=D;function g(y){if(!y)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{y.indexOf(`${h}+`)===0&&(v=h)}),v}t.cleanRemoteAuthority=g;function b(y,v,f=0,h){if(!!y)for(let o of Object.getOwnPropertyNames(y)){const s=y[o],e=h?h+o:o;Array.isArray(s)?v[e]=(0,T.safeStringify)(s):s instanceof Date?v[e]=s.toISOString():(0,S.isObject)(s)?f<2?b(s,v,f+1,e+"."):v[e]=(0,T.safeStringify)(s):v[e]=s}}function u(y){if(!y)return[];const v=[];return c(v,"",y),v}function c(y,v,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(h=>c(y,v?`${v}.${h}`:h,f[h])):y.push(v)}}),define(Y[118],J([0,1,20,24,9,18,10,28,7,26,21,22,23,49,16,14,40,43,114,115,29,36]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c,y,v,f,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=R.isWeb?"web":(0,D.getTargetPlatform)(R.platform,L.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...U){return String(U.reduce((N,_)=>N|_,0))}var r;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},O={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class p{constructor(N=O){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,_=this.state.pageSize){return new p({...this.state,pageNumber:N,pageSize:_})}withFilter(N,..._){const W=[...this.state.criteria,..._.length?_.map(X=>({filterType:N,value:X})):[{filterType:N}]];return new p({...this.state,criteria:W})}withSortBy(N){return new p({...this.state,sortBy:N})}withSortOrder(N){return new p({...this.state,sortOrder:N})}withFlags(...N){return new p({...this.state,flags:N.reduce((_,W)=>_|W,0)})}withAssetTypes(...N){return new p({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:_,pageSize:W,sortBy:X,sortOrder:Q,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:N,pageNumber:_,pageSize:W,sortBy:X,sortOrder:Q}],assetTypes:re,flags:se}}get searchText(){const N=this.state.criteria.filter(_=>_.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function C(U,N){const _=(U||[]).filter(W=>W.statisticName===N)[0];return _?_.value:0}function A(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(W=>W.assetType.indexOf(N)===0).reduce((W,X)=>{const Q=ae(U,X.assetType);return Q&&W.push([X.assetType.substring(N.length),Q]),W},[])}function x(U){if(U.properties){const N=U.properties.filter(X=>X.key===a.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=N.filter(X=>_.test(X.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return ae(U,a.Repository)}function K(U){return{uri:`${U.fallbackAssetUri}/${a.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${a.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ee(U){const N=ae(U,a.Icon);if(N)return N;const _=D.DefaultIconPath;return{uri:_,fallbackUri:_}}function ae(U,N){return U.files.filter(W=>W.assetType===N)[0]?{uri:`${U.assetUri}/${N}`,fallbackUri:`${U.fallbackAssetUri}/${N}`}:null}function te(U,N){const _=U.properties?U.properties.filter(X=>X.key===N):[],W=_.length>0&&_[0].value;return W?W.split(",").map(X=>(0,g.adoptToGalleryExtensionId)(X)):[]}function ue(U){const N=U.properties?U.properties.filter(_=>_.key===m.Engine):[];return N.length>0&&N[0].value||""}function oe(U){const N=U.properties?U.properties.filter(W=>W.key===m.LocalizedLanguages):[],_=N.length>0&&N[0].value||"";return _?_.split(","):[]}function B(U){return U.indexOf("preview")!==-1}function ne(U){return U.targetPlatform?(0,D.toTargetPlatform)(U.targetPlatform):"undefined"}function M(U){const N=(0,T.distinct)(U.versions.map(ne)),_=!!U.tags?.includes(D.WEB_EXTENSION_TAG),W=N.indexOf("web");return _?W===-1&&N.push("web"):W!==-1&&N.splice(W,1),N}function F(U,N){const _=(0,D.getFallbackTargetPlarforms)(N);for(let W=0;W<U.length;W++){const X=U[W];if(X.version===U[W-1]?.version){let Q=W;const se=ne(X);if(se===N)for(;Q>0&&U[Q-1].version===X.version;)Q--;else if(_.includes(se))for(;Q>0&&U[Q-1].version===X.version&&ne(U[Q-1])!==N;)Q--;Q!==W&&(U.splice(W,1),U.splice(Q,0,X))}}return U}t.sortExtensionVersions=F;function z(U,N,_,W,X){const Q=M(U);let se=U.versions[0];return se=U.versions.find(re=>re.version===se.version&&(0,D.isTargetPlatformCompatible)(ne(re),Q,X))||se,G(U,se,Q,N,_,W)}function G(U,N,_,W,X,Q){const se={manifest:ae(N,a.Manifest),readme:ae(N,a.Details),changelog:ae(N,a.Changelog),license:ae(N,a.License),repository:x(N),download:K(N),icon:ee(N),coreTranslations:A(N)};return{identifier:{id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:C(U.statistics,"install"),rating:C(U.statistics,"averagerating"),ratingCount:C(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:_,assets:se,properties:{dependencies:te(N,m.Dependency),extensionPack:te(N,m.ExtensionPack),engine:ue(N),localizedLanguages:oe(N),targetPlatform:ne(N)},preview:B(U.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+W,querySource:Q}}}let ie=class{constructor(N,_,W,X,Q,se,re,me){this.requestService=_,this.logService=W,this.environmentService=X,this.telemetryService=Q,this.fileService=se,this.productService=re,this.configurationService=me;const ye=re.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,_){const W=[];let X=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:se})=>se.toLowerCase()));N.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(X,e,S.CancellationToken.None);for(let se=0;se<Q.length;se++){const re=Q[se];if(!re.versions.length)continue;const me=(0,g.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ye=N.find(fe=>(0,g.areSameExtensions)(fe,{id:me}))?.version;if(ye){const fe=re.versions.find(Ie=>Ie.version===ye);fe&&W.push(G(re,fe,M(re),se,X))}else W.push(z(re,se,X,void 0,e))}return W}async getCompatibleExtension(N,_){const W=(0,D.isIExtensionIdentifier)(N)?null:N;if(W){if((0,D.isNotWebExtensionInWebTargetPlatform)(W.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(W,_))return W}const{id:X,uuid:Q}=W?W.identifier:N;let se=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,_,S.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const ye=M(me);if((0,D.isNotWebExtensionInWebTargetPlatform)(ye,_))return null;for(let fe of me.versions){if(!ue(fe)){const Ie=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:m.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(fe,ye,_))return G(me,fe,ye,0,se)}return null}async isExtensionCompatible(N,_){if(!(0,D.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,_))return!1;let W=N.properties.engine;if(!W){const X=await this.getManifest(N,S.CancellationToken.None);if(!X)throw new Error("Manifest was not found");W=X.engines.vscode}return(0,b.isEngineValid)(W,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,_,W){if(!(0,D.isTargetPlatformCompatible)(ne(N),_,W))return!1;const X=await this.getEngine(N);return(0,b.isEngineValid)(X,this.productService.version,this.productService.date)}async query(N,_){const W=S.CancellationToken.isCancellationToken(N)?{}:N,X=S.CancellationToken.isCancellationToken(N)?N:_;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=W.text||"";const se=(0,P.getOrDefault)(W,pe=>pe.pageSize,50);let re=new p().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Category,Ae||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Tag,Ae||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),re=re.withFilter(r.SearchText,Q)),re=re.withSortBy(0)):W.ids?re=re.withFilter(r.ExtensionId,...W.ids):W.names?re=re.withFilter(r.ExtensionName,...W.names):re=re.withSortBy(4),typeof W.sortBy=="number"&&(re=re.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(re=re.withSortOrder(W.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(re,e,X),fe=me.map((pe,Ee)=>z(pe,Ee,re,W.source,e)),Ie=async(pe,Ee)=>{if(Ee.isCancellationRequested)throw(0,w.canceled)();const Ae=re.withPage(pe+1),{galleryExtensions:Me}=await this.queryGallery(Ae,e,Ee);return Me.map((xe,ze)=>z(xe,ze,Ae,W.source,e))};return{firstPage:fe,total:ye,pageSize:re.pageSize,getPage:Ie}}async queryGallery(N,_,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(N.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},re=new Date().getTime();let me,ye,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},W),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Ie=await(0,v.asJson)(me);if(Ie){const pe=Ie.results[0],Ee=pe.extensions;Ee.forEach(Me=>F(Me.versions,_));const Ae=pe.resultMetadata&&pe.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Ae&&Ae.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe}}return{galleryExtensions:[],total:fe}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-re,success:!!me&&(0,v.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,w.isPromiseCanceledError)(ye)?"canceled":(0,w.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(N,_,W,X){if(!this.isEnabled())return;const Q=R.isWeb?this.api(`/itemName/${N}.${_}/version/${W}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${_}/${W}/stats?statType=${X}`),se=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},S.CancellationToken.None)}catch(ye){}}async download(N,_,W){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const X=(0,g.getGalleryExtensionTelemetryData)(N),Q=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=W===1?"install":W===2?"update":"",me=re?{uri:`${N.assets.download.uri}${l.URI.parse(N.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${N.assets.download.fallbackUri}${l.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:N.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(_,ye.stream),se(new Date().getTime()-Q)}async getReadme(N,_){if(N.assets.readme){const W=await this.getAsset(N.assets.readme,{},_);return await(0,v.asText)(W)||""}return""}async getManifest(N,_){if(N.assets.manifest){const W=await this.getAsset(N.assets.manifest,{},_),X=await(0,v.asText)(W);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(N,_){const W=ae(N,a.Manifest);if(!W)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(W,{headers:X});return await(0,v.asJson)(Q)}async getCoreTranslation(N,_){const W=N.assets.coreTranslations.filter(X=>X[0]===_.toUpperCase())[0];if(W){const X=await this.getAsset(W[1]),Q=await(0,v.asText)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(N,_){if(N.assets.changelog){const W=await this.getAsset(N.assets.changelog,{},_);return await(0,v.asText)(W)||""}return""}async getAllCompatibleVersions(N,_){let W=new p().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?W=W.withFilter(r.ExtensionId,N.identifier.uuid):W=W.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:X}=await this.queryGallery(W,_,S.CancellationToken.None);if(!X.length)return[];const Q=M(X[0]);if((0,D.isNotWebExtensionInWebTargetPlatform)(Q,_))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Q,_)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(N,_={},W=S.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},se={...X,..._.headers||{}};_={..._,...Q,headers:se};const re=N.uri,me=N.fallbackUri,ye={..._,url:re};try{const fe=await this.requestService.request(ye,W);if(fe.res.statusCode===200)return fe;const Ie=await(0,v.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Ie}`)}catch(fe){if((0,w.isPromiseCanceledError)(fe))throw fe;const Ie=(0,w.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Ie});const pe={..._,url:me};return this.requestService.request(pe,W)}}async getEngine(N){let _=ue(N);if(!_){const W=await this.getManifestFromRawExtensionVersion(N,S.CancellationToken.None);if(!W)throw new Error("Manifest was not found");_=W.engines.vscode}return _}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},S.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,v.asJson)(N),W=new Map;if(_)for(const X of _.malicious){const Q=W.get(X)||{id:{id:X},malicious:!0,slow:!1};Q.malicious=!0,W.set(X,Q)}return[...W.values()]}};ie=de([ce(1,v.IRequestService),ce(2,c.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,u.IFileService),ce(6,y.IProductService),ce(7,d.IConfigurationService)],ie);let H=class extends ie{constructor(N,_,W,X,Q,se,re,me){super(N,_,W,X,Q,se,re,me)}};H=de([ce(0,h.IStorageService),ce(1,v.IRequestService),ce(2,c.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,u.IFileService),ce(6,y.IProductService),ce(7,d.IConfigurationService)],H),t.ExtensionGalleryService=H;let Z=class extends ie{constructor(N,_,W,X,Q,se,re){super(void 0,N,_,W,X,Q,se,re)}};Z=de([ce(0,v.IRequestService),ce(1,c.ILogService),ce(2,E.IEnvironmentService),ce(3,o.ITelemetryService),ce(4,u.IFileService),ce(5,y.IProductService),ce(6,d.IConfigurationService)],Z),t.ExtensionGalleryServiceWithNoStorageService=Z;async function q(U,N,_,W,X,Q){const se={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},re=await(0,f.getServiceMachineId)(_,X,Q);return(0,s.supportsTelemetry)(N,_)&&(0,s.getTelemetryLevel)(W)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=q}),define(Y[119],J([0,1,2,18,10,27,85,26,33,32,25,29,36]),function(V,t,T,S,w,P,R,L,l,d,E,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let b=class{constructor(y,v){this._configurationService=v,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(f=>{const h=/^[a-f0-9]+$/i.test(f["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(y,v){this._experimentProperties[y]=v}_convertOldTelemetrySettingToNew(){const y=this._configurationService.getValue(D.TELEMETRY_OLD_SETTING_ID),v=this._configurationService.getValue("telemetry.enableCrashReporter");(y===!1||v===!1)&&this._configurationService.updateValue(D.TELEMETRY_SETTING_ID,"off")}_updateTelemetryLevel(){this._convertOldTelemetrySettingToNew(),this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let v=y.sessionID,f=y["common.instanceId"],h=y["common.machineId"],o=y["common.firstSessionDate"],s=y["common.msftInternal"];return{sessionId:v,instanceId:f,machineId:h,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(y,v,f,h){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(o=>{f=(0,S.mixin)(f,o),f=(0,S.mixin)(f,this._experimentProperties),f=(0,S.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,h)}),this._appenders.forEach(s=>s.log(y,f))},o=>{console.error(o)})}publicLog(y,v,f){return this._log(y,3,v,f)}publicLog2(y,v,f){return this.publicLog(y,v,f)}publicLogError(y,v){return this.sendErrorTelemetry?this._log(y,2,v,!0):Promise.resolve(void 0)}publicLogError2(y,v){return this.publicLogError(y,v)}_anonymizeFilePaths(y){let v=y;const f=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(y);if(!i)break;f.push([i.index,e.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(v="";;){const e=o.exec(y);if(!e)break;!h.test(e[0])&&f.every(([i,n])=>e.index<i||e.index>=n)&&(v+=y.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<y.length&&(v+=y.substr(s)),v}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const v=y.toLowerCase(),f=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":f.test(v)?"<REDACTED: email>":y}_cleanupInfo(y,v){let f=y;v&&(f=this._anonymizeFilePaths(f));for(let h of this._cleanupPatterns)f=f.replace(h,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=de([ce(1,L.IConfigurationService)],b),t.TelemetryService=b;const u=w.isWeb?"":" "+(0,R.localize)(0,null);E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(1,null),properties:{[D.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null)],markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(6,null,d.default.nameLong,d.default.privacyStatementUrl)+u:(0,R.localize)(5,null,d.default.nameLong)+u,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(7,null),properties:{[D.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(9,null,d.default.nameLong,d.default.privacyStatementUrl):(0,R.localize)(8,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(10,null,`\`#${D.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[120],J([0,1,9,18,36]),function(V,t,T,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function P(L){const l=await new Promise((E,D)=>{V(["applicationinsights"],E,D)});let d;return l.defaultClient?(d=new l.TelemetryClient(L),d.channel.setUseDiskRetryCaching(!0)):(l.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=l.defaultClient),L.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class R{constructor(l,d,E){this._eventPrefix=l,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof E=="function"?this._aiClient=E():this._aiClient=E,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,T.onUnexpectedError)(d),console.error(d)})}}log(l,d){!this._aiClient||(d=(0,S.mixin)(d,this._defaultData),d=(0,w.validateTelemetryData)(d),this._withAIClient(E=>E.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=R}),define(Y[121],J([0,1,8,12]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(P,R){const L=Object.create(null),l=(E,D)=>{const g=JSON.parse(E);L[D]=g};if(R){const E=[],D=await S.Promises.readdir(R);for(const b of D)try{(await S.Promises.stat((0,T.join)(R,b))).isDirectory()&&E.push(b)}catch{}const g=[];for(const b of E)(await S.Promises.readdir((0,T.join)(R,b))).filter(c=>c==="telemetry.json").length===1&&g.push(b);for(const b of g){const u=(await S.Promises.readFile((0,T.join)(R,b,"telemetry.json"))).toString();l(u,b)}}let d=(await S.Promises.readFile((0,T.join)(P,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await S.Promises.readFile((0,T.join)(P,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=w}),define(Y[44],J([0,1,47,6,8,11,12,71,133,134]),function(V,t,T,S,w,P,R,L,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class E extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=E;function D(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function g(s){if(s instanceof E)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new E(e,s)}function b(s,e,i,n,r,a){const m=w.dirname(e),I=w.join(n,m);if(!I.startsWith(n))return Promise.reject(new Error(L.localize(0,null,e)));const O=w.join(n,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(R.Promises.mkdir(I,{recursive:!0})).then(()=>new Promise((C,A)=>{if(!a.isCancellationRequested)try{p=(0,T.createWriteStream)(O,{mode:i}),p.once("close",()=>C()),p.once("error",A),s.once("error",A),s.pipe(p)}catch(x){A(x)}}))}function u(s,e,i,n){let r=(0,S.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,I)=>{const O=new S.Sequencer,p=C=>{C.isCancellationRequested||(a++,s.readEntry())};s.once("error",I),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?m():I(new E("Incomplete",new Error(L.localize(1,null,a,s.entryCount))))},I)),s.readEntry(),s.on("entry",C=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){p(n);return}const A=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(A)){const ee=w.join(e,A);r=(0,S.createCancelablePromise)(ae=>R.Promises.mkdir(ee,{recursive:!0}).then(()=>p(ae)).then(void 0,I));return}const x=y(s,C),K=D(C);r=(0,S.createCancelablePromise)(ee=>O.queue(()=>x.then(ae=>b(ae,A,K,e,i,ee).then(()=>p(ee)))).then(null,I))})})}function c(s,e=!1){return new Promise((i,n)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(g(r)):i((0,P.assertIsDefined)(a))})})}function y(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(g(r)):i((0,P.assertIsDefined)(a))})})}function v(s,e){return new Promise((i,n)=>{const r=new d.ZipFile;e.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const a=(0,T.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=v;function f(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=c(s,!0);return i.overwrite&&(a=a.then(m=>R.Promises.rm(e).then(()=>m))),a.then(m=>u(m,e,{sourcePathRegex:r},n))}t.extract=f;function h(s,e){return c(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&y(i,a).then(m=>n(m),m=>r(m))}),i.once("close",()=>r(new Error(L.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",m=>a.push(m)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(Y[122],J([0,1,44,78]),function(V,t,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(P){return(0,T.buffer)(P,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(L){throw new Error((0,S.localize)(0,null))}})}t.getManifest=w}),define(Y[123],J([0,1,20,6,9,2,5,8,10,19,42,7,31,12,44,79,21,22,23,89,16,14,40]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c,y,v,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",m="renaming";let I=class extends P.Disposable{constructor(p,C,A,x,K){super();this.beforeRemovingExtension=p,this.fileService=C,this.logService=A,this.environmentService=x,this.productService=K,this._devSystemExtensionsPath=null,this.systemExtensionsPath=x.builtinExtensionsPath,this.extensionsPath=x.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new S.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const C=[];(p===null||p===0)&&C.push(this.scanSystemExtensions().then(null,A=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(A).message,i)))),(p===null||p===1)&&C.push(this.scanUserExtensions(!0).then(null,A=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(A).message,n))));try{const A=await Promise.all(C);return(0,T.flatten)(A)}catch(A){throw this.joinErrors(A)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[C,A]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return A=A.filter(x=>!C[new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version).key()]),p&&(A=(0,f.groupByExtension)(A,K=>K.identifier).map(K=>K.sort((ee,ae)=>E.rcompare(ee.manifest.version,ae.manifest.version))[0])),this.logService.trace("Scanned user extensions:",A.length),A}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,C,A,x){const K=p.key(),ee=L.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),ae=L.join(this.extensionsPath,K);try{await b.Promises.rm(ae)}catch(ue){try{await b.Promises.rm(ae)}catch(oe){}throw new v.ExtensionManagementError((0,c.localize)(0,null,ae,p.id),a)}await this.extractAtLocation(p,C,ee,x);let te=await this.scanExtension(D.URI.file(ee),1);if(!te)throw new Error((0,c.localize)(1,null,ee));await this.storeMetadata(te,{...A,installedTimestamp:Date.now()});try{await this.rename(p,ee,ae,Date.now()+2*60*1e3),this.logService.info("Renamed to",ae)}catch(ue){try{await b.Promises.rm(ee)}catch(oe){}if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(ue)}. Deleted from extracted location`,ee),ue}try{te=await this.scanExtension(D.URI.file(ae),1)}catch(ue){}if(te)return te;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,C){return this.setMetadata(p,C),await this.storeMetadata(p,{...C,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const A=L.join(p.location.fsPath,"package.json"),x=await b.Promises.readFile(A,"utf8"),{manifest:K}=await this.parseManifest(x);return K.__metadata=C,await b.Promises.writeFile(A,JSON.stringify(K,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const C=p.map(A=>new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version));await this.withUninstalledExtensions(A=>{C.forEach(x=>A[x.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(x=>delete x[p.key()]);const A=(await this.scanExtensions(1)).find(x=>new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version).equals(p))||null;return A?(await this.storeMetadata(A,{installedTimestamp:Date.now()}),this.scanExtension(A.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(x){if(x.code!=="ENOENT")throw x}let A={};if(C)try{A=JSON.parse(C)}catch(x){}return p&&(p(A),Object.keys(A).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(A)):await b.Promises.rm(this.uninstalledPath)),A})}async removeExtension(p,C){this.logService.trace(`Deleting ${C} extension from disk`,p.identifier.id,p.location.fsPath),await b.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new f.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,C,A,x){this.logService.trace(`Started extracting the extension from ${C} to ${A}`);try{await b.Promises.rm(A)}catch(K){throw new v.ExtensionManagementError(this.joinErrors(K).message,a)}try{await(0,u.extract)(C,A,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${A}:`,p.id)}catch(K){try{await b.Promises.rm(A)}catch(ee){}throw new v.ExtensionManagementError(K.message,K instanceof u.ExtractError&&K.type?K.type:r)}}async rename(p,C,A,x){try{await b.Promises.rename(C,A)}catch(K){if(l.isWindows&&K&&K.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${C} to ${A} with 'EPERM' error. Trying again...`,p.id),this.rename(p,C,A,x);throw new v.ExtensionManagementError(K.message||(0,c.localize)(3,null,C,A),K.code||m)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const C=this.scanDevSystemExtensions(),[A,x]=await Promise.all([p,C]);return[...A,...x]}async scanExtensionsInDir(p,C){const A=new S.Limiter(10),x=await this.fileService.resolve(D.URI.file(p));return x.children?(await Promise.all(x.children.filter(ee=>ee.isDirectory).map(ee=>A.queue(async()=>C===1&&(0,d.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,C))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(p,C){try{const A=await this.fileService.resolve(p);if(A.children){const{manifest:x,metadata:K}=await this.readManifest(p.fsPath),ee=A.children.find(({name:oe})=>/^readme(\.txt|\.md|)$/i.test(oe))?.resource,ae=A.children.find(({name:oe})=>/^changelog(\.txt|\.md|)$/i.test(oe))?.resource,te={id:(0,f.getGalleryExtensionId)(x.publisher,x.name)},ue={type:C,identifier:te,manifest:x,location:p,readmeUrl:ee,changelogUrl:ae,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return K&&(this.setMetadata(ue,K),ue.installedTimestamp=K.installedTimestamp),ue}}catch(A){C!==0&&this.logService.trace(A)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(A=>p.some(x=>(0,f.areSameExtensions)(A.identifier,{id:x})))}else return[]}setMetadata(p,C){p.publisherDisplayName=C.publisherDisplayName||null,p.publisherId=C.publisherId||null,p.identifier.uuid=C.id,p.isMachineScoped=!!C.isMachineScoped,p.isBuiltin=p.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),A=new Set;for(const ee of C)p[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||A.add(ee.identifier.id.toLowerCase());const x=(0,f.groupByExtension)(C,ee=>ee.identifier);await S.Promises.settled(x.map(async ee=>{const ae=ee.sort((te,ue)=>E.rcompare(te.manifest.version,ue.manifest.version))[0];A.has(ae.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ae)}));const K=C.filter(ee=>p[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await S.Promises.settled(K.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),C=[],A=(0,f.groupByExtension)(p,x=>x.identifier);C.push(...(0,T.flatten)(A.map(x=>x.sort((K,ee)=>E.rcompare(K.manifest.version,ee.manifest.version)).slice(1)))),await S.Promises.settled(C.map(x=>this.removeExtension(x,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const C=Array.isArray(p)?p:[p];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((A,x)=>new Error(`${A.message}${A.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(R.FileAccess.asFileUri("",V).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const C=[b.Promises.readFile(L.join(p,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),b.Promises.readFile(L.join(p,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:A,metadata:x},K]=await Promise.all(C);return{manifest:(0,h.localizeManifest)(A,K),metadata:x}}parseManifest(p){return new Promise((C,A)=>{try{const x=JSON.parse(p),K=x.__metadata||null;C({manifest:x,metadata:K})}catch(x){A(new Error((0,c.localize)(4,null)))}})}};I=de([ce(1,o.IFileService),ce(2,s.ILogService),ce(3,y.INativeEnvironmentService),ce(4,e.IProductService)],I),t.ExtensionsScanner=I}),define(Y[124],J([0,1,30,9,5,8,10,28,19,42,7,31,12,44,77,51,21,117,22,23,107,97,122,108,123,109,49,16,15,14,32,29]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c,y,v,f,h,o,s,e,i,n,r,a,m,I,O,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const A="unsetUninstalled",x="downloading";let K=class extends v.AbstractExtensionManagementService{constructor(B,ne,M,F,z,G,ie){super(B,ne,M);this.environmentService=F,this.downloadService=z,this.fileService=ie;const H=this._register(G.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,q=>H.postUninstall(q))),this.manifestCache=this._register(new i.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const Z=this._register(new r.ExtensionsWatcher(this,ie,F,M));this._register(Z.onDidChangeExtensionsByAnotherSource(({added:q,removed:U})=>{q.length&&this._onDidInstallExtensions.fire(q.map(N=>({identifier:N.identifier,operation:0,local:N}))),U.forEach(N=>this._onDidUninstallExtension.fire({identifier:N}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const B=await this.isAlpineLinux(),ne=(0,f.getTargetPlatform)(B?"alpine":R.platform,L.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let B;try{B=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{B=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(M){this.logService.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(M))}}return!!B&&(B.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const ne=await this.collectFiles(B),M=await(0,b.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)()).fsPath,ne);return E.URI.file(M)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const ne=await this.downloadVsix(B),M=P.resolve(ne.fsPath);return(0,e.getManifest)(M)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,ne={}){this.logService.trace("ExtensionManagementService#install",B.toString());const M=await this.downloadVsix(B),F=await(0,e.getManifest)(P.resolve(M.fsPath));if(F.engines&&F.engines.vscode&&!(0,a.isEngineValid)(F.engines.vscode,p.default.version,p.default.date))throw new Error(u.localize(0,null,(0,h.getGalleryExtensionId)(F.publisher,F.name),p.default.version));return this.installExtension(F,M,ne)}async updateMetadata(B,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),B}async updateExtensionScope(B,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===w.Schemas.file)return B;const ne=(0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)());return await this.downloadService.download(B,ne),ne}createInstallExtensionTask(B,ne,M){return E.URI.isUri(ne)?new te(B,ne,M,this.galleryService,this.extensionsScanner,this.logService):new ae(ne,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,ne){return new ue(B,ne,this.extensionsScanner)}async collectFiles(B){const ne=async F=>{let z=await g.Promises.readdir(F);z=z.map(H=>P.join(F,H));const G=await Promise.all(z.map(H=>g.Promises.stat(H)));let ie=Promise.resolve([]);return G.forEach((H,Z)=>{const q=z[Z];H.isFile()&&(ie=ie.then(U=>[...U,q])),H.isDirectory()&&(ie=ie.then(U=>ne(q).then(N=>[...U,...N])))}),ie};return(await ne(B.location.fsPath)).map(F=>({path:`extension/${P.relative(B.location.fsPath,F)}`,localPath:F}))}};K=de([ce(0,f.IExtensionGalleryService),ce(1,C.ITelemetryService),ce(2,O.ILogService),ce(3,y.INativeEnvironmentService),ce(4,c.IDownloadService),ce(5,I.IInstantiationService),ce(6,m.IFileService)],K),t.ExtensionManagementService=K;class ee extends v.AbstractExtensionTask{constructor(B,ne,M,F){super();this.identifier=B,this.source=ne,this.extensionsScanner=M,this.logService=F,this._operation=1}get operation(){return this._operation}async installExtension(B,ne){try{const M=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(M)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,B.metadata):M}catch(M){throw R.isMacintosh?new f.ExtensionManagementError(u.localize(1,null),A):new f.ExtensionManagementError(u.localize(2,null),A)}return this.extract(B,ne)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const M=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),M}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.key()]}async extract({zipPath:B,identifierWithVersion:ne,metadata:M},F){let z=await this.extensionsScanner.extractUserExtension(ne,B,M,F);return this.logService.info("Extracting completed.",ne.id),z}}class ae extends ee{constructor(B,ne,M,F,z){super(B.identifier,B,F,z);this.gallery=B,this.options=ne,this.extensionsDownloader=M}async doRun(B){const M=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,h.areSameExtensions)(z.identifier,this.gallery.identifier));M&&(this._operation=2);const F=await this.downloadInstallableExtension(this.gallery,this._operation);F.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,F.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;try{const z=await this.installExtension(F,B);return M&&d.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M),z}catch(z){throw await this.deleteDownloadedVSIX(F.zipPath),z}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(E.URI.file(B))}catch(ne){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,S.getErrorMessage)(ne))}}async downloadInstallableExtension(B,ne){const M={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let F;try{this.logService.trace("Started downloading extension:",B.identifier.id),F=(await this.extensionsDownloader.downloadExtension(B,ne)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,F)}catch(z){throw new f.ExtensionManagementError((0,v.joinErrors)(z).message,x)}try{const z=await(0,e.getManifest)(F);return{zipPath:F,identifierWithVersion:new h.ExtensionIdentifierWithVersion(B.identifier,z.version),metadata:M}}catch(z){throw await this.deleteDownloadedVSIX(F),new f.ExtensionManagementError((0,v.joinErrors)(z).message,v.INSTALL_ERROR_VALIDATING)}}}class te extends ee{constructor(B,ne,M,F,z,G){super({id:(0,h.getGalleryExtensionId)(B.publisher,B.name)},ne,z,G);this.manifest=B,this.location=ne,this.options=M,this.galleryService=F}async doRun(B){const ne=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,h.areSameExtensions)(this.identifier,G.identifier)),z=await this.getMetadata(this.identifier.id,B);if(z.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||F?.isBuiltin,F)if(this._operation=2,ne.equals(new h.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch(G){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const G=await this.unsetUninstalledAndGetLocal(ne);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch(ie){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:z},B)}async getMetadata(B,ne){try{const M=(await this.galleryService.query({names:[B],pageSize:1},ne)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class ue extends v.AbstractExtensionTask{constructor(B,ne,M){super();this.extension=B,this.options=ne,this.extensionsScanner=M}async doRun(B){const ne=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const F=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...M.filter(z=>F.equals(new h.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else ne.push(...M.filter(F=>(0,h.areSameExtensions)(F.identifier,this.extension.identifier)));if(!ne.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const F of ne)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(F)}catch(z){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(z)))}}}}),define(Y[125],J([0,1,113,17,9,2,11,26,21,94,14,112,135]),function(V,t,T,S,w,P,R,L,l,d,E,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let b=class extends P.Disposable{constructor(c,y,v){super();this.environmentService=y,this.logService=v,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,y){this.logService.trace("RequestService#request",c.url);const{proxyUrl:v,strictSSL:f}=this;let h;try{h=await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(e){this.logService.error("RequestService#request resolving shell environment failed",e)}const o={...process.env,...h},s=c.agent?c.agent:await(0,D.getProxyAgent)(c.url||"",o,{proxyUrl:v,strictSSL:f});return c.agent=s,c.strictSSL=f,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,y)}async getNodeRequest(c){return((0,T.parse)(c.url).protocol==="https:"?await new Promise((f,h)=>{V(["https"],f,h)}):await new Promise((f,h)=>{V(["http"],f,h)})).request}_request(c,y){return new Promise(async(v,f)=>{let h;const o=(0,T.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),h=s(e,i=>{const n=(0,R.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},y).then(v,f);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,g.createGunzip)())),v({res:i,stream:(0,S.streamToBufferReadableStream)(r)})}}),h.on("error",f),c.timeout&&h.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&h.write(c.data),h.end(),y.onCancellationRequested(()=>{h.abort(),f((0,w.canceled)())})})}async resolveProxy(c){}};b=de([ce(0,L.IConfigurationService),ce(1,l.INativeEnvironmentService),ce(2,E.ILogService)],b),t.RequestService=b}),define(Y[136],J([0,1,47,137,34,6,17,30,9,2,5,8,28,7,12,26,104,51,111,21,88,118,22,106,124,16,99,101,50,96,53,54,110,14,98,32,40,43,125,116,29,119,36,120,121]),function(V,t,T,S,w,P,R,L,l,d,E,D,g,b,u,c,y,v,f,h,o,s,e,i,n,r,a,m,I,O,p,C,A,x,K,ee,ae,te,ue,oe,B,ne,M,F,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class G extends d.Disposable{constructor(Z){super();this.argv=Z,(0,S.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,q]=await this.initServices();return Z.invokeFunction(async U=>{const N=U.get(x.ILogService),_=U.get(r.IFileService),W=U.get(h.INativeEnvironmentService),X=U.get(e.IExtensionManagementCLIService);N.info("CLI main",this.argv),this.registerErrorHandler(N),await this.doRun(W,X,_),await Promise.all(q.map(Q=>{(0,P.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const Z=new p.ServiceCollection,q={_serviceBrand:void 0,...ee.default};Z.set(ae.IProductService,q);const U=new o.NativeEnvironmentService(this.argv,q);Z.set(h.INativeEnvironmentService,U),await Promise.all([U.appSettingsHome.fsPath,U.extensionsPath].map(me=>me?u.Promises.mkdir(me,{recursive:!0}):void 0));const N=(0,x.getLogLevel)(U),_=[];_.push(new K.SpdLogLogger("cli",(0,D.join)(U.logsPath,"cli.log"),!0,N)),N===x.LogLevel.Trace&&_.push(new x.ConsoleLogger(N));const W=this._register(new x.MultiplexLogService(_));Z.set(x.ILogService,W);const X=this._register(new a.FileService(W));Z.set(r.IFileService,X);const Q=this._register(new m.DiskFileSystemProvider(W));X.registerProvider(E.Schemas.file,Q);const se=this._register(new y.ConfigurationService(U.settingsResource,X));Z.set(c.IConfigurationService,se),await se.initialize(),Z.set(te.IRequestService,new I.SyncDescriptor(ue.RequestService)),Z.set(v.IDownloadService,new I.SyncDescriptor(f.DownloadService)),Z.set(e.IExtensionManagementService,new I.SyncDescriptor(n.ExtensionManagementService)),Z.set(e.IExtensionGalleryService,new I.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),Z.set(e.IExtensionManagementCLIService,new I.SyncDescriptor(i.ExtensionManagementCLIService)),Z.set(C.ILocalizationsService,new I.SyncDescriptor(A.LocalizationsService));const re=[];if((0,M.supportsTelemetry)(q,U)){q.aiConfig&&q.aiConfig.asimovKey&&re.push(new F.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:fe}=U,Ie={appenders:re,sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const Ee=await u.Promises.readFile((0,D.join)(U.userDataPath,"storage.json"));pe=JSON.parse(Ee.toString())[B.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&W.error(Ee)}return(0,oe.resolveCommonProperties)(X,(0,w.release)(),(0,w.hostname)(),process.arch,q.commit,q.version,pe,q.msftInternalDomains,fe)})(),piiPaths:[me,ye]};Z.set(B.ITelemetryService,new I.SyncDescriptor(ne.TelemetryService,[Ie]))}else Z.set(B.ITelemetryService,M.NullTelemetryService);return[new O.InstantiationService(Z),re]}registerErrorHandler(Z){(0,l.setUnexpectedErrorHandler)(q=>{const U=(0,L.toErrorMessage)(q,!0);!U||Z.error(`[uncaught exception in CLI]: ${U}`)}),process.on("uncaughtException",q=>(0,l.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,l.onUnexpectedError)(q))}async doRun(Z,q,U){if(this.argv["install-source"])return this.setInstallSource(Z,U,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,z.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(q=>/\.vsix$/i.test(q)?b.URI.file((0,D.isAbsolute)(q)?q:(0,D.join)((0,g.cwd)(),q)):q)}async setInstallSource(Z,q,U){await q.writeFile(b.URI.file(Z.installSourcePath),R.VSBuffer.fromString(U.slice(0,30)))}}async function ie(H){const Z=new G(H);try{await Z.run()}finally{Z.dispose()}}t.main=ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/284e0db6c4cac1e557a43cd6691babdaafc2e1a9/core/vs/code/node/cliProcessMain.js.map
