/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],m=0,F=Y.length;m<F;m++)e[m]=fe[Y[m]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(F,C){if(!F)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=m}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function F(i){const k=[];for(let l in i)m.call(i,l)&&k.push(i[l]);return k}e.values=F;function C(i,k){for(let l in i)if(m.call(i,l)&&k({key:l,value:i[l]},function(){delete i[l]})===!1)return}e.forEach=C;function y(i,k){const l=Object.create(null);for(const f of i){const d=k(f);let w=l[d];w||(w=l[d]=[]),w.push(f)}return l}e.groupBy=y;function A(i){const k=Object.create(null);return i&&i.forEach((l,f)=>{k[f]=l}),k}e.fromMap=A;function _(i,k){const l=[],f=[];for(let d of i)k.has(d)||l.push(d);for(let d of k)i.has(d)||f.push(d);return{removed:l,added:f}}e.diffSets=_;function S(i,k){const l=[],f=[];for(let[d,w]of i)k.has(d)||l.push(w);for(let[d,w]of k)i.has(d)||f.push(w);return{removed:l,added:f}}e.diffMaps=S;class P{constructor(){this.map=new Map}add(k,l){let f=this.map.get(k);f||(f=new Set,this.map.set(k,f)),f.add(l)}delete(k,l){const f=this.map.get(k);!f||(f.delete(l),f.size===0&&this.map.delete(k))}forEach(k,l){const f=this.map.get(k);!f||f.forEach(l)}}e.SetMap=P}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(A){return(_,S,P)=>{let i=null,k=null;if(typeof P.value=="function"?(i="value",k=P.value):typeof P.get=="function"&&(i="get",k=P.get),!k)throw new Error("not supported");P[i]=A(k,S)}}e.createDecorator=m;function F(A,_,S){let P=null,i=null;if(typeof S.value=="function"?(P="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",i=S.get),!i)throw new Error("not supported");const k=`$memoize$${_}`;S[P]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,l)}),this[k]}}e.memoize=F;function C(A,_,S){return m((P,i)=>{const k=`$debounce$${i}`,l=`$debounce$result$${i}`;return function(...f){this[l]||(this[l]=S?S():void 0),clearTimeout(this[k]),_&&(this[l]=_(this[l],...f),f=[this[l]]),this[k]=setTimeout(()=>{P.apply(this,f),this[l]=S?S():void 0},A)}})}e.debounce=C;function y(A,_,S){return m((P,i)=>{const k=`$throttle$timer$${i}`,l=`$throttle$result$${i}`,f=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...w){if(this[l]||(this[l]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),_&&(this[l]=_(this[l],...w)),this[d])return;const D=this[f]+A;D<=Date.now()?(this[f]=Date.now(),P.apply(this,[this[l]]),this[l]=S?S():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),P.apply(this,[this[l]]),this[l]=S?S():void 0},D-Date.now()))}})}e.throttle=y}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(h=>{h(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function F(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=F;function C(v){S(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=C;function y(v){S(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=y;function A(v){if(v instanceof Error){let{name:t,message:h}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:h,stack:s}}return v}e.transformErrorForSerialization=A;const _="Canceled";function S(v){return v instanceof Error&&v.name===_&&v.message===_}e.isPromiseCanceledError=S;class P extends Error{constructor(){super(_);this.name=this.message}}e.CancellationError=P;function i(){const v=new Error(_);return v.name=v.message,v}e.canceled=i;function k(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=k;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function f(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function d(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function c(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function o(v,t=Object.create(null)){const h=new Error(v);return t.actions&&(h.actions=t.actions),h}e.createErrorWithActions=o}),define(fe[16],me([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(B,X=0){return B[B.length-(1+X)]}e.tail=F;function C(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=C;function y(B,X,Q=(de,_e)=>de===_e){if(B===X)return!0;if(!B||!X||B.length!==X.length)return!1;for(let de=0,_e=B.length;de<_e;de++)if(!Q(B[de],X[de]))return!1;return!0}e.equals=y;function A(B,X,Q){let de=0,_e=B.length-1;for(;de<=_e;){const ye=(de+_e)/2|0,ke=Q(B[ye],X);if(ke<0)de=ye+1;else if(ke>0)_e=ye-1;else return ye}return-(de+1)}e.binarySearch=A;function _(B,X){let Q=0,de=B.length;if(de===0)return 0;for(;Q<de;){const _e=Math.floor((Q+de)/2);X(B[_e])?de=_e:Q=_e+1}return Q}e.findFirstInSorted=_;function S(B,X,Q){if(B=B|0,B>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],ye=[],ke=[];for(let Be of X){const We=Q(Be,de);We<0?_e.push(Be):We>0?ye.push(Be):ke.push(Be)}return B<_e.length?S(B,_e,Q):B<_e.length+ke.length?ke[0]:S(B-(_e.length+ke.length),ye,Q)}e.quickSelect=S;function P(B,X){const Q=[];let de;for(const _e of B.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],Q.push(de)):de.push(_e);return Q}e.groupBy=P;function i(B,X,Q){const de=[];function _e(Be,We,He){if(We===0&&He.length===0)return;const q=de[de.length-1];q&&q.start+q.deleteCount===Be?(q.deleteCount+=We,q.toInsert.push(...He)):de.push({start:Be,deleteCount:We,toInsert:He})}let ye=0,ke=0;for(;;){if(ye===B.length){_e(ye,0,X.slice(ke));break}if(ke===X.length){_e(ye,B.length-ye,[]);break}const Be=B[ye],We=X[ke],He=Q(Be,We);He===0?(ye+=1,ke+=1):He<0?(_e(ye,1,[]),ye+=1):He>0&&(_e(ye,0,[We]),ke+=1)}return de}e.sortedDiff=i;function k(B,X,Q){const de=i(B,X,Q),_e=[],ye=[];for(const ke of de)_e.push(...B.slice(ke.start,ke.start+ke.deleteCount)),ye.push(...ke.toInsert);return{removed:_e,added:ye}}e.delta=k;function l(B,X,Q){if(Q===0)return[];const de=B.slice(0,Q).sort(X);return d(B,X,de,Q,B.length),de}e.top=l;function f(B,X,Q,de,_e){return Q===0?Promise.resolve([]):new Promise((ye,ke)=>{(async()=>{const Be=B.length,We=B.slice(0,Q).sort(X);for(let He=Q,q=Math.min(Q+de,Be);He<Be;He=q,q=Math.min(q+de,Be)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,m.canceled)();d(B,X,We,He,q)}return We})().then(ye,ke)})}e.topAsync=f;function d(B,X,Q,de,_e){for(const ye=Q.length;de<_e;de++){const ke=B[de];if(X(ke,Q[ye-1])<0){Q.pop();const Be=_(Q,We=>X(ke,We)<0);Q.splice(Be,0,ke)}}}function w(B){return B.filter(X=>!!X)}e.coalesce=w;function D(B){let X=0;for(let Q=0;Q<B.length;Q++)B[Q]&&(B[X]=B[Q],X+=1);B.length=X}e.coalesceInPlace=D;function I(B,X,Q){B.splice(Q,0,B.splice(X,1)[0])}e.move=I;function b(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=b;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function o(B,X=Q=>Q){const Q=new Set;return B.filter(de=>{const _e=X(de);return Q.has(_e)?!1:(Q.add(_e),!0)})}e.distinct=o;function v(B){const X=Object.create(null);return Q=>{const de=B(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function t(B,X){const Q=h(B,X);if(Q!==-1)return B[Q]}e.findLast=t;function h(B,X){for(let Q=B.length-1;Q>=0;Q--){const de=B[Q];if(X(de))return Q}return-1}e.lastIndex=h;function s(B,X){return B.length>0?B[0]:X}e.firstOrDefault=s;function n(B,X,Q=(de,_e)=>de===_e){let de=0;for(let _e=0,ye=Math.min(B.length,X.length);_e<ye&&Q(B[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=n;function r(B){return[].concat(...B)}e.flatten=r;function a(B,X){let Q=typeof X=="number"?B:0;typeof X=="number"?Q=B:(Q=0,X=B);const de=[];if(Q<=X)for(let _e=Q;_e<X;_e++)de.push(_e);else for(let _e=Q;_e>X;_e--)de.push(_e);return de}e.range=a;function u(B,X,Q){return B.reduce((de,_e)=>(de[X(_e)]=Q?Q(_e):_e,de),Object.create(null))}e.index=u;function p(B,X){return B.push(X),()=>E(B,X)}e.insert=p;function E(B,X){const Q=B.indexOf(X);if(Q>-1)return B.splice(Q,1),X}e.remove=E;function g(B,X,Q){const de=B.slice(0,X),_e=B.slice(X);return de.concat(Q,_e)}e.arrayInsert=g;function T(B,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else Q=Math.random;for(let de=B.length-1;de>0;de-=1){const _e=Math.floor(Q()*(de+1)),ye=B[de];B[de]=B[_e],B[_e]=ye}}e.shuffle=T;function L(B,X){const Q=B.indexOf(X);Q>-1&&(B.splice(Q,1),B.unshift(X))}e.pushToStart=L;function M(B,X){const Q=B.indexOf(X);Q>-1&&(B.splice(Q,1),B.push(X))}e.pushToEnd=M;function R(B,X){return Array.isArray(B)?B.map(X):X(B)}e.mapArrayOrNot=R;function W(B){return Array.isArray(B)?B:[B]}e.asArray=W;function V(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=V;function N(B,X){for(const Q of B){const de=X(Q);if(de!==void 0)return de}}e.mapFind=N;function j(B,X,Q){const de=x(B,X),_e=B.length,ye=Q.length;B.length=_e+ye;for(let ke=_e-1;ke>=de;ke--)B[ke+ye]=B[ke];for(let ke=0;ke<ye;ke++)B[ke+de]=Q[ke]}e.insertInto=j;function U(B,X,Q,de){const _e=x(B,X),ye=B.splice(_e,Q);return j(B,_e,de),ye}e.splice=U;function x(B,X){return X<0?Math.max(X+B.length,0):Math.min(X,B.length)}function z(B,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return B.forEach((_e,ye)=>{const ke=X(_e);ke<Q&&(Q=ke,de=ye)}),de}e.minIndex=z;function O(B,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return B.forEach((_e,ye)=>{const ke=X(_e);ke>Q&&(Q=ke,de=ye)}),de}e.maxIndex=O;class ${constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=$}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(F){const C=this;let y=!1,A;return function(){return y||(y=!0,A=F.apply(C,arguments)),A}}e.once=m}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(F){function C(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}F.is=C;const y=Object.freeze([]);function A(){return y}F.empty=A;function*_(v){yield v}F.single=_;function S(v){return v||y}F.from=S;function P(v){return!v||v[Symbol.iterator]().next().done===!0}F.isEmpty=P;function i(v){return v[Symbol.iterator]().next().value}F.first=i;function k(v,t){for(const h of v)if(t(h))return!0;return!1}F.some=k;function l(v,t){for(const h of v)if(t(h))return h}F.find=l;function*f(v,t){for(const h of v)t(h)&&(yield h)}F.filter=f;function*d(v,t){let h=0;for(const s of v)yield t(s,h++)}F.map=d;function*w(...v){for(const t of v)for(const h of t)yield h}F.concat=w;function*D(v){for(const t of v)for(const h of t)yield h}F.concatNested=D;function I(v,t,h){let s=h;for(const n of v)s=t(s,n);return s}F.reduce=I;function*b(v,t,h=v.length){for(t<0&&(t+=v.length),h<0?h+=v.length:h>v.length&&(h=v.length);t<h;t++)yield v[t]}F.slice=b;function c(v,t=Number.POSITIVE_INFINITY){const h=[];if(t===0)return[h,v];const s=v[Symbol.iterator]();for(let n=0;n<t;n++){const r=s.next();if(r.done)return[h,F.empty()];h.push(r.value)}return[h,{[Symbol.iterator](){return s}}]}F.consume=c;function o(v,t,h=(s,n)=>s===n){const s=v[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const r=s.next(),a=n.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!h(r.value,a.value))return!1}}F.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,h=!1){let s=0,n=t.length,r="",a=0,u=16,p=0;function E(V){let N=0,j=0;for(;N<V;){const U=t.charCodeAt(s);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;s++,N++}return N<V&&(j=-1),j}function g(V){s=V,r="",a=0,u=16,p=0}function T(){const V=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&P(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&P(t.charCodeAt(s)))for(s++;s<t.length&&P(t.charCodeAt(s));)s++;else return p=3,t.substring(V,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&P(t.charCodeAt(s))){for(s++;s<t.length&&P(t.charCodeAt(s));)s++;N=s}else p=3;return t.substring(V,N)}function L(){let V="",N=s;for(;;){if(s>=n){V+=t.substring(N,s),p=2;break}const j=t.charCodeAt(s);if(j===34){V+=t.substring(N,s),s++;break}if(j===92){if(V+=t.substring(N,s),s++,s>=n){p=2;break}switch(t.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const x=E(4);x>=0?V+=String.fromCharCode(x):p=4;break;default:p=5}N=s;continue}if(j>=0&&j<=31)if(S(j)){V+=t.substring(N,s),p=2;break}else p=6;s++}return V}function M(){if(r="",p=0,a=s,s>=n)return a=n,u=17;let V=t.charCodeAt(s);if(_(V)){do s++,r+=String.fromCharCode(V),V=t.charCodeAt(s);while(_(V));return u=15}if(S(V))return s++,r+=String.fromCharCode(V),V===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),u=14;switch(V){case 123:return s++,u=1;case 125:return s++,u=2;case 91:return s++,u=3;case 93:return s++,u=4;case 58:return s++,u=6;case 44:return s++,u=5;case 34:return s++,r=L(),u=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!S(t.charCodeAt(s));)s++;return r=t.substring(N,s),u=12}if(t.charCodeAt(s+1)===42){s+=2;const j=n-1;let U=!1;for(;s<j;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,p=1),r=t.substring(N,s),u=13}return r+=String.fromCharCode(V),s++,u=16;case 45:if(r+=String.fromCharCode(V),s++,s===n||!P(t.charCodeAt(s)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),u=11;default:for(;s<n&&R(V);)s++,V=t.charCodeAt(s);if(a!==s){switch(r=t.substring(a,s),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(V),s++,u=16}}function R(V){if(_(V)||S(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let V;do V=M();while(V>=12&&V<=15);return V}return{setPosition:g,getPosition:()=>s,scan:h?W:M,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>p}}e.createScanner=A;function _(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function k(t,h){const s=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function p(E,g,T,L){a.value=E,a.offset=g,a.length=T,a.type=L,a.colonOffset=void 0,r=a}try{c(t,{onObjectBegin:(E,g)=>{if(h<=E)throw n;r=void 0,u=h>E,s.push("")},onObjectProperty:(E,g,T)=>{if(h<g||(p(E,g,T,"property"),s[s.length-1]=E,h<=g+T))throw n},onObjectEnd:(E,g)=>{if(h<=E)throw n;r=void 0,s.pop()},onArrayBegin:(E,g)=>{if(h<=E)throw n;r=void 0,s.push(0)},onArrayEnd:(E,g)=>{if(h<=E)throw n;r=void 0,s.pop()},onLiteralValue:(E,g,T)=>{if(h<g||(p(E,g,T,v(E)),h<=g+T))throw n},onSeparator:(E,g,T)=>{if(h<=g)throw n;if(E===":"&&r&&r.type==="property")r.colonOffset=g,u=!1,r=void 0;else if(E===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(u=!0,s[s.length-1]=""),r=void 0}}})}catch(E){if(E!==n)throw E}return{path:s,previousNode:r,isAtPropertyKey:u,matches:E=>{let g=0;for(let T=0;g<E.length&&T<s.length;T++)if(E[g]===s[T]||E[g]==="*")g++;else if(E[g]!=="**")return!1;return g===E.length}}}e.getLocation=k;function l(t,h=[],s=y.DEFAULT){let n=null,r=[];const a=[];function u(E){Array.isArray(r)?r.push(E):n!==null&&(r[n]=E)}return c(t,{onObjectBegin:()=>{const E={};u(E),a.push(r),r=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const E=[];u(E),a.push(r),r=E,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:u,onError:(E,g,T)=>{h.push({error:E,offset:g,length:T})}},s),r[0]}e.parse=l;function f(t,h=[],s=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function a(E){return n.children.push(E),E}c(t,{onObjectBegin:E=>{n=a({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,g,T)=>{n=a({type:"property",offset:g,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:g,length:T,parent:n})},onObjectEnd:(E,g)=>{n.length=E+g-n.offset,n=n.parent,r(E+g)},onArrayBegin:(E,g)=>{n=a({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,g)=>{n.length=E+g-n.offset,n=n.parent,r(E+g)},onLiteralValue:(E,g,T)=>{a({type:v(E),offset:g,length:T,parent:n,value:E}),r(g+T)},onSeparator:(E,g,T)=>{n.type==="property"&&(E===":"?n.colonOffset=g:E===","&&r(g))},onError:(E,g,T)=>{h.push({error:E,offset:g,length:T})}},s);const p=n.children[0];return p&&delete p.parent,p}e.parseTree=f;function d(t,h){if(!t)return;let s=t;for(let n of h)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===n){s=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const h=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}e.getNodePath=w;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const h=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(h[s.children[0].value]=D(n))}return h;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function I(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}e.contains=I;function b(t,h,s=!1){if(I(t,h,s)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=h;r++){const a=b(n[r],h,s);if(a)return a}return t}}e.findNodeAtOffset=b;function c(t,h,s=y.DEFAULT){const n=A(t,!1);function r(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(Q){return Q?de=>Q(de,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=r(h.onObjectBegin),p=a(h.onObjectProperty),E=r(h.onObjectEnd),g=r(h.onArrayBegin),T=r(h.onArrayEnd),L=a(h.onLiteralValue),M=a(h.onSeparator),R=r(h.onComment),W=a(h.onError),V=s&&s.disallowComments,N=s&&s.allowTrailingComma;function j(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:V||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(Q){case 12:case 13:V?U(10):R();break;case 16:U(1);break;case 15:case 14:break;default:return Q}}}function U(Q,de=[],_e=[]){if(W(Q),de.length+_e.length>0){let ye=n.getToken();for(;ye!==17;){if(de.indexOf(ye)!==-1){j();break}else if(_e.indexOf(ye)!==-1)break;ye=j()}}}function x(Q){const de=n.getTokenValue();return Q?L(de):p(de),j(),!0}function z(){switch(n.getToken()){case 11:let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(U(2),Q=0)}catch(de){U(2)}L(Q);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return j(),!0}function O(){return n.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),n.getToken()===6?(M(":"),j(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function $(){u(),j();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||U(4,[],[]),M(","),j(),n.getToken()===2&&N)break}else Q&&U(6,[],[]);O()||U(4,[],[2,5]),Q=!0}return E(),n.getToken()!==2?U(7,[2],[]):j(),!0}function B(){g(),j();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||U(4,[],[]),M(","),j(),n.getToken()===4&&N)break}else Q&&U(6,[],[]);X()||U(4,[],[4,5]),Q=!0}return T(),n.getToken()!==4?U(8,[4],[]):j(),!0}function X(){switch(n.getToken()){case 3:return B();case 1:return $();case 10:return x(!0);default:return z()}}return j(),n.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(n.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=c;function o(t,h){let s=A(t),n=[],r,a=0,u;do switch(u=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:a!==u&&n.push(t.substring(a,u)),h!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,h)),a=s.getPosition();break}while(r!==17);return n.join("")}e.stripComments=o;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,61]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function F(S,P,i){let k,l,f,d,w;if(P){for(d=P.offset,w=d+P.length,f=d;f>0&&!_(S,f-1);)f--;let a=w;for(;a<S.length&&!_(S,a);)a++;l=S.substring(f,a),k=y(l,i)}else l=S,k=0,f=0,d=0,w=S.length;const D=A(i,S);let I=!1,b=0,c;i.insertSpaces?c=C(" ",i.tabSize||4):c="	";const o=(0,m.createScanner)(l,!1);let v=!1;function t(){return D+C(c,k+b)}function h(){let a=o.scan();for(I=!1;a===15||a===14;)I=I||a===14,a=o.scan();return v=a===16||o.getTokenError()!==0,a}const s=[];function n(a,u,p){!v&&u<w&&p>d&&S.substring(u,p)!==a&&s.push({offset:u,length:p-u,content:a})}let r=h();if(r!==17){const a=o.getTokenOffset()+f,u=C(c,k);n(u,f,a)}for(;r!==17;){let a=o.getTokenOffset()+o.getTokenLength()+f,u=h(),p="";for(;!I&&(u===12||u===13);){const g=o.getTokenOffset()+f;n(" ",a,g),a=o.getTokenOffset()+o.getTokenLength()+f,p=u===12?t():"",u=h()}if(u===2)r!==1&&(b--,p=t());else if(u===4)r!==3&&(b--,p=t());else{switch(r){case 3:case 1:b++,p=t();break;case 5:case 12:p=t();break;case 13:I?p=t():p=" ";break;case 6:p=" ";break;case 10:if(u===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?p=" ":u!==5&&u!==17&&(v=!0);break;case 16:v=!0;break}I&&(u===12||u===13)&&(p=t())}const E=o.getTokenOffset()+f;n(p,a,E),r=u}return s}e.format=F;function C(S,P){let i="";for(let k=0;k<P;k++)i+=S;return i}function y(S,P){let i=0,k=0;const l=P.tabSize||4;for(;i<S.length;){const f=S.charAt(i);if(f===" ")k++;else if(f==="	")k+=l;else break;i++}return Math.floor(k/l)}function A(S,P){for(let i=0;i<P.length;i++){const k=P.charAt(i);if(k==="\r")return i+1<P.length&&P.charAt(i+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=A;function _(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=_}),define(fe[140],me([0,1,61,139]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(P,i,k){return y(P,i,void 0,k)}e.removeProperty=C;function y(P,i,k,l,f){const d=i.slice(),w=[],D=(0,m.parseTree)(P,w);let I,b;for(;d.length>0&&(b=d.pop(),I=(0,m.findNodeAtLocation)(D,d),I===void 0&&k!==void 0);)typeof b=="string"?k={[b]:k}:k=[k];if(I)if(I.type==="object"&&typeof b=="string"&&Array.isArray(I.children)){const c=(0,m.findNodeAtLocation)(I,[b]);if(c!==void 0)if(k===void 0){if(!c.parent)throw new Error("Malformed AST");const o=I.children.indexOf(c.parent);let v,t=c.parent.offset+c.parent.length;if(o>0){const h=I.children[o-1];v=h.offset+h.length}else v=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return A(P,{offset:v,length:t-v,content:""},l)}else return A(P,{offset:c.offset,length:c.length,content:JSON.stringify(k)},l);else{if(k===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,v=f?f(I.children.map(h=>h.children[0].value)):I.children.length;let t;if(v>0){const h=I.children[v-1];t={offset:h.offset+h.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return A(P,t,l)}}else if(I.type==="array"&&typeof b=="number"&&Array.isArray(I.children))if(k!==void 0){const c=`${JSON.stringify(k)}`;let o;if(I.children.length===0||b===0)o={offset:I.offset+1,length:0,content:I.children.length===0?c:c+","};else{const v=b===-1||b>I.children.length?I.children.length:b,t=I.children[v-1];o={offset:t.offset+t.length,length:0,content:","+c}}return A(P,o,l)}else{const c=b,o=I.children[c];let v;if(I.children.length===1)v={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===c){const t=I.children[c-1],h=t.offset+t.length,s=I.offset+I.length;v={offset:h,length:s-2-h,content:""}}else v={offset:o.offset,length:I.children[c+1].offset-o.offset,content:""};return A(P,v,l)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${I.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(k)},l)}}e.setProperty=y;function A(P,i,k){let l=_(P,i),f=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;f>0&&!(0,F.isEOL)(l,f-1);)f--;for(;d<l.length&&!(0,F.isEOL)(l,d);)d++}const w=(0,F.format)(l,{offset:f,length:d-f},k);for(let I=w.length-1;I>=0;I--){const b=w[I];l=_(l,b),f=Math.min(f,b.offset),d=Math.max(d,b.offset+b.length),d+=b.content.length-b.length}const D=P.length-(l.length-d)-f;return[{offset:f,length:D,content:l.substring(f,d)}]}e.withFormatting=A;function _(P,i){return P.substring(0,i.offset)+i.content+P.substring(i.offset+i.length)}e.applyEdit=_;function S(P,i){let k=i.slice(0).sort((f,d)=>{const w=f.offset-d.offset;return w===0?f.length-d.length:w}),l=P.length;for(let f=k.length-1;f>=0;f--){let d=k[f];if(d.offset+d.length<=l)P=_(P,d);else throw new Error("Overlapping edit");l=d.offset}return P}e.applyEdits=S}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new m(()=>C(this.getValue()))}}e.Lazy=m}),define(fe[6],me([0,1,76,94]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let y=null;function A(n){y=n}if(e.setDisposableTracker=A,C){const n="__is_disposable_tracked__";A(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==b.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==b.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function _(n){return y?.trackDisposable(n),n}function S(n){y?.markAsDisposed(n)}function P(n,r){y?.setParent(n,r)}function i(n,r){if(!!y)for(const a of n)y.setParent(a,r)}function k(n){return y?.markAsSingleton(n),n}e.markAsSingleton=k;class l extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=l;function f(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=f;function d(n){if(F.Iterable.is(n)){let r=[];for(const a of n)if(a)try{a.dispose()}catch(u){r.push(u)}if(r.length===1)throw r[0];if(r.length>1)throw new l(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=d;function w(...n){const r=D(()=>d(n));return i(n,r),r}e.combinedDisposable=w;function D(n){const r=_({dispose:(0,m.once)(()=>{S(r),n()})});return r}e.toDisposable=D;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return P(r,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new I,_(this),P(this._store,this)}dispose(){S(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&P(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&P(r,null),r}}e.MutableDisposable=c;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class v{constructor(){this.references=new Map}acquire(r,...a){let u=this.references.get(r);u||(u={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,u));const{object:p}=u,E=(0,m.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(r,u.object),this.references.delete(r))});return u.counter++,{object:p,dispose:E}}}e.ReferenceCollection=v;class t{constructor(r){this.referenceCollection=r}async acquire(r,...a){const u=this.referenceCollection.acquire(r,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(p){throw u.dispose(),p}}}e.AsyncReferenceCollection=t;class h{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=h;function s(n){const r=new I;try{n(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class F{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let y=this._first;for(;y!==m.Undefined;){const A=y.next;y.prev=m.Undefined,y.next=m.Undefined,y=A}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const _=new m(y);if(this._first===m.Undefined)this._first=_,this._last=_;else if(A){const P=this._last;this._last=_,_.prev=P,P.next=_}else{const P=this._first;this._first=_,_.next=P,P.prev=_}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(_))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=F}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,Ce){for(var Pe=0;Pe<Ce.length;Pe++){var se=Ce[Pe];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,Ce,Pe){return Ce&&Y(Re.prototype,Ce),Pe&&Y(Re,Pe),Re}function m(Re,Ce){if(!!Re){if(typeof Re=="string")return F(Re,Ce);var Pe=Object.prototype.toString.call(Re).slice(8,-1);if(Pe==="Object"&&Re.constructor&&(Pe=Re.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Re);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return F(Re,Ce)}}function F(Re,Ce){(Ce==null||Ce>Re.length)&&(Ce=Re.length);for(var Pe=0,se=new Array(Ce);Pe<Ce;Pe++)se[Pe]=Re[Pe];return se}function C(Re,Ce){var Pe=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Pe)return(Pe=Pe.call(Re)).next.bind(Pe);if(Array.isArray(Re)||(Pe=m(Re))||Ce&&Re&&typeof Re.length=="number"){Pe&&(Re=Pe);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var y={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function _(Re){y.exports.defaults=Re}y.exports={defaults:A(),getDefaults:A,changeDefaults:_};var S=/[&<>"']/,P=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Ce){return l[Ce]};function d(Re,Ce){if(Ce){if(S.test(Re))return Re.replace(P,f)}else if(i.test(Re))return Re.replace(k,f);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Re){return Re.replace(w,function(Ce,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var I=/(^|[^\[])\^/g;function b(Re,Ce){Re=Re.source||Re,Ce=Ce||"";var Pe={replace:function(ue,be){return be=be.source||be,be=be.replace(I,"$1"),Re=Re.replace(ue,be),Pe},getRegex:function(){return new RegExp(Re,Ce)}};return Pe}var c=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,Ce,Pe){if(Re){var se;try{se=decodeURIComponent(D(Pe)).replace(c,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ce&&!o.test(Pe)&&(Pe=r(Ce,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ue){return null}return Pe}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Re,Ce){t[" "+Re]||(h.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=E(Re,"/",!0)),Re=t[" "+Re];var Pe=Re.indexOf(":")===-1;return Ce.substring(0,2)==="//"?Pe?Ce:Re.replace(s,"$1")+Ce:Ce.charAt(0)==="/"?Pe?Ce:Re.replace(n,"$1")+Ce:Re+Ce}var a={exec:function(){}};function u(Re){for(var Ce=1,Pe,se;Ce<arguments.length;Ce++){Pe=arguments[Ce];for(se in Pe)Object.prototype.hasOwnProperty.call(Pe,se)&&(Re[se]=Pe[se])}return Re}function p(Re,Ce){var Pe=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,ze=we;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Pe.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>Ce)se.splice(Ce);else for(;se.length<Ce;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function E(Re,Ce,Pe){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var be=Re.charAt(se-ue-1);if(be===Ce&&!Pe)ue++;else if(be!==Ce&&Pe)ue++;else break}return Re.substr(0,se-ue)}function g(Re,Ce){if(Re.indexOf(Ce[1])===-1)return-1;for(var Pe=Re.length,se=0,ue=0;ue<Pe;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===Ce[0])se++;else if(Re[ue]===Ce[1]&&(se--,se<0))return ue;return-1}function T(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Re,Ce){if(Ce<1)return"";for(var Pe="";Ce>1;)Ce&1&&(Pe+=Re),Ce>>=1,Re+=Re;return Pe+Re}var M={escape:d,unescape:D,edit:b,cleanUrl:v,resolveUrl:r,noopTest:a,merge:u,splitCells:p,rtrim:E,findClosingBracket:g,checkSanitizeDeprecation:T,repeatString:L},R=y.exports.defaults,W=M.rtrim,V=M.splitCells,N=M.escape,j=M.findClosingBracket;function U(Re,Ce,Pe,se){var ue=Ce.href,be=Ce.title?N(Ce.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Pe,href:ue,title:be,text:we,tokens:se.inlineTokens(we,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Pe,href:ue,title:be,text:N(we)}}function x(Re,Ce){var Pe=Re.match(/^(\s+)(?:```)/);if(Pe===null)return Ce;var se=Pe[1];return Ce.split(`
`).map(function(ue){var be=ue.match(/^\s+/);if(be===null)return ue;var we=be[0];return we.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var z=function(){function Re(Pe){this.options=Pe||R}var Ce=Re.prototype;return Ce.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Ce.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var be=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?be:W(be,`
`)}}},Ce.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var be=ue[0],we=x(be,ue[3]||"");return{type:"code",raw:be,lang:ue[2]?ue[2].trim():ue[2],text:we}}},Ce.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var be=ue[2].trim();if(/#$/.test(be)){var we=W(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},Ce.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},Ce.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var be=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Ce.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var be,we,Fe,qe,ze,et,at,xe,ge,Ee,te=ue[1].trim(),K=te.length>1,Se={type:"list",raw:"",ordered:K,start:K?+te.slice(0,-1):"",loose:!1,items:[]};te=K?"\\d{1,9}\\"+te.slice(-1):"\\"+te,this.options.pedantic&&(te=K?te:"[*+-]");for(var Le=new RegExp("^( {0,3}"+te+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,Ee=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),Ee=ge[0].slice(qe-ue[1].length)),et=!1,be=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(be=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var it=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),it.test(xe)){be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!et){xe.trim()||(et=!0),xe.search(/[^ ]/)>=qe?Ee+=`
`+xe.slice(qe):Ee+=`
`+xe;continue}if(xe.search(/[^ ]/)>=qe||!xe.trim()){Ee+=`
`+xe.slice(qe);continue}else{be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(at?Se.loose=!0:/\n *\n *$/.test(be)&&(at=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Ee),we&&(Fe=we[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:Ee}),Se.raw+=be,se=se.slice(be.length)}Se.items[Se.items.length-1].raw=be.trimRight(),Se.items[Se.items.length-1].text=Ee.trimRight(),Se.raw=Se.raw.trimRight();var Ge=Se.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(pt){return pt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},Ce.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var be={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Ce.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var be=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:ue[0],href:ue[2],title:ue[3]}}},Ce.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var be={type:"table",header:V(ue[1]).map(function(at){return{text:at}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=ue[0];var we=be.align.length,Fe,qe,ze,et;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=V(be.rows[Fe],be.header.length).map(function(at){return{text:at}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(et=be.rows[qe],ze=0;ze<et.length;ze++)et[ze].tokens=[],this.lexer.inlineTokens(et[ze].text,et[ze].tokens);return be}}},Ce.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var be={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ce.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var be={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ce.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var be={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ce.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:N(ue[1])}},Ce.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]):ue[0]}},Ce.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var be=ue[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=W(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=j(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var et=ue[2],at="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(et);xe&&(et=xe[1],at=xe[3])}else at=ue[3]?ue[3].slice(1,-1):"";return et=et.trim(),/^</.test(et)&&(this.options.pedantic&&!/>$/.test(be)?et=et.slice(1):et=et.slice(1,-1)),U(ue,{href:et&&et.replace(this.rules.inline._escapes,"$1"),title:at&&at.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Ce.reflink=function(se,ue){var be;if((be=this.rules.inline.reflink.exec(se))||(be=this.rules.inline.nolink.exec(se))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(be,we,be[0],this.lexer)}},Ce.emStrong=function(se,ue,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(se);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,ze,et,at=qe,xe=0,ge=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(we=ge.exec(ue))!=null;)if(ze=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ze){if(et=ze.length,we[3]||we[4]){at+=et;continue}else if((we[5]||we[6])&&qe%3&&!((qe+et)%3)){xe+=et;continue}if(at-=et,!(at>0)){if(et=Math.min(et,et+at+xe),Math.min(qe,et)%2){var Ee=se.slice(1,qe+we.index+et);return{type:"em",raw:se.slice(0,qe+we.index+et+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var te=se.slice(2,qe+we.index+et-1);return{type:"strong",raw:se.slice(0,qe+we.index+et+1),text:te,tokens:this.lexer.inlineTokens(te,[])}}}}}},Ce.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var be=ue[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=N(be,!0),{type:"codespan",raw:ue[0],text:be}}},Ce.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},Ce.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Ce.autolink=function(se,ue){var be=this.rules.inline.autolink.exec(se);if(be){var we,Fe;return be[2]==="@"?(we=N(this.options.mangle?ue(be[1]):be[1]),Fe="mailto:"+we):(we=N(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},Ce.url=function(se,ue){var be;if(be=this.rules.inline.url.exec(se)){var we,Fe;if(be[2]==="@")we=N(this.options.mangle?ue(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=N(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},Ce.inlineText=function(se,ue){var be=this.rules.inline.text.exec(se);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):N(be[0]):be[0]:we=N(this.options.smartypants?ue(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),O=M.noopTest,$=M.edit,B=M.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=$(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=$(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=$(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=$(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=$(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=$(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=B({},X),X.gfm=B({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=$(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=B({},X.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:$(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=$(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=$(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=$(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=$(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=$(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=$(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=$(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=$(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=$(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=$(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:$(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=$(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:$(Q.br).replace("{2,}","*").getRegex(),text:$(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},_e=z,ye=y.exports.defaults,ke=de.block,Be=de.inline,We=M.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Re){var Ce="",Pe,se,ue=Re.length;for(Pe=0;Pe<ue;Pe++)se=Re.charCodeAt(Pe),Math.random()>.5&&(se="x"+se.toString(16)),Ce+="&#"+se+";";return Ce}var ee=function(){function Re(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:ke.normal,inline:Be.normal};this.options.pedantic?(se.block=ke.pedantic,se.inline=Be.pedantic):this.options.gfm&&(se.block=ke.gfm,this.options.breaks?se.inline=Be.breaks:se.inline=Be.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var be=new Re(ue);return be.lex(se)},Re.lexInline=function(se,ue){var be=new Re(ue);return be.inlineTokens(se)};var Ce=Re.prototype;return Ce.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Ce.blockTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var we,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(at){return(we=at.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(se)){se=se.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var at=Infinity,xe=se.slice(1),ge=void 0;be.options.extensions.startBlock.forEach(function(Ee){ge=Ee.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(at=Math.min(at,ge))}),at<Infinity&&at>=0&&(qe=se.substring(0,at+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),ze=qe.length!==se.length,se=se.substring(we.raw.length);continue}if(we=this.tokenizer.text(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(se){var et="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(et);break}else throw new Error(et)}}return this.state.top=!0,ue},Ce.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},Ce.inlineTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]);var we,Fe,qe,ze=se,et,at,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(et=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(et[0].slice(et[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,et.index)+"["+We("a",et[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(et=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,et.index)+"["+We("a",et[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(et=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,et.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(at||(xe=""),at=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(te){return(we=te.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(se,ze,xe)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(se,q)){se=se.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(se,q))){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var te=Infinity,K=se.slice(1),Se=void 0;be.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},K),typeof Se=="number"&&Se>=0&&(te=Math.min(te,Se))}),te<Infinity&&te>=0&&(qe=se.substring(0,te+1))}(),we=this.tokenizer.inlineText(qe,He)){se=se.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(xe=we.raw.slice(-1)),at=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(se){var Ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:ke,inline:Be}}}]),Re}(),re=y.exports.defaults,le=M.cleanUrl,Z=M.escape,ae=function(){function Re(Pe){this.options=Pe||re}var Ce=Re.prototype;return Ce.code=function(se,ue,be){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,we);Fe!=null&&Fe!==se&&(be=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(be?se:Z(se,!0))+`</code></pre>
`},Ce.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ce.html=function(se){return se},Ce.heading=function(se,ue,be,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(be)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(se,ue,be){var we=ue?"ol":"ul",Fe=ue&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+se+"</"+we+`>
`},Ce.listitem=function(se){return"<li>"+se+`</li>
`},Ce.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(se){return"<p>"+se+`</p>
`},Ce.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},Ce.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ce.tablecell=function(se,ue){var be=ue.header?"th":"td",we=ue.align?"<"+be+' align="'+ue.align+'">':"<"+be+">";return we+se+"</"+be+`>
`},Ce.strong=function(se){return"<strong>"+se+"</strong>"},Ce.em=function(se){return"<em>"+se+"</em>"},Ce.codespan=function(se){return"<code>"+se+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(se){return"<del>"+se+"</del>"},Ce.link=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<a href="'+Z(se)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+be+"</a>",we},Ce.image=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<img src="'+se+'" alt="'+be+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},Ce.text=function(se){return se},Re}(),pe=function(){function Re(){}var Ce=Re.prototype;return Ce.strong=function(se){return se},Ce.em=function(se){return se},Ce.codespan=function(se){return se},Ce.del=function(se){return se},Ce.html=function(se){return se},Ce.text=function(se){return se},Ce.link=function(se,ue,be){return""+be},Ce.image=function(se,ue,be){return""+be},Ce.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var Ce=Re.prototype;return Ce.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(se,ue){var be=se,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[se];do we++,be=se+"-"+we;while(this.seen.hasOwnProperty(be))}return ue||(this.seen[se]=we,this.seen[be]=0),be},Ce.slug=function(se,ue){ue===void 0&&(ue={});var be=this.serialize(se);return this.getNextSafeSlug(be,ue.dryrun)},Re}(),je=ae,Ke=pe,Je=Me,st=y.exports.defaults,Te=M.unescape,nt=function(){function Re(Pe){this.options=Pe||st,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Je}Re.parse=function(se,ue){var be=new Re(ue);return be.parse(se)},Re.parseInline=function(se,ue){var be=new Re(ue);return be.parseInline(se)};var Ce=Re.prototype;return Ce.parse=function(se,ue){ue===void 0&&(ue=!0);var be="",we,Fe,qe,ze,et,at,xe,ge,Ee,te,K,Se,Le,it,Ge,pt,Et,ft,bt,mt=se.length;for(we=0;we<mt;we++){if(te=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[te.type]&&(bt=this.options.extensions.renderers[te.type].call({parser:this},te),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(te.type))){be+=bt||"";continue}switch(te.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(te.tokens),te.depth,Te(this.parseInline(te.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(te.text,te.lang,te.escaped);continue}case"table":{for(ge="",xe="",ze=te.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(te.header[Fe].tokens),{header:!0,align:te.align[Fe]});for(ge+=this.renderer.tablerow(xe),Ee="",ze=te.rows.length,Fe=0;Fe<ze;Fe++){for(at=te.rows[Fe],xe="",et=at.length,qe=0;qe<et;qe++)xe+=this.renderer.tablecell(this.parseInline(at[qe].tokens),{header:!1,align:te.align[qe]});Ee+=this.renderer.tablerow(xe)}be+=this.renderer.table(ge,Ee);continue}case"blockquote":{Ee=this.parse(te.tokens),be+=this.renderer.blockquote(Ee);continue}case"list":{for(K=te.ordered,Se=te.start,Le=te.loose,ze=te.items.length,Ee="",Fe=0;Fe<ze;Fe++)Ge=te.items[Fe],pt=Ge.checked,Et=Ge.task,it="",Ge.task&&(ft=this.renderer.checkbox(pt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=ft+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=ft+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:ft}):it+=ft),it+=this.parse(Ge.tokens,Le),Ee+=this.renderer.listitem(it,Et,pt);be+=this.renderer.list(Ee,K,Se);continue}case"html":{be+=this.renderer.html(te.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(te.tokens));continue}case"text":{for(Ee=te.tokens?this.parseInline(te.tokens):te.text;we+1<mt&&se[we+1].type==="text";)te=se[++we],Ee+=`
`+(te.tokens?this.parseInline(te.tokens):te.text);be+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var _t='Token with "'+te.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return be},Ce.parseInline=function(se,ue){ue=ue||this.renderer;var be="",we,Fe,qe,ze=se.length;for(we=0;we<ze;we++){if(Fe=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=ue.text(Fe.text);break}case"html":{be+=ue.html(Fe.text);break}case"link":{be+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{be+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{be+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{be+=ue.codespan(Fe.text);break}case"br":{be+=ue.br();break}case"del":{be+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{be+=ue.text(Fe.text);break}default:{var et='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}}return be},Re}(),J=ee,ne=nt,ve=z,Qe=ae,tt=pe,ct=Me,ce=M.merge,Ie=M.checkSanitizeDeprecation,Ue=M.escape,Xe=y.exports.getDefaults,rt=y.exports.changeDefaults,ht=y.exports.defaults;function Ye(Re,Ce,Pe){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ce=="function"&&(Pe=Ce,Ce=null),Ce=ce({},Ye.defaults,Ce||{}),Ie(Ce),Pe){var se=Ce.highlight,ue;try{ue=J.lex(Re,Ce)}catch(qe){return Pe(qe)}var be=function(ze){var et;if(!ze)try{Ce.walkTokens&&Ye.walkTokens(ue,Ce.walkTokens),et=ne.parse(ue,Ce)}catch(at){ze=at}return Ce.highlight=se,ze?Pe(ze):Pe(null,et)};if(!se||se.length<3||(delete Ce.highlight,!ue.length))return be();var we=0;Ye.walkTokens(ue,function(qe){qe.type==="code"&&(we++,setTimeout(function(){se(qe.text,qe.lang,function(ze,et){if(ze)return be(ze);et!=null&&et!==qe.text&&(qe.text=et,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=J.lex(Re,Ce);return Ce.walkTokens&&Ye.walkTokens(Fe,Ce.walkTokens),ne.parse(Fe,Ce)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+Ue(qe.message+"",!0)+"</pre>";throw qe}}Ye.options=Ye.setOptions=function(Re){return ce(Ye.defaults,Re),rt(Ye.defaults),Ye},Ye.getDefaults=Xe,Ye.defaults=ht,Ye.use=function(){for(var Re=this,Ce=arguments.length,Pe=new Array(Ce),se=0;se<Ce;se++)Pe[se]=arguments[se];var ue=ce.apply(void 0,[{}].concat(Pe)),be=Ye.defaults.extensions||{renderers:{},childTokens:{}},we;Pe.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var et=be.renderers?be.renderers[ze.name]:null;et?be.renderers[ze.name]=function(){for(var at=arguments.length,xe=new Array(at),ge=0;ge<at;ge++)xe[ge]=arguments[ge];var Ee=ze.renderer.apply(this,xe);return Ee===!1&&(Ee=et.apply(this,xe)),Ee}:be.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[ze.level]?be[ze.level].unshift(ze.tokenizer):be[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?be.startBlock?be.startBlock.push(ze.start):be.startBlock=[ze.start]:ze.level==="inline"&&(be.startInline?be.startInline.push(ze.start):be.startInline=[ze.start]))}ze.childTokens&&(be.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=Ye.defaults.renderer||new Qe,et=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var te=arguments.length,K=new Array(te),Se=0;Se<te;Se++)K[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var at in Fe.renderer)et(at);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=Ye.defaults.tokenizer||new ve,et=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var te=arguments.length,K=new Array(te),Se=0;Se<te;Se++)K[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var at in Fe.tokenizer)et(at);ue.tokenizer=ze}(),Fe.walkTokens){var qe=Ye.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}we&&(ue.extensions=be),Ye.setOptions(ue)})},Ye.walkTokens=function(Re,Ce){for(var Pe=function(){var we=ue.value;switch(Ce(we),we.type){case"table":{for(var Fe=C(we.header),qe;!(qe=Fe()).done;){var ze=qe.value;Ye.walkTokens(ze.tokens,Ce)}for(var et=C(we.rows),at;!(at=et()).done;)for(var xe=at.value,ge=C(xe),Ee;!(Ee=ge()).done;){var te=Ee.value;Ye.walkTokens(te.tokens,Ce)}break}case"list":{Ye.walkTokens(we.items,Ce);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[we.type]?Ye.defaults.extensions.childTokens[we.type].forEach(function(K){Ye.walkTokens(we[K],Ce)}):we.tokens&&Ye.walkTokens(we.tokens,Ce)}},se=C(Re),ue;!(ue=se()).done;)Pe()},Ye.parseInline=function(Re,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ce=ce({},Ye.defaults,Ce||{}),Ie(Ce);try{var Pe=J.lexInline(Re,Ce);return Ce.walkTokens&&Ye.walkTokens(Pe,Ce.walkTokens),ne.parseInline(Pe,Ce)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+Ue(se.message+"",!0)+"</pre>";throw se}},Ye.Parser=ne,Ye.parser=ne.parse,Ye.Renderer=Qe,Ye.TextRenderer=tt,Ye.Lexer=J,Ye.lexer=J.lex,Ye.Tokenizer=ve,Ye.Slugger=ct,Ye.parse=Ye;var vt=Ye;return vt}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(A,_,S){return Math.min(Math.max(A,_),S)}e.clamp=m;function F(A,_){return(_+A%_)%_}e.rot=F;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class y{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Y(C){const y=[];typeof C=="number"&&y.push("code/timeOrigin",C);function A(S){y.push(S,Date.now())}function _(){const S=[];for(let P=0;P<y.length;P+=2)S.push({name:y[P],startTime:y[P+1]});return S}return{mark:A,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(C+A.startTime)});return y}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=m(F))}(),define(fe[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let F=!1,C=!1,y=!1,A=!1,_=!1,S=!1,P=!1,i,k=m,l,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const w=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=w&&d?.sandboxed,typeof navigator=="object"&&!w)f=navigator.userAgent,F=f.indexOf("Windows")>=0,C=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=f.indexOf("Linux")>=0,S=!0,i=navigator.language,k=i;else if(typeof d=="object"){F=d.platform==="win32",C=d.platform==="darwin",y=d.platform==="linux",A=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=m,k=m;const s=d.env.VSCODE_NLS_CONFIG;if(s)try{const n=JSON.parse(s),r=n.availableLanguages["*"];i=n.locale,k=r||m,l=n._translationsConfigFile}catch(n){}_=!0}else console.error("Unable to resolve platform.");var D;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function I(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let b=0;C?b=1:F?b=3:y&&(b=2),e.isWindows=F,e.isMacintosh=C,e.isLinux=y,e.isLinuxSnap=A,e.isNative=_,e.isWeb=S,e.isIOS=P,e.platform=b,e.userAgent=f,e.language=k;var c;(function(s){function n(){return e.language}s.value=n;function r(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=r;function a(){return e.language==="en"}s.isDefault=a})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let p=0,E=r.length;p<E;p++){const g=r[p];if(g.id===u.data.vscodeSetImmediateId){r.splice(p,1),g.callback();return}}});let a=0;return u=>{const p=++a;r.push({id:p,callback:u}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const n=Promise.resolve();return r=>n.then(r)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||P?2:F?1:3;let v=!0,t=!1;function h(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=h}),define(fe[38],me([0,1,11]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const C=m.globals.vscode.process;F={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(y){return(0,m.setImmediate)(y)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:F={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,m.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick,e.arch=F.arch}),define(fe[8],me([0,1,38]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,C=97,y=90,A=122,_=46,S=47,P=92,i=58,k=63;class l extends Error{constructor(o,v,t){let h;typeof v=="string"&&v.indexOf("not ")===0?(h="must not be",v=v.replace(/^not /,"")):h="must be";const s=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${s} ${h} of type ${v}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function f(c,o){if(typeof c!="string")throw new l(o,"string",c)}function d(c){return c===S||c===P}function w(c){return c===S}function D(c){return c>=F&&c<=y||c>=C&&c<=A}function I(c,o,v,t){let h="",s=0,n=-1,r=0,a=0;for(let u=0;u<=c.length;++u){if(u<c.length)a=c.charCodeAt(u);else{if(t(a))break;a=S}if(t(a)){if(!(n===u-1||r===1))if(r===2){if(h.length<2||s!==2||h.charCodeAt(h.length-1)!==_||h.charCodeAt(h.length-2)!==_){if(h.length>2){const p=h.lastIndexOf(v);p===-1?(h="",s=0):(h=h.slice(0,p),s=h.length-1-h.lastIndexOf(v)),n=u,r=0;continue}else if(h.length!==0){h="",s=0,n=u,r=0;continue}}o&&(h+=h.length>0?`${v}..`:"..",s=2)}else h.length>0?h+=`${v}${c.slice(n+1,u)}`:h=c.slice(n+1,u),s=u-n-1;n=u,r=0}else a===_&&r!==-1?++r:r=-1}return h}function b(c,o){if(o===null||typeof o!="object")throw new l("pathObject","Object",o);const v=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return v?v===o.root?`${v}${t}`:`${v}${c}${t}`:t}e.win32={resolve(...c){let o="",v="",t=!1;for(let h=c.length-1;h>=-1;h--){let s;if(h>=0){if(s=c[h],f(s,"path"),s.length===0)continue}else o.length===0?s=m.cwd():(s=m.env[`=${o}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${o}\\`));const n=s.length;let r=0,a="",u=!1;const p=s.charCodeAt(0);if(n===1)d(p)&&(r=1,u=!0);else if(d(p))if(u=!0,d(s.charCodeAt(1))){let E=2,g=E;for(;E<n&&!d(s.charCodeAt(E));)E++;if(E<n&&E!==g){const T=s.slice(g,E);for(g=E;E<n&&d(s.charCodeAt(E));)E++;if(E<n&&E!==g){for(g=E;E<n&&!d(s.charCodeAt(E));)E++;(E===n||E!==g)&&(a=`\\\\${T}\\${s.slice(g,E)}`,r=E)}}}else r=1;else D(p)&&s.charCodeAt(1)===i&&(a=s.slice(0,2),r=2,n>2&&d(s.charCodeAt(2))&&(u=!0,r=3));if(a.length>0)if(o.length>0){if(a.toLowerCase()!==o.toLowerCase())continue}else o=a;if(t){if(o.length>0)break}else if(v=`${s.slice(r)}\\${v}`,t=u,u&&o.length>0)break}return v=I(v,!t,"\\",d),t?`${o}\\${v}`:`${o}${v}`||"."},normalize(c){f(c,"path");const o=c.length;if(o===0)return".";let v=0,t,h=!1;const s=c.charCodeAt(0);if(o===1)return w(s)?"\\":c;if(d(s))if(h=!0,d(c.charCodeAt(1))){let r=2,a=r;for(;r<o&&!d(c.charCodeAt(r));)r++;if(r<o&&r!==a){const u=c.slice(a,r);for(a=r;r<o&&d(c.charCodeAt(r));)r++;if(r<o&&r!==a){for(a=r;r<o&&!d(c.charCodeAt(r));)r++;if(r===o)return`\\\\${u}\\${c.slice(a)}\\`;r!==a&&(t=`\\\\${u}\\${c.slice(a,r)}`,v=r)}}}else v=1;else D(s)&&c.charCodeAt(1)===i&&(t=c.slice(0,2),v=2,o>2&&d(c.charCodeAt(2))&&(h=!0,v=3));let n=v<o?I(c.slice(v),!h,"\\",d):"";return n.length===0&&!h&&(n="."),n.length>0&&d(c.charCodeAt(o-1))&&(n+="\\"),t===void 0?h?`\\${n}`:n:h?`${t}\\${n}`:`${t}${n}`},isAbsolute(c){f(c,"path");const o=c.length;if(o===0)return!1;const v=c.charCodeAt(0);return d(v)||o>2&&D(v)&&c.charCodeAt(1)===i&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let o,v;for(let s=0;s<c.length;++s){const n=c[s];f(n,"path"),n.length>0&&(o===void 0?o=v=n:o+=`\\${n}`)}if(o===void 0)return".";let t=!0,h=0;if(typeof v=="string"&&d(v.charCodeAt(0))){++h;const s=v.length;s>1&&d(v.charCodeAt(1))&&(++h,s>2&&(d(v.charCodeAt(2))?++h:t=!1))}if(t){for(;h<o.length&&d(o.charCodeAt(h));)h++;h>=2&&(o=`\\${o.slice(h)}`)}return e.win32.normalize(o)},relative(c,o){if(f(c,"from"),f(o,"to"),c===o)return"";const v=e.win32.resolve(c),t=e.win32.resolve(o);if(v===t||(c=v.toLowerCase(),o=t.toLowerCase(),c===o))return"";let h=0;for(;h<c.length&&c.charCodeAt(h)===P;)h++;let s=c.length;for(;s-1>h&&c.charCodeAt(s-1)===P;)s--;const n=s-h;let r=0;for(;r<o.length&&o.charCodeAt(r)===P;)r++;let a=o.length;for(;a-1>r&&o.charCodeAt(a-1)===P;)a--;const u=a-r,p=n<u?n:u;let E=-1,g=0;for(;g<p;g++){const L=c.charCodeAt(h+g);if(L!==o.charCodeAt(r+g))break;L===P&&(E=g)}if(g!==p){if(E===-1)return t}else{if(u>p){if(o.charCodeAt(r+g)===P)return t.slice(r+g+1);if(g===2)return t.slice(r+g)}n>p&&(c.charCodeAt(h+g)===P?E=g:g===2&&(E=3)),E===-1&&(E=0)}let T="";for(g=h+E+1;g<=s;++g)(g===s||c.charCodeAt(g)===P)&&(T+=T.length===0?"..":"\\..");return r+=E,T.length>0?`${T}${t.slice(r,a)}`:(t.charCodeAt(r)===P&&++r,t.slice(r,a))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const o=e.win32.resolve(c);if(o.length<=2)return c;if(o.charCodeAt(0)===P){if(o.charCodeAt(1)===P){const v=o.charCodeAt(2);if(v!==k&&v!==_)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===P)return`\\\\?\\${o}`;return c},dirname(c){f(c,"path");const o=c.length;if(o===0)return".";let v=-1,t=0;const h=c.charCodeAt(0);if(o===1)return d(h)?c:".";if(d(h)){if(v=t=1,d(c.charCodeAt(1))){let r=2,a=r;for(;r<o&&!d(c.charCodeAt(r));)r++;if(r<o&&r!==a){for(a=r;r<o&&d(c.charCodeAt(r));)r++;if(r<o&&r!==a){for(a=r;r<o&&!d(c.charCodeAt(r));)r++;if(r===o)return c;r!==a&&(v=t=r+1)}}}}else D(h)&&c.charCodeAt(1)===i&&(v=o>2&&d(c.charCodeAt(2))?3:2,t=v);let s=-1,n=!0;for(let r=o-1;r>=t;--r)if(d(c.charCodeAt(r))){if(!n){s=r;break}}else n=!1;if(s===-1){if(v===-1)return".";s=v}return c.slice(0,s)},basename(c,o){o!==void 0&&f(o,"ext"),f(c,"path");let v=0,t=-1,h=!0,s;if(c.length>=2&&D(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(v=2),o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let n=o.length-1,r=-1;for(s=c.length-1;s>=v;--s){const a=c.charCodeAt(s);if(d(a)){if(!h){v=s+1;break}}else r===-1&&(h=!1,r=s+1),n>=0&&(a===o.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=r))}return v===t?t=r:t===-1&&(t=c.length),c.slice(v,t)}for(s=c.length-1;s>=v;--s)if(d(c.charCodeAt(s))){if(!h){v=s+1;break}}else t===-1&&(h=!1,t=s+1);return t===-1?"":c.slice(v,t)},extname(c){f(c,"path");let o=0,v=-1,t=0,h=-1,s=!0,n=0;c.length>=2&&c.charCodeAt(1)===i&&D(c.charCodeAt(0))&&(o=t=2);for(let r=c.length-1;r>=o;--r){const a=c.charCodeAt(r);if(d(a)){if(!s){t=r+1;break}continue}h===-1&&(s=!1,h=r+1),a===_?v===-1?v=r:n!==1&&(n=1):v!==-1&&(n=-1)}return v===-1||h===-1||n===0||n===1&&v===h-1&&v===t+1?"":c.slice(v,h)},format:b.bind(null,"\\"),parse(c){f(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const v=c.length;let t=0,h=c.charCodeAt(0);if(v===1)return d(h)?(o.root=o.dir=c,o):(o.base=o.name=c,o);if(d(h)){if(t=1,d(c.charCodeAt(1))){let E=2,g=E;for(;E<v&&!d(c.charCodeAt(E));)E++;if(E<v&&E!==g){for(g=E;E<v&&d(c.charCodeAt(E));)E++;if(E<v&&E!==g){for(g=E;E<v&&!d(c.charCodeAt(E));)E++;E===v?t=E:E!==g&&(t=E+1)}}}}else if(D(h)&&c.charCodeAt(1)===i){if(v<=2)return o.root=o.dir=c,o;if(t=2,d(c.charCodeAt(2))){if(v===3)return o.root=o.dir=c,o;t=3}}t>0&&(o.root=c.slice(0,t));let s=-1,n=t,r=-1,a=!0,u=c.length-1,p=0;for(;u>=t;--u){if(h=c.charCodeAt(u),d(h)){if(!a){n=u+1;break}continue}r===-1&&(a=!1,r=u+1),h===_?s===-1?s=u:p!==1&&(p=1):s!==-1&&(p=-1)}return r!==-1&&(s===-1||p===0||p===1&&s===r-1&&s===n+1?o.base=o.name=c.slice(n,r):(o.name=c.slice(n,s),o.base=c.slice(n,r),o.ext=c.slice(s,r))),n>0&&n!==t?o.dir=c.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let o="",v=!1;for(let t=c.length-1;t>=-1&&!v;t--){const h=t>=0?c[t]:m.cwd();f(h,"path"),h.length!==0&&(o=`${h}/${o}`,v=h.charCodeAt(0)===S)}return o=I(o,!v,"/",w),v?`/${o}`:o.length>0?o:"."},normalize(c){if(f(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===S,v=c.charCodeAt(c.length-1)===S;return c=I(c,!o,"/",w),c.length===0?o?"/":v?"./":".":(v&&(c+="/"),o?`/${c}`:c)},isAbsolute(c){return f(c,"path"),c.length>0&&c.charCodeAt(0)===S},join(...c){if(c.length===0)return".";let o;for(let v=0;v<c.length;++v){const t=c[v];f(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(c,o){if(f(c,"from"),f(o,"to"),c===o||(c=e.posix.resolve(c),o=e.posix.resolve(o),c===o))return"";const v=1,t=c.length,h=t-v,s=1,n=o.length-s,r=h<n?h:n;let a=-1,u=0;for(;u<r;u++){const E=c.charCodeAt(v+u);if(E!==o.charCodeAt(s+u))break;E===S&&(a=u)}if(u===r)if(n>r){if(o.charCodeAt(s+u)===S)return o.slice(s+u+1);if(u===0)return o.slice(s+u)}else h>r&&(c.charCodeAt(v+u)===S?a=u:u===0&&(a=0));let p="";for(u=v+a+1;u<=t;++u)(u===t||c.charCodeAt(u)===S)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(s+a)}`},toNamespacedPath(c){return c},dirname(c){if(f(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===S;let v=-1,t=!0;for(let h=c.length-1;h>=1;--h)if(c.charCodeAt(h)===S){if(!t){v=h;break}}else t=!1;return v===-1?o?"/":".":o&&v===1?"//":c.slice(0,v)},basename(c,o){o!==void 0&&f(o,"ext"),f(c,"path");let v=0,t=-1,h=!0,s;if(o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let n=o.length-1,r=-1;for(s=c.length-1;s>=0;--s){const a=c.charCodeAt(s);if(a===S){if(!h){v=s+1;break}}else r===-1&&(h=!1,r=s+1),n>=0&&(a===o.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=r))}return v===t?t=r:t===-1&&(t=c.length),c.slice(v,t)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===S){if(!h){v=s+1;break}}else t===-1&&(h=!1,t=s+1);return t===-1?"":c.slice(v,t)},extname(c){f(c,"path");let o=-1,v=0,t=-1,h=!0,s=0;for(let n=c.length-1;n>=0;--n){const r=c.charCodeAt(n);if(r===S){if(!h){v=n+1;break}continue}t===-1&&(h=!1,t=n+1),r===_?o===-1?o=n:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===v+1?"":c.slice(o,t)},format:b.bind(null,"/"),parse(c){f(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const v=c.charCodeAt(0)===S;let t;v?(o.root="/",t=1):t=0;let h=-1,s=0,n=-1,r=!0,a=c.length-1,u=0;for(;a>=t;--a){const p=c.charCodeAt(a);if(p===S){if(!r){s=a+1;break}continue}n===-1&&(r=!1,n=a+1),p===_?h===-1?h=a:u!==1&&(u=1):h!==-1&&(u=-1)}if(n!==-1){const p=s===0&&v?1:s;h===-1||u===0||u===1&&h===n-1&&h===s+1?o.base=o.name=c.slice(p,n):(o.name=c.slice(p,h),o.base=c.slice(p,n),o.ext=c.slice(h,n))}return s>0?o.dir=c.slice(0,s-1):v&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[96],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var F;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(F=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(y,...A){const _=A.reduce((i,k)=>(i[k]=!0,i),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(i=>!_[i]).forEach(i=>{for(let k=0;k<S.length;k++)if(i.search(S[k])!==-1){delete y[i];break}})}e.sanitizeProcessEnvironment=C}),define(fe[142],me([0,1]),function(Y,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class F{constructor(_,S,P){this.level=_,this.key=S,this.value=P,this.forward=[]}}const C=void 0;class y{constructor(_,S=2**16){this.comparator=_,this[m]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new F(this._maxLevel,C,C)}get size(){return this._size}clear(){this._header=new F(this._maxLevel,C,C)}has(_){return Boolean(y._search(this,_,this.comparator))}get(_){return y._search(this,_,this.comparator)?.value}set(_,S){return y._insert(this,_,S,this.comparator)&&(this._size+=1),this}delete(_){const S=y._delete(this,_,this.comparator);return S&&(this._size-=1),S}forEach(_,S){let P=this._header.forward[0];for(;P;)_.call(S,P.value,P.key,this),P=P.forward[0]}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let _=this._header.forward[0];for(;_;)yield[_.key,_.value],_=_.forward[0]}*keys(){let _=this._header.forward[0];for(;_;)yield _.key,_=_.forward[0]}*values(){let _=this._header.forward[0];for(;_;)yield _.value,_=_.forward[0]}toString(){let _="[SkipList]:",S=this._header.forward[0];for(;S;)_+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return _}static _search(_,S,P){let i=_._header;for(let k=_._level-1;k>=0;k--)for(;i.forward[k]&&P(i.forward[k].key,S)<0;)i=i.forward[k];if(i=i.forward[0],i&&P(i.key,S)===0)return i}static _insert(_,S,P,i){let k=[],l=_._header;for(let f=_._level-1;f>=0;f--){for(;l.forward[f]&&i(l.forward[f].key,S)<0;)l=l.forward[f];k[f]=l}if(l=l.forward[0],l&&i(l.key,S)===0)return l.value=P,!1;{let f=y._randomLevel(_);if(f>_._level){for(let d=_._level;d<f;d++)k[d]=_._header;_._level=f}l=new F(f,S,P);for(let d=0;d<f;d++)l.forward[d]=k[d].forward[d],k[d].forward[d]=l;return!0}}static _randomLevel(_,S=.5){let P=1;for(;Math.random()<S&&P<_._maxLevel;)P+=1;return P}static _delete(_,S,P){let i=[],k=_._header;for(let l=_._level-1;l>=0;l--){for(;k.forward[l]&&P(k.forward[l].key,S)<0;)k=k.forward[l];i[l]=k}if(k=k.forward[0],!k||P(k.key,S)!==0)return!1;for(let l=0;l<_._level&&i[l].forward[l]===k;l++)i[l].forward[l]=k.forward[l];for(;_._level>0&&_._header.forward[_._level-1]===C;)_._level-=1;return!0}}e.SkipList=y}),define(fe[46],me([0,1,11]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=m.globals.performance&&typeof m.globals.performance.now=="function";class C{constructor(A){this._highResolution=F&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new C(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=C}),define(fe[3],me([0,1,18,76,6,95,46]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var _;(function(o){o.None=()=>C.Disposable.None;function v(N){return(j,U=null,x)=>{let z=!1,O;return O=N($=>{if(!z)return O?O.dispose():z=!0,j.call(U,$)},null,x),z&&O.dispose(),O}}o.once=v;function t(N,j){return u((U,x=null,z)=>N(O=>U.call(x,j(O)),null,z))}o.map=t;function h(N,j){return u((U,x=null,z)=>N(O=>{j(O),U.call(x,O)},null,z))}o.forEach=h;function s(N,j){return u((U,x=null,z)=>N(O=>j(O)&&U.call(x,O),null,z))}o.filter=s;function n(N){return N}o.signal=n;function r(...N){return(j,U=null,x)=>(0,C.combinedDisposable)(...N.map(z=>z(O=>j.call(U,O),null,x)))}o.any=r;function a(N,j,U){let x=U;return t(N,z=>(x=j(x,z),x))}o.reduce=a;function u(N){let j;const U=new l({onFirstListenerAdd(){j=N(U.fire,U)},onLastListenerRemove(){j.dispose()}});return U.event}function p(N,j,U=100,x=!1,z){let O,$,B,X=0;const Q=new l({leakWarningThreshold:z,onFirstListenerAdd(){O=N(de=>{X++,$=j($,de),x&&!B&&(Q.fire($),$=void 0),clearTimeout(B),B=setTimeout(()=>{const _e=$;$=void 0,B=void 0,(!x||X>1)&&Q.fire(_e),X=0},U)})},onLastListenerRemove(){O.dispose()}});return Q.event}o.debounce=p;function E(N,j=(U,x)=>U===x){let U=!0,x;return s(N,z=>{const O=U||!j(z,x);return U=!1,x=z,O})}o.latch=E;function g(N,j){return[o.filter(N,j),o.filter(N,U=>!j(U))]}o.split=g;function T(N,j=!1,U=[]){let x=U.slice(),z=N(B=>{x?x.push(B):$.fire(B)});const O=()=>{x&&x.forEach(B=>$.fire(B)),x=null},$=new l({onFirstListenerAdd(){z||(z=N(B=>$.fire(B)))},onFirstListenerDidAdd(){x&&(j?setTimeout(O):O())},onLastListenerRemove(){z&&z.dispose(),z=null}});return $.event}o.buffer=T;class L{constructor(j){this.event=j}map(j){return new L(t(this.event,j))}forEach(j){return new L(h(this.event,j))}filter(j){return new L(s(this.event,j))}reduce(j,U){return new L(a(this.event,j,U))}latch(){return new L(E(this.event))}debounce(j,U=100,x=!1,z){return new L(p(this.event,j,U,x,z))}on(j,U,x){return this.event(j,U,x)}once(j,U,x){return v(this.event)(j,U,x)}}function M(N){return new L(N)}o.chain=M;function R(N,j,U=x=>x){const x=(...B)=>$.fire(U(...B)),z=()=>N.on(j,x),O=()=>N.removeListener(j,x),$=new l({onFirstListenerAdd:z,onLastListenerRemove:O});return $.event}o.fromNodeEventEmitter=R;function W(N,j,U=x=>x){const x=(...B)=>$.fire(U(...B)),z=()=>N.addEventListener(j,x),O=()=>N.removeEventListener(j,x),$=new l({onFirstListenerAdd:z,onLastListenerRemove:O});return $.event}o.fromDOMEventEmitter=W;function V(N){return new Promise(j=>v(N)(j))}o.toPromise=V})(_=e.Event||(e.Event={}));class S{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${S._idPool++}`}start(v){this._stopWatch=new A.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let P=-1;function i(o){const v=P;return P=o,{dispose(){P=v}}}e.setGlobalLeakWarningThreshold=i;class k{constructor(v,t=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let t=P;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||v<t)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(h)||0;if(this._stacks.set(h,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let n,r=0;for(const[a,u]of this._stacks)(!n||r<u)&&(n=a,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(h)||0;this._stacks.set(h,n-1)}}}class l{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=P>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(v,t,h)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(t?[v,t]:v);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,t);const r=this._leakageMon?.check(this._listeners.size),a=(0,C.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof C.DisposableStore?h.add(a):Array.isArray(h)&&h.push(a),a}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,h]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,h):t[0].call(t[1],h)}catch(s){(0,m.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class f extends l{async fireAsync(v,t,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,v]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[s,n]=this._asyncDeliveryQueue.shift(),r=[],a={...n,waitUntil:u=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");h&&(u=h(u,typeof s=="function"?s:s[0])),r.push(u)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(u){(0,m.onUnexpectedError)(u);continue}Object.freeze(r),await Promise.allSettled(r).then(u=>{for(const p of u)p.status==="rejected"&&(0,m.onUnexpectedError)(p.reason)})}}}}e.AsyncEmitter=f;class d extends l{constructor(v){super(v);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=d;class w extends d{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class D extends l{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=D;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const t={event:v,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const h=()=>{this.hasListeners&&this.unhook(t);const s=this.events.indexOf(t);this.events.splice(s,1)};return(0,C.toDisposable)((0,F.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(t=>this.emitter.fire(t))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class b{constructor(){this.buffers=[]}wrapEvent(v){return(t,h,s)=>v(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>t.call(h,n)):t.call(h,n)},void 0,s)}bufferEvents(v){const t=[];this.buffers.push(t);const h=v();return this.buffers.pop(),t.forEach(s=>s()),h}}e.EventBufferer=b;class c{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=C.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(fe[21],me([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(_,S){const P=setTimeout(_.bind(S),0);return{dispose(){clearTimeout(P)}}});var C;(function(_){function S(P){return P===_.None||P===_.Cancelled||P instanceof y?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}_.isCancellationToken=S,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(C=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=C.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=A}),define(fe[47],me([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(k){const l=this._icons.get(k.id);l?k.description?l.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new F;e.iconRegistry=C;function y(i,k){return new _(i,k)}e.registerCodicon=y;function A(i){return i?i.replace(/\$\((.*?)\)/g,(k,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class _{constructor(k,l,f){this.id=k,this.definition=l,this.description=f,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=_;function S(i,k){const l=["codicon","codicon-"+i];return k&&l.push("codicon-modifier-"+k),l}e.getClassNamesArray=S;var P;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function l(w){if(w instanceof _)return["codicon","codicon-"+w.id];const D=k.exec(w.id);if(!D)return l(_.error);let[,I,b]=D;const c=["codicon","codicon-"+I];return b&&c.push("codicon-modifier-"+b.substr(1)),c}i.asClassNameArray=l;function f(w){return l(w).join(" ")}i.asClassName=f;function d(w){return"."+l(w).join(".")}i.asCSSSelector=d})(P=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",{fontCharacter:"\\eb0f"}),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(_=e.Codicon||(e.Codicon={}))}),define(fe[97],me([0,1,18,6]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(c){const o=c;return o?[o.on,o.pause,o.resume,o.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=C;function y(c){const o=c;return o?C(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(c,o){return new _(c,o)}e.newWriteableStream=A;class _{constructor(o,v){this.reducer=o,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(v=>v(o))}emitError(o){this.listeners.error.length===0?(0,m.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(v=>v(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,v){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(o,v){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const h=t.indexOf(v);h>=0&&t.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(c,o){const v=[];let t;for(;(t=c.read())!==null;)v.push(t);return o(v)}e.consumeReadable=S;function P(c,o,v){const t=[];let h;for(;(h=c.read())!==null&&t.length<v;)t.push(h);return h===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof h!="undefined"){const s=h;return h=void 0,s}return c.read()}}}e.peekReadable=P;function i(c,o){return new Promise((v,t)=>{const h=[];k(c,{onData:s=>{o&&h.push(s)},onError:s=>{o?t(s):v(void 0)},onEnd:()=>{v(o?o(h):void 0)}})})}e.consumeStream=i;function k(c,o){c.on("error",v=>o.onError(v)),c.on("end",()=>o.onEnd()),c.on("data",v=>o.onData(v))}e.listenStream=k;function l(c,o){return new Promise((v,t)=>{const h=new F.DisposableStore,s=[],n=u=>{if(s.push(u),s.length>o)return h.dispose(),c.pause(),v({stream:c,buffer:s,ended:!1})},r=u=>t(u),a=()=>v({stream:c,buffer:s,ended:!0});h.add((0,F.toDisposable)(()=>c.removeListener("error",r))),c.on("error",r),h.add((0,F.toDisposable)(()=>c.removeListener("end",a))),c.on("end",a),h.add((0,F.toDisposable)(()=>c.removeListener("data",n))),c.on("data",n)})}e.peekStream=l;function f(c,o){const v=A(o);return v.end(c),v}e.toStream=f;function d(){const c=A(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function w(c){let o=!1;return{read:()=>o?null:(o=!0,c)}}e.toReadable=w;function D(c,o,v){const t=A(v);return k(c,{onData:h=>t.write(o.data(h)),onError:h=>t.error(o.error?o.error(h):h),onEnd:()=>t.end()}),t}e.transform=D;function I(c,o,v){let t=!1;return{read:()=>{const h=o.read();return t?h:(t=!0,h!==null?v([c,h]):c)}}}e.prefixedReadable=I;function b(c,o,v){let t=!1;const h=A(v);return k(o,{onData:s=>t?h.write(s):(t=!0,h.write(v([c,s]))),onError:s=>h.error(s),onEnd:()=>{t||(t=!0,h.write(c)),h.end()}}),h}e.prefixedStream=b}),define(fe[22],me([0,1,97]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let C,y;class A{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return F?new A(Buffer.allocUnsafe(n)):new A(new Uint8Array(n))}static wrap(n){return F&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new A(n)}static fromString(n,r){return!(r?.dontUseNodeBuffer||!1)&&F?new A(Buffer.from(n)):(C||(C=new TextEncoder),new A(C.encode(n)))}static concat(n,r){if(typeof r=="undefined"){r=0;for(let p=0,E=n.length;p<E;p++)r+=n[p].byteLength}const a=A.alloc(r);let u=0;for(let p=0,E=n.length;p<E;p++){const g=n[p];a.set(g,u),u+=g.byteLength}return a}toString(){return F?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(n,r){return new A(this.buffer.subarray(n,r))}set(n,r){n instanceof A?this.buffer.set(n.buffer,r):this.buffer.set(n,r)}readUInt32BE(n){return P(this.buffer,n)}writeUInt32BE(n,r){i(this.buffer,n,r)}readUInt32LE(n){return k(this.buffer,n)}writeUInt32LE(n,r){l(this.buffer,n,r)}readUInt8(n){return f(this.buffer,n)}writeUInt8(n,r){d(this.buffer,n,r)}}e.VSBuffer=A;function _(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0}e.readUInt16LE=_;function S(s,n,r){s[r+0]=n&255,n=n>>>8,s[r+1]=n&255}e.writeUInt16LE=S;function P(s,n){return s[n]*2**24+s[n+1]*2**16+s[n+2]*2**8+s[n+3]}e.readUInt32BE=P;function i(s,n,r){s[r+3]=n,n=n>>>8,s[r+2]=n,n=n>>>8,s[r+1]=n,n=n>>>8,s[r]=n}e.writeUInt32BE=i;function k(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0|s[n+2]<<16>>>0|s[n+3]<<24>>>0}e.readUInt32LE=k;function l(s,n,r){s[r+0]=n&255,n=n>>>8,s[r+1]=n&255,n=n>>>8,s[r+2]=n&255,n=n>>>8,s[r+3]=n&255}e.writeUInt32LE=l;function f(s,n){return s[n]}e.readUInt8=f;function d(s,n,r){s[r]=n}e.writeUInt8=d;function w(s){return m.consumeReadable(s,n=>A.concat(n))}e.readableToBuffer=w;function D(s){return m.toReadable(s)}e.bufferToReadable=D;function I(s){return m.consumeStream(s,n=>A.concat(n))}e.streamToBuffer=I;async function b(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await I(s.stream)])}e.bufferedStreamToBuffer=b;function c(s){return m.toStream(s,n=>A.concat(n))}e.bufferToStream=c;function o(s){return m.transform(s,{data:n=>typeof n=="string"?A.fromString(n):A.wrap(n)},n=>A.concat(n))}e.streamToBufferReadableStream=o;function v(s){return m.newWriteableStream(n=>A.concat(n),s)}e.newWriteableBufferStream=v;function t(s,n){return m.prefixedReadable(s,n,r=>A.concat(r))}e.prefixedBufferReadable=t;function h(s,n){return m.prefixedStream(s,n,r=>A.concat(r))}e.prefixedBufferStream=h}),define(fe[9],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=m;const F=/{(\d+)}/g;function C(ce,...Ie){return Ie.length===0?ce:ce.replace(F,function(Ue,Xe){const rt=parseInt(Xe,10);return isNaN(rt)||rt<0||rt>=Ie.length?Ue:Ie[rt]})}e.format=C;const y=/{([^}]+)}/g;function A(ce,Ie){return ce.replace(y,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=A;function _(ce){return ce.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=_;function S(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function P(ce,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let rt=ce.length-1;rt>=0;rt--)ce.charCodeAt(rt)===Xe&&Ue++;return Ue}e.count=P;function i(ce,Ie,Ue="\u2026"){return ce.length<=Ie?ce:`${ce.substr(0,Ie)}${Ue}`}e.truncate=i;function k(ce,Ie=" "){const Ue=l(ce,Ie);return f(Ue,Ie)}e.trim=k;function l(ce,Ie){if(!ce||!Ie)return ce;const Ue=Ie.length;if(Ue===0||ce.length===0)return ce;let Xe=0;for(;ce.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return ce.substring(Xe)}e.ltrim=l;function f(ce,Ie){if(!ce||!Ie)return ce;const Ue=Ie.length,Xe=ce.length;if(Ue===0||Xe===0)return ce;let rt=Xe,ht=-1;for(;ht=ce.lastIndexOf(Ie,rt-1),!(ht===-1||ht+Ue!==rt);){if(ht===0)return"";rt=ht}return ce.substring(0,rt)}e.rtrim=f;function d(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function w(ce){return ce.replace(/\*/g,"")}e.stripWildcards=w;function D(ce,Ie,Ue={}){if(!ce)throw new Error("Cannot create regex from empty string");Ie||(ce=S(ce)),Ue.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(ce,Xe)}e.createRegExp=D;function I(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function b(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function c(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=c;function o(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=o;function v(ce){for(let Ie=0,Ue=ce.length;Ie<Ue;Ie++){const Xe=ce.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function t(ce,Ie=0,Ue=ce.length){for(let Xe=Ie;Xe<Ue;Xe++){const rt=ce.charCodeAt(Xe);if(rt!==32&&rt!==9)return ce.substring(Ie,Xe)}return ce.substring(Ie,Ue)}e.getLeadingWhitespace=t;function h(ce,Ie=ce.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=ce.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=h;function s(ce,Ie){return ce<Ie?-1:ce>Ie?1:0}e.compare=s;function n(ce,Ie,Ue=0,Xe=ce.length,rt=0,ht=Ie.length){for(;Ue<Xe&&rt<ht;Ue++,rt++){let Re=ce.charCodeAt(Ue),Ce=Ie.charCodeAt(rt);if(Re<Ce)return-1;if(Re>Ce)return 1}const Ye=Xe-Ue,vt=ht-rt;return Ye<vt?-1:Ye>vt?1:0}e.compareSubstring=n;function r(ce,Ie){return a(ce,Ie,0,ce.length,0,Ie.length)}e.compareIgnoreCase=r;function a(ce,Ie,Ue=0,Xe=ce.length,rt=0,ht=Ie.length){for(;Ue<Xe&&rt<ht;Ue++,rt++){let Re=ce.charCodeAt(Ue),Ce=Ie.charCodeAt(rt);if(Re===Ce)continue;if(Re>=128||Ce>=128)return n(ce.toLowerCase(),Ie.toLowerCase(),Ue,Xe,rt,ht);u(Re)&&(Re-=32),u(Ce)&&(Ce-=32);const Pe=Re-Ce;if(Pe!==0)return Pe}const Ye=Xe-Ue,vt=ht-rt;return Ye<vt?-1:Ye>vt?1:0}e.compareSubstringIgnoreCase=a;function u(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=u;function p(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=p;function E(ce,Ie){return ce.length===Ie.length&&a(ce,Ie)===0}e.equalsIgnoreCase=E;function g(ce,Ie){const Ue=Ie.length;return Ie.length>ce.length?!1:a(ce,Ie,0,Ue)===0}e.startsWithIgnoreCase=g;function T(ce,Ie){let Ue,Xe=Math.min(ce.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(ce.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=T;function L(ce,Ie){let Ue,Xe=Math.min(ce.length,Ie.length);const rt=ce.length-1,ht=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(ce.charCodeAt(rt-Ue)!==Ie.charCodeAt(ht-Ue))return Ue;return Xe}e.commonSuffixLength=L;function M(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=M;function R(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=R;function W(ce,Ie){return(ce-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=W;function V(ce,Ie,Ue){const Xe=ce.charCodeAt(Ue);if(M(Xe)&&Ue+1<Ie){const rt=ce.charCodeAt(Ue+1);if(R(rt))return W(Xe,rt)}return Xe}e.getNextCodePoint=V;function N(ce,Ie){const Ue=ce.charCodeAt(Ie-1);if(R(Ue)&&Ie>1){const Xe=ce.charCodeAt(Ie-2);if(M(Xe))return W(Xe,Ue)}return Ue}function j(ce,Ie){const Ue=nt.getInstance(),Xe=Ie,rt=ce.length,ht=V(ce,rt,Ie);Ie+=ht>=65536?2:1;let Ye=Ue.getGraphemeBreakType(ht);for(;Ie<rt;){const vt=V(ce,rt,Ie),Re=Ue.getGraphemeBreakType(vt);if(st(Ye,Re))break;Ie+=vt>=65536?2:1,Ye=Re}return Ie-Xe}e.nextCharLength=j;function U(ce,Ie){const Ue=nt.getInstance(),Xe=Ie,rt=N(ce,Ie);Ie-=rt>=65536?2:1;let ht=Ue.getGraphemeBreakType(rt);for(;Ie>0;){const Ye=N(ce,Ie),vt=Ue.getGraphemeBreakType(Ye);if(st(vt,ht))break;Ie-=Ye>=65536?2:1,ht=vt}return Xe-Ie}e.prevCharLength=U;function x(ce,Ie){const Ue=nt.getInstance(),Xe=ce.length,rt=Ie,ht=V(ce,Xe,Ie),Ye=Ue.getGraphemeBreakType(ht);Ie+=ht>=65536?2:1;let vt=Ye;for(;Ie<Xe;){const Ce=V(ce,Xe,Ie),Pe=Ue.getGraphemeBreakType(Ce);if(st(vt,Pe))break;Ie+=Ce>=65536?2:1,vt=Pe}const Re=Ie;for(Ie=rt,vt=Ye;Ie>0;){const Ce=N(ce,Ie),Pe=Ue.getGraphemeBreakType(Ce);if(st(Pe,vt))break;Ie-=Ce>=65536?2:1,vt=Pe}return[Ie,Re]}function z(ce,Ie){return Ie>0&&R(ce.charCodeAt(Ie))?x(ce,Ie-1):x(ce,Ie)}e.getCharContainingOffset=z;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(ce){return O.test(ce)}e.containsRTL=$;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(ce){return B.test(ce)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(ce){return Q.test(ce)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=_e;function ye(ce){for(let Ie=0,Ue=ce.length;Ie<Ue;Ie++)if(ke(ce.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=ye;function ke(ce){return ce=+ce,ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=ke;function Be(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=Be;function We(ce,Ie){if(ce.length<Ie)return ce;const Ue=/\b/g;let Xe=0;for(;Ue.test(ce)&&!(ce.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return ce.substring(Xe).replace(/^\s/,"")}e.lcut=We;const He=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function re(ce){return ce&&(ce=ce.replace(He,""),ce=ce.replace(q,""),ce=ce.replace(ee,"")),ce}e.removeAnsiEscapeCodes=re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function Z(ce){return le(ce)?ce.substr(1):ce}e.stripUTF8BOM=Z;function ae(ce,Ie){if(!ce||!Ie||ce.length<Ie.length)return!1;const Ue=Ie.length,Xe=ce.toLowerCase();let rt=0,ht=-1;for(;rt<Ue;){const Ye=Xe.indexOf(Ie[rt],ht+1);if(Ye<0)return!1;ht=Ye,rt++}return!0}e.fuzzyContains=ae;function pe(ce,Ie=!1){return ce?(Ie&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=pe;function Me(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Me;function je(ce,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ce.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ce:(ce[Ue-1]==="\r"&&Ue--,ce.substr(0,Ue))}e.getNLines=je;function Ke(ce){const Ie=90-65+1;return ce=ce%(2*Ie),ce<Ie?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Ie)}e.singleLetterHash=Ke;function Je(ce){return nt.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=Je;function st(ce,Ie){return ce===0?Ie!==5&&Ie!==7:ce===2&&Ie===3?!1:ce===4||ce===2||ce===3||Ie===4||Ie===2||Ie===3?!0:!(ce===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ce===11||ce===9)&&(Ie===9||Ie===10)||(ce===12||ce===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ce===1||ce===13&&Ie===14||ce===6&&Ie===6)}e.breakBetweenGraphemeBreakType=st;var Te;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(Te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class nt{constructor(){this._data=J()}static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let rt=1;for(;rt<=Xe;)if(Ie<Ue[3*rt])rt=2*rt;else if(Ie>Ue[3*rt+1])rt=2*rt+1;else return Ue[3*rt+2];return 0}}nt._INSTANCE=null;function J(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ne(ce,Ie){if(ce===0)return 0;const Ue=ve(ce,Ie);if(Ue!==void 0)return Ue;const Xe=N(Ie,ce);return ce-=Qe(Xe),ce}e.getLeftDeleteOffset=ne;function ve(ce,Ie){let Ue=N(Ie,ce);for(ce-=Qe(Ue);tt(Ue)||Ue===65039||Ue===8419;){if(ce===0)return;Ue=N(Ie,ce),ce-=Qe(Ue)}if(!!Be(Ue)){if(ce>=0){const Xe=N(Ie,ce);Xe===8205&&(ce-=Qe(Xe))}return ce}}function Qe(ce){return ce>=65536?2:1}function tt(ce){return 127995<=ce&&ce<=127999}var ct;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={}))}),define(fe[48],me([0,1,9]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(I){return C(I,0)}e.hash=F;function C(I,b){switch(typeof I){case"object":return I===null?y(349,b):Array.isArray(I)?S(I,b):P(I,b);case"string":return _(I,b);case"boolean":return A(I,b);case"number":return y(I,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=C;function y(I,b){return(b<<5)-b+I|0}e.numberHash=y;function A(I,b){return y(I?433:863,b)}function _(I,b){b=y(149417,b);for(let c=0,o=I.length;c<o;c++)b=y(I.charCodeAt(c),b);return b}e.stringHash=_;function S(I,b){return b=y(104579,b),I.reduce((c,o)=>C(o,c),b)}function P(I,b){return b=y(181387,b),Object.keys(I).sort().reduce((c,o)=>(c=_(o,c),C(I[o],c)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=i;var k;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function l(I,b,c=32){const o=c-b,v=~((1<<o)-1);return(I<<b|(v&I)>>>o)>>>0}function f(I,b=0,c=I.byteLength,o=0){for(let v=0;v<c;v++)I[b+v]=o}function d(I,b,c="0"){for(;I.length<b;)I=c+I;return I}function w(I,b=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),b/4)}e.toHexString=w;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const c=b.length;if(c===0)return;const o=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,h,s;for(t!==0?(h=t,s=-1,t=0):(h=b.charCodeAt(0),s=0);;){let n=h;if(m.isHighSurrogate(h))if(s+1<c){const r=b.charCodeAt(s+1);m.isLowSurrogate(r)?(s++,n=m.computeCodePoint(h,r)):n=65533}else{t=h;break}else m.isLowSurrogate(h)&&(n=65533);if(v=this._push(o,v,n),s++,s<c)h=b.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(b,c,o){return o<128?b[c++]=o:o<2048?(b[c++]=192|(o&1984)>>>6,b[c++]=128|(o&63)>>>0):o<65536?(b[c++]=224|(o&61440)>>>12,b[c++]=128|(o&4032)>>>6,b[c++]=128|(o&63)>>>0):(b[c++]=240|(o&1835008)>>>18,b[c++]=128|(o&258048)>>>12,b[c++]=128|(o&4032)>>>6,b[c++]=128|(o&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=D._bigBlock32,c=this._buffDV;for(let u=0;u<64;u+=4)b.setUint32(u,c.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)b.setUint32(u,l(b.getUint32(u-12,!1)^b.getUint32(u-32,!1)^b.getUint32(u-56,!1)^b.getUint32(u-64,!1),1),!1);let o=this._h0,v=this._h1,t=this._h2,h=this._h3,s=this._h4,n,r,a;for(let u=0;u<80;u++)u<20?(n=v&t|~v&h,r=1518500249):u<40?(n=v^t^h,r=1859775393):u<60?(n=v&t|v&h|t&h,r=2400959708):(n=v^t^h,r=3395469782),a=l(o,5)+n+s+r+b.getUint32(u*4,!1)&4294967295,s=h,h=t,t=l(v,30),v=o,o=a;this._h0=this._h0+o&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[49],me([0,1,9]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const y="error",A="warning",_="warn",S="info",P="ignore";function i(l){return l?m.equalsIgnoreCase(y,l)?C.Error:m.equalsIgnoreCase(A,l)||m.equalsIgnoreCase(_,l)?C.Warning:m.equalsIgnoreCase(S,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function k(l){switch(l){case C.Error:return y;case C.Warning:return A;case C.Info:return S;default:return P}}C.toString=k}(F||(F={})),e.default=F}),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(p){return Array.isArray(p)}e.isArray=m;function F(p){return typeof p=="string"}e.isString=F;function C(p){return Array.isArray(p)&&p.every(E=>F(E))}e.isStringArray=C;function y(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=y;function A(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=A;function _(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=_;function S(p){return p===!0||p===!1}e.isBoolean=S;function P(p){return typeof p=="undefined"}e.isUndefined=P;function i(p){return!k(p)}e.isDefined=i;function k(p){return P(p)||p===null}e.isUndefinedOrNull=k;function l(p,E){if(!p)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=l;function f(p){if(k(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=f;function d(...p){const E=[];for(let g=0;g<p.length;g++){const T=p[g];if(k(T))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);E.push(T)}return E}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function D(p){if(!y(p))return!1;for(let E in p)if(w.call(p,E))return!1;return!0}e.isEmptyObject=D;function I(p){return typeof p=="function"}e.isFunction=I;function b(...p){return p.length>0&&p.every(I)}e.areFunctions=b;function c(p,E){const g=Math.min(p.length,E.length);for(let T=0;T<g;T++)o(p[T],E[T])}e.validateConstraints=c;function o(p,E){if(F(E)){if(typeof p!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(I(E)){try{if(p instanceof E)return}catch{}if(!k(p)&&p.constructor===E||E.length===1&&E.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function v(p){let E=[],g=Object.getPrototypeOf(p);for(;Object.prototype!==g;)E=E.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return E}e.getAllPropertyNames=v;function t(p){const E=[];for(const g of v(p))typeof p[g]=="function"&&E.push(g);return E}e.getAllMethodNames=t;function h(p,E){const g=L=>function(){const M=Array.prototype.slice.call(arguments,0);return E(L,M)};let T={};for(const L of p)T[L]=g(L);return T}e.createProxyObject=h;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function n(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=n;function r(p){return class{constructor(){return new Proxy({},{get(E,g){if(E[g])return E[g];throw new Error(`Not Implemented: ${p}->${String(g)}`)}})}}}e.NotImplementedProxy=r;function a(p,E="Unreachable"){throw new Error(E)}e.assertNever=a;function u(p){return!!p&&typeof p.then=="function"&&typeof p.catch=="function"}e.isPromise=u}),define(fe[29],me([0,1,8,11,9,12]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function _(s){return s.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=_;function S(s){return s.indexOf("/")===-1&&(s=_(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function P(s,n=m.posix.sep){if(!s)return"";const r=s.length,a=s.charCodeAt(0);if(A(a)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let p=3;const E=p;for(;p<r&&!A(s.charCodeAt(p));p++);if(E!==p&&!A(s.charCodeAt(p+1))){for(p+=1;p<r;p++)if(A(s.charCodeAt(p)))return s.slice(0,p+1).replace(/[\\/]/g,n)}}return n}else if(I(a)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let u=s.indexOf("://");if(u!==-1){for(u+=3;u<r;u++)if(A(s.charCodeAt(u)))return s.slice(0,u+1)}return""}e.getRoot=P;function i(s){if(!F.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let r=2;const a=r;for(;r<s.length&&(n=s.charCodeAt(r),n!==92);r++);return!(a===r||(n=s.charCodeAt(r+1),isNaN(n)||n===92))}e.isUNC=i;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,n=F.isWindows){const r=n?k:l;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||n&&f.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function w(s,n,r){const a=s===n;return!r||a?a:!s||!n?!1:(0,C.equalsIgnoreCase)(s,n)}e.isEqual=w;function D(s,n,r,a=m.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(r){if(!(0,C.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let p=n.length;return n.charAt(n.length-1)===a&&p--,s.charAt(p)===a}return n.charAt(n.length-1)!==a&&(n+=a),s.indexOf(n)===0}e.isEqualOrParent=D;function I(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=I;function b(s,n){return F.isWindows&&s.endsWith(":")&&(s+=m.sep),(0,m.isAbsolute)(s)||(s=(0,m.join)(n,s)),s=(0,m.normalize)(s),F.isWindows?(s=(0,C.rtrim)(s,m.sep),s.endsWith(":")&&(s+=m.sep)):(s=(0,C.rtrim)(s,m.sep),s||(s=m.sep)),s}e.sanitizeFilePath=b;function c(s){const n=(0,m.normalize)(s);return F.isWindows?s.length>3?!1:o(n)&&(s.length===2||n.charCodeAt(2)===92):n===m.posix.sep}e.isRootOrDriveLetter=c;function o(s){return F.isWindows?I(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function v(s){return o(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,n,r){return n.length>s.length?-1:s===n?0:(r&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function h(s){const n=s.split(":");let r,a,u;if(n.forEach(p=>{const E=Number(p);(0,y.isNumber)(E)?a===void 0?a=E:u===void 0&&(u=E):r=r?[r,p].join(":"):p}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:a!==void 0?a:void 0,column:u!==void 0?u:a!==void 0?1:void 0}}e.parseLineAndColumnAware=h}),define(fe[25],me([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const D=Array.isArray(w)?[]:{};return Object.keys(w).forEach(I=>{w[I]&&typeof w[I]=="object"?D[I]=F(w[I]):D[I]=w[I]}),D}e.deepClone=F;function C(w){if(!w||typeof w!="object")return w;const D=[w];for(;D.length>0;){const I=D.shift();Object.freeze(I);for(const b in I)if(y.call(I,b)){const c=I[b];typeof c=="object"&&!Object.isFrozen(c)&&D.push(c)}}return w}e.deepFreeze=C;const y=Object.prototype.hasOwnProperty;function A(w,D){return _(w,D,new Set)}e.cloneAndChange=A;function _(w,D,I){if((0,m.isUndefinedOrNull)(w))return w;const b=D(w);if(typeof b!="undefined")return b;if((0,m.isArray)(w)){const c=[];for(const o of w)c.push(_(o,D,I));return c}if((0,m.isObject)(w)){if(I.has(w))throw new Error("Cannot clone recursive data-structure");I.add(w);const c={};for(let o in w)y.call(w,o)&&(c[o]=_(w[o],D,I));return I.delete(w),c}return w}function S(w,D,I=!0){return(0,m.isObject)(w)?((0,m.isObject)(D)&&Object.keys(D).forEach(b=>{b in w?I&&((0,m.isObject)(w[b])&&(0,m.isObject)(D[b])?S(w[b],D[b],I):w[b]=D[b]):w[b]=D[b]}),w):D}e.mixin=S;function P(w,D){if(w===D)return!0;if(w==null||D===null||D===void 0||typeof w!=typeof D||typeof w!="object"||Array.isArray(w)!==Array.isArray(D))return!1;let I,b;if(Array.isArray(w)){if(w.length!==D.length)return!1;for(I=0;I<w.length;I++)if(!P(w[I],D[I]))return!1}else{const c=[];for(b in w)c.push(b);c.sort();const o=[];for(b in D)o.push(b);if(o.sort(),!P(c,o))return!1;for(I=0;I<c.length;I++)if(!P(w[c[I]],D[c[I]]))return!1}return!0}e.equals=P;function i(w){const D=new Set;return JSON.stringify(w,(I,b)=>{if((0,m.isObject)(b)||Array.isArray(b)){if(D.has(b))return"[Circular]";D.add(b)}return b})}e.safeStringify=i;function k(w,D,I){const b=D(w);return typeof b=="undefined"?I:b}e.getOrDefault=k;function l(w,D){const I=Object.create(null);return!w||!D||Object.keys(D).forEach(c=>{const o=w[c],v=D[c];P(o,v)||(I[c]=v)}),I}e.distinct=l;function f(w,D){const I=D.toLowerCase(),b=Object.keys(w).find(c=>c.toLowerCase()===I);return b?w[b]:w[D]}e.getCaseInsensitive=f;function d(w,D){const I=Object.create(null);for(const b of Object.keys(w))D(b,w[b])&&(I[b]=w[b]);return I}e.filter=d}),define(fe[98],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function F(y){return y<0?0:y>255?255:y|0}e.toUint8=F;function C(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=C}),define(fe[2],me([0,1,8,11]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function _(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,n){return!s&&!n?"file":s}function P(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const i="",k="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(n,r,a,u,p,E=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=S(n,E),this.authority=r||i,this.path=P(this.scheme,a||i),this.query=u||i,this.fragment=p||i,_(this,E))}static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return c(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:a,path:u,query:p,fragment:E}=n;return r===void 0?r=this.scheme:r===null&&(r=i),a===void 0?a=this.authority:a===null&&(a=i),u===void 0?u=this.path:u===null&&(u=i),p===void 0?p=this.query:p===null&&(p=i),E===void 0?E=this.fragment:E===null&&(E=i),r===this.scheme&&a===this.authority&&u===this.path&&p===this.query&&E===this.fragment?this:new w(r,a,u,p,E)}static parse(n,r=!1){const a=l.exec(n);return a?new w(a[2]||i,h(a[4]||i),h(a[5]||i),h(a[7]||i),h(a[9]||i),r):new w(i,i,i,i,i)}static file(n){let r=i;if(F.isWindows&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const a=n.indexOf(k,2);a===-1?(r=n.substring(2),n=k):(r=n.substring(2,a),n=n.substring(a)||k)}return new w("file",r,n,i,i)}static from(n){const r=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return _(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return F.isWindows&&n.scheme==="file"?a=f.file(m.win32.join(c(n,!0),...r)).path:a=m.posix.join(n.path,...r),n.with({path:a})}toString(n=!1){return o(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const r=new w(n);return r._formatted=n.external,r._fsPath=n._sep===d?n.fsPath:null,r}}else return n}}e.URI=f;const d=F.isWindows?1:void 0;class w extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(n=!1){return n?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(s,n){let r,a=-1;for(let u=0;u<s.length;u++){const p=s.charCodeAt(u);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||n&&p===47)a!==-1&&(r+=encodeURIComponent(s.substring(a,u)),a=-1),r!==void 0&&(r+=s.charAt(u));else{r===void 0&&(r=s.substr(0,u));const E=D[p];E!==void 0?(a!==-1&&(r+=encodeURIComponent(s.substring(a,u)),a=-1),r+=E):a===-1&&(a=u)}}return a!==-1&&(r+=encodeURIComponent(s.substring(a))),r!==void 0?r:s}function b(s){let n;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(n===void 0&&(n=s.substr(0,r)),n+=D[a]):n!==void 0&&(n+=s[r])}return n!==void 0?n:s}function c(s,n){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,F.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=c;function o(s,n){const r=n?b:I;let a="",{scheme:u,authority:p,path:E,query:g,fragment:T}=s;if(u&&(a+=u,a+=":"),(p||u==="file")&&(a+=k,a+=k),p){let L=p.indexOf("@");if(L!==-1){const M=p.substr(0,L);p=p.substr(L+1),L=M.indexOf(":"),L===-1?a+=r(M,!1):(a+=r(M.substr(0,L),!1),a+=":",a+=r(M.substr(L+1),!1)),a+="@"}p=p.toLowerCase(),L=p.indexOf(":"),L===-1?a+=r(p,!1):(a+=r(p.substr(0,L),!1),a+=p.substr(L))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const L=E.charCodeAt(1);L>=65&&L<=90&&(E=`/${String.fromCharCode(L+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const L=E.charCodeAt(0);L>=65&&L<=90&&(E=`${String.fromCharCode(L+32)}:${E.substr(2)}`)}a+=r(E,!0)}return g&&(a+="?",a+=r(g,!1)),T&&(a+="#",a+=n?T:I(T,!1)),a}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(s){return s.match(t)?s.replace(t,n=>v(n)):s}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[24],me([0,1,16,9,2]),function(Y,e,m,F,C){"use strict";var y,A,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(s,n,r){let a=s.get(n);return a===void 0&&(a=r,s.set(n,a)),a}e.getOrSet=S;function P(s){const n=[];return s.forEach((r,a)=>{n.push(`${a} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=P;function i(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=i;class k{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=k;class l{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,F.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=l;class f{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,F.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var d;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(d||(d={}));class w{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,F.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(I||(I={}));class b{constructor(n){this._iter=n}static forUris(n=()=>!1){return new b(new w(n))}static forPaths(){return new b(new f)}static forStrings(){return new b(new k)}static forConfigKeys(){return new b(new l)}clear(){this._root=void 0}fill(n,r){if(r){const a=r.slice(0);(0,m.shuffle)(a);for(let u of a)this.set(u,n)}else{const a=n.slice(0);(0,m.shuffle)(a);for(let u of a)this.set(u[0],u[1])}}set(n,r){const a=this._iter.reset(n);let u;this._root||(this._root=new D,this._root.segment=a.value());const p=[];for(u=this._root;;){const g=a.cmp(u.segment);if(g>0)u.left||(u.left=new D,u.left.segment=a.value()),p.push([-1,u]),u=u.left;else if(g<0)u.right||(u.right=new D,u.right.segment=a.value()),p.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new D,u.mid.segment=a.value()),p.push([0,u]),u=u.mid;else break}const E=u.value;u.value=r,u.key=n;for(let g=p.length-1;g>=0;g--){const T=p[g][1];T.updateHeight();const L=T.balanceFactor();if(L<-1||L>1){const M=p[g][0],R=p[g+1][0];if(M===1&&R===1)p[g][1]=T.rotateLeft();else if(M===-1&&R===-1)p[g][1]=T.rotateRight();else if(M===1&&R===-1)T.right=p[g+1][1]=p[g+1][1].rotateRight(),p[g][1]=T.rotateLeft();else if(M===-1&&R===1)T.left=p[g+1][1]=p[g+1][1].rotateLeft(),p[g][1]=T.rotateRight();else throw new Error;if(g>0)switch(p[g-1][0]){case-1:p[g-1][1].left=p[g][1];break;case 1:p[g-1][1].right=p[g][1];break;case 0:p[g-1][1].mid=p[g][1];break}else this._root=p[0][1]}}return E}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let a=this._root;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const a=this._iter.reset(n),u=[];let p=this._root;for(;p;){const E=a.cmp(p.segment);if(E>0)u.push([-1,p]),p=p.left;else if(E<0)u.push([1,p]),p=p.right;else if(a.hasNext())a.next(),u.push([0,p]),p=p.mid;else break}if(!!p){if(r?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const E=this._min(p.right),{key:g,value:T,segment:L}=E;this._delete(E.key,!1),p.key=g,p.value=T,p.segment=L}else{const E=p.left??p.right;if(u.length>0){const[g,T]=u[u.length-1];switch(g){case-1:T.left=E;break;case 0:T.mid=E;break;case 1:T.right=E;break}}else this._root=E}for(let E=u.length-1;E>=0;E--){const g=u[E][1];g.updateHeight();const T=g.balanceFactor();if(T>1?(g.right.balanceFactor()>=0||(g.right=u[E+1][1]=u[E+1][1].rotateRight()),u[E][1]=g.rotateLeft()):T<-1&&(g.left.balanceFactor()<=0||(g.left=u[E+1][1]=u[E+1][1].rotateLeft()),u[E][1]=g.rotateRight()),E>0)switch(u[E-1][0]){case-1:u[E-1][1].left=u[E][1];break;case 1:u[E-1][1].right=u[E][1];break;case 0:u[E-1][1].mid=u[E][1];break}else this._root=u[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const r=this._iter.reset(n);let a=this._root,u;for(;a;){const p=r.cmp(a.segment);if(p>0)a=a.left;else if(p<0)a=a.right;else if(r.hasNext())r.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(n){const r=this._iter.reset(n);let a=this._root;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[r,a]of this)n(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:n(r.left)&&n(r.right)};return n(this._root)}}e.TernarySearchTree=b;class c{constructor(n,r){this[y]="ResourceMap",n instanceof c?(this.map=new Map(n.map),this.toKey=r??c.defaultToKey):(this.map=new Map,this.toKey=n??c.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[a,u]of this.map)n(u,C.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield C.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[C.URI.parse(n[0]),n[1]]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[C.URI.parse(n[0]),n[1]]}}e.ResourceMap=c,c.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class v{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const a=this._map.get(n);if(!!a)return r!==0&&this.touch(a,r),a.value}set(n,r,a=0){let u=this._map.get(n);if(u)u.value=r,a!==0&&this.touch(u,a);else{switch(u={key:n,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const a=this._state;let u=this._head;for(;u;){if(r?n.bind(r)(u.value,u.key,this):n(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,r=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.key,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return u}values(){const n=this,r=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.value,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return u}entries(){const n=this,r=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:[a.key,a.value],done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>n;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,a=n.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const a=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const a=n.next,u=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,a)=>{n.push([a,r])}),n}fromJSON(n){this.clear();for(const[r,a]of n)this.set(r,a)}}e.LinkedMap=v;class t extends v{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class h{constructor(n){_.set(this,void 0),ot(this,_,n,"f")}get size(){return Oe(this,_,"f").size}forEach(n,r){Oe(this,_,"f").forEach(n,r)}get(n){return Oe(this,_,"f").get(n)}has(n){return Oe(this,_,"f").has(n)}entries(){return Oe(this,_,"f").entries()}keys(){return Oe(this,_,"f").keys()}values(){return Oe(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return Oe(this,_,"f").entries()}}e.ReadonlyMapView=h}),define(fe[99],me([0,1,24,9]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(ae,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](ae,pe);if(Ke)return Ke}return null}}e.or=C,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Z,ae,pe){if(!pe||pe.length<ae.length)return null;let Me;return Z?Me=F.startsWithIgnoreCase(pe,ae):Me=pe.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(Z,ae){const pe=ae.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=A;function _(Z,ae){return S(Z.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=_;function S(Z,ae,pe,Me){if(pe===Z.length)return[];if(Me===ae.length)return null;if(Z[pe]===ae[Me]){let je=null;return(je=S(Z,ae,pe+1,Me+1))?I({start:Me,end:Me+1},je):null}return S(Z,ae,pe,Me+1)}function P(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function k(Z){return 48<=Z&&Z<=57}function l(Z){return Z===32||Z===9||Z===10||Z===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>f.add(Z.charCodeAt(0)));function d(Z){return l(Z)||f.has(Z)}function w(Z,ae){return Z===ae||d(Z)&&d(ae)}function D(Z){return P(Z)||i(Z)||k(Z)}function I(Z,ae){return ae.length===0?ae=[Z]:Z.end===ae[0].start?ae[0].start=Z.start:ae.unshift(Z),ae}function b(Z,ae){for(let pe=ae;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||k(Me)||pe>0&&!D(Z.charCodeAt(pe-1)))return pe}return Z.length}function c(Z,ae,pe,Me){if(pe===Z.length)return[];if(Me===ae.length)return null;if(Z[pe]!==ae[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=c(Z,ae,pe+1,Me+1);!je&&(Ke=b(ae,Ke))<ae.length;)je=c(Z,ae,pe+1,Ke),Ke++;return je===null?null:I({start:Me,end:Me+1},je)}}function o(Z){let ae=0,pe=0,Me=0,je=0,Ke=0;for(let J=0;J<Z.length;J++)Ke=Z.charCodeAt(J),i(Ke)&&ae++,P(Ke)&&pe++,D(Ke)&&Me++,k(Ke)&&je++;const Je=ae/Z.length,st=pe/Z.length,Te=Me/Z.length,nt=je/Z.length;return{upperPercent:Je,lowerPercent:st,alphaPercent:Te,numericPercent:nt}}function v(Z){const{upperPercent:ae,lowerPercent:pe}=Z;return pe===0&&ae>.6}function t(Z){const{upperPercent:ae,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&ae<.8&&Me>.6&&je<.2}function h(Z){let ae=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&ae++,P(Me)&&pe++,l(Me)&&je++;return(ae===0||pe===0)&&je===0?Z.length<=30:ae<=5}function s(Z,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!h(Z)||ae.length>60)return null;const pe=o(ae);if(!t(pe)){if(!v(pe))return null;ae=ae.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<ae.length&&(Me=c(Z,ae,0,je))===null;)je=b(ae,je+1);return Me}e.matchesCamelCase=s;function n(Z,ae,pe=!1){if(!ae||ae.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),ae=ae.toLowerCase();je<ae.length&&(Me=r(Z,ae,0,je,pe))===null;)je=a(ae,je+1);return Me}e.matchesWords=n;function r(Z,ae,pe,Me,je){if(pe===Z.length)return[];if(Me===ae.length)return null;if(w(Z.charCodeAt(pe),ae.charCodeAt(Me))){let Ke=null,Je=Me+1;if(Ke=r(Z,ae,pe+1,Me+1,je),!je)for(;!Ke&&(Je=a(ae,Je))<ae.length;)Ke=r(Z,ae,pe+1,Je,je),Je++;return Ke===null?null:I({start:Me,end:Me+1},Ke)}else return null}function a(Z,ae){for(let pe=ae;pe<Z.length;pe++)if(d(Z.charCodeAt(pe))||pe>0&&d(Z.charCodeAt(pe-1)))return pe;return Z.length}const u=C(e.matchesPrefix,s,A),p=C(e.matchesPrefix,s,_),E=new m.LRUCache(1e4);function g(Z,ae,pe=!1){if(typeof Z!="string"||typeof ae!="string")return null;let Me=E.get(Z);Me||(Me=new RegExp(F.convertSimple2RegExpPattern(Z),"i"),E.set(Z,Me));const je=Me.exec(ae);return je?[{start:je.index,end:je.index+je[0].length}]:pe?p(Z,ae):u(Z,ae)}e.matchesFuzzy=g;function T(Z,ae){const pe=Be(Z,Z.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return pe?M(pe):null}e.matchesFuzzy2=T;function L(Z,ae,pe,Me,je,Ke){const Je=Math.min(13,Z.length);for(;pe<Je;pe++){const st=Be(Z,ae,pe,Me,je,Ke,!1);if(st)return st}return[0,Ke]}e.anyScore=L;function M(Z){if(typeof Z=="undefined")return[];const ae=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=ae[ae.length-1];Ke&&Ke.end===je?Ke.end=je+1:ae.push({start:je,end:je+1})}return ae}e.createMatches=M;const R=128;function W(){const Z=[],ae=[];for(let pe=0;pe<=R;pe++)ae[pe]=0;for(let pe=0;pe<=R;pe++)Z.push(ae.slice(0));return Z}function V(Z){const ae=[];for(let pe=0;pe<=Z;pe++)ae[pe]=0;return ae}const N=V(2*R),j=V(2*R),U=W(),x=W(),z=W(),O=!1;function $(Z,ae,pe,Me,je){function Ke(st,Te,nt=" "){for(;st.length<Te;)st=nt+st;return st}let Je=` |   |${Me.split("").map(st=>Ke(st,3)).join("|")}
`;for(let st=0;st<=pe;st++)st===0?Je+=" |":Je+=`${ae[st-1]}|`,Je+=Z[st].slice(0,je+1).map(Te=>Ke(Te.toString(),3)).join("|")+`
`;return Je}function B(Z,ae,pe,Me){Z=Z.substr(ae),pe=pe.substr(Me),console.log($(x,Z,Z.length,pe,pe.length)),console.log($(z,Z,Z.length,pe,pe.length)),console.log($(U,Z,Z.length,pe,pe.length))}function X(Z,ae){if(ae<0||ae>=Z.length)return!1;const pe=Z.codePointAt(ae);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(pe)}}function Q(Z,ae){if(ae<0||ae>=Z.length)return!1;switch(Z.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function de(Z,ae,pe){return ae[Z]!==pe[Z]}function _e(Z,ae,pe,Me,je,Ke,Je=!1){for(;ae<pe&&je<Ke;)Z[ae]===Me[je]&&(Je&&(N[ae]=je),ae+=1),je+=1;return ae===pe}e.isPatternInWord=_e;var ye;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var ke;(function(Z){Z.Default=[-100,0];function ae(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=ae})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,ae,pe,Me,je,Ke,Je){const st=Z.length>R?R:Z.length,Te=Me.length>R?R:Me.length;if(pe>=st||Ke>=Te||st-pe>Te-Ke||!_e(ae,pe,st,je,Ke,Te,!0))return;We(st,Te,pe,Ke,ae,je);let nt=1,J=1,ne=pe,ve=Ke;const Qe=[!1];for(nt=1,ne=pe;ne<st;nt++,ne++){const Ue=N[ne],Xe=j[ne],rt=ne+1<st?j[ne+1]:Te;for(J=Ue-Ke+1,ve=Ue;ve<rt;J++,ve++){let ht=Number.MIN_SAFE_INTEGER,Ye=!1;ve<=Xe&&(ht=He(Z,ae,ne,pe,Me,je,ve,Te,Ke,U[nt-1][J-1]===0,Qe));let vt=0;ht!==Number.MAX_SAFE_INTEGER&&(Ye=!0,vt=ht+x[nt-1][J-1]);const Re=ve>Ue,Ce=Re?x[nt][J-1]+(U[nt][J-1]>0?-5:0):0,Pe=ve>Ue+1&&U[nt][J-1]>0,se=Pe?x[nt][J-2]+(U[nt][J-2]>0?-5:0):0;if(Pe&&(!Re||se>=Ce)&&(!Ye||se>=vt))x[nt][J]=se,z[nt][J]=3,U[nt][J]=0;else if(Re&&(!Ye||Ce>=vt))x[nt][J]=Ce,z[nt][J]=2,U[nt][J]=0;else if(Ye)x[nt][J]=vt,z[nt][J]=1,U[nt][J]=U[nt-1][J-1]+1;else throw new Error("not possible")}}if(O&&B(Z,pe,Me,Ke),!Qe[0]&&!Je)return;nt--,J--;const tt=[x[nt][J],Ke];let ct=0,ce=0;for(;nt>=1;){let Ue=J;do{const Xe=z[nt][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);ct>1&&ae[pe+nt-1]===je[Ke+J-1]&&!de(Ue+Ke-1,Me,je)&&ct+1>U[nt][Ue]&&(Ue=J),Ue===J?ct++:ct=1,ce||(ce=Ue),nt--,J=Ue-1,tt.push(J)}Te===st&&(tt[0]+=2);const Ie=ce-st;return tt[0]-=Ie,tt}e.fuzzyScore=Be;function We(Z,ae,pe,Me,je,Ke){let Je=Z-1,st=ae-1;for(;Je>=pe&&st>=Me;)je[Je]===Ke[st]&&(j[Je]=st,Je--),st--}function He(Z,ae,pe,Me,je,Ke,Je,st,Te,nt,J){if(ae[pe]!==Ke[Je])return Number.MIN_SAFE_INTEGER;let ne=1,ve=!1;return Je===pe-Me?ne=Z[pe]===je[Je]?7:5:de(Je,je,Ke)&&(Je===0||!de(Je-1,je,Ke))?(ne=Z[pe]===je[Je]?7:5,ve=!0):X(Ke,Je)&&(Je===0||!X(Ke,Je-1))?ne=5:(X(Ke,Je-1)||Q(Ke,Je-1))&&(ne=5,ve=!0),ne>1&&pe===Me&&(J[0]=!0),ve||(ve=de(Je,je,Ke)||X(Ke,Je-1)||Q(Ke,Je-1)),pe===Me?Je>Te&&(ne-=ve?3:5):nt?ne+=ve?2:0:ne+=ve?0:1,Je+1===st&&(ne-=ve?3:5),ne}function q(Z,ae,pe,Me,je,Ke,Je){return re(Z,ae,pe,Me,je,Ke,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function ee(Z,ae,pe,Me,je,Ke,Je){return re(Z,ae,pe,Me,je,Ke,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,ae,pe,Me,je,Ke,Je,st){let Te=Be(Z,ae,pe,Me,je,Ke,st);if(Te&&!Je)return Te;if(Z.length>=3){const nt=Math.min(7,Z.length-1);for(let J=pe+1;J<nt;J++){const ne=le(Z,J);if(ne){const ve=Be(ne,ne.toLowerCase(),pe,Me,je,Ke,st);ve&&(ve[0]-=3,(!Te||ve[0]>Te[0])&&(Te=ve))}}}return Te}function le(Z,ae){if(ae+1>=Z.length)return;const pe=Z[ae],Me=Z[ae+1];if(pe!==Me)return Z.slice(0,ae)+Me+pe+Z.slice(ae+2)}}),define(fe[143],me([0,1,47,99,9]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function _(w){return w.replace(A,(D,I)=>I?D:`\\${D}`)}e.escapeIcons=_;const S=new RegExp(`\\\\${y.source}`,"g");function P(w){return w.replace(S,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=P;const i=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function k(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(i,(D,I,b,c)=>b?D:I||c||"")}e.stripIcons=k;function l(w){const D=w.indexOf(e.iconStartMarker);return D===-1?{text:w}:f(w,D)}e.parseLabelWithIcons=l;function f(w,D){const I=[];let b="";function c(a){if(a){b+=a;for(const u of a)I.push(t)}}let o=-1,v="",t=0,h,s,n=D;const r=w.length;for(c(w.substr(0,D));n<r;)h=w[n],s=w[n+1],h===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(o=n,c(v),v=e.iconStartMarker,n++):h===")"&&o!==-1?(t+=n-o+1,o=-1,v=""):o!==-1?/^[a-z0-9\-]$/i.test(h)?v+=h:(c(v),o=-1,v=""):c(h),n++;return c(v),{text:b,iconOffsets:I}}function d(w,D,I=!1){const{text:b,iconOffsets:c}=D;if(!c||c.length===0)return(0,F.matchesFuzzy)(w,b,I);const o=(0,C.ltrim)(b," "),v=b.length-o.length,t=(0,F.matchesFuzzy)(w,o,I);if(t)for(const h of t){const s=c[h.start+v]+v;h.start+=s,h.end+=s}return t}e.matchesFuzzyIconAware=d}),define(fe[100],me([0,1,18,143]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",d=!1){if(this.value=f,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(f,d=0){return this.value+=P(this.supportThemeIcons?(0,F.escapeIcons)(f):f).replace(/([ \t]+)/g,(w,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,d){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=y;function A(l){return _(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function _(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=_;function S(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=S;function P(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function i(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function k(l){const f=[],d=l.split("|").map(D=>D.trim());l=d[0];const w=d[1];if(w){const D=/height=(\d+)/.exec(w),I=/width=(\d+)/.exec(w),b=D?D[1]:"",c=I?I[1]:"",o=isFinite(parseInt(c)),v=isFinite(parseInt(b));o&&f.push(`width="${c}"`),v&&f.push(`height="${b}"`)}return{href:l,dimensions:f}}e.parseHrefAndDimensions=k}),define(fe[62],me([0,1,22,9,2]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,S)}e.stringify=y;function A(i){let k=JSON.parse(i);return k=P(k),k}e.parse=A;var _;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(_=e.MarshalledId||(e.MarshalledId={}));function S(i,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,F.regExpFlags)(k)}:k}function P(i,k=0){if(!i||k>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return C.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof m.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let l=0;l<i.length;++l)i[l]=P(i[l],k+1);else for(const l in i)Object.hasOwnProperty.call(i,l)&&(i[l]=P(i[l],k+1))}return i}e.revive=P}),define(fe[10],me([0,1,11,2]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(_){_.inMemory="inmemory",_.vscode="vscode",_.internal="private",_.walkThrough="walkThrough",_.walkThroughSnippet="walkThroughSnippet",_.http="http",_.https="https",_.file="file",_.mailto="mailto",_.untitled="untitled",_.data="data",_.command="command",_.vscodeRemote="vscode-remote",_.vscodeRemoteResource="vscode-remote-resource",_.userData="vscode-userdata",_.vscodeCustomEditor="vscode-custom-editor",_.vscodeNotebook="vscode-notebook",_.vscodeNotebookCell="vscode-notebook-cell",_.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",_.vscodeNotebookCellOutput="vscode-notebook-cell-output",_.vscodeInteractive="vscode-interactive",_.vscodeInteractiveInput="vscode-interactive-input",_.vscodeSettings="vscode-settings",_.vscodeWorkspaceTrust="vscode-workspace-trust",_.vscodeTerminal="vscode-terminal",_.webviewPanel="webview-panel",_.vscodeWebview="vscode-webview",_.extension="extension",_.vscodeFileResource="vscode-file",_.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,P,i){this._hosts[S]=P,this._ports[S]=i}setConnectionToken(S,P){this._connectionTokens[S]=P}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let i=this._hosts[P];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const k=this._ports[P],l=this._connectionTokens[P];let f=`path=${encodeURIComponent(S.path)}`;return typeof l=="string"&&(f+=`&tkn=${encodeURIComponent(l)}`),F.URI.from({scheme:m.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${k}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class A{asBrowserUri(S,P){const i=this.toUri(S,P);return i.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===C.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${C.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:C.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(S,P){const i=this.toUri(S,P);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,P){return F.URI.isUri(S)?S:F.URI.parse(P.toUrl(S))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(fe[79],me([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new m.LRUCache(1e4);function C(P){return S(P,"NFC",F)}e.normalizeNFC=C;const y=new m.LRUCache(1e4);function A(P){return S(P,"NFD",y)}e.normalizeNFD=A;const _=/[^\u0000-\u0080]/;function S(P,i,k){if(!P)return P;const l=k.get(P);if(l)return l;let f;return _.test(P)?f=P.normalize(i):f=P,k.set(P,f),f}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(i){return A(i).replace(P,"")}}()}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,_.uriToFsPath)(f,!0)}e.originalFSPath=S;class P{constructor(d){this._ignorePathCasing=d}compare(d,w,D=!1){return d===w?0:(0,A.compare)(this.getComparisonKey(d,D),this.getComparisonKey(w,D))}isEqual(d,w,D=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,D)===this.getComparisonKey(w,D)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,D=!1){if(d.scheme===w.scheme){if(d.scheme===F.Schemas.file)return m.isEqualOrParent(S(d),S(w),this._ignorePathCasing(d))&&d.query===w.query&&(D||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return m.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(D||d.fragment===w.fragment)}return!1}joinPath(d,...w){return _.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return C.posix.basename(d.path)}extname(d){return C.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===F.Schemas.file?w=_.URI.file(C.dirname(S(d))).path:(w=C.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===F.Schemas.file?w=_.URI.file(C.normalize(S(d))).path:w=C.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))return;if(d.scheme===F.Schemas.file){const b=C.relative(S(d),S(w));return y.isWindows?m.toSlashes(b):b}let D=d.path||"/",I=w.path||"/";if(this._ignorePathCasing(d)){let b=0;for(const c=Math.min(D.length,I.length);b<c&&!(D.charCodeAt(b)!==I.charCodeAt(b)&&D.charAt(b).toLowerCase()!==I.charAt(b).toLowerCase());b++);D=I.substr(0,b)+D.substr(b)}return C.posix.relative(D,I)}resolvePath(d,w){if(d.scheme===F.Schemas.file){const D=_.URI.file(C.resolve(S(d),w));return d.with({authority:D.authority,path:D.path})}return w=m.toPosixPath(w),d.with({path:C.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,A.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=C.sep){if(d.scheme===F.Schemas.file){const D=S(d);return D.length>m.getRoot(D).length&&D[D.length-1]===w}else{const D=d.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=C.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=C.sep){let D=!1;if(d.scheme===F.Schemas.file){const I=S(d);D=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===w}else{w="/";const I=d.path;D=I.length===1&&I.charCodeAt(I.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(f=>f.scheme===F.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new P(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(f,d){const w=[];for(let D=0;D<f.length;D++){const I=d(f[D]);f.some((b,c)=>c===D?!1:(0,e.isEqualOrParent)(I,d(b)))||w.push(f[D])}return w}e.distinctParents=i;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(w){const D=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,v]=c.split(":");o&&v&&D.set(o,v)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&D.set(f.META_DATA_MIME,b),D}f.parseMetaData=d})(k=e.DataUri||(e.DataUri={}));function l(f,d,w){if(d){let D=f.path;return D&&D[0]!==C.posix.sep&&(D=C.posix.sep+D),f.with({scheme:w,authority:d,path:D})}return f.with({scheme:w})}e.toLocalResource=l}),define(fe[17],me([0,1,21,18,3,6,23]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(U){return!!U&&typeof U.then=="function"}e.isThenable=_;function S(U){const x=new m.CancellationTokenSource,z=U(x.token),O=new Promise(($,B)=>{const X=x.token.onCancellationRequested(()=>{X.dispose(),x.dispose(),B((0,F.canceled)())});Promise.resolve(z).then(Q=>{X.dispose(),x.dispose(),$(Q)},Q=>{X.dispose(),x.dispose(),B(Q)})});return new class{cancel(){x.cancel()}then($,B){return O.then($,B)}catch($){return this.then(void 0,$)}finally($){return O.finally($)}}}e.createCancelablePromise=S;function P(U,x,z){return Promise.race([U,new Promise(O=>x.onCancellationRequested(()=>O(z)))])}e.raceCancellation=P;async function i(U){let x=-1;const z=U.map(($,B)=>$.then(X=>(x=B,X))),O=await Promise.race(z);return U.forEach(($,B)=>{B!==x&&$.cancel()}),O}e.raceCancellablePromises=i;function k(U,x,z){let O;const $=setTimeout(()=>{O?.(void 0),z?.()},x);return Promise.race([U.finally(()=>clearTimeout($)),new Promise(B=>O=B)])}e.raceTimeout=k;function l(U){return new Promise((x,z)=>{const O=U();_(O)?O.then(x,z):x(O)})}e.asPromise=l;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(z,z).then(O)})}return new Promise((z,O)=>{this.queuedPromise.then(z,O)})}return this.activePromise=x(),new Promise((z,O)=>{this.activePromise.then($=>{this.activePromise=null,z($)},$=>{this.activePromise=null,O($)})})}}e.Throttler=f;class d{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=d;class w{constructor(){this.promiseMap=new Map}queue(x,z){const $=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(x)===$&&this.promiseMap.delete(x)});return this.promiseMap.set(x,$),$}}e.SequencerByKey=w;class D{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,z=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,$)=>{this.doResolve=O,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class I{constructor(x){this.delayer=new D(x),this.throttler=new f}trigger(x,z){return this.delayer.trigger(()=>this.throttler.queue(x),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,z)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class c extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function o(U,x){return x?new Promise((z,O)=>{const $=setTimeout(()=>{B.dispose(),z()},U),B=x.onCancellationRequested(()=>{clearTimeout($),B.dispose(),O((0,F.canceled)())})}):S(z=>o(U,z))}e.timeout=o;function v(U,x=0){const z=setTimeout(U,x);return(0,y.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=v;function t(U){const x=[];let z=0;const O=U.length;function $(){return z<O?U[z++]():null}function B(X){X!=null&&x.push(X);const Q=$();return Q?Q.then(B):Promise.resolve(x)}return Promise.resolve(null).then(B)}e.sequence=t;function h(U,x=O=>!!O,z=null){let O=0;const $=U.length,B=()=>{if(O>=$)return Promise.resolve(z);const X=U[O++];return Promise.resolve(X()).then(de=>x(de)?Promise.resolve(de):B())};return B()}e.first=h;function s(U,x=O=>!!O,z=null){if(U.length===0)return Promise.resolve(z);let O=U.length;const $=()=>{O=-1;for(const B of U)B.cancel?.()};return new Promise((B,X)=>{for(const Q of U)Q.then(de=>{--O>=0&&x(de)?($(),B(de)):O===0&&B(z)}).catch(de=>{--O>=0&&($(),X(de))})})}e.firstParallel=s;class n{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((z,O)=>{this.outstandingPromises.push({factory:x,c:z,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const z=x.factory();z.then(x.c,x.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class r extends n{constructor(){super(1)}}e.Queue=r;class a{constructor(){this.queues=new Map}queueFor(x,z=A.extUri){const O=z.getComparisonKey(x);let $=this.queues.get(O);return $||($=new r,C.Event.once($.onFinished)(()=>{$?.dispose(),this.queues.delete(O)}),this.queues.set(O,$)),$}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=a;class u{constructor(x,z){this._token=-1,typeof x=="function"&&typeof z=="number"&&this.setIfNotSet(x,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},z)}setIfNotSet(x,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},z))}}e.TimeoutTimer=u;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,z){this.cancel(),this._token=setInterval(()=>{x()},z)}}e.IntervalTimer=p;class E{constructor(x,z){this.timeoutToken=-1,this.runner=x,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class g{constructor(x,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class T extends E{constructor(x,z){super(x,z);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class L extends y.Disposable{constructor(x,z,O,$){super();this.maxWorkChunkSize=x,this.maxPendingWork=z,this.throttleDelay=O,this.handler=$,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{const x=setTimeout(()=>{const O=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0,clearTimeout(x))}}}:e.runWhenIdle=(U,x)=>{const z=requestIdleCallback(U,typeof x=="number"?{timeout:x}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(z))}}}}();class M{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function R(U,x,z){let O;for(let $=0;$<z;$++)try{return await U()}catch(B){O=B,await o(x)}throw O}e.retry=R;class W{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,z,O){return this._pending={taskId:x,cancel:()=>O?.(),promise:z},z.then(()=>this.donePending(x),()=>this.donePending(x)),z}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let z,O;const $=new Promise((B,X)=>{z=B,O=X});this._next={run:x,promise:$,promiseResolve:z,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=W;class V{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,z)=>{this.completeCallback=x,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(z=>{this.completeCallback(x),this.resolved=!0,z()})}error(x){return new Promise(z=>{this.errorCallback(x),this.rejected=!0,z()})}cancel(){new Promise(x=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=N;var j;(function(U){async function x(O){let $;const B=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{$||($=Q)})));if(typeof $!="undefined")throw $;return B}U.settled=x;function z(O){return new Promise(async($,B)=>{try{await O($,B)}catch(X){B(X)}})}U.withAsyncBody=z})(j=e.Promises||(e.Promises={}))}),define(fe[101],me([0,1,17,8]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new m.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),y=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function _(E,g,T=!1){const L=E||"",M=g||"",R=C.value.collator.compare(L,M);return C.value.collatorIsNumeric&&R===0&&L!==M?L<M?-1:1:R}e.compareFileNames=_;function S(E,g){const T=y.value.collator;return E=E||"",g=g||"",v(T,E,g)}e.compareFileNamesDefault=S;function P(E,g){const T=y.value.collator;return E=E||"",g=g||"",n(E,g)||v(T,E,g)}e.compareFileNamesUpper=P;function i(E,g){const T=y.value.collator;return E=E||"",g=g||"",s(E,g)||v(T,E,g)}e.compareFileNamesLower=i;function k(E,g){return E=E||"",g=g||"",E===g?0:E<g?-1:1}e.compareFileNamesUnicode=k;function l(E,g,T=!1){T||(E=E&&E.toLowerCase(),g=g&&g.toLowerCase());const[L,M]=c(E),[R,W]=c(g);return L!==R?L<R?-1:1:M===W?0:M<W?-1:1}e.noIntlCompareFileNames=l;function f(E,g){const[T,L]=c(E),[M,R]=c(g);let W=C.value.collator.compare(L,R);if(W===0){if(C.value.collatorIsNumeric&&L!==R)return L<R?-1:1;if(W=C.value.collator.compare(T,M),C.value.collatorIsNumeric&&W===0&&T!==M)return T<M?-1:1}return W}e.compareFileExtensions=f;function d(E,g){E=E||"",g=g||"";const T=o(E),L=o(g),M=y.value.collator,R=A.value.collator;return v(R,T,L)||v(M,E,g)}e.compareFileExtensionsDefault=d;function w(E,g){E=E||"",g=g||"";const T=o(E),L=o(g),M=y.value.collator,R=A.value.collator;return v(R,T,L)||n(E,g)||v(M,E,g)}e.compareFileExtensionsUpper=w;function D(E,g){E=E||"",g=g||"";const T=o(E),L=o(g),M=y.value.collator,R=A.value.collator;return v(R,T,L)||s(E,g)||v(M,E,g)}e.compareFileExtensionsLower=D;function I(E,g){E=E||"",g=g||"";const T=o(E).toLowerCase(),L=o(g).toLowerCase();return T!==L?T<L?-1:1:E!==g?E<g?-1:1:0}e.compareFileExtensionsUnicode=I;const b=/^(.*?)(\.([^.]*))?$/;function c(E,g=!1){const T=E?b.exec(E):[];let L=[T&&T[1]||"",T&&T[3]||""];return g&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function o(E){const g=E?b.exec(E):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function v(E,g,T){let L=E.compare(g,T);return L!==0?L:g.length!==T.length?g.length<T.length?-1:1:0}function t(E){const g=E.charAt(0);return g.toLocaleUpperCase()!==g}function h(E){const g=E.charAt(0);return g.toLocaleLowerCase()!==g}function s(E,g){return t(E)&&h(g)?-1:h(E)&&t(g)?1:0}function n(E,g){return h(E)&&t(g)?-1:t(E)&&h(g)?1:0}function r(E,g,T=!1){return T||(E=E&&E.toLowerCase(),g=g&&g.toLowerCase()),E===g?0:E<g?-1:1}function a(E,g,T=!1){const L=E.split(F.sep),M=g.split(F.sep),R=L.length-1,W=M.length-1;let V,N;for(let j=0;;j++){if(V=R===j,N=W===j,V&&N)return _(L[j],M[j],T);if(V)return-1;if(N)return 1;const U=r(L[j],M[j],T);if(U!==0)return U}}e.comparePaths=a;function u(E,g,T){const L=E.toLowerCase(),M=g.toLowerCase(),R=p(E,g,T);if(R)return R;const W=L.endsWith(T),V=M.endsWith(T);if(W!==V)return W?-1:1;const N=_(L,M);return N!==0?N:L.localeCompare(M)}e.compareAnything=u;function p(E,g,T){const L=E.toLowerCase(),M=g.toLowerCase(),R=L.startsWith(T),W=M.startsWith(T);if(R!==W)return R?-1:1;if(R&&W){if(L.length<M.length)return-1;if(L.length>M.length)return 1}return 0}e.compareByPrefix=p}),define(fe[102],me([0,1,101,99,48,8,11,9]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,P=[S,[]];function i(U,x,z,O){if(!U||!x)return P;const $=U.length,B=x.length;if($<B)return P;const X=U.toLowerCase();return k(x,z,B,U,X,$,O)}e.scoreFuzzy=i;function k(U,x,z,O,$,B,X){const Q=[],de=[];for(let Be=0;Be<z;Be++){const We=Be*B,He=We-B,q=Be>0,ee=U[Be],re=x[Be];for(let le=0;le<B;le++){const Z=le>0,ae=We+le,pe=ae-1,Me=He+le-1,je=Z?Q[pe]:0,Ke=q&&Z?Q[Me]:0,Je=q&&Z?de[Me]:0;let st;!Ke&&q?st=0:st=l(ee,re,O,$,le,Je),st&&Ke+st>=je&&(X||q||$.startsWith(x,le))?(de[ae]=Je+1,Q[ae]=Ke+st):(de[ae]=S,Q[ae]=je)}}const _e=[];let ye=z-1,ke=B-1;for(;ye>=0&&ke>=0;){const Be=ye*B+ke;de[Be]===S||(_e.push(ke),ye--),ke--}return[Q[z*B-1],_e.reverse()]}function l(U,x,z,O,$,B){let X=0;if(!f(x,O[$]))return X;if(X+=1,B>0&&(X+=B*5),U===z[$]&&(X+=1),$===0)X+=8;else{const Q=d(z.charCodeAt($-1));Q?X+=Q:(0,F.isUpper)(z.charCodeAt($))&&(X+=2)}return X}function f(U,x){return U===x?!0:U==="/"||U==="\\"?x==="/"||x==="\\":!1}function d(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function D(U,x,z=0,O=0){const $=x;return $.values&&$.values.length>1?I(U,$.values,z,O):b(U,x,z,O)}e.scoreFuzzy2=D;function I(U,x,z,O){let $=0;const B=[];for(const X of x){const[Q,de]=b(U,X,z,O);if(typeof Q!="number")return w;$+=Q,B.push(...de)}return[$,p(B)]}function b(U,x,z,O){const $=(0,F.fuzzyScore)(x.original,x.originalLowercase,z,U,U.toLowerCase(),O,!0);return $?[$[0],(0,F.createMatches)($)]:w}const c=Object.freeze({score:0}),o=1<<18,v=1<<17,t=1<<16;function h(U,x,z,O){const $=O.values?O.values:[O];return(0,C.hash)({[O.normalized]:{values:$.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:U,description:x,allowNonContiguousMatches:z}})}function s(U,x,z,O,$){if(!U||!x.normalized)return c;const B=O.getItemLabel(U);if(!B)return c;const X=O.getItemDescription(U),Q=h(B,X,z,x),de=$[Q];if(de)return de;const _e=n(B,X,O.getItemPath(U),x,z);return $[Q]=_e,_e}e.scoreItemFuzzy=s;function n(U,x,z,O,$){const B=!z||!O.containsPathSeparator;return z&&(A.isLinux?O.pathNormalized===z:(0,_.equalsIgnoreCase)(O.pathNormalized,z))?{score:o,labelMatch:[{start:0,end:U.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?r(U,x,z,O.values,B,$):a(U,x,z,O,B,$)}function r(U,x,z,O,$,B){let X=0;const Q=[],de=[];for(const _e of O){const{score:ye,labelMatch:ke,descriptionMatch:Be}=a(U,x,z,_e,$,B);if(ye===S)return c;X+=ye,ke&&Q.push(...ke),Be&&de.push(...Be)}return{score:X,labelMatch:p(Q),descriptionMatch:p(de)}}function a(U,x,z,O,$,B){if($||!x){const[X,Q]=i(U,O.normalized,O.normalizedLowercase,B&&!O.expectContiguousMatch);if(X){const de=(0,F.matchesPrefix)(O.normalized,U);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/U.length*100)):_e=t,{score:_e+X,labelMatch:de||u(Q)}}}if(x){let X=x;z&&(X=`${x}${y.sep}`);const Q=X.length,de=`${X}${U}`,[_e,ye]=i(de,O.normalized,O.normalizedLowercase,B&&!O.expectContiguousMatch);if(_e){const ke=u(ye),Be=[],We=[];return ke.forEach(He=>{He.start<Q&&He.end>Q?(Be.push({start:0,end:He.end-Q}),We.push({start:He.start,end:Q})):He.start>=Q?Be.push({start:He.start-Q,end:He.end-Q}):We.push(He)}),{score:_e,labelMatch:Be,descriptionMatch:We}}}return c}function u(U){const x=[];if(!U)return x;let z;for(const O of U)z&&z.end===O?z.end+=1:(z={start:O,end:O+1},x.push(z));return x}function p(U){const x=U.sort(($,B)=>$.start-B.start),z=[];let O;for(const $ of x)!O||!E(O,$)?(O=$,z.push($)):(O.start=Math.min(O.start,$.start),O.end=Math.max(O.end,$.end));return z}function E(U,x){return!(U.end<x.start||x.end<U.start)}function g(U,x,z,O,$,B){const X=s(U,z,O,$,B),Q=s(x,z,O,$,B),de=X.score,_e=Q.score;if((de===o||_e===o)&&de!==_e)return de===o?-1:1;if(de>t||_e>t){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=L(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=$.getItemLabel(U)||"",q=$.getItemLabel(x)||"";if(He.length!==q.length)return He.length-q.length}if(de!==_e)return de>_e?-1:1;const ye=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,ke=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(ye&&!ke)return-1;if(ke&&!ye)return 1;const Be=T(U,X,$),We=T(x,Q,$);return Be&&We&&Be!==We?We>Be?-1:1:M(U,x,z,$)}e.compareItemsByFuzzyScore=g;function T(U,x,z){let O=-1,$=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if($=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const B=z.getItemDescription(U);B&&($+=B.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&($=x.descriptionMatch[x.descriptionMatch.length-1].end);return $-O}function L(U,x){if(!U&&!x||(!U||!U.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!U||!U.length)return 1;const z=U[0].start,$=U[U.length-1].end-z,B=x[0].start,Q=x[x.length-1].end-B;return $===Q?0:Q<$?1:-1}function M(U,x,z,O){const $=O.getItemLabel(U)||"",B=O.getItemLabel(x)||"",X=O.getItemDescription(U),Q=O.getItemDescription(x),de=$.length+(X?X.length:0),_e=B.length+(Q?Q.length:0);if(de!==_e)return de-_e;const ye=O.getItemPath(U),ke=O.getItemPath(x);return ye&&ke&&ye.length!==ke.length?ye.length-ke.length:$!==B?(0,m.compareAnything)($,B,z.normalized):X&&Q&&X!==Q?(0,m.compareAnything)(X,Q,z.normalized):ye&&ke&&ye!==ke?(0,m.compareAnything)(ye,ke,z.normalized):0}function R(U){return U.startsWith('"')&&U.endsWith('"')}const W=" ";function V(U){typeof U!="string"&&(U="");const x=U.toLowerCase(),{pathNormalized:z,normalized:O,normalizedLowercase:$}=N(U),B=z.indexOf(y.sep)>=0,X=R(U);let Q;const de=U.split(W);if(de.length>1)for(const _e of de){const ye=R(_e),{pathNormalized:ke,normalized:Be,normalizedLowercase:We}=N(_e);Be&&(Q||(Q=[]),Q.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:ke,normalized:Be,normalizedLowercase:We,expectContiguousMatch:ye}))}return{original:U,originalLowercase:x,pathNormalized:z,normalized:O,normalizedLowercase:$,values:Q,containsPathSeparator:B,expectContiguousMatch:X}}e.prepareQuery=V;function N(U){let x;A.isWindows?x=U.replace(/\//g,y.sep):x=U.replace(/\\/g,y.sep);const z=(0,_.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:z,normalizedLowercase:z.toLowerCase()}}function j(U){return Array.isArray(U)?V(U.map(x=>x.original).join(W)):V(U.original)}e.pieceToQuery=j}),define(fe[30],me([0,1,17,29,24,8,9]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_;const S="**",P="/",i="[/\\\\]",k="[^/\\\\]",l=/\//g;function f(O){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${i}|${k}+${i}|${i}${k}+)*?`}}function d(O,$){if(!O)return[];const B=[];let X=!1,Q=!1,de="";for(const _e of O){switch(_e){case $:if(!X&&!Q){B.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=_e}return de&&B.push(de),B}e.splitGlobAware=d;function w(O){if(!O)return"";let $="";const B=d(O,P);if(B.every(X=>X===S))$=".*";else{let X=!1;B.forEach((Q,de)=>{if(Q===S){X||($+=f(2),X=!0);return}let _e=!1,ye="",ke=!1,Be="";for(const We of Q){if(We!=="}"&&_e){ye+=We;continue}if(ke&&(We!=="]"||!Be)){let He;We==="-"?He=We:(We==="^"||We==="!")&&!Be?He="^":We===P?He="":He=A.escapeRegExpCharacters(We),Be+=He;continue}switch(We){case"{":_e=!0;continue;case"[":ke=!0;continue;case"}":$+=`(?:${d(ye,",").map(ee=>w(ee)).join("|")})`,_e=!1,ye="";break;case"]":$+="["+Be+"]",ke=!1,Be="";break;case"?":$+=k;continue;case"*":$+=f(1);continue;default:$+=A.escapeRegExpCharacters(We)}}de<B.length-1&&(B[de+1]!==S||de+2<B.length)&&($+=i),X=!1})}return $}const D=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),h=function(){return!1},s=function(){return null};function n(O,$){if(!O)return s;let B;typeof O!="string"?B=O.pattern:B=O,B=B.trim();const X=`${B}_${!!$.trimForExclusions}`;let Q=t.get(X);if(Q)return r(Q,O);let de;if(D.test(B)){const _e=B.substr(4);Q=function(ye,ke){return typeof ye=="string"&&ye.endsWith(_e)?B:null}}else(de=I.exec(a(B,$)))?Q=u(de[1],B):($.trimForExclusions?c:b).test(B)?Q=p(B,$):(de=o.exec(a(B,$)))?Q=E(de[1].substr(1),B,!0):(de=v.exec(a(B,$)))?Q=E(de[1],B,!1):Q=g(B);return t.set(X,Q),r(Q,O)}function r(O,$){return typeof $=="string"?O:function(B,X){return F.isEqualOrParent(B,$.base)?O(y.relative($.base,B),X):null}}function a(O,$){return $.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function u(O,$){const B=`/${O}`,X=`\\${O}`,Q=function(_e,ye){return typeof _e!="string"?null:ye?ye===O?$:null:_e===O||_e.endsWith(B)||_e.endsWith(X)?$:null},de=[O];return Q.basenames=de,Q.patterns=[$],Q.allBasenames=de,Q}function p(O,$){const B=z(O.slice(1,-1).split(",").map(ye=>n(ye,$)).filter(ye=>ye!==s),O),X=B.length;if(!X)return s;if(X===1)return B[0];const Q=function(ye,ke){for(let Be=0,We=B.length;Be<We;Be++)if(B[Be](ye,ke))return O;return null},de=B.find(ye=>!!ye.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=B.reduce((ye,ke)=>ke.allPaths?ye.concat(ke.allPaths):ye,[]);return _e.length&&(Q.allPaths=_e),Q}function E(O,$,B){const X=y.sep===y.posix.sep,Q=X?O:O.replace(l,y.sep),de=y.sep+Q,_e=y.posix.sep+O,ye=B?function(ke,Be){return typeof ke=="string"&&(ke===Q||ke.endsWith(de)||!X&&(ke===O||ke.endsWith(_e)))?$:null}:function(ke,Be){return typeof ke=="string"&&(ke===Q||!X&&ke===O)?$:null};return ye.allPaths=[(B?"*/":"./")+O],ye}function g(O){try{const $=new RegExp(`^${w(O)}$`);return function(B){return $.lastIndex=0,typeof B=="string"&&$.test(B)?O:null}}catch($){return s}}function T(O,$,B){return!O||typeof $!="string"?!1:L(O)($,void 0,B)}e.match=T;function L(O,$={}){if(!O)return h;if(typeof O=="string"||V(O)){const B=n(O,$);if(B===s)return h;const X=function(Q,de){return!!B(Q,de)};return B.allBasenames&&(X.allBasenames=B.allBasenames),B.allPaths&&(X.allPaths=B.allPaths),X}return U(O,$)}e.parse=L;function M(O){if(!O)return;let $;return B=>($||($=(O()||Promise.resolve([])).then(X=>X?W(X):{})),$.then(X=>!!X[B]))}e.hasSiblingPromiseFn=M;function R(O){if(!O)return;let $;return B=>{if(!$){const X=O();$=X?W(X):{}}return!!$[B]}}e.hasSiblingFn=R;function W(O){const $={};for(const B of O)$[B]=!0;return $}function V(O){const $=O;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=V;function N(O){return O.allBasenames||[]}e.getBasenameTerms=N;function j(O){return O.allPaths||[]}e.getPathTerms=j;function U(O,$){const B=z(Object.getOwnPropertyNames(O).map(ye=>x(ye,O[ye],$)).filter(ye=>ye!==s)),X=B.length;if(!X)return s;if(!B.some(ye=>!!ye.requiresSiblings)){if(X===1)return B[0];const ye=function(We,He){for(let q=0,ee=B.length;q<ee;q++){const re=B[q](We,He);if(re)return re}return null},ke=B.find(We=>!!We.allBasenames);ke&&(ye.allBasenames=ke.allBasenames);const Be=B.reduce((We,He)=>He.allPaths?We.concat(He.allPaths):We,[]);return Be.length&&(ye.allPaths=Be),ye}const Q=function(ye,ke,Be){let We;for(let He=0,q=B.length;He<q;He++){const ee=B[He];ee.requiresSiblings&&Be&&(ke||(ke=y.basename(ye)),We||(We=ke.substr(0,ke.length-y.extname(ye).length)));const re=ee(ye,ke,We,Be);if(re)return re}return null},de=B.find(ye=>!!ye.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=B.reduce((ye,ke)=>ke.allPaths?ye.concat(ke.allPaths):ye,[]);return _e.length&&(Q.allPaths=_e),Q}function x(O,$,B){if($===!1)return s;const X=n(O,B);if(X===s)return s;if(typeof $=="boolean")return X;if($){const Q=$.when;if(typeof Q=="string"){const de=(_e,ye,ke,Be)=>{if(!Be||!X(_e,ye))return null;const We=Q.replace("$(basename)",ke),He=Be(We);return(0,m.isThenable)(He)?He.then(q=>q?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function z(O,$){const B=O.filter(ye=>!!ye.basenames);if(B.length<2)return O;const X=B.reduce((ye,ke)=>{const Be=ke.basenames;return Be?ye.concat(Be):ye},[]);let Q;if($){Q=[];for(let ye=0,ke=X.length;ye<ke;ye++)Q.push($)}else Q=B.reduce((ye,ke)=>{const Be=ke.patterns;return Be?ye.concat(Be):ye},[]);const de=function(ye,ke){if(typeof ye!="string")return null;if(!ke){let We;for(We=ye.length;We>0;We--){const He=ye.charCodeAt(We-1);if(He===47||He===92)break}ke=ye.substr(We)}const Be=X.indexOf(ke);return Be!==-1?Q[Be]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const _e=O.filter(ye=>!ye.basenames);return _e.push(de),_e}}),define(fe[80],me([0,1,29,10,8,11,23,9,2]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(n,r,a){if(typeof n=="string"&&(n=S.URI.file(n)),a){const p=a.getWorkspaceFolder(n);if(p){const E=a.getWorkspace().folders.length>1;let g;if((0,A.isEqual)(p.uri,n)?g="":g=(0,A.relativePath)(p.uri,n),E){const T=p.name?p.name:(0,A.basename)(p.uri);g=g?T+" \u2022 "+g:T}return g}}if(n.scheme!==F.Schemas.file&&n.scheme!==F.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(n.fsPath))return(0,C.normalize)(k(n.fsPath));let u=(0,C.normalize)(n.fsPath);return!y.isWindows&&r?.userHome&&(u=f(u,r.userHome.fsPath)),u}e.getPathLabel=P;function i(n){if(!n)return;typeof n=="string"&&(n=S.URI.file(n));const r=(0,A.basename)(n)||(n.scheme===F.Schemas.file?n.fsPath:n.path);return y.isWindows&&(0,m.isRootOrDriveLetter)(r)?k(r):r}e.getBaseLabel=i;function k(n){return(0,m.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=k;let l=Object.create(null);function f(n,r){if(y.isWindows||!n||!r)return n;let a=l.original===r?l.normalized:void 0;return a||(a=`${(0,_.rtrim)(r,C.posix.sep)}${C.posix.sep}`,l={original:r,normalized:a}),(y.isLinux?n.startsWith(a):(0,_.startsWithIgnoreCase)(n,a))&&(n=`~/${n.substr(a.length)}`),n}e.tildify=f;function d(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=d;const w="\u2026",D="\\\\",I="~";function b(n,r=C.sep){const a=new Array(n.length);let u=!1;for(let p=0;p<n.length;p++){let E=n[p];if(E===""){a[p]=`.${r}`;continue}if(!E){a[p]=E;continue}u=!0;let g="";E.indexOf(D)===0?(g=E.substr(0,E.indexOf(D)+D.length),E=E.substr(E.indexOf(D)+D.length)):E.indexOf(r)===0?(g=E.substr(0,E.indexOf(r)+r.length),E=E.substr(E.indexOf(r)+r.length)):E.indexOf(I)===0&&(g=E.substr(0,E.indexOf(I)+I.length),E=E.substr(E.indexOf(I)+I.length));const T=E.split(r);for(let L=1;u&&L<=T.length;L++)for(let M=T.length-L;u&&M>=0;M--){u=!1;let R=T.slice(M,M+L).join(r);for(let W=0;!u&&W<n.length;W++)if(W!==p&&n[W]&&n[W].indexOf(R)>-1){const V=M+L===T.length,N=M>0&&n[W].indexOf(r)>-1?r+R:R,j=n[W].endsWith(N);u=!V||j}if(!u){let W="";(T[0].endsWith(":")||g!=="")&&(M===1&&(M=0,L++,R=T[0]+r+R),M>0&&(W=T[0]+r),W=g+W),M>0&&(W=W+w+r),W=W+R,M+L<T.length&&(W=W+r+w),a[p]=W}}u&&(a[p]=E)}return a}e.shorten=b;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function o(n,r=Object.create(null)){const a=[];let u=!1,p="";for(const E of n)if(E==="$"||u&&E==="{")p&&a.push({value:p,type:c.TEXT}),p="",u=!0;else if(E==="}"&&u){const g=r[p];if(typeof g=="string")g.length&&a.push({value:g,type:c.VARIABLE});else if(g){const T=a[a.length-1];(!T||T.type!==c.SEPARATOR)&&a.push({value:g.label,type:c.SEPARATOR})}p="",u=!1}else p+=E;return p&&!u&&a.push({value:p,type:c.TEXT}),a.filter((E,g)=>{if(E.type===c.SEPARATOR){const T=a[g-1],L=a[g+1];return[T,L].every(M=>M&&(M.type===c.VARIABLE||M.type===c.TEXT)&&M.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=o;function v(n,r){return y.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(n,r){return y.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):y.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function h(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=h;function s(n){const r=n.indexOf("/")!==-1?C.posix:C.win32,a=r.basename(n),u=r.dirname(n);return a.length?{name:a,parentPath:u}:{name:u,parentPath:""}}e.splitName=s}),define(fe[103],me([0,1,30,10,8,23,9]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var _;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(_=e.Mimes||(e.Mimes={}));let S=[],P=[],i=[];function k(n,r=!1){const a=l(n);S.push(a),a.userConfigured?i.push(a):P.push(a),r&&!a.userConfigured&&S.forEach(u=>{u.mime===a.mime||u.userConfigured||(a.extension&&u.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&u.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&u.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&u.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=k;function l(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,m.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(C.posix.sep)>=0:!1}}function f(n){n?(S=S.filter(r=>!r.userConfigured),i=[]):(S=[],P=[],i=[])}e.clearTextMimes=f;function d(n,r){let a;if(n)switch(n.scheme){case F.Schemas.file:a=n.fsPath;break;case F.Schemas.data:a=y.DataUri.parseMetaData(n).get(y.DataUri.META_DATA_LABEL);break;default:a=n.path}if(!a)return[_.unknown];a=a.toLowerCase();const u=(0,C.basename)(a),p=w(a,u,i);if(p)return[p,_.text];const E=w(a,u,P);if(E)return[E,_.text];if(r){const g=D(r);if(g)return[g,_.text]}return[_.unknown]}e.guessMimeTypes=d;function w(n,r,a){let u=null,p=null,E=null;for(let g=a.length-1;g>=0;g--){const T=a[g];if(r===T.filenameLowercase){u=T;break}if(T.filepattern&&(!p||T.filepattern.length>p.filepattern.length)){const L=T.filepatternOnPath?n:r;T.filepatternLowercase?.(L)&&(p=T)}T.extension&&(!E||T.extension.length>E.extension.length)&&r.endsWith(T.extensionLowercase)&&(E=T)}return u?u.mime:p?p.mime:E?E.mime:null}function D(n){if((0,A.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let r=S.length-1;r>=0;r--){const a=S[r];if(!a.firstline)continue;const u=n.match(a.firstline);if(u&&u.length>0)return a.mime}return null}function I(n){return n?typeof n=="string"?n===_.binary||n===_.text||n===_.unknown:n.length===1&&I(n[0]):!0}e.isUnspecific=I;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(n){const r=(0,C.extname)(n),a=b[r.toLowerCase()];return a!==void 0?a:v(n)}e.getMediaOrTextMime=o;function v(n){const r=(0,C.extname)(n);return c[r.toLowerCase()]}e.getMediaMime=v;function t(n){for(const r in c)if(c[r]===n)return r}e.getExtensionForMimeType=t;const h=/^(.+)\/(.+?)(;.+)?$/;function s(n,r){const a=h.exec(n);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:r?void 0:n}e.normalizeMimeType=s}),define(fe[104],me([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(i){return i.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const l=this._uriTransformer.transformIncoming(k);return l===k?k:F(m.URI.from(l))}transformOutgoing(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:F(m.URI.from(l))}transformOutgoingURI(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:m.URI.from(l)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function y(i,k,l){if(!i||l>200)return null;if(typeof i=="object"){if(i instanceof m.URI)return k.transformOutgoing(i);for(let f in i)if(Object.hasOwnProperty.call(i,f)){const d=y(i[f],k,l+1);d!==null&&(i[f]=d)}}return null}function A(i,k){const l=y(i,k,0);return l===null?i:l}e.transformOutgoingURIs=A;function _(i,k,l,f){if(!i||f>200)return null;if(typeof i=="object"){if(i.$mid===1)return l?m.URI.revive(k.transformIncoming(i)):k.transformIncoming(i);for(let d in i)if(Object.hasOwnProperty.call(i,d)){const w=_(i[d],k,l,f+1);w!==null&&(i[d]=w)}}return null}function S(i,k){const l=_(i,k,!1,0);return l===null?i:l}e.transformIncomingURIs=S;function P(i,k){const l=_(i,k,!0,0);return l===null?i:l}e.transformAndReviveIncomingURIs=P}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return m.test(S)}e.isUUID=F;const C=new Uint8Array(16),y=[];for(let S=0;S<256;S++)y.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let P=0;P<S.length;P++)S[P]=Math.floor(Math.random()*256);return S};function _(){A(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let S=0,P="";return P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P}e.generateUuid=_}),define(fe[144],me([0,1,105]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class F{constructor(y="utf8"){this.stringDecoder=new m.StringDecoder(y),this.remaining=null}write(y){const A=[],_=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(_.length<1)return A;let S=0,P,i=S;for(;i<_.length;)if(P=_.charCodeAt(i),P===13||P===10){if(A.push(_.substring(S,i)),i++,i<_.length){const k=P;P=_.charCodeAt(i),(k===13&&P===10||k===10&&P===13)&&i++}S=i}else i++;return this.remaining=S<_.length?_.substr(S):null,A}end(){return this.remaining}}e.LineDecoder=F}),define(fe[28],me([0,1,50,81,292,17,29,79,8,11,23,2,32]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function d(N,j=f.UNLINK){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return j===f.UNLINK?D(N):w(N)}async function w(N){try{const j=(0,S.join)((0,F.tmpdir)(),(0,l.generateUuid)());try{await e.Promises.rename(N,j)}catch(U){return D(N)}D(j).catch(U=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function D(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function I(N){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(N,{recursive:!0})}e.rimrafSync=I;async function b(N,j){return v(await(j?c(N):(0,C.promisify)(m.readdir)(N)))}async function c(N){try{return await(0,C.promisify)(m.readdir)(N,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const j=[],U=await b(N);for(const x of U){let z=!1,O=!1,$=!1;try{const B=await e.Promises.lstat((0,S.join)(N,x));z=B.isFile(),O=B.isDirectory(),$=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}j.push({name:x,isFile:()=>z,isDirectory:()=>O,isSymbolicLink:()=>$})}return j}function o(N){return v(m.readdirSync(N))}e.readdirSync=o;function v(N){return N.map(j=>typeof j=="string"?P.isMacintosh?(0,_.normalizeNFC)(j):j:(j.name=P.isMacintosh?(0,_.normalizeNFC)(j.name):j.name,j))}async function t(N){const j=await b(N),U=[];for(const x of j)await s.existsDirectory((0,S.join)(N,x))&&U.push(x);return U}function h(N,j=1e3){return new Promise(U=>{let x=!1;const z=setInterval(()=>{x||(x=!0,m.access(N,O=>{x=!1,O&&(clearInterval(z),U(void 0))}))},j)})}e.whenDeleted=h;var s;(function(N){async function j(z){let O;try{if(O=await e.Promises.lstat(z),!O.isSymbolicLink())return{stat:O}}catch($){}try{return{stat:await e.Promises.stat(z),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(P.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw B}throw $}}N.stat=j;async function U(z){try{const{stat:O,symbolicLink:$}=await N.stat(z);return O.isFile()&&$?.dangling!==!0}catch(O){}return!1}N.existsFile=U;async function x(z){try{const{stat:O,symbolicLink:$}=await N.stat(z);return O.isDirectory()&&$?.dangling!==!0}catch(O){}return!1}N.existsDirectory=x})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new y.ResourceQueue;function r(N,j,U){return n.queueFor(k.URI.file(N),i.extUriBiasedIgnorePathCase).queue(()=>{const x=E(U);return new Promise((z,O)=>u(N,j,x,$=>$?O($):z()))})}let a=!0;function u(N,j,U,x){if(!a)return m.writeFile(N,j,{mode:U.mode,flag:U.flag},x);m.open(N,U.flag,U.mode,(z,O)=>{if(z)return x(z);m.writeFile(O,j,$=>{if($)return m.close(O,()=>x($));m.fdatasync(O,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),a=!1),m.close(O,X=>x(X))))})})}function p(N,j,U){const x=E(U);if(!a)return m.writeFileSync(N,j,{mode:x.mode,flag:x.flag});const z=m.openSync(N,x.flag,x.mode);try{m.writeFileSync(z,j);try{m.fdatasyncSync(z)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),a=!1}}finally{m.closeSync(z)}}e.writeFileSync=p;function E(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function g(N,j){if(N===j)return;async function U(x){try{const z=await e.Promises.lstat(x);if(z.isDirectory()||z.isSymbolicLink())return;await e.Promises.utimes(x,z.atime,new Date)}catch(z){}}try{await e.Promises.rename(N,j),await U(j)}catch(x){if(N.toLowerCase()!==j.toLowerCase()&&x.code==="EXDEV"||N.endsWith("."))await T(N,j,{preserveSymlinks:!1}),await d(N,f.MOVE),await U(j);else throw x}}async function T(N,j,U){return M(N,j,{root:{source:N,target:j},options:U,handledSourcePaths:new Set})}const L=511;async function M(N,j,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:x,symbolicLink:z}=await s.stat(N);if(z){if(U.options.preserveSymlinks)try{return await V(N,j,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(z.dangling)return}return x.isDirectory()?R(N,j,x.mode&L,U):W(N,j,x.mode&L)}async function R(N,j,U,x){await e.Promises.mkdir(j,{recursive:!0,mode:U});const z=await b(N);for(const O of z)await M((0,S.join)(N,O),(0,S.join)(j,O),x)}async function W(N,j,U){await e.Promises.copyFile(N,j),await e.Promises.chmod(j,U)}async function V(N,j,U){let x=await e.Promises.readlink(N);(0,A.isEqualOrParent)(x,U.root.source,!P.isLinux)&&(x=(0,S.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,j)}e.Promises=new class{get access(){return(0,C.promisify)(m.access)}get stat(){return(0,C.promisify)(m.stat)}get lstat(){return(0,C.promisify)(m.lstat)}get utimes(){return(0,C.promisify)(m.utimes)}get read(){return(0,C.promisify)(m.read)}get readFile(){return(0,C.promisify)(m.readFile)}get write(){return(0,C.promisify)(m.write)}get appendFile(){return(0,C.promisify)(m.appendFile)}get fdatasync(){return(0,C.promisify)(m.fdatasync)}get truncate(){return(0,C.promisify)(m.truncate)}get rename(){return(0,C.promisify)(m.rename)}get copyFile(){return(0,C.promisify)(m.copyFile)}get open(){return(0,C.promisify)(m.open)}get close(){return(0,C.promisify)(m.close)}get symlink(){return(0,C.promisify)(m.symlink)}get readlink(){return(0,C.promisify)(m.readlink)}get chmod(){return(0,C.promisify)(m.chmod)}get mkdir(){return(0,C.promisify)(m.mkdir)}get unlink(){return(0,C.promisify)(m.unlink)}get rmdir(){return(0,C.promisify)(m.rmdir)}get realpath(){return(0,C.promisify)(m.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return r}get rm(){return d}get move(){return g}get copy(){return T}}}),define(fe[106],me([0,1,50,8,9,28]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const k=(0,F.dirname)(i);if(i===k)return i;const l=((0,F.basename)(i)||i).toLowerCase();try{const d=(0,y.readdirSync)(k).filter(w=>w.toLowerCase()===l);if(d.length===1){const w=A(k);if(w)return(0,F.join)(w,d[0])}else if(d.length>1){const w=d.indexOf(l);if(w>=0){const D=A(k);if(D)return(0,F.join)(D,d[w])}}}catch(f){}return null}e.realcaseSync=A;async function _(i){try{return await y.Promises.realpath(i)}catch(k){const l=P(i);return await y.Promises.access(l,m.constants.R_OK),l}}e.realpath=_;function S(i){try{return m.realpathSync(i)}catch(k){const l=P(i);return m.accessSync(l,m.constants.R_OK),l}}e.realpathSync=S;function P(i){return(0,C.rtrim)((0,F.normalize)(i),F.sep)}});var Ve=this&&this.__decorate||function(Y,e,m,F){var C=arguments.length,y=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,m):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Y,e,m,F);else for(var _=Y.length-1;_>=0;_--)(A=Y[_])&&(y=(C<3?A(y):C>3?A(e,m,y):A(e,m))||y);return C>3&&y&&Object.defineProperty(e,m,y),y};define(fe[107],me([0,1,16,17,22,21,60,18,3,6,62,9,12]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function d(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function D(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(I||(I={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const $=this.buffer.slice(this.pos,this.pos+O);return this.pos+=$.byteLength,$}}class c{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function v(z){const O=C.VSBuffer.alloc(4);return O.writeUInt32BE(z,0),O}function t(z){return z.read(4).readUInt32BE(0)}function h(z){const O=C.VSBuffer.alloc(1);return O.writeUInt8(z,0),O}const s={Undefined:h(o.Undefined),String:h(o.String),Buffer:h(o.Buffer),VSBuffer:h(o.VSBuffer),Array:h(o.Array),Object:h(o.Object)},n=typeof Buffer!="undefined";function r(z,O){if(typeof O=="undefined")z.write(s.Undefined);else if(typeof O=="string"){const $=C.VSBuffer.fromString(O);z.write(s.String),z.write(v($.byteLength)),z.write($)}else if(n&&Buffer.isBuffer(O)){const $=C.VSBuffer.wrap(O);z.write(s.Buffer),z.write(v($.byteLength)),z.write($)}else if(O instanceof C.VSBuffer)z.write(s.VSBuffer),z.write(v(O.byteLength)),z.write(O);else if(Array.isArray(O)){z.write(s.Array),z.write(v(O.length));for(const $ of O)r(z,$)}else{const $=C.VSBuffer.fromString(JSON.stringify(O));z.write(s.Object),z.write(v($.byteLength)),z.write($)}}function a(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(t(z)).toString();case o.Buffer:return z.read(t(z)).buffer;case o.VSBuffer:return z.read(t(z));case o.Array:{const $=t(z),B=[];for(let X=0;X<$;X++)B.push(a(z));return B}case o.Object:return JSON.parse(z.read(t(z)).toString())}}class u{constructor(O,$,B=null,X=1e3){this.protocol=O,this.ctx=$,this.logger=B,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,$){this.channels.set(O,$),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const $=this.send([O.type]);this.logger&&this.logger.logOutgoing($,0,1,D(O.type));return}case 201:case 202:case 204:case 203:{const $=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing($,O.id,1,D(O.type),O.data);return}}}send(O,$=void 0){const B=new c;return r(B,O),r(B,$),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onRawMessage(O){const $=new b(O),B=a($),X=a($),Q=B[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${d(Q)}: ${B[2]}.${B[3]}`,X),this.onPromise({type:Q,id:B[1],channelName:B[2],name:B[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${d(Q)}: ${B[2]}.${B[3]}`,X),this.onEventListen({type:Q,id:B[1],channelName:B[2],name:B[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]})}}onPromise(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const B=new y.CancellationTokenSource;let X;try{X=$.call(this.ctx,O.name,O.arg,B.token)}catch(_e){X=Promise.reject(_e)}const Q=O.id;X.then(_e=>{this.sendResponse({id:Q,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Q,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,P.toDisposable)(()=>B.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const B=O.id,Q=$.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:B,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const $=this.activeRequests.get(O.id);$&&($.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let $=this.pendingRequests.get(O.channelName);$||($=[],this.pendingRequests.set(O.channelName,$));const B=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:O,timeoutTimer:B})}flushPendingRequests(O){const $=this.pendingRequests.get(O);if($){for(const B of $)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var p;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(O,$=null){this.protocol=O,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=$}getChannel(O){const $=this;return{call(B,X,Q){return $.isDisposed?Promise.reject(_.canceled()):$.requestPromise(O,B,X,Q)},listen(B,X){return $.isDisposed?Promise.reject(_.canceled()):$.requestEvent(O,B,X)}}}requestPromise(O,$,B,X=y.CancellationToken.None){const Q=this.lastRequestId++,_e={id:Q,type:100,channelName:O,name:$,arg:B};if(X.isCancellationRequested)return Promise.reject(_.canceled());let ye;return new Promise((Be,We)=>{if(X.isCancellationRequested)return We(_.canceled());const He=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),Be(Z.data);break;case 202:this.handlers.delete(Q);const ae=new Error(Z.data.message);ae.stack=Z.data.stack,ae.name=Z.data.name,We(ae);break;case 203:this.handlers.delete(Q),We(Z.data);break}};this.handlers.set(Q,le),this.sendRequest(_e)};let q=null;this.state===I.Idle?He():(q=(0,F.createCancelablePromise)(le=>this.whenInitialized()),q.then(()=>{q=null,He()}));const ee=()=>{q?(q.cancel(),q=null):this.sendRequest({id:Q,type:101}),We(_.canceled())},re=X.onCancellationRequested(ee);ye=(0,P.combinedDisposable)((0,P.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(O,$,B){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:$,arg:B};let _e=null;const ye=new S.Emitter({onFirstListenerAdd:()=>{_e=(0,F.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:X,type:103}))}}),ke=Be=>ye.fire(Be.data);return this.handlers.set(X,ke),ye.event}sendRequest(O){switch(O.type){case 100:case 102:{const $=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing($,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const $=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing($,O.id,0,d(O.type));return}}}send(O,$=void 0){const B=new c;return r(B,O),r(B,$),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onBuffer(O){const $=new b(O),B=a($),X=a($),Q=B[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,D(Q)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],0,D(Q),X),this.onResponse({type:B[0],id:B[1],data:X})}}onResponse(O){if(O.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(O.id);$&&$(O)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([A.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class g{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:$,onDidClientDisconnect:B})=>{S.Event.once($.onMessage)(Q=>{const de=new b(Q),_e=a(de),ye=new u($,_e),ke=new E($);this.channels.forEach((We,He)=>ye.registerChannel(He,We));const Be={channelServer:ye,channelClient:ke,ctx:_e};this._connections.add(Be),this._onDidAddConnection.fire(Be),B(()=>{ye.dispose(),ke.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach($=>O.push($)),O}getChannel(O,$){const B=this;return{call(X,Q,de){let _e;if((0,l.isFunction)($)){let ke=(0,m.getRandomElement)(B.connections.filter($));_e=ke?Promise.resolve(ke):S.Event.toPromise(S.Event.filter(B.onDidAddConnection,$))}else _e=$.routeCall(B,X,Q);const ye=_e.then(ke=>ke.channelClient.getChannel(O));return L(ye).call(X,Q,de)},listen(X,Q){if((0,l.isFunction)($))return B.getMulticastEvent(O,$,X,Q);const de=$.routeEvent(B,X,Q).then(_e=>_e.channelClient.getChannel(O));return L(de).listen(X,Q)}}}getMulticastEvent(O,$,B,X){const Q=this;let de=new P.DisposableStore;const _e=new S.Emitter({onFirstListenerAdd:()=>{de=new P.DisposableStore;const ye=new S.EventMultiplexer,ke=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(B,X),re=ye.add(ee);ke.set(He,re)},We=He=>{const q=ke.get(He);!q||(q.dispose(),ke.delete(He))};Q.connections.filter($).forEach(Be),S.Event.filter(Q.onDidAddConnection,$)(Be,void 0,de),Q.onDidRemoveConnection(We,void 0,de),ye.event(_e.fire,_e,de),de.add(ye)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,$){this.channels.set(O,$),this._connections.forEach(B=>{B.channelServer.registerChannel(O,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class T{constructor(O,$,B=null){const X=new c;r(X,$),O.send(X.buffer),this.channelClient=new E(O,B),this.channelServer=new u(O,$,B)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,$){this.channelServer.registerChannel(O,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(z){return{call(O,$,B){return z.then(X=>X.call(O,$,B))},listen(O,$){const B=new S.Relay;return z.then(X=>B.input=X.listen(O,$)),B.event}}}e.getDelayedChannel=L;function M(z){let O=!1;return{call($,B,X){return O?z.call($,B,X):(0,F.timeout)(0).then(()=>O=!0).then(()=>z.call($,B,X))},listen($,B){if(O)return z.listen($,B);const X=new S.Relay;return(0,F.timeout)(0).then(()=>O=!0).then(()=>X.input=z.listen($,B)),X.event}}}e.getNextTickChannel=M;class R{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const $ of O.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await S.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=R;var W;(function(z){function O(Q,de){const _e=Q,ye=de&&de.disableMarshalling,ke=new Map;for(const Be in _e)B(Be)&&ke.set(Be,S.Event.buffer(_e[Be],!0));return new class{listen(Be,We,He){const q=ke.get(We);if(q)return q;if(X(We)){const ee=_e[We];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${We}`)}call(Be,We,He){const q=_e[We];if(typeof q=="function"){if(!ye&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return q.apply(_e,He)}throw new Error(`Method not found: ${We}`)}}}z.fromService=O;function $(Q,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(ye,ke){if(typeof ke=="string")return de?.properties?.has(ke)?de.properties.get(ke):X(ke)?function(Be){return Q.listen(ke,Be)}:B(ke)?Q.listen(ke):async function(...Be){let We;de&&!(0,l.isUndefinedOrNull)(de.context)?We=[de.context,...Be]:We=Be;const He=await Q.call(ke,We);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(ke)}`)}})}z.toService=$;function B(Q){return Q[0]==="o"&&Q[1]==="n"&&k.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&k.isUpperAsciiLetter(Q.charCodeAt(9))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let O=z.toString();if(O!=="[object Object]")return O}return z}function j(z){return Array.isArray(z)?z.map(N):N(z)}function U(z,O,$,B,X,Q,de){de=j(de);const _e=V[X],ye=_e[B%_e.length];let ke=[`%c[${z}]%c[${String(O).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(Q)?(ke=ke.concat(de),ke.push(")")):ke.push(de),console.log.apply(console,ke)}e.logWithColors=U;class x{constructor(O,$){this._outgoingPrefix=O,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,$,B,X,Q){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,$,B,X,Q)}logIncoming(O,$,B,X,Q){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,$,B,X,Q)}}e.IPCLogger=x}),define(fe[108],me([0,1,22,3,6,11,38,107]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function i(){return P||(P=m.VSBuffer.alloc(0)),P}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,r){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return r&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}let a=m.VSBuffer.alloc(n),u=0,p=0;for(;n>0;){const E=this._chunks[p];if(E.byteLength>n){const g=E.slice(0,n);a.set(g,u),u+=n,r&&(this._chunks[p]=E.slice(n),this._totalLength-=n),n-=n}else a.set(E,u),u+=E.byteLength,r?(this._chunks.shift(),this._totalLength-=E.byteLength):p++,n-=E.byteLength}return a}}e.ChunkStream=k;var l;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(n,r,a,u){this.type=n,this.id=r,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends C.Disposable{constructor(n){super();this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const a=this._state.messageType,u=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(a,u,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=m.VSBuffer.alloc(13);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this._writeSoon(r,n.data)}_bufferAdd(n,r){const a=this._totalLength===0;return this._data.push(n,r),this._totalLength+=n.byteLength+r.byteLength,a}_bufferTake(){const n=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,r){this._bufferAdd(n,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends C.Disposable{constructor(n){super();this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new d(1,0,0,n))}}e.Protocol=I;class b extends _.IPCClient{constructor(n,r,a=null){super(n,r,a);this.protocol=n}static fromSocket(n,r){return new b(new I(n),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class o{constructor(n){this.data=n,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],r=0,a=this._first;for(;a;)n[r++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const r=new o(n);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let r=0;r<t._HISTORY_LENGTH;r++)this.lastRuns[r]=n-1e3*r;setInterval(()=>{for(let r=t._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),r=(1+t._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<t._HISTORY_LENGTH;u++)n-this.lastRuns[u]<=r&&a++;return 1-a/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class h{constructor(n,r=null,a=t.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new d(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const r=new d(4,0,0,i());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,r){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let r=0,a=n.length;r<a;r++)this._socketWriter.write(n[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const r=this._outgoingUnackMsg.toArray();for(let a=0,u=r.length;a<u;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new d(1,r,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const r=new d(2,0,0,n);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),r=Date.now()-n.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new d(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=h}),define(fe[109],me([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(_){let S=(0,m.toUint8)(_);this._defaultValue=S,this._asciiMap=F._createAsciiMap(S),this._map=new Map}static _createAsciiMap(_){let S=new Uint8Array(256);for(let P=0;P<256;P++)S[P]=_;return S}set(_,S){let P=(0,m.toUint8)(S);_>=0&&_<256?this._asciiMap[_]=P:this._map.set(_,P)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}}e.CharacterClassifier=F;var C;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(C||(C={}));class y{constructor(){this._actual=new F(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}}e.CharacterSet=y}),define(fe[145],me([0,1,109]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends m.CharacterClassifier{constructor(_){super(0);for(let S=0,P=_.length;S<P;S++)this.set(_.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function y(A){let _={};return S=>(_.hasOwnProperty(S)||(_[S]=A(S)),_[S])}e.getMapForWordSeparators=y(A=>new C(A))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(C,y){this.lineNumber=C,this.column=y}with(C=this.lineNumber,y=this.column){return C===this.lineNumber&&y===this.column?this:new m(C,y)}delta(C=0,y=0){return this.with(this.lineNumber+C,this.column+y)}equals(C){return m.equals(this,C)}static equals(C,y){return!C&&!y?!0:!!C&&!!y&&C.lineNumber===y.lineNumber&&C.column===y.column}isBefore(C){return m.isBefore(this,C)}static isBefore(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<y.column}isBeforeOrEqual(C){return m.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<=y.column}static compare(C,y){let A=C.lineNumber|0,_=y.lineNumber|0;if(A===_){let S=C.column|0,P=y.column|0;return S-P}return A-_}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new m(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=m}),define(fe[42],me([0,1,51]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(y,A,_,S){y>_||y===_&&A>S?(this.startLineNumber=_,this.startColumn=S,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=_,this.endColumn=S)}isEmpty(){return F.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return F.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return F.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return F.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return F.plusRange(this,y)}static plusRange(y,A){let _,S,P,i;return A.startLineNumber<y.startLineNumber?(_=A.startLineNumber,S=A.startColumn):A.startLineNumber===y.startLineNumber?(_=A.startLineNumber,S=Math.min(A.startColumn,y.startColumn)):(_=y.startLineNumber,S=y.startColumn),A.endLineNumber>y.endLineNumber?(P=A.endLineNumber,i=A.endColumn):A.endLineNumber===y.endLineNumber?(P=A.endLineNumber,i=Math.max(A.endColumn,y.endColumn)):(P=y.endLineNumber,i=y.endColumn),new F(_,S,P,i)}intersectRanges(y){return F.intersectRanges(this,y)}static intersectRanges(y,A){let _=y.startLineNumber,S=y.startColumn,P=y.endLineNumber,i=y.endColumn,k=A.startLineNumber,l=A.startColumn,f=A.endLineNumber,d=A.endColumn;return _<k?(_=k,S=l):_===k&&(S=Math.max(S,l)),P>f?(P=f,i=d):P===f&&(i=Math.min(i,d)),_>P||_===P&&S>i?null:new F(_,S,P,i)}equalsRange(y){return F.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(y){return new m.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(y){return new m.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new F(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new F(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(y){return new F(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new F(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new F(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const P=y.startLineNumber|0,i=A.startLineNumber|0;if(P===i){const k=y.startColumn|0,l=A.startColumn|0;if(k===l){const f=y.endLineNumber|0,d=A.endLineNumber|0;if(f===d){const w=y.endColumn|0,D=A.endColumn|0;return w-D}return f-d}return k-l}return P-i}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=F}),define(fe[146],me([0,1,51,42]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class y extends F.Range{constructor(_,S,P,i){super(_,S,P,i);this.selectionStartLineNumber=_,this.selectionStartColumn=S,this.positionLineNumber=P,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return y.selectionsEqual(this,_)}static selectionsEqual(_,S){return _.selectionStartLineNumber===S.selectionStartLineNumber&&_.selectionStartColumn===S.selectionStartColumn&&_.positionLineNumber===S.positionLineNumber&&_.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,S){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,_,S):new y(_,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(_,S){return this.getDirection()===0?new y(_,S,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,_,S)}static fromPositions(_,S=_){return new y(_.lineNumber,_.column,S.lineNumber,S.column)}static liftSelection(_){return new y(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,S){if(_&&!S||!_&&S)return!1;if(!_&&!S)return!0;if(_.length!==S.length)return!1;for(let P=0,i=_.length;P<i;P++)if(!this.selectionsEqual(_[P],S[P]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,S,P,i,k){return k===0?new y(_,S,P,i):new y(P,i,_,S)}}e.Selection=y}),define(fe[110],me([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPair=e.IndentGuide=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(I){I[I.Left=1]="Left",I[I.Center=2]="Center",I[I.Right=4]="Right",I[I.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(I){I[I.Inline=1]="Inline",I[I.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var y;(function(I){I[I.TextDefined=0]="TextDefined",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(I){I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(I){I[I.LF=0]="LF",I[I.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),this.indentSize=b.tabSize|0,this.insertSpaces=Boolean(b.insertSpaces),this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=Boolean(b.trimAutoWhitespace),this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class P{constructor(b,c){this._findMatchBrand=void 0,this.range=b,this.matches=c}}e.FindMatch=P;var i;(function(I){I[I.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",I[I.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",I[I.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",I[I.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));class k{constructor(b,c){this.visibleColumn=b,this.className=c}}e.IndentGuide=k;class l{constructor(b,c,o,v){this.range=b,this.openingBracketRange=c,this.closingBracketRange=o,this.nestingLevel=v}}e.BracketPair=l;var f;(function(I){I[I.Left=0]="Left",I[I.Right=1]="Right",I[I.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var d;(function(I){I[I.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d=e.ModelConstants||(e.ModelConstants={}));class w{constructor(b,c,o,v,t,h){this.identifier=b,this.range=c,this.text=o,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=t,this._isTracked=h}}e.ValidAnnotatedEditOperation=w;class D{constructor(b,c,o){this.reverseEdits=b,this.changes=c,this.trimAutoWhitespaceLineNumbers=o}}e.ApplyEditsResult=D}),define(fe[147],me([0,1,9,145,51,42,110]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const _=999;class S{constructor(c,o,v,t){this.searchString=c,this.isRegex=o,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=P(this.searchString):c=this.searchString.indexOf(`
`)>=0;let o=null;try{o=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let v=!this.isRegex&&!c;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(o,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=S;function P(b){if(!b||b.length===0)return!1;for(let c=0,o=b.length;c<o;c++)if(b.charCodeAt(c)===92){if(c++,c>=o)break;const t=b.charCodeAt(c);if(t===110||t===114||t===87)return!0}return!1}e.isMultilineRegexSource=P;class i{constructor(c,o,v){this.regex=c,this.wordSeparators=o,this.simpleSearch=v}}e.SearchData=i;function k(b,c,o){if(!o)return new A.FindMatch(b,null);let v=[];for(let t=0,h=c.length;t<h;t++)v[t]=c[t];return new A.FindMatch(b,v)}e.createFindMatch=k;class l{constructor(c){let o=[],v=0;for(let t=0,h=c.length;t<h;t++)c.charCodeAt(t)===10&&(o[v++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(c){const o=this._lineFeedsOffsets;let v=0,t=o.length-1;if(t===-1||c<=o[0])return 0;for(;v<t;){const h=v+((t-v)/2>>0);o[h]>=c?t=h-1:o[h+1]>=c?(v=h,t=h):v=h+1}return v+1}}class f{static findMatches(c,o,v,t,h){const s=o.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(c,v,new I(s.wordSeparators,s.regex),t,h):this._doFindMatchesLineByLine(c,v,s,t,h):[]}static _getMultilineMatchRange(c,o,v,t,h,s){let n,r=0;t?(r=t.findLineFeedCountBeforeOffset(h),n=o+h+r):n=o+h;let a;if(t){let g=t.findLineFeedCountBeforeOffset(h+s.length)-r;a=n+s.length+g}else a=n+s.length;const u=c.getPositionAt(n),p=c.getPositionAt(a);return new y.Range(u.lineNumber,u.column,p.lineNumber,p.column)}static _doFindMatchesMultiline(c,o,v,t,h){const s=c.getOffsetAt(o.getStartPosition()),n=c.getValueInRange(o,1),r=c.getEOL()===`\r
`?new l(n):null,a=[];let u=0,p;for(v.reset(0);p=v.next(n);)if(a[u++]=k(this._getMultilineMatchRange(c,s,n,r,p.index,p[0]),p,t),u>=h)return a;return a}static _doFindMatchesLineByLine(c,o,v,t,h){const s=[];let n=0;if(o.startLineNumber===o.endLineNumber){const a=c.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return n=this._findMatchesInLine(v,a,o.startLineNumber,o.startColumn-1,n,s,t,h),s}const r=c.getLineContent(o.startLineNumber).substring(o.startColumn-1);n=this._findMatchesInLine(v,r,o.startLineNumber,o.startColumn-1,n,s,t,h);for(let a=o.startLineNumber+1;a<o.endLineNumber&&n<h;a++)n=this._findMatchesInLine(v,c.getLineContent(a),a,0,n,s,t,h);if(n<h){const a=c.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);n=this._findMatchesInLine(v,a,o.endLineNumber,0,n,s,t,h)}return s}static _findMatchesInLine(c,o,v,t,h,s,n,r){const a=c.wordSeparators;if(!n&&c.simpleSearch){const E=c.simpleSearch,g=E.length,T=o.length;let L=-g;for(;(L=o.indexOf(E,L+g))!==-1;)if((!a||D(a,o,T,L,g))&&(s[h++]=new A.FindMatch(new y.Range(v,L+1+t,v,L+1+g+t),null),h>=r))return h;return h}const u=new I(c.wordSeparators,c.regex);let p;u.reset(0);do if(p=u.next(o),p&&(s[h++]=k(new y.Range(v,p.index+1+t,v,p.index+1+p[0].length+t),p,n),h>=r))return h;while(p);return h}static findNextMatch(c,o,v,t){const h=o.parseSearchRequest();if(!h)return null;const s=new I(h.wordSeparators,h.regex);return h.regex.multiline?this._doFindNextMatchMultiline(c,v,s,t):this._doFindNextMatchLineByLine(c,v,s,t)}static _doFindNextMatchMultiline(c,o,v,t){const h=new C.Position(o.lineNumber,1),s=c.getOffsetAt(h),n=c.getLineCount(),r=c.getValueInRange(new y.Range(h.lineNumber,h.column,n,c.getLineMaxColumn(n)),1),a=c.getEOL()===`\r
`?new l(r):null;v.reset(o.column-1);let u=v.next(r);return u?k(this._getMultilineMatchRange(c,s,r,a,u.index,u[0]),u,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(c,new C.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(c,o,v,t){const h=c.getLineCount(),s=o.lineNumber,n=c.getLineContent(s),r=this._findFirstMatchInLine(v,n,s,o.column,t);if(r)return r;for(let a=1;a<=h;a++){const u=(s+a-1)%h,p=c.getLineContent(u+1),E=this._findFirstMatchInLine(v,p,u+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(c,o,v,t,h){c.reset(t-1);const s=c.next(o);return s?k(new y.Range(v,s.index+1,v,s.index+1+s[0].length),s,h):null}static findPreviousMatch(c,o,v,t){const h=o.parseSearchRequest();if(!h)return null;const s=new I(h.wordSeparators,h.regex);return h.regex.multiline?this._doFindPreviousMatchMultiline(c,v,s,t):this._doFindPreviousMatchLineByLine(c,v,s,t)}static _doFindPreviousMatchMultiline(c,o,v,t){const h=this._doFindMatchesMultiline(c,new y.Range(1,1,o.lineNumber,o.column),v,t,10*_);if(h.length>0)return h[h.length-1];const s=c.getLineCount();return o.lineNumber!==s||o.column!==c.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(c,new C.Position(s,c.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(c,o,v,t){const h=c.getLineCount(),s=o.lineNumber,n=c.getLineContent(s).substring(0,o.column-1),r=this._findLastMatchInLine(v,n,s,t);if(r)return r;for(let a=1;a<=h;a++){const u=(h+s-a-1)%h,p=c.getLineContent(u+1),E=this._findLastMatchInLine(v,p,u+1,t);if(E)return E}return null}static _findLastMatchInLine(c,o,v,t){let h=null,s;for(c.reset(0);s=c.next(o);)h=k(new y.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return h}}e.TextModelSearch=f;function d(b,c,o,v,t){if(v===0)return!0;const h=c.charCodeAt(v-1);if(b.get(h)!==0||h===13||h===10)return!0;if(t>0){const s=c.charCodeAt(v);if(b.get(s)!==0)return!0}return!1}function w(b,c,o,v,t){if(v+t===o)return!0;const h=c.charCodeAt(v+t);if(b.get(h)!==0||h===13||h===10)return!0;if(t>0){const s=c.charCodeAt(v+t-1);if(b.get(s)!==0)return!0}return!1}function D(b,c,o,v,t){return d(b,c,o,v,t)&&w(b,c,o,v,t)}e.isValidMatch=D;class I{constructor(c,o){this._wordSeparators=c,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const o=c.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(v=this._searchRegex.exec(c),!v))return null;const t=v.index,h=v[0].length;if(t===this._prevMatchStartIndex&&h===this._prevMatchLength){if(h===0){m.getNextCodePoint(c,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=h,!this._wordSeparators||D(this._wordSeparators,c,o,t,h))return v}while(v);return null}}e.Searcher=I}),define(fe[111],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(_=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)_.indexOf(P)>=0||(S+="\\"+P);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function F(_){let S=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)S=_;else{let P="g";_.ignoreCase&&(P+="i"),_.multiline&&(P+="m"),_.unicode&&(P+="u"),S=new RegExp(_.source,P)}return S.lastIndex=0,S}e.ensureValidWordDefinition=F;const C={maxLen:1e3,windowSize:15,timeBudget:150};function y(_,S,P,i,k=C){if(P.length>k.maxLen){let D=_-k.maxLen/2;return D<0?D=0:i+=D,P=P.substring(D,_+k.maxLen/2),y(_,S,P,i,k)}const l=Date.now(),f=_-1-i;let d=-1,w=null;for(let D=1;!(Date.now()-l>=k.timeBudget);D++){const I=f-k.windowSize*D;S.lastIndex=Math.max(0,I);const b=A(S,P,f,d);if(!b&&w||(w=b,I<=0))break;d=I}if(w){let D={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return S.lastIndex=0,D}return null}e.getWordAtText=y;function A(_,S,P,i){let k;for(;k=_.exec(S);){const l=k.index||0;if(l<=P&&_.lastIndex>=P)return k;if(i>0&&l>i)return null}return null}}),define(fe[148],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class F{constructor(_){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=_.open,this.close=_.close,this._standardTokenMask=0,Array.isArray(_.notIn))for(let S=0,P=_.notIn.length;S<P;S++)switch(_.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(_){return(this._standardTokenMask&_)==0}}e.StandardAutoClosingPairConditional=F;class C{constructor(_){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of _)y(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),y(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),y(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),y(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&y(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=C;function y(A,_,S){A.has(_)?A.get(_).push(S):A.set(_,[S])}}),define(fe[82],me([0,1,30,8]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(y,A,_,S){if(Array.isArray(y)){let P=0;for(const i of y){const k=C(i,A,_,S);if(k===10)return k;k>P&&(P=k)}return P}else{if(typeof y=="string")return S?y==="*"?5:y===_?10:0:0;if(y){const{language:P,pattern:i,scheme:k,hasAccessToAllModels:l}=y;if(!S&&!l)return 0;let f=0;if(k)if(k===A.scheme)f=10;else if(k==="*")f=5;else return 0;if(P)if(P===_)f=10;else if(P==="*")f=Math.max(f,5);else return 0;if(i){let d;if(typeof i=="string"?d=i:d={...i,base:(0,F.normalize)(i.base)},d===A.fsPath||(0,m.match)(d,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=C}),define(fe[149],me([0,1,109]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class C{constructor(d,w,D){const I=new Uint8Array(d*w);for(let b=0,c=d*w;b<c;b++)I[b]=D;this._data=I,this.rows=d,this.cols=w}get(d,w){return this._data[d*this.cols+w]}set(d,w,D){this._data[d*this.cols+w]=D}}e.Uint8Matrix=C;class y{constructor(d){let w=0,D=0;for(let b=0,c=d.length;b<c;b++){let[o,v,t]=d[b];v>w&&(w=v),o>D&&(D=o),t>D&&(D=t)}w++,D++;let I=new C(D,w,0);for(let b=0,c=d.length;b<c;b++){let[o,v,t]=d[b];I.set(o,v,t)}this._states=I,this._maxCharCode=w}nextState(d,w){return w<0||w>=this._maxCharCode?0:this._states.get(d,w)}}e.StateMachine=y;let A=null;function _(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var S;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let P=null;function i(){if(P===null){P=new m.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<f.length;w++)P.set(f.charCodeAt(w),1);const d=".,;";for(let w=0;w<d.length;w++)P.set(d.charCodeAt(w),2)}return P}class k{static _createLink(d,w,D,I,b){let c=b-1;do{const o=w.charCodeAt(c);if(d.get(o)!==2)break;c--}while(c>I);if(I>0){const o=w.charCodeAt(I-1),v=w.charCodeAt(c);(o===40&&v===41||o===91&&v===93||o===123&&v===125)&&c--}return{range:{startLineNumber:D,startColumn:I+1,endLineNumber:D,endColumn:c+2},url:w.substring(I,c+1)}}static computeLinks(d,w=_()){const D=i();let I=[];for(let b=1,c=d.getLineCount();b<=c;b++){const o=d.getLineContent(b),v=o.length;let t=0,h=0,s=0,n=1,r=!1,a=!1,u=!1,p=!1;for(;t<v;){let E=!1;const g=o.charCodeAt(t);if(n===13){let T;switch(g){case 40:r=!0,T=0;break;case 41:T=r?0:1;break;case 91:u=!0,a=!0,T=0;break;case 93:u=!1,T=a?0:1;break;case 123:p=!0,T=0;break;case 125:T=p?0:1;break;case 39:T=s===34||s===96?0:1;break;case 34:T=s===39||s===96?0:1;break;case 96:T=s===39||s===34?0:1;break;case 42:T=s===42?1:0;break;case 124:T=s===124?1:0;break;case 32:T=u?0:1;break;default:T=D.get(g)}T===1&&(I.push(k._createLink(D,o,b,h,t)),E=!0)}else if(n===12){let T;g===91?(a=!0,T=0):T=D.get(g),T===1?E=!0:n=13}else n=w.nextState(n,g),n===0&&(E=!0);E&&(n=1,r=!1,a=!1,p=!1,h=t+1,s=g),t++}n===13&&I.push(k._createLink(D,o,b,h,v))}return I}}e.LinkComputer=k;function l(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:k.computeLinks(f)}e.computeLinks=l}),define(fe[150],me([0,1,3,6]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,_){return this._map.set(A,_),this.fire([A]),(0,F.toDisposable)(()=>{this._map.get(A)===_&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,_){let S=null,P=!1;return this._promises.set(A,_.then(i=>{this._promises.delete(A),!(P||!i)&&(S=this.register(A,i))})),(0,F.toDisposable)(()=>{P=!0,S&&S.dispose()})}getPromise(A){const _=this.get(A);if(_)return Promise.resolve(_);const S=this._promises.get(A);return S?S.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(fe[112],me([0,1,22,11]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function y(k){for(let l=0,f=k.length;l<f;l+=4){const d=k[l+0],w=k[l+1],D=k[l+2],I=k[l+3];k[l+0]=I,k[l+1]=D,k[l+2]=w,k[l+3]=d}}function A(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||y(l),m.VSBuffer.wrap(l)}function _(k){const l=k.buffer;if(F.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const f=new Uint8Array(l.byteLength);return f.set(l),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(k){const l=new Uint32Array(P(k));let f=0;if(l[f++]=k.id,k.type==="full")l[f++]=1,l[f++]=k.data.length,l.set(k.data,f),f+=k.data.length;else{l[f++]=2,l[f++]=k.deltas.length;for(const d of k.deltas)l[f++]=d.start,l[f++]=d.deleteCount,d.data?(l[f++]=d.data.length,l.set(d.data,f),f+=d.data.length):l[f++]=0}return A(l)}e.encodeSemanticTokensDto=S;function P(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const f of k.deltas)f.data&&(l+=f.data.length)}return l}function i(k){const l=_(k);let f=0;const d=l[f++];if(l[f++]===1){const b=l[f++],c=l.subarray(f,f+b);return f+=b,{id:d,type:"full",data:c}}const D=l[f++];let I=[];for(let b=0;b<D;b++){const c=l[f++],o=l[f++],v=l[f++];let t;v>0&&(t=l.subarray(f,f+v),f+=v),I[b]={start:c,deleteCount:o,data:t}}return{id:d,type:"delta",deltas:I}}e.decodeSemanticTokensDto=i}),define(fe[113],me([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(A,_){this._prefixSumIndexOfResultBrand=void 0,this.index=A,this.remainder=_}}e.PrefixSumIndexOfResult=F;class C{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,_){A=(0,m.toUint32)(A);const S=this.values,P=this.prefixSum,i=_.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A),A+i),this.values.set(_,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,_){return A=(0,m.toUint32)(A),_=(0,m.toUint32)(_),this.values[A]===_?!1:(this.values[A]=_,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,_){A=(0,m.toUint32)(A),_=(0,m.toUint32)(_);const S=this.values,P=this.prefixSum;if(A>=S.length)return!1;let i=S.length-A;return _>=i&&(_=i),_===0?!1:(this.values=new Uint32Array(S.length-_),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A+_),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=(0,m.toUint32)(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let _=this.prefixSumValidIndex[0]+1;_===0&&(this.prefixSum[0]=this.values[0],_++),A>=this.values.length&&(A=this.values.length-1);for(let S=_;S<=A;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let _=0,S=this.values.length-1,P=0,i=0,k=0;for(;_<=S;)if(P=_+(S-_)/2|0,i=this.prefixSum[P],k=i-this.values[P],A<k)S=P-1;else if(A>=i)_=P+1;else break;return new F(P,A-k)}}e.PrefixSumComputer=C}),define(fe[151],me([0,1,9,51,113]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(_,S,P,i){this._uri=_,this._lines=S,this._eol=P,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const S=_.changes;for(const P of S)this._acceptDeleteRange(P.range),this._acceptInsertText(new F.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,S=this._lines.length,P=new Uint32Array(S);for(let i=0;i<S;i++)P[i]=this._lines[i].length+_;this._lineStarts=new C.PrefixSumComputer(P)}}_setLineText(_,S){this._lines[_]=S,this._lineStarts&&this._lineStarts.changeValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,S){if(S.length===0)return;let P=(0,m.splitLines)(S);if(P.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+P[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}P[P.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+P[0]);let i=new Uint32Array(P.length-1);for(let k=1;k<P.length;k++)this._lines.splice(_.lineNumber+k-1,0,P[k]),i[k-1]=P[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,i)}}e.MirrorTextModel=y}),define(fe[152],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[153],me([0,1,152]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,C=F*60,y=C*24,A=y*7,_=y*30,S=y*365;function P(k,l){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,m.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,m.localize)(1,null);let d;return f<F?(d=f,l?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):f<C?(d=Math.floor(f/F),l?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):f<y?(d=Math.floor(f/C),l?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):f<A?(d=Math.floor(f/y),l?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):f<_?(d=Math.floor(f/A),l?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):f<S?(d=Math.floor(f/_),l?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(f/S),l?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=P;function i(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,16,12,154]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(P,i){return i&&(P.stack||P.stacktrace)?C.localize(0,null,_(P),A(P.stack)||A(P.stacktrace)):_(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function _(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?C.localize(1,null,P.message):P.message||C.localize(2,null)}function S(P=null,i=!1){if(!P)return C.localize(3,null);if(Array.isArray(P)){const k=m.coalesce(P),l=S(k[0],i);return k.length>1?C.localize(4,null,l,k.length):l}if(F.isString(P))return P;if(P.detail){const k=P.detail;if(k.error)return y(k.error,i);if(k.exception)return y(k.exception,i)}return P.stack?y(P,i):P.message?P.message:C.localize(5,null)}e.toErrorMessage=S}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[114],me([0,1,39,29,10,25,8,11,38,96,12,144,28,155]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function d(v){switch(v){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(v,t){if(_.isWindows)try{const h={stdio:["pipe","pipe","ignore"]};t&&(h.cwd=t);const s=m.execFile("taskkill",["/T","/F","/PID",v.pid.toString()],h);return new Promise(n=>{s.once("error",r=>{n({success:!1,error:r})}),s.once("exit",(r,a)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(h){return Promise.resolve({success:!1,error:h,code:h.status?d(h.status):1})}else if(_.isLinux||_.isMacintosh)try{const h=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(s=>{m.execFile(h,[v.pid.toString()],{encoding:"utf8",shell:!0},(n,r,a)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(h){return Promise.resolve({success:!1,error:h})}else v.kill("SIGKILL");return Promise.resolve({success:!0})}function D(v=S.env){return v.comspec||"cmd.exe"}e.getWindowsShell=D;class I{constructor(t,h,s,n){if(h!==void 0&&s!==void 0&&n!==void 0)this.cmd=t,this.args=h,this.shell=s,this.options=n;else{const r=t;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(S.env).forEach(a=>{r[a]=S.env[a]}),Object.keys(this.options.env).forEach(a=>{r[a]=this.options.env[a]}),this.options.env=r}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const h=t.lastIndexOf(A.sep);return h!==-1&&(t=t.substring(h+1)),I.WellKnowCommands[t]?t:"other"}start(t){return _.isWindows&&(this.options&&this.options.cwd&&F.isUNC(this.options.cwd)||!this.options&&F.isUNC(S.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(h=>{let s,n;const r=new Promise((a,u)=>{s=a,n=u});if(h){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=m.exec(a,this.options,(u,p,E)=>{this.childProcess=null;const g=u;g&&g.killed?n({killed:this.terminateRequested,stdout:p.toString(),stderr:E.toString()}):this.handleExec(s,t,u,p,E)})}else{let a=null;const u=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,s,t,n);const E={terminated:this.terminateRequested};i.isNumber(p)&&(E.cmdCode=p),s(E)};if(this.shell&&_.isWindows){const p=y.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let E=!1,g=!1;const T=[];let L=this.ensureQuotes(this.cmd);T.push(L.value),E=L.quoted,this.args&&this.args.forEach(R=>{L=this.ensureQuotes(R),T.push(L.value),g=g&&L.quoted});const M=["/s","/c"];E?g?M.push('"'+T.join(" ")+'"'):T.length>1?M.push('"'+T[0]+'" '+T.slice(1).join(" ")):M.push('"'+T[0]+'"'):M.push(T.join(" ")),a=m.spawn(D(),M,p)}else this.cmd&&(a=m.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(i.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",p=>{this.childProcess=null,n({terminated:this.terminateRequested,error:p})}),a.pid&&(this.childProcess.on("close",u),this.handleSpawn(a,s,t,n,!0)))}return r})}handleClose(t,h,s,n){}ensureQuotes(t){return I.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(h=>(h.success&&(this.childProcess=null),h))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!_.isWindows)return t(!1);const h=m.spawn(D(),["/s","/c"]);h.on("error",s=>t(!0)),h.on("exit",s=>t(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class b extends I{constructor(t,h,s,n){super(t,h,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,h,s,n,r){[n,r].forEach((a,u)=>{const p=new k.LineDecoder;p.write(a).forEach(T=>{h({line:T,source:u===0?0:1})});const g=p.end();g&&h({line:g,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,h,s,n,r){const a=new k.LineDecoder,u=new k.LineDecoder;t.stdout.on("data",p=>{a.write(p).forEach(g=>s({line:g,source:0}))}),t.stderr.on("data",p=>{u.write(p).forEach(g=>s({line:g,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=u}handleClose(t,h,s,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&s({line:a,source:1})}}e.LineProcess=b;function c(v){let t=[],h=!1;const s=function(n){if(h){t.push(n);return}(!v.send(n,a=>{if(a&&console.error(a),h=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(p=>s(p))}})||_.isWindows)&&(h=!0)};return{send:s}}e.createQueuedSender=c;var o;(function(v){async function t(h,s,n){if(A.isAbsolute(h))return h;if(s===void 0&&(s=S.cwd()),A.dirname(h)!=="."||(n===void 0&&i.isString(S.env.PATH)&&(n=S.env.PATH.split(A.delimiter)),n===void 0||n.length===0))return A.join(s,h);async function a(u){if(await l.Promises.exists(u)){let p;try{p=await l.Promises.stat(u)}catch(E){E.message.startsWith("EACCES")&&(p=await l.Promises.lstat(u))}return p?!p.isDirectory():!1}return!1}for(let u of n){let p;if(A.isAbsolute(u)?p=A.join(u,h):p=A.join(s,u,h),await a(p))return p;let E=p+".com";if(await a(E)||(E=p+".exe",await a(E)))return E}return A.join(s,h)}v.findExecutable=t})(o=e.win32||(e.win32={}))}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[115],me([0,1,156,11,111]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=A;class _{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,ve){this._values[ne]=ve}}e.ValidatedEditorOptions=_;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class P{constructor(ne,ve,Qe,tt){this.id=ne,this.name=ve,this.defaultValue=Qe,this.schema=tt}compute(ne,ve,Qe){return Qe}}class i{constructor(ne,ve=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ne){return this.defaultValue}}class k{constructor(ne,ve,Qe,tt){this.id=ne,this.name=ve,this.defaultValue=Qe,this.schema=tt}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,ve,Qe){return Qe}}function l(J,ne){return typeof J=="undefined"?ne:J==="false"?!1:Boolean(J)}e.boolean=l;class f extends k{constructor(ne,ve,Qe,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=Qe),super(ne,ve,Qe,tt)}validate(ne){return l(ne,this.defaultValue)}}function d(J,ne,ve,Qe){if(typeof J=="undefined")return ne;let tt=parseInt(J,10);return isNaN(tt)?ne:(tt=Math.max(ve,tt),tt=Math.min(Qe,tt),tt|0)}e.clampedInt=d;class w extends k{constructor(ne,ve,Qe,tt,ct,ce=void 0){typeof ce!="undefined"&&(ce.type="integer",ce.default=Qe,ce.minimum=tt,ce.maximum=ct),super(ne,ve,Qe,ce),this.minimum=tt,this.maximum=ct}static clampedInt(ne,ve,Qe,tt){return d(ne,ve,Qe,tt)}validate(ne){return w.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class D extends k{constructor(ne,ve,Qe,tt,ct){typeof ct!="undefined"&&(ct.type="number",ct.default=Qe),super(ne,ve,Qe,ct),this.validationFn=tt}static clamp(ne,ve,Qe){return ne<ve?ve:ne>Qe?Qe:ne}static float(ne,ve){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return ve;const Qe=parseFloat(ne);return isNaN(Qe)?ve:Qe}validate(ne){return this.validationFn(D.float(ne,this.defaultValue))}}class I extends k{static string(ne,ve){return typeof ne!="string"?ve:ne}constructor(ne,ve,Qe,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=Qe),super(ne,ve,Qe,tt)}validate(ne){return I.string(ne,this.defaultValue)}}function b(J,ne,ve){return typeof J!="string"||ve.indexOf(J)===-1?ne:J}e.stringSet=b;class c extends k{constructor(ne,ve,Qe,tt,ct=void 0){typeof ct!="undefined"&&(ct.type="string",ct.enum=tt,ct.default=Qe),super(ne,ve,Qe,ct),this._allowedValues=tt}validate(ne){return b(ne,this.defaultValue,this._allowedValues)}}class o extends P{constructor(ne,ve,Qe,tt,ct,ce,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="string",Ie.enum=ct,Ie.default=tt),super(ne,ve,Qe,Ie),this._allowedValues=ct,this._convert=ce}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,ve,Qe){return Qe===0?ne.accessibilitySupport:Qe}}class h extends P{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(J){switch(J){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function u(J){switch(J){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends i{constructor(){super(126,[65,33])}compute(ne,ve,Qe){const tt=["monaco-editor"];return ve.get(33)&&tt.push(ve.get(33)),ne.extraEditorClassName&&tt.push(ne.extraEditorClassName),ve.get(65)==="default"?tt.push("mouse-default"):ve.get(65)==="copy"&&tt.push("mouse-copy"),ve.get(99)&&tt.push("showUnused"),ve.get(124)&&tt.push("showDeprecated"),tt.join(" ")}}class E extends f{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ne,ve,Qe){return Qe&&ne.emptySelectionClipboard}}class g extends P{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:m.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:m.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":b(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":b(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class T extends P{constructor(){super(44,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?T.OFF:ne==="true"?T.ON:ne:Boolean(ne)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class L extends i{constructor(){super(43)}compute(ne,ve,Qe){return ne.fontInfo}}class M extends k{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ne){let ve=D.float(ne,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(ve,6,100)}compute(ne,ve,Qe){return ne.fontInfo.fontSize}}class R extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:R.MINIMUM_VALUE,maximum:R.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:R.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(w.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,R.MINIMUM_VALUE,R.MAXIMUM_VALUE))}}R.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],R.MINIMUM_VALUE=1,R.MAXIMUM_VALUE=1e3;class W extends P{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Qe,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Qe,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Qe,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Qe,description:m.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{multiple:b(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??b(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??b(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??b(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??b(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??b(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends P{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:m.localize(41,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:w.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var N;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ne,ve,Qe){return j.computeLayout(ve,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const ve=ne.height/ne.lineHeight,Qe=ne.scrollBeyondLastLine?ve-1:0,tt=(ne.viewLineCount+Qe)/(ne.pixelRatio*ne.height),ct=Math.floor(ne.viewLineCount/tt);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:ct}}static _computeMinimapLayout(ne,ve){const Qe=ne.outerWidth,tt=ne.outerHeight,ct=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const ce=ve.stableMinimapLayoutInput,Ie=ce&&ne.outerHeight===ce.outerHeight&&ne.lineHeight===ce.lineHeight&&ne.typicalHalfwidthCharacterWidth===ce.typicalHalfwidthCharacterWidth&&ne.pixelRatio===ce.pixelRatio&&ne.scrollBeyondLastLine===ce.scrollBeyondLastLine&&ne.minimap.enabled===ce.minimap.enabled&&ne.minimap.side===ce.minimap.side&&ne.minimap.size===ce.minimap.size&&ne.minimap.showSlider===ce.minimap.showSlider&&ne.minimap.renderCharacters===ce.minimap.renderCharacters&&ne.minimap.maxColumn===ce.minimap.maxColumn&&ne.minimap.scale===ce.minimap.scale&&ne.verticalScrollbarWidth===ce.verticalScrollbarWidth&&ne.isViewportWrapping===ce.isViewportWrapping,Ue=ne.lineHeight,Xe=ne.typicalHalfwidthCharacterWidth,rt=ne.scrollBeyondLastLine,ht=ne.minimap.renderCharacters;let Ye=ct>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const vt=ne.minimap.maxColumn,Re=ne.minimap.size,Ce=ne.minimap.side,Pe=ne.verticalScrollbarWidth,se=ne.viewLineCount,ue=ne.remainingWidth,be=ne.isViewportWrapping,we=ht?2:3;let Fe=Math.floor(ct*tt);const qe=Fe/ct;let ze=!1,et=!1,at=we*Ye,xe=Ye/ct,ge=1;if(Re==="fill"||Re==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:pt,desiredRatio:Et,minimapLineCount:ft}=j.computeContainedMinimapLineCount({viewLineCount:se,scrollBeyondLastLine:rt,height:tt,lineHeight:Ue,pixelRatio:ct});if(se/ft>1)ze=!0,et=!0,Ye=1,at=1,xe=Ye/ct;else{let mt=!1,_t=Ye+1;if(Re==="fit"){const Dt=Math.ceil((se+pt)*at);be&&Ie&&ue<=ve.stableFitRemainingWidth?(mt=!0,_t=ve.stableFitMaxMinimapScale):mt=Dt>Fe}if(Re==="fill"||mt){ze=!0;const Dt=Ye;at=Math.min(Ue*ct,Math.max(1,Math.floor(1/Et))),be&&Ie&&ue<=ve.stableFitRemainingWidth&&(_t=ve.stableFitMaxMinimapScale),Ye=Math.min(_t,Math.max(1,Math.floor(at/we))),Ye>Dt&&(ge=Math.min(2,Ye/Dt)),xe=Ye/ct/ge,Fe=Math.ceil(Math.max(Ge,se+pt)*at),be?(ve.stableMinimapLayoutInput=ne,ve.stableFitRemainingWidth=ue,ve.stableFitMaxMinimapScale=Ye):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Ee=Math.floor(vt*xe),te=Math.min(Ee,Math.max(0,Math.floor((ue-Pe-2)*xe/(Xe+xe)))+e.MINIMAP_GUTTER_WIDTH);let K=Math.floor(ct*te);const Se=K/ct;K=Math.floor(K*ge);const Le=ht?1:2,it=Ce==="left"?0:Qe-te-Pe;return{renderMinimap:Le,minimapLeft:it,minimapWidth:te,minimapHeightIsEditorHeight:ze,minimapIsSampling:et,minimapScale:Ye,minimapLineHeight:at,minimapCanvasInnerWidth:K,minimapCanvasInnerHeight:Fe,minimapCanvasOuterWidth:Se,minimapCanvasOuterHeight:qe}}static computeLayout(ne,ve){const Qe=ve.outerWidth|0,tt=ve.outerHeight|0,ct=ve.lineHeight|0,ce=ve.lineNumbersDigitCount|0,Ie=ve.typicalHalfwidthCharacterWidth,Ue=ve.maxDigitWidth,Xe=ve.pixelRatio,rt=ve.viewLineCount,ht=ne.get(121),Ye=ht==="inherit"?ne.get(120):ht,vt=Ye==="inherit"?ne.get(116):Ye,Re=ne.get(119),Ce=ne.get(2),Pe=ve.isDominatedByLongLines,se=ne.get(49),ue=ne.get(59).renderType!==0,be=ne.get(60),we=ne.get(93),Fe=ne.get(64),qe=ne.get(91),ze=qe.verticalScrollbarSize,et=qe.verticalHasArrows,at=qe.arrowSize,xe=qe.horizontalScrollbarSize,ge=ne.get(57),Ee=ne.get(37);let te;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const kt=parseFloat(ge.substr(0,ge.length-2));te=w.clampedInt(kt*Ie,0,0,1e3)}else te=w.clampedInt(ge,0,0,1e3);Ee&&(te+=16);let K=0;if(ue){const kt=Math.max(ce,be);K=Math.round(kt*Ue)}let Se=0;se&&(Se=ct);let Le=0,it=Le+Se,Ge=it+K,pt=Ge+te;const Et=Qe-Se-K-te;let ft=!1,bt=!1,mt=-1;Ce!==2&&(Ye==="inherit"&&Pe?(ft=!0,bt=!0):vt==="on"||vt==="bounded"?bt=!0:vt==="wordWrapColumn"&&(mt=Re));const _t=j._computeMinimapLayout({outerWidth:Qe,outerHeight:tt,lineHeight:ct,typicalHalfwidthCharacterWidth:Ie,pixelRatio:Xe,scrollBeyondLastLine:we,minimap:Fe,verticalScrollbarWidth:ze,viewLineCount:rt,remainingWidth:Et,isViewportWrapping:bt},ve.memory||new S);_t.renderMinimap!==0&&_t.minimapLeft===0&&(Le+=_t.minimapWidth,it+=_t.minimapWidth,Ge+=_t.minimapWidth,pt+=_t.minimapWidth);const Dt=Et-_t.minimapWidth,Bt=Math.max(1,Math.floor((Dt-ze-2)/Ie)),Vt=et?at:0;return bt&&(mt=Math.max(1,Bt),vt==="bounded"&&(mt=Math.min(mt,Re))),{width:Qe,height:tt,glyphMarginLeft:Le,glyphMarginWidth:Se,lineNumbersLeft:it,lineNumbersWidth:K,decorationsLeft:Ge,decorationsWidth:te,contentLeft:pt,contentWidth:Dt,minimap:_t,viewportColumn:Bt,isWordWrapMinified:ft,isViewportWrapping:bt,wrappingColumn:mt,verticalScrollbarWidth:ze,horizontalScrollbarHeight:xe,overviewRuler:{top:Vt,width:ze,height:tt-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=j;class U extends P{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:m.localize(42,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:l(ne.enabled,this.defaultValue.enabled)}}}class x extends P{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:m.localize(45,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class z extends D{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>D.clamp(ne,0,150),{markdownDescription:m.localize(46,null)})}compute(ne,ve,Qe){return ne.fontInfo.lineHeight}}class O extends P{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:ne.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:m.localize(56,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:b(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ve.side,this.defaultValue.side,["right","left"]),showSlider:b(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ve.scale,1,1,3),maxColumn:w.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(J){return J==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{top:w.clampedInt(ve.top,0,0,1e3),bottom:w.clampedInt(ve.bottom,0,0,1e3)}}}class X extends P{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:m.localize(60,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(127)}compute(ne,ve,Qe){return ne.pixelRatio}}class de extends P{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:m.localize(61,null)},comments:{type:"boolean",default:ne.comments,description:m.localize(62,null)},other:{type:"boolean",default:ne.other,description:m.localize(63,null)}}}],default:ne,description:m.localize(64,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const ve=ne,Qe={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(ne){let ve=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(ve=4,Qe=ne):ne==="interval"?ve=3:ne==="relative"?ve=2:ne==="on"?ve=1:ve=0),{renderType:ve,renderFn:Qe}}}function ke(J){const ne=J.get(86);return ne==="editable"?J.get(80):ne!=="on"}e.filterValidationDecorations=ke;class Be extends P{constructor(){const ne=[],ve={type:"number",description:m.localize(70,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:ne,description:m.localize(72,null)})}validate(ne){if(Array.isArray(ne)){let ve=[];for(let Qe of ne)if(typeof Qe=="number")ve.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const tt=Qe;ve.push({column:w.clampedInt(tt.column,0,0,1e4),color:tt.color})}return ve.sort((Qe,tt)=>Qe.column-tt.column),ve}return this.defaultValue}}function We(J,ne){if(typeof J!="string")return ne;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends P{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:m.localize(83,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne,Qe=w.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=w.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(ve.vertical,this.defaultValue.vertical),horizontal:We(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(ve.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:w.clampedInt(ve.verticalSliderSize,tt,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class q extends P{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:m.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:l(ve.enabled,this.defaultValue.enabled),mode:b(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends P{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:m.localize(85,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:l(ne.enabled,this.defaultValue.enabled)}}}class re extends P{constructor(){const ne={bracketPairs:!1,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:"boolean",default:ne.bracketPairs,description:m.localize(86,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:m.localize(87,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:m.localize(88,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{bracketPairs:l(ve.bracketPairs,this.defaultValue.bracketPairs),indentation:l(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:l(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class le extends P{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(89,null),m.localize(90,null)],default:ne.insertMode,description:m.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:m.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:m.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:m.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:m.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:m.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:m.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:m.localize(98,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:m.localize(99,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(100,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(101,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(102,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertMode:b(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),previewMode:b(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(131,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends i{constructor(){super(128,[80])}compute(ne,ve,Qe){return ve.get(80)?!0:ne.tabFocusMode}}var pe;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(pe=e.WrappingIndent||(e.WrappingIndent={}));function Me(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class je extends i{constructor(){super(130,[129])}compute(ne,ve,Qe){const tt=ve.get(129);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const Ke="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Je:F.isLinux?st:Ke,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Te(J){return e.editorOptionsRegistry[J.id]=J,J}var nt;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(132,null)})),acceptSuggestionOnEnter:Te(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(133,null),""],markdownDescription:m.localize(134,null)})),accessibilitySupport:Te(new t),accessibilityPageSize:Te(new w(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(135,null)})),ariaLabel:Te(new I(4,"ariaLabel",m.localize(136,null))),autoClosingBrackets:Te(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(137,null),m.localize(138,null),""],description:m.localize(139,null)})),autoClosingDelete:Te(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(140,null),""],description:m.localize(141,null)})),autoClosingOvertype:Te(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(142,null),""],description:m.localize(143,null)})),autoClosingQuotes:Te(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(144,null),m.localize(145,null),""],description:m.localize(146,null)})),autoIndent:Te(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(147,null),m.localize(148,null),m.localize(149,null),m.localize(150,null),m.localize(151,null)],description:m.localize(152,null)})),automaticLayout:Te(new f(10,"automaticLayout",!1)),autoSurround:Te(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(153,null),m.localize(154,null),m.localize(155,null),""],description:m.localize(156,null)})),bracketPairColorization:Te(new ee),bracketPairGuides:Te(new re),stickyTabStops:Te(new f(103,"stickyTabStops",!1,{description:m.localize(157,null)})),codeLens:Te(new f(14,"codeLens",!0,{description:m.localize(158,null)})),codeLensFontFamily:Te(new I(15,"codeLensFontFamily","",{description:m.localize(159,null)})),codeLensFontSize:Te(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(160,null)})),colorDecorators:Te(new f(17,"colorDecorators",!0,{description:m.localize(161,null)})),columnSelection:Te(new f(18,"columnSelection",!1,{description:m.localize(162,null)})),comments:Te(new h),contextmenu:Te(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new f(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(163,null)})),cursorBlinking:Te(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:m.localize(164,null)})),cursorSmoothCaretAnimation:Te(new f(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(165,null)})),cursorStyle:Te(new o(24,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],u,{description:m.localize(166,null)})),cursorSurroundingLines:Te(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(167,null)})),cursorSurroundingLinesStyle:Te(new c(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(168,null),m.localize(169,null)],description:m.localize(170,null)})),cursorWidth:Te(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(171,null)})),disableLayerHinting:Te(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new f(30,"domReadOnly",!1)),dragAndDrop:Te(new f(31,"dragAndDrop",!0,{description:m.localize(172,null)})),emptySelectionClipboard:Te(new E),extraEditorClassName:Te(new I(33,"extraEditorClassName","")),fastScrollSensitivity:Te(new D(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:m.localize(173,null)})),find:Te(new g),fixedOverflowWidgets:Te(new f(36,"fixedOverflowWidgets",!1)),folding:Te(new f(37,"folding",!0,{description:m.localize(174,null)})),foldingStrategy:Te(new c(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(175,null),m.localize(176,null)],description:m.localize(177,null)})),foldingHighlight:Te(new f(39,"foldingHighlight",!0,{description:m.localize(178,null)})),foldingImportsByDefault:Te(new f(40,"foldingImportsByDefault",!1,{description:m.localize(179,null)})),unfoldOnClickAfterEndOfLine:Te(new f(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(180,null)})),fontFamily:Te(new I(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(181,null)})),fontInfo:Te(new L),fontLigatures2:Te(new T),fontSize:Te(new M),fontWeight:Te(new R),formatOnPaste:Te(new f(47,"formatOnPaste",!1,{description:m.localize(182,null)})),formatOnType:Te(new f(48,"formatOnType",!1,{description:m.localize(183,null)})),glyphMargin:Te(new f(49,"glyphMargin",!0,{description:m.localize(184,null)})),gotoLocation:Te(new W),hideCursorInOverviewRuler:Te(new f(51,"hideCursorInOverviewRuler",!1,{description:m.localize(185,null)})),hover:Te(new V),inDiffEditor:Te(new f(53,"inDiffEditor",!1)),letterSpacing:Te(new D(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>D.clamp(J,-5,20),{description:m.localize(186,null)})),lightbulb:Te(new U),lineDecorationsWidth:Te(new k(57,"lineDecorationsWidth",10)),lineHeight:Te(new z),lineNumbers:Te(new ye),lineNumbersMinChars:Te(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new f(61,"linkedEditing",!1,{description:m.localize(187,null)})),links:Te(new f(62,"links",!0,{description:m.localize(188,null)})),matchBrackets:Te(new c(63,"matchBrackets","always",["always","near","never"],{description:m.localize(189,null)})),minimap:Te(new O),mouseStyle:Te(new c(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new D(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:m.localize(190,null)})),mouseWheelZoom:Te(new f(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(191,null)})),multiCursorMergeOverlapping:Te(new f(68,"multiCursorMergeOverlapping",!0,{description:m.localize(192,null)})),multiCursorModifier:Te(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[m.localize(193,null),m.localize(194,null)],markdownDescription:m.localize(195,null)})),multiCursorPaste:Te(new c(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(196,null),m.localize(197,null)],markdownDescription:m.localize(198,null)})),occurrencesHighlight:Te(new f(71,"occurrencesHighlight",!0,{description:m.localize(199,null)})),overviewRulerBorder:Te(new f(72,"overviewRulerBorder",!0,{description:m.localize(200,null)})),overviewRulerLanes:Te(new w(73,"overviewRulerLanes",3,0,3)),padding:Te(new B),parameterHints:Te(new X),peekWidgetDefaultFocus:Te(new c(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(201,null),m.localize(202,null)],description:m.localize(203,null)})),definitionLinkOpensInPeek:Te(new f(77,"definitionLinkOpensInPeek",!1,{description:m.localize(204,null)})),quickSuggestions:Te(new de),quickSuggestionsDelay:Te(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(205,null)})),readOnly:Te(new f(80,"readOnly",!1)),renameOnType:Te(new f(81,"renameOnType",!1,{description:m.localize(206,null),markdownDeprecationMessage:m.localize(207,null)})),renderControlCharacters:Te(new f(82,"renderControlCharacters",!1,{description:m.localize(208,null)})),renderFinalNewline:Te(new f(83,"renderFinalNewline",!0,{description:m.localize(209,null)})),renderLineHighlight:Te(new c(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(210,null)],description:m.localize(211,null)})),renderLineHighlightOnlyWhenFocus:Te(new f(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(212,null)})),renderValidationDecorations:Te(new c(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new c(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(213,null),m.localize(214,null),m.localize(215,null),""],description:m.localize(216,null)})),revealHorizontalRightPadding:Te(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new f(89,"roundedSelection",!0,{description:m.localize(217,null)})),rulers:Te(new Be),scrollbar:Te(new He),scrollBeyondLastColumn:Te(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(218,null)})),scrollBeyondLastLine:Te(new f(93,"scrollBeyondLastLine",!0,{description:m.localize(219,null)})),scrollPredominantAxis:Te(new f(94,"scrollPredominantAxis",!0,{description:m.localize(220,null)})),selectionClipboard:Te(new f(95,"selectionClipboard",!0,{description:m.localize(221,null),included:F.isLinux})),selectionHighlight:Te(new f(96,"selectionHighlight",!0,{description:m.localize(222,null)})),selectOnLineNumbers:Te(new f(97,"selectOnLineNumbers",!0)),showFoldingControls:Te(new c(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(223,null),m.localize(224,null)],description:m.localize(225,null)})),showUnused:Te(new f(99,"showUnused",!0,{description:m.localize(226,null)})),showDeprecated:Te(new f(124,"showDeprecated",!0,{description:m.localize(227,null)})),inlayHints:Te(new x),snippetSuggestions:Te(new c(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null)],description:m.localize(232,null)})),smartSelect:Te(new Z),smoothScrolling:Te(new f(102,"smoothScrolling",!1,{description:m.localize(233,null)})),stopRenderingLineAfter:Te(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new le),inlineSuggest:Te(new q),suggestFontSize:Te(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(234,null)})),suggestLineHeight:Te(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(235,null)})),suggestOnTriggerCharacters:Te(new f(108,"suggestOnTriggerCharacters",!0,{description:m.localize(236,null)})),suggestSelection:Te(new c(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(237,null),m.localize(238,null),m.localize(239,null)],description:m.localize(240,null)})),tabCompletion:Te(new c(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(241,null),m.localize(242,null),m.localize(243,null)],description:m.localize(244,null)})),tabIndex:Te(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Te(new c(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(245,null),m.localize(246,null),m.localize(247,null)],description:m.localize(248,null)})),useShadowDOM:Te(new f(113,"useShadowDOM",!0)),useTabStops:Te(new f(114,"useTabStops",!0,{description:m.localize(249,null)})),wordSeparators:Te(new I(115,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:m.localize(250,null)})),wordWrap:Te(new c(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null),m.localize(254,null)],description:m.localize(255,null)})),wordWrapBreakAfterCharacters:Te(new I(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new I(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(256,null)})),wordWrapOverride1:Te(new c(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new c(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[m.localize(257,null),m.localize(258,null),m.localize(259,null),m.localize(260,null)],description:m.localize(261,null)})),wrappingStrategy:Te(new c(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(262,null),m.localize(263,null)],description:m.localize(264,null)})),editorClassName:Te(new p),pixelRatio:Te(new Q),tabFocusMode:Te(new ae),layoutInfo:Te(new j),wrappingInfo:Te(new je)}}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[180],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[181],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var F;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var C;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[182],me([0,1,159]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||F.test(l)}e.isValidVersionStr=y;function A(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=l.match(F);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function _(l){if(!l)return null;let f=l.majorBase,d=l.majorMustEqual,w=l.minorBase,D=l.minorMustEqual,I=l.patchBase,b=l.patchMustEqual;l.hasCaret&&(f===0||(D=!1),b=!1);let c=0;if(l.preRelease){const o=C.exec(l.preRelease);if(o){const[,v,t,h]=o;c=Date.UTC(Number(v),Number(t)-1,Number(h))}}return{majorBase:f,majorMustEqual:d,minorBase:w,minorMustEqual:D,patchBase:I,patchMustEqual:b,isMinimum:l.hasGreaterEquals,notBefore:c}}e.normalizeVersion=_;function S(l,f,d){let w;typeof l=="string"?w=_(A(l)):w=l;let D;f instanceof Date?D=f.getTime():typeof f=="string"&&(D=new Date(f).getTime());let I;if(typeof d=="string"?I=_(A(d)):I=d,!w||!I)return!1;let b=w.majorBase,c=w.minorBase,o=w.patchBase,v=I.majorBase,t=I.minorBase,h=I.patchBase,s=I.notBefore,n=I.majorMustEqual,r=I.minorMustEqual,a=I.patchMustEqual;return I.isMinimum?b>v?!0:b<v?!1:c>t?!0:c<t||D&&D<s?!1:o>=h:(b===1&&v===0&&(!n||!r||!a)&&(v=1,t=0,h=0,n=!0,r=!1,a=!1),b<v?!1:b>v?!n:c<t?!1:c>t?!r:o<h?!1:o>h?!a:!(D&&D<s))}e.isValidVersion=S;function P(l,f,d,w){return d.isBuiltin||typeof d.main=="undefined"?!0:k(l,f,d.engines.vscode,w)}e.isValidExtensionVersion=P;function i(l,f,d){return l==="*"||k(f,d,l)}e.isEngineValid=i;function k(l,f,d,w=[]){let D=_(A(d));if(!D)return w.push(m.localize(0,null,d)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return w.push(m.localize(1,null,d)),!1}else if(!D.majorMustEqual)return w.push(m.localize(2,null,d)),!1;return S(l,f,D)?!0:(w.push(m.localize(3,null,l,d)),!1)}}),define(fe[116],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(C,y=[],A=!1){this.ctor=C,this.staticArguments=y,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=m}),define(fe[83],me([0,1,116]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function C(A,_,S){_ instanceof m.SyncDescriptor||(_=new m.SyncDescriptor(_,[],S)),F.push([A,_])}e.registerSingleton=C;function y(){return F}e.getSingletonServiceDescriptors=y}),define(fe[183],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class F{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const _=this.lookupOrInsertNode(y),S=this.lookupOrInsertNode(A);_.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(y),_)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let _ of this._nodes.values())_.outgoing.delete(A),_.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let _=this._nodes.get(A);return _||(_=new m(y),this._nodes.set(A,_)),_}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,_]of this._nodes)y.push(`${A}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const _=new Set([y]),S=this._findCycle(A,_);if(S)return S}}_findCycle(y,A){for(let[_,S]of y.outgoing){if(A.has(_))return[...A,_].join(" -> ");A.add(_);const P=this._findCycle(S,A);if(P)return P;A.delete(_)}}}e.Graph=F}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function S(P){return P[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=S})(m=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function F(_,S,P,i){S[m.DI_TARGET]===S?S[m.DI_DEPENDENCIES].push({id:_,index:P,optional:i}):(S[m.DI_DEPENDENCIES]=[{id:_,index:P,optional:i}],S[m.DI_TARGET]=S)}function C(_){if(m.serviceIds.has(_))return m.serviceIds.get(_);const S=function(P,i,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(S,P,k,!1)};return S.toString=()=>_,m.serviceIds.set(_,S),S}e.createDecorator=C;function y(_){return _}e.refineServiceDecorator=y;function A(_){return function(S,P,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(_,S,i,!0)}}e.optional=A}),define(fe[184],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function F(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(fe[185],me([0,1,3,48,6,24,78,82,184]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(P):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(D,I){let b={selector:D,provider:I,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(b){let c=this._entries.indexOf(b);c>=0&&(this._entries.splice(c,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const I=[];for(let b of this._entries)b._score>0&&I.push(b.provider);return I}ordered(D){const I=[];return this._orderedForEach(D,b=>I.push(b.provider)),I}orderedGroups(D){const I=[];let b,c;return this._orderedForEach(D,o=>{b&&c===o._score?b.push(o.provider):(c=o._score,b=[o.provider],I.push(b))}),I}_orderedForEach(D,I){if(!!D){this._updateScores(D);for(const b of this._entries)b._score>0&&I(b)}}_updateScores(D){let I={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let b of this._entries)if(b._score=(0,_.score)(b.selector,D.uri,D.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(D)),P(b.selector)&&b._score>0){for(let c of this._entries)c._score=0;b._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(D,I){return D._score<I._score?1:D._score>I._score?-1:D._time<I._time?1:D._time>I._time?-1:0}}e.LanguageFeatureRegistry=i;const k=new WeakMap;let l=0;function f(w){let D=k.get(w);return D===void 0&&(D=++l,k.set(w,D)),D}class d{constructor(D,I,b=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=I,this.max=b,this._cache=new y.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((I,b)=>(0,F.doHash)(f(b),I),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const I=this._key(D),b=this._cache.get(I);return this._clamp(b?.value)}update(D,I){const b=this._key(D);let c=this._cache.get(b);return c||(c=new A.MovingAverage,this._cache.set(b,c)),c.update(I),this.get(D)}}e.LanguageFeatureRequestDelays=d}),define(fe[84],me([0,1,2,42,185,150,47]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var _;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));class S{constructor(T,L){this.language=T,this.id=L}}e.LanguageIdentifier=S;var P;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var i;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var k;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let L=this.getForeground(T),M="mtk"+L,R=this.getFontStyle(T);return R&1&&(M+=" mtki"),R&2&&(M+=" mtkb"),R&4&&(M+=" mtku"),M}static getInlineStyleFromMetadata(T,L){const M=this.getForeground(T),R=this.getFontStyle(T);let W=`color: ${L[M]};`;return R&1&&(W+="font-style: italic;"),R&2&&(W+="font-weight: bold;"),R&4&&(W+="text-decoration: underline;"),W}}e.TokenMetadata=f;var d;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(T){const L=g[T];let M=L&&A.iconRegistry.get(L);return M||(console.info("No codicon found for CompletionItemKind "+T),M=A.Codicon.symbolProperty),M.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(T,L){let M=g[T];return typeof M=="undefined"&&!L&&(M=9),M}}();var w;(function(g){g[g.Deprecated=1]="Deprecated"})(w=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(g){return g&&m.URI.isUri(g.uri)&&F.Range.isIRange(g.range)&&(F.Range.isIRange(g.originSelectionRange)||F.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=t;var h;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(h=e.SymbolKind||(e.SymbolKind={}));var s;(function(g){g[g.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(g){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function M(V){return T.get(V)}g.fromString=M;function R(V){return L.get(V)}g.toString=R;function W(V,N){const j=L.get(V);let U=j&&A.iconRegistry.get("symbol-"+j);return U||(console.info("No codicon found for SymbolKind "+V),U=A.Codicon.symbolProperty),`${N?"inline":"block"} ${U.classNames}`}g.toCssClassName=W})(n=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(T){this.value=T}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var a;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var p;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(p=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var E;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=m.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",m.isMacintosh),A.set("isLinux",m.isLinux),A.set("isWindows",m.isWindows),A.set("isWeb",m.isWeb),A.set("isMacNative",m.isMacintosh&&!m.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const _=Object.prototype.hasOwnProperty;var S;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return l.INSTANCE}static true(){return f.INSTANCE}static has(R){return d.create(R)}static equals(R,W){return w.create(R,W)}static notEquals(R,W){return b.create(R,W)}static regex(R,W){return s.create(R,W)}static in(R,W){return D.create(R,W)}static not(R){return c.create(R)}static and(...R){return a.create(R,null)}static or(...R){return u.create(R,null,!0)}static greater(R,W){return o.create(R,W)}static less(R,W){return t.create(R,W)}static deserialize(R,W=!1){if(!!R)return this._deserializeOrExpression(R,W)}static _deserializeOrExpression(R,W){let V=R.split("||");return u.create(V.map(N=>this._deserializeAndExpression(N,W)),null,!0)}static _deserializeAndExpression(R,W){let V=R.split("&&");return a.create(V.map(N=>this._deserializeOne(N,W)),null)}static _deserializeOne(R,W){if(R=R.trim(),R.indexOf("!=")>=0){let V=R.split("!=");return b.create(V[0].trim(),this._deserializeValue(V[1],W))}if(R.indexOf("==")>=0){let V=R.split("==");return w.create(V[0].trim(),this._deserializeValue(V[1],W))}if(R.indexOf("=~")>=0){let V=R.split("=~");return s.create(V[0].trim(),this._deserializeRegexValue(V[1],W))}if(R.indexOf(" in ")>=0){let V=R.split(" in ");return D.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const V=R.split(">=");return v.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const V=R.split(">");return o.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const V=R.split("<=");return h.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const V=R.split("<");return t.create(V[0].trim(),V[1].trim())}return/^\!\s*/.test(R)?c.create(R.substr(1).trim()):d.create(R)}static _deserializeValue(R,W){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;let V=/^'([^']*)'$/.exec(R);return V?V[1].trim():R}static _deserializeRegexValue(R,W){if((0,F.isFalsyOrWhitespace)(R)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let V=R.indexOf("/"),N=R.lastIndexOf("/");if(V===N||V<0){if(W)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}let j=R.slice(V+1,N),U=R[N+1]==="i"?"i":"";try{return new RegExp(j,U)}catch(x){if(W)throw new Error(`bad regexp-value '${R}', parse error: ${x}`);return console.warn(`bad regexp-value '${R}', parse error: ${x}`),null}}}e.ContextKeyExpr=P;function i(M,R){const W=M?M.substituteConstants():void 0,V=R?R.substituteConstants():void 0;return!W&&!V?!0:!W||!V?!1:W.equals(V)}e.expressionsAreEqualWithConstantSubstitution=i;function k(M,R){return M.cmp(R)}class l{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class f{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class d{constructor(R,W){this.key=R,this.negated=W,this.type=2}static create(R,W=null){const V=A.get(R);return typeof V=="boolean"?V?f.INSTANCE:l.INSTANCE:new d(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:E(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=A.get(this.key);return typeof R=="boolean"?R?f.INSTANCE:l.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class w{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=4}static create(R,W,V=null){if(typeof W=="boolean")return W?d.create(R,V):c.create(R,V);const N=A.get(R);return typeof N=="boolean"?W===(N?"true":"false")?f.INSTANCE:l.INSTANCE:new w(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=A.get(this.key);if(typeof R=="boolean"){const W=R?"true":"false";return this.value===W?f.INSTANCE:l.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class D{constructor(R,W){this.key=R,this.valueKey=W,this.type=10,this.negated=null}static create(R,W){return new D(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const W=R.getValue(this.valueKey),V=R.getValue(this.key);return Array.isArray(W)?W.indexOf(V)>=0:typeof V=="string"&&typeof W=="object"&&W!==null?_.call(W,V):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this)),this.negated}}e.ContextKeyInExpr=D;class I{constructor(R){this._actual=R,this.type=11}static create(R){return new I(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new I(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class b{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=5}static create(R,W,V=null){if(typeof W=="boolean")return W?c.create(R,V):d.create(R,V);const N=A.get(R);return typeof N=="boolean"?W===(N?"true":"false")?l.INSTANCE:f.INSTANCE:new b(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=A.get(this.key);if(typeof R=="boolean"){const W=R?"true":"false";return this.value===W?l.INSTANCE:f.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class c{constructor(R,W){this.key=R,this.negated=W,this.type=3}static create(R,W=null){const V=A.get(R);return typeof V=="boolean"?V?l.INSTANCE:f.INSTANCE:new c(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:E(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=A.get(this.key);return typeof R=="boolean"?R?l.INSTANCE:f.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=c;class o{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=12}static create(R,W,V=null){return new o(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class v{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=13}static create(R,W,V=null){return new v(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class t{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=14}static create(R,W,V=null){return new t(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class h{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=15}static create(R,W,V=null){return new h(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class s{constructor(R,W){this.key=R,this.regexp=W,this.type=7,this.negated=null}static create(R,W){return new s(R,W)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const W=this.regexp?this.regexp.source:"",V=R.regexp?R.regexp.source:"";return W<V?-1:W>V?1:0}equals(R){if(R.type===this.type){const W=this.regexp?this.regexp.source:"",V=R.regexp?R.regexp.source:"";return this.key===R.key&&W===V}return!1}substituteConstants(){return this}evaluate(R){let W=R.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(R){this._actual=R,this.type=8}static create(R){return new n(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new n(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function r(M){let R=null;for(let W=0,V=M.length;W<V;W++){const N=M[W].substituteConstants();if(M[W]!==N&&R===null){R=[];for(let j=0;j<W;j++)R[j]=M[j]}R!==null&&(R[W]=N)}return R===null?M:R}class a{constructor(R,W){this.expr=R,this.negated=W,this.type=6}static create(R,W){return a._normalizeArr(R,W)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,V=this.expr.length;W<V;W++){const N=k(this.expr[W],R.expr[W]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,V=this.expr.length;W<V;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=r(this.expr);return R===this.expr?this:a.create(R,this.negated)}evaluate(R){for(let W=0,V=this.expr.length;W<V;W++)if(!this.expr[W].evaluate(R))return!1;return!0}static _normalizeArr(R,W){const V=[];let N=!1;for(const j of R)if(!!j){if(j.type===1){N=!0;continue}if(j.type===0)return l.INSTANCE;if(j.type===6){V.push(...j.expr);continue}V.push(j)}if(V.length===0&&N)return f.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(k);for(let j=1;j<V.length;j++)V[j-1].equals(V[j])&&(V.splice(j,1),j--);if(V.length===1)return V[0];for(;V.length>1;){const j=V[V.length-1];if(j.type!==9)break;V.pop();const U=V.pop(),x=V.length===0,z=u.create(j.expr.map(O=>a.create([O,U],null)),null,x);z&&(V.push(z),V.sort(k))}return V.length===1?V[0]:new a(V,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(let W of this.expr)R.push(...W.keys());return R}map(R){return new a(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.negated){const R=[];for(let W of this.expr)R.push(W.negate());this.negated=u.create(R,this,!0)}return this.negated}}class u{constructor(R,W){this.expr=R,this.negated=W,this.type=9}static create(R,W,V){return u._normalizeArr(R,W,V)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,V=this.expr.length;W<V;W++){const N=k(this.expr[W],R.expr[W]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,V=this.expr.length;W<V;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=r(this.expr);return R===this.expr?this:u.create(R,this.negated,!1)}evaluate(R){for(let W=0,V=this.expr.length;W<V;W++)if(this.expr[W].evaluate(R))return!0;return!1}static _normalizeArr(R,W,V){let N=[],j=!1;if(R){for(let U=0,x=R.length;U<x;U++){const z=R[U];if(!!z){if(z.type===0){j=!0;continue}if(z.type===1)return f.INSTANCE;if(z.type===9){N=N.concat(z.expr);continue}N.push(z)}}if(N.length===0&&j)return l.INSTANCE;N.sort(k)}if(N.length!==0){if(N.length===1)return N[0];for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];if(V){for(let U=0;U<N.length;U++)for(let x=U+1;x<N.length;x++)T(N[U],N[x])&&(N.splice(x,1),x--);if(N.length===1)return N[0]}return new u(N,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(let W of this.expr)R.push(...W.keys());return R}map(R){return new u(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.negated){let R=[];for(let W of this.expr)R.push(W.negate());for(;R.length>1;){const W=R.shift(),V=R.shift(),N=[];for(const U of L(W))for(const x of L(V))N.push(a.create([U,x],null));const j=R.length===0;R.unshift(u.create(N,null,j))}this.negated=R[0]}return this.negated}}class p extends d{constructor(R,W,V){super(R,null);this._defaultValue=W,typeof V=="object"?p._info.push({...V,key:R}):V!==!0&&p._info.push({key:R,description:V,type:W!=null?typeof W:void 0})}static all(){return p._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return w.create(this.key,R)}notEqualsTo(R){return b.create(this.key,R)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(M,R){return M<R?-1:M>R?1:0}function g(M,R,W,V){return M<W?-1:M>W?1:R<V?-1:R>V?1:0}function T(M,R){if(R.type===6&&M.type!==9&&M.type!==6){for(const N of R.expr)if(M.equals(N))return!0}const W=M.negate(),V=L(W).concat(L(R));V.sort(k);for(let N=0;N<V.length;N++){const U=V[N].negate();for(let x=N+1;x<V.length;x++){const z=V[x];if(U.equals(z))return!0}}return!1}e.implies=T;function L(M){return M.type===9?M.expr:[M]}}),define(fe[186],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[187],me([0,1,10,158,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var y;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function A(b){switch(b){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function _(b){switch(b){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function S(b,c){switch(b){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function P(b,c){return c==="web"&&!b.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function i(b,c,o){return P(c,o)?!1:b==="undefined"||b==="universal"?!0:b==="unknown"?!1:b===o?!0:k(o).includes(b)}e.isTargetPlatformCompatible=i;function k(b){switch(b){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function l(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=l;var f;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=10]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(f=e.SortBy||(e.SortBy={}));var d;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var w;(function(b){b.Install="install",b.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var D;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(c,o){super(c);this.code=o,this.name=o}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,F.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,F.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(fe[188],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(fe[189],me([0,1,39,10,8,11,96,28,114,160,188]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=P.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends l{openTerminal(o,v){return this.spawnTerminal(m,o,S.getWindowsShell(),v)}spawnTerminal(o,v,t,h){const s=v.windowsExec||f.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const n=C.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return o.spawn(s,h?[h]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(n==="wt"||n==="wt.exe")&&r.push("-d ."),new Promise((a,u)=>{const p=D(process),E=o.spawn(t,r,{cwd:h,env:p});E.on("error",u),E.on("exit",()=>a())})}runInTerminal(o,v,t,h,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows();return new Promise((r,a)=>{const u=`"${v} - ${k}"`,p=`""${t.join('" "')}" & pause"`,E=["/c","start",u,"/wait",n,"/c",p],g=Object.assign({},D(process),h);Object.keys(g).filter(M=>g[M]===null).forEach(M=>delete g[M]);const T={cwd:v,env:g,windowsVerbatimArguments:!0};m.spawn(f.CMD,E,T).on("error",M=>{a(I(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class d extends l{openTerminal(o,v){return this.spawnTerminal(m,o,v)}runInTerminal(o,v,t,h,s){const n=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(n===i.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const u=n===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,Y).fsPath,"-t",o||k,"-w",v];for(let L of t)E.push("-a"),E.push(L);if(h){const L=Object.assign({},D(process),h);for(let M in L){const R=L[M];R===null?(E.push("-u"),E.push(M)):(E.push("-e"),E.push(`${M}=${R}`))}}let g="";const T=m.spawn(d.OSASCRIPT,E);T.on("error",L=>{a(I(L))}),T.stderr.on("data",L=>{g+=L.toString()}),T.on("exit",L=>{if(L===0)r(void 0);else if(g){const M=g.split(`
`,1);a(new Error(M[0]))}else a(new Error(P.localize(1,null,u,L)))})}else a(new Error(P.localize(2,null,n)))})}spawnTerminal(o,v,t){const h=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const r=["-a",h];t&&r.push(t);const a=D(process),u=o.spawn("/usr/bin/open",r,{cwd:t,env:a});u.on("error",n),u.on("exit",()=>s())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class w extends l{openTerminal(o,v){return this.spawnTerminal(m,o,v)}runInTerminal(o,v,t,h,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{let u=[];n.then(p=>{p.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const E=`${b(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;u.push(`''${E}''`);const g=Object.assign({},D(process),h);Object.keys(g).filter(R=>g[R]===null).forEach(R=>delete g[R]);const T={cwd:v,env:g};let L="";const M=m.spawn(p,u,T);M.on("error",R=>{a(I(R))}),M.stderr.on("data",R=>{L+=R.toString()}),M.on("exit",R=>{if(R===0)r(void 0);else if(L){const W=L.split(`
`,1);a(new Error(W[0]))}else a(new Error(P.localize(4,null,p,R)))})})})}static async getDefaultTerminalLinuxReady(){return w._DEFAULT_TERMINAL_LINUX_READY||(w._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{y.isLinux?await _.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,v,t){const h=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{h.then(r=>{const a=D(process),u=o.spawn(r,[],{cwd:t,env:a});u.on("error",n),u.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=P.localize(3,null);function D(c){const o={...c.env};return(0,A.sanitizeProcessEnvironment)(o),o}function I(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(P.localize(5,null,c.path)):c}function b(c){let o="";for(let v of c)v.indexOf(" ")>=0?o+='"'+v+'"':o+=v,o+=" ";return o}}),define(fe[43],me([0,1,24,8,9,12,2,161,4]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function P(N){return N.create===!0}e.isFileOpenForWriteOptions=P;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var k;(function(N){N[N.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var l;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function d(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=d;function w(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function D(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=D;var I;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(j,U){super(j);this.code=U}}e.FileSystemProviderError=b;function c(N,j){const U=new b(N.toString(),j);return v(U,j),U}e.createFileSystemProviderError=c;function o(N){return N||c((0,_.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=o;function v(N,j){return N.name=j?`${j} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=v;function t(N){if(!N)return I.Unknown;if(N instanceof b)return N.code;const j=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!j)return I.Unknown;switch(j[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function h(N){if(N instanceof p)return N.fileOperationResult;switch(t(N)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(j,U,x){this.resource=j,this.operation=U,this.target=x}isOperation(j){return this.operation===j}}e.FileOperationEvent=n;var r;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class a{constructor(j,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const z of j){const O=x.get(z.type);O?O.push([z.resource,z]):x.set(z.type,[[z.resource,z]])}for(const[z,O]of x)switch(z){case 1:this.added=m.TernarySearchTree.forUris(()=>U),this.added.fill(O);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>U),this.updated.fill(O);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>U),this.deleted.fill(O);break}}contains(j,...U){return this.doContains(j,{includeChildren:!1},...U)}affects(j,...U){return this.doContains(j,{includeChildren:!0},...U)}doContains(j,U,...x){if(!j)return!1;const z=x.length>0;return!!((!z||x.includes(1))&&(this.added?.get(j)||U.includeChildren&&this.added?.findSuperstr(j))||(!z||x.includes(0))&&(this.updated?.get(j)||U.includeChildren&&this.updated?.findSuperstr(j))||(!z||x.includes(2))&&(this.deleted?.findSubstr(j)||U.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function u(N,j,U){return!N||!j||N===j||j.length>N.length?!1:(j.charAt(j.length-1)!==F.sep&&(j+=F.sep),U?(0,C.startsWithIgnoreCase)(N,j):N.indexOf(j)===0)}e.isParent=u;class p extends Error{constructor(j,U,x){super(j);this.fileOperationResult=U,this.options=x}}e.FileOperationError=p;class E extends p{constructor(j,U,x){super(j,2,x);this.stat=U}}e.NotModifiedSinceFileOperationError=E;var g;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function M(N,j){if(!j.hasProvider(A.URI.from({scheme:N.scheme})))return new Promise(U=>{const x=j.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===N.scheme&&z.added&&(x.dispose(),U())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(j){return(0,y.isNumber)(j)||(j=0),j<R.KB?(0,_.localize)(1,null,j.toFixed(0)):j<R.MB?(0,_.localize)(2,null,(j/R.KB).toFixed(2)):j<R.GB?(0,_.localize)(3,null,(j/R.MB).toFixed(2)):j<R.TB?(0,_.localize)(4,null,(j/R.GB).toFixed(2)):(0,_.localize)(5,null,(j/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var W;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function V(N){return{maxFileSize:N===0?300*R.MB:16*R.GB,maxHeapSize:N===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=V}),define(fe[85],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...C){this._entries=new Map;for(let[y,A]of C)this.set(y,A)}set(C,y){const A=this._entries.get(C);return this._entries.set(C,y),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=m}),define(fe[190],me([0,1,17,18,116,183,4,85]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new _.ServiceCollection,w=!1,D){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=D,this._services.set(A.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...w){let D=l.traceInvocation(d),I=!1;try{return d({get:(c,o)=>{if(I)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(c,D);if(!v&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return v}},...w)}finally{I=!0,D.stop()}}createInstance(d,...w){let D,I;return d instanceof C.SyncDescriptor?(D=l.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(w),D)):(D=l.traceCreation(d),I=this._createInstance(d,w,D)),D.stop(),I}_createInstance(d,w=[],D){let I=A._util.getServiceDependencies(d).sort((o,v)=>o.index-v.index),b=[];for(const o of I){let v=this._getOrCreateServiceInstance(o.id,D);if(!v&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);b.push(v)}let c=I.length>0?I[0].index:w.length;if(w.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${w.length} static arguments`);let o=c-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,c)}return new d(...[...w,...b])}_setServiceInstance(d,w){if(this._services.get(d)instanceof C.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let D=this._getServiceInstanceOrDescriptor(d);return D instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,D,w.branch(d,!0)):(w.branch(d,!1),D)}_safeCreateAndCacheServiceInstance(d,w,D){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,D)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,D){const I=new y.Graph(o=>o.id.toString());let b=0;const c=[{id:d,desc:w,_trace:D}];for(;c.length;){const o=c.pop();if(I.lookupOrInsertNode(o),b++>1e3)throw new P(I);for(let v of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${d} depends on ${v.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const h={id:v.id,desc:t,_trace:o._trace.branch(v.id,!0)};I.insertEdge(o,h),c.push(h)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:v}of o){if(this._getServiceInstanceOrDescriptor(v.id)instanceof C.SyncDescriptor){const h=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,h)}I.removeNode(v)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,D=[],I,b){if(this._services.get(d)instanceof C.SyncDescriptor)return this._createServiceInstance(w,D,I,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,D,I,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],D,I){if(D){const b=new m.IdleValue(()=>this._createInstance(d,w,I));return new Proxy(Object.create(null),{get(c,o){if(o in c)return c[o];let v=b.value,t=v[o];return typeof t!="function"||(t=t.bind(v),c[o]=t),t},set(c,o,v){return b.value[o]=v,!0}})}else return this._createInstance(d,w,I)}}e.InstantiationService=i;var k;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(k||(k={}));class l{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new l(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(d){return S?new l(0,d.name):l._None}branch(d,w){let D=new l(2,d.toString());return this._dep.push([d,w,D]),D}stop(){let d=Date.now()-this._start;l._totals+=d;let w=!1;function D(b,c){let o=[],v=new Array(b+1).join("	");for(const[t,h,s]of c._dep)if(h&&s){w=!0,o.push(`${v}CREATES -> ${t}`);let n=D(b+1,s);n&&o.push(n)}else o.push(`${v}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(I.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(fe[13],me([0,1,52,3,6,11,4]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function _(){return new Date().toISOString()}var S;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class P extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class i extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...h){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...h]))}debug(t,...h){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...h]))}info(t,...h){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...h]))}warn(t,...h){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...h]))}error(t,...h){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...h]))}critical(t,...h){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...h]))}flush(){}format(t){let h="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(r){}h+=(s>0?" ":"")+n}return h}}e.AbstractMessageLogger=i;class k extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!y.isWindows}trace(t,...h){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...h):console.log(`[main ${_()}]`,t,...h))}debug(t,...h){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...h):console.log(`[main ${_()}]`,t,...h))}info(t,...h){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...h):console.log(`[main ${_()}]`,t,...h))}warn(t,...h){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,t,...h):console.warn(`[main ${_()}]`,t,...h))}error(t,...h){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,t,...h):console.error(`[main ${_()}]`,t,...h))}critical(t,...h){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,t,...h):console.error(`[main ${_()}]`,t,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class l extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...h){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...h)}debug(t,...h){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...h)}info(t,...h){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...h)}warn(t,...h){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...h)}error(t,...h){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...h)}critical(t,...h){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...h)}dispose(){}flush(){}}e.ConsoleLogger=l;class f extends P{constructor(t,h=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(h)}trace(t,...h){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...h])}debug(t,...h){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...h])}info(t,...h){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...h])}warn(t,...h){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...h])}error(t,...h){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...h])}critical(t,...h){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...h])}extractMessage(t){return typeof t=="string"?t:(0,m.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class d extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const h of this.logServices)h.setLevel(t);super.setLevel(t)}trace(t,...h){for(const s of this.logServices)s.trace(t,...h)}debug(t,...h){for(const s of this.logServices)s.debug(t,...h)}info(t,...h){for(const s of this.logServices)s.info(t,...h)}warn(t,...h){for(const s of this.logServices)s.warn(t,...h)}error(t,...h){for(const s of this.logServices)s.error(t,...h)}critical(t,...h){for(const s of this.logServices)s.critical(t,...h)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends C.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...h){this.logger.trace(t,...h)}debug(t,...h){this.logger.debug(t,...h)}info(t,...h){this.logger.info(t,...h)}warn(t,...h){this.logger.warn(t,...h)}error(t,...h){this.logger.error(t,...h)}critical(t,...h){this.logger.critical(t,...h)}flush(){this.logger.flush()}}e.LogService=w;class D extends C.Disposable{constructor(t,h){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(h(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,h){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,h?.always?S.Trace:this.logLevel,h),this.loggers.set(t.toString(),s),h?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class I{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...h){}debug(t,...h){}info(t,...h){}warn(t,...h){}error(t,...h){}critical(t,...h){}dispose(){}flush(){}}e.NullLogService=I;function b(v){if(v.verbose)return S.Trace;if(typeof v.logLevel=="string"){const t=c(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function c(v){switch(v){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=c;function o(v){switch(v){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(fe[117],me([0,1,43,13]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(S,P,i,k){try{const l=await new Promise((f,d)=>{Y(["spdlog"],f,d)});return l.setFlushOn(F.LogLevel.Trace),l.createAsyncRotatingLogger(S,P,i,k)}catch(l){console.error(l)}return null}function y(S,P,i,k){const l=Y.__$__nodeRequire("spdlog");return l.setFlushOn(F.LogLevel.Trace),l.createRotatingLogger(S,P,i,k)}e.createRotatingLogger=y;function A(S,P,i){switch(P){case F.LogLevel.Trace:S.trace(i);break;case F.LogLevel.Debug:S.debug(i);break;case F.LogLevel.Info:S.info(i);break;case F.LogLevel.Warning:S.warn(i);break;case F.LogLevel.Error:S.error(i);break;case F.LogLevel.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}class _ extends F.AbstractMessageLogger{constructor(P,i,k,l){super();this.name=P,this.filepath=i,this.rotating=k,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const P=this.rotating?6:1,i=30/P*m.ByteSize.MB;return C(this.name,this.filepath,i,P).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:l,message:f}of this.buffer)A(this._logger,l,f);this.buffer=[]}})}log(P,i){this._logger?A(this._logger,P,i):this.getLevel()<=P&&this.buffer.push({level:P,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(fe[118],me([0,1,49,162,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(d,w){return w-d}S.compare=P;const i=Object.create(null);i[S.Error]=(0,F.localize)(0,null),i[S.Warning]=(0,F.localize)(1,null),i[S.Info]=(0,F.localize)(2,null);function k(d){return i[d]||""}S.toString=k;function l(d){switch(d){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=l;function f(d){switch(d){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var _;(function(S){const P="";function i(l){return k(l,!0)}S.makeKey=i;function k(l,f){let d=[P];return l.source?d.push(l.source.replace("\xA6","\\\xA6")):d.push(P),l.code?typeof l.code=="string"?d.push(l.code.replace("\xA6","\\\xA6")):d.push(l.code.value.replace("\xA6","\\\xA6")):d.push(P),l.severity!==void 0&&l.severity!==null?d.push(A.toString(l.severity)):d.push(P),l.message&&f?d.push(l.message.replace("\xA6","\\\xA6")):d.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?d.push(l.startLineNumber.toString()):d.push(P),l.startColumn!==void 0&&l.startColumn!==null?d.push(l.startColumn.toString()):d.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?d.push(l.endLineNumber.toString()):d.push(P),l.endColumn!==void 0&&l.endColumn!==null?d.push(l.endColumn.toString()):d.push(P),d.push(P),d.join("\xA6")}S.makeKeyOptionalMessage=k})(_=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(fe[191],me([0,1,3,49,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,C.createDecorator)("notificationService");var y;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class _{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=_;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S}),define(fe[192],me([0,1,6,9,2,4]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function A(_,S){return C.URI.isUri(_)?(0,F.equalsIgnoreCase)(_.scheme,S):(0,F.startsWithIgnoreCase)(_,S+":")}e.matchesScheme=A}),define(fe[193],me([0,1,10,11,38,23]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const _=F.globals.vscode.context.configuration();if(_)A=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const _=(0,y.dirname)(m.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,y.joinPath)(_,"product.json").fsPath);const S=Y.__$__nodeRequire((0,y.joinPath)(_,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:S.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var $e=this&&this.__param||function(Y,e){return function(m,F){e(m,F,Y)}};define(fe[119],me([0,1,17,21,6,4]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,y.createDecorator)("progressService");var A;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class _{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=_,_.None=Object.freeze({report(){}});let S=class extends C.Disposable{constructor(k,l){super();this.deferred=new m.DeferredPromise,l.withProgress(k,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=Ve([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends C.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const l=++this.currentOperationId,f=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:f.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,y.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,58,12]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,_){m.ok(F.isString(A)),m.ok(F.isObject(_)),m.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,_)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(fe[120],me([0,1,3,34]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class y{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[C(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;F.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[86],me([0,1,16,3,12,157,120,34]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=_.Registry.as(A.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const v=this.doRegisterConfigurations(c,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:c,remove:o}){const v=[];v.push(...this.doDeregisterConfigurations(o)),v.push(...this.doRegisterConfigurations(c,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,m.distinct)(v))}registerDefaultConfigurations(c){const o=[],v=[];for(const t of c)for(const h in t)if(o.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]={...this.defaultValues[h]||{},...t[h]};const s={type:"object",default:this.defaultValues[h],description:y.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};v.push(f(h)),this.configurationProperties[h]=s,this.defaultLanguageConfigurationOverridesNode.properties[h]=s}else{this.defaultValues[h]=t[h];const s=this.configurationProperties[h];s&&(this.updatePropertyDefaultValue(h,s),this.updateSchema(h,s))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(c){const o=[];for(const v of c)for(const t in v)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const v=[];return c.forEach(t=>{v.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),v}doDeregisterConfigurations(c){const o=[],v=t=>{if(t.properties)for(const h in t.properties)o.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,t.properties[h]);t.allOf&&t.allOf.forEach(h=>v(h))};for(const t of c){v(t);const h=this.configurationContributors.indexOf(t);h!==-1&&this.configurationContributors.splice(h,1)}return o}validateAndRegisterProperties(c,o=!0,v,t=3){t=C.isUndefinedOrNull(c.scope)?t:c.scope;let h=[],s=c.properties;if(s)for(let r in s){if(o&&D(r)){delete s[r];continue}const a=s[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=C.isUndefinedOrNull(a.scope)?t:a.scope,a.restricted=C.isUndefinedOrNull(a.restricted)?!!v?.restrictedConfigurations?.includes(r):a.restricted),s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),h.push(r)}let n=c.allOf;if(n)for(let r of n)h.push(...this.validateAndRegisterProperties(r,o,v,t));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const o=v=>{let t=v.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);let h=v.allOf;h&&h.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,v={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,v),e.allSettings.properties[o]=v,e.applicationSettings.properties[o]=v,e.machineSettings.properties[o]=v,e.machineOverridableSettings.properties[o]=v,e.windowSettings.properties[o]=v,e.resourceSettings.properties[o]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){let v=this.defaultValues[c];C.isUndefined(v)&&(v=o.default),C.isUndefined(v)&&(v=d(o.type)),o.default=v}}const l="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(l);function f(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=f;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const w=new k;_.Registry.add(e.Extensions.Configuration,w);function D(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?y.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?y.localize(6,null,b):null:y.localize(4,null)}e.validateProperty=D;function I(){const b=[],c=w.getConfigurationProperties();for(const o of Object.keys(c))b.push([o,c[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=I}),define(fe[121],me([0,1,25,12,2,86,4,34]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function S(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof C.URI)}e.isConfigurationOverrides=S;var P;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function k(h,s){const n=s?h?s.keys.filter(T=>h.keys.indexOf(T)===-1):[...s.keys]:[],r=h?s?h.keys.filter(T=>s.keys.indexOf(T)===-1):[...h.keys]:[],a=[];if(s&&h){for(const T of h.keys)if(s.keys.indexOf(T)!==-1){const L=I(h.contents,T),M=I(s.contents,T);m.equals(L,M)||a.push(T)}}const u=[],p=T=>{const L={};for(const M of T)for(const R of M.identifiers)L[v(R)]=M;return L},E=s?p(s.overrides):{},g=h?p(h.overrides):{};if(Object.keys(E).length)for(const T of n){const L=E[T];L&&u.push([(0,y.overrideIdentifierFromKey)(T),L.keys])}if(Object.keys(g).length)for(const T of r){const L=g[T];L&&u.push([(0,y.overrideIdentifierFromKey)(T),L.keys])}if(Object.keys(E).length&&Object.keys(g).length)for(const T of a){const L=g[T],M=E[T];if(L&&M){const R=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});u.push([(0,y.overrideIdentifierFromKey)(T),[...R.added,...R.removed,...R.updated]])}}return{added:n,removed:r,updated:a,overrides:u}}e.compare=k;function l(h,s){const n=[];for(const r of Object.keys(h))if(y.OVERRIDE_PROPERTY_PATTERN.test(r)){const a={};for(const u in h[r])a[u]=h[r][u];n.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(a),contents:f(a,s)})}return n}e.toOverrides=l;function f(h,s){const n=Object.create(null);for(let r in h)d(n,r,h[r],s);return n}e.toValuesTree=f;function d(h,s,n,r){const a=s.split("."),u=a.pop();let p=h;for(let E=0;E<a.length;E++){let g=a[E],T=p[g];switch(typeof T){case"undefined":T=p[g]=Object.create(null);break;case"object":break;default:r(`Ignoring ${s} as ${a.slice(0,E+1).join(".")} is ${JSON.stringify(T)}`);return}p=T}if(typeof p=="object"&&p!==null)try{p[u]=n}catch(E){r(`Ignoring ${s} as ${a.join(".")} is ${JSON.stringify(p)}`)}else r(`Ignoring ${s} as ${a.join(".")} is ${JSON.stringify(p)}`)}e.addToValueTree=d;function w(h,s){const n=s.split(".");D(h,n)}e.removeFromValueTree=w;function D(h,s){const n=s.shift();if(s.length===0){delete h[n];return}if(Object.keys(h).indexOf(n)!==-1){const r=h[n];typeof r=="object"&&!Array.isArray(r)&&(D(r,s),Object.keys(r).length===0&&delete h[n])}}function I(h,s,n){function r(p,E){let g=p;for(const T of E){if(typeof g!="object"||g===null)return;g=g[T]}return g}const a=s.split("."),u=r(h,a);return typeof u=="undefined"?n:u}e.getConfigurationValue=I;function b(h,s,n){Object.keys(s).forEach(r=>{r!=="__proto__"&&(r in h?F.isObject(h[r])&&F.isObject(s[r])?b(h[r],s[r],n):n&&(h[r]=s[r]):h[r]=s[r])})}e.merge=b;function c(){const h=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(h)}e.getConfigurationKeys=c;function o(){const h=Object.create(null),s=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let n in s){let r=s[n].default;d(h,n,r,a=>console.error(`Conflict in default settings: ${a}`))}return h}e.getDefaultValues=o;function v(h){return`[${h}]`}e.keyFromOverrideIdentifier=v;function t(h,s,n){const r=h.inspect(s),a=h.inspect(n);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:r.defaultValue}e.getMigratedSettingValue=t}),define(fe[194],me([0,1,16,3,61,6,24,25,12,2,121,86,34]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},h=[],s=[]){this._contents=t,this._keys=h,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,h){const s=this.getContentsForOverrideIdentifer(h);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const h of this.overrides)if(h.identifiers.indexOf(t)!==-1)return h.keys;return[]}override(t){let h=this.overrideConfigurations.get(t);return h||(h=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,h)),h}merge(...t){const h=_.deepClone(this.contents),s=_.deepClone(this.overrides),n=[...this.keys];for(const r of t){this.mergeContents(h,r.contents);for(const a of r.overrides){const[u]=s.filter(p=>m.equals(p.identifiers,a.identifiers));u?this.mergeContents(u.contents,a.contents):s.push(_.deepClone(a))}for(const a of r.keys)n.indexOf(a)===-1&&n.push(a)}return new f(h,n,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const h=this.getContentsForOverrideIdentifer(t);if(!h||typeof h!="object"||!Object.keys(h).length)return this;let s={};for(const n of m.distinct([...Object.keys(this.contents),...Object.keys(h)])){let r=this.contents[n],a=h[n];a&&(typeof r=="object"&&typeof a=="object"?(r=_.deepClone(r),this.mergeContents(r,a)):r=a),s[n]=r}return new f(s,this.keys,this.overrides)}mergeContents(t,h){for(const s of Object.keys(h)){if(s in t&&S.isObject(t[s])&&S.isObject(h[s])){this.mergeContents(t[s],h[s]);continue}t[s]=_.deepClone(h[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const h of this.overrides)if(h.identifiers.indexOf(t)!==-1)return h.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,h){this.addKey(t),(0,i.addToValueTree)(this.contents,t,h,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let h=this.keys.length;for(let s=0;s<h;s++)t.indexOf(this.keys[s])===0&&(h=s);this.keys.splice(h,1,t)}removeKey(t){let h=this.keys.indexOf(t);return h!==-1?(this.keys.splice(h,1),!0):!1}}e.ConfigurationModel=f;class d extends f{constructor(){const t=(0,i.getDefaultValues)(),h=(0,i.getConfigurationKeys)(),s=[];for(const n of Object.keys(t))k.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[(0,k.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],r=>console.error(`Conflict in default settings file: ${r}`))});super(t,h,s)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,h){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,h)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,h){this._raw=t;const{contents:s,keys:n,overrides:r,restricted:a}=this.doParseRaw(t,h);this._configurationModel=new f(s,n,r),this._restrictedConfigurations=a||[]}doParseContent(t){let h={},s=null,n=[],r=[],a=[];function u(E){Array.isArray(n)?n.push(E):s!==null&&(n[s]=E)}let p={onObjectBegin:()=>{let E={};u(E),r.push(n),n=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{let E=[];u(E),r.push(n),n=E,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:u,onError:(E,g,T)=>{a.push({error:E,offset:g,length:T})}};if(t)try{C.visit(t,p),h=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return h}doParseRaw(t,h){const s=l.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,h);t=n.raw;const r=(0,i.toValuesTree)(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),a=Object.keys(t),u=(0,i.toOverrides)(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:r,keys:a,overrides:u,restricted:n.restricted}}filter(t,h,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const r={},a=[];for(let u in t)if(k.OVERRIDE_PROPERTY_PATTERN.test(u)&&s){const p=this.filter(t[u],h,!1,n);r[u]=p.raw,a.push(...p.restricted)}else{const p=h[u],E=p?typeof p.scope!="undefined"?p.scope:3:void 0;p?.restricted&&a.push(u),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&p?.restricted||(r[u]=t[u]))}return{raw:r,restricted:a}}}e.ConfigurationModelParser=w;class D extends y.Disposable{constructor(t,h,s,n){super();this.userSettingsResource=t,this.scopes=h,this.fileService=n,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class I{constructor(t,h,s=new f,n=new f,r=new A.ResourceMap,a=new f,u=new A.ResourceMap,p=!0){this._defaultConfiguration=t,this._localUserConfiguration=h,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=r,this._memoryConfiguration=a,this._memoryConfigurationByResource=u,this._freeze=p,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,h,s){return this.getConsolidateConfigurationModel(h,s).getValue(t)}updateValue(t,h,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new f,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,h===void 0?n.removeValue(t):n.setValue(t,h),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,h,s){const n=this.getConsolidateConfigurationModel(h,s),r=this.getFolderConfigurationModelForResource(h.resource,s),a=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,u=h.overrideIdentifier?this._defaultConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),p=h.overrideIdentifier?this.userConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=h.overrideIdentifier?this.localUserConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=h.overrideIdentifier?this.remoteUserConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=s?h.overrideIdentifier?this._workspaceConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=r?h.overrideIdentifier?r.freeze().override(h.overrideIdentifier).getValue(t):r.freeze().getValue(t):void 0,M=h.overrideIdentifier?a.override(h.overrideIdentifier).getValue(t):a.getValue(t),R=n.getValue(t),W=m.distinct(m.flatten(n.overrides.map(V=>V.identifiers))).filter(V=>n.getOverrideValue(t,V)!==void 0);return{defaultValue:u,userValue:p,userLocalValue:E,userRemoteValue:g,workspaceValue:T,workspaceFolderValue:L,memoryValue:M,value:R,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,user:p!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:r?.freeze().getValue(t),override:h.overrideIdentifier?r?.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:a.getValue(t),override:h.overrideIdentifier?a.getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const h=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:h?h.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,h){this._folderConfigurations.set(t,h),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,h){const s=h.filter(n=>k.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const r=(0,k.overrideIdentifierFromKey)(n),a=this._defaultConfiguration.getKeysForOverrideIdentifier(r),u=t.getKeysForOverrideIdentifier(r),p=[...u.filter(E=>a.indexOf(E)===-1),...a.filter(E=>u.indexOf(E)===-1),...a.filter(E=>!_.equals(this._defaultConfiguration.override(r).getValue(E),t.override(r).getValue(E)))];return[r,p]});return this.updateDefaultConfiguration(t),{keys:h,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:h,updated:s,removed:n,overrides:r}=(0,i.compare)(this.localUserConfiguration,t),a=[...h,...s,...n];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:h,updated:s,removed:n,overrides:r}=(0,i.compare)(this.remoteUserConfiguration,t);let a=[...h,...s,...n];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:h,updated:s,removed:n,overrides:r}=(0,i.compare)(this.workspaceConfiguration,t);let a=[...h,...s,...n];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:r}}compareAndUpdateFolderConfiguration(t,h){const s=this.folderConfigurations.get(t),{added:n,updated:r,removed:a,overrides:u}=(0,i.compare)(s,h);let p=[...n,...r,...a];return(p.length||!s)&&this.updateFolderConfiguration(t,h),{keys:p,overrides:u}}compareAndDeleteFolderConfiguration(t){const h=this.folderConfigurations.get(t);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:r,overrides:a}=(0,i.compare)(h,void 0);return{keys:[...s,...n,...r],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,h){let s=this.getConsolidatedConfigurationModelForResource(t,h);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},h){let s=this.getWorkspaceConsolidatedConfiguration();if(h&&t){const n=h.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const r=this._memoryConfigurationByResource.get(t);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let h=this._foldersConsolidatedConfigurations.get(t);if(!h){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(h=s.merge(n),this._freeze&&(h=h.freeze()),this._foldersConsolidatedConfigurations.set(t,h)):h=s}return h}getFolderConfigurationModelForResource(t,h){if(h&&t){const s=h.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,h)=>{const{contents:s,overrides:n,keys:r}=this._folderConfigurations.get(h);return t.push([h,{contents:s,overrides:n,keys:r}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(h=>t.add(h)),this.userConfiguration.freeze().keys.forEach(h=>t.add(h)),this._workspaceConfiguration.freeze().keys.forEach(h=>t.add(h)),this._folderConfigurations.forEach(h=>h.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>h.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>h.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>h.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>h.add(n))),[...h.values()]}static parse(t){const h=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),r=t.folders.reduce((a,u)=>(a.set(P.URI.revive(u[0]),this.parseConfigurationModel(u[1])),a),new A.ResourceMap);return new I(h,s,new f,n,r,new f,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,h=new Map;for(const n of v)n.keys.forEach(r=>t.add(r)),n.overrides.forEach(([r,a])=>{const u=(0,A.getOrSet)(h,r,new Set);a.forEach(p=>u.add(p))});const s=[];return h.forEach((n,r)=>s.push([r,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class c{constructor(t,h,s,n){this.change=t,this.previous=h,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const r=new Set;t.keys.forEach(u=>r.add(u)),t.overrides.forEach(([,u])=>u.forEach(p=>r.add(p))),this.affectedKeys=[...r.values()];const a=new f;this.affectedKeys.forEach(u=>a.setValue(u,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,h){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(h){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,h,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,h,this.currentWorkspace);return!_.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(t,h){let s=(0,i.toValuesTree)({[h]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=c;class o extends c{constructor(t,h,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,h);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=o}),define(fe[122],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var F;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(A,_=F.Unknown,S){super(A);this._message=A,this._code=_,this._detail=S,this.isHandled=_===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(A){return A instanceof C&&A._code===F.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof C&&A._code===F.NoResolverFound}static isHandled(A){return A instanceof C&&A.isHandled}}e.RemoteAuthorityResolverError=C}),define(fe[64],me([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(P){return P.scheme===m.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=F;function C(P){if(!P)return;const i=P.indexOf("+");return i<0?P:P.substr(0,i)}e.getRemoteName=C;function y(P){return P.scheme!==m.Schemas.file&&P.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=y;function A(P){if(P.folders.length)return P.folders.every(i=>y(i.uri))?P.folders[0].uri:void 0;if(P.configuration&&y(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function _(P){return A(P)?.scheme}e.getVirtualWorkspaceScheme=_;function S(P){return A(P)!==void 0}e.isVirtualWorkspace=S}),define(fe[26],me([0,1,9,4,64]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function y(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=y;function A(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class S{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,d){if(typeof f=="undefined"||f===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof f=="string"||typeof d=="string"){let w=typeof f=="string"?f:f.value,D=typeof d=="string"?d:d.value;return m.equalsIgnoreCase(w,D)}return f._lower===d._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=S;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function i(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function k(l,f){if(f&&l.enableProposedApi){const d=`onResolveRemoteAuthority:${(0,C.getRemoteName)(f)}`;return l.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,9,26]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(d,w){return d.uuid&&w.uuid?d.uuid===w.uuid:d.id===w.id?!0:(0,m.compareIgnoreCase)(d.id,w.id)===0}e.areSameExtensions=C;class y{constructor(w,D){this.version=D,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof y?C(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(d,w){return`${d}.${w}`}e.getExtensionId=A;function _(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=_;function S(d,w){return _(A(d,w))}e.getGalleryExtensionId=S;function P(d,w){const D=[],I=b=>{for(const c of D)if(c.some(o=>C(w(o),w(b))))return c;return null};for(const b of d){const c=I(b);c?c.push(b):D.push([b])}return D}e.groupByExtension=P;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function k(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function l(d){const w=new Set;for(const D of d)D.malicious&&w.add(D.id.id);return w}e.getMaliciousExtensionsSet=l;function f(d,w){const D=[],I=w.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const b=I.shift();if(b&&D.every(c=>!C(c.identifier,{id:b}))){const c=d.filter(o=>C(o.identifier,{id:b}));c.length===1&&(D.push(c[0]),I.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=f}),define(fe[123],me([0,1,3,11,4,13]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var _;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(_=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=k;function l(d,w){return w?w!==1&&d<1024:!F.isWindows&&d<1024}e.isPortPrivileged=l;let f=class{constructor(w){this.logService=w,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,D){return this._tunnelProvider=w,w?(this._canElevate=D.elevation,this._privacyOptions=D.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async w=>{const D=[],I=Array.from(this._tunnels.values());for(let b of I){const c=Array.from(b.values());for(let o of c){const v=await o.value;v&&D.push(v)}}w(D)})}async dispose(){for(const w of this._tunnels.values()){for(const{value:D}of w.values())await D.then(I=>I?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,D,I,b,c=!1,o=_.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${D}:${I} on local port ${b}.`),!w)return;D||(D="localhost");const t=this.retainOrCreateTunnel(w,D,I,b,c,o,v);return t?t.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(D,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(h);return(h.tunnelRemoteHost!==D||h.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const D=this._tunnels.get(w.tunnelRemoteHost);if(D){const I=D.get(w.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,I))}}}}async tryDisposeTunnel(w,D,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${D}.`);const b=I.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(D),b}}async closeTunnel(w,D){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${D} `);const I=this._tunnels.get(w);if(I&&I.has(D)){const b=I.get(D);b.refcount=0,await this.tryDisposeTunnel(w,D,b)}}addTunnelToMap(w,D,I){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(D,{refcount:1,value:I})}async removeEmptyTunnelFromMap(w,D){const I=this._tunnels.get(w);I&&(await I.get(D)||I.delete(D),I.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,D){let I=[w];i(w)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):k(w)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const b=I.map(c=>this._tunnels.get(c));for(const c of b){const o=c?.get(D);if(o)return o}}canTunnel(w){return!!P(w)}createWithProvider(w,D,I,b,c,o,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${D}:${I} on local port ${b}.`);const h={elevationRequired:c?l(b===void 0?I:b):!1},s={remoteAddress:{host:D,port:I},localAddressPort:b,privacy:o,public:o!==_.Private,protocol:v},n=w.forwardPort(s,h);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(D,I,n),n}};f=Ve([$e(0,y.ILogService)],f),e.AbstractTunnelService=f}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((C,y)=>Y(["vsda"],C,y))}async sign(C){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(C)}catch(y){}return C}}e.SignService=m}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,y,A=5){let _;return _=y(S=>{const P=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(P);return}const k=setTimeout(()=>this.flushBuffer(C),A);i={data:[P],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),_.dispose()}},this._terminalBufferMap.set(C,i)}),_}stopBuffering(C){const y=this._terminalBufferMap.get(C);y&&y.dispose()}flushBuffer(C){const y=this._terminalBufferMap.get(C);y&&(this._terminalBufferMap.delete(C),this._callback(C,y.data.join("")))}}e.TerminalDataBufferer=m}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,47,3,6,4,34,198]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var S;(function(D){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}D.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function P(D){return{id:D}}e.themeColorFromId=P;var i;(function(D){function I(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color=="undefined"||S.isThemeColor(h.color))}D.isThemeIcon=I;const b=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function c(h){const s=b.exec(h);if(!s)return;let[,n]=s;return{id:n}}D.fromString=c;function o(h,s){let n=h.id;const r=n.lastIndexOf("~");return r!==-1&&(n=n.substring(0,r)),s&&(n=`${n}~${s}`),{id:n}}D.modify=o;function v(h,s){return h.id===s.id&&h.color?.id===s.color?.id}D.isEqual=v;function t(h,s){return{id:h.id,color:s?P(s):void 0}}D.asThemeIcon=t,D.asClassNameArray=m.CSSIcon.asClassNameArray,D.asClassName=m.CSSIcon.asClassName,D.asCSSSelector=m.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function k(D){switch(D){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(I);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new l;A.Registry.add(e.Extensions.ThemingContribution,f);function d(D){return f.onColorThemeChange(D)}e.registerThemingParticipant=d;class w extends C.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,b){let c=this.theme.getColor(I);return c&&b&&(c=b(c,this.theme)),c?c.toString():null}}e.Themable=w}),define(fe[199],me([0,1,17,47,3,163,120,34,65]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,b,c,o){const v=this.iconsById[I];if(v){if(c&&!v.description){v.description=c,this.iconSchema.properties[I].markdownDescription=`${c} $(${I})`;const s=this.iconReferenceSchema.enum.indexOf(I);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=c),this._onDidChange.fire()}return v}let t={id:I,description:c,defaults:b,deprecationMessage:o};this.iconsById[I]=t;let h={$ref:"#/definitions/icons"};return o&&(h.deprecationMessage=o),c&&(h.markdownDescription=`${c}: $(${I})`),this.iconSchema.properties[I]=h,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const b=this.iconReferenceSchema.enum.indexOf(I);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,b){const c=this.iconFontsById[I];if(c)return c;let o={id:I,definition:b};return this.iconFontsById[I]=o,this._onDidChange.fire(),o}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(v,t)=>v.id.localeCompare(t.id),b=v=>{for(;S.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of o.filter(t=>!!t.description).sort(I))c.push(`|<i class="${b(v)}"></i>|${v.id}|${S.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const v of o.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(I))c.push(`|<i class="${b(v)}"></i>|${v.id}|`);return c.join(`
`)}}const i=new P;_.Registry.add(e.Extensions.IconContribution,i);function k(D,I,b,c){return i.registerIcon(D,I,b,c)}e.registerIcon=k;function l(){return i}e.getIconRegistry=l;function f(){for(const D of F.iconRegistry.all)i.registerIcon(D.id,D.definition,D.description);F.iconRegistry.onDidRegister(D=>i.registerIcon(D.id,D.definition,D.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let d=_.Registry.as(A.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new m.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=k("widget-close",F.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",F.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",F.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=S.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function _(l){const f=l;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=_;function S(l){const f=l;return!!(f&&typeof f=="object"&&C.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(f,d,w,D,I){this._id=f,this._transient=w,this._configuration=D,this._ignorePathCasing=I,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class i{constructor(f,d){this.raw=d,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,F.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function k(l){return new i({uri:l,index:0,name:(0,F.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=k}),define(fe[200],me([0,1,29,61,140,80,10,8,11,23,2,164,4,64,44]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(N){return(typeof N=="string"?(0,_.extname)(N):(0,P.extname)(N))===w}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function I(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function c(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=c;function o(N){const j=N;return typeof j?.id=="string"&&i.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function v(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(N){const j=N;return typeof j?.id=="string"&&i.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function h(N){const j=N;if(j?.uri)return{id:j.id,uri:i.URI.revive(j.uri)};const U=N;if(U?.configPath)return{id:U.id,configPath:i.URI.revive(U.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=h;function s(N,j){return P.extUriBiasedIgnorePathCase.isEqualOrParent(N,j.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(N){return r(N)||a(N)}e.isStoredWorkspaceFolder=n;function r(N){const j=N;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=r;function a(N){const j=N;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=a;function u(N,j,U,x,z=!S.isWindows,O){if(N.scheme!==x.scheme)return{name:U,uri:N.toString(!0)};let $=j?void 0:O.relativePath(x,N);if($!==void 0)$.length===0?$=".":S.isWindows&&N.scheme===A.Schemas.file&&!z&&($=$.replace(/\//g,"\\"));else if(N.scheme===A.Schemas.file)$=N.fsPath,S.isWindows&&($=(0,y.normalizeDriveLetter)($),z&&($=(0,m.toSlashes)($)));else{if(!O.isEqualAuthority(N.authority,x.authority))return{name:U,uri:N.toString(!0)};$=N.path}return{name:U,path:$}}e.getStoredWorkspaceFolder=u;function p(N,j,U){let x=[],z=new Set;const O=U.dirname(j);for(let $ of N){let B;if(r($))$.path&&(B=U.resolvePath(O,$.path));else if(a($))try{B=i.URI.parse($.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(X){console.warn(X)}if(B){let X=U.getComparisonKey(B);if(!z.has(X)){z.add(X);const Q=$.name||U.basenameOrAuthority(B);x.push(new d.WorkspaceFolder({uri:B,name:Q,index:x.length},$))}}}return x}e.toWorkspaceFolders=p;function E(N,j,U,x,z){let O=g(j,N);const $=z.dirname(j),B=z.dirname(x),X=[],Q=T(O.folders);for(const ke of O.folders){const Be=r(ke)?z.resolvePath($,ke.path):i.URI.parse(ke.uri);let We;U?We=!1:We=!r(ke)||(0,_.isAbsolute)(ke.path),X.push(u(Be,We,ke.name,B,Q,z))}const de={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},_e=C.setProperty(N,["folders"],X,de);let ye=C.applyEdits(N,_e);return O.remoteAuthority===(0,f.getRemoteAuthority)(x)&&(ye=C.applyEdits(ye,C.removeProperty(ye,["remoteAuthority"],de))),ye}e.rewriteWorkspaceFileForNewLocation=E;function g(N,j){let U=F.parse(j);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>n(x));else throw new Error(`${N} looks like an invalid workspace file.`);return U}function T(N){return S.isWindows?N.some(j=>r(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function M(N){return typeof N.folderUri=="string"}function R(N){return typeof N.fileUri=="string"}function W(N,j){const U={workspaces:[],files:[]};if(N){const x=function(O,$){for(let B=0;B<O.length;B++)try{$(O[B],B)}catch(X){j.warn(`Error restoring recent entry ${JSON.stringify(O[B])}: ${X.toString()}. Skip entry.`)}},z=N;if(Array.isArray(z.entries))x(z.entries,O=>{const $=O.label,B=O.remoteAuthority;L(O)?U.workspaces.push({label:$,remoteAuthority:B,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):M(O)?U.workspaces.push({label:$,remoteAuthority:B,folderUri:i.URI.parse(O.folderUri)}):R(O)&&U.files.push({label:$,remoteAuthority:B,fileUri:i.URI.parse(O.fileUri)})});else{const O=N;Array.isArray(O.workspaces3)&&x(O.workspaces3,($,B)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[B]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:$.id,configPath:i.URI.parse($.configURIPath)}}):typeof $=="string"&&U.workspaces.push({label:X,folderUri:i.URI.parse($)})}),Array.isArray(O.files2)&&x(O.files2,($,B)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[B]||void 0;typeof $=="string"&&U.files.push({label:X,fileUri:i.URI.parse($)})})}}return U}e.restoreRecentlyOpened=W;function V(N){const j={entries:[]};for(const U of N.workspaces)b(U)?j.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):j.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of N.files)j.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return j}e.toStoreData=V}),define(fe[87],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const y=this._idPool++;return this._data.set(y,C),this.logDebugInfo(),y}get(C,y){return this._data.has(C)?this._data.get(C)[y]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(fe[53],me([0,1,10,23,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class y{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(_=>{const S=this._providerInfo.get(_.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(_,S){S===null?this._providerInfo.delete(_):this._providerInfo.set(_,S)}isFreeScheme(_){return!this._providerInfo.has(_)&&!this._systemSchemes.has(_)}getCapabilities(_){return this._providerInfo.get(_)}}e.ExtHostFileSystemInfo=y,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(fe[27],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,17]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,_,S){this._deferredPromises=new Map,this._id=A,this._shared=_,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of P.values())i.complete()}catch(i){for(const k of P.values())k.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,_){let S=this._value[A];return typeof S=="undefined"&&(S=_),S}update(A,_){this._value[A]=_;let S=this._deferredPromises.get(A);if(S!==void 0)return S.p;const P=new m.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class C extends F{constructor(A,_){super(A.identifier.value,!0,_);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(fe[202],me([0,1,3,2,13]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(_,S){this._logService=_,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(_,S,P){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptModelChanged(S.value,P)}$acceptDirtyStateChanged(_,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptDirty(S)}$acceptModelSaved(_){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(_,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",_.path,S);const P=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));P.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};y=Ve([$e(0,C.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(fe[14],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class F{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=F});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[203],me([0,1,26,3]),function(Y,e,m,F){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(_,S){C.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(_.identifier),ot(this,C,S,"f"),Oe(this,C,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(_){return Oe(this,C,"f").get(this._id,_)}store(_,S){return Oe(this,C,"f").store(this._id,_,S)}delete(_){return Oe(this,C,"f").delete(this._id,_)}}e.ExtensionSecrets=y,C=new WeakMap}),define(fe[124],me([0,1,4,3]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,C=(b,c)=>{const o={controllerId:c};return F.set(b,o),o};e.createPrivateApiFor=C;const y=b=>F.get(b);e.getPrivateApiFor=y;const A=(b,c,o,v)=>{let t=o;return{enumerable:!0,configurable:!1,get(){return t},set(h){if(!v(t,h)){const s=t;t=h,b.listener?.({op:3,key:c,value:h,previous:s})}}}},_=(b,c)=>b===c,S={range:(b,c)=>b===c?!0:!b||!c?!1:b.isEqual(c),label:_,description:_,busy:_,error:_,canResolveChildren:_,tags:(b,c)=>!(b.length!==c.length||b.some(o=>!c.find(v=>o.id===v.id)))},P=Object.keys(S),i=(b,c)=>({range:A(b,"range",void 0,S.range),label:A(b,"label",c,S.label),description:A(b,"description",void 0,S.description),canResolveChildren:A(b,"canResolveChildren",!1,S.canResolveChildren),busy:A(b,"busy",!1,S.busy),error:A(b,"error",void 0,S.error),tags:A(b,"tags",[],S.tags)}),k=(b,c)=>{const o=new Map;for(const v of P)S[v](b[v],c[v])||o.set(v,c[v]);return o};e.diffTestItems=k;class l extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=l;class f extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(c,o,v){super(`TestItem with ID "${c}" is from controller "${o}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=d;const w=b=>{const c=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(v,t){for(const h of o.values())v.call(t,h,this)},replace(v){const t=new Map,h=new Set(o.keys()),s={op:4,ops:[]};for(const n of v){if(!(n instanceof D))throw new f(n.id);const r=(0,e.getPrivateApiFor)(n).controllerId;if(r!==c.controllerId)throw new d(n.id,r,c.controllerId);if(t.has(n.id))throw new l(n.id);t.set(n.id,n),h.delete(n.id),s.ops.push({op:0,item:n})}for(const n of h.keys())s.ops.push({op:1,id:n});c.listener?.(s),o=t},add(v){if(!(v instanceof D))throw new f(v.id);o.set(v.id,v),c.listener?.({op:0,item:v})},delete(v){o.delete(v)&&c.listener?.({op:1,id:v})},get(v){return o.get(v)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class D{constructor(c,o,v,t){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const h=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof I?void 0:h.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(h,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class I extends D{constructor(c,o){super(c,c,o,void 0)}}e.TestItemRootImpl=I}),define(fe[54],me([0,1,4,123,3,14]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(S){function P(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=P;function i(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==F.TunnelPrivacyId.ConstantPrivate&&k.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=i})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let _=class{constructor(P){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,i){return{dispose:()=>{}}}async $providePortAttributes(P,i,k,l,f){return[]}async $forwardPort(P,i){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};_=Ve([$e(0,y.IExtHostRpcService)],_),e.ExtHostTunnelService=_});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[7],me([0,1,16,18,100,24,103,12,2,32,43,122]),function(Y,e,m,F,C,y,A,_,S,P,i,k){"use strict";var l,f,d,w,D,I,b,c,o,v,t,h,s,n,r,a,u,p,E,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(G){function H(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf(H,G),Object.setPrototypeOf(H.prototype,G.prototype),H}let L=D=class{constructor(H){l.set(this,void 0),ot(this,l,H,"f")}static from(...H){let oe=H;return new D(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}dispose(){typeof Oe(this,l,"f")=="function"&&(Oe(this,l,"f").call(this),ot(this,l,void 0,"f"))}};l=new WeakMap,L=D=Ve([T],L),e.Disposable=L;let M=I=class{constructor(H,oe){if(H<0)throw(0,F.illegalArgument)("line must be non-negative");if(oe<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=H,this._character=oe}static Min(...H){if(H.length===0)throw new TypeError;let oe=H[0];for(let De=1;De<H.length;De++){const Ze=H[De];Ze.isBefore(oe)&&(oe=Ze)}return oe}static Max(...H){if(H.length===0)throw new TypeError;let oe=H[0];for(let De=1;De<H.length;De++){const Ze=H[De];Ze.isAfter(oe)&&(oe=Ze)}return oe}static isPosition(H){if(!H)return!1;if(H instanceof I)return!0;let{line:oe,character:De}=H;return typeof oe=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,oe=0){if(H===null||oe===null)throw(0,F.illegalArgument)();let De;return typeof H=="undefined"?De=0:typeof H=="number"?De=H:(De=typeof H.lineDelta=="number"?H.lineDelta:0,oe=typeof H.characterDelta=="number"?H.characterDelta:0),De===0&&oe===0?this:new I(this.line+De,this.character+oe)}with(H,oe=this.character){if(H===null||oe===null)throw(0,F.illegalArgument)();let De;return typeof H=="undefined"?De=this.line:typeof H=="number"?De=H:(De=typeof H.line=="number"?H.line:this.line,oe=typeof H.character=="number"?H.character:this.character),De===this.line&&oe===this.character?this:new I(De,oe)}toJSON(){return{line:this.line,character:this.character}}};M=I=Ve([T],M),e.Position=M;let R=b=class{constructor(H,oe,De,Ze){let lt,dt;if(typeof H=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ze=="number"?(lt=new M(H,oe),dt=new M(De,Ze)):H instanceof M&&oe instanceof M&&(lt=H,dt=oe),!lt||!dt)throw new Error("Invalid arguments");lt.isBefore(dt)?(this._start=lt,this._end=dt):(this._start=dt,this._end=lt)}static isRange(H){return H instanceof b?!0:H?M.isPosition(H.start)&&M.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof b?this.contains(H._start)&&this.contains(H._end):H instanceof M?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const oe=M.Max(H.start,this._start),De=M.Min(H.end,this._end);if(!oe.isAfter(De))return new b(oe,De)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const oe=M.Min(H.start,this._start),De=M.Max(H.end,this.end);return new b(oe,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,oe=this.end){if(H===null||oe===null)throw(0,F.illegalArgument)();let De;return H?M.isPosition(H)?De=H:(De=H.start||this.start,oe=H.end||this.end):De=this.start,De.isEqual(this._start)&&oe.isEqual(this.end)?this:new b(De,oe)}toJSON(){return[this.start,this.end]}};R=b=Ve([T],R),e.Range=R;let W=c=class extends R{constructor(H,oe,De,Ze){let lt,dt;if(typeof H=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ze=="number"?(lt=new M(H,oe),dt=new M(De,Ze)):H instanceof M&&oe instanceof M&&(lt=H,dt=oe),!lt||!dt)throw new Error("Invalid arguments");super(lt,dt);this._anchor=lt,this._active=dt}static isSelection(H){return H instanceof c?!0:H?R.isRange(H)&&M.isPosition(H.anchor)&&M.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=c=Ve([T],W),e.Selection=W;class V{constructor(H,oe,De){if(typeof H!="string"||H.length===0)throw(0,F.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,F.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,F.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(oe),this.connectionToken=De}}e.ResolvedAuthority=V;class N extends Error{constructor(H,oe=k.RemoteAuthorityResolverErrorCode.Unknown,De){super(H);this._message=H,this._code=oe,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(H,oe){return new N(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(H){return new N(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var j;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var U;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=o=class{constructor(H,oe){this._range=H,this._newText=oe}static isTextEdit(H){return H instanceof o?!0:H?R.isRange(H)&&typeof H.newText=="string":!1}static replace(H,oe){return new o(H,oe)}static insert(H,oe){return o.replace(new R(H,H),oe)}static delete(H){return o.replace(H,"")}static setEndOfLine(H){const oe=new o(new R(new M(0,0),new M(0,0)),"");return oe.newEol=H,oe}get range(){return this._range}set range(H){if(H&&!R.isRange(H))throw(0,F.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,F.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,F.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=o=Ve([T],x),e.TextEdit=x;var z;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,oe,De,Ze){this._edits.push({_type:1,from:H,to:oe,options:De,metadata:Ze})}createFile(H,oe,De){this._edits.push({_type:1,from:void 0,to:H,options:oe,metadata:De})}deleteFile(H,oe,De){this._edits.push({_type:1,from:H,to:void 0,options:oe,metadata:De})}replaceNotebookMetadata(H,oe,De){this._edits.push({_type:3,metadata:De,uri:H,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(H,oe,De,Ze,lt){let dt,gt,It=[],At;if(zt.isNotebookRange(oe)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(Ze)?(dt=oe.start,gt=oe.end,It=De,At=Ze):typeof oe=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(Ze)&&(dt=oe,gt=De,It=Ze,At=lt),dt===void 0||gt===void 0)throw new Error("Invalid arguments");(dt!==gt||It.length>0)&&this._edits.push({_type:5,uri:H,index:dt,count:gt-dt,cells:It,metadata:At})}replaceNotebookCellMetadata(H,oe,De,Ze){this._edits.push({_type:3,metadata:Ze,uri:H,edit:{editType:8,index:oe,metadata:De}})}replace(H,oe,De,Ze){this._edits.push({_type:2,uri:H,edit:new x(oe,De),metadata:Ze})}insert(H,oe,De,Ze){this.replace(H,new R(oe,oe),De,Ze)}delete(H,oe,De){this.replace(H,oe,"",De)}has(H){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===H.toString())}set(H,oe){if(oe)for(const De of oe)De&&this._edits.push({_type:2,uri:H,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ze=this._edits[De];Ze._type===2&&Ze.uri.toString()===H.toString()&&(this._edits[De]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(H){const oe=[];for(let De of this._edits)De._type===2&&De.uri.toString()===H.toString()&&oe.push(De.edit);return oe}entries(){const H=new y.ResourceMap;for(let oe of this._edits)if(oe._type===2){let De=H.get(oe.uri);De||(De=[oe.uri,[]],H.set(oe.uri,De)),De[1].push(oe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([T],O),e.WorkspaceEdit=O;let $=v=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof v?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=v._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,oe=this._tabstop++){if(typeof H=="function"){const De=new v;De._tabstop=this._tabstop,H(De),this._tabstop=De._tabstop,H=De.value}else H=v._escape(H);return this.value+="${",this.value+=oe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,oe=this._tabstop++){const De=H.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(H,oe){if(typeof oe=="function"){const De=new v;De._tabstop=this._tabstop,oe(De),this._tabstop=De._tabstop,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};$=v=Ve([T],$),e.SnippetString=$;var B;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var X;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(X=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=t=class{constructor(H,oe){if(this.uri=H,oe)if(oe instanceof R)this.range=oe;else if(oe instanceof M)this.range=new R(oe,oe);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof t?!0:H?R.isRange(H.range)&&S.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=t=Ve([T],Q),e.Location=Q;let de=class{constructor(H,oe){this.location=H,this.message=oe}static is(H){return H?typeof H.message=="string"&&H.location&&R.isRange(H.location.range)&&S.URI.isUri(H.location.uri):!1}static isEqual(H,oe){return H===oe?!0:!H||!oe?!1:H.message===oe.message&&H.location.range.isEqual(oe.location.range)&&H.location.uri.toString()===oe.location.uri.toString()}};de=Ve([T],de),e.DiagnosticRelatedInformation=de;let _e=class{constructor(H,oe,De=X.Error){if(!R.isRange(H))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=H,this.message=oe,this.severity=De}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,oe){return H===oe?!0:!H||!oe?!1:H.message===oe.message&&H.severity===oe.severity&&H.code===oe.code&&H.severity===oe.severity&&H.source===oe.source&&H.range.isEqual(oe.range)&&(0,m.equals)(H.tags,oe.tags)&&(0,m.equals)(H.relatedInformation,oe.relatedInformation,de.isEqual)}};_e=Ve([T],_e),e.Diagnostic=_e;let ye=class{constructor(H,oe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=oe}};ye=Ve([T],ye),e.Hover=ye;var ke;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(H,oe=ke.Text){this.range=H,this.kind=oe}toJSON(){return{range:this.range,kind:ke[this.kind]}}};Be=Ve([T],Be),e.DocumentHighlight=Be;var We;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var He;(function(G){G[G.Deprecated=1]="Deprecated"})(He=e.SymbolTag||(e.SymbolTag={}));let q=h=class{constructor(H,oe,De,Ze,lt){this.name=H,this.kind=oe,this.containerName=lt,typeof De=="string"&&(this.containerName=De),Ze instanceof Q?this.location=Ze:De instanceof R&&(this.location=new Q(Ze,De)),h.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};q=h=Ve([T],q),e.SymbolInformation=q;let ee=s=class{constructor(H,oe,De,Ze,lt){this.name=H,this.detail=oe,this.kind=De,this.range=Ze,this.selectionRange=lt,this.children=[],s.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(s.validate)}};ee=s=Ve([T],ee),e.DocumentSymbol=ee;var re;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(H,oe){this.title=H,this.kind=oe}};le=Ve([T],le),e.CodeAction=le;let Z=n=class{constructor(H){this.value=H}append(H){return new n(this.value?this.value+n.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+n.sep)}};Z.sep=".",Z=n=Ve([T],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let ae=class{constructor(H,oe){if(this.range=H,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ve([T],ae),e.SelectionRange=ae;class pe{constructor(H,oe,De,Ze,lt,dt){this.kind=H,this.name=oe,this.detail=De,this.uri=Ze,this.range=lt,this.selectionRange=dt}}e.CallHierarchyItem=pe;class Me{constructor(H,oe){this.fromRanges=oe,this.from=H}}e.CallHierarchyIncomingCall=Me;class je{constructor(H,oe){this.fromRanges=oe,this.to=H}}e.CallHierarchyOutgoingCall=je;var Ke;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(H,oe){this.range=H,this.command=oe}get isResolved(){return!!this.command}};Je=Ve([T],Je),e.CodeLens=Je;let st=r=class{constructor(H,oe=!1){f.set(this,void 0),ot(this,f,new C.MarkdownString(H,{supportThemeIcons:oe}),"f")}static isMarkdownString(H){return H instanceof r?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Oe(this,f,"f").value}set value(H){Oe(this,f,"f").value=H}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(H){Oe(this,f,"f").isTrusted=H}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(H){Oe(this,f,"f").supportThemeIcons=H}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(H){Oe(this,f,"f").supportHtml=H}appendText(H){return Oe(this,f,"f").appendText(H),this}appendMarkdown(H){return Oe(this,f,"f").appendMarkdown(H),this}appendCodeblock(H,oe){return Oe(this,f,"f").appendCodeblock(oe??"",H),this}};f=new WeakMap,st=r=Ve([T],st),e.MarkdownString=st;let Te=class{constructor(H,oe){this.label=H,this.documentation=oe}};Te=Ve([T],Te),e.ParameterInformation=Te;let nt=class{constructor(H,oe){this.label=H,this.documentation=oe,this.parameters=[]}};nt=Ve([T],nt),e.SignatureInformation=nt;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([T],J),e.SignatureHelp=J;var ne;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ve=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(H,oe,De){this.text=H,this.position=oe,this.kind=De}};Qe=Ve([T],Qe),e.InlayHint=Qe;var tt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(tt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(G){G[G.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Ie=class{constructor(H,oe){this.label=H,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ie=Ve([T],Ie),e.CompletionItem=Ie;let Ue=class{constructor(H=[],oe=!1){this.items=H,this.isIncomplete=oe}};Ue=Ve([T],Ue),e.CompletionList=Ue;let Xe=class{constructor(H,oe,De){this.text=H,this.range=oe,this.command=De}};Xe=Ve([T],Xe),e.InlineSuggestion=Xe;let rt=class{constructor(H){this.items=H}};rt=Ve([T],rt),e.InlineSuggestions=rt;var ht;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pe;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function H(oe){switch(oe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(H,oe){if(oe&&!S.URI.isUri(oe))throw(0,F.illegalArgument)("target");if(!R.isRange(H)||H.isEmpty)throw(0,F.illegalArgument)("range");this.range=H,this.target=oe}};be=Ve([T],be),e.DocumentLink=be;let we=class{constructor(H,oe,De,Ze){this.red=H,this.green=oe,this.blue=De,this.alpha=Ze}};we=Ve([T],we),e.Color=we;let Fe=class{constructor(H,oe){if(oe&&!(oe instanceof we))throw(0,F.illegalArgument)("color");if(!R.isRange(H)||H.isEmpty)throw(0,F.illegalArgument)("range");this.range=H,this.color=oe}};Fe=Ve([T],Fe),e.ColorInformation=Fe;let qe=class{constructor(H){if(!H||typeof H!="string")throw(0,F.illegalArgument)("label");this.label=H}};qe=Ve([T],qe),e.ColorPresentation=qe;var ze;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var et;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(et=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor(H,oe,De){if(this.startIndex=H,this.length=oe,this.tooltip=De,typeof H!="number"||H<0)throw(0,F.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,F.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=at;var xe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(xe=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(H){this.options=H,typeof H!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ge;var Ee;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var te;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(te=e.TaskPanelKind||(e.TaskPanelKind={}));let K=a=class{constructor(H,oe){if(this.label=oe,typeof H!="string"||typeof oe!="string")throw(0,F.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};K.Clean=new a("clean","Clean"),K.Build=new a("build","Build"),K.Rebuild=new a("rebuild","Rebuild"),K.Test=new a("test","Test"),K=a=Ve([T],K),e.TaskGroup=K;function Se(G){let H="";for(let oe=0;oe<G.length;oe++)H+=G[oe].replace(/,/g,",,")+",";return H}let Le=class{constructor(H,oe,De){if(typeof H!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=H,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=De):this._options=oe)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,F.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)H.push(oe);return Se(H)}};Le=Ve([T],Le),e.ProcessExecution=Le;let it=class{constructor(H,oe,De){if(this._args=[],Array.isArray(oe)){if(!H)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,F.illegalArgument)("command");this._command=H,this._args=oe,this._options=De}else{if(typeof H!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=H,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,F.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)H.push(typeof oe=="string"?oe:oe.value);return Se(H)}};it=Ve([T],it),e.ShellExecution=it;var Ge;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Ge=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class Et{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=Et;let ft=u=class{constructor(H,oe,De,Ze,lt,dt){this.__deprecated=!1,this._definition=this.definition=H;let gt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=De,this.execution=Ze,gt=lt,this.__deprecated=!0):oe===pt.Global||oe===pt.Workspace?(this.target=oe,this._name=this.name=De,this._source=this.source=Ze,this.execution=lt,gt=dt):(this.target=oe,this._name=this.name=De,this._source=this.source=Ze,this.execution=lt,gt=dt),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const oe=this._definition.type;(u.EmptyType===oe||u.ProcessType===oe||u.ShellType===oe||u.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=u=Ve([T],ft),e.Task=ft;var bt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(H,oe=_t.None){this.collapsibleState=oe,S.URI.isUri(H)?this.resourceUri=H:this.label=H}};mt=Ve([T],mt),e.TreeItem=mt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(H,oe){this.id=H,this.color=oe}};Dt=Ve([T],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Bt=class{constructor(H){this.id=H}};Bt=Ve([T],Bt),e.ThemeColor=Bt;var Vt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(H,oe){if(typeof H!="string"&&(!H||!S.URI.isUri(H)&&!S.URI.isUri(H.uri)))throw(0,F.illegalArgument)("base");if(typeof oe!="string")throw(0,F.illegalArgument)("pattern");typeof H=="string"?(this.baseFolder=S.URI.file(H),this.base=H):S.URI.isUri(H)?(this.baseFolder=H,this.base=H.fsPath):(this.baseFolder=H.uri,this.base=H.uri.fsPath),this.pattern=oe}};kt=Ve([T],kt),e.RelativePattern=kt;let $t=class{constructor(H,oe,De,Ze){this.enabled=typeof H=="boolean"?H:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Ve([T],$t),e.Breakpoint=$t;let en=class extends $t{constructor(H,oe,De,Ze,lt){super(oe,De,Ze,lt);if(H===null)throw(0,F.illegalArgument)("location");this.location=H}};en=Ve([T],en),e.SourceBreakpoint=en;let St=class extends $t{constructor(H,oe,De,Ze,lt){super(oe,De,Ze,lt);this.functionName=H}};St=Ve([T],St),e.FunctionBreakpoint=St;let Qt=class extends $t{constructor(H,oe,De,Ze,lt,dt,gt){super(Ze,lt,dt,gt);if(!oe)throw(0,F.illegalArgument)("dataId");this.label=H,this.dataId=oe,this.canPersist=De}};Qt=Ve([T],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(H,oe,De){this.command=H,this.args=oe||[],this.options=De}};jt=Ve([T],jt),e.DebugAdapterExecutable=jt;let tn=class{constructor(H,oe){this.port=H,this.host=oe}};tn=Ve([T],tn),e.DebugAdapterServer=tn;let nn=class{constructor(H){this.path=H}};nn=Ve([T],nn),e.DebugAdapterNamedPipeServer=nn;let Tt=class{constructor(H){this.implementation=H}};Tt=Ve([T],Tt),e.DebugAdapterInlineImplementation=Tt;let Xt=class{constructor(H,oe){this.range=H,this.expression=oe}};Xt=Ve([T],Xt),e.EvaluatableExpression=Xt;var bn;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(H,oe){this.range=H,this.text=oe}};Wt=Ve([T],Wt),e.InlineValueText=Wt;let Ht=class{constructor(H,oe,De=!0){this.range=H,this.variableName=oe,this.caseSensitiveLookup=De}};Ht=Ve([T],Ht),e.InlineValueVariableLookup=Ht;let wt=class{constructor(H,oe){this.range=H,this.expression=oe}};wt=Ve([T],wt),e.InlineValueEvaluatableExpression=wt;let rn=class{constructor(H,oe){this.frameId=H,this.stoppedLocation=oe}};rn=Ve([T],rn),e.InlineValueContext=rn;var Ot;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=p=class extends Error{constructor(H,oe=i.FileSystemProviderErrorCode.Unknown,De){super(S.URI.isUri(H)?H.toString(!0):H);this.code=De?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(H){return new p(H,i.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(H){return new p(H,i.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(H){return new p(H,i.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(H){return new p(H,i.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(H){return new p(H,i.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(H){return new p(H,i.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};Nt=p=Ve([T],Nt),e.FileSystemError=Nt;let Yt=class{constructor(H,oe,De){this.start=H,this.end=oe,this.kind=De}};Yt=Ve([T],Yt),e.FoldingRange=Yt;var En;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor(H,oe=[]){this.tokenTypes=H,this.tokenModifiers=oe}}e.SemanticTokensLegend=mn;function sn(G){return typeof G=="undefined"||(0,_.isStringArray)(G)}class on{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let oe=0,De=H.tokenTypes.length;oe<De;oe++)this._tokenTypeStrToInt.set(H.tokenTypes[oe],oe);for(let oe=0,De=H.tokenModifiers.length;oe<De;oe++)this._tokenModifierStrToInt.set(H.tokenModifiers[oe],oe)}}push(H,oe,De,Ze,lt){if(typeof H=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ze=="number"&&(typeof lt=="number"||typeof lt=="undefined"))return typeof lt=="undefined"&&(lt=0),this._pushEncoded(H,oe,De,Ze,lt);if(R.isRange(H)&&typeof oe=="string"&&sn(De))return this._push(H,oe,De);throw(0,F.illegalArgument)()}_push(H,oe,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,lt=H.start.character,dt=H.end.character-H.start.character,gt=this._tokenTypeStrToInt.get(oe);let It=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);It|=1<<Lt>>>0}this._pushEncoded(Ze,lt,dt,gt,It)}_pushEncoded(H,oe,De,Ze,lt){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<It;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=At,dn+=Lt):Ut+=At,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,At=Ut,Lt=dn}}let dt=H,gt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=lt,this._prevLine=H,this._prevChar=oe}static _sortAndDeltaEncode(H){let oe=[];const De=H.length/5|0;for(let gt=0;gt<De;gt++)oe[gt]=gt;oe.sort((gt,It)=>{const At=H[5*gt],Lt=H[5*It];if(At===Lt){const Mt=H[5*gt+1],Ut=H[5*It+1];return Mt-Ut}return At-Lt});const Ze=new Uint32Array(H.length);let lt=0,dt=0;for(let gt=0;gt<De;gt++){const It=5*oe[gt],At=H[It+0],Lt=H[It+1],Mt=H[It+2],Ut=H[It+3],dn=H[It+4],xn=At-lt,Gn=xn===0?Lt-dt:Lt,hn=5*gt;Ze[hn+0]=xn,Ze[hn+1]=Gn,Ze[hn+2]=Mt,Ze[hn+3]=Ut,Ze[hn+4]=dn,lt=At,dt=Lt}return Ze}build(H){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),H):new qt(on._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=on;class qt{constructor(H,oe){this.resultId=oe,this.data=H}}e.SemanticTokens=qt;class an{constructor(H,oe,De){this.start=H,this.deleteCount=oe,this.data=De}}e.SemanticTokensEdit=an;class Sn{constructor(H,oe){this.resultId=oe,this.edits=H}}e.SemanticTokensEdits=Sn;var yn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new Dt("arrow-left")},Jt=Ve([T],Jt),e.QuickInputButtons=Jt;var Dn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(H,oe,De){this.badge=H,this.tooltip=oe,this.color=De}static validate(H){if(H.badge&&H.badge.length!==1&&H.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor(H){this.kind=H}};ln=Ve([T],ln),e.ColorTheme=ln;var cn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(cn=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(H,oe){if(H<0)throw(0,F.illegalArgument)("start must be positive");if(oe<0)throw(0,F.illegalArgument)("end must be positive");H<=oe?(this._start=H,this._end=oe):(this._start=oe,this._end=H)}static isNotebookRange(H){return H instanceof zt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let oe=this._start,De=this._end;return H.start!==void 0&&(oe=H.start),H.end!==void 0&&(De=H.end),oe===this._start&&De===this._end?this:new zt(oe,De)}}e.NotebookRange=zt;class Ft{constructor(H,oe,De,Ze,lt,dt,gt){this.kind=H,this.value=oe,this.languageId=De,this.mime=Ze,this.outputs=lt??[],this.metadata=dt,this.executionSummary=gt,Ft.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(oe=>Ft.isNotebookCellData(oe))}static isNotebookCellData(H){return!0}}e.NotebookCellData=Ft;class Ne{constructor(H){this.cells=H}}e.NotebookData=Ne;class Rt{constructor(H,oe){this.data=H,this.mime=oe;const De=(0,A.normalizeMimeType)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(H){return H instanceof Rt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const oe={name:H.name,message:H.message,stack:H.stack};return Rt.json(oe,"application/vnd.code.notebook.error")}static stdout(H){return Rt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Rt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,oe="application/octet-stream"){return new Rt(H,oe)}static text(H,oe=A.Mimes.text){const De=Oe(Rt,d,"f",w).encode(String(H));return new Rt(De,oe)}static json(H,oe="application/json"){const De=JSON.stringify(H,void 0,"	");return Rt.text(De,oe)}}e.NotebookCellOutputItem=Rt,d=Rt,w={value:new TextEncoder};class Kt{constructor(H,oe,De){this.items=Kt.ensureUniqueMimeTypes(H,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,P.generateUuid)(),this.metadata=oe??De)}static isNotebookCellOutput(H){return H instanceof Kt?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,_.isArray)(H.items)}static ensureUniqueMimeTypes(H,oe=!1){const De=new Set,Ze=new Set;for(let lt=0;lt<H.length;lt++){const dt=H[lt],gt=(0,A.normalizeMimeType)(dt.mime);if(!De.has(gt)){De.add(gt);continue}Ze.add(lt),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?H:H.filter((lt,dt)=>!Ze.has(dt))}}e.NotebookCellOutput=Kt;var yt;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(H,oe){this.text=H,this.alignment=oe}}e.NotebookCellStatusBarItem=pn;var Pn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(H,oe=[]){this.uri=H,this.provides=(0,m.asArray)(oe)}}e.NotebookRendererScript=Tn;let un=class{constructor(H,oe){this.label=H,this.timestamp=oe}};un=Ve([T],un),e.TimelineItem=un;var An;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(H,oe){this.ranges=H,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class Fn{constructor(H,oe){this._port=H,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(H,oe,De){this.include=H,this.exclude=oe,this.profile=De}};ie=Ve([T],ie),e.TestRunRequest=ie;let he=E=class{constructor(H){this.message=H}static diff(H,oe,De){const Ze=new E(H);return Ze.expectedOutput=oe,Ze.actualOutput=De,Ze}};he=E=Ve([T],he),e.TestMessage=he;let Ae=class{constructor(H){this.id=H}};Ae=Ve([T],Ae),e.TestTag=Ae;let ut=class{constructor(H,oe){this.covered=H,this.total=oe}};ut=Ve([T],ut),e.CoveredCount=ut;let Ct=g=class{constructor(H,oe,De,Ze){this.uri=H,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Ze}static fromDetails(H,oe){const De=new ut(0,0),Ze=new ut(0,0),lt=new ut(0,0);for(const gt of oe)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const It of gt.branches)Ze.total+=1,Ze.covered+=It.executionCount>0?1:0}else lt.total+=1,lt.covered+=gt.executionCount>0?1:0;const dt=new g(H,De,Ze.total>0?Ze:void 0,lt.total>0?lt:void 0);return dt.detailedCoverage=oe,dt}};Ct=g=Ve([T],Ct),e.FileCoverage=Ct;let Pt=class{constructor(H,oe,De=[]){this.executionCount=H,this.location=oe,this.branches=De}};Pt=Ve([T],Pt),e.StatementCoverage=Pt;let Nn=class{constructor(H,oe){this.executionCount=H,this.location=oe}};Nn=Ve([T],Nn),e.BranchCoverage=Nn;let Un=class{constructor(H,oe){this.executionCount=H,this.location=oe}};Un=Ve([T],Un),e.FunctionCoverage=Un;var zn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(H,oe,De,Ze,lt,dt){this.kind=H,this.name=oe,this.detail=De,this.uri=Ze,this.range=lt,this.selectionRange=dt}}e.TypeHierarchyItem=qn}),define(fe[125],me([0,1,58,10,9,151,111,7,16]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function i(d,w){w?P.set(d,w):P.delete(d)}e.setWordDefinitionFor=i;function k(d){return P.get(d)}e.getWordDefinitionFor=k;class l extends y.MirrorTextModel{constructor(w,D,I,b,c,o,v,t){super(D,I,b,c);this._proxy=w,this._languageId=o,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,S.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===F.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(D){return D?w._getTextInRange(D):w.getText()},get eol(){return w._eol===`
`?_.EndOfLine.LF:_.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(D){return w._lineAt(D)},offsetAt(D){return w._offsetAt(D)},positionAt(D){return w._positionAt(D)},validateRange(D){return w._validateRange(D)},validatePosition(D){return w._validatePosition(D)},getWordRangeAtPosition(D,I){return w._getWordRangeAtPosition(D,I)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,m.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,m.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const D=this._validateRange(w);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const I=this._eol,b=D.start.line,c=D.end.line,o=[];o.push(this._lines[b].substring(D.start.character));for(let v=b+1;v<c;v++)o.push(this._lines[v]);return o.push(this._lines[c].substring(0,D.end.character)),o.join(I)}_lineAt(w){let D;if(w instanceof _.Position?D=w.line:typeof w=="number"&&(D=w),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new f(D,this._lines[D],D===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(w),I=this._lines[D.index].length;return new _.Position(D.index,Math.min(D.remainder,I))}_validateRange(w){if(!(w instanceof _.Range))throw new Error("Invalid argument");const D=this._validatePosition(w.start),I=this._validatePosition(w.end);return D===w.start&&I===w.end?w:new _.Range(D.line,D.character,I.line,I.character)}_validatePosition(w){if(!(w instanceof _.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:D,character:I}=w,b=!1;if(D<0)D=0,I=0,b=!0;else if(D>=this._lines.length)D=this._lines.length-1,I=this._lines[D].length,b=!0;else{const c=this._lines[D].length;I<0?(I=0,b=!0):I>c&&(I=c,b=!0)}return b?new _.Position(D,I):w}_getWordRangeAtPosition(w,D){const I=this._validatePosition(w);if(!D)D=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const b=(0,A.getWordAtText)(I.character+1,(0,A.ensureValidWordDefinition)(D),this._lines[I.line],0);if(b)return new _.Range(I.line,b.startColumn-1,I.line,b.endColumn-1)}}e.ExtHostDocumentData=l;class f{constructor(w,D,I){this._line=w,this._text=D,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new _.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new _.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(fe[204],me([0,1,7,3,113,6,82,24,2,32]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(l,f,d,w){this._notebook=d,this._selector=w,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(I=>{const b=this._cellUris.get(I.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(I=>D(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new _.ResourceMap;const l=[],f=[];for(const d of this._notebook.getCells())d.kind===m.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),l.push(d.document.getText().length+1),f.push(d.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(l){if(!l){let b="";for(const c of this._cells)b+=c.document.getText()+`
`;return b=b.slice(0,-1),b}if(l.isEmpty)return"";const f=this.locationAt(l.start),d=this.locationAt(l.end),w=this._cellUris.get(f.uri),D=this._cellUris.get(d.uri);if(w===void 0||D===void 0)return"";if(w===D)return this._cells[w].document.getText(new m.Range(f.range.start,d.range.end));const I=[this._cells[w].document.getText(new m.Range(f.range.start,new m.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<D;b++)I.push(this._cells[b].document.getText());return I.push(this._cells[D].document.getText(new m.Range(new m.Position(0,0),d.range.end))),I.join(`
`)}offsetAt(l){const f=this._cellLines.getIndexOf(l.line),d=this._cellLengths.getPrefixSum(f.index-1),w=this._cells[f.index].document.offsetAt(l.with(f.remainder));return d+w}positionAt(l){if(typeof l=="number"){const d=this._cellLengths.getIndexOf(l),w=this._cellLines.getPrefixSum(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(w)}const f=this._cellUris.get(l.uri);if(f!==void 0){const d=this._cellLines.getPrefixSum(f-1);return new m.Position(d+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const f=this._cellLines.getIndexOf(l.start.line);let d=f;l.isEmpty||(d=this._cellLines.getIndexOf(l.end.line));const w=new m.Position(f.remainder,l.start.character),D=new m.Position(d.remainder,l.end.character),I=new m.Range(w,D),b=this._cells[f.index];return new m.Location(b.document.uri,b.document.validateRange(I))}contains(l){return this._cellUris.has(l)}validateRange(l){const f=this.validatePosition(l.start),d=this.validatePosition(l.end);return l.with(f,d)}validatePosition(l){const f=this._cellLines.getIndexOf(l.line),d=new m.Position(f.remainder,l.character),w=this._cells[f.index].document.validatePosition(d),D=this._cellLines.getPrefixSum(f.index-1);return new m.Position(D+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[205],me([0,1,7,14,3]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(_){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(_){let S=_==="light"?m.ColorThemeKind.Light:_==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([$e(0,F.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(fe[67],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class F{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(fe[206],me([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function C(_,S){if(S.serializeBuffersForPostMessage){const P=new F,i=(f,d)=>{if(d instanceof ArrayBuffer){const w=P.add(d);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(d)){const w=y(d);if(w){const D=P.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:w,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},k=JSON.stringify(_,i),l=P.buffers.map(f=>{const d=new Uint8Array(f);return m.VSBuffer.wrap(d)});return{message:k,buffers:l}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeWebviewMessage=C;function y(_){switch(_.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(_,S){const P=S.map(l=>{const f=new ArrayBuffer(l.byteLength);return new Uint8Array(f).set(l.buffer),f}),i=S.length?(l,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const d=f,{index:w}=d,D=P[w];if(d.view)switch(d.view.type){case 1:return new Int8Array(D,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return f}:void 0;return{message:JSON.parse(_,i),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(fe[207],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(F){function C(A){const _={items:new Map};return A.types.forEach((S,P)=>{_.items.set(S,{asString:async()=>A.items[P].asString})}),_}F.toITreeDataTransfer=C;async function y(A){const _={types:[],items:[]},S=Array.from(A.items.entries());for(const P of S)_.types.push(P[0]),_.items.push({asString:await P[1].asString()});return _}F.toTreeDataTransferDTO=y})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[88],me([0,1,10,2]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(_,S){return _.scheme===m.Schemas.http||_.scheme===m.Schemas.https?_:(S&&S.authority&&S.isRemote&&_.scheme===m.Schemas.file&&(_=F.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:_.path})),F.URI.from({scheme:m.Schemas.https,authority:`${_.scheme}+${y(_.authority)}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=C;function y(_){return _.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function A(_){return _.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=A}),define(fe[208],me([0,1,3,6,88]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(_,S,P){this._proxy=_,this._editors=S,this._initData=P,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const i=S.getVisibleTextEditors();for(const k of this._insets.values())i.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(_=>_.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(_,S,P,i,k){let l;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===_){l=c;break}if(!l)throw new Error("not a visible editor");const f=this,d=this._handlePool++,w=new m.Emitter,D=new m.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,C.asWebviewUri)(c,f._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(c){this._options=c,f._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,f._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(c){return f._proxy.$postMessage(d,c)}},b=new class{constructor(){this.editor=_,this.line=S,this.height=P,this.webview=I,this.onDidDispose=D.event}dispose(){f._insets.has(d)&&(f._insets.delete(d),f._proxy.$disposeEditorInset(d),D.fire(),D.dispose(),w.dispose())}};return this._proxy.$createEditorInset(d,l.id,l.value.document.uri,S+1,P,i||{},k.identifier,k.extensionLocation),this._insets.set(d,{editor:_,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(_){const S=this._insets.get(_);S&&S.inset.dispose()}$onDidReceiveMessage(_,S){const P=this._insets.get(_);P&&P.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=y}),define(fe[209],me([0,1,174,12,2,6,4,63,34,16,10]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new _.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new _.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new _.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new _.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new _.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new _.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new _.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new _.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new _.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new _.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new _.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new _.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new _.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new _.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new _.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new _.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new _.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new _.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new _.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new _.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new _.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new _.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(M,R,W){for(const V of W.visibleEditorPanes)if(V.group.id===R&&M.matches(V.input))return V.getViewState()}e.findViewStateForEditor=k;function l(M){if(o(M))return!1;const R=M;return C.URI.isUri(R?.resource)}e.isResourceEditorInput=l;function f(M){if(o(M))return!1;const R=M;return R?.original!==void 0&&R.modified!==void 0}e.isResourceDiffEditorInput=f;function d(M){if(o(M)||f(M))return!1;const R=M;return R?.primary!==void 0&&R.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function w(M){if(o(M))return!1;const R=M;return R?R.resource===void 0||R.resource.scheme===i.Schemas.untitled||R.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var D;(function(M){M[M.SHORT=0]="SHORT",M[M.MEDIUM=1]="MEDIUM",M[M.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var I;(function(M){M[M.EXPLICIT=1]="EXPLICIT",M[M.AUTO=2]="AUTO",M[M.FOCUS_CHANGE=3]="FOCUS_CHANGE",M[M.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var b;(function(M){M[M.None=0]="None",M[M.Readonly=2]="Readonly",M[M.Untitled=4]="Untitled",M[M.Singleton=8]="Singleton",M[M.RequiresTrust=16]="RequiresTrust",M[M.CanSplitInGroup=32]="CanSplitInGroup",M[M.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends y.Disposable{}e.AbstractEditorInput=c;function o(M){return M instanceof c}e.isEditorInput=o;function v(M){const R=M;return C.URI.isUri(R?.preferredResource)}function t(M){const R=M;return o(R?.primary)&&o(R?.secondary)}e.isSideBySideEditorInput=t;function h(M){const R=M;return o(R?.modified)&&o(R?.original)}e.isDiffEditorInput=h;function s(M){return o(M?.editor)}e.isEditorInputWithOptions=s;function n(M){const R=M;return s(M)&&R?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function r(M){const R=M;return typeof R?.groupId=="number"&&o(R.editor)}e.isEditorIdentifier=r;var a;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.REPLACE=1]="REPLACE",M[M.MOVE=2]="MOVE",M[M.UNPIN=3]="UNPIN"})(a=e.EditorCloseContext||(e.EditorCloseContext={}));var u;(function(M){M[M.PRIMARY=1]="PRIMARY",M[M.SECONDARY=2]="SECONDARY",M[M.BOTH=3]="BOTH",M[M.ANY=4]="ANY"})(u=e.SideBySideEditor||(e.SideBySideEditor={}));class p{getOriginalUri(R,W){if(!R)return;if(W?.supportSideBySide){const{primary:N,secondary:j}=this.getSideEditors(R);if(N&&j){if(W?.supportSideBySide===u.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===u.ANY)return this.getOriginalUri(N,{filterByScheme:W.filterByScheme})??this.getOriginalUri(j,{filterByScheme:W.filterByScheme});R=W.supportSideBySide===u.PRIMARY?N:j}}if(f(R)||d(R))return;const V=v(R)?R.preferredResource:R.resource;return!V||!W||!W.filterByScheme?V:this.filterUri(V,W.filterByScheme)}getSideEditors(R){return t(R)||d(R)?{primary:R.primary,secondary:R.secondary}:h(R)||f(R)?{primary:R.modified,secondary:R.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(R,W){if(!R)return;if(W?.supportSideBySide){const{primary:N,secondary:j}=this.getSideEditors(R);if(N&&j){if(W?.supportSideBySide===u.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===u.ANY)return this.getCanonicalUri(N,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:W.filterByScheme});R=W.supportSideBySide===u.PRIMARY?N:j}}if(f(R)||d(R))return;const V=R.resource;return!V||!W||!W.filterByScheme?V:this.filterUri(V,W.filterByScheme)}filterUri(R,W){if(Array.isArray(W)){if(W.some(V=>R.scheme===V))return R}else if(W===R.scheme)return R}}e.EditorResourceAccessor=new p;var E;(function(M){M[M.LEFT=0]="LEFT",M[M.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(R){const W=this.instantiationService=R.get(A.IInstantiationService);for(const[V,N]of this.editorSerializerConstructors)this.createEditorSerializer(V,N,W);this.editorSerializerConstructors.clear()}createEditorSerializer(R,W,V){const N=V.createInstance(W);this.editorSerializerInstances.set(R,N)}registerFileEditorFactory(R){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=R}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(R,W){if(this.editorSerializerConstructors.has(R)||this.editorSerializerInstances.has(R))throw new Error(`A editor serializer with type ID '${R}' was already registered.`);return this.instantiationService?this.createEditorSerializer(R,W,this.instantiationService):this.editorSerializerConstructors.set(R,W),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(R),this.editorSerializerInstances.delete(R)})}getEditorSerializer(R){return this.editorSerializerInstances.get(typeof R=="string"?R:R.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new g);async function T(M,R){if(!M||!M.length)return[];const W=await Promise.all(M.map(async V=>{const N=C.URI.revive(V.fileUri);if(!N||!await R.canHandleResource(N))return;const U=typeof V.exists=="boolean"?V.exists:await R.exists(N);if(!U&&V.openOnlyIfExists)return;const x={selection:U?V.selection:void 0,pinned:!0,override:V.editorOverrideId};let z;return U?z={resource:N,options:x}:z={resource:N,options:x,forceUntitled:!0},z}));return(0,P.coalesce)(W)}e.pathsToEditors=T;var L;(function(M){M[M.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",M[M.SEQUENTIAL=1]="SEQUENTIAL"})(L=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[210],me([0,1,3,63,175,4,6,24,34,16,59,25,47,199]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",l.Codicon.window,(0,C.localize)(0,null));var d;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(d=e.Extensions||(e.Extensions={}));var w;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function D(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=D;function I(r){return`viewContainer.${r}.enabled`}e.getEnabledViewContainerContextKey=I;class b extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(a,u,p){const E=this.get(a.id);if(E)return E;const g=a;return g.openCommandActionDescriptor=p?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,_.getOrSet)(this.viewContainers,u,[]).push(g),p?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:u}),g}deregisterViewContainer(a){for(const u of this.viewContainers.keys()){const p=this.viewContainers.get(u),E=p?.indexOf(a);if(E!==-1){p?.splice(E,1),p.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:u});return}}}get(a){return this.all.filter(u=>u.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(p=>p?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===a)}}S.Registry.add(d.ViewContainersRegistry,new b);var c;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function o(r,a){const u=r.group??c.More,p=a.group??c.More;return u!==p?u.localeCompare(p):(r.order??5)-(a.order??5)}class v extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(a,u){this.registerViews2([{views:a,viewContainer:u}])}registerViews2(a){a.forEach(({views:u,viewContainer:p})=>this.addViews(u,p)),this._onViewsRegistered.fire(a)}deregisterViews(a,u){const p=this.removeViews(a,u);p.length&&this._onViewsDeregistered.fire({views:p,viewContainer:u})}moveViews(a,u){for(const p of this._views.keys())if(p!==u){const E=this.removeViews(a,p);E.length&&(this.addViews(E,u),this._onDidChangeContainer.fire({views:E,from:p,to:u}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const u of this._viewContainers){const p=(this._views.get(u)||[]).filter(E=>E.id===a)[0];if(p)return p}return null}getViewContainer(a){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(E=>E.id===a)[0])return u;return null}registerViewWelcomeContent(a,u){return this._viewWelcomeContents.add(a,u),this._onDidChangeViewWelcomeContent.fire(a),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(a,u),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,u){const p=new Map;for(const[E,g]of u)this._viewWelcomeContents.add(a,g),p.set(E,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(a,g),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),p}getViewWelcomeContent(a){const u=[];return this._viewWelcomeContents.forEach(a,p=>u.push(p)),u.sort(o)}addViews(a,u){let p=this._views.get(u);p||(p=[],this._views.set(u,p),this._viewContainers.push(u));for(const E of a){if(this.getView(E.id)!==null)throw new Error((0,C.localize)(1,null,E.id));p.push(E)}}removeViews(a,u){const p=this._views.get(u);if(!p)return[];const E=[],g=[];for(const T of p)a.includes(T)?E.push(T):g.push(T);return E.length&&(g.length?this._views.set(u,g):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),E}}S.Registry.add(d.ViewsRegistry,new v),e.IViewsService=(0,y.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(r){return`view.${r}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var h;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(h=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(a,u){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,a),this._hasResolve=!!u,this.resolve=async p=>{if(u&&!this.resolved){const E=await u(p);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}p.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[126],me([0,1,3,17,176]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(_){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=_}onEvent(_){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=_}onRequest(_){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=_}sendResponse(_){_.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${_.command}`)):this.internalSend("response",_)}sendRequest(_,S,P,i){const k={command:_};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof i=="number"){const l=setTimeout(()=>{clearTimeout(l);const f=this.pendingRequests.get(k.seq);if(f){this.pendingRequests.delete(k.seq);const d={type:"response",seq:0,request_seq:k.seq,success:!1,command:_,message:(0,C.localize)(0,null,i,_)};f(d)}},i)}return P&&this.pendingRequests.set(k.seq,P),k.seq}acceptMessage(_){this.messageCallback?this.messageCallback(_):(this.queue.push(_),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(_,S){return _.type!=="event"||S.type!=="event"}async processQueue(){let _;for(;this.queue.length;){if((!_||this.needsTaskBoundaryBetween(this.queue[0],_))&&await(0,F.timeout)(0),_=this.queue.shift(),!_)return;switch(_.type){case"event":this.eventCallback&&this.eventCallback(_);break;case"request":this.requestCallback&&this.requestCallback(_);break;case"response":const S=_,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}internalSend(_,S){S.type=_,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const _=new Map;this.pendingRequests.forEach((S,P)=>_.set(P,S)),await(0,F.timeout)(500),_.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(fe[211],me([0,1,9,2,8,25,10]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const _=/{([^}]+)}/g;function S(s,n,r){return s.replace(_,function(a,u){return n&&u.length>0&&u[0]!=="_"?a:r&&r.hasOwnProperty(u)?r[u]:a})}e.formatPII=S;function P(s){const n={};for(const r of Object.keys(s))r.startsWith("!")||(n[r]=s[r]);return n}e.filterExceptionsFromTelemetry=P;function i(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||i(s.parentSession))}e.isSessionAttach=i;function k(s){let n=s.configuration.type;if(!!n)return n==="vslsShare"&&(n=s.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(n,"extensionhost")||(0,m.equalsIgnoreCase)(n,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function l(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=l;function f(s,n,r){let a,u=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=p.exec(s);){let g=E.index+1,T=g+E[0].length;if(g<=n&&T>=r){a=E[0],u=g;break}}if(a){let g=/\w+/g,T=null;for(;(T=g.exec(a))&&!(T.index+1+u+T[0].length>=r););T&&(a=a.substring(0,g.lastIndex))}return a?{start:u,end:u+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(s){return!!(s&&s.match(d))}e.isUri=w;function D(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(w(s.path))return F.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return F.URI.file(s.path)}return s.path}function I(s){if(typeof s.path=="object"){const n=F.URI.revive(s.path);if(n)return n.scheme===A.Schemas.file?n.fsPath:n.toString()}return s.path}function b(s,n){const r=n?D:I,a=(0,y.deepClone)(s);return o(a,(u,p)=>{u&&p&&(p.path=r(p))}),a}e.convertToDAPaths=b;function c(s,n){const r=n?D:I,a=(0,y.deepClone)(s);return o(a,(u,p)=>{!u&&p&&(p.path=r(p))}),a}e.convertToVSCPaths=c;function o(s,n){switch(s.type){case"event":const r=s;switch(r.event){case"output":n(!1,r.body.source);break;case"loadedSource":n(!1,r.body.source);break;case"breakpoint":n(!1,r.body.breakpoint.source);break;default:break}break;case"request":const a=s;switch(a.command){case"setBreakpoints":n(!0,a.arguments.source);break;case"breakpointLocations":n(!0,a.arguments.source);break;case"source":n(!0,a.arguments.source);break;case"gotoTargets":n(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(p=>n(!1,p));break;default:break}break;case"response":const u=s;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(p=>n(!1,p.source));break;case"loadedSources":u.body.sources.forEach(p=>n(!1,p));break;case"scopes":u.body.scopes.forEach(p=>n(!1,p.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(p=>n(!1,p.source));break;case"setBreakpoints":u.body.breakpoints.forEach(p=>n(!1,p.source));break;default:break}break}}function v(s){return s.filter(n=>!n.presentation?.hidden).sort((n,r)=>n.presentation?r.presentation?n.presentation.group?r.presentation.group?n.presentation.group!==r.presentation.group?n.presentation.group.localeCompare(r.presentation.group):t(n.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(n.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,n){return typeof s!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:s-n}async function h(s,n){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorMode});if(r!=="none"&&(await n.saveAll(),r==="allEditorsInActiveGroup")){const a=n.activeEditorPane;a&&await n.save({editor:a.input,groupId:a.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(fe[212],me([0,1,28,39,177,127,8,9,25,11,187,126]),function(Y,e,m,F,C,y,A,_,S,P,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const c=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${l.TWO_CRLF}${c}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+c))}continue}}else{const c=this.rawData.indexOf(l.TWO_CRLF);if(c!==-1){const v=this.rawData.toString("utf8",0,c).split(l.HEADER_LINESEPARATOR);for(const t of v){const h=t.split(l.HEADER_FIELDSEPARATOR);h[0]==="Content-Length"&&(this.contentLength=Number(h[1]))}this.rawData=this.rawData.slice(c+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class f extends l{startSession(){return new Promise((b,c)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",v=>{o?this._onError.fire(v):c(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class d extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=d;class w extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class D extends l{constructor(b,c,o){super();this.adapterExecutable=b,this.debugType=c,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,c=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await m.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let v=process.env;if(o.env&&Object.keys(o.env).length>0&&(v=S.mixin(S.deepClone(process.env),o.env)),b==="node")if(Array.isArray(c)&&c.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:v,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(s.cwd=o.cwd);const n=F.fork(c[0],c.slice(1),s);if(!n.pid)throw new Error(C.localize(2,null,c[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const h={env:v};o.cwd&&(h.cwd=o.cwd),this.serverProcess=F.spawn(b,c,h)}this.serverProcess.on("error",h=>{this._onError.fire(h)}),this.serverProcess.on("exit",(h,s)=>{this._onExit.fire(h)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",h=>{this._onError.fire(h)}),this.serverProcess.stdin.on("error",h=>{this._onError.fire(h)});const t=this.outputService;if(t){const h=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(h(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((b,c)=>{const o=F.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,h){if(v)return c(v)});o.on("exit",b),o.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,c){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=A.join(c,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?o.program=b.program:o.program=A.join(c,b.program)),b.args&&(o.args=b.args);const v=b;return v.win&&(o.win=D.extract(v.win,c)),v.winx86&&(o.winx86=D.extract(v.winx86,c)),v.windows&&(o.windows=D.extract(v.windows,c)),v.osx&&(o.osx=D.extract(v.osx,c)),v.linux&&(o.linux=D.extract(v.linux,c)),o}static platformAdapterExecutable(b,c){let o=Object.create(null);c=c.toLowerCase();for(const r of b)if(r.contributes){const a=r.contributes.debuggers;a&&a.length>0&&a.filter(u=>typeof u.type=="string"&&_.equalsIgnoreCase(u.type,c)).forEach(u=>{const p=D.extract(u,r.extensionLocation.fsPath);o=S.mixin(o,p,r.isBuiltin)})}let v;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=o.winx86||o.win||o.windows:P.isWindows?v=o.win||o.windows:P.isMacintosh?v=o.osx:P.isLinux&&(v=o.linux),v=v||o;let t=v.program||o.program;const h=v.args||o.args;let s=v.runtime||o.runtime;const n=v.runtimeArgs||o.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(h||[])};if(t)return{type:"executable",command:t,args:h||[]}}}e.ExecutableDebugAdapter=D}),define(fe[213],me([0,1,39,11,29,189]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,f){return new Promise((d,w)=>{let D="";const I=m.spawn(l,f);I.pid&&I.stdout.on("data",b=>{D+=b.toString()}),I.on("error",b=>{w(b)}),I.on("close",b=>{d(D)})})}let _;function S(l,f){if(!_)if(F.isWindows)_=new y.WindowsExternalTerminalService;else if(F.isMacintosh)_=new y.MacExternalTerminalService;else if(F.isLinux)_=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const d=f.getConfiguration("terminal");return _.runInTerminal(l.title,l.cwd,l.args,l.env||{},d.external||{})}e.runInExternalTerminal=S;function P(l){return l?F.isWindows?new Promise(async f=>{(await new Promise((w,D)=>{Y(["windows-process-tree"],w,D)})).getProcessTree(l,w=>{f(w.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(f=>{const d=f.trim();return!(d.length===0||d.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var i;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(i||(i={}));function k(l,f,d,w){l=l.trim().toLowerCase();let D;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?D=1:l.indexOf("cmd.exe")>=0?D=0:l.indexOf("bash")>=0?D=2:F.isWindows?D=0:D=2;let I,b=" ";switch(D){case 1:if(I=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),d){const o=(0,C.getDriveLetter)(d);o&&(b+=`${o}:; `),b+=`cd ${I(d)}; `}if(w)for(let o in w){const v=w[o];v===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${v}'; `}if(f.length>0){const o=I(f.shift());b+=o[0]==="'"?`& ${o} `:`${o} `;for(let v of f)b+=`${I(v)} `}break;case 0:if(I=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),d){const o=(0,C.getDriveLetter)(d);o&&(b+=`${o}: && `),b+=`cd ${I(d)} && `}if(w){b+='cmd /C "';for(let o in w){let v=w[o];v===null?b+=`set "${o}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${o}=${v}" && `)}}for(let o of f)b+=`${I(o)} `;w&&(b+='"');break;case 2:I=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const c=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(d&&(b+=`cd ${I(d)} ; `),w){b+="/usr/bin/env";for(let o in w){const v=w[o];v===null?b+=` -u ${c(o)}`:b+=` ${c(`${o}=${v}`)}`}b+=" "}for(let o of f)b+=`${I(o)} `;break}return b}e.prepareCommand=k}),define(fe[128],me([0,1,30,103,10,8,11,63]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var D;(function(g){g.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function L(N,j){return N.with({scheme:g.scheme,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}g.generate=L;function M(N){if(N.scheme!==g.scheme)return;const j=T.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||C.Schemas.file,fragment:null})}:void 0}g.parse=M;function R(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const j=T.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||C.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=R;function W(N,j,U){return N.with({scheme:U,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}g.generateCellUri=W;function V(N,j){if(N.scheme!==j)return;const U=T.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}g.parseCellUri=V})(D=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(g){return I.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function c(g){return I.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function o(g){return I.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=o;function v(g,T){return A.isWindows&&(g=g.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),m.match(g,T)}function t(g,T,L){let M=0;for(let R=0;R<T.length;R++){if(v(T[R],g))return M;M++}for(let R=0;R<L.length;R++){if(v(L[R],g))return M;M++}return M}function h(g,T,L){return g.sort((M,R)=>t(M,T,L)-t(R,T,L))}e.sortMimeTypes=h;function s(g,T,L,M=(R,W)=>R===W){const R=[];function W(j,U,x){if(U===0&&x.length===0)return;const z=R[R.length-1];z&&z.start+z.deleteCount===j?(z.deleteCount+=U,z.toInsert.push(...x)):R.push({start:j,deleteCount:U,toInsert:x})}let V=0,N=0;for(;;){if(V===g.length){W(V,0,T.slice(N));break}if(N===T.length){W(V,g.length-V,[]);break}const j=g[V],U=T[N];if(M(j,U)){V+=1,N+=1;continue}L(U)?(W(V,1,[]),V+=1):(W(V,0,[U]),N+=1)}return R}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(g){g.default="default",g.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(g){const T=g;return!!((typeof T.include=="string"||m.isRelativePattern(T.include))&&(typeof T.exclude=="string"||m.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=r;function a(g,T,L){if(Array.isArray(g.viewType)&&g.viewType.indexOf(T)>=0||g.viewType===T)return!0;if(g.filenamePattern){let M=r(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,R=r(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(m.match(M,(0,y.basename)(L.fsPath).toLowerCase()))return!(R&&m.match(R,(0,y.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class u{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)T[L]=this.textModel.cells[L].getHashValue();return T}}e.CellSequence=u,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var p;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(T){return`${E._prefix}${T}`}static parse(T){if(T.startsWith(E._prefix))return T.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(fe[214],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState",C[C.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(fe[215],me([0,1,179,4,63]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[216],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=m;function F(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=F}),define(fe[129],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var F;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(k){k[k.Error=0]="Error",k[k.Info=1]="Info"})(C=e.TestMessageType||(e.TestMessageType={}));var y;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(k,l)=>{l.expand!==void 0&&(k.expand=l.expand),l.item!==void 0&&(k.item=k.item?Object.assign(k.item,l.item):l.item)};e.applyTestItemUpdate=A;var _;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var S;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",k[k.Retire=4]="Retire",k[k.AddTag=5]="AddTag",k[k.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(l){}update(l){}remove(l,f){}complete(){}}e.IncrementalChangeCollector=P;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const f=this.createChangeCollector();for(const d of l)switch(d[0]){case 0:{const w=d[1];if(w.parent){if(this.items.has(w.parent)){const D=this.items.get(w.parent);D.children.add(w.item.extId);const I=this.createItem(w,D);this.items.set(w.item.extId,I),f.add(I)}}else{const D=this.createItem(w);this.roots.add(D),this.items.set(w.item.extId,D),f.add(D)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=d[1],D=this.items.get(w.extId);if(!D)break;w.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,w),f.update(D);break}case 2:{const w=this.items.get(d[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const D=[[d[1]]];for(;D.length;)for(const I of D.pop()){const b=this.items.get(I);b&&(D.push(b.children),this.items.delete(I),f.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d[1]);break;case 3:this.updatePendingRoots(d[1]);break;case 5:this._tags.set(d[1].id,d[1]);break;case 6:this._tags.delete(d[1]);break}f.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=i}),define(fe[89],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(y){y.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(y){y[y.IsSame=0]="IsSame",y[y.Disconnected=1]="Disconnected",y[y.IsChild=2]="IsChild",y[y.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class C{constructor(A,_=A.length){if(this.path=A,this.viewEnd=_,A.length===0||_<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,_,S=A.parent){if(A.id===_)return new C([_]);let P=[A.id];for(let i=S;i&&i.id!==_;i=i.parent)P.push(i.id);return P.push(_),new C(P.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new C(A.split("\0"))}static join(A,_){return new C([...A.path,_])}static joinToString(A,_){return A.toString()+"\0"+_}static compare(A,_){return A===_?0:_.startsWith(A+"\0")?2:A.startsWith(_+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let _=0;_<A.viewEnd&&_<this.viewEnd;_++)if(A.path[_]!==this.path[_])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=C}),define(fe[217],me([0,1,8,38,12,25,11,80,180]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(k,l,f){this._contributedVariables=new Map,this._context=k,this._labelService=l,f&&(this._envVariablesPromise=f.then(d=>this.prepareEnv(d)))}prepareEnv(k){if(A.isWindows){const l=Object.create(null);return Object.keys(k).forEach(f=>{l[f.toLowerCase()]=k[f]}),l}return k}resolveWithEnvironment(k,l,f){return this.recursiveResolve(this.prepareEnv(k),l?l.uri:void 0,f)}async resolveAsync(k,l){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,l)}async resolveAnyBase(k,l,f,d){const w=y.deepClone(l);return A.isWindows&&w.windows?Object.keys(w.windows).forEach(D=>w[D]=w.windows[D]):A.isMacintosh&&w.osx?Object.keys(w.osx).forEach(D=>w[D]=w.osx[D]):A.isLinux&&w.linux&&Object.keys(w.linux).forEach(D=>w[D]=w.linux[D]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,w,f,d)}async resolveAnyAsync(k,l,f){return this.resolveAnyBase(k,l,f)}async resolveAnyMap(k,l,f){const d=new Map;return{newConfig:await this.resolveAnyBase(k,l,f,d),resolvedVariables:d}}resolveWithInteractionReplace(k,l,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,l,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,l){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,l)}recursiveResolve(k,l,f,d,w){if(C.isString(f))return this.resolveString(k,l,f,d,w);if(C.isArray(f))return f.map(D=>this.recursiveResolve(k,l,D,d,w));if(C.isObject(f)){let D=Object.create(null);return Object.keys(f).forEach(I=>{const b=this.resolveString(k,l,I,d,w);D[b]=this.recursiveResolve(k,l,f[I],d,w)}),D}return f}resolveString(k,l,f,d,w){return f.replace(P.VARIABLE_REGEXP,(I,b)=>{if(b.includes(P.VARIABLE_LHS))return I;let c=this.evaluateSingleVariable(k,I,b,l,d);return w&&w.set(b,c),c!==I&&C.isString(c)&&c.match(P.VARIABLE_REGEXP)&&(c=this.resolveString(k,l,c,d,w)),c})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,l,f,d,w){let D;const I=f.split(":");I.length>1&&(f=I[0],D=I[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,S.localize)(0,null,l))},c=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,l,m.basename(v)))},o=()=>{if(D){const v=this._context.getFolderUri(D);if(v)return v;throw new Error((0,S.localize)(2,null,l,D))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,l)):new Error((0,S.localize)(4,null,l))};switch(f){case"env":if(D){if(k){const v=k[A.isWindows?D.toLowerCase():D];if(C.isString(v))return v}return""}throw new Error((0,S.localize)(5,null,l));case"config":if(D){const v=this._context.getConfigurationValue(d,D);if(C.isUndefinedOrNull(v))throw new Error((0,S.localize)(6,null,l,D));if(C.isObject(v))throw new Error((0,S.localize)(7,null,l,D));return v}throw new Error((0,S.localize)(8,null,l));case"command":return this.resolveFromMap(l,D,w,"command");case"input":return this.resolveFromMap(l,D,w,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,_.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return d||D?(0,_.normalizeDriveLetter)(this.fsPath(o())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(o()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,S.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,l));case"file":return b();case"fileWorkspaceFolder":return c();case"relativeFile":return d||D?m.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":const h=m.dirname(b());if(d||D){const a=m.relative(this.fsPath(o()),h);return a.length===0?".":a}return h;case"fileDirname":return m.dirname(b());case"fileExtname":return m.extname(b());case"fileBasename":return m.basename(b());case"fileBasenameNoExtension":const s=m.basename(b());return s.slice(0,s.length-m.extname(s).length);case"fileDirnameBasename":return m.basename(m.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const r=this._context.getAppRoot();return r||l;case"pathSeparator":return m.sep;default:try{const a=D?`${f}:${D}`:f;return this.resolveFromMap(l,a,w,void 0)}catch(a){return l}}}}resolveFromMap(k,l,f,d){if(l&&f){const w=d===void 0?f[l]:f[d+":"+l];if(typeof w=="string")return w;throw new Error((0,S.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[130],me([0,1,4,209]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var y;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var _;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(w){const D=w;return(0,F.isEditorInput)(D?.editor)&&(0,F.isEditorInput)(D?.replacement)}e.isEditorReplacement=P;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function f(w){const D=w;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=f;function d(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(fe[218],me([0,1,4,130]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(y){const A=y;return typeof y=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=C}),define(fe[15],me([0,1,16,22,100,293,62,25,12,2,42,84,181,118,66,128,89,218,7]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(ge){function Ee(K){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:it,positionColumn:Ge}=K,pt=new b.Position(Se-1,Le-1),Et=new b.Position(it-1,Ge-1);return new b.Selection(pt,Et)}ge.to=Ee;function te(K){const{anchor:Se,active:Le}=K;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=te})(c=e.Selection||(e.Selection={}));var o;(function(ge){function Ee(K){if(!K)return;const{start:Se,end:Le}=K;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=Ee;function te(K){if(!K)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:it,endColumn:Ge}=K;return new b.Range(Se-1,Le-1,it-1,Ge-1)}ge.to=te})(o=e.Range||(e.Range={}));var v;(function(ge){function Ee(te){switch(te){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=Ee})(v=e.TokenType||(e.TokenType={}));var t;(function(ge){function Ee(K){return new b.Position(K.lineNumber-1,K.column-1)}ge.to=Ee;function te(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=te})(t=e.Position||(e.Position={}));var h;(function(ge){function Ee(Se,Le){return(0,m.coalesce)((0,m.asArray)(Se).map(it=>te(it,Le)))}ge.from=Ee;function te(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:K(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:ce.from(Se.pattern),exclusive:Se.exclusive}}function K(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(h=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(ge){function Ee(K){switch(K){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=Ee;function te(K){switch(K){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=te})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ge){function Ee(K){let Se;return K.code&&((0,S.isString)(K.code)||(0,S.isNumber)(K.code)?Se=String(K.code):Se={value:String(K.code.value),target:K.code.target}),{...o.from(K.range),message:K.message,source:K.source,code:Se,severity:a.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(r.from),tags:Array.isArray(K.tags)?(0,m.coalesce)(K.tags.map(s.from)):void 0}}ge.from=Ee;function te(K){const Se=new b.Diagnostic(o.to(K),K.message,a.to(K.severity));return Se.source=K.source,Se.code=(0,S.isString)(K.code)?K.code:K.code?.value,Se.relatedInformation=K.relatedInformation&&K.relatedInformation.map(r.to),Se.tags=K.tags&&(0,m.coalesce)(K.tags.map(s.to)),Se}ge.to=te})(n=e.Diagnostic||(e.Diagnostic={}));var r;(function(ge){function Ee(K){return{...o.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=Ee;function te(K){return new b.DiagnosticRelatedInformation(new b.Location(K.resource,o.to(K)),K.message)}ge.to=te})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(ge){function Ee(K){switch(K){case b.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ge.from=Ee;function te(K){switch(K){case f.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=te})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(ge){function Ee(K){return typeof K=="number"&&K>=b.ViewColumn.One?K-1:K===b.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ge.from=Ee;function te(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=te})(u=e.ViewColumn||(e.ViewColumn={}));function p(ge){return typeof ge.range!="undefined"}function E(ge){return ge.length===0?!0:!!p(ge[0])}e.isDecorationOptionsArr=E;var g;(function(ge){function Ee(Ge){return Ge.map(ge.from)}ge.fromMany=Ee;function te(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let pt;if(te(Ge)){const{language:mt,value:_t}=Ge;pt={value:"```"+mt+`
`+_t+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ge)?pt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?pt={value:Ge}:pt={value:""};const Et=Object.create(null);pt.uris=Et;const ft=mt=>{try{let _t=P.URI.parse(mt,!0);_t=_t.with({query:Se(_t.query,Et)}),Et[mt]=_t}catch(_t){}return""},bt=new y.Renderer;return bt.link=ft,bt.image=mt=>ft(C.parseHrefAndDimensions(mt).href),y(pt.value,{renderer:bt}),pt}ge.from=K;function Se(Ge,pt){if(!Ge)return Ge;let Et;try{Et=(0,A.parse)(Ge)}catch(bt){}if(!Et)return Ge;let ft=!1;return Et=(0,_.cloneAndChange)(Et,bt=>{if(P.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[mt]=bt,ft=!0,mt}else return}),ft?JSON.stringify(Et):Ge}function Le(Ge){const pt=new b.MarkdownString(Ge.value,Ge.supportThemeIcons);return pt.isTrusted=Ge.isTrusted,pt.supportHtml=Ge.supportHtml,pt}ge.to=Le;function it(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=it})(g=e.MarkdownString||(e.MarkdownString={}));function T(ge){return E(ge)?ge.map(Ee=>({range:o.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?g.fromMany(Ee.hoverMessage):Ee.hoverMessage?g.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ge.map(Ee=>({range:o.from(Ee)}))}e.fromRangeOrRangeWithMessage=T;function L(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?P.URI.file(ge):ge}e.pathOrURIToURI=L;var M;(function(ge){function Ee(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?L(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}ge.from=Ee})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(ge){function Ee(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?L(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?M.from(te.before):void 0,after:te.after?M.from(te.after):void 0}}ge.from=Ee})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(ge){function Ee(te){if(typeof te=="undefined")return te;switch(te){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=Ee})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ge){function Ee(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?W.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?R.from(te.light):void 0,dark:te.dark?R.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?L(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?M.from(te.before):void 0,after:te.after?M.from(te.after):void 0}}ge.from=Ee})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ge){function Ee(K){return{text:K.newText,eol:K.newEol&&ne.from(K.newEol),range:o.from(K.range)}}ge.from=Ee;function te(K){const Se=new b.TextEdit(o.to(K.range),K.text);return Se.newEol=typeof K.eol=="undefined"?void 0:ne.to(K.eol),Se}ge.to=te})(N=e.TextEdit||(e.TextEdit={}));var j;(function(ge){function Ee(K,Se,Le){const it={edits:[]};if(K instanceof b.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)it.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const pt=Se?.getDocument(Ge.uri);it.edits.push({_type:2,resource:Ge.uri,edit:N.from(Ge.edit),modelVersionId:pt?.version,metadata:Ge.metadata})}else Ge._type===3?it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ye.from)}});return it}ge.from=Ee;function te(K){const Se=new b.WorkspaceEdit;for(const Le of K.edits)Le.edit?Se.replace(P.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):Se.renameFile(P.URI.revive(Le.oldUri),P.URI.revive(Le.newUri),Le.options);return Se}ge.to=te})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ge){const Ee=Object.create(null);Ee[b.SymbolKind.File]=0,Ee[b.SymbolKind.Module]=1,Ee[b.SymbolKind.Namespace]=2,Ee[b.SymbolKind.Package]=3,Ee[b.SymbolKind.Class]=4,Ee[b.SymbolKind.Method]=5,Ee[b.SymbolKind.Property]=6,Ee[b.SymbolKind.Field]=7,Ee[b.SymbolKind.Constructor]=8,Ee[b.SymbolKind.Enum]=9,Ee[b.SymbolKind.Interface]=10,Ee[b.SymbolKind.Function]=11,Ee[b.SymbolKind.Variable]=12,Ee[b.SymbolKind.Constant]=13,Ee[b.SymbolKind.String]=14,Ee[b.SymbolKind.Number]=15,Ee[b.SymbolKind.Boolean]=16,Ee[b.SymbolKind.Array]=17,Ee[b.SymbolKind.Object]=18,Ee[b.SymbolKind.Key]=19,Ee[b.SymbolKind.Null]=20,Ee[b.SymbolKind.EnumMember]=21,Ee[b.SymbolKind.Struct]=22,Ee[b.SymbolKind.Event]=23,Ee[b.SymbolKind.Operator]=24,Ee[b.SymbolKind.TypeParameter]=25;function te(Se){return typeof Ee[Se]=="number"?Ee[Se]:6}ge.from=te;function K(Se){for(const Le in Ee)if(Ee[Le]===Se)return Number(Le);return b.SymbolKind.Property}ge.to=K})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(ge){function Ee(K){switch(K){case b.SymbolTag.Deprecated:return 1}}ge.from=Ee;function te(K){switch(K){case 1:return b.SymbolTag.Deprecated}}ge.to=te})(x=e.SymbolTag||(e.SymbolTag={}));var z;(function(ge){function Ee(K){return{name:K.name,kind:U.from(K.kind),tags:K.tags&&K.tags.map(x.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=Ee;function te(K){const Se=new b.SymbolInformation(K.name,U.to(K.kind),K.containerName,Q.to(K.location));return Se.tags=K.tags&&K.tags.map(x.to),Se}ge.to=te})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function Ee(K){const Se={name:K.name||"!!MISSING: name!!",detail:K.detail,range:o.from(K.range),selectionRange:o.from(K.selectionRange),kind:U.from(K.kind),tags:K.tags?.map(x.from)??[]};return K.children&&(Se.children=K.children.map(Ee)),Se}ge.from=Ee;function te(K){const Se=new b.DocumentSymbol(K.name,K.detail,U.to(K.kind),o.to(K.range),o.to(K.selectionRange));return(0,m.isNonEmptyArray)(K.tags)&&(Se.tags=K.tags.map(x.to)),K.children&&(Se.children=K.children.map(te)),Se}ge.to=te})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var $;(function(ge){function Ee(K){const Se=new b.CallHierarchyItem(U.to(K.kind),K.name,K.detail||"",P.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=Ee;function te(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:K.name,detail:K.detail,kind:U.from(K.kind),uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(x.from)}}ge.from=te})($=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(ge){function Ee(te){return new b.CallHierarchyIncomingCall($.to(te.from),te.fromRanges.map(K=>o.to(K)))}ge.to=Ee})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function Ee(te){return new b.CallHierarchyOutgoingCall($.to(te.to),te.fromRanges.map(K=>o.to(K)))}ge.to=Ee})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function Ee(K){return{range:K.range&&o.from(K.range),uri:K.uri}}ge.from=Ee;function te(K){return new b.Location(P.URI.revive(K.uri),o.to(K.range))}ge.to=te})(Q=e.location||(e.location={}));var de;(function(ge){function Ee(K){const Se=K,Le=K;return{originSelectionRange:Se.originSelectionRange?o.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:o.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?o.from(Se.targetSelectionRange):void 0}}ge.from=Ee;function te(K){return{targetUri:P.URI.revive(K.uri),targetRange:o.to(K.range),targetSelectionRange:K.targetSelectionRange?o.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?o.to(K.originSelectionRange):void 0}}ge.to=te})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function Ee(K){return{range:o.from(K.range),contents:g.fromMany(K.contents)}}ge.from=Ee;function te(K){return new b.Hover(K.contents.map(g.to),o.to(K.range))}ge.to=te})(_e=e.Hover||(e.Hover={}));var ye;(function(ge){function Ee(K){return{range:o.from(K.range),expression:K.expression}}ge.from=Ee;function te(K){return new b.EvaluatableExpression(o.to(K.range),K.expression)}ge.to=te})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ke;(function(ge){function Ee(K){if(K instanceof b.InlineValueText)return{type:"text",range:o.from(K.range),text:K.text};if(K instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=Ee;function te(K){switch(K.type){case"text":return{range:o.to(K.range),text:K.text};case"variable":return{range:o.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:o.to(K.range),expression:K.expression}}}ge.to=te})(ke=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function Ee(K){return{frameId:K.frameId,stoppedLocation:o.from(K.stoppedLocation)}}ge.from=Ee;function te(K){return new b.InlineValueContext(K.frameId,o.to(K.stoppedLocation))}ge.to=te})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ge){function Ee(K){return{range:o.from(K.range),kind:K.kind}}ge.from=Ee;function te(K){return new b.DocumentHighlight(o.to(K.range),K.kind)}ge.to=te})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function Ee(te){switch(te){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=Ee})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(ge){function Ee(te){return{triggerKind:He.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}ge.to=Ee})(q=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function Ee(K){switch(K){case b.CompletionItemTag.Deprecated:return 1}}ge.from=Ee;function te(K){switch(K){case 1:return b.CompletionItemTag.Deprecated}}ge.to=te})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(ge){const Ee=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function te(Le){return Ee.get(Le)??9}ge.from=te;const K=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Se(Le){return K.get(Le)??b.CompletionItemKind.Property}ge.to=Se})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(ge){function Ee(te,K){const Se=new b.CompletionItem(te.label);return Se.insertText=te.insertText,Se.kind=re.to(te.kind),Se.tags=te.tags?.map(ee.to),Se.detail=te.detail,Se.documentation=C.isMarkdownString(te.documentation)?g.to(te.documentation):te.documentation,Se.sortText=te.sortText,Se.filterText=te.filterText,Se.preselect=te.preselect,Se.commitCharacters=te.commitCharacters,i.Range.isIRange(te.range)?Se.range=o.to(te.range):typeof te.range=="object"&&(Se.range={inserting:o.to(te.range.insert),replacing:o.to(te.range.replace)}),Se.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?Se.insertText=new b.SnippetString(te.insertText):(Se.insertText=te.insertText,Se.textEdit=Se.range instanceof b.Range?new b.TextEdit(Se.range,Se.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(Se.additionalTextEdits=te.additionalTextEdits.map(Le=>N.to(Le))),Se.command=K&&te.command?K.fromInternal(te.command):void 0,Se}ge.to=Ee})(le=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?g.fromStrict(K.documentation):void 0}}ge.from=Ee;function te(K){return{label:K.label,documentation:C.isMarkdownString(K.documentation)?g.to(K.documentation):K.documentation}}ge.to=te})(Z=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?g.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=Ee;function te(K){return{label:K.label,documentation:C.isMarkdownString(K.documentation)?g.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=te})(ae=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function Ee(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.from):[]}}ge.from=Ee;function te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.to):[]}}ge.to=te})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function Ee(K){return{text:K.text,position:t.from(K.position),kind:je.from(K.kind??b.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=Ee;function te(K){const Se=new b.InlayHint(K.text,t.to(K.position),je.to(K.kind));return Se.whitespaceAfter=K.whitespaceAfter,Se.whitespaceBefore=K.whitespaceBefore,Se}ge.to=te})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function Ee(K){return K}ge.from=Ee;function te(K){return K}ge.to=te})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function Ee(K){return{range:o.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=Ee;function te(K){let Se;if(K.url)try{Se=typeof K.url=="string"?P.URI.parse(K.url,!0):P.URI.revive(K.url)}catch(Le){}return new b.DocumentLink(o.to(K.range),Se)}ge.to=te})(Ke=e.DocumentLink||(e.DocumentLink={}));var Je;(function(ge){function Ee(K){const Se=new b.ColorPresentation(K.label);return K.textEdit&&(Se.textEdit=N.to(K.textEdit)),K.additionalTextEdits&&(Se.additionalTextEdits=K.additionalTextEdits.map(Le=>N.to(Le))),Se}ge.to=Ee;function te(K){return{label:K.label,textEdit:K.textEdit?N.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Se=>N.from(Se)):void 0}}ge.from=te})(Je=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(ge){function Ee(K){return new b.Color(K[0],K[1],K[2],K[3])}ge.to=Ee;function te(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=te})(st=e.Color||(e.Color={}));var Te;(function(ge){function Ee(K){return{range:o.from(K.range)}}ge.from=Ee;function te(K){return new b.SelectionRange(o.to(K.range))}ge.to=te})(Te=e.SelectionRange||(e.SelectionRange={}));var nt;(function(ge){function Ee(te){switch(te){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=Ee})(nt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ge){function Ee(K){switch(K){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=Ee;function te(K){switch(K){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=te})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(ge){function Ee(K){if(K===b.EndOfLine.CRLF)return 1;if(K===b.EndOfLine.LF)return 0}ge.from=Ee;function te(K){if(K===1)return b.EndOfLine.CRLF;if(K===0)return b.EndOfLine.LF}ge.to=te})(ne=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ge){function Ee(te){if(typeof te=="object")return te.viewId;switch(te){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=Ee})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Qe;(function(ge){function Ee(te){const K={start:te.start+1,end:te.end+1};return te.kind&&(K.kind=tt.from(te.kind)),K}ge.from=Ee})(Qe=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ge){function Ee(te){if(te)switch(te){case b.FoldingRangeKind.Comment:return k.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return k.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return k.FoldingRangeKind.Region}}ge.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ct;(function(ge){function Ee(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?o.from(te.selection):void 0,override:typeof te.override=="boolean"?l.EditorResolution.DISABLED:void 0}}ge.from=Ee})(ct=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(ge){function Ee(K){return K instanceof b.RelativePattern||typeof K=="string"?K:te(K)?new b.RelativePattern(K.base,K.pattern):K}ge.from=Ee;function te(K){const Se=K;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(ce=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function Ee(te){if(te){if(Array.isArray(te))return te.map(Ee);if(typeof te=="string")return te;{const K=te;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:ce.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=Ee})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function Ee(K){return{start:K.start,end:K.end}}ge.from=Ee;function te(K){return new b.NotebookRange(K.start,K.end)}ge.to=te})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function Ee(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=Ee;function te(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=te})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var rt;(function(ge){function Ee(K){switch(K){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=Ee;function te(K){switch(K){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=te})(rt=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(ge){function Ee(K){const Se={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)b.NotebookCellData.validate(Le),Se.cells.push(Ye.from(Le));return Se}ge.from=Ee;function te(K){const Se=new b.NotebookData(K.cells.map(Ye.to));return(0,S.isEmptyObject)(K.metadata)||(Se.metadata=K.metadata),Se}ge.to=te})(ht=e.NotebookData||(e.NotebookData={}));var Ye;(function(ge){function Ee(K){return{cellKind:rt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=Ee;function te(K){return new b.NotebookCellData(rt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=te})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(ge){function Ee(K){return{mime:K.mime,valueBytes:F.VSBuffer.wrap(K.data)}}ge.from=Ee;function te(K){return new b.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=te})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function Ee(K){return{outputId:K.id,items:K.items.map(vt.from),metadata:K.metadata}}ge.from=Ee;function te(K){const Se=K.items.map(vt.to);return new b.NotebookCellOutput(Se,K.outputId,K.metadata)}ge.to=te})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(ge){function Ee(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new b.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:ce.from(Le.include)||void 0,exclude:ce.from(Le.exclude)||void 0}}}ge.from=Ee;function te(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=te;function K(Le){const it=Le,Ge=ce.from(it.include);if(!(Ge&&Ge instanceof b.RelativePattern||typeof Ge=="string"))return!1;const pt=ce.from(it.exclude);return!!(pt&&pt instanceof b.RelativePattern||typeof pt=="string")}function Se(Le){const it=Le;return it&&typeof it.base=="string"&&typeof it.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(ge){function Ee(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?M.from(te.top):void 0}}ge.from=Ee})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function Ee(te,K,Se){const Le=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Se),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}ge.from=Ee})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function Ee(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}ge.from=Ee})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(ge){function Ee(K){return{uri:K.uri,provides:K.provides}}ge.from=Ee;function te(K){return new b.NotebookRendererScript(P.URI.revive(K.uri),K.provides)}ge.to=te})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(ge){function Ee(K){return{message:g.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=Ee;function te(K){const Se=new b.TestMessage(typeof K.message=="string"?K.message:g.to(K.message));return Se.actualOutput=K.actual,Se.expectedOutput=K.expected,Se.location=K.location?Q.to(K.location):void 0,Se}ge.to=te})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let Ee;(function(te){te.Delimiter="\0"})(Ee||(Ee={})),ge.namespace=(te,K)=>te+"\0"+K,ge.denamespace=te=>{const K=te.indexOf("\0");return{ctrlId:te.slice(0,K),tagId:te.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function Ee(Le){const it=(0,d.getPrivateApiFor)(Le).controllerId;return{extId:D.TestId.fromExtHostTestItem(Le,it).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(it,Ge.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&g.fromStrict(Le.error)||null}}ge.from=Ee;function te(Le){return{id:D.TestId.fromString(Le.extId).localId,label:Le.label,uri:P.URI.revive(Le.uri),tags:(Le.tags||[]).map(it=>{const{tagId:Ge}=Fe.denamespace(it);return new b.TestTag(Ge)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=te;function K(Le){const it=D.TestId.fromString(Le.extId),Ge=new d.TestItemImpl(it.controllerId,it.localId,Le.label,P.URI.revive(Le.uri));return Ge.range=o.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Se(Le){let it;for(const Ge of Le.tests){const pt=K(Ge.item);(0,d.getPrivateApiFor)(pt).parent=it,it=pt}return it}ge.toItemFromContext=Se})(qe=e.TestItem||(e.TestItem={})),function(ge){function Ee(K){return{id:K.id}}ge.from=Ee;function te(K){return new b.TestTag(K.id)}ge.to=te}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const Ee=(K,Se)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Ge=>Ge.type===0).map(we.to)})),children:K.children.map(it=>Se.get(it)).filter(S.isDefined).map(it=>Ee(it,Se))};for(const it of Le.children)it.parent=Le;return Le};function te(K){const Se=[],Le=new Map;for(const it of K.items)Le.set(it.item.extId,it),K.request.targets.some(Ge=>Ge.controllerId===it.controllerId&&Ge.testIds.includes(it.item.extId))&&Se.push(it);return{completedAt:K.completedAt,results:Se.map(it=>Ee(it,Le))}}ge.to=te})(ze=e.TestResults||(e.TestResults={}));var et;(function(ge){function Ee(Le){return{covered:Le.covered,total:Le.covered}}function te(Le){return"line"in Le?t.from(Le):o.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:te(Le.location),type:1,branches:Le.branches.length?Le.branches.map(it=>({count:it.executionCount,location:it.location&&te(it.location)})):void 0}:{type:0,count:Le.executionCount,location:te(Le.location)}}ge.fromDetailed=K;function Se(Le){return{uri:Le.uri,statement:Ee(Le.statementCoverage),branch:Le.branchCoverage&&Ee(Le.branchCoverage),function:Le.functionCoverage&&Ee(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Se})(et=e.TestCoverage||(e.TestCoverage={}));var at;(function(ge){function Ee(te){switch(te){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=Ee})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function Ee(K){const Se=new b.TypeHierarchyItem(U.to(K.kind),K.name,K.detail||"",P.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=Ee;function te(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:U.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(x.from)}}ge.from=te})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[219],me([0,1,2,18,7,15,95]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class _{constructor(P,i,k,l={timeout:1500,errors:3}){this._logService=P,this._documents=i,this._mainThreadBulkEdits=k,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(i,k,l)=>{const d={dispose:this._callbacks.push([i,k,P])};return Array.isArray(l)&&l.push(d),d}}async $participateInSave(P,i){const k=m.URI.revive(P);let l=!1;const f=setTimeout(()=>l=!0,this._thresholds.timeout),d=[];try{for(let w of[...this._callbacks]){if(l)break;const D=this._documents.getDocument(k),I=await this._deliverEventAsyncAndBlameBadListeners(w,{document:D,reason:y.TextDocumentSaveReason.to(i)});d.push(I)}}finally{clearTimeout(f)}return d}_deliverEventAsyncAndBlameBadListeners([P,i,k],l){const f=this._badListeners.get(P);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,P,i,l).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const w=this._badListeners.get(P);this._badListeners.set(P,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,i,k,l){const f=[],d=Date.now(),{document:w,reason:D}=l,{version:I}=w,b=Object.freeze({document:w,reason:D,waitUntil(c){if(Object.isFrozen(f))throw(0,F.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{i.apply(k,[b])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,o)=>{const v=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(v),c(t)}).catch(t=>{clearTimeout(v),o(t)})}).then(c=>{const o={edits:[]};for(const v of c)if(Array.isArray(v)&&v.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:h,range:s}of v)o.edits.push({_type:2,resource:w.uri,edit:{range:s&&y.Range.from(s),text:t,eol:h&&y.EndOfLine.from(h)}});if(o.edits.length!==0)return I===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=_}),define(fe[220],me([0,1,3,30,2,15,7]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(i,k,l,f,d){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),f&&(this._config+=2),d&&(this._config+=4);const w=(0,F.parse)(k),D=i(I=>{if(!l)for(let b of I.created){const c=C.URI.revive(b);w(c.fsPath)&&this._onDidCreate.fire(c)}if(!f)for(let b of I.changed){const c=C.URI.revive(b);w(c.fsPath)&&this._onDidChange.fire(c)}if(!d)for(let b of I.deleted){const c=C.URI.revive(b);w(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(i,k,l){this._logService=k,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,k,l,f){return new _(this._onFileSystemEvent.event,i,k,l,f)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,k){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(l=>({oldUri:C.URI.revive(l.source),newUri:C.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(l=>C.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:k.map(l=>C.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,k){return(l,f,d)=>{const w=function(I){l.call(f,I)};return w.extension=i,k.event(w,void 0,d)}}async $onWillRunFileOperation(i,k,l,f){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},l,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(d=>C.URI.revive(d.target))},l,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(d=>C.URI.revive(d.target))},l,f)}}async _fireWillEvent(i,k,l,f){const d=new Set,w=[];if(await i.fireAsync(k,f,async(I,b)=>{const c=Date.now(),o=await Promise.resolve(I);o instanceof A.WorkspaceEdit&&(w.push(o),d.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-c>l&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||w.length===0)return;const D={edits:[]};for(let I of w){let{edits:b}=y.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(b)}return{edit:D,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=S}),define(fe[221],me([0,1,10,25,2,15,7,128]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(l,f,d,w){this.start=l,this.deletedCount=f,this.deletedItems=d,this.items=w}static asApiEvents(l){return l.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(d=>d.apiCell)}))}}class P{constructor(l,f,d){this.notebook=l,this._extHostDocument=f,this._cellData=d,this.handle=d.handle,this.uri=C.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(l,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return l._mime},set mime(d){l._mime=d},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,f,d){const w=d.map(y.NotebookCellOutputItem.to),D=this._outputs.find(I=>I.id===l);D&&(f||(D.items.length=0),D.items.push(...w))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=P;class i{constructor(l,f,d,w,D,I){this._proxy=l,this._textDocumentsAndEditors=f,this._textDocuments=d,this._emitter=w,this.uri=D,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(f){return f=l._validateIndex(f),l._cells[f].apiCell},getCells(f){return(f?l._getCells(f):l._cells).map(w=>w.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,f){this._versionId=l.versionId,this._isDirty=f;for(const d of l.rawEvents)d.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===_.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===_.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===_.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===_.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===_.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let f=l.start|0,d=l.end|0;return f<0&&(f=0),d>this._cells.length&&(d=this._cells.length),l.with({start:f,end:d})}_getCells(l){l=this._validateRange(l);const f=[];for(let d=l.start;d<l.end;d++)f.push(this._cells[d]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,f){if(this._disposed)return;const d=[],w=[],D=[];l.reverse().forEach(I=>{const c=I[2].map(t=>{const h=new P(this,this._textDocumentsAndEditors,t);return f||w.push(P.asModelAddData(this.apiNotebook,t)),h}),o=new S(I[0],I[1],[],c),v=this._cells.splice(I[0],I[1],...c);for(const t of v)D.push(t.uri),o.deletedItems.push(t.apiCell);d.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:D}),f||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(d)}))}_moveCell(l,f){const d=this._cells.splice(l,1);this._cells.splice(f,0,...d);const w=[new S(l,1,d.map(D=>D.apiCell),[]),new S(f,0,[],d)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(w)}))}_setCellOutputs(l,f){const d=this._cells[l];d.setOutputs(f),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(l,f,d,w){const D=this._cells[l];D.setOutputItems(f,d,w),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(l,f){const d=this._cells[l];d.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(d.uri,f)}_changeCellMime(l,f){const d=this._cells[l];d.apiCell.mime=f}_changeCellMetadata(l,f){const d=this._cells[l],w=d.apiCell.metadata;d.setMetadata(f);const D=d.apiCell.metadata;(0,F.equals)(w,D)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(l,f){const d=this._cells[l],w=d.internalMetadata;if(d.setInternalMetadata(f),w.runState!==f.runState){const D=f.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,state:D}))}}getCellFromApiCell(l){return this._cells.find(f=>f.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(f=>f.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[131],me([0,1,7,15,18]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,i){this._throwIfFinalized(),!(S===P&&i.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:i.map(F.NotebookCellData.from)})}}class A{constructor(S,P,i,k,l,f){this.id=S,this._proxy=P,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=k,this._viewColumn=f}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(m.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,i){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(P),i??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const i=new y(this.document.version);return P(i),S._applyEdit(i.finalize())},setDecorations(P,i){return S.setDecorations(P,i)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let i=-1;for(let k=0;k<S.cellEdits.length;k++){if(i<0){P.push(S.cellEdits[k]),i++;continue}const f=P[i],d=S.cellEdits[k];if(f.editType===1&&d.editType===1&&f.index===d.index){f.cells.push(...S.cellEdits[k].cells),f.count+=S.cellEdits[k].count;continue}P.push(S.cellEdits[k]),i++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}setDecorations(S,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return P.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(P),S.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[222],me([0,1,15,119,167,21,60]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,l,f){const d=this._handles++,{title:w,location:D,cancellable:I}=l,b={label:(0,C.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(d,{location:m.ProgressLocation.from(D),title:w,source:b,cancellable:I},k),this._withProgress(d,f,!!I)}_withProgress(k,l,f){let d;f&&(d=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,d));const w=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),d&&d.dispose()};let D;try{D=l(new P(this._proxy,k),f&&d?d.token:y.CancellationToken.None)}catch(I){throw w(k),I}return D.then(I=>w(k),I=>w(k)),D}$acceptProgressCanceled(k){const l=this._mapHandleToCancellationSource.get(k);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=_;function S(i,k){return i.message=k.message,typeof k.increment=="number"&&(typeof i.increment=="number"?i.increment+=k.increment:i.increment=k.increment),i}class P extends F.Progress{constructor(k,l){super(f=>this.throttledReport(f));this._proxy=k,this._handle=l}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}Ve([(0,A.throttle)(100,(i,k)=>S(i,k),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(fe[132],me([0,1,58,18,77,15,7]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class _{constructor(l,f,d){const w=_._Keys.nextId();l.$registerTextEditorDecorationType(f.identifier,w,y.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:w,dispose(){l.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=_,_._Keys=new C.IdGenerator("TextEditorDecorationType");class S{constructor(l,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,f){this._throwIfFinalized();let d=null;if(l instanceof A.Position)d=new A.Range(l,l);else if(l instanceof A.Range)d=l;else throw new Error("Unrecognized location");this._pushEdit(d,f,!1)}insert(l,f){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),f,!0)}delete(l){this._throwIfFinalized();let f=null;if(l instanceof A.Range)f=l;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(l,f,d){const w=this._document.validateRange(l);this._collectedEdits.push({range:w,text:f,forceMoveMarkers:d})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=S;class P{constructor(l,f,d,w){this._proxy=l,this._id=f,this._accept(d),this._logService=w;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(I){D._setTabSize(I)},get insertSpaces(){return D._insertSpaces},set insertSpaces(I){D._setInsertSpaces(I)},get cursorStyle(){return D._cursorStyle},set cursorStyle(I){D._setCursorStyle(I)},get lineNumbers(){return D._lineNumbers},set lineNumbers(I){D._setLineNumbers(I)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const f=Math.floor(l);return f>0?f:null}if(typeof l=="string"){const f=parseInt(l,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(l){const f=this._validateTabSize(l);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const f=this._validateInsertSpaces(l);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const f={};let d=!1;if(typeof l.tabSize!="undefined"){const w=this._validateTabSize(l.tabSize);w==="auto"?(d=!0,f.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,d=!0,f.tabSize=w)}if(typeof l.insertSpaces!="undefined"){const w=this._validateInsertSpaces(l.insertSpaces);w==="auto"?(d=!0,f.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,d=!0,f.insertSpaces=w)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,d=!0,f.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,d=!0,f.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(l){l.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=P;class i{constructor(l,f,d,w,D,I,b,c){this.id=l,this._proxy=f,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new P(this._proxy,this.id,I,d),this._visibleRanges=b,this._viewColumn=c;const o=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,F.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,F.illegalArgument)("selection");o._selections=[v],o._trySetSelection()},get selections(){return o._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");o._selections=v,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(v){throw(0,F.readonly)("visibleRanges")},get options(){return o._options.value},set options(v){o._disposed||o._options.assign(v)},get viewColumn(){return o._viewColumn},set viewColumn(v){throw(0,F.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new S(w.getValue(),t);return v(h),o._applyEdit(h)},insertSnippet(v,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=o._selections.map(n=>y.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:r}=y.Position.from(t);s=[{startLineNumber:n,startColumn:r,endLineNumber:n,endColumn:r}]}else if(t instanceof A.Range)s=[y.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.Range)s.push(y.Range.from(n));else{const{lineNumber:r,column:a}=y.Position.from(n);s.push({startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a})}}return f.$tryInsertSnippet(l,v.value,s,h)},setDecorations(v,t){const h=t.length===0;h&&!o._hasDecorationsForKey.has(v.key)||(h?o._hasDecorationsForKey.delete(v.key):o._hasDecorationsForKey.add(v.key),o._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return f.$trySetDecorations(l,v.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,r=t.length;n<r;n++){const a=t[n];s[4*n]=a.start.line+1,s[4*n+1]=a.start.character+1,s[4*n+2]=a.end.line+1,s[4*n+3]=a.end.character+1}return f.$trySetDecorationsFast(l,v.key,s)}}))},revealRange(v,t){o._runOnProxy(()=>f.$tryRevealRange(l,y.Range.from(v),t||A.TextEditorRevealType.Default))},show(v){f.$tryShowEditor(l,y.ViewColumn.from(v))},hide(){f.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const f=l.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const d=f.edits.map(D=>D.range);d.sort((D,I)=>D.end.line===I.end.line?D.end.character===I.end.character?D.start.line===I.start.line?D.start.character-I.start.character:D.start.line-I.start.line:D.end.character-I.end.character:D.end.line-I.end.line);for(let D=0,I=d.length-1;D<I;D++){const b=d[D].end;if(d[D+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=f.edits.map(D=>({range:y.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,w,{setEndOfLine:typeof f.setEndOfLine=="number"?y.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=i}),define(fe[223],me([0,1,170,23,2,3,6,210,17,7,12,16,15,21,207]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,c){if((0,i.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let o;return Array.isArray(b.highlights)&&(o=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),o=o.length?o:void 0),{label:b.label,highlights:o}}}class D{constructor(c,o,v){this._proxy=c,this.commands=o,this.logService=v,this.treeViews=new Map;function t(h){return h&&h.$treeViewId&&h.$treeItemHandle}o.registerArgumentProcessor({processArgument:h=>t(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(s=>t(s)?this.convertArgument(s):s):h})}registerTreeDataProvider(c,o,v){const t=this.createTreeView(c,{treeDataProvider:o},v);return{dispose:()=>t.dispose()}}createTreeView(c,o,v){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=o.dragAndDropController!==void 0,h=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(c,o,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(n){s.message=n},get title(){return s.title},set title(n){s.title=n},get description(){return s.description},set description(n){s.description=n},reveal:(n,r)=>s.reveal(n,r),dispose:async()=>{await h,this.treeViews.delete(c),s.dispose()}}}$getChildren(c,o){const v=this.treeViews.get(c);return v?v.getChildren(o):Promise.reject(new Error((0,m.localize)(0,null,c)))}async $onDrop(c,o,v){const t=this.treeViews.get(c);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,c)));const h=d.TreeDataTransferConverter.toITreeDataTransfer(o);if(h.items.has(_.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await h.items.get(_.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(r=>t.getExtensionElement(r)).filter(r=>!!r);n.length>0?h.items.set(_.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):h.items.delete(_.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(h,v)}async $hasResolve(c){const o=this.treeViews.get(c);if(!o)throw new Error((0,m.localize)(2,null,c));return o.hasResolve}$resolve(c,o,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,m.localize)(3,null,c));return t.resolveTreeItem(o,v)}$setExpanded(c,o,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,m.localize)(4,null,c));t.setExpanded(o,v)}$setSelection(c,o){const v=this.treeViews.get(c);if(!v)throw new Error((0,m.localize)(5,null,c));v.setSelection(o)}$setVisible(c,o){const v=this.treeViews.get(c);if(!v)throw new Error((0,m.localize)(6,null,c));v.setVisible(o)}createExtHostTreeView(c,o,v){const t=new I(c,o,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(c,t),t}convertArgument(c){const o=this.treeViews.get(c.$treeViewId);return o?o.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=D;class I extends A.Disposable{constructor(c,o,v,t,h,s){super();if(this.viewId=c,this.proxy=v,this.commands=t,this.logService=h,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,s.contributes&&s.contributes.views)for(const a in s.contributes.views)for(const u of s.contributes.views[a])u.id===c&&(this._title=u.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(a=>this._onDidChangeData.fire({message:!1,element:a}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let n,r;this._register(y.Event.debounce(this._onDidChangeData.event,(a,u)=>(a||(a={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(p=>r=p),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(u.element)?a.elements.push(...u.element):a.elements.push(u.element)),u.message&&(a.message=!0),a),200,!0)(({message:a,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=r;return n=null,this.refresh(u).then(()=>p())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,i.isUndefinedOrNull)(c))}async getChildren(c){const o=c?this.getExtensionElement(c):void 0;if(c&&!o)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(c);return v||(v=await this.fetchChildrenNodes(o)),v?v.map(t=>t.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,o){o=o||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(o.select)?!0:o.select,t=(0,i.isUndefinedOrNull)(o.focus)?!1:o.focus,h=(0,i.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(s=>this.resolveTreeNode(c,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(r=>r.item)},{select:v,focus:t,expand:h})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:h})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,o){const v=this.getExtensionElement(c);v&&(o?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(c){(0,k.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,o){const v=this.getExtensionElement(o);if(!!v)return(0,S.asPromise)(()=>this.dndController?.onDrop(c,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,o){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(c);if(v){const t=this.nodes.get(v);if(t){const h=await this.dataProvider.resolveTreeItem(t.extensionItem,v,o)??t.extensionItem;return t.item.tooltip=this.getTooltip(h.tooltip),t.item.command=this.getCommand(t.disposableStore,h.command),t.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(o=>o?this.resolveUnknownParentChain(o).then(v=>this.resolveTreeNode(o,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(c){const o=this.nodes.get(c);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,o){const v=this.nodes.get(c);return v?Promise.resolve(v):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(t=>this.createHandle(c,t,o,!0)).then(t=>this.getChildren(o?o.item.handle:void 0).then(()=>{const h=this.getExtensionElement(t);if(h){const s=this.nodes.get(h);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(c){if(c){let o;if(typeof c=="string"){const v=this.getExtensionElement(c);o=v?this.nodes.get(v):void 0}else o=c;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const o=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=c?this.nodes.get(c):void 0,t=await this.dataProvider.getChildren(c);if(o.token.isCancellationRequested)return;const h=await Promise.all((0,k.coalesce)(t||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,v):null}));return o.token.isCancellationRequested?void 0:(0,k.coalesce)(h)}finally{o.dispose()}}refresh(c){if(c.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(c);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const o=new Set,v=c.map(h=>this.nodes.get(h));for(const h of v)if(h&&!o.has(h.item.handle)){let s=h;for(;s&&s.parent&&v.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&o.add(h.item.handle)}const t=[];return o.forEach(h=>{const s=this.elements.get(h);if(s){const n=this.nodes.get(s);n&&(!n.parent||!o.has(n.parent.item.handle))&&t.push(h)}}),t}refreshHandles(c){const o={};return Promise.all(c.map(v=>this.refreshNode(v).then(t=>{t&&(o[v]=t.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(c){const o=this.getExtensionElement(c);if(o){const v=this.nodes.get(o);if(v)return this.clearChildren(o),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>{if(t){const h=this.createTreeNode(o,t,v.parent);return this.updateNodeCache(o,h,v,v.parent),v.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,o,v){const t=this.createTreeNode(c,o,v);if(o.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,o.id));return this.addNodeToCache(c,t),this.addNodeToParentCache(t,v),t}getTooltip(c){return P.MarkdownString.isMarkdownString(c)?l.MarkdownString.from(c):c}getCommand(c,o){return o?this.commands.toInternal(o,c):void 0}createTreeNode(c,o,v){const t=new A.DisposableStore,h=this.createHandle(c,o,v),s=this.getLightIconPath(o);return{item:{handle:h,parentHandle:v?v.item.handle:void 0,label:w(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(t,o.command),contextValue:o.contextValue,icon:s,iconDark:this.getDarkIconPath(o)||s,themeIcon:this.getThemeIcon(o),collapsibleState:(0,i.isUndefinedOrNull)(o.collapsibleState)?P.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(c){return c.iconPath instanceof P.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:o,label:v,resourceUri:t},h,s){if(o)return`${I.ID_HANDLE_PREFIX}/${o}`;const n=w(v,this.extension),r=h?h.item.handle:I.LABEL_HANDLE_PREFIX;let a=n?n.label:t?(0,F.basename)(t):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const u=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,p=this.getChildrenNodes(h)||[];let E,g=0;do{if(E=`${r}/${g}:${a}`,s||!this.elements.has(E)||u===E)break;g++}while(g<=p.length);return E}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon))return typeof c.iconPath=="string"||C.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return C.URI.isUri(c)?c:C.URI.file(c)}addNodeToCache(c,o){this.elements.set(o.item.handle,c),this.nodes.set(c,o)}updateNodeCache(c,o,v,t){this.elements.delete(o.item.handle),this.nodes.delete(c),o.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(c,o);const h=this.getChildrenNodes(t)||[],s=h.filter(n=>n.item.handle===v.item.handle)[0];s&&h.splice(h.indexOf(s),1,o)}addNodeToParentCache(c,o){o?(o.children||(o.children=[]),o.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const o=this.nodes.get(c);if(o){if(o.children)for(const v of o.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}o.children=void 0}}else this.clearAll()}clear(c){const o=this.nodes.get(c);if(o){if(o.children)for(const v of o.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(c),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(fe[224],me([0,1,17,3,6,12,66,15,129,89]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends C.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const f=this.diff[this.diff.length-1];if(f&&l[0]===1){if(f[0]===1&&f[1].extId===l[1].extId){(0,S.applyTestItemUpdate)(f[1],l[1]);return}if(f[0]===0&&f[1].item.extId===l[1].extId){(0,S.applyTestItemUpdate)(f[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,f){const d=this.tree.get(l);if(!!d){if((d.expandLevels===void 0||f>d.expandLevels)&&(d.expandLevels=f),d.expand===1){const w=this.resolveChildren(d);return w.isOpen()?this.expandChildren(d,f-1):w.wait().then(()=>this.expandChildren(d,f-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,f-1)):this.expandChildren(d,f-1)}}dispose(){for(const l of this.tree.values())(0,A.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,f){switch(f.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(l.fullId,f.id));break;case 0:this.upsertItem(f.item,l);break;case 4:for(const b of f.ops)this.onTestItemEvent(l,b);break;case 3:const{key:d,value:w,previous:D}=f,I=l.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(w,D,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:_.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:_.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[d]:w??null}}]);break}break;default:(0,y.assertNever)(f)}}upsertItem(l,f){if(!(l instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const d=P.TestId.fromExtHostTestItem(l,this.root.id,f?.actual),w=(0,A.getPrivateApiFor)(l);w.parent&&w.parent!==f?.actual&&w.parent.children.delete(l.id);let D=this.tree.get(d.toString());if(!D){D={fullId:d,actual:l,parent:f?d.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(l,f),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:_.TestItem.from(l)}]),this.connectItemAndChildren(l,D,f);return}if(D.actual===l){this.connectItem(l,D,f);return}const I=D.actual.children,b=D.actual,c=(0,A.diffTestItems)(b,l);(0,A.getPrivateApiFor)(b).listener=void 0,D.actual=l,D.expand=0;for(const[o,v]of c)this.onTestItemEvent(D,{op:3,key:o,value:v,previous:b[o]});this.connectItemAndChildren(l,D,f);for(const o of I)l.children.get(o.id)||this.removeItem(P.TestId.joinToString(d,o.id))}diffTagRefs(l,f,d){const w=new Set(f.map(D=>D.id));for(const D of l)w.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:d,item:{tags:l.map(D=>_.TestTag.namespace(this.controllerId,D.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const f=this.tags.get(l.id);f?f.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:_.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const f=this.tags.get(l);f&&!--f.refCount&&(this.tags.delete(l),this.pushDiff([6,_.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,f){(0,A.getPrivateApiFor)(l).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(l,f,d){this.setItemParent(l,d);const w=(0,A.getPrivateApiFor)(l);w.parent=d?.actual,w.listener=D=>this.onTestItemEvent(f,D),this.updateExpandability(f)}connectItemAndChildren(l,f,d){this.connectItem(l,f,d);for(const w of l.children)this.upsertItem(w,f)}updateExpandability(l){let f;this._resolveHandler?l.resolveBarrier?f=l.resolveBarrier.isOpen()?3:2:f=l.actual.canResolveChildren?1:0:f=0,f!==l.expand&&(l.expand=f,this.pushDiff([1,{extId:l.fullId.toString(),expand:f}]),f===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,f){if(f<0)return;const d=[];for(const w of l.actual.children){const D=this.expand(P.TestId.joinToString(l.fullId,w.id),f);(0,m.isThenable)(D)&&d.push(D)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const D=new m.Barrier;return D.open(),D}l.expand=2,this.pushExpandStateUpdate(l);const f=l.resolveBarrier=new m.Barrier,d=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=D.stack||D.message||String(D))};let w;try{w=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(D){d(D)}return(0,m.isThenable)(w)?w.catch(d).then(()=>{f.open(),this.updateExpandability(l)}):(f.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const f=this.tree.get(l);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const d=[f];for(;d.length;){const w=d.pop();if(!!w){(0,A.getPrivateApiFor)(w.actual).listener=void 0;for(const D of w.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(w.fullId.toString());for(const D of w.actual.children)d.push(this.tree.get(P.TestId.joinToString(w.fullId,D.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=i}),define(fe[225],me([0,1,4,186]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(F.IEnvironmentService)}),define(fe[226],me([0,1,26,3,8]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=y;class A{constructor(i){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let k of i.activationEvents)k==="onUri"&&(k=`onUri:${m.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(i)}}keepOnly(i){const k=new Set;i.forEach(l=>k.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>k.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,k){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const l=A._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(l.map(f=>f.identifier)),k.length>0){const f=new Set;k.forEach(d=>f.add(m.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!f.has(m.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(i){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,I){this.addNode(D),this.addNode(I),this._arcs.has(D)?this._arcs.get(D).push(I):this._arcs.set(D,[I])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,I){const b=k.getArcs(D);for(let c=0;c<b.length;c++)if(!I.has(b[c]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let D of i){const I=m.ExtensionIdentifier.toKey(D.identifier);if(l.set(I,D),D.extensionDependencies)for(let b of D.extensionDependencies){const c=m.ExtensionIdentifier.toKey(b);k.addArc(I,c)}}let f=new Set;k.getNodes().filter(D=>k.getArcs(D).length===0).forEach(D=>f.add(D));let d=k.getNodes().filter(D=>!f.has(D)),w;do{w=!1;for(let D=0;D<d.length;D++){const I=d[D];k.hasOnlyGoodArcs(I,f)&&(d.splice(D,1),D--,f.add(I),w=!0)}}while(w);return d.map(D=>l.get(D))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const k=this._activationMap.get(i);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const k=this._extensionsMap.get(m.ExtensionIdentifier.toKey(i));return k||void 0}}e.ExtensionDescriptionRegistry=A;var _;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(_||(_={}));function S(P,i){const k=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(k!==l)return k-l;const f=C.posix.basename(P.extensionLocation.path),d=C.posix.basename(i.extensionLocation.path);return f<d?-1:f>d?1:0}}),define(fe[227],me([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function y(_){const S=m.VSBuffer.alloc(1);switch(_){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=y;function A(_,S){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=A}),define(fe[35],me([0,1,3,2,4,26,195]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");var _;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(_=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class P{constructor(v){this.dependency=v}}e.MissingExtensionDependency=P;var i;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=k;class l{constructor(v,t,h,s){this.codeLoadingTime=v,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.ActivationTimes=l;class f{constructor(v,t){this.description=v,this.value=t}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var d;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function w(o){o.enableProposedApi||D(o)}e.checkProposedApiEnabled=w;function D(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=D;function I(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=I;function b(o,v){return{identifier:new y.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!v,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class c{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,t){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,t,h,s,n){}_onDidActivateExtensionError(v,t){}_onExtensionRuntimeError(v,t){}_onExtensionHostExit(v){}}e.NullExtensionService=c}),define(fe[228],me([0,1,26,35,13]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(d,w,D,I){this.startup=d,this.codeLoadingTime=w,this.activateCallTime=D,this.activateResolvedTime=I}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class _{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,w){return d===-1||w===-1?-1:w-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class S{constructor(d,w,D,I,b,c){this.activationFailed=d,this.activationFailedError=w,this.activationTimes=D,this.module=I,this.exports=b,this.subscriptions=c}}e.ActivatedExtension=S;class P extends S{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class i extends S{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class k extends S{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let l=class{constructor(d,w,D,I,b){this._logService=b,this._registry=d,this._resolvedExtensionsSet=new Set,w.forEach(c=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,D.forEach(c=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(c),c)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const w=m.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(w)}getActivatedExtension(d){const w=m.ExtensionIdentifier.toKey(d),D=this._activatedExtensions.get(w);if(!D)throw new Error("Extension `"+d.value+"` is not known or not activated");return D}activateByEvent(d,w){if(this._alreadyActivatedEvents[d])return y;const D=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(D.map(I=>({id:I.identifier,reason:{startup:w,extensionId:I.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,w){const D=this._registry.getExtensionDescription(d);if(!D)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:D.identifier,reason:w}])}_handleActivateRequest(d,w,D){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(d.id))){w[m.ExtensionIdentifier.toKey(d.id)]=d;return}const I=this._registry.getExtensionDescription(d.id);if(!I){const o=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,o,new F.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(d.id),new k(o));return}const b=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let c=!0;for(let o=0,v=b.length;o<v;o++){const t=b[o];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const h=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(h&&!h.activationFailed)continue;if(h&&h.activationFailed){const a=I.displayName||I.identifier.value,u=this._registry.getExtensionDescription(t),p=u&&u.displayName||t,E=new Error(`Cannot activate the '${a}' extension because its dependency '${p}' failed to activate`);E.detail=h.activationFailedError,this._host.onExtensionActivationError(I.identifier,E,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(I.identifier),new k(E));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){c=!1,w[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){if(!s.main&&!s.browser)continue;c=!1,w[m.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:d.reason};continue}const n=I.displayName||I.identifier.value,r=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(I.identifier,r,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(I.identifier),new k(r));return}c?w[m.ExtensionIdentifier.toKey(I.identifier)]=d:D.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(b=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(b.id))),d.length===0))return Promise.resolve(void 0);const w=Object.create(null),D=[];for(let b=0,c=d.length;b<c;b++)this._handleActivateRequest(d[b],w,D);for(let b=0,c=D.length;b<c;b++){const o=m.ExtensionIdentifier.toKey(D[b].id);w[o]&&delete w[o]}const I=Object.keys(w).map(b=>w[b]);return D.length===0?Promise.all(I.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(I).then(b=>this._activateExtensions(D))}_activateExtension(d,w){const D=m.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const I=this._activatingExtensions.get(D);if(I)return I;const b=this._host.actualActivateExtension(d,w).then(void 0,c=>{const o=new Error;return c&&c.name&&(o.name=c.name),c&&c.message?o.message=`Activating extension '${d.value}' failed: ${c.message}.`:o.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(o.stack=c.stack),this._host.onExtensionActivationError(d,o,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new k(c)}).then(c=>{this._activatedExtensions.set(D,c),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,b),b}};l=Ve([$e(4,C.ILogService)],l),e.ExtensionsActivator=l}),define(fe[229],me([0,1,13,35,27,10,117]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends m.LogService{constructor(P){if(P.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(F.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};_=Ve([$e(0,C.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(fe[230],me([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,m.onUnexpectedError)(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=F}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(P,i){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=i,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const F=[];function C(S){const P=new m(!0,S);return F[P.nid]=P,P}e.createMainContextProxyIdentifier=C;function y(S){const P=new m(!1,S);return F[P.nid]=P,P}e.createExtHostContextProxyIdentifier=y;function A(S){return F[S].sid}e.getStringIdentifierForProxy=A;class _{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=_}),define(fe[5],me([0,1,62,2,55]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(c){c.name="$ident";function o(t,h){return Object.defineProperty(t,c.name,{value:h,enumerable:!0}),t}c.mixin=o;function v(t){return t[c.name]}c.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(o){return o._id=f._n++,o}}e.IdObject=f,f._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(c){if(c&&c.edits)for(const o of c.edits)typeof o.resource=="object"?o.resource=F.URI.revive(o.resource):(o.newUri=F.URI.revive(o.newUri),o.oldUri=F.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,m.revive)(o.metadata));return c}e.reviveWorkspaceEditDto=I;var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[90],me([0,1,5,3,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(_){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=_.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(_){this._onDidChangePassword.fire(_)}get(_,S){return this._proxy.$getPassword(_,S)}store(_,S,P){return this._proxy.$setPassword(_,S,P)}delete(_,S){return this._proxy.$deletePassword(_,S)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,13,5,14]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(C.MainContext.MainThreadTelemetry)}report(S,P,i){const k=this.getUsageKey(S,P);this._reportedUsages.has(k)||(this._reportedUsages.add(k),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};A=Ve([$e(0,y.IExtHostRpcService),$e(1,F.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(_,S,P){}})}),define(fe[231],me([0,1,3,5,7,26]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,i,k={}){const l=y.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(l)||[],d=[...i].sort().join(" ");let w=f.find(D=>D.scopes===d);if(w)return w.result;{const D=this._getSession(S,l,P,i,k);w={scopes:d,result:D},f.push(w),this._inFlightRequests.set(l,f);try{await D}finally{const I=f.findIndex(b=>b.scopes===d);I>-1&&(f.splice(I),this._inFlightRequests.set(l,f))}return D}}async _getSession(S,P,i,k,l={}){await this._proxy.$ensureProvider(i);const f=S.displayName||S.name;return this._proxy.$getSession(i,k,P,f,l)}async removeSession(S,P){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,i,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:i,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===S)||this._providers.push({id:S,label:P});const l=i.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(S,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(S);const f=this._providers.findIndex(d=>d.id===S);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[232],me([0,1,5,14,15]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(_,S){this._extHostDocumentsAndEditors=S,this._proxy=_.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(_){const S=C.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=Ve([$e(0,F.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(fe[233],me([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(y){const A=y.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(_){return A.$writeText(_)}})}}e.ExtHostClipboard=F}),define(fe[40],me([0,1,12,7,15,25,5,16,13,62,42,51,2,6,4,14,66,22,55,52]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(r,a){this._commands=new Map,this._apiCommands=new Map,this._proxy=r.getProxy(A.MainContext.MainThreadCommands),this._logService=a,this.converter=new v(this,u=>{const p=this._apiCommands.get(u);return p?.result===h.Void?p:void 0},a),this._argumentProcessors=[{processArgument(u){return(0,P.revive)(u)}},{processArgument(u){return(0,y.cloneAndChange)(u,function(p){if(i.Range.isIRange(p))return C.Range.to(p);if(k.Position.isIPosition(p))return C.Position.to(p);if(i.Range.isIRange(p.range)&&l.URI.isUri(p.uri))return C.location.to(p);if(p instanceof I.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const a=this.registerCommand(!1,r.id,async(...u)=>{const p=r.args.map((g,T)=>{if(!g.validate(u[T]))throw new Error(`Invalid argument '${g.name}' when running '${r.id}', received: ${u[T]}`);return g.convert(u[T])}),E=await this.executeCommand(r.internalId,...p);return r.result.convert(E,u,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new F.Disposable(()=>{a.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,a,u,p,E,g){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:u,thisArg:p,description:E,extension:g}),r&&this._proxy.$registerCommand(a),new F.Disposable(()=>{this._commands.delete(a)&&r&&this._proxy.$unregisterCommand(a)})}executeCommand(r,...a){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,a,!0)}async _doExecuteCommand(r,a,u){if(this._commands.has(r))return this._executeContributedCommand(r,a,!1);{let p=!1;const E=(0,y.cloneAndChange)(a,function(g){if(g instanceof F.Position)return C.Position.from(g);if(g instanceof F.Range)return C.Range.from(g);if(g instanceof F.Location)return C.location.from(g);if(F.NotebookRange.isNotebookRange(g))return C.NotebookRange.from(g);if(g instanceof ArrayBuffer)return p=!0,I.VSBuffer.wrap(new Uint8Array(g));if(g instanceof Uint8Array)return p=!0,I.VSBuffer.wrap(g);if(!Array.isArray(g))return g});try{const g=await this._proxy.$executeCommand(r,p?new b.SerializableObjectWithBuffers(E):E,u);return(0,P.revive)(g)}catch(g){if(g instanceof Error&&g.message==="$executeCommand:retry")return this._doExecuteCommand(r,a,!1);throw g}}}async _executeContributedCommand(r,a,u){const p=this._commands.get(r);if(!p)throw new Error("Unknown command");let{callback:E,thisArg:g,description:T}=p;if(T)for(let L=0;L<T.args.length;L++)try{(0,m.validateConstraint)(a[L],T.args[L].constraint)}catch(M){throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${T.args[L].name}' - ${T.args[L].description}`)}try{return await E.apply(g,a)}catch(L){if(r===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...a);M&&(r=M.command)}throw this._logService.error(L,r,p.extension?.identifier),u?new class extends Error{constructor(){super((0,c.toErrorMessage)(L));this.id=r,this.source=p.extension?.displayName??p.extension?.name}}:L}}$executeContributedCommand(r,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(a=a.map(u=>this._argumentProcessors.reduce((p,E)=>E.processArgument(p),u)),this._executeContributedCommand(r,a,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),this._proxy.$getCommands().then(a=>(r&&(a=a.filter(u=>u[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(let[a,u]of this._commands){let{description:p}=u;p&&(r[a]=p)}return Promise.resolve(r)}};o=Ve([$e(0,w.IExtHostRpcService),$e(1,S.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class v{constructor(r,a,u){this._commands=r,this._lookupApiCommand=a,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,a){if(!r)return;const u={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return u;const p=this._lookupApiCommand(r.command);if(p)u.id=p.internalId,u.arguments=p.args.map((E,g)=>E.convert(r.arguments&&r.arguments[g]));else if((0,_.isNonEmptyArray)(r.arguments)){const E=++this._cachIdPool;this._cache.set(E,r),a.add((0,f.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),u.$ident=E,u.id=this.delegatingCommandId,u.arguments=[E],this._logService.trace("CommandsConverter#CREATE",r.command,E)}return u}fromInternal(r){const a=A.ObjectIdentifier.of(r);return typeof a=="number"?this._cache.get(a):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const a=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class t{constructor(r,a,u,p){this.name=r,this.description=a,this.validate=u,this.convert=p}optional(){return new t(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,a){return new t(r??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",n=>l.URI.isUri(n),n=>n),t.Position=new t("position","A position in a text document",n=>F.Position.isPosition(n),C.Position.from),t.Range=new t("range","A range in a text document",n=>F.Range.isRange(n),C.Range.from),t.Selection=new t("selection","A selection in a text document",n=>F.Selection.isSelection(n),C.Selection.from),t.Number=new t("number","",n=>typeof n=="number",n=>n),t.String=new t("string","",n=>typeof n=="string",n=>n),t.CallHierarchyItem=new t("item","A call hierarchy item",n=>n instanceof F.CallHierarchyItem,C.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",n=>n instanceof F.TypeHierarchyItem,C.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",n=>n instanceof D.TestItemImpl,C.TestItem.from);class h{constructor(r,a){this.description=r,this.convert=a}}e.ApiCommandResult=h,h.Void=new h("no result",n=>n);class s{constructor(r,a,u,p,E){this.id=r,this.internalId=a,this.description=u,this.args=p,this.result=E}}e.ApiCommand=s}),define(fe[234],me([0,1,15,7,84,40,16,112]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(m.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,A.isFalsyOrEmpty)(l))return;class d extends F.SymbolInformation{static to(D){const I=new d(D.name,m.SymbolKind.to(D.kind),D.containerName||"",new F.Location(f[0],m.Range.to(D.range)));return I.detail=D.detail,I.range=I.location.range,I.selectionRange=m.Range.to(D.selectionRange),I.children=D.children?D.children.map(d.to):[],I}}return l.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(m.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(m.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(m.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>F.Position.isPosition(f)),l=>l.map(m.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(f=>{let d;for(const w of f.reverse())d=new F.SelectionRange(m.Range.to(w),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const f=[];if(Array.isArray(l))for(let d of l)f.push(...d[1].map(m.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:m.Range.to(l.range),placeholder:l.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,_.decodeSemanticTokensDto)(l);if(f.type==="full")return new F.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,_.decodeSemanticTokensDto)(l);if(f.type==="full")return new F.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,f,d)=>{if(!l)return new F.CompletionList([]);const w=l.suggestions.map(D=>m.CompletionItem.to(D,d));return new F.CompletionList(w,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,f,d)=>i(w=>new F.CodeLens(m.Range.to(w.range),w.command&&d.fromInternal(w.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>F.Range.isRange(l),l=>F.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,f,d)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(w.command)}else{const D=new F.CodeAction(w.title,w.kind?new F.CodeActionKind(w.kind):void 0);return w.edit&&(D.edit=m.WorkspaceEdit.to(w.edit)),w.command&&(D.command=d.fromInternal(w.command)),D.isPreferred=w.isPreferred,D}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new F.ColorInformation(m.Range.to(f.range),m.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof F.Color,m.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>m.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class P{static register(f){S.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=P;function i(l){return f=>{if(Array.isArray(f))return f.map(l)}}function k(l){if(!Array.isArray(l))return;const f=[];for(const d of l)C.isLocationLink(d)?f.push(m.DefinitionLink.to(d)):f.push(m.location.to(d));return f}}),define(fe[235],me([0,1,17,60,3,6,2,84,26,15,7,5]),function(Y,e,m,F,C,y,A,_,S,P,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(f,d,w){const D=f.getProxy(k.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const r=this._commentControllers.get(n.handle);return r||n}else if(n&&n.$mid===7){const r=this._commentControllers.get(n.commentControlHandle);if(!r)return n;const a=r.getCommentThread(n.commentThreadHandle);return a||n}else if(n&&n.$mid===8){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const a=r.getCommentThread(n.thread.commentThreadHandle);return a?{thread:a,text:n.text}:n}else if(n&&n.$mid===9){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const a=r.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let u=n.commentUniqueId,p=a.getCommentByUniqueId(u);return p||n}else if(n&&n.$mid===10){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const a=r.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let u=n.text,p=n.commentUniqueId,E=a.getCommentByUniqueId(p);return E?(E.body=u,E):n}return n}})}createCommentController(n,r,a){const u=I.handlePool++,p=new c(n,u,r,a);this._commentControllers.set(p.handle,p);const E=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return E.push(p),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(n.identifier),E),p.value}$createCommentThreadTemplate(n,r,a){const u=this._commentControllers.get(n);!u||u.$createCommentThreadTemplate(r,a)}async $updateCommentThreadTemplate(n,r,a){const u=this._commentControllers.get(n);!u||u.$updateCommentThreadTemplate(r,a)}$deleteCommentThread(n,r){const a=this._commentControllers.get(n);a&&a.$deleteCommentThread(r)}$provideCommentingRanges(n,r,a){const u=this._commentControllers.get(n);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const p=w.getDocument(A.URI.revive(r));return(0,m.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(p,a)).then(E=>E?E.map(g=>P.Range.from(g)):void 0)}$toggleReaction(n,r,a,u,p){const E=this._commentControllers.get(n);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const g=E.getCommentThread(r);if(g){const T=g.getCommentByUniqueId(u.uniqueIdInThread);if(E!==void 0&&T&&E.reactionHandler)return E.reactionHandler(T,t(p))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class b{constructor(n,r,a,u,p,E,g){this._commentControllerHandle=r,this._id=a,this._uri=u,this._range=p,this._comments=E,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),D.$createCommentThread(r,this.handle,this._id,this._uri,P.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(r,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(L){T.range=L},get comments(){return T.comments},set comments(L){T.comments=L},get collapsibleState(){return T.collapsibleState},set collapsibleState(L){T.collapsibleState=L},get canReply(){return T.canReply},set canReply(L){T.canReply=L},get contextValue(){return T.contextValue},set contextValue(L){T.contextValue=L},get label(){return T.label},set label(L){T.label=L},dispose:()=>{T.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const n=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),r={};n("range")&&(r.range=P.Range.from(this._range)),n("label")&&(r.label=this.label),n("contextValue")&&(r.contextValue=this.contextValue),n("comments")&&(r.comments=this._comments.map(a=>o(this,a,this._commentsMap))),n("collapsibleState")&&(r.collapseState=h(this._collapseState)),n("canReply")&&(r.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(n){for(let r of this._commentsMap){let a=r[0],u=r[1];if(n===u)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}b._handlePool=0,Ve([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(n,r,a,u){this._extension=n,this._handle=r,this._id=a,this._label=u,this._threads=new Map,D.$registerCommentController(this.handle,a,u);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(E){p.options=E},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(E){p.commentingRangeProvider=E},get reactionHandler(){return p.reactionHandler},set reactionHandler(E){p.reactionHandler=E},createCommentThread(E,g,T){return p.createCommentThread(E,g,T).value},dispose:()=>{p.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,r,a,u){if(typeof n=="string"){const p=new b(this.id,this.handle,n,r,a,u,this._extension.identifier);return this._threads.set(p.handle,p),p}else{const p=new b(this.id,this.handle,void 0,n,r,a,this._extension.identifier);return this._threads.set(p.handle,p),p}}$createCommentThreadTemplate(n,r){const a=new b(this.id,this.handle,void 0,A.URI.revive(n),P.Range.to(r),[],this._extension.identifier);return a.collapsibleState=_.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(n,r){let a=this._threads.get(n);a&&(a.range=P.Range.to(r))}$deleteCommentThread(n){let r=this._threads.get(n);r&&r.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function o(s,n,r){let a=r.get(n);a||(a=++s.commentHandle,r.set(n,a));const u=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:a,body:P.MarkdownString.from(n.body),userName:n.author.name,userIconPath:u,label:n.label,commentReactions:n.reactions?n.reactions.map(p=>v(p)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?A.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function h(s){if(s!==void 0)switch(s){case i.CommentThreadCollapsibleState.Expanded:return _.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return _.CommentThreadCollapsibleState.Collapsed}return _.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=l}),define(fe[133],me([0,1,2,5,7,4,14,13,16,9,8]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class wn{constructor(f,d){this._logService=d,this._provider=new Map,this._proxy=f.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,d){const w=wn._handlePool++;this._provider.set(w,{provider:f,extensionId:d}),this._proxy.$registerDecorationProvider(w,d.value);const D=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(w,null);return}let b=(0,S.asArray)(I);if(b.length<=wn._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,b.length);const c=b.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),o=(0,S.groupBy)(c,(t,h)=>t.rank-h.rank||(0,P.compare)(t.uri.path,h.uri.path));let v=[];e:for(let t of o){let h;for(let s of t){let n=(0,i.dirname)(s.uri.path);if(h!==n&&(h=n,v.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new C.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(f,d,w){if(!this._provider.has(f))return Object.create(null);const D=Object.create(null),{provider:I,extensionId:b}=this._provider.get(f);return await Promise.all(d.map(async c=>{try{const{uri:o,id:v}=c,t=await Promise.resolve(I.provideFileDecoration(m.URI.revive(o),w));if(!t)return;try{C.FileDecoration.validate(t),D[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${b.value}': ${h}`)}}catch(o){this._logService.error(o)}})),D}};k._handlePool=0,k._maxEventSize=250,k=Ve([$e(0,A.IExtHostRpcService),$e(1,_.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[236],me([0,1,165,118,2,5,7,15,3,13,24,53,142]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";var f,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(c,o,v,t,h,s){this._name=c,this._owner=o,this._maxDiagnosticsPerFile=v,f.set(this,void 0),d.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,ot(this,w,new l.SkipList((n,r)=>t.compare(n,r)),"f"),ot(this,f,h,"f"),ot(this,d,s,"f")}dispose(){this._isDisposed||(Oe(this,d,"f").fire([...Oe(this,w,"f").keys()]),Oe(this,f,"f")&&Oe(this,f,"f").$clear(this._owner),Oe(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,o){if(!c){this.clear();return}this._checkDisposed();let v=[];if(C.URI.isUri(c)){if(!o){this.delete(c);return}Oe(this,w,"f").set(c,o.slice()),v=[c]}else if(Array.isArray(c)){v=[];let h;c=[...c].sort(D._compareIndexedTuplesByUri);for(const s of c){const[n,r]=s;if((!h||n.toString()!==h.toString())&&(h&&Oe(this,w,"f").get(h).length===0&&Oe(this,w,"f").delete(h),h=n,v.push(n),Oe(this,w,"f").set(n,[])),r){const a=Oe(this,w,"f").get(n);a&&a.push(...r)}else{const a=Oe(this,w,"f").get(n);a&&(a.length=0)}}}if(Oe(this,d,"f").fire(v),!Oe(this,f,"f"))return;const t=[];for(let h of v){let s=[];const n=Oe(this,w,"f").get(h);if(n)if(n.length>this._maxDiagnosticsPerFile){s=[];const r=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(let u of n)if(u.severity===r[a]&&s.push(_.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;s.push({severity:F.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=n.map(r=>_.Diagnostic.from(r));t.push([h,s])}Oe(this,f,"f").$changeMany(this._owner,t)}delete(c){this._checkDisposed(),Oe(this,d,"f").fire([c]),Oe(this,w,"f").delete(c),Oe(this,f,"f")&&Oe(this,f,"f").$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),Oe(this,d,"f").fire([...Oe(this,w,"f").keys()]),Oe(this,w,"f").clear(),Oe(this,f,"f")&&Oe(this,f,"f").$clear(this._owner)}forEach(c,o){this._checkDisposed();for(let v of Oe(this,w,"f").keys())c.apply(o,[v,this.get(v),this])}get(c){this._checkDisposed();const o=Oe(this,w,"f").get(c);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(Oe(this,w,"f").get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,o){return c[0].toString()<o[0].toString()?-1:c[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=D,f=new WeakMap,d=new WeakMap,w=new WeakMap;let I=class Zt{constructor(c,o,v){this._logService=o,this._fileSystemInfoService=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(c){const o=new i.ResourceMap;for(const v of c)o.set(v,v);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(c,o){const{_collections:v,_proxy:t,_onDidChangeDiagnostics:h,_logService:s,_fileSystemInfoService:n}=this,r=new class{$changeMany(p,E){t.$changeMany(p,E),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,p,E.length===0?"CLEARING":E)}$clear(p){t.$clear(p),s.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,p)}dispose(){t.dispose()}};let a;if(!o)o="_generated_diagnostic_collection_name_#"+Zt._idPool++,a=o;else if(!v.has(o))a=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do a=o+Zt._idPool++;while(v.has(a))}return new class extends D{constructor(){super(o,a,Zt._maxDiagnosticsPerFile,n.extUri,r,h);v.set(a,this)}dispose(){super.dispose(),v.delete(a)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const o=new Map,v=[];for(const t of this._collections.values())t.forEach((h,s)=>{let n=o.get(h.toString());typeof n=="undefined"&&(n=v.length,o.set(h.toString(),n),v.push([h,[]])),v[n][1]=v[n][1].concat(...s)});return v}}_getDiagnostics(c){let o=[];for(let v of this._collections.values())v.has(c)&&(o=o.concat(v.get(c)));return o}$acceptMarkersChange(c){if(!this._mirrorCollection){const o="_generated_mirror",v=new D(o,o,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,v),this._mirrorCollection=v}for(const[o,v]of c)this._mirrorCollection.set(C.URI.revive(o),v.map(_.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=Ve([$e(1,P.ILogService),$e(2,k.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(fe[237],me([0,1,2,5]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(A){this._proxy=A.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(_=>_?_.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(_=>_?m.URI.revive(_):void 0)}}e.ExtHostDialogs=C}),define(fe[238],me([0,1,18,2,7,5,10,21,9]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(k,l,f){this._documentsAndEditors=l,this._logService=f,this._documentContentProviders=new Map,this._proxy=k.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const f=P._handlePool++;this._documentContentProviders.set(f,l),this._proxy.$registerTextContentProvider(f,k);let d;return typeof l.onDidChange=="function"&&(d=l.onDidChange(w=>{if(w.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(f,w).then(D=>{if(!D&&typeof D!="string")return;const I=this._documentsAndEditors.getDocument(w);if(!I)return;const b=(0,S.splitLines)(D);if(!I.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,D)},m.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(k,l){const f=this._documentContentProviders.get(k);return f?Promise.resolve(f.provideTextDocumentContent(F.URI.revive(l),_.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(fe[239],me([0,1,3,6,2,5,125,15,12,25,7]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(f,d){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const D of w)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const D of w)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const d=this._documentsAndEditors.getDocument(f);if(d)return d}getDocument(f){const d=this.getDocumentData(f);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return d.document}ensureDocumentData(f){const d=this._documentsAndEditors.getDocument(f);if(d)return Promise.resolve(d);let w=this._documentLoader.get(f.toString());return w||(w=this._proxy.$tryOpenDocument(f).then(D=>{this._documentLoader.delete(f.toString());const I=C.URI.revive(D);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(I))},D=>(this._documentLoader.delete(f.toString()),Promise.reject(D))),this._documentLoader.set(f.toString(),w)),w}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(d=>C.URI.revive(d))}$acceptModelModeChanged(f,d){const w=C.URI.revive(f),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(d),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(f){const d=C.URI.revive(f),w=this._documentsAndEditors.getDocument(d);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(f,d){const w=C.URI.revive(f),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");D._acceptIsDirty(d),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,d,w){const D=C.URI.revive(f),I=this._documentsAndEditors.getDocument(D);if(!I)throw new Error("unknown document");I._acceptIsDirty(w),I.onEvents(d);let b;d.isUndoing?b=i.TextDocumentChangeReason.Undo:d.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:d.changes.map(c=>({range:_.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:b}))}setWordDefinitionFor(f,d){(0,A.setWordDefinitionFor)(f,d)}}e.ExtHostDocuments=k}),define(fe[45],me([0,1,58,3,6,2,4,5,125,14,132,15,13,24,10,94,141]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,v){this._extHostRpc=o,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const v=[],t=[],h=[];if(o.removedDocuments)for(const s of o.removedDocuments){const n=y.URI.revive(s),r=this._documents.get(n);r?.unref()&&(this._documents.delete(n),v.push(r.value))}if(o.addedDocuments)for(const s of o.addedDocuments){const n=y.URI.revive(s.uri);let r=this._documents.get(n);if(r&&n.scheme!==d.Schemas.vscodeNotebookCell&&n.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);r||(r=new I(new S.ExtHostDocumentData(this._extHostRpc.getProxy(_.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,r),t.push(r.value)),r.ref()}if(o.removedEditors)for(const s of o.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&h.push(n)}if(o.addedEditors)for(const s of o.addedEditors){const n=y.URI.revive(s.documentUri);m.ok(this._documents.has(n),`document '${n}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(n).value,a=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(_.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>r.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(u=>k.Range.to(u)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,a)}o.newActiveEditor!==void 0&&(m.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,C.dispose)(v),(0,C.dispose)(h),o.removedDocuments&&this._onDidRemoveDocuments.fire(v),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return o?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([$e(0,P.IExtHostRpcService),$e(1,l.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,15,5,2,3,4,14,17]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let P=class{constructor(k){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new y.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=k.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(k){let l=-1;this._tabs=k.map((d,w)=>(d.isActive&&(l=w),Object.freeze({label:d.label,viewColumn:m.ViewColumn.to(d.viewColumn),index:w,resource:C.URI.revive(d.resource),additionalResourcesAndViewIds:d.additionalResourcesAndViewIds.map(({resource:D,viewId:I})=>({resource:C.URI.revive(D),viewId:I})),viewId:d.editorId,isActive:d.isActive,move:async(D,I)=>{this._proxy.$moveTab(d,D,m.ViewColumn.from(I)),await(0,S.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(d),await(0,S.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((d,w)=>d.viewColumn===w.viewColumn?d.index-w.index:d.viewColumn-w.viewColumn);const f=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=Ve([$e(0,_.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(fe[240],me([0,1,2,5,6,7,15,149,9,22]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const d=this._schemes.indexOf(f);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),d=[];let w,D,I=14,b=14;for(const c of f){let o=w?(0,S.commonPrefixLength)(w,c):0;for(o===0?D=1:D=b;o<c.length;o++)o+1===c.length?(I=b,b=9):b+=1,d.push([D,c.toUpperCase().charCodeAt(o),b]),d.push([D,c.toLowerCase().charCodeAt(o),b]),D=b;w=c,b=I}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new _.StateMachine(d)}}provideDocumentLinks(f){this._initStateMachine();const d=[],w=_.LinkComputer.computeLinks({getLineContent(D){return f.lineAt(D-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const D of w){const I=A.DocumentLink.to(D);I.target&&d.push(I)}return d}}class k{constructor(f,d){this._extHostLanguageFeatures=d,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,d,w,D={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(I,w);let b=2;D.isCaseSensitive&&(b+=1024),D.isReadonly&&(b+=2048),typeof w.copy=="function"&&(b+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(I,d,b).catch(o=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${d}`),console.error(o)});const c=w.onDidChangeFile(o=>{const v=[];for(const t of o){let{uri:h,type:s}=t;if(h.scheme!==d)continue;let n;switch(s){case y.FileChangeType.Changed:n=0;break;case y.FileChangeType.Created:n=1;break;case y.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:h,type:n})}this._proxy.$onFileSystemChange(I,v)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(f){const{type:d,ctime:w,mtime:D,size:I,permissions:b}=f;return{type:d,ctime:w,mtime:D,size:I,permissions:b}}$stat(f,d){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(d))).then(w=>k._asIStat(w))}$readdir(f,d){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(d)))}$readFile(f,d){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(d))).then(w=>P.VSBuffer.wrap(w))}$writeFile(f,d,w,D){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(d),w.buffer,D))}$delete(f,d,w){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(d),w))}$rename(f,d,w,D){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(d),m.URI.revive(w),D))}$copy(f,d,w,D){const I=this._getFsProvider(f);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(m.URI.revive(d),m.URI.revive(w),D))}$mkdir(f,d){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(d)))}$watch(f,d,w,D){const I=this._getFsProvider(f).watch(m.URI.revive(w),D);this._watches.set(d,I)}$unwatch(f,d){const w=this._watches.get(d);w&&(w.dispose(),this._watches.delete(d))}$open(f,d,w){const D=this._getFsProvider(f);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(m.URI.revive(d),w))}$close(f,d){const w=this._getFsProvider(f);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(d))}$read(f,d,w,D){const I=this._getFsProvider(f);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const b=P.VSBuffer.alloc(D);return Promise.resolve(I.read(d,w,b.buffer,0,D)).then(c=>b.slice(0,c))}$write(f,d,w,D){const I=this._getFsProvider(f);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(d,w,D.buffer,0,D.byteLength))}_getFsProvider(f){const d=this._fsProvider.get(f);if(!d){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return d}}e.ExtHostFileSystem=k}),define(fe[91],me([0,1,5,43,7,22,4,14,53]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class xt{constructor(k,l){const f=k.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return f.$stat(d).catch(xt._handleError)},readDirectory(d){return f.$readdir(d).catch(xt._handleError)},createDirectory(d){return f.$mkdir(d).catch(xt._handleError)},async readFile(d){return f.$readFile(d).then(w=>w.buffer).catch(xt._handleError)},writeFile(d,w){return f.$writeFile(d,y.VSBuffer.wrap(w)).catch(xt._handleError)},delete(d,w){return f.$delete(d,{recursive:!1,useTrash:!1,...w}).catch(xt._handleError)},rename(d,w,D){return f.$rename(d,w,{overwrite:!1,...D}).catch(xt._handleError)},copy(d,w,D){return f.$copy(d,w,{overwrite:!1,...D}).catch(xt._handleError)},isWritableFileSystem(d){const w=l.getCapabilities(d);if(typeof w=="number")return!(w&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new C.FileSystemError(String(k));if(k.name==="ENOPRO")throw C.FileSystemError.Unavailable(k.message);switch(k.name){case F.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(k.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(k.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(k.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(k.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(k.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(k.message);default:throw new C.FileSystemError(k.message,k.name)}}};P=Ve([$e(0,_.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[241],me([0,1,2,40]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(A,_,S,P){this._extHostNotebooks=_,this._textDocumentsAndEditors=S,this._commands=P;const i=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",k=>!0,k=>k),new F.ApiCommandArgument("resource","Interactive resource Uri",k=>!0,k=>k),new F.ApiCommandArgument("controllerId","Notebook controller Id",k=>!0,k=>k),new F.ApiCommandArgument("title","Interactive editor title",k=>!0,k=>k)],new F.ApiCommandResult("Notebook and input URI",k=>{if(k.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(k.notebookEditorId);return{notebookUri:m.URI.revive(k.notebookUri),inputUri:m.URI.revive(k.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:m.URI.revive(k.notebookUri),inputUri:m.URI.revive(k.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(A,_,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:_,lines:[""],modeId:S,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=C}),define(fe[242],me([0,1,6,5]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const _=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(_,A),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(_)})}}e.ExtHostLabelService=C}),define(fe[243],me([0,1,2,25,15,7,5,9,42,16,12,146,6,112,77,87,46,18,3]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentSymbols(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,P.isFalsyOrEmpty)(le))return le[0]instanceof y.DocumentSymbol?le.map(C.DocumentSymbol.from):c._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((le,Z)=>{let ae=le.location.range.start.compareTo(Z.location.range.start);return ae===0&&(ae=Z.location.range.end.compareTo(le.location.range.end)),ae});const ee=[],re=[];for(const le of q){const Z={name:le.name||"!!MISSING: name!!",kind:C.SymbolKind.from(le.kind),tags:le.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:C.Range.from(le.location.range),selectionRange:C.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const ae=re[re.length-1];if(S.Range.containsRange(ae.range,Z.range)&&!S.Range.equalsRange(ae.range,Z.range)){ae.children&&ae.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class o{constructor(q,ee,re){this._documents=q,this._commands=ee,this._provider=re,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),ae=new l.DisposableStore;this._disposables.set(Z,ae);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:C.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return pe}async resolveCodeLens(q,ee){const re=q.cacheId&&this._cache.get(...q.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const Z=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!Z)return q.command=this._commands.toInternal(le.command??o._badCmd,Z),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(C.DefinitionLink.from):He?[C.DefinitionLink.from(He)]:[]}class t{constructor(q,ee){this._documents=q,this._provider=ee}async provideDefinition(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideDefinition(le,Z,re);return v(ae)}}class h{constructor(q,ee){this._documents=q,this._provider=ee}async provideDeclaration(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideDeclaration(le,Z,re);return v(ae)}}class s{constructor(q,ee){this._documents=q,this._provider=ee}async provideImplementation(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideImplementation(le,Z,re);return v(ae)}}class n{constructor(q,ee){this._documents=q,this._provider=ee}async provideTypeDefinition(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideTypeDefinition(le,Z,re);return v(ae)}}class r{constructor(q,ee){this._documents=q,this._provider=ee}async provideHover(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideHover(le,Z,re);if(!(!ae||(0,P.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Z)),ae.range||(ae.range=new y.Range(Z,Z)),C.Hover.from(ae)}}class a{constructor(q,ee){this._documents=q,this._provider=ee}async provideEvaluatableExpression(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideEvaluatableExpression(le,Z,re);if(ae)return C.EvaluatableExpression.from(ae)}}class u{constructor(q,ee){this._documents=q,this._provider=ee}async provideInlineValues(q,ee,re,le){const Z=this._documents.getDocument(q),ae=await this._provider.provideInlineValues(Z,C.Range.to(ee),C.InlineValueContext.to(re),le);if(Array.isArray(ae))return ae.map(pe=>C.InlineValue.from(pe))}}class p{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentHighlights(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideDocumentHighlights(le,Z,re);if(Array.isArray(ae))return ae.map(C.DocumentHighlight.from)}}class E{constructor(q,ee){this._documents=q,this._provider=ee}async provideLinkedEditingRanges(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideLinkedEditingRanges(le,Z,re);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,P.coalesce)(ae.ranges.map(C.Range.from)),wordPattern:ae.wordPattern}}}class g{constructor(q,ee){this._documents=q,this._provider=ee}async provideReferences(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=await this._provider.provideReferences(Z,ae,re,le);if(Array.isArray(pe))return pe.map(C.location.from)}}class T{constructor(q,ee,re,le,Z,ae,pe){this._documents=q,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=Z,this._extension=ae,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,ee,re,le){const Z=this._documents.getDocument(q),ae=k.Selection.isISelection(ee)?C.Selection.to(ee):C.Range.to(ee),pe=[];for(const Te of this._diagnostics.getDiagnostics(q))if(ae.intersection(Te.range)&&pe.push(Te)>T._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:re.only?new y.CodeActionKind(re.only):void 0,triggerKind:C.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(Z,ae,Me,le);if(!(0,P.isNonEmptyArray)(je)||le.isCancellationRequested)return;const Ke=this._cache.add(je),Je=new l.DisposableStore;this._disposables.set(Ke,Je);const st=[];for(let Te=0;Te<je.length;Te++){const nt=je[Te];!nt||(T._isCommand(nt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:nt.title,command:this._commands.toInternal(nt,Je)})):(Me.only&&(nt.kind?Me.only.contains(nt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ke,Te],title:nt.title,command:nt.command&&this._commands.toInternal(nt.command,Je),diagnostics:nt.diagnostics&&nt.diagnostics.map(C.Diagnostic.from),edit:nt.edit&&C.WorkspaceEdit.from(nt.edit),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,disabled:nt.disabled?.reason})))}return{cacheId:Ke,actions:st}}async resolveCodeAction(q,ee){const[re,le]=q,Z=this._cache.get(re,le);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Z,ee)??Z;return ae?.edit?C.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}T._maxCodeActionsPerFile=1e3;class L{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentFormattingEdits(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(Z))return Z.map(C.TextEdit.from)}}class M{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentRangeFormattingEdits(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,ae,re,le);if(Array.isArray(pe))return pe.map(C.TextEdit.from)}}class R{constructor(q,ee){this._documents=q,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,ee,re,le,Z){const ae=this._documents.getDocument(q),pe=C.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(ae,pe,re,le,Z);if(Array.isArray(Me))return Me.map(C.TextEdit.from)}}class W{constructor(q,ee){this._provider=q,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,ee){const re=A.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(q,ee);if((0,P.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const ae=A.IdObject.mixin(C.WorkspaceSymbol.from(Z));this._symbolCache.set(ae._id,Z),re.symbols.push(ae)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(q,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,F.mixin)(q,C.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(q){const ee=this._resultCache.get(q);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class V{constructor(q,ee,re){this._documents=q,this._provider=ee,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,ae,re,le);return pe?C.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=V._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(q,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(q),Z=C.Position.to(ee);try{const ae=await this._provider.prepareRename(le,Z,re);let pe,Me;if(y.Range.isRange(ae)?(pe=ae,Me=le.getText(ae)):(0,i.isObject)(ae)&&(pe=ae.range,Me=ae.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(pe),text:Me}}catch(ae){const pe=V._asMessage(ae);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class N{constructor(q,ee){this.resultId=q,this.tokens=ee}}class j{constructor(q,ee){this._documents=q,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,ee,re){const le=this._documents.getDocument(q),Z=ee!==0?this._previousResults.get(ee):null;let ae=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return Z&&this._previousResults.delete(ee),ae?(ae=j._fixProvidedSemanticTokens(ae),this._send(j._convertToEdits(Z,ae),ae)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return j._isSemanticTokens(q)?j._isCorrectSemanticTokens(q)?q:new y.SemanticTokens(new Uint32Array(q.data),q.resultId):j._isSemanticTokensEdits(q)?j._isCorrectSemanticTokensEdits(q)?q:new y.SemanticTokensEdits(q.edits.map(ee=>new y.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const ee of q.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,ee){if(!j._isSemanticTokens(ee)||!q||!q.tokens)return ee;const re=q.tokens,le=re.length,Z=ee.data,ae=Z.length;let pe=0;const Me=Math.min(le,ae);for(;pe<Me&&re[pe]===Z[pe];)pe++;if(pe===le&&pe===ae)return new y.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&re[le-je-1]===Z[ae-je-1];)je++;return new y.SemanticTokensEdits([{start:pe,deleteCount:le-pe-je,data:Z.subarray(pe,ae-je)}],ee.resultId)}_send(q,ee){if(j._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new N(q.resultId,q.data)),(0,f.encodeSemanticTokensDto)({id:re,type:"full",data:q.data})}if(j._isSemanticTokensEdits(q)){const re=this._nextResultId++;return j._isSemanticTokens(ee)?this._previousResults.set(re,new N(ee.resultId,ee.data)):this._previousResults.set(re,new N(q.resultId)),(0,f.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(q.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=j;class U{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentRangeSemanticTokens(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideDocumentRangeSemanticTokens(le,C.Range.to(ee),re);return Z?this._send(Z):null}_send(q){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(q,ee,re,le,Z){this._documents=q,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=Z.getWordRangeAtPosition(ae)||new y.Range(ae,ae),Me=pe.with({end:ae}),je=new D.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,ae,le,C.CompletionContext.to(re));if(!Ke||le.isCancellationRequested)return;const Je=Array.isArray(Ke)?new y.CompletionList(Ke):Ke,st=x.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),Te=new l.DisposableStore;this._disposables.set(st,Te);const nt=[],J={x:st,b:nt,a:{replace:C.Range.from(pe),insert:C.Range.from(Me)},c:Je.isIncomplete||void 0,d:je.elapsed()};for(let ne=0;ne<Je.items.length;ne++){const ve=Je.items[ne],Qe=this._convertCompletionItem(ve,[st,ne],Me,pe);nt.push(Qe)}return J}async resolveCompletionItem(q,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,ee,re,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const ae={x:ee,a:q.label,b:q.kind!==void 0?C.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(C.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(q.command,Z)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=q.textEdit.newText):typeof q.insertText=="string"?ae.h=q.insertText:q.insertText instanceof y.SnippetString&&(ae.h=q.insertText.value,ae.i|=4);let pe;return q.textEdit?pe=q.textEdit.range:q.range&&(pe=q.range),y.Range.isRange(pe)?ae.j=C.Range.from(pe):pe&&(!re?.isEqual(pe.inserting)||!le?.isEqual(pe.replacing))&&(ae.j={insert:C.Range.from(pe.inserting),replace:C.Range.from(pe.replacing)}),ae}}class z{constructor(q,ee,re){this._documents=q,this._provider=ee,this._commands=re,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,ae,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:C.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},le);if(!pe||le.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Je,st)=>{let Te;return Je.command&&(Ke||(Ke=new l.DisposableStore,this._disposables.set(je,Ke)),Te=this._commands.toInternal(Je.command,Ke)),{text:Je.text,range:Je.range?C.Range.from(Je.range):void 0,command:Te,idx:st}})}}disposeCompletions(q){this._cache.delete(q);const ee=this._disposables.get(q);ee&&ee.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,ee){const re=this._cache.get(q,ee);re&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let ee=O.map.get(q);return ee||(ee=new O,O.map.set(q,ee)),ee}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=O,O.map=new WeakMap;class ${constructor(q,ee){this._documents=q,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,ae,le,pe);if(Me){const je=this._cache.add([Me]);return{...C.SignatureHelp.from(Me),id:je}}}reviveContext(q){let ee;if(q.activeSignatureHelp){const re=C.SignatureHelp.to(q.activeSignatureHelp),le=this._cache.get(q.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...q,activeSignatureHelp:ee}}releaseSignatureHelp(q){this._cache.delete(q)}}class B{constructor(q,ee){this._documents=q,this._provider=ee}async provideInlayHints(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideInlayHints(le,C.Range.to(ee),re);return Z?{hints:Z.map(C.InlayHint.from)}:void 0}}class X{constructor(q,ee){this._documents=q,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(X._validateLink).map(C.DocumentLink.from)};{const Z=this._cache.add(le),ae={links:[],id:Z};for(let pe=0;pe<le.length;pe++){if(!X._validateLink(le[pe]))continue;const Me=C.DocumentLink.from(le[pe]);Me.cacheId=[Z,pe],ae.links.push(Me)}return ae}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...q);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!X._validateLink(le)))return C.DocumentLink.from(le)}releaseLinks(q){this._cache.delete(q)}}class Q{constructor(q,ee){this._documents=q,this._provider=ee}async provideColors(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(ae=>({color:C.Color.from(ae.color),range:C.Range.from(ae.range)})):[]}async provideColorPresentations(q,ee,re){const le=this._documents.getDocument(q),Z=C.Range.to(ee.range),ae=C.Color.to(ee.color),pe=await this._provider.provideColorPresentations(ae,{document:le,range:Z},re);if(!!Array.isArray(pe))return pe.map(C.ColorPresentation.from)}}class de{constructor(q,ee){this._documents=q,this._provider=ee}async provideFoldingRanges(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(Z))return Z.map(C.FoldingRange.from)}}class _e{constructor(q,ee,re){this._documents=q,this._provider=ee,this._logService=re}async provideSelectionRanges(q,ee,re){const le=this._documents.getDocument(q),Z=ee.map(C.Position.to),ae=await this._provider.provideSelectionRanges(le,Z,re);if(!(0,P.isNonEmptyArray)(ae))return[];if(ae.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Je=ae[Me];for(;;){if(!Je.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(Je)),!Je.parent)break;Ke=Je.range,Je=Je.parent}}return pe}}class ye{constructor(q,ee){this._documents=q,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.prepareCallHierarchy(le,Z,re);if(!ae)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,ae)]}async provideCallsTo(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!Z)return Z.map(ae=>({from:this._cacheAndConvertItem(q,ae.from),fromRanges:ae.fromRanges.map(pe=>C.Range.from(pe))}))}async provideCallsFrom(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!Z)return Z.map(ae=>({to:this._cacheAndConvertItem(q,ae.to),fromRanges:ae.fromRanges.map(pe=>C.Range.from(pe))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,ee){const re=this._cache.get(q),le=C.CallHierarchyItem.from(ee,q,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(q,ee){return this._cache.get(q)?.get(ee)}}class ke{constructor(q,ee){this._documents=q,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.prepareTypeHierarchy(le,Z,re);if(!ae)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,ae)]}async provideSupertypes(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(q,ae))}async provideSubtypes(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(q,ae))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,ee){const re=this._cache.get(q),le=C.TypeHierarchyItem.from(ee,q,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(q,ee){return this._cache.get(q)?.get(ee)}}class Be{constructor(q,ee){this.adapter=q,this.extension=ee}}class We{constructor(q,ee,re,le,Z,ae,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=q.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=Z,this._logService=ae,this._apiDeprecation=pe}_transformDocumentSelector(q){return C.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new y.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return We._handlePool++}_withAdapter(q,ee,re,le,Z=!1){const ae=this._adapter.get(q);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof ee){let pe;ae.extension&&(pe=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(ae.adapter,ae.extension),je=ae.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof I.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,ee){const re=this._nextHandle();return this._adapter.set(re,new Be(q,ee)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,ee,re,le){const Z=this._addNewAdapter(new c(this._documents,re),q),ae=le&&le.label||We._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),ae),this._createDisposable(Z)}$provideDocumentSymbols(q,ee,re){return this._withAdapter(q,c,le=>le.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(q,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new o(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const pe=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));ae=y.Disposable.from(ae,pe)}return ae}$provideCodeLenses(q,ee,re){return this._withAdapter(q,o,le=>le.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(q,ee,re){return this._withAdapter(q,o,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(q,ee){this._withAdapter(q,o,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(q,ee,re){const le=this._addNewAdapter(new t(this._documents,re),q);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(q,ee,re,le){return this._withAdapter(q,t,Z=>Z.provideDefinition(m.URI.revive(ee),re,le),[])}registerDeclarationProvider(q,ee,re){const le=this._addNewAdapter(new h(this._documents,re),q);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(q,ee,re,le){return this._withAdapter(q,h,Z=>Z.provideDeclaration(m.URI.revive(ee),re,le),[])}registerImplementationProvider(q,ee,re){const le=this._addNewAdapter(new s(this._documents,re),q);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(q,ee,re,le){return this._withAdapter(q,s,Z=>Z.provideImplementation(m.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(q,ee,re){const le=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(q,ee,re,le){return this._withAdapter(q,n,Z=>Z.provideTypeDefinition(m.URI.revive(ee),re,le),[])}registerHoverProvider(q,ee,re,le){const Z=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(q,ee,re,le){return this._withAdapter(q,r,Z=>Z.provideHover(m.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(q,ee,re,le){const Z=this._addNewAdapter(new a(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(q,ee,re,le){return this._withAdapter(q,a,Z=>Z.provideEvaluatableExpression(m.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(q,ee,re,le){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new u(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(ae);if(Z!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=y.Disposable.from(pe,Me)}return pe}$provideInlineValues(q,ee,re,le,Z){return this._withAdapter(q,u,ae=>ae.provideInlineValues(m.URI.revive(ee),re,le,Z),void 0)}registerDocumentHighlightProvider(q,ee,re){const le=this._addNewAdapter(new p(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(q,ee,re,le){return this._withAdapter(q,p,Z=>Z.provideDocumentHighlights(m.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(q,ee,re){const le=this._addNewAdapter(new E(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(q,ee,re,le){return this._withAdapter(q,E,async Z=>{const ae=await Z.provideLinkedEditingRanges(m.URI.revive(ee),re,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?We._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(q,ee,re){const le=this._addNewAdapter(new g(this._documents,re),q);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(q,ee,re,le,Z){return this._withAdapter(q,g,ae=>ae.provideReferences(m.URI.revive(ee),re,le,Z),void 0)}registerCodeActionProvider(q,ee,re,le){const Z=new l.DisposableStore,ae=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(pe=>pe.value),documentation:le?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},We._extLabel(q),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(ae)),Z}$provideCodeActions(q,ee,re,le,Z){return this._withAdapter(q,T,ae=>ae.provideCodeActions(m.URI.revive(ee),re,le,Z),void 0)}$resolveCodeAction(q,ee,re){return this._withAdapter(q,T,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(q,ee){this._withAdapter(q,T,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(q,ee,re){const le=this._addNewAdapter(new L(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),q.identifier,q.displayName||q.name),this._createDisposable(le)}$provideDocumentFormattingEdits(q,ee,re,le){return this._withAdapter(q,L,Z=>Z.provideDocumentFormattingEdits(m.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(q,ee,re){const le=this._addNewAdapter(new M(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),q.identifier,q.displayName||q.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(q,ee,re,le,Z){return this._withAdapter(q,M,ae=>ae.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,le,Z),void 0)}registerOnTypeFormattingEditProvider(q,ee,re,le){const Z=this._addNewAdapter(new R(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,q.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(q,ee,re,le,Z,ae){return this._withAdapter(q,R,pe=>pe.provideOnTypeFormattingEdits(m.URI.revive(ee),re,le,Z,ae),void 0)}registerWorkspaceSymbolProvider(q,ee){const re=this._addNewAdapter(new W(ee,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(q,ee,re){return this._withAdapter(q,W,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(q,ee,re){return this._withAdapter(q,W,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(q,ee){this._withAdapter(q,W,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(q,ee,re){const le=this._addNewAdapter(new V(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),V.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(q,ee,re,le,Z){return this._withAdapter(q,V,ae=>ae.provideRenameEdits(m.URI.revive(ee),re,le,Z),void 0)}$resolveRenameLocation(q,ee,re,le){return this._withAdapter(q,V,Z=>Z.resolveRenameLocation(m.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(q,ee,re,le){const Z=this._nextHandle(),ae=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new j(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,ae);let pe=this._createDisposable(Z);if(ae){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(ae));pe=y.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(q,ee,re,le){return this._withAdapter(q,j,Z=>Z.provideDocumentSemanticTokens(m.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(q,ee){this._withAdapter(q,j,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(q,ee,re,le){const Z=this._addNewAdapter(new U(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(q,ee,re,le){return this._withAdapter(q,U,Z=>Z.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(q,ee,re,le){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,x.supportsResolving(re),`${q.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(q,ee,re,le,Z){return this._withAdapter(q,x,ae=>ae.provideCompletionItems(m.URI.revive(ee),re,le,Z),void 0)}$resolveCompletionItem(q,ee,re){return this._withAdapter(q,x,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(q,ee){this._withAdapter(q,x,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(q,ee,re){const le=this._addNewAdapter(new z(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(q,ee,re,le,Z){return this._withAdapter(q,z,ae=>ae.provideInlineCompletions(m.URI.revive(ee),re,le,Z),void 0)}$handleInlineCompletionDidShow(q,ee,re){this._withAdapter(q,z,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(q,ee){this._withAdapter(q,z,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(q,ee,re,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new $(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(ee),Z),this._createDisposable(ae)}$provideSignatureHelp(q,ee,re,le,Z){return this._withAdapter(q,$,ae=>ae.provideSignatureHelp(m.URI.revive(ee),re,le,Z),void 0)}$releaseSignatureHelp(q,ee){this._withAdapter(q,$,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(q,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new B(this._documents,re),q);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let ae=this._createDisposable(Z);if(le!==void 0){const pe=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=y.Disposable.from(ae,pe)}return ae}$provideInlayHints(q,ee,re,le){return this._withAdapter(q,B,Z=>Z.provideInlayHints(m.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(q,ee,re){const le=this._addNewAdapter(new X(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(q,ee,re){return this._withAdapter(q,X,le=>le.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(q,ee,re){return this._withAdapter(q,X,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(q,ee){this._withAdapter(q,X,re=>re.releaseLinks(ee),void 0)}registerColorProvider(q,ee,re){const le=this._addNewAdapter(new Q(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(q,ee,re){return this._withAdapter(q,Q,le=>le.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(q,ee,re,le){return this._withAdapter(q,Q,Z=>Z.provideColorPresentations(m.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(q,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new de(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const pe=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ae=y.Disposable.from(ae,pe)}return ae}$provideFoldingRanges(q,ee,re,le){return this._withAdapter(q,de,Z=>Z.provideFoldingRanges(m.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(q,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(q,ee,re,le){return this._withAdapter(q,_e,Z=>Z.provideSelectionRanges(m.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(q,ee,re){const le=this._addNewAdapter(new ye(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(q,ee,re,le){return this._withAdapter(q,ye,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(q,ee,re,le){return this._withAdapter(q,ye,Z=>Z.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(q,ee,re,le){return this._withAdapter(q,ye,Z=>Z.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(q,ee){this._withAdapter(q,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(q,ee,re){const le=this._addNewAdapter(new ke(this._documents,re),q);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(q,ee,re,le){return this._withAdapter(q,ke,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(q,ee,re,le){return this._withAdapter(q,ke,Z=>Z.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(q,ee,re,le){return this._withAdapter(q,ke,Z=>Z.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(q,ee){this._withAdapter(q,ke,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,_.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:We._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?We._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?We._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:We._serializeRegExp(q.beforeText),afterText:q.afterText?We._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?We._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(We._serializeOnEnterRule)}setLanguageConfiguration(q,ee,re){let{wordPattern:le}=re;if(le&&(0,_.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const Z=this._nextHandle(),ae={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?We._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?We._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,ae),this._createDisposable(Z)}$setWordDefinitions(q){for(const ee of q)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(fe[244],me([0,1,5,15,7,49,17,6]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(i,k,l,f){this._documents=k,this._commands=l,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,k){await this._proxy.$changeLanguage(i,k);const l=this._documents.getDocumentData(i);if(!l)throw new Error(`document '${i.toString}' NOT found`);return l.document}async tokenAtPosition(i,k){const l=i.version,f=F.Position.from(k),d=await this._proxy.$tokensAtPosition(i.uri,f),w={type:C.StandardTokenType.Other,range:i.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!d)return w;const D={range:F.Range.to(d.range),type:F.TokenType.to(d.type)};return!D.range.contains(k)||l!==i.version?w:D}createLanguageStatusItem(i,k,l){const f=this._handlePool++,d=this._proxy,w=this._ids,D=`${i.identifier.value}/${k}`;if(w.has(D))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);w.add(D);const I={selector:l,id:k,name:i.displayName??i.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,c=new _.DisposableStore;const o=()=>{b?.dispose(),b=(0,A.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(f,{id:D,name:I.name??i.displayName??i.name,source:i.displayName??i.name,selector:F.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===C.LanguageStatusSeverity.Error?y.default.Error:I.severity===C.LanguageStatusSeverity.Warning?y.default.Warning:y.default.Info,command:I.command&&this._commands.toInternal(I.command,c),accessibilityInfo:I.accessibilityInformation})},0)},v={dispose(){c.dispose(),b?.dispose(),d.$removeLanguageStatus(f),w.delete(D)},get id(){return I.id},get name(){return I.name},set name(t){I.name=t,o()},get selector(){return I.selector},set selector(t){I.selector=t,o()},get text(){return I.text},set text(t){I.text=t,o()},get detail(){return I.detail},set detail(t){I.detail=t,o()},get severity(){return I.severity},set severity(t){I.severity=t,o()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(t){I.accessibilityInformation=t,o()},get command(){return I.command},set command(t){I.command=t,o()}};return o(),v}}e.ExtHostLanguages=S}),define(fe[245],me([0,1,5,13,35]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(_){return _&&_.title}let A=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,P,i,k,l){const f={extension:S};let d;typeof k=="string"||y(k)?d=[k,...l]:(f.modal=k?.modal,f.useCustom=k?.useCustom,f.detail=k?.detail,d=l),f.useCustom&&(0,C.checkProposedApiEnabled)(S);const w=[];for(let D=0;D<d.length;D++){const I=d[D];if(typeof I=="string")w.push({title:I,handle:D,isCloseAffordance:!1});else if(typeof I=="object"){let{title:b,isCloseAffordance:c}=I;w.push({title:b,isCloseAffordance:!!c,handle:D})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,i,f,w).then(D=>{if(typeof D=="number")return d[D]})}};A=Ve([$e(1,F.ILogService)],A),e.ExtHostMessageService=A}),define(fe[246],me([0,1,22,3,48,6,24,9,12,2,87,5,15,7,55,221,131]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(c,o,v,t,h){this._textDocumentsAndEditors=v,this._textDocuments=t,this._extensionStoragePaths=h,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,r=s.cell.handle,u=this._documents.get(n)?.getCell(r);if(u)return u.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const o=this._editors.get(c);if(!o)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(c){for(const[o,v]of this._editors)if(v.apiEditor===c)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,o){const v=this._documents.get(c);if(!v&&!o)throw new Error(`NO notebook document for '${c}'`);return v}_getProviderData(c){const o=this._notebookContentProviders.get(c);if(!o)throw new Error(`NO provider for '${c}'`);return o}registerNotebookContentProvider(c,o,v,t,h){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:c,provider:v});let s;return v.onDidChangeNotebookContentOptions&&(s=v.onDidChangeNotebookContentOptions(()=>{const n=l.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(o,n)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},o,l.NotebookDocumentContentOptions.from(t),I._convertNotebookRegistrationData(c,h)),new f.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(c,o){if(!o)return;const v=o.filenamePattern.map(t=>l.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(o.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:o.displayName,filenamePattern:v,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,o,v){const t=I._notebookStatusBarItemProviderHandlePool++,h=typeof v.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,h,o);let s;return h!==void 0&&(s=v.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(h))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,h),s&&s.dispose()})}async createNotebookDocument(c){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&l.NotebookData.from(c.content)});return P.URI.revive(o)}async openNotebookDocument(c){const o=this._documents.get(c);if(o)return o.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(c),t=this._documents.get(P.URI.revive(v));return(0,S.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(c,o){P.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let v;typeof o=="object"?v={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,v),h=t&&this._editors.get(t)?.apiEditor;if(h)return h;throw t?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,o,v,t){const h=this._notebookStatusBarItemProviders.get(c),s=P.URI.revive(o),n=this._documents.get(s);if(!n||!h)return;const r=n.getCellFromIndex(v);if(!r)return;const a=await h.provideCellStatusBarItems(r.apiCell,t);if(!a)return;const u=new y.DisposableStore,p=this._statusBarCache.add([u]),g=(Array.isArray(a)?a:[a]).map(T=>l.NotebookStatusBarItem.from(T,this._commandsConverter,u));return{cacheId:p,items:g}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,o,v,t,h){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,v),this._notebookProxy.$registerNotebookSerializer(s,{id:c.identifier,location:c.extensionLocation},o,l.NotebookDocumentContentOptions.from(t),I._convertNotebookRegistrationData(c,h)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(c,o,v){const t=this._notebookSerializer.get(c);if(!t)throw new Error("NO serializer found");const h=await t.deserializeNotebook(o.buffer,v);return new d.SerializableObjectWithBuffers(l.NotebookData.from(h))}async $notebookToData(c,o,v){const t=this._notebookSerializer.get(c);if(!t)throw new Error("NO serializer found");const h=await t.serializeNotebook(l.NotebookData.to(o.value),v);return m.VSBuffer.wrap(h)}async $openNotebook(c,o,v,t,h){const{provider:s}=this._getProviderData(c),n=await s.openNotebook(P.URI.revive(o),{backupId:v,untitledDocumentData:t?.buffer},h);return new d.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(l.NotebookCellData.from)})}async $saveNotebook(c,o,v){const t=this.getNotebookDocument(P.URI.revive(o)),{provider:h}=this._getProviderData(c);return await h.saveNotebook(t.apiNotebook,v),!0}async $saveNotebookAs(c,o,v,t){const h=this.getNotebookDocument(P.URI.revive(o)),{provider:s}=this._getProviderData(c);return await s.saveNotebookAs(P.URI.revive(v),h.apiNotebook,t),!0}async $backupNotebook(c,o,v){const t=this.getNotebookDocument(P.URI.revive(o)),h=this._getProviderData(c),s=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension),n=String((0,C.hash)([t.uri.toString(),this._backupIdPool++])),r=P.URI.joinPath(s,n),a=await h.provider.backupNotebook(t.apiNotebook,{destination:r},v);return t.updateBackup(a),a.id}_createExtHostEditor(c,o,v){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const t=new D.ExtHostNotebookEditor(o,this._notebookEditorsProxy,c,v.visibleRanges.map(l.NotebookRange.to),v.selections.map(l.NotebookRange.to),typeof v.viewColumn=="number"?l.ViewColumn.to(v.viewColumn):void 0);this._editors.set(o,t)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const v of c.value.removedDocuments){const t=P.URI.revive(v),h=this._documents.get(t);h&&(h.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(h.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===t.toString()&&this._editors.delete(s.id)}if(c.value.addedDocuments){const v=[];for(const t of c.value.addedDocuments){const h=P.URI.revive(t.uri);if(this._documents.has(h))throw new Error(`adding EXISTING notebook ${h} `);const s=this,n=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){s._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){s._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){s._onDidChangeCellMetadata.fire(r)},emitCellExecutionStateChange(r){s._onDidChangeCellExecutionState.fire(r)}},h,t);v.push(...t.cells.map(r=>w.ExtHostCell.asModelAddData(n.apiNotebook,r))),this._documents.get(h)?.dispose(),this._documents.set(h,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(c.value.addedEditors)for(const v of c.value.addedEditors){if(this._editors.has(v.id))return;const t=P.URI.revive(v.documentUri),h=this._documents.get(t);h&&this._createExtHostEditor(h,v.id,v)}const o=[];if(c.value.removedEditors)for(const v of c.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),o.push(t))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const h=v.has(t.id);t._acceptVisibility(h)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(fe[247],me([0,1,3,77,13,5,14,15]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(k,l){const f=S._Keys.nextId();k.$registerNotebookEditorDecorationType(f,_.NotebookDecorationRenderOptions.from(l)),this.value={key:f,dispose(){k.$removeNotebookEditorDecorationType(f)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(k,l,f){this._logService=k,this._extHostRpc=l,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new S(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,l);const f=this._notebooksAndEditors.getEditorById(k);l.visibleRanges&&f._acceptVisibleRanges(l.visibleRanges.ranges.map(_.NotebookRange.to)),l.selections&&f._acceptSelections(l.selections.selections.map(_.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const l in k)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(_.ViewColumn.to(k[l]))}};P=Ve([$e(0,C.ILogService),$e(1,A.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(fe[248],me([0,1,16,17,21,3,6,24,2,26,13,5,40,15,7,88,214,35,55]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let c=class{constructor(s,n,r,a,u){this._initData=n,this._extHostNotebook=r,this._commands=a,this._logService=u,this._activeExecutions=new _.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(k.MainContext.MainThreadNotebookKernels);const p=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const g=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:g}}else if(E&&"notebookEditor"in E){const g=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(g===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:g}}return E})],l.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(s,n,r,a,u,p){for(let $ of this._kernelData.values())if($.controller.id===n&&P.ExtensionIdentifier.equals(s.identifier,$.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const E=this._handlePool++,g=this;this._logService.trace(`NotebookController[${E}], CREATED by ${s.identifier.value}, ${n}`);const T=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${s.identifier}'`);let L=!1;const M=new A.DisposableStore,R=new y.Emitter,W=new y.Emitter,V={id:`${s.identifier.value}/${n}`,notebookType:r,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:a||s.identifier.value,preloads:p?p.map(f.NotebookRendererScript.from):[]};let N=u??T,j;this._proxy.$addKernel(E,V).catch($=>{console.log($),L=!0});let U=0;const x=()=>{if(L)return;const $=++U;Promise.resolve().then(()=>{$===U&&this._proxy.$updateKernel(E,V)})},z=new _.ResourceMap,O={get id(){return n},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return V.label},set label($){V.label=$??s.displayName??s.name,x()},get detail(){return V.detail??""},set detail($){V.detail=$,x()},get description(){return V.description??""},set description($){V.description=$,x()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages($){V.supportedLanguages=$,x()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder($){V.supportsExecutionOrder=$,x()},get rendererScripts(){return V.preloads?V.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler($){N=$??T},get interruptHandler(){return j},set interruptHandler($){j=$,V.supportsInterrupt=Boolean($),x()},createNotebookCellExecution($){if(L)throw new Error("notebook controller is DISPOSED");if(!z.has($.notebook.uri))throw g._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(B=>B.toString())),new Error(`notebook controller is NOT associated to notebook: ${$.notebook.uri.toString()}`);return g._createNotebookCellExecution($)},dispose:()=>{L||(this._logService.trace(`NotebookController[${E}], DISPOSED`),L=!0,this._kernelData.delete(E),M.dispose(),R.dispose(),W.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity($,B){g._proxy.$updateNotebookPriority(E,$.uri,B)},onDidReceiveMessage:W.event,postMessage($,B){return(0,I.checkProposedApiEnabled)(s),g._proxy.$postMessage(E,B&&g._extHostNotebook.getIdByEditor(B),$)},asWebviewUri($){return(0,I.checkProposedApiEnabled)(s),(0,w.asWebviewUri)($,g._initData.remote)}};return this._kernelData.set(E,{extensionId:s.identifier,controller:O,onDidReceiveMessage:W,onDidChangeSelection:R,associatedNotebooks:z}),O}$acceptNotebookAssociation(s,n,r){const a=this._kernelData.get(s);if(a){const u=this._extHostNotebook.getNotebookDocument(S.URI.revive(n));r?a.associatedNotebooks.set(u.uri,!0):a.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,u.uri.toString(),r),a.onDidChangeSelection.fire({selected:r,notebook:u.apiNotebook})}}async $executeCells(s,n,r){const a=this._kernelData.get(s);if(!a)return;const u=this._extHostNotebook.getNotebookDocument(S.URI.revive(n)),p=[];for(let E of r){const g=u.getCell(E);g&&p.push(g.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,u.uri.toString(),p.length),await a.controller.executeHandler.call(a.controller,p,u.apiNotebook,a.controller)}catch(E){this._logService.error(`NotebookController[${s}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(s,n,r){const a=this._kernelData.get(s);if(!a)return;const u=this._extHostNotebook.getNotebookDocument(S.URI.revive(n));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,u.apiNotebook);else for(let p of r){const E=u.getCell(p);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,r){const a=this._kernelData.get(s);if(!a)return;const u=this._extHostNotebook.getEditorById(n);a.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:r}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const a=new v(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,a);const u=a.onDidChangeState(()=>{a.state===o.Resolved&&(a.dispose(),u.dispose(),this._activeExecutions.delete(r.uri))});return a.asApiObject()}};c=Ve([$e(4,i.ILogService)],c),e.ExtHostNotebookKernels=c;var o;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(o||(o={}));class v extends A.Disposable{constructor(s,n,r){super();this._document=s,this._cell=n,this._proxy=r,this._handle=v.HANDLE++,this._onDidChangeState=new y.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new t(10,a=>this.update(a)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let n=this._cell;if(s&&(n=this._document.getCellFromApiCell(s)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(s){return s.map(n=>{const r=d.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return r===n.items?f.NotebookCellOutput.from(n):f.NotebookCellOutput.from({items:r,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,r){const a=this.cellIndexToHandle(n),u=this.validateAndConvertOutputs((0,m.asArray)(s));return this.updateSoon({editType:D.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:a,append:r,outputs:u})}async updateOutputItems(s,n,r){return s=d.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(s),!0),this.updateSoon({editType:D.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(f.NotebookCellOutputItem.from),outputId:n.id,append:r})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(r){s._executionOrder=r,s.update([{editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(r){if(s._state===o.Resolved||s._state===o.Started)throw new Error("Cannot call start again");s._state=o.Started,s._onDidChangeState.fire(),s.update({editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:r})},end(r,a){if(s._state===o.Resolved)throw new Error("Cannot call resolve twice");s._state=o.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:D.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:a,lastRunSuccess:r}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(r){return s.verifyStateForOutput(),s.updateOutputs([],r,!1)},appendOutput(r,a){return s.verifyStateForOutput(),s.updateOutputs(r,a,!0)},replaceOutput(r,a){return s.verifyStateForOutput(),s.updateOutputs(r,a,!1)},appendOutputItems(r,a){return s.verifyStateForOutput(),s.updateOutputItems(r,a,!0)},replaceOutputItems(r,a){return s.verifyStateForOutput(),s.updateOutputItems(r,a,!1)}})}}v.HANDLE=0;class t{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}}),define(fe[249],me([0,1,3,5,131]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(_,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,S,P){const i=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(S)?.fire({editor:i.apiEditor,message:P})}createRendererMessaging(_,S){if(!_.contributes?.notebookRenderer?.some(l=>l.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const P=!!_.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(l,f,d)=>{const w=P?l:D=>{const I={};i.set(I,D.editor),l({editor:I,message:D.message})};return this.getOrCreateEmitterFor(S).event(w,f,d)},postMessage:(l,f)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,f]=[f,l]);const d=P?f:i.get(f),w=d&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(w?.id,S,l)}}}getOrCreateEmitterFor(_){let S=this._rendererMessageEmitters.get(_);return S||(S=new m.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,S),S)}}e.ExtHostNotebookRenderers=y}),define(fe[69],me([0,1,5,3,6,22,4,14]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends C.Disposable{constructor(d,w,D,I,b){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=b,this._id=b.$register(this.name,w,D,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?y.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(w=>this._proxy.$clear(w,d))}show(d,w){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof d=="boolean"?d:w)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class P extends S{constructor(d,w,D){super(d,!1,void 0,w,D)}append(d){super.append(d),this._id.then(w=>this._proxy.$append(w,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class i extends S{constructor(d,w,D){super(d,!0,w,void 0,D)}append(d){throw new Error("Not supported")}}class k{constructor(d,w){this.name=d,this._channel=w}append(d){this._channel.then(w=>w.append(d))}appendLine(d){this._channel.then(w=>w.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,w){this._channel.then(D=>D.show(d,w))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=k;let l=class{constructor(d){this._proxy=d.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d,w){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new P(d,w.identifier.value,this._proxy)}createOutputChannelFromLogFile(d,w){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!w)throw new Error("illegal argument `file`. must not be falsy");return new i(d,w,this._proxy)}};l=Ve([$e(0,_.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(fe[250],me([0,1,17,21,3,6,5,2,7,18,16,49,65]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(d,w,D){const I=d.getProxy(A.MainContext.MainThreadQuickOpen);class b{constructor(a,u){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=u}showQuickPick(a,u,p,E=F.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(a),T=++this._instances,L=I.$show(T,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},E),M={},R=L.then(()=>M);return Promise.race([R,g]).then(W=>{if(W!==M)return g.then(V=>{const N=[];for(let j=0;j<V.length;j++){const U=V[j];let x,z,O,$,B;typeof U=="string"?x=U:(x=U.label,z=U.description,O=U.detail,$=U.picked,B=U.alwaysShow),N.push({label:x,description:z,handle:j,detail:O,picked:$,alwaysShow:B})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{p.onDidSelectItem(V[j])}),I.$setItems(T,N),L.then(j=>{if(typeof j=="number")return V[j];if(Array.isArray(j))return j.map(U=>V[U])})})}).then(void 0,W=>{if(!(0,P.isPromiseCanceledError)(W))return I.$setError(T,W),Promise.reject(W)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,u=F.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,I.$input(a,typeof this._validateInput=="function",u).then(void 0,p=>{if(!(0,P.isPromiseCanceledError)(p))return Promise.reject(p)})}$validateInput(a){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,u=F.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!p)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(g=>g.uri.toString()===p.uri.toString())}createQuickPick(a,u){const p=new s(a,u,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(a){const u=new n(a,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(a,u){const p=this._sessions.get(a);p&&p._fireDidChangeValue(u)}$onDidAccept(a){const u=this._sessions.get(a);u&&u._fireDidAccept()}$onDidChangeActive(a,u){const p=this._sessions.get(a);p instanceof s&&p._fireDidChangeActive(u)}$onDidChangeSelection(a,u){const p=this._sessions.get(a);p instanceof s&&p._fireDidChangeSelection(u)}$onDidTriggerButton(a,u){const p=this._sessions.get(a);p&&p._fireDidTriggerButton(u)}$onDidTriggerItemButton(a,u,p){const E=this._sessions.get(a);E instanceof s&&E._fireDidTriggerItemButton(u,p)}$onDidHide(a){const u=this._sessions.get(a);u&&u._fireDidHide()}}class c{constructor(a,u){this._extensionId=a,this._onDidDispose=u,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((u,p)=>{const E=u===S.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(E,u)}),this.update({buttons:a.map((u,p)=>({...h(u),tooltip:u.tooltip,handle:u===S.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const u=this._handlesToButtons.get(a);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(a){if(!this._disposed){for(const u of Object.keys(a)){const p=a[u];this._pendingUpdate[u]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}c._nextId=1;function o(r){if(r instanceof S.ThemeIcon)return{id:r.id};const a=t(r),u=v(r);return{dark:typeof a=="string"?_.URI.file(a):a,light:typeof u=="string"?_.URI.file(u):u}}function v(r){return typeof r=="object"&&"light"in r?r.light:r}function t(r){return typeof r=="object"&&"dark"in r?r.dark:r}function h(r){const a=o(r.iconPath);let u,p;return"id"in a?p=l.ThemeIcon.asClassName(a):u=a,{iconPath:u,iconClass:p}}class s extends c{constructor(a,u,p){super(a,p);this.enableProposedApi=u,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((u,p)=>{this._handlesToItems.set(p,u),this._itemsToHandles.set(u,p)}),this.update({items:a.map((u,p)=>({label:u.label,description:u.description,handle:p,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons&&this.enableProposedApi?u.buttons.map((E,g)=>({...h(E),tooltip:E.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(a){const u=(0,i.coalesce)(a.map(p=>this._handlesToItems.get(p)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(a){const u=(0,i.coalesce)(a.map(p=>this._handlesToItems.get(p)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(a,u){const p=this._handlesToItems.get(a);if(!p||!p.buttons||!p.buttons.length)return;const E=p.buttons[u];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:p})}}class n extends c{constructor(a,u){super(a,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?k.default.Error:k.default.Ignore})}}return new b(w,D)}e.createExtHostQuickOpen=f}),define(fe[251],me([0,1,2,3,60,6,17,5,16,101,13,26,35,65,15]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(a){if(a)return typeof a.iconPath=="string"?m.URI.file(a.iconPath):m.URI.isUri(a.iconPath)||f.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function D(a,u){if(!a.iconPath&&!u.iconPath)return 0;if(a.iconPath){if(!u.iconPath)return 1}else return-1;const p=typeof a.iconPath=="string"?a.iconPath:m.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,E=typeof u.iconPath=="string"?u.iconPath:m.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,P.comparePaths)(p,E)}function I(a,u){let p=0;if(a.strikeThrough!==u.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==u.faded)return a.faded?1:-1;if(a.tooltip!==u.tooltip)return(a.tooltip||"").localeCompare(u.tooltip||"");if(p=D(a,u),p!==0)return p;if(a.light&&u.light)p=D(a.light,u.light);else{if(a.light)return 1;if(u.light)return-1}if(p!==0)return p;if(a.dark&&u.dark)p=D(a.dark,u.dark);else{if(a.dark)return 1;if(u.dark)return-1}return p}function b(a,u){if(a.command!==u.command)return a.command<u.command?-1:1;if(a.title!==u.title)return a.title<u.title?-1:1;if(a.tooltip!==u.tooltip){if(a.tooltip!==void 0&&u.tooltip!==void 0)return a.tooltip<u.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(a.arguments===u.arguments)return 0;if(a.arguments)if(u.arguments){if(a.arguments.length!==u.arguments.length)return a.arguments.length-u.arguments.length}else return 1;else return-1;for(let p=0;p<a.arguments.length;p++){const E=a.arguments[p],g=u.arguments[p];if(E!==g)return E<g?-1:1}return 0}function c(a,u){let p=(0,P.comparePaths)(a.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(p!==0)return p;if(a.command&&u.command)p=b(a.command,u.command);else{if(a.command)return 1;if(u.command)return-1}if(p!==0)return p;if(a.decorations&&u.decorations)p=I(a.decorations,u.decorations);else{if(a.decorations)return 1;if(u.decorations)return-1}return p}function o(a,u){for(let p=0;p<a.length;p++)if(a[p]!==u[p])return!1;return!0}function v(a,u){return a.command===u.command&&a.title===u.title&&a.tooltip===u.tooltip&&(a.arguments&&u.arguments?o(a.arguments,u.arguments):a.arguments===u.arguments)}function t(a,u){return(0,S.equals)(a,u,v)}class h{constructor(u,p,E){this._extension=u,this._proxy=p,this._sourceControlHandle=E,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,l.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,p){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,p)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=h;class s{constructor(u,p,E,g,T){this._proxy=u,this._commands=p,this._sourceControlHandle=E,this._id=g,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,p){const E=this._resourceStatesCommandsMap.get(u);return E?(0,A.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(c),E=(0,S.sortedDiff)(this._resourceSnapshot,u,c).map(L=>{const M=L.toInsert.map(R=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,R);const V=R.resourceUri;let N;if(R.command)if(R.command.command==="vscode.open"||R.command.command==="vscode.diff"){const de=new y.DisposableStore;N=this._commands.converter.toInternal(R.command,de),this._resourceStatesDisposablesMap.set(W,de)}else this._resourceStatesCommandsMap.set(W,R.command);const j=w(R.decorations),U=R.decorations&&w(R.decorations.light)||j,x=R.decorations&&w(R.decorations.dark)||j,z=[U,x],O=R.decorations&&R.decorations.tooltip||"",$=R.decorations&&!!R.decorations.strikeThrough,B=R.decorations&&!!R.decorations.faded,X=R.contextValue||"";return{rawResource:[W,V,z,O,$,B,X,N],handle:W}});return{start:L.start,deleteCount:L.deleteCount,toInsert:M}}),g=E.map(({start:L,deleteCount:M,toInsert:R})=>[L,M,R.map(W=>W.rawResource)]),T=E.reverse();for(const{start:L,deleteCount:M,toInsert:R}of T){const W=R.map(N=>N.handle),V=this._handlesSnapshot.splice(L,M,...W);for(const N of V)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=u,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class n{constructor(u,p,E,g,T,L){this._extension=u,this._proxy=p,this._commands=E,this._id=g,this._label=T,this._rootUri=L,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new y.MutableDisposable,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new h(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,T,L)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=u;const p=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(u){(0,l.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new y.DisposableStore,this._actionButton=u;const p=u!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:p??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&t(this._statusBarCommands,u))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=u;const p=(u||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(u,p){const E=new s(this._proxy,this._commands,this.handle,u,p),g=F.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,g),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const u=[],p=[];for(const[E,g]of this.createdResourceGroups){g.dispose();const T=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});F.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),T.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),u.push([E.handle,E.id,E.label,E.features]);const L=E._takeResourceStateSnapshot();L.length>0&&p.push([E.handle,L]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,u,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(p=>{const E=p._takeResourceStateSnapshot();E.length!==0&&u.push([p.handle,E])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let r=class Bn{constructor(u,p,E){this._commands=p,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=u.getProxy(_.MainContext.MainThreadSCM),this._telemetry=u.getProxy(_.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const T=this._sourceControls.get(g.sourceControlHandle);if(!T)return g;const L=T.getResourceGroup(g.groupHandle);return L?L.getResourceState(g.handle):g}else if(g&&g.$mid===4){const T=this._sourceControls.get(g.sourceControlHandle);return T?T.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const T=this._sourceControls.get(g.handle);return T||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,p,E,g){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,p,E,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const T=Bn._handlePool++,L=new n(u,this._proxy,this._commands,p,E,g);this._sourceControls.set(T,L);const M=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(u.identifier))||[];return M.push(L),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(u.identifier),M),L}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const p=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(u.identifier)),E=p&&p[p.length-1];return E&&E.inputBox}$provideOriginalResource(u,p,E){const g=m.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,g.toString());const T=this._sourceControls.get(u);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(g,E)).then(L=>L||null)}$onInputBoxValueChange(u,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const E=this._sourceControls.get(u);return E&&E.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(u,p,E,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,p,E);const T=this._sourceControls.get(u);if(!T)return Promise.resolve(void 0);const L=T.getResourceGroup(p);return L?L.$executeResourceCommand(E,g):Promise.resolve(void 0)}$validateInput(u,p,E){this.logService.trace("ExtHostSCM#$validateInput",u);const g=this._sourceControls.get(u);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>g.inputBox.validateInput(p,E)).then(T=>{if(!T)return Promise.resolve(void 0);const L=d.MarkdownString.fromStrict(T.message);return L?Promise.resolve([L,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};r._handlePool=0,r=Ve([$e(2,i.ILogService)],r),e.ExtHostSCM=r});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[252],me([0,1,7,5,168,6,15,12]),function(Y,e,m,F,C,y,A,_){"use strict";var S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(d,w,D,I,b=m.StatusBarAlignment.Left,c){S.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,ot(this,S,d,"f"),ot(this,P,w,"f"),this._entryId=i.ID_GEN++,this._extension=D,this._id=I,this._alignment=b,this._priority=this.validatePriority(c)}validatePriority(d){if(!!(0,_.isNumber)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!i.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Oe(this,P,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Oe(this,P,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let w;this._name?w=this._name:w=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,d,w,this._text,I,this._command?.internal,D,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,S=new WeakMap,P=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const w={message:d};return this._messages.unshift(w),this._update(),new m.Disposable(()=>{const D=this._messages.indexOf(w);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(d,w){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new k(this)}createStatusBarEntry(d,w,D,I){return new i(this._proxy,this._commands,d,w,D,I)}setStatusBarMessage(d,w){const D=this._statusMessage.setMessage(d);let I;return typeof w=="number"?I=setTimeout(()=>D.dispose(),w):typeof w!="undefined"&&w.then(()=>D.dispose(),()=>D.dispose()),new m.Disposable(()=>{D.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=l}),define(fe[92],me([0,1,5,3,4]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(_){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=_.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(_,S){this._proxy.$registerExtensionStorageKeysToSync(_,S)}getValue(_,S,P){return this._proxy.$getValue(_,S).then(i=>i||P)}setValue(_,S,P){return this._proxy.$setValue(_,S,P)}$acceptValue(_,S,P){this._onDidChangeStorage.fire({shared:_,key:S,value:P})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,27,13,91,2]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let _=class{constructor(P,i,k){this._logService=i,this._extHostFileSystem=k,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(P){return A.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,i=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};_=Ve([$e(0,F.IExtHostInitDataService),$e(1,C.ILogService),$e(2,y.IExtHostConsumerFileSystem)],_),e.ExtensionStoragePaths=_}),define(fe[33],me([0,1,3,5,4,2,14,6,7,169,18,216,21,32,197,65,12]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class I{constructor(r,a,u,p){this._proxy=r,this._id=a,this._creationOptions=u,this._name=p,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(g,T=!0){E._checkDisposed(),E._proxy.$sendText(E._id,g,T)},show(g){E._checkDisposed(),E._proxy.$show(E._id,g)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(r,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,D.withNullAsUndefined)(r.shellPath),shellArgs:(0,D.withNullAsUndefined)(r.shellArgs),cwd:(0,D.withNullAsUndefined)(r.cwd),env:(0,D.withNullAsUndefined)(r.env),icon:(0,D.withNullAsUndefined)(h(r.iconPath)),color:w.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,D.withNullAsUndefined)(r.message),strictEnv:(0,D.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,D.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,D.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,D.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(r.location,a?.resolvedExtHostIdentifier)})}async createExtensionTerminal(r,a,u,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:w.ThemeColor.isThemeColor(p)?p.id:void 0,location:this._serializeParentTerminal(r,a)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(r,a){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in r?{viewColumn:r.viewColumn,preserveFocus:r.preserveFocus}:void 0:r}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,a){return r===this._cols&&a===this._rows||r===0||a===0?!1:(this._cols=r,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=I;class b{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(r){return Promise.resolve("")}async updateProperty(r,a){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,a){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:a})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose&&this._pty.onDidClose((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(a=>this._onProcessOverrideDimensions.fire(a&&{cols:a.columns,rows:a.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(a=>this._onProcessTitleChanged.fire(a)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=b;let c=1,o=class extends _.Disposable{constructor(r,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[u,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,a){const u=new I(this._proxy,(0,f.generateUuid)(),r,r.name),p=new b(r.pty);return u.createExtensionTerminal(r.location,this._serializeParentTerminal(r,a).resolvedExtHostIdentifier,h(r.iconPath),s(r.color)).then(E=>{const g=this._setupExtHostProcessListeners(E,p);this._terminalProcessDisposables[E]=g}),this._terminals.push(u),u.value}_serializeParentTerminal(r,a){if(a=a||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const u=r.location.parentTerminal;if(u){const p=this._terminals.find(E=>E.value===u);p&&(a.resolvedExtHostIdentifier=p._id)}}else r.location&&typeof r.location!="object"?a.location=r.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(r,a){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const p=new b(a),E=this._setupExtHostProcessListeners(r,p);this._terminalProcessDisposables[r]=E}async $acceptActiveTerminalChanged(r){const a=this._activeTerminal;if(r===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(r);u&&(this._activeTerminal=u,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,a){const u=this._getTerminalById(r);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:a})}async $acceptTerminalDimensions(r,a,u){const p=this._getTerminalById(r);p&&p.setDimensions(a,u)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(r,a,u){this._terminalProcesses.get(r)?.resize(a,u)}async $acceptTerminalTitleChange(r,a){const u=this._getTerminalById(r);u&&(u.name=a)}async $acceptTerminalClosed(r,a){const u=this._getTerminalObjectIndexById(this._terminals,r);if(u!==null){const p=this._terminals.splice(u,1)[0];p.setExitCode(a),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(r,a,u,p){if(a){const T=this._getTerminalObjectIndexById(this._terminals,a);if(T!==null){this._terminals[T]._id=r,this._onDidOpenTerminal.fire(this.terminals[T]),this._terminals[T].isOpen=!0;return}}const E={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:y.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},g=new I(this._proxy,r,E,u);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(r,a){const u=this._getTerminalById(r);u&&u._setProcessId(a)}async $startExtensionTerminal(r,a){const u=this._getTerminalById(r);if(!u)return{message:(0,P.localize)(0,null,r)};u.isOpen||await new Promise(E=>{const g=this.onDidOpenTerminal(async T=>{T===u.value&&(g.dispose(),E())})});const p=this._terminalProcesses.get(r);p?p.startSendingEvents(a):this._extensionTerminalAwaitingStart[r]={initialDimensions:a}}_setupExtHostProcessListeners(r,a){const u=new _.DisposableStore;u.add(a.onProcessReady(E=>this._proxy.$sendProcessReady(r,E.pid,E.cwd))),u.add(a.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(r,E))),this._bufferer.startBuffering(r,a.onProcessData),u.add(a.onProcessExit(E=>this._onProcessExit(r,E))),a.onProcessOverrideDimensions&&u.add(a.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(r,E))),this._terminalProcesses.set(r,a);const p=this._extensionTerminalAwaitingStart[r];return p&&a instanceof b&&(a.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),u}$acceptProcessAckDataEvent(r,a){this._terminalProcesses.get(r)?.acknowledgeDataEvent(a)}$acceptProcessInput(r,a){this._terminalProcesses.get(r)?.input(a)}$acceptTerminalInteraction(r){const a=this._getTerminalById(r);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(r,a,u){try{this._terminalProcesses.get(r)?.resize(a,u)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(r,a){this._terminalProcesses.get(r)?.shutdown(a)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(r,a))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(a=>this._proxy.$sendProcessCwd(r,a))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,a,u){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,u),this._proxy.$registerProfileProvider(a,r.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(r,a){const u=new l.CancellationTokenSource().token,p=await this._profileProviders.get(r)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,a);return}this.createTerminalFromOptions(p.options,a)}}async $provideLinks(r,a){const u=this._getTerminalById(r);if(!u)return[];this._terminalLinkCache.delete(r);const p=this._terminalLinkCancellationSource.get(r);p&&p.dispose(!0);const E=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,E);const g=[],T={terminal:u.value,line:a},L=[];for(const W of this._linkProviders)L.push(new Promise(async V=>{E.token.onCancellationRequested(()=>V({provider:W,links:[]}));const N=await W.provideTerminalLinks(T,E.token)||[];E.token.isCancellationRequested||V({provider:W,links:N})}));const M=await Promise.all(L);if(E.token.isCancellationRequested)return[];const R=new Map;for(const W of M)W&&W.links.length>0&&g.push(...W.links.map(V=>{const N={id:c++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return R.set(N.id,{provider:W.provider,link:V}),N}));return this._terminalLinkCache.set(r,R),g}$activateLink(r,a){const u=this._terminalLinkCache.get(r)?.get(a);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(r,a){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const u=this._terminalProcessDisposables[r];u&&(u.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,a)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,a){const u=this._getTerminalObjectIndexById(r,a);return u!==null?r[u]:null}_getTerminalObjectIndexById(r,a){let u=null;return r.some((p,E)=>p._id===a?(u=E,!0):!1),u}getEnvironmentVariableCollection(r){let a=this._environmentVariableCollections.get(r.identifier.value);return a||(a=new v,this._setEnvironmentVariableCollection(r.identifier.value,a)),a}_syncEnvironmentVariableCollection(r,a){const u=(0,k.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(r,a.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(r){r.forEach(a=>{const u=a[0],p=new v(a[1]);this._setEnvironmentVariableCollection(u,p)})}$acceptDefaultProfile(r,a){this._defaultProfile=r,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(r,a){this._environmentVariableCollections.set(r,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,a)})}};o=Ve([$e(1,A.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class v{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,a){this._setIfDiffers(r,{value:a,type:S.EnvironmentVariableMutatorType.Replace})}append(r,a){this._setIfDiffers(r,{value:a,type:S.EnvironmentVariableMutatorType.Append})}prepend(r,a){this._setIfDiffers(r,{value:a,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,a){const u=this.map.get(r);(!u||u.value!==a.value||u.type!==a.type)&&(this.map.set(r,a),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,a){this.map.forEach((u,p)=>r.call(a,p,u,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends o{constructor(r){super(!1,r)}createTerminal(r,a,u){throw new i.NotSupportedError}createTerminalFromOptions(r,a){throw new i.NotSupportedError}};t=Ve([$e(0,A.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function h(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return w.ThemeColor.isThemeColor(n)?n:void 0}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[253],me([0,1,16,22,21,3,76,48,6,25,12,32,5,14,66,15,7,224,129,89]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(L,M){this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(l.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new h(this.proxy),M.registerArgumentProcessor({processArgument:R=>R?.$mid===13?w.TestItem.toItemFromContext(R):R})}createTestController(L,M){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const R=new S.DisposableStore,W=R.add(new I.SingleUseTestCollection(L));W.root.label=M;const V=new Map,N=this.proxy,j={items:W.root.children,get label(){return M},set label(x){M=x,W.root.label=x,N.$updateControllerLabel(L,M)},get id(){return L},createRunProfile:(x,z,O,$,B)=>{let X=(0,_.hash)(x);for(;V.has(X);)X++;const Q=new E(this.proxy,L,X,x,z,O,$,B);return V.set(X,Q),Q},createTestItem(x,z,O){return new d.TestItemImpl(L,x,z,O)},createTestRun:(x,z,O=!0)=>this.runTracker.createTestRun(L,W,x,z,O),set resolveHandler(x){W.resolveHandler=x},get resolveHandler(){return W.resolveHandler},dispose:()=>{R.dispose()}};j.createRunConfiguration=j.createRunProfile,N.$registerTestController(L,M),R.add((0,S.toDisposable)(()=>N.$unregisterTestController(L)));const U={controller:j,collection:W,profiles:V};return this.controllers.set(L,U),R.add((0,S.toDisposable)(()=>this.controllers.delete(L))),R.add(W.onDidGenerateDiff(x=>N.$publishDiff(L,x))),j}createTestObserver(){return this.observer.checkout()}async runTests(L,M=C.CancellationToken.None){const R=s(L);if(!R)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(R.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(V=>V.id)??[W.collection.root.id],profileGroup:g[R.kind],profileId:R.profileId,controllerId:R.controllerId}],exclude:L.exclude?.map(V=>V.id)},M)}$provideFileCoverage(L,M,R){return(0,m.mapFind)(this.runTracker.trackers,V=>V.id===L?V.getCoverage(M):void 0)?.provideFileCoverage(R)??Promise.resolve([])}$resolveFileCoverage(L,M,R,W){return(0,m.mapFind)(this.runTracker.trackers,N=>N.id===L?N.getCoverage(M):void 0)?.resolveFileCoverage(R,W)??Promise.resolve([])}$configureRunProfile(L,M){this.controllers.get(L)?.profiles.get(M)?.configureHandler?.()}$publishTestResults(L){this.results=Object.freeze(L.map(M=>(0,P.deepFreeze)(w.TestResults.to(M))).concat(this.results).sort((M,R)=>R.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,M){const R=this.controllers.get(c.TestId.fromString(L).controllerId)?.collection;R&&(await R.expand(L,M<0?Infinity:M),R.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,M){const R=this.controllers.get(L.controllerId);if(!R)return;const{collection:W,profiles:V}=R,N=V.get(L.profileId);if(!N)return;const j=L.testIds.map(O=>W.tree.get(O)).filter(i.isDefined),U=L.excludeExtIds.map(O=>R.collection.tree.get(O)).filter(i.isDefined).filter(O=>j.some($=>$.fullId.compare(O.fullId)===2));if(!j.length)return;const x=new D.TestRunRequest(j.some(O=>O.actual instanceof d.TestItemRootImpl)?void 0:j.map(O=>O.actual),U.map(O=>O.actual),N),z=this.runTracker.prepareForMainThreadTestRun(x,n.fromInternal(L,R.collection),M);try{await N.runHandler(x,M)}finally{z.isRunning&&!M.isCancellationRequested&&await y.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};v=Ve([$e(0,f.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends S.Disposable{constructor(L,M,R){super();this.dto=L,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new y.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(R)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:W}of this.tasks.values())W.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const M=this.dto.id,R=this.dto.controllerId,W=(0,k.generateUuid)(),V=new r(this.proxy,M,W),N=z=>(O,...$)=>{if(U){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),z(O,...$))},j=(z,O)=>{const $=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(z.uri&&z.range){const B={range:w.Range.from(z.range),uri:z.uri};for(const X of $)X.location=X.location||B}this.proxy.$appendTestMessagesInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),$)};let U=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return V.coverageProvider},set coverageProvider(z){V.coverageProvider=z},enqueued:N(z=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),1)}),skipped:N(z=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),5)}),started:N(z=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),2)}),errored:N((z,O,$)=>{j(z,O),this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),6,$)}),failed:N((z,O,$)=>{j(z,O),this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),4,$)}),passed:N((z,O)=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,O)}),appendOutput:(z,O,$)=>{U||($&&(this.dto.isIncluded($)?this.ensureTestIsKnown($):$=void 0),this.proxy.$appendOutputToRun(M,W,F.VSBuffer.fromString(z),O&&w.location.from(O),$&&c.TestId.fromExtHostTestItem($,R).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(M,W),this.tasks.delete(W),this.isRunning||this.dispose())}};return this.tasks.set(W,{run:x,coverage:V}),this.proxy.$startedTestRunTask(M,{id:W,name:L,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof d.TestItemImpl))throw new d.InvalidTestItemError(L.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const M=[],R=this.dto.colllection.root;for(;;){const W=w.TestItem.from(L);if(M.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),L===R))break;L=L.parent||R}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class h{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,M,R){return this.getTracker(L,M,R)}cancelRunById(L){for(const M of this.tracked.values())if(M.id===L){M.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,M,R,W,V){const N=this.tracked.get(R);if(N)return N.createRun(W);const j=n.fromPublic(L,M,R,V),U=s(R);this.proxy.$startedExtensionTestRun({controllerId:L,profile:U&&{group:g[U.kind],id:U.profileId},exclude:R.exclude?.map(z=>z.id)??[],id:j.id,include:R.include?.map(z=>z.id)??[M.root.id],persist:V});const x=this.getTracker(R,j);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),x.createRun(W)}getTracker(L,M,R){const W=new t(M,this.proxy,R);return this.tracked.set(L,W),W.onEnd(()=>this.tracked.delete(L)),W}}e.TestRunCoordinator=h;const s=T=>{if(!!T.profile){if(!(T.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class n{constructor(L,M,R,W,V,N){this.controllerId=L,this.id=M,this.isPersisted=V,this.colllection=N,this.includePrefix=R.map(j=>j+"\0"),this.excludePrefix=W.map(j=>j+"\0")}static fromPublic(L,M,R,W){return new n(L,(0,k.generateUuid)(),R.include?.map(V=>c.TestId.fromExtHostTestItem(V,L).toString())??[L],R.exclude?.map(V=>c.TestId.fromExtHostTestItem(V,L).toString())??[],W,M)}static fromInternal(L,M){return new n(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,M)}isIncluded(L){const M=c.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const R of this.excludePrefix)if(M===R||M.startsWith(R))return!1;for(const R of this.includePrefix)if(M===R||M.startsWith(R))return!0;return!1}}e.TestRunDto=n;class r{constructor(L,M,R){this.proxy=L,this.runId=M,this.taskId=R}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(L,M){const R=await this.fileCoverage;let W=R?.[L];return!this._coverageProvider||!R||!W?[]:(W.detailedCoverage||(W=R[L]=await this._coverageProvider.resolveFileCoverage?.(W,M)??W),W.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class a extends b.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,w.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:M,removed:R}=this;return{get added(){return[...L].map(W=>W.revived)},get updated(){return[...M].map(W=>W.revived)},get removed(){return[...R].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,M){return{...L,revived:w.TestItem.toPlain(L.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=u;class p{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(M=>M.revived)},dispose:(0,A.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class E{constructor(L,M,R,W,V,N,j=!1,U=void 0){this.controllerId=M,this.profileId=R,this._label=W,this.kind=V,this.runHandler=N,this._isDefault=j,this._tag=U,o.set(this,void 0),ot(this,o,L,"f");const x=g[V];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Oe(this,o,"f").$publishTestRunProfile({profileId:R,controllerId:M,tag:U?w.TestTag.namespace(this.controllerId,U.id):null,label:W,group:x,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?w.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Oe(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,o=new WeakMap;const g={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(fe[254],me([0,1,3,16,5,132,15,7]),function(Y,e,m,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const k=this._extHostDocumentsAndEditors.allEditors();return i?k:k.map(l=>l.value)}async showTextDocument(i,k,l){let f;typeof k=="number"?f={position:A.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?f={position:A.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?A.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:f={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(i.uri,f),w=d&&this._extHostDocumentsAndEditors.getEditor(d);if(w)return w.value;throw d?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,k){return new y.TextEditorDecorationType(this._proxy,i,k).value}$acceptEditorPropertiesChanged(i,k){const l=this._extHostDocumentsAndEditors.getEditor(i);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const f=k.selections.selections.map(A.Selection.to);l._acceptSelections(f)}if(k.visibleRanges){const f=F.coalesce(k.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(f)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...k.options,lineNumbers:A.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const f=_.TextEditorSelectionChangeKind.fromValue(k.selections.source),d=k.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:d,kind:f})}if(k.visibleRanges){const f=F.coalesce(k.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:f})}}$acceptEditorPositionData(i){for(const k in i){const l=this._extHostDocumentsAndEditors.getEditor(k);if(!l)throw new Error("Unknown text editor");const f=A.ViewColumn.to(i[k]);l.value.viewColumn!==f&&(l._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:f}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S}),define(fe[255],me([0,1,2,4,5,6,7]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class _{constructor(i,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const f=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(S(f))?.get(l.handle)}return l}})}async $getTimeline(i,k,l,f,d){return this._providers.get(i)?.provideTimeline(m.URI.revive(k),l,f,d)}registerTimelineProvider(i,k,l,f){const d=new y.DisposableStore,w=this.convertTimelineItem(k.id,f,d).bind(this);let D;k.onDidChange&&(D=k.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:k.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:i,onDidChange:void 0,async provideTimeline(b,c,o,v){v?.resetCache&&(d.clear(),I.get(k.id)?.clear());const t=await k.provideTimeline(b,c,o);if(t==null)return;const h=w(b,v);return{...t,source:k.id,items:t.items.map(h)}},dispose(){for(const b of I.values())b.get(k.id)?.clear();D?.dispose(),d.dispose()}})}convertTimelineItem(i,k,l){return(f,d)=>{let w;if(d?.cacheResults){let D=this._itemsBySourceAndUriMap.get(i);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(i,D));const I=S(f);w=D.get(I),w===void 0&&(w=new Map,D.set(I,w))}return D=>{const{iconPath:I,...b}=D,c=`${i}|${D.id??D.timestamp}`;w?.set(c,D);let o,v,t;return D.iconPath&&(I instanceof A.ThemeIcon?t={id:I.id,color:I.color}:m.URI.isUri(I)?(o=I,v=I):{light:o,dark:v}=I),{...b,id:b.id??void 0,handle:c,source:i,command:D.command?k.toInternal(D.command,l):void 0,icon:o,iconDark:v,themeIcon:t,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,y.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=_;function S(P){return P?.toString()}}),define(fe[256],me([0,1,6,10,2,5]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(S){this._openers=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,i,k){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=k.schemes.find(f=>!A.supportedSchemes.has(f));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,i),this._proxy.$registerUriOpener(P,k.schemes,S,k.label),(0,m.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,i){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const l=C.URI.revive(P);return k.canOpenExternalUri(l,i)}async $openUri(S,P,i){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(C.URI.revive(P.resolvedUri),{sourceUri:C.URI.revive(P.sourceUri)},i)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(fe[257],me([0,1,5,2,6,18,26]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class _{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(P,i){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const k=_.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(k,i),this._proxy.$registerUriHandler(k,P),(0,C.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(P,i){const k=this.handlers.get(P);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(i))}catch(l){(0,y.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(P){return F.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=_,_.HandlePool=0});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[71],me([0,1,3,2,182,206,88,5]),function(Y,e,m,F,C,y,A,_){"use strict";var S,P,i,k,l,f,d,w,D,I,b,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(u,p,E,g,T,L,M){S.set(this,void 0),P.set(this,void 0),i.set(this,void 0),k.set(this,void 0),l.set(this,void 0),f.set(this,void 0),d.set(this,""),w.set(this,void 0),D.set(this,!1),I.set(this,!1),b.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new m.Emitter),this._onDidDispose=Oe(this,c,"f").event,ot(this,S,u,"f"),ot(this,P,p,"f"),ot(this,w,E,"f"),ot(this,k,g,"f"),ot(this,l,T,"f"),ot(this,f,L,"f"),ot(this,b,v(L),"f"),ot(this,i,M,"f")}dispose(){ot(this,D,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return ot(this,I,!0,"f"),(0,A.asWebviewUri)(u,Oe(this,k,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,d,"f")}set html(u){this.assertNotDisposed(),Oe(this,d,"f")!==u&&(ot(this,d,u,"f"),!Oe(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(ot(this,I,!0,"f"),Oe(this,i,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,P,"f").$setHtml(Oe(this,S,"f"),u))}get options(){return this.assertNotDisposed(),Oe(this,w,"f")}set options(u){this.assertNotDisposed(),Oe(this,P,"f").$setOptions(Oe(this,S,"f"),s(Oe(this,f,"f"),Oe(this,l,"f"),u)),ot(this,w,u,"f")}async postMessage(u){if(Oe(this,D,"f"))return!1;const p=(0,y.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:Oe(this,b,"f")});return Oe(this,P,"f").$postMessage(Oe(this,S,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,S=new WeakMap,P=new WeakMap,i=new WeakMap,k=new WeakMap,l=new WeakMap,f=new WeakMap,d=new WeakMap,w=new WeakMap,D=new WeakMap,I=new WeakMap,b=new WeakMap,c=new WeakMap;function v(a){try{const u=(0,C.normalizeVersion)((0,C.parseVersion)(a.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(u,p,E,g,T){this.initData=p,this.workspace=E,this._logService=g,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=u.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(u,p,...E){const g=this.getWebview(u);if(g){const{message:T}=(0,y.deserializeWebviewMessage)(p,E);g._onMessageEmitter.fire(T)}}$onMissingCsp(u,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,p,E){const g=new o(u,this._webviewProxy,n(p),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(u,g),g._onDidDispose(()=>{this._webviews.delete(u)}),g}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=t;function h(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=h;function s(a,u,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||r(a,u)}}e.serializeWebviewOptions=s;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(u=>F.URI.from(u))}}e.reviveOptions=n;function r(a,u){return[...(u?.getWorkspaceFolders()||[]).map(p=>p.uri),a.extensionLocation]}}),define(fe[258],me([0,1,21,48,6,10,23,2,15,71,87,5,7]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,h){this.document=t,this._storagePath=h,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,h){await this.getEdit(t).undo(),h||this.disposeBackup()}async redo(t,h){await this.getEdit(t).redo(),h||this.disposeBackup()}disposeEdits(t){for(const h of t)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const h=this._edits.get(t,0);if(!h)throw new Error("No edit found");return h}}class d{constructor(){this._documents=new Map}get(t,h){return this._documents.get(this.key(t,h))}add(t,h,s){const n=this.key(t,h.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${h.uri}`);const r=new f(h,s);return this._documents.set(n,r),r}delete(t,h){const s=this.key(t,h.uri);this._documents.delete(s)}key(t,h){return`${t}@@@${h}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class D{constructor(){this._providers=new Map}addTextProvider(t,h,s){return this.add(0,t,h,s)}addCustomProvider(t,h,s){return this.add(1,t,h,s)}get(t){return this._providers.get(t)}add(t,h,s,n){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:t,extension:s,provider:n}),new l.Disposable(()=>this._providers.delete(h))}}class I{constructor(t,h,s,n,r){this._extHostDocuments=h,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=r,this._editorProviders=new D,this._documents=new d,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,h,s,n){const r=new C.DisposableStore;return b(s)?(r.add(this._editorProviders.addTextProvider(h,t,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),h,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(r.add(this._editorProviders.addCustomProvider(h,t,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(a=>{const u=this.getCustomDocumentEntry(h,a.document.uri);if(c(a)){const p=u.addEdit(a);this._proxy.$onDidEdit(a.document.uri,h,p,a.label)}else this._proxy.$onContentChange(a.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),h,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(r,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(t,h,s,n,r){const a=this._editorProviders.get(h);if(!a)throw new Error(`No provider found for '${h}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${h}'`);const u=_.URI.revive(t),p=await a.provider.openCustomDocument(u,{backupId:s,untitledDocumentData:n?.buffer},r);let E;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(h,p,E),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(t,h){const s=this._editorProviders.get(h);if(!s)throw new Error(`No provider found for '${h}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${h}'`);const n=_.URI.revive(t),{document:r}=this.getCustomDocumentEntry(h,n);this._documents.delete(h,r),r.dispose()}async $resolveWebviewEditor(t,h,s,n,r,a){const u=this._editorProviders.get(s);if(!u)throw new Error(`No provider found for '${s}'`);const p=S.ViewColumn.to(r),E=this._extHostWebview.createNewWebview(h,n.webviewOptions,u.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(h,s,n.title,p,n.panelOptions,E),T=_.URI.revive(t);switch(u.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,T);return u.provider.resolveCustomEditor(L,g,a)}case 0:{const L=this._extHostDocuments.getDocument(T);return u.provider.resolveCustomTextEditor(L,g,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,h,s){this.getCustomDocumentEntry(h,t).disposeEdits(s)}async $onMoveCustomEditor(t,h,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(t);if(!r)throw new Error("No webview found");const a=_.URI.revive(h),u=this._extHostDocuments.getDocument(a);await n.provider.moveCustomTextEditor(u,r,m.CancellationToken.None)}async $undo(t,h,s,n){return this.getCustomDocumentEntry(h,t).undo(s,n)}async $redo(t,h,s,n){return this.getCustomDocumentEntry(h,t).redo(s,n)}async $revert(t,h,s){const n=this.getCustomDocumentEntry(h,t);await this.getCustomEditorProvider(h).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,h,s){const n=this.getCustomDocumentEntry(h,t);await this.getCustomEditorProvider(h).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,h,s,n){const r=this.getCustomDocumentEntry(h,t);return this.getCustomEditorProvider(h).saveCustomDocumentAs(r.document,_.URI.revive(s),n)}async $backup(t,h,s){const n=this.getCustomDocumentEntry(h,t),a=await this.getCustomEditorProvider(h).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(a),a.id}getCustomDocumentEntry(t,h){const s=this._documents.get(t,_.URI.revive(h));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function b(v){return typeof v.resolveCustomTextEditor=="function"}function c(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function o(v){const t=v.scheme===y.Schemas.file||v.scheme===y.Schemas.untitled?v.fsPath:v.toString();return(0,F.hash)(t)+""}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[259],me([0,1,3,6,2,32,15,71,5,7]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";var i,k,l,f,d,w,D,I,b,c,o,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends F.Disposable{constructor(a,u,p,E,g,T,L){super();i.set(this,void 0),k.set(this,void 0),l.set(this,void 0),f.set(this,void 0),d.set(this,void 0),w.set(this,void 0),D.set(this,void 0),I.set(this,void 0),b.set(this,!0),c.set(this,!0),o.set(this,!1),v.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,v,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,ot(this,i,a,"f"),ot(this,k,u,"f"),ot(this,l,p,"f"),ot(this,d,T,"f"),ot(this,I,g,"f"),ot(this,w,E,"f"),ot(this,f,L,"f")}dispose(){Oe(this,o,"f")||(ot(this,o,!0,"f"),Oe(this,v,"f").fire(),Oe(this,k,"f").$disposeWebview(Oe(this,i,"f")),Oe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,l,"f")}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(a){this.assertNotDisposed(),Oe(this,w,"f")!==a&&(ot(this,w,a,"f"),Oe(this,k,"f").$setTitle(Oe(this,i,"f"),a))}get iconPath(){return this.assertNotDisposed(),Oe(this,D,"f")}set iconPath(a){this.assertNotDisposed(),Oe(this,D,"f")!==a&&(ot(this,D,a,"f"),Oe(this,k,"f").$setIconPath(Oe(this,i,"f"),C.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Oe(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,I,"f")=="number"&&Oe(this,I,"f")<0))return Oe(this,I,"f")}get active(){return this.assertNotDisposed(),Oe(this,c,"f")}get visible(){return this.assertNotDisposed(),Oe(this,b,"f")}_updateViewState(a){Oe(this,o,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(ot(this,c,a.active,"f"),ot(this,b,a.visible,"f"),ot(this,I,a.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(a,u){this.assertNotDisposed(),Oe(this,k,"f").$reveal(Oe(this,i,"f"),{viewColumn:a?A.ViewColumn.from(a):void 0,preserveFocus:!!u})}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,k=new WeakMap,l=new WeakMap,f=new WeakMap,d=new WeakMap,w=new WeakMap,D=new WeakMap,I=new WeakMap,b=new WeakMap,c=new WeakMap,o=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(a,u,p){this.webviews=u,this.workspace=p,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(a,u,p,E,g={}){const T=typeof E=="object"?E.viewColumn:E,L={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof E=="object"&&!!E.preserveFocus},M=(0,_.shouldSerializeBuffersForPostMessage)(a),R=s.newHandle();this._proxy.$createWebviewPanel((0,_.toExtensionData)(a),R,u,{title:p,panelOptions:n(g),webviewOptions:(0,_.serializeWebviewOptions)(a,this.workspace,g),serializeBuffersForPostMessage:M},L);const W=this.webviews.createNewWebview(R,g,a);return this.createNewWebviewPanel(R,u,p,T,g,W)}$onDidChangeWebviewPanelViewStates(a){const u=Object.keys(a);u.sort((p,E)=>{const g=a[p],T=a[E];return g.active?1:T.active?-1:+g.visible-+T.visible});for(const p of u){const E=this.getWebviewPanel(p);if(!E)continue;const g=a[p];E._updateViewState({active:g.active,visible:g.visible,viewColumn:A.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,u,p){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:p,extension:a}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,_.shouldSerializeBuffersForPostMessage)(a)}),new P.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(a,u,p,E){const g=this._serializers.get(u);if(!g)throw new Error(`No serializer found for '${u}'`);const{serializer:T,extension:L}=g,M=this.webviews.createNewWebview(a,p.webviewOptions,L),R=this.createNewWebviewPanel(a,u,p.title,E,p.panelOptions,M);await T.deserializeWebviewPanel(R,p.state)}createNewWebviewPanel(a,u,p,E,g,T){const L=new h(a,this._proxy,u,p,E,g,T);return this._webviewPanels.set(a,L),L}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=s;function n(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[260],me([0,1,3,6,71,5,7]),function(Y,e,m,F,C,y,A){"use strict";var _,S,P,i,k,l,f,d,w,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends F.Disposable{constructor(o,v,t,h,s,n){super();_.set(this,void 0),S.set(this,void 0),P.set(this,void 0),i.set(this,void 0),k.set(this,!1),l.set(this,void 0),f.set(this,void 0),d.set(this,void 0),w.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,w,"f").event,D.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,D,"f").event,ot(this,P,t,"f"),ot(this,f,h,"f"),ot(this,_,o,"f"),ot(this,S,v,"f"),ot(this,i,s,"f"),ot(this,l,n,"f")}dispose(){Oe(this,k,"f")||(ot(this,k,!0,"f"),Oe(this,D,"f").fire(),Oe(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(o){this.assertNotDisposed(),Oe(this,f,"f")!==o&&(ot(this,f,o,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,_,"f"),o))}get description(){return this.assertNotDisposed(),Oe(this,d,"f")}set description(o){this.assertNotDisposed(),Oe(this,d,"f")!==o&&(ot(this,d,o,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,_,"f"),o))}get visible(){return Oe(this,l,"f")}get webview(){return Oe(this,i,"f")}get viewType(){return Oe(this,P,"f")}_setVisible(o){o===Oe(this,l,"f")||Oe(this,k,"f")||(ot(this,l,o,"f"),Oe(this,w,"f").fire())}show(o){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,_,"f"),!!o)}assertNotDisposed(){if(Oe(this,k,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,S=new WeakMap,P=new WeakMap,i=new WeakMap,k=new WeakMap,l=new WeakMap,f=new WeakMap,d=new WeakMap,w=new WeakMap,D=new WeakMap;class b{constructor(o,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,v,t,h){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(o),v,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(o,v,t,h,s){const n=this._viewProviders.get(v);if(!n)throw new Error(`No view provider found for '${v}'`);const{provider:r,extension:a}=n,u=this._extHostWebview.createNewWebview(o,{},a),p=new I(o,this._proxy,v,t,u,!0);this._webviewViews.set(o,p),await r.resolveWebviewView(p,{state:h},s)}async $onDidChangeWebviewViewVisibility(o,v){this.getWebviewView(o)._setVisible(v)}async $disposeWebviewView(o){const v=this.getWebviewView(o);this._webviewViews.delete(o),v.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const v=this._webviewViews.get(o);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,9,4,14]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class $n{constructor(k){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=k.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,l){let f;if(typeof k=="string"){f=k;try{k=C.URI.parse(k)}catch(d){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,f,l)}async asExternalUri(k,l){if((0,A.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(k,l);return C.URI.from(f)}};P.InitialState={focused:!0},P=Ve([$e(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,_.createDecorator)("IExtHostWindow")}),define(fe[261],me([0,1,8,81,32,40,6,5,2,14]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends A.Disposable{constructor(l,f){super();const d=l.getProxy(_.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async w=>{const D=S.URI.file((0,m.join)((0,F.tmpdir)(),(0,C.generateUuid)()));return await d.$download(w,D),D})}};i=Ve([$e(0,P.IExtHostRpcService),$e(1,y.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[262],me([0,1,2,8,153,28,69,27,14,6,13,117,43]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(I,b,c){this.name=I,this.file=b,this.appender=c}static async create(I,b){const c=await(0,k.createRotatingLogger)(I,b,30*l.ByteSize.MB,1);return c.clearFormatters(),new f(I,b,c)}append(I){this.appender.critical(I)}flush(){this.appender.flush()}}class d extends A.AbstractExtHostOutputChannel{constructor(I,b,c,o){super(I,!1,m.URI.file(b.file),c,o);this._appender=b}append(I){super.append(I),this._appender.append(I),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(I,b){this._appender.flush(),super.show(I,b)}clear(){this._appender.flush(),super.clear()}}let w=class extends A.ExtHostOutputService{constructor(I,b,c){super(I);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(I){if(I){const b=this._channels.get(I);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(I,b){if(I=I.trim(),!I)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(I,b);return c.then(o=>o._id.then(v=>this._channels.set(v,o))),new A.LazyOutputChannel(I,c)}async _doCreateOutChannel(I,b){try{const c=(0,F.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(c)||await y.Promises.mkdir(c,{recursive:!0});const v=`${this._namePool++}-${I.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=m.URI.file((0,F.join)(c,`${v}.log`)),h=await f.create(v,t.fsPath);return new d(I,h,b.identifier.value,this._proxy)}catch(c){return this.logService.error(c),new A.ExtHostPushOutputChannel(I,b.identifier.value,this._proxy)}}};w=Ve([$e(0,S.IExtHostRpcService),$e(1,i.ILogService),$e(2,_.IExtHostInitDataService)],w),e.ExtHostOutputService2=w}),define(fe[263],me([0,1,50,8,2,70,6,10,17]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==_.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const h=t.fsPath;let s=0;do{let n;s===0?n=h:n=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${s}`:`${h}-${s}`,await i(n);const r=F.join(n,"vscode.lock"),a=await d(this._logService,r,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),C.URI.file(n);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function i(o){try{await m.promises.stat(o);return}catch{}try{await m.promises.mkdir(o,{recursive:!0})}catch{}}const k=1e3,l=10*60*1e3;class f extends A.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const h=await w(v,t);(!h||h.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.promises.utimes(t,new Date,new Date)}catch(s){v.error(s),v.info(`Lock '${t}': Could not update mtime.`)}},k)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await m.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function d(o,v,t){try{const s={pid:process.pid,willReleaseAt:0};await m.promises.writeFile(v,JSON.stringify(s),{flag:"wx"})}catch(s){o.error(s)}const h=await w(o,v);return!h||h.pid!==process.pid?t?(o.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),b(o,v)):(o.info(`Lock '${v}': Lock acquired.`),new f(o,v))}async function w(o,v){let t;try{t=await m.promises.readFile(v)}catch(h){return o.error(h),null}try{return JSON.parse(String(t))}catch(h){return o.error(h),null}}async function D(o,v){let t;try{t=await m.promises.stat(v)}catch(h){return o.error(h),0}return t.mtime.getTime()}function I(o){try{return process.kill(o,0),!0}catch(v){return!1}}async function b(o,v){const t=await w(o,v);if(!t)return o.info(`Lock '${v}': Could not read pid of lock holder.`),c(o,v);if(t.willReleaseAt){let a=t.willReleaseAt-Date.now();if(a<5e3){for(a>0?o.info(`Lock '${v}': The lockfile is scheduled to be released in ${a} ms.`):o.info(`Lock '${v}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,S.timeout)(Math.min(100,a)),await D(o,v)===0)return c(o,v);a=t.willReleaseAt-Date.now()}return c(o,v)}}if(!I(t.pid))return o.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),c(o,v);const h=await D(o,v),s=Date.now()-h;if(s<=l)return o.info(`Lock '${v}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;o.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const n=await D(o,v),r=Date.now()-n;return r<=l?(o.info(`Lock '${v}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null):(o.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),c(o,v))}async function c(o,v){o.info(`Lock '${v}': Deleting a stale lock.`);try{await m.promises.unlink(v)}catch(t){}return d(o,v,!0)}}),define(fe[264],me([0,1,32,14,33]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends C.BaseExtHostTerminalService{constructor(_){super(!0,_)}createTerminal(_,S,P){return this.createTerminalFromOptions({name:_,shellPath:S,shellArgs:P})}createTerminalFromOptions(_,S){const P=new C.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),_,_.name);return this._terminals.push(P),P.create(_,this._serializeParentTerminal(_,S)),P.value}};y=Ve([$e(0,F.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(fe[265],me([0,1,5,14,173,6,27,2,39,23,28,7,11,54,3,123,78,13]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(p,E,g){this.remoteAddress=p,this.localAddress=E,this._dispose=g,this._onDispose=new d.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function c(u){const p=u.trim().split(`
`),E=[];return p.forEach(T=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);L&&L.length>=3&&E.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),E.reduce((T,L)=>(T[L.socket]=L,T),{})}e.getSockets=c;function o(...u){const p=[].concat(...u.map(t));return[...new Map(p.filter(E=>E.st==="0A").map(E=>{const g=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:v(g[0]),port:parseInt(g[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=o;function v(u){let p="";if(u.length===8)for(let E=u.length-2;E>=0;E-=2)p+=parseInt(u.substr(E,2),16),E!==0&&(p+=".");else for(let E=u.length-4;E>=0;E-=4)p+=parseInt(u.substr(E,4),16).toString(16),E!==0&&(p+=":");return p}e.parseIpAddress=v;function t(u){const p=u.trim().split(`
`),E=p.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return p.map(T=>T.trim().split(/\s+/).reduce((L,M,R)=>(L[E[R]||R]=M,L),{}))}e.loadConnectionTable=t;function h(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/vs/server/main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function s(u){const p=u.trim().split(`
`),E=[];return p.forEach(g=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(g);T&&T.length>=4&&E.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),E}e.getRootProcesses=s;async function n(u,p,E){const g=E.reduce((L,M)=>(L[M.pid]=M,L),{}),T=[];return u.forEach(({socket:L,ip:M,port:R})=>{const W=p[L]?p[L].pid:void 0,V=W?g[W]?.cmd:void 0;W&&V&&!h(V)&&T.push({host:M,port:R,detail:V,pid:W})}),T}e.findPorts=n;function r(u,p,E){const g=new Map,T=s(p);for(const L of u){const M=E.get(L.port);if(M){g.set(L.port,M);continue}const R=T.find(W=>W.cmd.includes(`${L.port}`));if(R){let W=R,V;do V=T.find(N=>N.ppid===W.pid),V&&(W=V);while(V);g.set(L.port,{host:L.ip,port:L.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else g.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return g}e.tryFindRootPorts=r;let a=class extends y.Disposable{constructor(p,E,g){super();this.logService=g,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new d.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(m.MainContext.MainThreadTunnelService),l.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${E.remoteAddress.host}:${E.remoteAddress.port}.`);const g=await this._proxy.$openTunnel(E,p.displayName);if(g){const T=new b(g.remoteAddress,g.localAddress,()=>this._proxy.$closeTunnel(g.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,E){const g=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(g,{selector:p,provider:E}),this._proxy.$registerPortsAttributesProvider(p,g),new k.Disposable(()=>{this._portAttributesProviders.delete(g),this._proxy.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(p,E,g,T,L){const M=[];for(const W of p){const V=this._portAttributesProviders.get(W);if(!V)return[];M.push(...await Promise.all(E.map(async N=>V.provider.providePortAttributes(N,g,T,L))))}const R=M.filter(W=>!!W);return R.length>0?R.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(p){if(p&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=p;let E=new D.MovingAverage,g;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),L=(await this.findCandidatePorts()).filter(R=>(0,w.isLocalhost)(R.host)||(0,w.isAllInterfaces)(R.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(R=>R.port).join(", ")}`);const M=new Date().getTime()-T;E.update(M),(!g||JSON.stringify(g)!==JSON.stringify(L))&&(g=L,await this._proxy.$onFoundNewCandidates(g)),await new Promise(R=>setTimeout(()=>R(),this.calculateDelay(E.value)))}}async setTunnelExtensionFunctions(p){if(p){if(p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter()),p.tunnelFactory){this._forwardPortProvider=p.tunnelFactory;let E=p.tunnelFeatures?.privacyOptions??[];p.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!p.tunnelFeatures?.elevation,public:!!p.tunnelFeatures?.public,privacyOptions:E})}}else this._forwardPortProvider=void 0;return(0,y.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,E){if(this._extensionTunnels.has(p.host)){const g=this._extensionTunnels.get(p.host);g.has(p.port)&&(E&&g.get(p.port).disposeListener.dispose(),await g.get(p.port).tunnel.dispose(),g.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this._forwardPortProvider(p,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const T=await g;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const L=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:T,disposeListener:L}),f.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(g){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const E=await Promise.all(p.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),g=p.filter((T,L)=>E[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(T=>T.port).join(", ")} to ${g.map(T=>T.port).join(", ")}`),g}async findCandidatePorts(){let p="",E="";try{p=await i.Promises.readFile("/proc/net/tcp","utf8"),E=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const g=o(p,E),T=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,z,O)=>{U(z)})}),L=c(T),M=await i.Promises.readdir("/proc"),R=[];for(let U of M)try{const x=Number(U),z=P.joinPath(_.URI.file("/proc"),U);if((await i.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(x)){const $=await i.Promises.readlink(P.joinPath(z,"cwd").fsPath),B=await i.Promises.readFile(P.joinPath(z,"cmdline").fsPath,"utf8");R.push({pid:x,cwd:$,cmd:B})}}catch(x){}const W=[],V=g.filter(U=>{const x=L[U.socket];return x||W.push(U),x}),N=n(V,L,R);let j;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const U=await new Promise(x=>{(0,S.exec)("ps -F -A -l | grep root",(z,O,$)=>{x(O)})});this._foundRootPorts=r(W,U,this._foundRootPorts),j=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${j.join(", ")}`)}return N.then(U=>j?U.concat(j):U)}};a=Ve([$e(0,F.IExtHostRpcService),$e(1,A.IExtHostInitDataService),$e(2,I.ILogService)],a),e.ExtHostTunnelService=a}),define(fe[266],me([0,1,17,22,21,18,3,6,104,230,55]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(g,T){try{return JSON.stringify(g,T)}catch(L){return"null"}}const f="$$ref$$",d={[f]:-1};class w{constructor(T,L){this.jsonString=T,this.referencedBuffers=L}}function D(g,T=null,L=!1){const M=[];return{jsonString:(L?l:JSON.stringify)(g,(W,V)=>{if(typeof V=="undefined")return d;if(typeof V=="object"){if(V instanceof F.VSBuffer){const N=M.push(V)-1;return{[f]:N}}if(T)return T(W,V)}return V}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=D;function I(g,T,L){return JSON.parse(g,(M,R)=>{if(R){const W=R[f];if(typeof W=="number")return T[W];if(L&&R.$mid===1)return L.transformIncoming(R)}return R})}e.parseJsonAndRestoreBufferRefs=I;function b(g,T){return JSON.stringify(g,T)}function c(g){return g?(T,L)=>L&&L.$mid===1?g.transformOutgoing(L):L:null}var o;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends _.Disposable{constructor(T,L=null,M=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=L,this._uriTransformer=M,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,W=i.ProxyIdentifier.count;R<W;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(y.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,S.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:L,sid:M}=T;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,M)),this._proxies[L]}_createProxy(T,L){let M={get:(R,W)=>(typeof W=="string"&&!R[W]&&W.charCodeAt(0)===36&&(R[W]=(...V)=>this._remoteCall(T,W,V)),W===s?L:R[W])};return new Proxy(Object.create(null),M)}set(T,L){return this._locals[T.nid]=L,L}assertRegistered(T){for(let L=0,M=T.length;L<M;L++){const R=T[L];if(!this._locals[R.nid])throw new Error(`Missing actor ${R.sid} (isMain: ${R.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const L=T.byteLength,M=r.read(T,0),R=M.readUInt8(),W=M.readUInt32();switch(R){case 1:case 2:{let{rpcId:V,method:N,args:j}=u.deserializeRequestJSONArgs(M);this._uriTransformer&&(j=(0,S.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(L,W,V,N,j,R===2);break}case 3:case 4:{let{rpcId:V,method:N,args:j}=u.deserializeRequestMixedArgs(M);this._uriTransformer&&(j=(0,S.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(L,W,V,N,j,R===4);break}case 5:{this._logger&&this._logger.logIncoming(L,W,0,"ack"),this._onDidReceiveAcknowledge(W);break}case 6:{this._receiveCancel(L,W);break}case 7:{this._receiveReply(L,W,void 0);break}case 9:{let V=u.deserializeReplyOKJSON(M);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReply(L,W,V);break}case 10:{const V=u.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(L,W,V);break}case 8:{let V=u.deserializeReplyOKVSBuffer(M);this._receiveReply(L,W,V);break}case 11:{let V=u.deserializeReplyErrError(M);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReplyErr(L,W,V);break}case 12:{this._receiveReplyErr(L,W,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,L,M,R,W,V){this._logger&&this._logger.logIncoming(T,L,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(M)}.${R}(`,W);const N=String(L);let j,U;if(V){const z=new C.CancellationTokenSource;W.push(z.token),j=this._invokeHandler(M,R,W),U=()=>z.cancel()}else j=this._invokeHandler(M,R,W),U=t;this._cancelInvokedHandlers[N]=U;const x=u.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(x.byteLength,L,1,"ack"),this._protocol.send(x),j.then(z=>{delete this._cancelInvokedHandlers[N];const O=u.serializeReplyOK(L,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,L,1,"reply:",z),this._protocol.send(O)},z=>{delete this._cancelInvokedHandlers[N];const O=u.serializeReplyErr(L,z);this._logger&&this._logger.logOutgoing(O.byteLength,L,1,"replyErr:",z),this._protocol.send(O)})}_receiveCancel(T,L){this._logger&&this._logger.logIncoming(T,L,1,"receiveCancel");const M=String(L);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(T,L,M){this._logger&&this._logger.logIncoming(T,L,0,"receiveReply:",M);const R=String(L);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const W=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],W.resolveOk(M)}_receiveReplyErr(T,L,M){this._logger&&this._logger.logIncoming(T,L,0,"receiveReplyErr:",M);const R=String(L);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const W=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let V;M&&(M.$isError?(V=new Error,V.name=M.name,V.message=M.message,V.stack=M.stack):V=M),W.resolveErr(V)}_invokeHandler(T,L,M){try{return Promise.resolve(this._doInvokeHandler(T,L,M))}catch(R){return Promise.reject(R)}}_doInvokeHandler(T,L,M){const R=this._locals[T];if(!R)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(T));let W=R[L];if(typeof W!="function")throw new Error("Unknown method "+L+" on actor "+(0,i.getStringIdentifierForProxy)(T));return W.apply(R,M)}_remoteCall(T,L,M){if(this._isDisposed)return Promise.reject(y.canceled());let R=null;if(M.length>0&&C.CancellationToken.isCancellationToken(M[M.length-1])&&(R=M.pop()),R&&R.isCancellationRequested)return Promise.reject(y.canceled());const W=u.serializeRequestArguments(M,this._uriReplacer),V=++this._lastMessageId,N=String(V),j=new P.LazyPromise;R&&R.onCancellationRequested(()=>{const x=u.serializeCancel(V);this._logger&&this._logger.logOutgoing(x.byteLength,V,0,"cancel"),this._protocol.send(u.serializeCancel(V))}),this._pendingRPCReplies[N]=j,this._onWillSendRequest(V);const U=u.serializeRequest(V,T,L,W,!!R);return this._logger&&this._logger.logOutgoing(U.byteLength,V,0,`request: ${(0,i.getStringIdentifierForProxy)(T)}.${L}(`,M),this._protocol.send(U),j}}e.RPCProtocol=n,k=h,n.UNRESPONSIVE_TIME=3*1e3;class r{constructor(T,L){this._buff=T,this._offset=L}static alloc(T,L,M){let R=new r(F.VSBuffer.alloc(M+1+4),0);return R.writeUInt8(T),R.writeUInt32(L),R}static read(T,L){return new r(T,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,M}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,M}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,L}static sizeMixedArray(T){let L=0;L+=1;for(let M=0,R=T.length;M<R;M++){const W=T[M];switch(L+=1,W.type){case 1:L+=this.sizeLongString(W.value);break;case 2:L+=this.sizeVSBuffer(W.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(W.value);for(let V=0;V<W.buffers.length;++V)L+=this.sizeVSBuffer(W.buffers[V]);break;case 4:break}}return L}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let L=0,M=T.length;L<M;L++){const R=T[L];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let W=0;W<R.buffers.length;++W)this.writeBuffer(R.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(T);for(let M=0;M<T;M++)switch(this.readUInt8()){case 1:L[M]=this.readLongString();break;case 2:L[M]=this.readVSBuffer();break;case 3:const W=this.readUInt32(),V=this.readLongString(),N=[];for(let j=0;j<W;++j)N.push(this.readVSBuffer());L[M]=new i.SerializableObjectWithBuffers(I(V,N,null));break;case 4:L[M]=void 0;break}return L}}r.sizeUInt32=4;var a;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(a||(a={}));class u{static _useMixedArgSerialization(T){for(let L=0,M=T.length;L<M;L++)if(T[L]instanceof F.VSBuffer||T[L]instanceof i.SerializableObjectWithBuffers||typeof T[L]=="undefined")return!0;return!1}static serializeRequestArguments(T,L){if(this._useMixedArgSerialization(T)){const M=[];for(let R=0,W=T.length;R<W;R++){const V=T[R];if(V instanceof F.VSBuffer)M[R]={type:2,value:V};else if(typeof V=="undefined")M[R]={type:4};else if(V instanceof i.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:j}=D(V.value,L);M[R]={type:3,value:F.VSBuffer.fromString(N),buffers:j}}else M[R]={type:1,value:F.VSBuffer.fromString(b(V,L))}}return{type:1,args:M}}return{type:0,args:b(T,L)}}static serializeRequest(T,L,M,R,W){switch(R.type){case 0:return this._requestJSONArgs(T,L,M,R.args,W);case 1:return this._requestMixedArgs(T,L,M,R.args,W)}}static _requestJSONArgs(T,L,M,R,W){const V=F.VSBuffer.fromString(M),N=F.VSBuffer.fromString(R);let j=0;j+=r.sizeUInt8(),j+=r.sizeShortString(V),j+=r.sizeLongString(N);let U=r.alloc(W?2:1,T,j);return U.writeUInt8(L),U.writeShortString(V),U.writeLongString(N),U.buffer}static deserializeRequestJSONArgs(T){const L=T.readUInt8(),M=T.readShortString(),R=T.readLongString();return{rpcId:L,method:M,args:JSON.parse(R)}}static _requestMixedArgs(T,L,M,R,W){const V=F.VSBuffer.fromString(M);let N=0;N+=r.sizeUInt8(),N+=r.sizeShortString(V),N+=r.sizeMixedArray(R);let j=r.alloc(W?4:3,T,N);return j.writeUInt8(L),j.writeShortString(V),j.writeMixedArray(R),j.buffer}static deserializeRequestMixedArgs(T){const L=T.readUInt8(),M=T.readShortString(),R=T.readMixedArray(),W=new Array(R.length);for(let V=0,N=R.length;V<N;V++){const j=R[V];typeof j=="string"?W[V]=JSON.parse(j):W[V]=j}return{rpcId:L,method:M,args:W}}static serializeAcknowledged(T){return r.alloc(5,T,0).buffer}static serializeCancel(T){return r.alloc(6,T,0).buffer}static serializeReplyOK(T,L,M){if(typeof L=="undefined")return this._serializeReplyOKEmpty(T);if(L instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(T,L);if(L instanceof i.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:W}=D(L.value,M,!0);return this._serializeReplyOKJSONWithBuffers(T,R,W)}else return this._serializeReplyOKJSON(T,l(L,M))}static _serializeReplyOKEmpty(T){return r.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,L){let M=0;M+=r.sizeVSBuffer(L);let R=r.alloc(8,T,M);return R.writeVSBuffer(L),R.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,L){const M=F.VSBuffer.fromString(L);let R=0;R+=r.sizeLongString(M);let W=r.alloc(9,T,R);return W.writeLongString(M),W.buffer}static _serializeReplyOKJSONWithBuffers(T,L,M){const R=F.VSBuffer.fromString(L);let W=0;W+=r.sizeUInt32,W+=r.sizeLongString(R);for(const N of M)W+=r.sizeVSBuffer(N);let V=r.alloc(10,T,W);V.writeUInt32(M.length),V.writeLongString(R);for(const N of M)V.writeBuffer(N);return V.buffer}static deserializeReplyOKJSON(T){const L=T.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(T,L){const M=T.readUInt32(),R=T.readLongString(),W=[];for(let V=0;V<M;++V)W.push(T.readVSBuffer());return new i.SerializableObjectWithBuffers(I(R,W,L))}static serializeReplyErr(T,L){return L?this._serializeReplyErrEror(T,L):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,L){const M=F.VSBuffer.fromString(l(y.transformErrorForSerialization(L),null));let R=0;R+=r.sizeLongString(M);let W=r.alloc(11,T,R);return W.writeLongString(M),W.buffer}static deserializeReplyErrError(T){const L=T.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(T){return r.alloc(12,T,0).buffer}}var p;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var E;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(E||(E={}))}),define(fe[267],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(fe[268],me([0,1,10,8,11,2,4,64,44,225,267]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let k=class Wn{constructor(f,d,w,D){this.localUserHome=f,this.remoteAgentService=d,this.environmentService=w,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||f})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return m.Schemas.vscodeRemote;const w=(0,_.getVirtualWorkspaceScheme)(d.getWorkspace());if(w)return w;const D=d.getWorkspace().folders[0];if(D)return D.uri.scheme;const I=d.getWorkspace().configuration;return I?I.scheme:m.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?F.win32:F.posix)}async fileURI(f){let d="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const D=f.indexOf("/",2);D===-1?(d=f.substring(2),f="/"):(d=f.substring(2,D),f=f.substring(D)||"/")}return y.URI.from({scheme:m.Schemas.file,authority:d,path:f,query:"",fragment:""})}};k=Ve([$e(1,i.IRemoteAgentService),$e(2,P.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(A,_){this.line=A,this.character=_}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,_){return new m(0,0)}with(A){return new m(0,0)}}e.Position=m;class F{constructor(A,_,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(A,_),this.end=new m(S,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var C;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,16,30,25,29,9,4,8,18,72,12]),function(Y,e,m,F,C,y,A,_,S,P,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",f=" characters skipped \u27EB",d=(l.length+f.length+5)*2;e.ISearchService=(0,_.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function I(x){return!!x.preview}e.resultIsMatch=I;function b(x){return!!x.resource}e.isFileMatch=b;function c(x){return!!x.message}e.isProgressMessage=c;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=v;class t{constructor(z,O,$){this.ranges=O;const B=Array.isArray(O)?O:[O];if($&&$.matchLines===1&&h(B)){z=(0,A.getNLines)(z,$.matchLines);let X="",Q=0,de=0;const _e=Math.floor($.charsPerLine/5),ye=[];for(const ke of B){const Be=Math.max(ke.startColumn-_e,0),We=ke.startColumn+$.charsPerLine;if(Be>de+_e+d){const He=l+(Be-de)+f;X+=He+z.slice(Be,We),Q+=Be-(de+He.length)}else X+=z.slice(de,We);ye.push(new n(0,ke.startColumn-Q,ke.endColumn-Q)),de=We}this.preview={text:X,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:z,matches:(0,m.mapArrayOrNot)(O,Q=>new s(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=t;function h(x){const z=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==z||O.endLineNumber!==z)return!1;return!0}class s{constructor(z,O,$,B){this.startLineNumber=z,this.startColumn=O,this.endLineNumber=$,this.endColumn=B}}e.SearchRange=s;class n extends s{constructor(z,O,$){super(z,O,z,$)}}e.OneLineRange=n;var r;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function a(x,z=!0){const O=x&&x.files&&x.files.exclude,$=z&&x&&x.search&&x.search.exclude;if(!O&&!$)return;if(!O||!$)return O||$;let B=Object.create(null);return B=C.mixin(B,C.deepClone(O)),B=C.mixin(B,C.deepClone($),!0),B}e.getExcludes=a;function u(x,z){return x.excludePattern&&F.match(x.excludePattern,z)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&F.match(x.includePattern,z)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const $=O.folder.fsPath;if(y.isEqualOrParent(z,$)){const B=S.relative($,z);return!O.includePattern||!!F.match(O.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var p;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(z,O){super(z);this.code=O}}e.SearchError=E;function g(x){const z=x.message;if((0,P.isPromiseCanceledError)(x))return new E(z,p.canceled);try{const O=JSON.parse(z);return new E(O.message,O.code)}catch(O){return new E(z,p.other)}}e.deserializeSearchError=g;function T(x){const z={message:x.message,code:x.code};return new Error(JSON.stringify(z))}e.serializeSearchError=T;function L(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=L;function M(x){return x.type==="success"}e.isSerializedSearchSuccess=M;function R(x){return!!x.path}e.isSerializedFileMatch=R;function W(x,z){const O=x.searchPath?x.searchPath:x.relativePath;return(0,A.fuzzyContains)(O,z)}e.isFilePatternMatch=W;class V{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function N(x,z){const O={...x||{},...z||{}};return Object.keys(O).filter($=>{const B=O[$];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=N;class j{constructor(z,O){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let $=z.includePattern;O.includePattern&&($?$={...$,...O.includePattern}:$=O.includePattern),$&&(this._parsedIncludeExpression=F.parse($))}matchesExcludesSync(z,O,$){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,$))}includedInQuerySync(z,O,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,O,$))}includedInQuery(z,O,$){const B=this._parsedExcludeExpression(z,O,$),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,O,$):!0;return(0,k.isPromise)(B)?B.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=j;function U(x){for(const z in x)if(typeof x[z]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,16,17,21,3,24,10,78,23,9,12,2,171,4,13,191,44,53,27,14,7,31,5]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c,o,v,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(T,L,M){return new P.ExtUri(R=>u(R,M)).isEqual(T,L)}function n(T,L,M){return s(T.uri,L.uri,M)?0:(0,i.compare)(T.uri.toString(),L.uri.toString())}function r(T,L,M){return T.index!==L.index?T.index<L.index?-1:1:s(T.uri,L.uri,M)?(0,i.compare)(T.name,L.name):(0,i.compare)(T.uri.toString(),L.uri.toString())}function a(T,L,M,R){const W=T.slice(0).sort((N,j)=>M(N,j,R)),V=L.slice(0).sort((N,j)=>M(N,j,R));return(0,m.delta)(W,V,(N,j)=>M(N,j,R))}function u(T,L){const M=L.getCapabilities(T.scheme);return!(M&&M&1024)}class p extends I.Workspace{constructor(L,M,R,W,V,N,j){super(L,R.map(U=>new I.WorkspaceFolder(U)),W,V,j);this._name=M,this._isUntitled=N,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(j),R.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(L,M,R,W){if(!L)return{workspace:null,added:[],removed:[]};const{id:V,name:N,folders:j,configuration:U,transient:x,isUntitled:z}=L,O=[],$=M;M?j.forEach((de,_e)=>{const ye=l.URI.revive(de.uri),ke=p._findFolder(R||M,ye,W);ke?(ke.name=de.name,ke.index=de.index,O.push(ke)):O.push({uri:ye,name:de.name,index:_e})}):O.push(...j.map(({uri:de,name:_e,index:ye})=>({uri:l.URI.revive(de),name:_e,index:ye}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const B=new p(V,N,O,!!x,U?l.URI.revive(U):null,!!z,de=>u(de,W)),{added:X,removed:Q}=a($?$.workspaceFolders:[],B.workspaceFolders,n,W);return{workspace:B,added:X,removed:Q}}static _findFolder(L,M,R){for(let W=0;W<L.folders.length;W++){const V=L.workspaceFolders[W];if(s(V.uri,M,R))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,M){return M&&this._structure.get(L)&&(L=(0,P.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let E=class{constructor(L,M,R,W){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=W,this._extHostFileSystemInfo=R,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(h.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(h.MainContext.MainThreadMessageService);const V=M.workspace;this._confirmedWorkspace=V?new p(V.id,V.name,[],!!V.transient,V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,N=>u(N,R)):void 0}$initializeWorkspace(L,M){this._trusted=M,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:_.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,M,R,...W){const V=[];if(Array.isArray(W)&&W.forEach(z=>{l.URI.isUri(z.uri)&&!V.some(O=>s(O.uri,z.uri,this._extHostFileSystemInfo))&&V.push({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[M,R].some(z=>typeof z!="number"||z<0)||R===0&&V.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+R>N.length)return!1;const j=N.slice(0);j.splice(M,R,...V.map(z=>({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<j.length;z++){const O=j[z];if(j.some(($,B)=>B!==z&&s(O.uri,$.uri,this._extHostFileSystemInfo)))return!1}j.forEach((z,O)=>z.index=O);const{added:U,removed:x}=a(N,j,r,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const z=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(z,M,R,V).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,f.localize)(0,null,z,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(L,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async getWorkspaceFolder2(L,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,M){let R,W="";if(typeof L=="string"?(R=l.URI.file(L),W=L):typeof L!="undefined"&&(R=L,W=L.fsPath),!R)return W;const V=this.getWorkspaceFolder(R,!0);if(!V)return W;typeof M=="undefined"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let N=(0,P.relativePath)(V.uri,R);return M&&V.name&&(N=`${V.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=p.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:M,added:R,removed:W}=p.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:W}))}findFiles(L,M,R,W,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let N;if(M===null?N=!1:M&&(typeof M=="string"?N=M:N=M.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:U}=g(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(j),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(R),V).then(x=>Array.isArray(x)?x.map(z=>l.URI.revive(z)):[])}async findTextInFiles(L,M,R,W,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),j=typeof M.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:U,folder:x}=g(M.include),z=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,O={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:j,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:U,excludePattern:z},$=!1;if(this._activeSearchCallbacks[N]=B=>{if($)return;const X=l.URI.revive(B.resource);B.results.forEach(Q=>{(0,t.resultIsMatch)(Q)?R({uri:X,preview:{text:Q.preview.text,matches:(0,m.mapArrayOrNot)(Q.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,m.mapArrayOrNot)(Q.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):R({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},V.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(x),O,N,V);return delete this._activeSearchCallbacks[N],B||{}}catch(B){throw delete this._activeSearchCallbacks[N],B}}$handleTextSearchResult(L,M){this._activeSearchCallbacks[M]&&this._activeSearchCallbacks[M](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Ve([$e(0,o.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,w.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function g(T){let L,M;return T&&(typeof T=="string"?L=T:(L=T.pattern,M=T.baseFolder||l.URI.file(T.base))),{includePattern:L,folder:M}}}),define(fe[37],me([0,1,25,3,36,5,7,194,86,12,17,4,14,13,2]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(h,s){if(s){const n=s.split(".");let r=h;for(let a=0;r&&a<n.length;a++)r=r[n[a]];return r}}function D(h){return h instanceof d.URI}function I(h){return h&&h.uri instanceof d.URI&&h.languageId&&typeof h.languageId=="string"}function b(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function c(h){return h&&h.uri instanceof d.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function o(h){if(D(h))return{resource:h};if(I(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(b(h))return{overrideIdentifier:h.languageId};if(c(h))return{resource:h.uri};if(h===null)return{resource:null}}let v=class{constructor(s,n,r){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=r,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,n))}};v=Ve([$e(0,l.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,f.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,n,r,a){this._onDidChangeConfiguration=new F.Emitter,this._proxy=s,this._logService=a,this._extHostWorkspace=n,this._configuration=_.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=_.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,r))}getConfiguration(s,n,r){const a=o(n)||{},u=this._toReadonlyValue(s?w(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,a,r?.identifier);function p(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(g){return typeof w(u,g)!="undefined"},get:(g,T)=>{this._validateConfigurationAccess(s?`${s}.${g}`:g,a,r?.identifier);let L=w(u,g);if(typeof L=="undefined")L=T;else{let M;const R=(W,V)=>{let N;const j=()=>{M=M||(0,m.deepClone)(u),N=N||w(M,V)};return(0,P.isObject)(W)?new Proxy(W,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return j(),()=>N;if(M)return N=N||w(M,V),N[x];const z=U[x];return typeof x=="string"?R(z,`${V}.${x}`):z},set:(U,x,z)=>(j(),N&&(N[x]=z),!0),deleteProperty:(U,x)=>(j(),N&&delete N[x],!0),defineProperty:(U,x,z)=>(j(),N&&Object.defineProperty(N,x,z),!0)}):W};L=R(L,g)}return L},update:(g,T,L,M)=>{g=s?`${s}.${g}`:g;const R=p(L);return T!==void 0?this._proxy.$updateConfigurationOption(R,g,T,a,M):this._proxy.$removeConfigurationOption(R,g,a,M)},inspect:g=>{g=s?`${s}.${g}`:g;const T=(0,m.deepClone)(this._configuration.inspect(g,a,this._extHostWorkspace.workspace));if(T)return{key:g,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof u=="object"&&(0,m.mixin)(E,u,!1),Object.freeze(E)}_toReadonlyValue(s){const n=r=>(0,P.isObject)(r)?new Proxy(r,{get:(a,u)=>n(a[u]),set:(a,u,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(a,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(a,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return n(s)}_validateConfigurationAccess(s,n,r){const a=S.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),u=r?`[${r.value}] `:"";if(a===4){typeof n?.resource=="undefined"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){n?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const r=new _.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,u)=>r.affectsConfiguration(a,o(u))})}_toMap(s){return s.reduce((n,r)=>(n.set(r[0],r[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[73],me([0,1,2,17,3,5,7,36,45,37,21,33,14,27,4,10,11,13,68,215,18]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(V){function N(x){if(x){const z=x;return z&&!!z.process}else return!1}V.is=N;function j(x){if(x==null)return;const z={process:x.process,args:x.args};return x.options&&(z.options=s.from(x.options)),z}V.from=j;function U(x){if(x!=null)return new A.ProcessExecution(x.process,x.args,x.options)}V.to=U})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(V){function N(x){if(x){const z=x;return z&&(!!z.commandLine||!!z.command)}else return!1}V.is=N;function j(x){if(x==null)return;const z={};return x.commandLine!==void 0?z.commandLine=x.commandLine:(z.command=x.command,z.args=x.args),x.options&&(z.options=r.from(x.options)),z}V.from=j;function U(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new A.ShellExecution(x.commandLine,x.options):new A.ShellExecution(x.command,x.args?x.args:[],x.options)}V.to=U})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var u;(function(V){function N(x){if(x){let z=x;return z&&z.customExecution==="customExecution"}else return!1}V.is=N;function j(x){return{customExecution:"customExecution"}}V.from=j;function U(x,z){return z.get(x)}V.to=U})(u=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var p;(function(V){function N(j,U){let x;return j.scope!==void 0&&typeof j.scope!="number"?x=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?x=U.workspaceFile:x=c.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:x}}V.from=N})(p=e.TaskHandleDTO||(e.TaskHandleDTO={}));var E;(function(V){function N(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}V.from=N})(E=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(V){function N(x,z){if(x==null)return[];const O=[];for(let $ of x){const B=j($,z);B&&O.push(B)}return O}V.fromMany=N;function j(x,z){if(x==null)return;let O;x.execution instanceof A.ProcessExecution?O=n.from(x.execution):x.execution instanceof A.ShellExecution?O=a.from(x.execution):x.execution&&x.execution instanceof A.CustomExecution&&(O=u.from(x.execution));const $=t.from(x.definition);let B;return x.scope?typeof x.scope=="number"?B=x.scope:B=x.scope.uri:B=A.TaskScope.Workspace,!$||!B?void 0:{_id:x._id,definition:$,name:x.name,source:{extensionId:z.identifier.value,label:x.source,scope:B},execution:O,isBackground:x.isBackground,group:E.from(x.group),presentationOptions:h.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}V.from=j;async function U(x,z,O){if(x==null)return;let $;n.is(x.execution)?$=n.to(x.execution):a.is(x.execution)?$=a.to(x.execution):u.is(x.execution)&&($=u.to(x._id,O));const B=t.to(x.definition);let X;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?X=x.source.scope:X=await z.resolveWorkspaceFolder(m.URI.revive(x.source.scope)):X=A.TaskScope.Workspace),!B||!X)return;const Q=new A.Task(B,X,x.name,x.source.label,$,x.problemMatchers);return x.isBackground!==void 0&&(Q.isBackground=x.isBackground),x.group!==void 0&&(Q.group=A.TaskGroup.from(x.group._id),Q.group&&x.group.isDefault&&(Q.group=new A.TaskGroup(Q.group.id,Q.group.label),x.group.isDefault&&(Q.group.isDefault=x.group.isDefault))),x.presentationOptions&&(Q.presentationOptions=h.to(x.presentationOptions)),x._id&&(Q._id=x._id),x.detail&&(Q.detail=x.detail),Q}V.to=U})(g=e.TaskDTO||(e.TaskDTO={}));var T;(function(V){function N(U){return U}V.from=N;function j(U){if(!!U)return Object.assign(Object.create(null),U)}V.to=j})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(N,j,U){this._id=j,this._task=U,v.set(this,void 0),ot(this,v,N,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}v=new WeakMap;var M;(function(V){function N(j){return{id:j._id,task:void 0}}V.from=N})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let R=class{constructor(N,j,U,x,z,O,$,B){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=x,this._configurationService=z,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,j,U){if(!U)return new A.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:j,provider:U,extension:N}),this._proxy.$registerTaskProvider(x,j),new A.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(N,j){this._proxy.$registerTaskSystem(N,j)}fetchTasks(N){return this._proxy.$fetchTasks(T.from(N)).then(async j=>{const U=[];for(let x of j){const z=await g.to(x,this._workspaceProvider,this._providedCustomExecutions2);z&&U.push(z)}return U})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(j=>N.push(j)),N}terminateTask(N){if(!(N instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,j,U){const x=this._providedCustomExecutions2.get(N.id);if(x){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,x),this._terminalService.attachPtyToTerminal(j,await x.callback(U))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const j=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:j,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:N.exitCode})}$provideTasks(N,j){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));const x=[],z=(0,F.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(j,x,U,O));return new Promise(O=>{z.then($=>{Promise.all(x).then(()=>{O($)})})})}async $resolveTask(N,j){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const x=await g.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask(x,i.CancellationToken.None);if(!z)return;this.checkDeprecation(z,U);const O=g.from(z,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(O.execution)&&await this.addCustomExecution(O,z,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,j,U){const x=await this._proxy.$createTaskId(N);!U&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,j.execution)}async getTaskExecution(N,j){if(typeof N=="string"){const z=this._taskExecutionPromises.get(N);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let U=this._taskExecutionPromises.get(N.id);if(U)return U;const x=new Promise(async(z,O)=>{const $=j||await g.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);$?z(new L(this,N.id,$)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,x),x.then(z=>(this._taskExecutions.set(N.id,z),z),z=>Promise.reject(z))}checkDeprecation(N,j){N._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let U=this._notProvidedCustomExecutions.values(),x=U.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=U.next()}};R=Ve([$e(0,l.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,_.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,I.ILogService),$e(7,b.IExtHostApiDeprecationService)],R),e.ExtHostTaskBase=R;let W=class extends R{constructor(N,j,U,x,z,O,$,B){super(N,j,U,x,z,O,$,B);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(N,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=g.from(j,N);if(U===void 0)throw new Error("Task is not valid");if(u.is(U.execution))await this.addCustomExecution(U,j,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),j);return this._proxy.$executeTask(U).catch(z=>{throw new Error(z)}),x}provideTasksInternal(N,j,U,x){const z=[];if(x)for(let O of x){this.checkDeprecation(O,U),(!O.definition||!N[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const $=g.from(O,U.extension);$&&u.is($.execution)?(z.push($),j.push(this.addCustomExecution($,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async resolveTaskInternal(N){if(u.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,j,U){}};W=Ve([$e(0,l.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,_.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,I.ILogService),$e(7,b.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=(0,d.createDecorator)("IExtHostTask")}),define(fe[269],me([0,1,16,59,30,80,24,10,8,23,9,12,2,147,178,121,44,130,268,31]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(p,E,g,T){this.configurationService=p,this.workspaceContextService=E,this.editorGroupsService=g,this.pathService=T}text(p,E,g={}){p=this.getContentPattern(p,g);const T=this.configurationService.getValue(),L=E&&E.some(R=>!this.configurationService.getValue({resource:R}).search.useRipgrep);return{...this.commonQuery(E?.map(D.toWorkspaceFolder),g),type:2,contentPattern:p,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(p,E){const g=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const T={...p,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(p,E)&&(T.isCaseSensitive=!0),this.isMultiline(p)&&(T.isMultiline=!0),T}file(p,E={}){return{...this.commonQuery(p,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(p,E){return p?(p=Array.isArray(p)?p.map(n):n(p),E?this.parseSearchPaths(p):{pattern:t(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],E={}){const g=this.handleIncludeExclude(E.includePattern,E.expandPatterns),T=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),L=p.length>1,M=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,E,T)):p.map(V=>this.getFolderQueryForRoot(V,E,T,L))).filter(V=>!!V),R={_reason:E._reason,folderQueries:M,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:T.pattern,includePattern:g.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const N=m.coalesce(m.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,c.pathIncludedInQuery)(R,U.fsPath)),j=this.commonQueryFromFileList(N);return{...R,...j}}const W=E.extraFileResources&&E.extraFileResources.filter(V=>(0,c.pathIncludedInQuery)(R,V.fsPath));return R.extraFileResources=W&&W.length?W:void 0,R}commonQueryFromFileList(p){const E=[],g=new A.ResourceMap,T={};let L=!1;return p.forEach(M=>{if(M.scheme===_.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(M)){const W=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:S.dirname(M.fsPath)});let V=g.get(W);V||(L=!0,V={folder:W,includePattern:{}},E.push(V),g.set(W,V));const N=S.relative(W.fsPath,M.fsPath);(0,k.assertIsDefined)(V.includePattern)[N.replace(/\\/g,"/")]=!0}else M.fsPath&&(L=!0,T[M.fsPath]=!0)}),{folderQueries:E,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(p,E){if(E.isSmartCase){if(p.isRegExp){if(i.containsUppercaseCharacter(p.pattern,!0))return!0}else if(i.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,f.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const E=j=>S.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),T=(Array.isArray(p)?p:h(p)).map(j=>{const U=this.pathService.resolvedUserHome;return U?(0,y.untildify)(j,U.scheme===_.Schemas.file?U.fsPath:U.path):j}),L=F.groupBy(T,j=>E(j)?"searchPaths":"exprSegments"),M=(L.exprSegments||[]).map(j=>i.rtrim(j,"/")).map(j=>i.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),s(j))),R={},W=this.expandSearchPathPatterns(L.searchPaths||[]);W&&W.length&&(R.searchPaths=W);const V=m.flatten(M),N=t(...V);return N&&(R.pattern=N),R}getExcludesForFolder(p,E){return E.disregardExcludeSettings?void 0:(0,c.getExcludes)(p,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const E=m.flatten(p.map(T=>{let{pathPortion:L,globPortion:M}=v(T);M&&(M=r(M));const R=this.expandOneSearchPath(L);return m.flatten(R.map(W=>this.resolveOneSearchPathPattern(W,M)))})),g=new Map;return E.forEach(T=>{const L=T.searchPath.toString(),M=g.get(L);M?T.pattern&&(M.pattern=M.pattern||{},M.pattern[T.pattern]=!0):g.set(L,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(p){if(S.isAbsolute(p)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==_.Schemas.file?[{searchPath:E[0].uri.with({path:p})}]:[{searchPath:l.URI.file(S.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=n(p),p.startsWith("../")||p===".."){const T=S.posix.resolve(E.path,p);return[{searchPath:E.with({path:T})}]}const g=r(p);return[{searchPath:E,pattern:g}]}else{if(p==="./"||p===".\\")return[];{const E=p.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(L=>{const M=E.match(new RegExp(`^${i.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return M?{match:M,folder:L}:null}).filter(k.isDefined);if(T.length)return T.map(L=>{const M=L.match[1];return{searchPath:L.folder.uri,pattern:M&&r(M)}});{const L=p.match(/\.[\/\\](.+)[\/\\]?/),M=L?L[1]:p,R=d.localize(0,null,M);throw new Error(R)}}}}resolveOneSearchPathPattern(p,E){const g=p.pattern&&E?`${p.pattern}/${E}`:p.pattern||E,T=[{searchPath:p.searchPath,pattern:g}];return g&&!g.endsWith("**")&&T.push({searchPath:p.searchPath,pattern:g+"/**"}),T}getFolderQueryForSearchPath(p,E,g){const T=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(p.searchPath),E,g,!1);return T?{...T,includePattern:p.pattern}:null}getFolderQueryForRoot(p,E,g,T){let L;const M=l.URI.isUri(p)?p:p.uri;if(g.searchPaths){const j=g.searchPaths.filter(U=>(0,P.isEqual)(U.searchPath,M))[0];if(j&&!j.pattern)return null;j&&(L=j.pattern)}const R=this.configurationService.getValue({resource:M}),V={...this.getExcludesForFolder(R,E)||{},...L||{}},N=l.URI.isUri(p)?(0,P.basename)(p):p.name;return{folder:M,folderName:T?N:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!R.search.followSymlinks}}};o=Ve([$e(0,w.IConfigurationService),$e(1,D.IWorkspaceContextService),$e(2,I.IEditorGroupsService),$e(3,b.IPathService)],o),e.QueryBuilder=o;function v(u){const p=u.match(/[\*\{\}\(\)\[\]\?]/);if(p){const E=p.index,g=u.substr(0,E).match(/[/|\\][^/\\]*$/);if(g){let T=u.substr(0,g.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:u.substr((g.index||0)+1)}}}return{pathPortion:u}}function t(...u){return u.length?u.reduce((p,E)=>(p[E]=!0,p),Object.create(null)):void 0}function h(u){return C.splitGlobAware(u,",").map(p=>p.trim()).filter(p=>!!p.length)}function s(u){return[`**/${u}/**`,`**/${u}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(u){return u.replace(/\\/g,"/")}function r(u){return n(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(u,p){u=m.distinct(u,T=>T.toString());const E=[],g=p.getWorkspace();return u&&u.forEach(T=>{let L;if(p.getWorkbenchState()===2)L=(0,P.relativePath)(g.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const M=p.getWorkspaceFolder(T);if(M){const R=M.name;if(g.folders.filter(V=>V.name===R).length===1){const V=(0,P.relativePath)(M.uri,T);V===""?L=`./${M.name}`:L=`./${M.name}/${V}`}else L=T.fsPath}}L&&E.push(L)}),E}e.resolveResourcesForSearchIncludes=a}),define(fe[270],me([0,1,23,2,21,18,4,269,31,44]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function k(w,D){const I=D.activationEvents;if(!I)return Promise.resolve(void 0);const b=[],c=[];for(const n of I)if(/^workspaceContains:/.test(n)){const r=n.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||w.forceUsingSearch?c.push(r):b.push(r)}if(b.length===0&&c.length===0)return Promise.resolve(void 0);let o;const v=new Promise((n,r)=>{o=n}),t=n=>o({activationEvent:n}),h=Promise.all(b.map(n=>l(w,n,t))).then(()=>{}),s=f(w,D.identifier,c,t);return Promise.all([h,s]).then(()=>{o(void 0)}),v}e.checkActivateWorkspaceContainsExtension=k;async function l(w,D,I){for(const b of w.folders)if(await w.exists(m.joinPath(F.URI.revive(b),D))){I(`workspaceContains:${D}`);return}}async function f(w,D,I,b){if(I.length===0)return Promise.resolve(void 0);const c=new C.CancellationTokenSource,o=w.checkExists(w.folders,I,c.token),v=setTimeout(async()=>{c.cancel(),b(`workspaceContainsTimeout:${I.join(",")}`)},i);let t=!1;try{t=await o}catch(h){y.isPromiseCanceledError(h)||y.onUnexpectedError(h)}c.dispose(),clearTimeout(v),t&&b(`workspaceContains:${I.join(",")}`)}function d(w,D,I,b){const c=w.get(A.IInstantiationService),o=w.get(S.ISearchService),t=c.createInstance(_.QueryBuilder).file(D.map(h=>(0,P.toWorkspaceFolder)(F.URI.revive(h))),{_reason:"checkExists",includePattern:I,exists:!0});return o.fileSearch(t,b).then(h=>!!h.limitHit,h=>y.isPromiseCanceledError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=d});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,m):C?C.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[41],me([0,1,166,8,74,23,17,6,24,2,13,5,37,228,92,36,35,226,18,26,22,201,7,122,4,27,70,14,85,54,33,3,270,90,203,10]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c,o,v,t,h,s,n,r,a,u,p,E,g,T,L,M,R){"use strict";var W,V,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Hn extends _.Disposable{constructor(O,$,B,X,Q,de,_e,ye,ke,Be){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=$,this._extHostContext=B,this._initData=_e,this._extHostWorkspace=X,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=ke,this._extHostTerminalService=Be,this._disposables=new _.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=O.createChild(new u.ServiceCollection([d.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(He=>We.add(c.ExtensionIdentifier.toKey(He))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,q,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(q),ee)},actualActivateExtension:async(He,q)=>{if(We.has(c.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,q),new f.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,q)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch($){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,$){return this._activator.activateByEvent(O,$)}_activateById(O,$){return this._activator.activateById(O,$)}activateByIdWithErrors(O,$){return this._activateById(O,$).then(()=>{const B=this._activator.getActivatedExtension(O);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==R.Schemas.file)return O;const $=await this._hostUtils.realpath(O.fsPath);return P.URI.file($)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=S.TernarySearchTree.forUris($=>y.extUriBiasedIgnorePathCase.ignorePathCasing($));for(const $ of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint($)){const B=await this._realPathExtensionUri($.extensionLocation);O.set(B,$)}return O})()),this._extensionPathIndex}_deactivate(O){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return $;const B=this._activator.getActivatedExtension(O);if(!B)return $;try{typeof B.module.deactivate=="function"&&($=Promise.resolve(B.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,_.dispose)(B.subscriptions)}catch(X){this._logService.error(X)}return $}async _activateExtension(O,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,$).then(B=>{const X=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,$),this._logExtensionActivationTimes(O,$,"success",X),B},B=>{throw this._logExtensionActivationTimes(O,$,"failure"),B})}_logExtensionActivationTimes(O,$,B,X){const Q=U(O,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...X||{},outcome:B})}_doActivateExtension(O,$){const B=U(O,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${$.startup}, activationEvent: '${$.activationEvent}'${O.identifier.value!==$.extensionId.value?`, root cause: ${$.extensionId.value}`:""}`),this._logService.flush();const Q=new f.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,y.joinPath)(O.extensionLocation,X),Q),this._loadExtensionContext(O)]).then(de=>(C.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Hn._callActivate(this._logService,O.identifier,de[0],de[1],Q))).then(de=>(C.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const $=new v.ExtensionGlobalMemento(O,this._storage),B=new v.ExtensionMemento(O.identifier.value,!1,this._storage),X=new M.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([$.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let ye;return Object.freeze({globalState:$,workspaceState:B,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(ke){return F.join(O.extensionLocation.fsPath,ke)},get storagePath(){return _e._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(O).fsPath},get logPath(){return F.join(_e._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return P.URI.joinPath(_e._initData.logsLocation,O.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(O)},get globalStorageUri(){return _e._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return ye===void 0&&(ye=new x(_e,O.identifier,O,de)),ye},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(O),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,$,B,X,Q){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,$,B,X,Q).then(de=>new f.ActivatedExtension(!1,null,Q.build(),B,de,X.subscriptions))}static _callActivateOptional(O,$,B,X,Q){if(typeof B.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${$.value}`);const de=typeof global=="object"?global:self,_e=B.activate.apply(de,[X]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(_e).then(ye=>(Q.activateResolveStop(),ye))}catch(de){return Promise.reject(de)}else return Promise.resolve(B)}_activateOneStartupFinished(O,$){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:$}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const $ of O.activationEvents)$==="onStartupFinished"&&this._activateOneStartupFinished(O,$)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions($),X=Promise.all([O,B]).then(()=>{});return Promise.race([X,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(O,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,$){if(this.isActivated($.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:B,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,_e,ye)=>this._mainThreadWorkspaceProxy.$checkExists(de,_e,ye)},Q=await(0,T.checkActivateWorkspaceContainsExtension)(X,$);if(!!Q)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:$}=this._initData.environment;if(!O||!$)throw new Error(m.localize(0,null));const B=await this._loadCommonJSModule(null,$,new f.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(m.localize(1,null,$.toString()));return new Promise((X,Q)=>{const de=(ke,Be)=>{ke?Q(ke):X(typeof Be=="number"&&Be>0?1:0)},_e=(0,y.originalFSPath)($),ye=B.run(_e,de);ye&&ye.then&&ye.then(()=>{X(0)}).catch(ke=>{Q(ke.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,$){return this._resolvers[O]=$,(0,_.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const $=O.indexOf("+");if($===-1)throw new Error("Not an authority that can be resolved!");const B=O.substr(0,$);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(O,$){const{authorityPrefix:B,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),C.mark(`code/extHost/willResolveAuthority/${B}`);const Q=await X.resolve(O,{resolveAttempt:$});C.mark(`code/extHost/didResolveAuthorityOK/${B}`);const de={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},_e={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:de,options:_e,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(C.mark(`code/extHost/didResolveAuthorityError/${B}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,$){const{authorityPrefix:B,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const Q=P.URI.revive($);if(typeof X.getCanonicalURI=="undefined")return Q;const de=await(0,A.asPromise)(()=>X.getCanonicalURI(Q));return de||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,$){return $===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(O,!1))}async $activate(O,$){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,$),!0):!1}async $deltaExtensions(O,$){O.forEach(X=>X.extensionLocation=P.URI.revive(X.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all($.map(async X=>{const Q=this._registry.getExtensionDescription(X);Q&&B.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async X=>{const Q=await this._realPathExtensionUri(X.extensionLocation);B.set(Q,X)})),this._registry.deltaExtensions(O,$),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let $=o.VSBuffer.alloc(O),B=Math.random()%256;for(let X=0;X<O;X++)$.writeUInt8(B,X);return $}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};j=Ve([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,a.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,l.IExtHostConfiguration),$e(5,i.ILogService),$e(6,n.IExtHostInitDataService),$e(7,r.IExtensionStoragePaths),$e(8,p.IExtHostTunnelService),$e(9,E.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function U(z,O){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class x{constructor(O,$,B,X){W.set(this,void 0),V.set(this,void 0),N.set(this,void 0),ot(this,W,O,"f"),ot(this,V,$,"f"),ot(this,N,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=F.normalize((0,y.originalFSPath)(B.extensionLocation)),this.packageJSON=B,this.extensionKind=X}get isActive(){return Oe(this,W,"f").isActivated(Oe(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,W,"f").getExtensionExports(Oe(this,N,"f"))}activate(){return Oe(this,W,"f").activateByIdWithErrors(Oe(this,N,"f"),{startup:!1,extensionId:Oe(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,W=new WeakMap,V=new WeakMap,N=new WeakMap}),define(fe[57],me([0,1,8,2,3,17,5,7,126,36,41,45,217,37,211,14,4,12,38,56]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let o=class{constructor(u,p,E,g,T,L){this._workspaceService=p,this._extensionService=E,this._editorsService=g,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=u.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(R=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,p){const E=u;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let g=`debug:${encodeURIComponent(E.path||"")}`,T="?";return p&&(g+=`${T}session=${encodeURIComponent(p.id)}`,T="&"),g+=`${T}ref=${E.sourceReference}`,F.URI.parse(g)}else{if(E.path)return F.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const p=[];for(const E of u.getAllExtensionDescriptions())if(E.contributes){const g=E.contributes.debuggers;if(g&&g.length>0)for(const T of g)(0,d.isDebuggerMainContribution)(T)&&p.push(T.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(p=>u.push(p)),u}addBreakpoints(u){this.startBreakpoints();const p=u.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(p,[],[]);const E=[],g=new Map;for(const T of p)if(T instanceof _.SourceBreakpoint){let L=g.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},g.set(T.location.uri.toString(),L),E.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof _.FunctionBreakpoint&&E.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(u){this.startBreakpoints();const p=u.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],p,[]);const E=p.filter(L=>L instanceof _.SourceBreakpoint).map(L=>L.id),g=p.filter(L=>L instanceof _.FunctionBreakpoint).map(L=>L.id),T=p.filter(L=>L instanceof _.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(E,g,T)}startDebugging(u,p,E){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,p,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI,suppressSaveBeforeStart:E.suppressSaveBeforeStart})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,p,E){if(!p)return new _.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:g,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,E,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,g),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(u,p,E){if(!E)return new _.Disposable(()=>{});if(!this.definesDebugType(u,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:g,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,g),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(u,p){if(!p)return new _.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:E,factory:p}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==p)})}async $runInTerminal(u,p){return Promise.resolve(void 0)}async $substituteVariables(u,p){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let E;const g=await this.getFolder(u);return g&&(E={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,p)}createDebugAdapter(u,p){if(u.type==="implementation")return new n(u.implementation)}createSignService(){}async $startDASession(u,p){const E=this,g=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),M=this.createDebugAdapter(L,g);if(!M)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const R=M;return this._debugAdapters.set(u,R),this.getDebugAdapterTrackers(g).then(W=>(W&&this._debugAdaptersTrackers.set(u,W),R.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const N=V,j={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(N.arguments.value);j.body={signature:U},R.sendResponse(j)}else throw new Error("no signer")}catch(U){j.success=!1,j.message=U.message,R.sendResponse(j)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(V),V=(0,d.convertToVSCPaths)(V,!0),E._debugServiceProxy.$acceptDAMessage(u,V)}),R.onError(V=>{W&&W.onError&&W.onError(V),this._debugServiceProxy.$acceptDAError(u,V.name,V.message,V.stack)}),R.onExit(V=>{W&&W.onExit&&W.onExit((0,I.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,I.withNullAsUndefined)(V),void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),R.startSession()))})}$sendDAMessage(u,p){p=(0,d.convertToDAPaths)(p,!1);const E=this._debugAdaptersTrackers.get(u);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(p);const g=this._debugAdapters.get(u);g&&g.sendMessage(p)}$stopDASession(u){const p=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),p&&p.onWillStopSession&&p.onWillStopSession();const E=this._debugAdapters.get(u);return this._debugAdapters.delete(u),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const p=[],E=[],g=[];if(u.added)for(const T of u.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let M;if(T.type==="function")M=new _.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")M=new _.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const R=F.URI.revive(T.uri);M=new _.SourceBreakpoint(new _.Location(R,new _.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}M._id=L,this._breakpoints.set(L,M),p.push(M)}}if(u.removed)for(const T of u.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),E.push(L))}if(u.changed){for(const T of u.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof _.FunctionBreakpoint&&T.type==="function"){const M=L;M.enabled=T.enabled,M.condition=T.condition,M.hitCondition=T.hitCondition,M.logMessage=T.logMessage,M.functionName=T.functionName}else if(L instanceof _.SourceBreakpoint&&T.type==="source"){const M=L;M.enabled=T.enabled,M.condition=T.condition,M.hitCondition=T.hitCondition,M.logMessage=T.logMessage,M.location=new _.Location(F.URI.revive(T.uri),new _.Position(T.line,T.character))}g.push(L)}}}this.fireBreakpointChanges(p,E,g)}$provideDebugConfigurations(u,p,E){return(0,y.asPromise)(async()=>{const g=this.getConfigProviderByHandle(u);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(p);return g.provideDebugConfigurations(T,E)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(u,p,E,g){return(0,y.asPromise)(async()=>{const T=this.getConfigProviderByHandle(u);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(p);return T.resolveDebugConfiguration(L,E,g)})}$resolveDebugConfigurationWithSubstitutedVariables(u,p,E,g){return(0,y.asPromise)(async()=>{const T=this.getConfigProviderByHandle(u);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(p);return T.resolveDebugConfigurationWithSubstitutedVariables(L,E,g)})}async $provideDebugAdapter(u,p){const E=this.getAdapterDescriptorFactoryByHandle(u);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(p);return this.getAdapterDescriptor(E,g).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(u){const p=await this.getSession(u);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(u){const p=await this.getSession(u);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,p){const E=await this.getSession(u);E&&E._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(u,p){const g={session:await this.getSession(u),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(u){if(u instanceof _.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof _.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const p=this._adapterFactories.filter(E=>E.type===u);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(u){const p=this._adapterFactories.filter(E=>E.handle===u);if(p.length>0)return p[0].factory}getConfigProviderByHandle(u){const p=this._configProviders.filter(E=>E.handle===u);if(p.length>0)return p[0].provider}definesDebugType(u,p){if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0){for(const g of E)if(g.label&&g.type&&g.type===p)return!0}}return!1}getDebugAdapterTrackers(u){const E=u.configuration.type,g=this._trackerFactories.filter(T=>T.type===E||T.type==="*").map(T=>(0,y.asPromise)(()=>T.factory.createDebugAdapterTracker(u)).then(L=>L,L=>null));return Promise.race([Promise.all(g).then(T=>{const L=T.filter(M=>!!M);if(L.length>0)return new s(L)}),new Promise((T,L)=>{const M=setTimeout(()=>{clearTimeout(M),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(u,p){const E=p.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new _.DebugAdapterServer(E));if(u){const T=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>u.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,T))).then(L=>{if(L)return L})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,g))}daExecutableFromPackage(u,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,p,E){(u.length>0||p.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:p,changed:E}))}async getSession(u){if(u)if(typeof u=="string"){const p=this._debugSessions.get(u);if(p)return p}else{let p=this._debugSessions.get(u.id);if(!p){const E=await this.getFolder(u.folderUri),g=u.parent?this._debugSessions.get(u.parent):void 0;p=new v(this._debugServiceProxy,u.id,u.type,u.name,E,u.configuration,g),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(u){if(u){const p=F.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};o=Ve([$e(0,w.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,k.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class v{constructor(u,p,E,g,T,L,M){this._debugServiceProxy=u,this._id=p,this._type=E,this._name=g,this._workspaceFolder=T,this._configuration=L,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}get parentSession(){return this._parentSession}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,p)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=v;class t{constructor(u){this.value=Object.freeze({append(p){u.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=t;class h extends l.AbstractVariableResolverService{constructor(u,p,E,g,T){function L(){if(p){const M=p.activeEditor();if(M)return M.document.uri;const R=g.tabs.filter(W=>W.isActive);if(R.length>0){const W=R[0].resource;return W&&(W.primary||W.secondary)?W.primary??W.secondary:R[0].resource}}}super({getFolderUri:M=>{const R=u.filter(W=>W.name===M);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(M,R)=>E.getConfiguration(void 0,M).get(R),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=L();if(M)return m.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const M=L();if(M){const R=T.getWorkspaceFolder(M);if(R)return m.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(p){const M=p.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(p){const M=p.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=h;class s{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(p=>p.onError?p.onError(u):void 0)}onExit(u,p){this.trackers.forEach(E=>E.onExit?E.onExit(u,p):void 0)}}class n extends S.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(u,p,E,g,T,L){super(u,p,E,g,T,L)}createVariableResolver(u,p,E){return new h(u,p,E,this._editorTabs)}};r=Ve([$e(0,w.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,k.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(fe[271],me([0,1,74,2,5,37,35,26,14,27,4,41,38,13]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(c,o,v,t,h,s,n){this._apiFactory=c,this._extensionRegistry=o,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=h,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,o,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(D)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,o,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let o of c.nodeModuleName)this._factories.set(o,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(o=>c.alternativeModuleName(o))}};d=Ve([$e(2,i.IInstantiationService),$e(3,y.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,f.ILogService)],d),e.RequireInterceptor=d;class w{constructor(c,o,v,t,h){this._apiFactory=c,this._extensionPaths=o,this._extensionRegistry=v,this._configProvider=t,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,o){const v=this._extensionPaths.findSubstr(o);if(v){let t=this._extApiImpl.get(_.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(_.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((h,s)=>t+=`	${s} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(c,o){this.nodeModuleName="keytar";const{environment:v}=o,t=c.getProxy(C.MainContext.MainThreadKeytar);if(v.appRoot){let h=v.appRoot.fsPath;l.platform==="win32"&&(h=h.replace(/\\/g,"/")),h[h.length-1]==="/"&&(h=h.substr(0,h.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${h}/node_modules.asar/keytar`),this.alternativeNames.add(`${h}/node_modules/keytar`)}this._impl={getPassword:(h,s)=>t.$getPassword(h,s),setPassword:(h,s,n)=>t.$setPassword(h,s,n),deletePassword:(h,s)=>t.$deletePassword(h,s),findPassword:h=>t.$findPassword(h),findCredentials(h){return t.$findCredentials(h)}}}load(c,o){return this._impl}alternativeModuleName(c){const o=c.length;if(o<=7||!this.alternativeNames)return;const v=o-7;if((c.charAt(v)==="/"||c.charAt(v)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};D=Ve([$e(0,S.IExtHostRpcService),$e(1,P.IExtHostInitDataService)],D);let I=class{constructor(c,o,v){this._extensionPaths=c,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(C.MainContext.MainThreadTelemetry);const t=v.getProxy(C.MainContext.MainThreadWindow);this._impl=(h,s)=>{const n=F.URI.parse(h);return s?this.callOriginal(h,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,h,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,h,{}):this.callOriginal(h,s)}}load(c,o,v){const t=this._extensionPaths.findSubstr(o);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(c),this._impl}callOriginal(c,o){return this.sendNoForwardTelemetry(),this._original(c,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Ve([$e(2,S.IExtHostRpcService)],I)}),define(fe[272],me([0,1,172,11,7,212,36,41,45,37,33,14,57,196,17,213,56]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let I=class extends l.ExtHostDebugServiceBase{constructor(o,v,t,h,s,n,r){super(o,v,t,h,s,r);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(o,v){switch(o.type){case"server":return new y.SocketDebugAdapter(o);case"pipeServer":return new y.NamedPipeDebugAdapter(o);case"executable":return new y.ExecutableDebugAdapter(o,v.type)}return super.createDebugAdapter(o,v)}daExecutableFromPackage(o,v){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),o.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(o,v){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),h=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=o.title||m.localize(0,null),r=JSON.stringify({shell:h,shellArgs:s});let a=await this._integratedTerminalInstances.checkout(r,n),u,p=!1;if(a)u=o.cwd;else{const L={shellPath:h,shellArgs:s,cwd:o.cwd,name:n,iconPath:new C.ThemeIcon("debug")};p=!0,a=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(a,r)}a.show(!0);const E=await a.processId;p?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0||h.indexOf("cmd.exe")>=0?a.sendText("cls"):h.indexOf("bash")>=0?a.sendText("clear"):F.isWindows?a.sendText("cls"):a.sendText("clear"));const g=(0,w.prepareCommand)(h,o.args,u,o.env);a.sendText(g);const T=this.onDidTerminateDebugSession(L=>{L.id===v&&(this._integratedTerminalInstances.free(a),T.dispose())});return E}else if(o.kind==="external")return(0,w.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,v)}createVariableResolver(o,v,t){return new l.ExtHostVariableResolverService(o,v,t,this._editorTabs,this._workspaceService)}};I=Ve([$e(0,k.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,_.IExtHostExtensionService),$e(3,S.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,D.IExtHostEditorTabs)],I),e.ExtHostDebugService=I;class b{constructor(){this._terminalInstances=new Map}async checkout(o,v){const h=[...this._terminalInstances.entries()].map(([s,n])=>(0,d.createCancelablePromise)(async r=>{if(s.name!==v||n.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await s.processId))return null;const a=Date.now();return n.lastUsedAt+b.minUseDelay>a||r.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=a,s)}));return await(0,d.firstParallel)(h,s=>!!s)}insert(o,v){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:v})}free(o){const v=this._terminalInstances.get(o);v&&(v.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}b.minUseDelay=1e3}),define(fe[273],me([0,1,8,2,114,36,57,45,37,44,33,14,27,73,10,13,68,56,23,81]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends f.ExtHostTaskBase{constructor(t,h,s,n,r,a,u,p,E){super(t,h,s,n,r,a,u,p);this.workspaceService=s,this.editorTabs=E,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(d.Schemas.file,{scheme:d.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,h){const s=h;if(!h.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const n=f.TaskHandleDTO.from(s,this.workspaceService),r=await this._proxy.$getTaskExecution(n);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(r,h);return this._proxy.$executeTask(n).catch(()=>{}),a}else{const n=f.TaskDTO.from(h,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,h,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),h);return this._proxy.$executeTask(n).catch(()=>{}),r}}provideTasksInternal(t,h,s,n){const r=[];if(n)for(let a of n){this.checkDeprecation(a,s),(!a.definition||!t[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const u=f.TaskDTO.from(a,s.extension);u&&(r.push(u),f.CustomExecutionDTO.is(u.execution)&&h.push(this.addCustomExecution(u,a,!0)))}return{tasks:r,extension:s.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(t,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let h=t&&t.length>0?t[0]:void 0;if(!h){const s=F.URI.file((0,c.homedir)());h=new P.WorkspaceFolder({uri:s,name:b.basename(s),index:0})}return{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,h){const s=F.URI.revive(t),n={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(s),a=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.getVariableResolver(a),p=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(let E of h.variables)n.variables[E]=await u.resolveAsync(p,E);if(h.process!==void 0){let E;if(h.process.path!==void 0){E=h.process.path.split(m.delimiter);for(let g=0;g<E.length;g++)E[g]=await u.resolveAsync(p,E[g])}n.process=await C.win32.findExecutable(await u.resolveAsync(p,h.process.name),h.process.cwd!==void 0?await u.resolveAsync(p,h.process.cwd):void 0,E)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,h,s){return C.win32.findExecutable(t,h,s)}};o=Ve([$e(0,k.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,S.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,w.ILogService),$e(7,D.IExtHostApiDeprecationService),$e(8,I.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(fe[274],me([0,1,17,18,74,6,2,5,266,13,83,85,27,190,14,67,41,33]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,v,t,h){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(o,null,h),v=b._transform(v,this._rpcProtocol);const s=new k.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),s.set(w.IURITransformerService,new w.URITransformerService(h)),s.set(D.IHostUtils,t);const n=new f.InstantiationService(s,!0),r=n.invokeFunction(E=>E.get(I.IExtHostTerminalService));this._disposables.add(r),this._logService=n.invokeFunction(E=>E.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=n.invokeFunction(E=>E.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const a=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(g,T)=>{let L="",M,R;for(const W of T)L+=`
	at ${W.toString()}`,R=W.getFileName(),!M&&R&&(M=E.findSubstr(A.URI.file(R)));return a.set(g,M),`${g.name||"Error"}: ${g.message||""}${L}`}});const u=this._rpcProtocol.getProxy(_.MainContext.MainThreadExtensionService),p=this._rpcProtocol.getProxy(_.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(E=>{const g=F.transformErrorForSerialization(E),T=a.get(E);T?u.$onExtensionRuntimeError(T.identifier,g):p.$onUnexpectedError(g)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,v){o.extensions.forEach(h=>h.extensionLocation=A.URI.revive(v.transformIncomingURIs(h.extensionLocation))),o.environment.appRoot=A.URI.revive(v.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(h=>A.URI.revive(v.transformIncomingURIs(h)))),o.environment.extensionTestsLocationURI=A.URI.revive(v.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=A.URI.revive(v.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=A.URI.revive(v.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=A.URI.revive(v.transformIncomingURIs(o.logsLocation)),o.logFile=A.URI.revive(v.transformIncomingURIs(o.logFile)),o.workspace=v.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(fe[275],me([0,1,8,21,52,30,23,46,31]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,f,d){this.config=l,this.provider=f,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const f=this.config.folderQueries||[];return new Promise((d,w)=>{const D=I=>{this.resultCount++,l(I)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const b=I.toString(),c=m.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,c)||this.matchFile(D,{base:I,basename:c})}),Promise.all(f.map(I=>this.searchInFolder(I,D))).then(I=>{d({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{w(new Error((0,C.toErrorMessage)(I)))})})}async searchInFolder(l,f){const d=new F.CancellationTokenSource,w=this.getSearchOptionsForFolder(l),D=this.initDirectoryTree(),I=new S.QueryGlobTester(this.config,l),b=!I.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(d),c=_.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,d.token),v=c.elapsed(),t=_.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(h=>{const s=m.posix.relative(l.folder.path,h.path);if(b){const n=m.basename(h.path);this.matchFile(f,{base:l.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(D,l.folder,s,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,I,f),{providerTime:v,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(l){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),d=(0,S.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:d,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},f,d,w){if(d===this.filePattern){const I=m.basename(this.filePattern);this.matchFile(w,{base:f,relativePath:this.filePattern,basename:I})}function D(I){const b=m.basename(I),c=m.dirname(I);let o=l[c];o||(o=l[c]=[],D(c)),o.push({base:f,relativePath:I,basename:b})}D(d)}matchDirectoryTree({rootEntries:l,pathToEntries:f},d,w){const D=this,I=this.filePattern;function b(c){const o=y.hasSiblingFn(()=>c.map(v=>v.basename));for(let v=0,t=c.length;v<t;v++){const h=c[v],{relativePath:s,basename:n}=h;if(d.matchesExcludesSync(s,n,I!==n?o:void 0))continue;const r=f[s];if(r)b(r);else{if(s===I)continue;D.matchFile(w,h)}if(D.isLimitHit)break}}b(l)}matchFile(l,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(f))}}class i{constructor(){this.sessions=new Map}fileSearch(l,f,d,w){const D=this.getSessionTokenSource(l.cacheKey),I=new P(l,f,D&&D.token);let b=0;const c=o=>{b+=o.length,d(o.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(I,i.BATCH_SIZE,c,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(l){const f=this.getSessionTokenSource(l);f&&f.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new F.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,f,d,w){w.onCancellationRequested(()=>{l.cancel()});const D=b=>{b&&(I.push(b),f>0&&I.length>=f&&(d(I),I=[]))};let I=[];return l.search(D).then(b=>(I.length&&d(I),b),b=>(I.length&&d(I),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,16,21,52,30,10,8,23,12,2,31]),function(Y,e,m,F,C,y,A,_,S,P,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(c,o,v,t){this.query=c,this.provider=o,this.fileUtils=v,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,o){const v=this.query.folderQueries||[],t=new F.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((h,s)=>{this.collector=new d(c);let n=!1;const r=(a,u)=>{if(!n&&!this.isLimitHit){const p=this.resultSize(a);D(a)&&typeof this.query.maxResults=="number"&&this.resultCount+p>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const E=this.resultSize(a);this.resultCount+=E,(E>0||!D(a))&&this.collector.add(a,u)}};Promise.all(v.map((a,u)=>this.searchInFolder(a,p=>r(p,u),t.token))).then(a=>{t.dispose(),this.collector.flush();const u=a.some(p=>!!p&&!!p.limitHit);h({limitHit:this.isLimitHit||u,messages:(0,m.flatten)(a.map(p=>p?.message?(0,P.isArray)(p.message)?p.message:[p.message]:[])),stats:{type:this.processType}})},a=>{t.dispose();const u=(0,C.toErrorMessage)(a);s(new Error(u))})})}resultSize(c){return D(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,o){const v=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:v.slice(0,o),preview:{matches:t.slice(0,o),text:c.preview.text},uri:c.uri}}async searchInFolder(c,o,v){const t=new k.QueryGlobTester(this.query,c),h=[],s={report:a=>{if(!this.validateProviderResult(a))return;const u=c.folder.scheme===A.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,p=S.relativePath(c.folder,a.uri);if(p){const E=t.includedInQuery(p,_.basename(p),u);(0,P.isPromise)(E)?h.push(E.then(g=>{g&&o(a)})):E&&o(a)}}},n=this.getSearchOptionsForFolder(c),r=await this.provider.provideTextSearchResults(f(this.query.contentPattern),n,s,v);return h.length&&await Promise.all(h),r}validateProviderResult(c){if(D(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const o=(0,k.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:i.URI.from(c.folder),excludes:v,includes:o,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,o=>this.sendItems(o))}add(c,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!S.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(w(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function w(b){return D(b)?{preview:{matches:(0,m.mapArrayOrNot)(b.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:b.preview.text},ranges:(0,m.mapArrayOrNot)(b.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function D(b){return!!b.preview}e.extensionResultIsMatch=D;class I{constructor(c,o){this.maxBatchSize=c,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,o){!c||this.addItemToBatch(c,o)}addItems(c,o){!c||this.addItemsToBatch(c,o)}addItemToBatch(c,o){this.batch.push(c),this.batchSize+=o,this.onUpdate()}addItemsToBatch(c,o){this.batch=this.batch.concat(c),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,275,14,67,13,2,135]),function(Y,e,m,F,C,y,A,_,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(w,D,I){this.extHostRpc=w,this._uriTransformer=D,this._logService=I,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,D){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const I=this._handlePool++;return this._textSearchProvider.set(I,D),this._proxy.$registerTextSearchProvider(I,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(w,D){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const I=this._handlePool++;return this._fileSearchProvider.set(I,D),this._proxy.$registerFileSearchProvider(I,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(w,D,I,b){const c=l(I),o=this._fileSearchProvider.get(w);if(o)return this._fileSearchManager.fileSearch(c,o,v=>{this._proxy.$handleFileMatch(w,D,v.map(t=>t.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,D,I,b){const c=this._textSearchProvider.get(w);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=l(I);return this.createTextSearchManager(o,c).search(t=>this._proxy.$handleTextMatch(w,D,t),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,D){return new i.TextSearchManager(w,D,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};k=Ve([$e(0,A.IExtHostRpcService),$e(1,_.IURITransformerService),$e(2,S.ILogService)],k),e.ExtHostSearch=k;function l(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(f),extraFileResources:d.extraFileResources&&d.extraFileResources.map(w=>P.URI.revive(w))}}e.reviveQuery=l;function f(d){return{...d,folder:P.URI.revive(d.folder)}}}),define(fe[276],me([0,1,21,18,3,49,2,115,110,148,82,43,5,234,233,40,235,37,236,237,238,219,239,45,41,240,220,243,244,245,69,222,250,251,252,92,33,254,223,15,7,257,71,134,36,35,59,208,242,64,133,73,57,75,13,67,14,27,246,205,54,68,231,255,204,70,91,260,258,259,232,53,253,256,90,56,124,248,72,249,10,192,247,202,241]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c,o,v,t,h,s,n,r,a,u,p,E,g,T,L,M,R,W,V,N,j,U,x,z,O,$,B,X,Q,de,_e,ye,ke,Be,We,He,q,ee,re,le,Z,ae,pe,Me,je,Ke,Je,st,Te,nt,J,ne,ve,Qe,tt,ct,ce,Ie,Ue,Xe,rt,ht,Ye,vt,Re,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Pe(se){const ue=se.get(re.IExtHostInitDataService),be=se.get(ve.IExtHostFileSystemInfo),we=se.get(st.IExtHostConsumerFileSystem),Fe=se.get(s.IExtHostExtensionService),qe=se.get($.IExtHostWorkspace),ze=se.get(Ie.IExtHostTelemetry),et=se.get(I.IExtHostConfiguration),at=se.get(q.IURITransformerService),xe=se.get(ee.IExtHostRpcService),ge=se.get(R.IExtHostStorage),Ee=se.get(Je.IExtensionStoragePaths),te=se.get(He.ILogService),K=se.get(ae.IExtHostTunnelService),Se=se.get(pe.IExtHostApiDeprecationService),Le=se.get(O.IExtHostWindow),it=se.get(ct.IExtHostSecretState),Ge=se.get(ce.IExtHostEditorTabs);xe.set(l.ExtHostContext.ExtHostFileSystemInfo,be),xe.set(l.ExtHostContext.ExtHostLogService,te),xe.set(l.ExtHostContext.ExtHostWorkspace,qe),xe.set(l.ExtHostContext.ExtHostConfiguration,et),xe.set(l.ExtHostContext.ExtHostExtensionService,Fe),xe.set(l.ExtHostContext.ExtHostStorage,ge),xe.set(l.ExtHostContext.ExtHostTunnelService,K),xe.set(l.ExtHostContext.ExtHostWindow,Le),xe.set(l.ExtHostContext.ExtHostSecretState,it),xe.set(l.ExtHostContext.ExtHostTelemetry,ze),xe.set(l.ExtHostContext.ExtHostEditorTabs,Ge);const pt=xe.set(l.ExtHostContext.ExtHostDecorations,se.get(ye.IExtHostDecorations)),Et=xe.set(l.ExtHostContext.ExtHostDocumentsAndEditors,se.get(h.IExtHostDocumentsAndEditors)),ft=xe.set(l.ExtHostContext.ExtHostCommands,se.get(w.IExtHostCommands)),bt=xe.set(l.ExtHostContext.ExtHostTerminalService,se.get(W.IExtHostTerminalService)),mt=xe.set(l.ExtHostContext.ExtHostDebugService,se.get(Be.IExtHostDebugService)),_t=xe.set(l.ExtHostContext.ExtHostSearch,se.get(We.IExtHostSearch)),Dt=xe.set(l.ExtHostContext.ExtHostTask,se.get(ke.IExtHostTask)),Bt=xe.set(l.ExtHostContext.ExtHostOutputService,se.get(E.IExtHostOutputService)),Vt=xe.set(l.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(xe)),kt=xe.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(xe,Et)),$t=xe.set(l.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(xe,Et,te)),en=xe.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(te,kt,xe.getProxy(l.MainContext.MainThreadBulkEdits))),St=xe.set(l.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(xe,ft,Et,kt,Ee)),Qt=xe.set(l.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(te,St)),jt=xe.set(l.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(te,xe,St)),tn=xe.set(l.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(xe,ue,St,ft,te)),nn=xe.set(l.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(xe,St)),Tt=xe.set(l.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(xe,Et)),Xt=xe.set(l.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(xe.getProxy(l.MainContext.MainThreadTreeViews),ft,te)),bn=xe.set(l.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(xe.getProxy(l.MainContext.MainThreadEditorInsets),Tt,ue)),Wt=xe.set(l.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,te,be)),Ht=xe.set(l.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(xe,kt,ft.converter,at)),wt=xe.set(l.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(xe,at,kt,ft,Wt,te,Se)),rn=xe.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(xe,wt)),Ot=xe.set(l.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(xe,te,Et)),Nt=xe.set(l.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(xe,qe,ft)),Yt=xe.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(xe,ft,te)),En=xe.set(l.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(xe,ft,kt)),fn=xe.set(l.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(xe.getProxy(l.MainContext.MainThreadProgress))),_n=xe.set(l.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),mn=xe.set(l.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(xe)),sn=xe.set(l.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(xe)),on=xe.set(l.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(xe,ft)),qt=xe.set(l.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(xe,{remote:ue.remote},qe,te,Se)),an=xe.set(l.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(xe,qt,qe)),Sn=xe.set(l.ExtHostContext.ExtHostCustomEditors,new nt.ExtHostCustomEditors(xe,kt,Ee,qt,an)),yn=xe.set(l.ExtHostContext.ExtHostWebviewViews,new Te.ExtHostWebviewViews(xe,qt)),Gt=xe.set(l.ExtHostContext.ExtHostTesting,new Qe.ExtHostTesting(xe,ft)),Jt=xe.set(l.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(xe));xe.set(l.ExtHostContext.ExtHostInteractive,new Ce.ExtHostInteractive(xe,St,Et,ft));const Dn=(0,X.values)(l.ExtHostContext);xe.assertRegistered(Dn);const Cn=new ne.ExtHostBulkEdits(xe,Et),ln=new d.ExtHostClipboard(xe),cn=new p.ExtHostMessageService(xe,te),zt=new c.ExtHostDialogs(xe),Ft=new M.ExtHostStatusBar(xe,ft.converter);return f.ExtHostApiCommands.register(ft),function(Ne,Rt,Kt){const yt=function(){let ie=!Ne.isUnderDevelopment;function he(Ae){ie||(te.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(ut){if(Array.isArray(ut))ut.forEach(Ae);else if(typeof ut=="string")he(ut);else{const Ct=ut;typeof Ct.scheme=="undefined"&&he(ut),!Ne.enableProposedApi&&typeof Ct.exclusive=="boolean"&&(0,B.throwProposedApiError)(Ne)}return ut}}(),kn={getSession(ie,he,Ae){return Ae?.forceNewSession&&(0,B.checkProposedApiEnabled)(Ne),sn.getSession(Ne,ie,he,Ae)},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(ie,he,Ae,ut){return sn.registerAuthenticationProvider(ie,he,Ae,ut)}},In={registerCommand(ie,he,Ae){return ft.registerCommand(!0,ie,he,Ae,void 0,Ne)},registerTextEditorCommand(ie,he,Ae){return ft.registerCommand(!0,ie,(...ut)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){te.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Ae,[Ct,Pt,...ut])}).then(Pt=>{Pt||te.warn("Edits from command "+ie+" were not applied.")},Pt=>{te.warn("An error occurred while running command "+ie,Pt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ie,he,Ae)=>((0,B.checkProposedApiEnabled)(Ne),ft.registerCommand(!0,ie,async(...ut)=>{const Ct=Et.activeEditor(!0);if(!Ct){te.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(Ct.id);he.apply(Ae,[Pt,...ut])},void 0,void 0,Ne)),executeCommand(ie,...he){return ft.executeCommand(ie,...he)},getCommands(ie=!1){return ft.getCommands(ie)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Le.openUri(ie,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===ue.environment.appUriScheme)return Vt.createAppUri(ie);try{return await Le.asExternalUri(ie,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,Ye.matchesScheme)(ie,ht.Schemas.http)||(0,Ye.matchesScheme)(ie,ht.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,B.checkProposedApiEnabled)(Ne),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pn={createTestController(ie,he){return Gt.createTestController(ie,he)},createTestObserver(){return(0,B.checkProposedApiEnabled)(Ne),Gt.createTestObserver()},runTests(ie){return(0,B.checkProposedApiEnabled)(Ne),Gt.runTests(ie)},get onDidChangeTestResults(){return(0,B.checkProposedApiEnabled)(Ne),Gt.onResultsChanged},get testResults(){return(0,B.checkProposedApiEnabled)(Ne),Gt.results}},Tn={getExtension(ie){const he=Rt.getExtensionDescription(ie);if(he)return new s.Extension(Fe,Ne.identifier,he,pn)},get all(){return Rt.getAllExtensionDescriptions().map(ie=>new s.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Rt.onDidChange}},un={createDiagnosticCollection(ie){return Wt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:ie=>Wt.getDiagnostics(ie),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(ie,he){return Ht.changeLanguage(ie.uri,he)},match(ie,he){return(0,i.score)(j.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Ae){return wt.registerCodeActionProvider(Ne,yt(ie),he,Ae)},registerCodeLensProvider(ie,he){return wt.registerCodeLensProvider(Ne,yt(ie),he)},registerDefinitionProvider(ie,he){return wt.registerDefinitionProvider(Ne,yt(ie),he)},registerDeclarationProvider(ie,he){return wt.registerDeclarationProvider(Ne,yt(ie),he)},registerImplementationProvider(ie,he){return wt.registerImplementationProvider(Ne,yt(ie),he)},registerTypeDefinitionProvider(ie,he){return wt.registerTypeDefinitionProvider(Ne,yt(ie),he)},registerHoverProvider(ie,he){return wt.registerHoverProvider(Ne,yt(ie),he,Ne.identifier)},registerEvaluatableExpressionProvider(ie,he){return wt.registerEvaluatableExpressionProvider(Ne,yt(ie),he,Ne.identifier)},registerInlineValuesProvider(ie,he){return wt.registerInlineValuesProvider(Ne,yt(ie),he,Ne.identifier)},registerDocumentHighlightProvider(ie,he){return wt.registerDocumentHighlightProvider(Ne,yt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return wt.registerLinkedEditingRangeProvider(Ne,yt(ie),he)},registerReferenceProvider(ie,he){return wt.registerReferenceProvider(Ne,yt(ie),he)},registerRenameProvider(ie,he){return wt.registerRenameProvider(Ne,yt(ie),he)},registerDocumentSymbolProvider(ie,he,Ae){return wt.registerDocumentSymbolProvider(Ne,yt(ie),he,Ae)},registerWorkspaceSymbolProvider(ie){return wt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,he){return wt.registerDocumentFormattingEditProvider(Ne,yt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return wt.registerDocumentRangeFormattingEditProvider(Ne,yt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Ae,...ut){return wt.registerOnTypeFormattingEditProvider(Ne,yt(ie),he,[Ae].concat(ut))},registerDocumentSemanticTokensProvider(ie,he,Ae){return wt.registerDocumentSemanticTokensProvider(Ne,yt(ie),he,Ae)},registerDocumentRangeSemanticTokensProvider(ie,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Ne,yt(ie),he,Ae)},registerSignatureHelpProvider(ie,he,Ae,...ut){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Ne,yt(ie),he,Ae):wt.registerSignatureHelpProvider(Ne,yt(ie),he,typeof Ae=="undefined"?[]:[Ae,...ut])},registerCompletionItemProvider(ie,he,...Ae){return wt.registerCompletionItemProvider(Ne,yt(ie),he,Ae)},registerInlineCompletionItemProvider(ie,he){return(0,B.checkProposedApiEnabled)(Ne),wt.registerInlineCompletionsProvider(Ne,yt(ie),he)},registerDocumentLinkProvider(ie,he){return wt.registerDocumentLinkProvider(Ne,yt(ie),he)},registerColorProvider(ie,he){return wt.registerColorProvider(Ne,yt(ie),he)},registerFoldingRangeProvider(ie,he){return wt.registerFoldingRangeProvider(Ne,yt(ie),he)},registerSelectionRangeProvider(ie,he){return wt.registerSelectionRangeProvider(Ne,ie,he)},registerCallHierarchyProvider(ie,he){return wt.registerCallHierarchyProvider(Ne,ie,he)},registerTypeHierarchyProvider(ie,he){return wt.registerTypeHierarchyProvider(Ne,ie,he)},setLanguageConfiguration:(ie,he)=>wt.setLanguageConfiguration(Ne,ie,he),getTokenInformationAtPosition(ie,he){return(0,B.checkProposedApiEnabled)(Ne),Ht.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,B.checkProposedApiEnabled)(Ne),wt.registerInlayHintsProvider(Ne,ie,he)},createLanguageStatusItem(ie,he){return(0,B.checkProposedApiEnabled)(Ne),Ht.createLanguageStatusItem(Ne,ie,he)}},An={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,he,Ae){const ut=await(A.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Tt.showTextDocument(ut,he,Ae)},createTextEditorDecorationType(ie){return Tt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,he,Ae){return Tt.onDidChangeActiveTextEditor(ie,he,Ae)},onDidChangeVisibleTextEditors(ie,he,Ae){return Tt.onDidChangeVisibleTextEditors(ie,he,Ae)},onDidChangeTextEditorSelection(ie,he,Ae){return Tt.onDidChangeTextEditorSelection(ie,he,Ae)},onDidChangeTextEditorOptions(ie,he,Ae){return Tt.onDidChangeTextEditorOptions(ie,he,Ae)},onDidChangeTextEditorVisibleRanges(ie,he,Ae){return Tt.onDidChangeTextEditorVisibleRanges(ie,he,Ae)},onDidChangeTextEditorViewColumn(ie,he,Ae){return Tt.onDidChangeTextEditorViewColumn(ie,he,Ae)},onDidCloseTerminal(ie,he,Ae){return bt.onDidCloseTerminal(ie,he,Ae)},onDidOpenTerminal(ie,he,Ae){return bt.onDidOpenTerminal(ie,he,Ae)},onDidChangeActiveTerminal(ie,he,Ae){return bt.onDidChangeActiveTerminal(ie,he,Ae)},onDidChangeTerminalDimensions(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),bt.onDidChangeTerminalDimensions(ie,he,Ae)},onDidChangeTerminalState(ie,he,Ae){return bt.onDidChangeTerminalState(ie,he,Ae)},onDidWriteTerminalData(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),bt.onDidWriteTerminalData(ie,he,Ae)},get state(){return Le.state},onDidChangeWindowState(ie,he,Ae){return Le.onDidChangeWindowState(ie,he,Ae)},showInformationMessage(ie,...he){return cn.showMessage(Ne,y.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return cn.showMessage(Ne,y.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return cn.showMessage(Ne,y.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Ae){return Nt.showQuickPick(ie,!!Ne.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Nt.showInput(ie,he)},showOpenDialog(ie){return zt.showOpenDialog(ie)},showSaveDialog(ie){return zt.showSaveDialog(ie)},createStatusBarItem(ie,he,Ae){let ut,Ct,Pt;return typeof ie=="string"?(ut=ie,Ct=he,Pt=Ae):(Ct=ie,Pt=he),Ft.createStatusBarEntry(Ne,ut,Ct,Pt)},setStatusBarMessage(ie,he){return Ft.setStatusBarMessage(ie,he)},withScmProgress(ie){return Se.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:U.ProgressLocation.SourceControl},(he,Ae)=>ie({report(ut){}}))},withProgress(ie,he){return fn.withProgress(Ne,ie,he)},createOutputChannel(ie){return Bt.createOutputChannel(ie,Ne)},createWebviewPanel(ie,he,Ae,ut){return an.createWebviewPanel(Ne,ie,he,Ae,ut)},createWebviewTextEditorInset(ie,he,Ae,ut){return(0,B.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,he,Ae,ut,Ne)},createTerminal(ie,he,Ae){return typeof ie=="object"?("location"in ie&&(0,B.checkProposedApiEnabled)(Ne),"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie)):bt.createTerminal(ie,he,Ae)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return bt.registerProfileProvider(Ne,ie,he)},registerTreeDataProvider(ie,he){return Xt.registerTreeDataProvider(ie,he,Ne)},createTreeView(ie,he){return Xt.createTreeView(ie,he,Ne)},registerWebviewPanelSerializer:(ie,he)=>an.registerWebviewPanelSerializer(Ne,ie,he),registerCustomEditorProvider:(ie,he,Ae={})=>Sn.registerCustomEditorProvider(Ne,ie,he,Ae),registerFileDecorationProvider(ie){return pt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return Vt.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Nt.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Ae){return mn.onDidChangeActiveColorTheme(ie,he,Ae)},registerWebviewViewProvider(ie,he,Ae){return yn.registerWebviewViewProvider(Ne,ie,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,B.checkProposedApiEnabled)(Ne),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),St.onDidChangeActiveNotebookEditor(ie,he,Ae)},get visibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorSelection(ie,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorVisibleRanges(ie,he,Ae)},showNotebookDocument(ie,he){return(0,B.checkProposedApiEnabled)(Ne),St.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,ie,he,Ae)},get tabs(){return(0,B.checkProposedApiEnabled)(Ne),Ge.tabs},get activeTab(){return(0,B.checkProposedApiEnabled)(Ne),Ge.activeTab},get onDidChangeTabs(){return(0,B.checkProposedApiEnabled)(Ne),Ge.onDidChangeTabs},get onDidChangeActiveTab(){return(0,B.checkProposedApiEnabled)(Ne),Ge.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,B.checkProposedApiEnabled)(Ne),a.InlineCompletionController.get(ie)}},vn={get rootPath(){return Se.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(ie){throw F.readonly()},getWorkspaceFolder(ie){return qe.getWorkspaceFolder(ie)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(ie){throw F.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(ie){throw F.readonly()},updateWorkspaceFolders:(ie,he,...Ae)=>qe.updateWorkspaceFolders(Ne,ie,he||0,...Ae),onDidChangeWorkspaceFolders:function(ie,he,Ae){return qe.onDidChangeWorkspace(ie,he,Ae)},asRelativePath:(ie,he)=>qe.getRelativePath(ie,he),findFiles:(ie,he,Ae,ut)=>qe.findFiles(j.GlobPattern.from(ie),j.GlobPattern.from(he),Ae,Ne.identifier,ut),findTextInFiles:(ie,he,Ae,ut)=>{let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Ae):(Ct={},Pt=he,ut=Ae),qe.findTextInFiles(ie,Ct||{},Pt,Ne.identifier,ut)},saveAll:ie=>qe.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Ae,ut)=>Ot.createFileSystemWatcher(j.GlobPattern.from(ie),he,Ae,ut),get textDocuments(){return kt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw F.readonly()},openTextDocument(ie){let he;const Ae=ie;if(typeof ie=="string")he=Promise.resolve(A.URI.file(ie));else if(A.URI.isUri(ie))he=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ut=>kt.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(ie,he,Ae)=>kt.onDidAddDocument(ie,he,Ae),onDidCloseTextDocument:(ie,he,Ae)=>kt.onDidRemoveDocument(ie,he,Ae),onDidChangeTextDocument:(ie,he,Ae)=>kt.onDidChangeDocument(ie,he,Ae),onDidSaveTextDocument:(ie,he,Ae)=>kt.onDidSaveDocument(ie,he,Ae),onWillSaveTextDocument:(ie,he,Ae)=>en.getOnWillSaveTextDocumentEvent(Ne)(ie,he,Ae),get notebookDocuments(){return St.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Ae;if(A.URI.isUri(ie))Ae=ie,await St.openNotebookDocument(ie);else if(typeof ie=="string")Ae=A.URI.revive(await St.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Ae,ut){return St.registerNotebookSerializer(Ne,ie,he,Ae,Ne.enableProposedApi?ut:void 0)},registerNotebookContentProvider:(ie,he,Ae,ut)=>((0,B.checkProposedApiEnabled)(Ne),St.registerNotebookContentProvider(Ne,ie,he,Ae,Ne.enableProposedApi?ut:void 0)),onDidChangeConfiguration:(ie,he,Ae)=>Kt.onDidChangeConfiguration(ie,he,Ae),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,Kt.getConfiguration(ie,he,Ne)},registerTextDocumentContentProvider(ie,he){return $t.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Se.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Ne,ie,he)),registerFileSystemProvider(ie,he,Ae){return rn.registerFileSystemProvider(Ne.identifier,ie,he,Ae)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,B.checkProposedApiEnabled)(Ne),_t.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,B.checkProposedApiEnabled)(Ne),_t.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,B.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,B.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Ae)=>Ot.onDidCreateFile(ie,he,Ae),onDidDeleteFiles:(ie,he,Ae)=>Ot.onDidDeleteFile(ie,he,Ae),onDidRenameFiles:(ie,he,Ae)=>Ot.onDidRenameFile(ie,he,Ae),onWillCreateFiles:(ie,he,Ae)=>Ot.getOnWillCreateFileEvent(Ne)(ie,he,Ae),onWillDeleteFiles:(ie,he,Ae)=>Ot.getOnWillDeleteFileEvent(Ne)(ie,he,Ae),onWillRenameFiles:(ie,he,Ae)=>Ot.getOnWillRenameFileEvent(Ne)(ie,he,Ae),openTunnel:ie=>((0,B.checkProposedApiEnabled)(Ne),K.openTunnel(Ne,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,B.checkProposedApiEnabled)(Ne),K.getTunnels()},onDidChangeTunnels:(ie,he,Ae)=>((0,B.checkProposedApiEnabled)(Ne),K.onDidChangeTunnels(ie,he,Ae)),registerPortAttributesProvider:(ie,he)=>((0,B.checkProposedApiEnabled)(Ne),K.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,B.checkProposedApiEnabled)(Ne),on.registerTimelineProvider(ie,he,Ne.identifier,ft.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:ie=>((0,B.checkProposedApiEnabled)(Ne),qe.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Ae)=>qe.onDidGrantWorkspaceTrust(ie,he,Ae)},Rn={get inputBox(){return Se.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Ne)},createSourceControl(ie,he,Ae){return Yt.createSourceControl(Ne,ie,he,Ae)}},Ln={createCommentController(ie,he){return En.createCommentController(Ne,ie,he)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ie,he,Ae){return mt.onDidStartDebugSession(ie,he,Ae)},onDidTerminateDebugSession(ie,he,Ae){return mt.onDidTerminateDebugSession(ie,he,Ae)},onDidChangeActiveDebugSession(ie,he,Ae){return mt.onDidChangeActiveDebugSession(ie,he,Ae)},onDidReceiveDebugSessionCustomEvent(ie,he,Ae){return mt.onDidReceiveDebugSessionCustomEvent(ie,he,Ae)},onDidChangeBreakpoints(ie,he,Ae){return mt.onDidChangeBreakpoints(ie,he,Ae)},registerDebugConfigurationProvider(ie,he,Ae){return mt.registerDebugConfigurationProvider(ie,he,Ae||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return mt.registerDebugAdapterDescriptorFactory(Ne,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return mt.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?mt.startDebugging(ie,he,{parentSession:Ae}):mt.startDebugging(ie,he,Ae||{})},stopDebugging(ie){return mt.stopDebugging(ie)},addBreakpoints(ie){return mt.addBreakpoints(ie)},removeBreakpoints(ie){return mt.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return mt.asDebugSourceUri(ie,he)}},Mn={registerTaskProvider:(ie,he)=>Dt.registerTaskProvider(Ne,ie,he),fetchTasks:ie=>Dt.fetchTasks(ie),executeTask:ie=>Dt.executeTask(Ne,ie),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(ie,he,Ae)=>Dt.onDidStartTask(ie,he,Ae),onDidEndTask:(ie,he,Ae)=>Dt.onDidEndTask(ie,he,Ae),onDidStartTaskProcess:(ie,he,Ae)=>Dt.onDidStartTaskProcess(ie,he,Ae),onDidEndTaskProcess:(ie,he,Ae)=>Dt.onDidEndTaskProcess(ie,he,Ae)},On={createNotebookController(ie,he,Ae,ut,Ct){return tn.createNotebookController(Ne,ie,he,Ae,ut,Ne.enableProposedApi?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>St.registerNotebookCellStatusBarItemProvider(Ne,ie,he),get onDidSaveNotebookDocument(){return(0,B.checkProposedApiEnabled)(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,B.checkProposedApiEnabled)(Ne),jt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return nn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),Qt.onDidChangeNotebookDocumentMetadata(ie,he,Ae)},onDidChangeNotebookCells(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),St.onDidChangeNotebookCells(ie,he,Ae)},onDidChangeNotebookCellExecutionState(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),St.onDidChangeNotebookCellExecutionState(ie,he,Ae)},onDidChangeCellOutputs(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),St.onDidChangeCellOutputs(ie,he,Ae)},onDidChangeCellMetadata(ie,he,Ae){return(0,B.checkProposedApiEnabled)(Ne),St.onDidChangeCellMetadata(ie,he,Ae)},createConcatTextDocument(ie,he){return(0,B.checkProposedApiEnabled)(Ne),new Ke.ExtHostNotebookConcatDocument(St,kt,ie,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:un,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:vn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:P.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:_.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:l.UIKind,Uri:A.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Pe}),define(fe[277],me([0,1,83,69,36,133,37,40,45,33,73,57,75,92,54,68,134,91,53,90,124,56]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,m.registerSingleton)(_.IExtHostCommands,_.ExtHostCommands),(0,m.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,m.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,m.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,m.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,m.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,m.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,m.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,m.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,m.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,m.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,m.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,m.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,m.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[93],me([0,1,16,13,31,72]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function _(k,l,f,d){const w=(0,m.mapArrayOrNot)(f,S),D=new C.TextSearchMatch(l,w,d),I=D.preview.matches;return{ranges:(0,m.mapArrayOrNot)(w,P),uri:k,preview:{text:D.preview.text,matches:(0,m.mapArrayOrNot)(I,P)}}}e.createTextSearchResult=_;function S(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function P(k){return new y.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let i=class{constructor(l,f){this.prefix=l,this.logService=f}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};i=Ve([$e(1,F.ILogService)],i),e.OutputChannel=i}),define(fe[278],me([0,1,97,22]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(h=>h===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,_=512*8,S=512*128;class P{constructor(h){this.iconvLiteDecoder=h}static async create(h){let s;if(h!==e.UTF8)s=(await new Promise((r,a)=>{Y(["iconv-lite-umd"],r,a)})).getDecoder(f(h));else{const n=new TextDecoder;s={write(r){return n.decode(r,{stream:!0})},end(){return n.decode()}}}return new P(s)}write(h){return this.iconvLiteDecoder.write(h)}end(){return this.iconvLiteDecoder.end()}}function i(t,h){const s=h.minBytesRequiredForDetection??h.guessEncoding?_:A;return new Promise((n,r)=>{const a=(0,m.newWriteableStream)(T=>T.join("")),u=[];let p=0,E;const g=async()=>{try{const T=await v({buffer:F.VSBuffer.concat(u),bytesRead:p},h.guessEncoding);T.encoding=await h.overwriteEncoding(T.encoding),E=await P.create(T.encoding);const L=E.write(F.VSBuffer.concat(u).buffer);a.write(L),u.length=0,p=0,n({stream:a,detected:T})}catch(T){r(T)}};(0,m.listenStream)(t,{onData:async T=>{E?a.write(E.write(T.buffer)):(u.push(T),p+=T.byteLength,p>=s&&(t.pause(),await g(),setTimeout(()=>t.resume())))},onError:T=>a.error(T),onEnd:async()=>{E||await g(),a.end(E?.end())}})})}e.toDecodeStream=i;async function k(t,h,s){const r=(await new Promise((p,E)=>{Y(["iconv-lite-umd"],p,E)})).getEncoder(f(h),s);let a=!1,u=!1;return{read(){if(u)return null;const p=t.read();if(typeof p!="string"){if(u=!0,!a&&s?.addBOM)switch(h){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=r.end();return E&&E.length>0?(a=!0,F.VSBuffer.wrap(E)):null}return a=!0,F.VSBuffer.wrap(r.write(p))}}}e.toEncodeReadable=k;async function l(t){return(await new Promise((s,n)=>{Y(["iconv-lite-umd"],s,n)})).encodingExists(f(t))}e.encodingExists=l;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function d(t,h){if(!t||h<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(h<e.UTF8_BOM.length)return null;const r=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&r===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const w=["ascii","utf-16","utf-32"];async function D(t){const h=await new Promise((u,p)=>{Y(["jschardet"],u,p)}),s=t.slice(0,S),n=c(s.buffer),r=h.detect(n);if(!r||!r.encoding)return null;const a=r.encoding.toLowerCase();return 0<=w.indexOf(a)?null:b(r.encoding)}const I={ibm866:"cp866",big5:"cp950"};function b(t){const h=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return I[h]||h}function c(t){let h="";for(let s=0;s<t.length;s++)h+=String.fromCharCode(t[s]);return h}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const h=t.match(/windows(\d+)/);return h?"windows-"+h[1]:t}}e.toCanonicalName=o;function v({buffer:t,bytesRead:h},s){let n=d(t,h),r=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let a=!0,u=!0,p=!1;for(let E=0;E<h&&E<y;E++){const g=E%2==1,T=t.readUInt8(E)===0;if(T&&(p=!0),a&&(g&&!T||!g&&T)&&(a=!1),u&&(g&&T||!g&&!T)&&(u=!1),T&&!a&&!u)break}p&&(a?n=e.UTF16le:u?n=e.UTF16be:r=!0)}return s&&!r&&!n&&t?D(t.slice(0,h)).then(a=>({seemsBinary:!1,encoding:a})):{seemsBinary:r,encoding:n}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,278,28,135]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends C.TextSearchManager{constructor(_,S,P=F,i="searchProcess"){super(_,S,{readdir:k=>P.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,m.toCanonicalName)(k)},i)}}e.NativeTextSearchManager=y}),define(fe[279],me([0,1,280,294,295,2,296]),function(Y,e,m,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function _(k,l,f,d,w,D){const I=D.environment.useHostProxy,b=typeof I=="boolean"?I:!D.remote.isRemote,c=(0,A.createProxyResolver)({resolveProxy:v=>k.resolveProxy(v),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(v,t,...h)=>{switch(v){case A.LogLevel.Trace:d.trace(t,...h);break;case A.LogLevel.Debug:d.debug(t,...h);break;case A.LogLevel.Info:d.info(t,...h);break;case A.LogLevel.Warning:d.warn(t,...h);break;case A.LogLevel.Error:d.error(t,...h);break;case A.LogLevel.Critical:d.critical(t,...h);break;case A.LogLevel.Off:break;default:s(v,t,h);break}function s(n,r,...a){d.error("Unknown log level",n),d.error(r,...a)}},getLogLevel:()=>d.getLevel(),proxyResolveTelemetry:v=>{w.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),o=S(l,c);return i(f,o)}e.connectProxyResolver=_;function S(k,l){const f={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(w=>{f.config=k.getConfiguration("http").get("proxySupport")||"off"});const d={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(w=>{d.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,A.createHttpPatch)(m,l,{config:"off"},d,!0)),on:Object.assign({},m,(0,A.createHttpPatch)(m,l,{config:"on"},d,!0)),override:Object.assign({},m,(0,A.createHttpPatch)(m,l,{config:"override"},d,!0)),onRequest:Object.assign({},m,(0,A.createHttpPatch)(m,l,f,d,!0)),default:Object.assign(m,(0,A.createHttpPatch)(m,l,f,d,!1))},https:{off:Object.assign({},F,(0,A.createHttpPatch)(F,l,{config:"off"},d,!0)),on:Object.assign({},F,(0,A.createHttpPatch)(F,l,{config:"on"},d,!0)),override:Object.assign({},F,(0,A.createHttpPatch)(F,l,{config:"override"},d,!0)),onRequest:Object.assign({},F,(0,A.createHttpPatch)(F,l,f,d,!0)),default:Object.assign(F,(0,A.createHttpPatch)(F,l,f,d,!1))},tls:Object.assign(C,(0,A.createTlsPatch)(C))}}const P=new Map;function i(k,l){return k.getExtensionPathIndex().then(f=>{const d=Y.__$__nodeRequire("module"),w=d._load;d._load=function(I,b,c){if(I==="tls")return l.tls;if(I!=="http"&&I!=="https")return w.apply(this,arguments);const o=l[I],v=f.findSubstr(y.URI.file(b.filename));let t=P.get(v);if(t||P.set(v,t={}),!t[I]){let h=o.default;v&&v.enableProposedApi&&(h=o[v.proxySupport]||o.onRequest),t[I]={...h}}return t[I]}})}}),define(fe[281],me([0,1,39,8,79,29,11,9,93,282]),function(Y,e,m,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(c,o,v,t){const h=l(c,o,v,t),s=o.folder.fsPath;return{cmd:m.spawn(i,h.args,{cwd:s}),rgDiskPath:i,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}e.spawnRipgrepCmd=k;function l(c,o,v,t){const h=["--files","--hidden","--case-sensitive"];d([o],v,!1).forEach(n=>{const r=(0,S.anchorGlob)(n);if(h.push("-g",r),A.isMacintosh){const a=(0,C.normalizeNFD)(r);a!==r&&h.push("-g",a)}});const s=f([o],t,void 0,!1);return s.globArgs.forEach(n=>{const r=`!${(0,S.anchorGlob)(n)}`;if(h.push("-g",r),A.isMacintosh){const a=(0,C.normalizeNFD)(r);a!==r&&h.push("-g",a)}}),o.disregardIgnoreFiles!==!1?h.push("--no-ignore"):h.push("--no-ignore-parent"),o.ignoreSymlinks||h.push("--follow"),c.exists&&h.push("--quiet"),h.push("--no-config"),o.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function f(c,o,v,t=!0){const h=[];let s={};return c.forEach(n=>{const r=Object.assign({},n.excludePattern||{},o||{}),a=w(r,t?n.folder.fsPath:void 0,v);h.push(...a.globArgs),a.siblingClauses&&(s=Object.assign(s,a.siblingClauses))}),{globArgs:h,siblingClauses:s}}e.foldersToRgExcludeGlobs=f;function d(c,o,v=!0){const t=[];return c.forEach(h=>{const s=Object.assign({},o||{},h.includePattern||{}),n=w(s,v?h.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=d;function w(c,o,v){const t=[],h={};return Object.keys(c).forEach(s=>{if(v&&v.has(s)||!s)return;const n=c[s];s=I(o?D(o,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(b(s))):n&&n.when&&(h[s]=n)}),{globArgs:t,siblingClauses:h}}function D(c,o){return F.isAbsolute(o)?o:F.join(c,o)}e.getAbsoluteGlob=D;function I(c){return c=_.rtrim(c,"\\"),_.rtrim(c,"/")}function b(c){return y.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=b}),define(fe[283],me([0,1,39,50,8,105,16,52,30,79,29,11,46,9,12,28,31,281,102]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class o{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(r=>{const a=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),u=r.folder.fsPath;n.folderQueries.map(p=>p.folder.fsPath).filter(p=>p!==u).forEach(p=>{(0,i.isEqualOrParent)(p,u)&&(a[C.relative(u,p)]=!0)}),this.folderExcludePatterns.set(u,new t(a,u))})}cancel(){this.isCanceled=!0}walk(n,r,a,u,p){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return p(null,this.isLimitHit);r.forEach(E=>{const g=C.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,g)||this.matchFile(a,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(E,g)=>{this.call(this.cmdTraversal,this,E,a,u,T=>{if(T){const L=(0,_.toErrorMessage)(T);console.error(L),this.errors.push(L),g(T,void 0)}else g(null,void 0)})},(E,g)=>{this.fileWalkSW.stop();const T=E?A.coalesce(E)[0]:null;p(T,this.isLimitHit)})}parallel(n,r,a){const u=new Array(n.length),p=new Array(n.length);let E=!1,g=0;if(n.length===0)return a(null,[]);n.forEach((T,L)=>{r(T,(M,R)=>{if(M?(E=!0,u[L]=null,p[L]=M):(u[L]=R,p[L]=null),++g===n.length)return a(E?p:null,u)})})}call(n,r,...a){try{n.apply(r,a)}catch(u){a[a.length-1](u)}}cmdTraversal(n,r,a,u){const p=n.folder.fsPath,E=k.isMacintosh;let g;const T=()=>g&&g.kill();c.add(T);let L=U=>{c.delete(T),L=()=>{},u(U)},M="";const R=this.initDirectoryTree();let W;const V=(0,I.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);g=V.cmd,W=!Object.keys(V.siblingClauses).length;const N=V.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),a({message:j}),this.cmdResultCount=0,this.collectStdout(g,"utf8",a,(U,x,z)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const $=(M+(E?P.normalizeNFC(x||""):x)).split(`
`);if(z){const B=$.length;$[B-1]=$[B-1].trim(),$[B-1]||$.pop()}else M=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,W){for(const B of $)if(this.matchFile(r,{base:p,relativePath:B,searchPath:this.getSearchPath(n,B)}),this.isLimitHit){T();break}(z||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,R,p,$,r),z&&(this.matchDirectoryTree(R,p,r),L())})}spawnFindCmd(n){const r=this.folderExcludePatterns.get(n.folder.fsPath),a=r.getBasenameTerms(),u=r.getPathTerms(),p=["-L","."];if(a.length||u.length){p.push("-not","(","(");for(const E of a)p.push("-name",E),p.push("-o");for(const E of u)p.push("-path",E),p.push("-o");p.pop(),p.push(")","-prune",")")}return p.push("-type","f"),m.spawn("find",p,{cwd:n.folder.fsPath})}readStdout(n,r,a){let u="";this.collectStdout(n,r,()=>{},(p,E,g)=>{if(p){a(p);return}u+=E,g&&a(null,u)})}collectStdout(n,r,a,u){let p=(T,L,M)=>{(T||M)&&(p=()=>{},this.cmdSW&&this.cmdSW.stop()),u(T,L,M)},E=!1;n.stdout?(this.forwardData(n.stdout,r,p),n.stdout.once("data",()=>E=!0)):a({message:"stdout is null"});let g;n.stderr?g=this.collectData(n.stderr):a({message:"stderr is null"}),n.on("error",T=>{p(T)}),n.on("close",T=>{let L;!E&&(L=this.decodeData(g,r))&&h(L)?p(new Error(`command failed with error code ${T}: ${this.decodeData(g,r)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),p(null,"",!0))})}forwardData(n,r,a){const u=new y.StringDecoder(r);return n.on("data",p=>{a(null,u.write(p))}),u}collectData(n){const r=[];return n.on("data",a=>{r.push(a)}),r}decodeData(n,r){const a=new y.StringDecoder(r);return n.map(u=>a.write(u)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:r},a,u,p){u.indexOf(this.filePattern)!==-1&&this.matchFile(p,{base:a,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const E=g=>{const T=C.basename(g),L=C.dirname(g);let M=r[L];M||(M=r[L]=[],E(L)),M.push({base:a,relativePath:g,basename:T,searchPath:this.getSearchPath(n,g)})};u.forEach(E)}matchDirectoryTree({rootEntries:n,pathToEntries:r},a,u){const p=this,E=this.folderExcludePatterns.get(a),g=this.filePattern;function T(L){p.directoriesWalked++;const M=S.hasSiblingFn(()=>L.map(R=>R.basename));for(let R=0,W=L.length;R<W;R++){const V=L[R],{relativePath:N,basename:j}=V;if(E.test(N,j,g!==j?M:void 0))continue;const U=r[N];if(U)T(U);else{if(p.filesWalked++,N===g)continue;p.matchFile(u,V)}if(p.isLimitHit)break}}T(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,r,a,u,p){const E=n.folder,g=S.hasSiblingFn(()=>a);this.parallel(a,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const M=r?[r,T].join(C.sep):T;if(this.folderExcludePatterns.get(n.folder.fsPath).test(M,T,this.config.filePattern!==T?g:void 0))return L(null);const R=[E.fsPath,M].join(C.sep);F.lstat(R,(W,V)=>{if(W||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(R,V,(N,j)=>N||this.isCanceled||this.isLimitHit?L(null):j.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(R,V,(U,x)=>U||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?L(null):(this.walkedPaths[x]=!0,w.Promises.readdir(R).then(z=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,M,z,u,O=>L(O||null))},z=>{L(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&d.isNumber(j.size)&&j.size>this.maxFilesize||this.matchFile(u,{base:E.fsPath,relativePath:M,searchPath:this.getSearchPath(n,M)}),L(null,void 0)))})},T=>{const L=T&&A.coalesce(T);return p(L&&L.length>0?L[0]:void 0)})}matchFile(n,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,C.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(r))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,r,a){return r.isSymbolicLink()?F.stat(n,a):a(null,r)}realPathIfNeeded(n,r,a){return r.isSymbolicLink()?F.realpath(n,(u,p)=>u?a(u):a(null,p)):a(null,n)}getSearchPath(n,r){return n.folderName?C.join(n.folderName,r):r}}e.FileWalker=o;class v{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new o(n)}search(n,r,a){this.walker.walk(this.folderQueries,this.extraFiles,n,r,(u,p)=>{a(u,{limitHit:p,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(n,r){this.expression=n,this.root=r,this.init(n)}init(n){let r,a;Object.keys(n).filter(u=>n[u]).forEach(u=>{C.isAbsolute(u)?(r=r||S.getEmptyExpression(),r[u]=n[u]):(a=a||S.getEmptyExpression(),a[u]=n[u])}),this.absoluteParsedExpr=r&&S.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=a&&S.parse(a,{trimForExclusions:!0})}test(n,r,a){return this.relativeParsedExpr&&this.relativeParsedExpr(n,r,a)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),r,a)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function h(s){const n=s.trim().split(`
`),r=n[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return f.uppercaseFirstLetter(n[n.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=h}),define(fe[137],me([0,1,39,297,105,16,59,30,8,9,2,31,72,298,282,93]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=d.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class I{constructor(E){this.outputChannel=E}provideTextSearchResults(E,g,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...g,folder:g.folder.toString()})}`),new Promise((M,R)=>{L.onCancellationRequested(()=>O());const W=h(E,g),V=g.folder.fsPath,N=W.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${D} ${N}
 - cwd: ${V}`);let j=m.spawn(D,W,{cwd:V});j.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),R((0,k.serializeSearchError)(new k.SearchError(de&&de.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const x=new o(g.maxResults,V,g.previewOptions);x.on("result",de=>{U=!0,B="",T.report(de)});let z=!1;const O=()=>{z=!0,j&&j.kill(),x&&x.cancel()};let $=!1;x.on("hitLimit",()=>{$=!0,O()});let B="";j.stdout.on("data",de=>{x.handleData(de),U||(B+=de)});let X=!1;j.stdout.once("data",()=>X=!0);let Q="";j.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),Q+=_e}),j.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),z)M({limitHit:$});else{x.flush(),j=null;let de;Q&&!X&&(de=b(Q))?R((0,k.serializeSearchError)(new k.SearchError(de.message,de.code))):M({limitHit:$})}})})}}e.RipgrepTextSearchEngine=I;function b(p){const E=p.split(`
`),g=E[0].trim();if(E.some(L=>L.startsWith("regex parse error")))return new k.SearchError(c(E),k.SearchErrorCode.regexParseError);const T=g.match(/grep config error: unknown encoding: (.*)/);if(T)return new k.SearchError(`Unknown encoding: ${T[1]}`,k.SearchErrorCode.unknownEncoding);if(g.startsWith("error parsing glob"))return new k.SearchError(g.charAt(0).toUpperCase()+g.substr(1),k.SearchErrorCode.globParseError);if(g.startsWith("the literal"))return new k.SearchError(g.charAt(0).toUpperCase()+g.substr(1),k.SearchErrorCode.invalidLiteral);if(g.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(g,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function c(p){const E=["Regex parse error"],g=p.filter(T=>T.startsWith("PCRE2:"));if(g.length>=1){const T=g[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];E.push(":"+L)}}return E.join("")}e.buildRegexParseError=c;class o extends F.EventEmitter{constructor(E,g,T){super();this.maxResults=E,this.rootFolder=g,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,g){return super.on(E,g),this}handleData(E){if(this.isDone)return;const g=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(g)}handleDecodedData(E){let g=E.indexOf(`
`);const T=this.remainder+E;if(g>=0)g+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;g>=0;)this.handleLine(T.substring(L,g).trim()),L=g+1,g=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(E){if(this.isDone||!E)return;let g;try{g=JSON.parse(E)}catch(T){throw new Error(`malformed line from rg: ${E}`)}if(g.type==="match"){const T=v(g.data.path),L=i.URI.file(S.join(this.rootFolder,T)),M=this.createTextSearchMatch(g.data,L);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(g.type==="context"){const T=v(g.data.path),L=i.URI.file(S.join(this.rootFolder,T));this.createTextSearchContext(g.data,L).forEach(R=>this.onResult(R))}}createTextSearchMatch(E,g){const T=E.line_number-1,L=v(E.lines),M=Buffer.from(L);let R=0,W=0,V=T;E.submatches.length===0&&E.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=(0,y.coalesce)(E.submatches.map((j,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=v(j.match),z=M.slice(R,j.start).toString().length,O=W+z,$=t(x),B=V,X=$.numLines+B,Q=$.numLines>0?$.lastLineLength:$.lastLineLength+O;return R=j.end,W=Q,V=X,new l.Range(B,O,X,Q)}));return(0,w.createTextSearchResult)(g,L,N,this.previewOptions)}createTextSearchContext(E,g){const T=v(E.lines),L=E.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((M,R)=>({text:M,uri:g,lineNumber:L+R}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=o;function v(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const E=/\n/g;let g=0,T=-1,L;for(;L=E.exec(p);)g++,T=L.index;const M=T>=0?p.length-T-1:p.length;return{numLines:g,lastLineLength:M}}function h(p,E){const g=["--hidden"];g.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=(0,A.groupBy)(E.includes,R=>R.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const R=new Set;L.forEach(W=>{R.add(W)}),g.push("-g","!*"),R.forEach(W=>{s(W).map(w.anchorGlob).forEach(V=>{g.push("-g",V)})})}T&&T.length&&T.forEach(R=>{g.push("-g",R)}),E.excludes.map(w.anchorGlob).forEach(R=>g.push("-g",`!${R}`)),E.maxFileSize&&g.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?g.push("--no-ignore-parent"):g.push("--no-ignore"),E.followSymlinks&&g.push("--follow"),E.encoding&&E.encoding!=="utf8"&&g.push("--encoding",E.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,P.escapeRegExpCharacters)(p.pattern),p.isRegExp=!0),E.usePCRE2&&g.push("--pcre2"),g.push("--crlf"),p.isRegExp&&(p.pattern=n(p.pattern),g.push("--auto-hybrid-regex"));let M;if(p.isWordMatch){const W=(0,P.createRegExp)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");g.push("--regexp",W)}else if(p.isRegExp){let R=a(p.pattern);R=u(R),g.push("--regexp",R)}else M=p.pattern,g.push("--fixed-strings");return g.push("--no-config"),E.useGlobalIgnoreFiles||g.push("--no-ignore-global"),g.push("--json"),p.isMultiline&&g.push("--multiline"),E.beforeContext&&g.push("--before-context",E.beforeContext+""),E.afterContext&&g.push("--after-context",E.afterContext+""),g.push("--"),M&&g.push(M),g.push("."),g}function s(p){const E=(0,_.splitGlobAware)(p,"/");return E.map((g,T)=>E.slice(0,T+1).join("/"))}e.spreadGlobComponents=s;function n(p){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");const g=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(g);)p=p.replace(g,"$1\\x{$2}");return p}e.unicodeEscapesToPCRE2=n;const r=p=>p.type==="Assertion"&&p.kind==="lookbehind";function a(p){let E;try{E=new f.RegExpParser().parsePattern(p)}catch{return p}let g="",T=0;const L=(W,V,N)=>{g+=p.slice(T,W)+N,T=V},M=[];return new f.RegExpVisitor({onCharacterEnter(W){if(W.raw!=="\\n")return;const V=M[0];if(!V)L(W.start,W.end,"\\r?\\n");else if(!M.some(r))if(V.type==="CharacterClass")if(V.negate){const N=p.slice(V.start+2,W.start)+p.slice(W.end,V.end-1);L(V.start,V.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=p.slice(V.start+1,W.start)+p.slice(W.end,V.end-1);L(V.start,V.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else V.type==="Quantifier"&&L(W.start,W.end,"(?:\\r?\\n)")},onQuantifierEnter(W){M.unshift(W)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(W){M.unshift(W)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(W){M.unshift(W)},onCharacterClassLeave(){M.shift()},onAssertionEnter(W){r(W)&&M.push(W)},onAssertionLeave(W){M[0]===W&&M.shift()}}).visit(E),g+=p.slice(T),g}e.fixRegexNewline=a;function u(p){return p.replace(/\n/g,"\\r?\\n")}e.fixNewline=u}),define(fe[284],me([0,1,21,137,119,10]),function(Y,e,m,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,i,k,l){const f=new F.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===y.Schemas.userData){const d={...i,folder:i.folder.with({scheme:y.Schemas.file})},w=new C.Progress(D=>k.report({...D,uri:D.uri.with({scheme:i.folder.scheme})}));return this.withToken(l,D=>f.provideTextSearchResults(P,d,w,D))}else return this.withToken(l,d=>f.provideTextSearchResults(P,i,k,d))}async withToken(P,i){const k=_(P);this.inProgress.add(k);const l=await i(k.token);return this.inProgress.delete(k),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function _(S){const P=new m.CancellationTokenSource;return S.onCancellationRequested(()=>P.cancel()),P}}),define(fe[285],me([0,1,28,137,136]),function(Y,e,m,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(S){this.query=S}search(S,P,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(f){i({message:f})}},l=new C.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(k),m);return new Promise((f,d)=>l.search(w=>{P(w.map(A))},S).then(w=>f({limitHit:w.limitHit,type:"success",stats:w.stats}),d))}}e.TextSearchEngineAdapter=y;function A(_){return{path:_.resource&&_.resource.fsPath,results:_.results,numMatches:(_.results||[]).reduce((S,P)=>{if(P.ranges){const i=P;return S+(Array.isArray(i.ranges)?i.ranges.length:1)}else return S+1},0)}}}),define(fe[286],me([0,1,50,299,16,17,18,3,102,8,46,2,43,31,283,285]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,F.gracefulify(m);class D{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let h;const s=c(t),n=new _.Emitter({onFirstListenerDidAdd:()=>{h=(0,y.createCancelablePromise)(r=>this.doFileSearchWithEngine(d.Engine,s,a=>n.fire(a),r)),h.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return n.event}textSearch(t){let h;const s=c(t),n=new _.Emitter({onFirstListenerDidAdd:()=>{h=(0,y.createCancelablePromise)(r=>this.ripgrepTextSearch(s,a=>n.fire(a),r)),h.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return n.event}ripgrepTextSearch(t,h,s){return t.maxFileSize=(0,l.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(t).search(s,h,h)}doFileSearch(t,h,s){return this.doFileSearchWithEngine(d.Engine,t,h,s)}doFileSearchWithEngine(t,h,s,n,r=D.BATCH_SIZE){let a=0;const u=E=>{Array.isArray(E)?(a+=E.length,s(E.map(g=>this.rawMatchToSearchItem(g)))):E.relativePath?(a++,s(this.rawMatchToSearchItem(E))):s(E)};if(h.sortByScore){let E=this.trySortedSearchFromCache(h,u,n);if(!E){const g=h.maxResults?Object.assign({},h,{maxResults:null}):h,T=new t(g);E=this.doSortedSearch(T,h,s,u,n)}return new Promise((g,T)=>{E.then(([L,M])=>{const R=M.map(W=>this.rawMatchToSearchItem(W));this.sendProgress(R,s,r),g(L)},T)})}const p=new t(h);return this.doSearch(p,u,r,n).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.processType,fromCache:!1,resultCount:a,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,h,s,n,r){const a=new _.Emitter;let u=(0,y.createCancelablePromise)(E=>{let g=[];const T=L=>{Array.isArray(L)?g=L:(n(L),a.fire(L))};return this.doSearch(t,T,-1,E).then(L=>[L,g])}),p;if(h.cacheKey){p=this.getOrCreateCache(h.cacheKey);const E={promise:u,event:a.event,resolved:!1};p.resultsToSearchCache[h.filePattern||""]=E,u.then(()=>{E.resolved=!0},g=>{delete p.resultsToSearchCache[h.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([E,g])=>{const T=p?p.scorerCache:Object.create(null),L=(typeof h.maxResults!="number"||h.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(h,g,T,r).then(M=>{const R=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:h.folderQueries.length,resultCount:M.length},messages:E.messages,limitHit:E.limitHit||typeof h.maxResults=="number"&&g.length>h.maxResults},M]})})}getOrCreateCache(t){const h=this.caches[t];return h||(this.caches[t]=new I)}trySortedSearchFromCache(t,h,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const r=this.getResultsFromCache(n,t.filePattern||"",h,s);if(r)return r.then(([a,u,p])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,u,n.scorerCache,s).then(g=>{const T=E.elapsed(),L={fromCache:!0,detailStats:p,type:this.processType,resultCount:u.length,sortingTime:T};return[{type:"success",limitHit:a.limitHit||typeof t.maxResults=="number"&&u.length>t.maxResults,stats:L},g]})})}sortResults(t,h,s,n){const r=(0,S.prepareQuery)(t.filePattern||""),a=(p,E)=>(0,S.compareItemsByFuzzyScore)(p,E,r,!0,b,s),u=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(h,a,u,1e4,n)}sendProgress(t,h,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)h(t.slice(n,n+s));else h(t)}getResultsFromCache(t,h,s,n){const r=i.StopWatch.create(!1),a=h.indexOf(P.sep)>=0;let u;for(const T in t.resultsToSearchCache)if(h.startsWith(T)){if(a&&T.indexOf(P.sep)<0&&T!=="")continue;const L=t.resultsToSearchCache[T];u={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!u)return null;const p=r.elapsed(),E=i.StopWatch.create(!1),g=u.event(s);return n&&n.onCancellationRequested(()=>{g.dispose()}),u.promise.then(([T,L])=>{if(n&&n.isCancellationRequested)throw(0,A.canceled)();const M=[],R=(0,S.prepareQuery)(h).normalizedLowercase;for(const W of L)!(0,f.isFilePatternMatch)(W,R)||M.push(W);return[T,M,{cacheWasResolved:u.resolved,cacheLookupTime:p,cacheFilterTime:E.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,h,s,n){return new Promise((r,a)=>{let u=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(p=>{p&&(s?(u.push(p),s>0&&u.length>=s&&(h(u),u=[])):h(p))},p=>{h(p)},(p,E)=>{u.length&&h(u),p?a(p):r(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,s){return t.then(h,s)}catch(h){return this.then(void 0,h)}finally(h){return t.finally(h)}}}}e.SearchService=D,D.BATCH_SIZE=512;class I{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(v){return(0,P.basename)(v.relativePath)}getItemDescription(v){return(0,P.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function c(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(o),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>k.URI.revive(t))}}function o(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(fe[287],me([0,1,6,10,2,28,13,27,14,75,67,31,286,284,93,136]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends P.ExtHostSearch{constructor(b,c,o,v){super(b,o,v);this._pfs=y,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new d.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(F.Schemas.userData,new f.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new d.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(F.Schemas.file,new f.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(F.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,c){const o=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,c,o,v){const t=(0,P.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,c,t,v):super.$provideFileSearchResults(b,c,o,v)}doInternalFileSearch(b,c,o,v){const t=h=>{if((0,k.isSerializedFileMatch)(h)&&(h=[h]),Array.isArray(h)){this._proxy.$handleFileMatch(b,c,h.map(s=>C.URI.file(s.path)));return}h.message&&this._logService.debug("ExtHostSearch",h.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,t,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,c){return new w.NativeTextSearchManager(b,c,void 0,"textSearchProvider")}};D=Ve([$e(0,S.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,i.IURITransformerService),$e(3,A.ILogService)],D),e.NativeExtHostSearch=D}),define(fe[138],me([0,1,300,127,81,22,18,3,6,8,11,32,107,108,301]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(u){this.socket=u,this._errorListener=p=>{if(p){if(p.code==="EPIPE")return;(0,A.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const p=E=>u(y.VSBuffer.wrap(E));return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=E=>{u({type:0,hadError:E,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,A.onUnexpectedError)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,A.onUnexpectedError)(p)}}end(){this.socket.end()}drain(){return new Promise((u,p)=>{if(this.socket.bufferSize===0){u();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),u()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=w;var D;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var I;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(I||(I={}));class b extends S.Disposable{constructor(u,p,E,g){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=p,this._recordInflateBytes=g,p?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):y.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let p=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,p=p.slice(0,p.length-4),this._isEnded||this._write(y.VSBuffer.wrap(p),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,p){let E=2;u.byteLength<126?E+=0:u.byteLength<2**16?E+=2:E+=8;const g=y.VSBuffer.alloc(E);if(p?g.writeUInt8(194,0):g.writeUInt8(130,0),u.byteLength<126)g.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){g.writeUInt8(126,1);let T=1;g.writeUInt8(u.byteLength>>>8&255,++T),g.writeUInt8(u.byteLength>>>0&255,++T)}else{g.writeUInt8(127,1);let T=1;g.writeUInt8(0,++T),g.writeUInt8(0,++T),g.writeUInt8(0,++T),g.writeUInt8(0,++T),g.writeUInt8(u.byteLength>>>24&255,++T),g.writeUInt8(u.byteLength>>>16&255,++T),g.writeUInt8(u.byteLength>>>8&255,++T),g.writeUInt8(u.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=g.byteLength+u.byteLength,this.socket.write(y.VSBuffer.concat([g,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const p=this._incomingData.peek(this._state.readLen),E=p.readUInt8(0),g=(E&128)>>>7,T=(E&64)>>>6,L=p.readUInt8(1),M=(L&128)>>>7,R=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(R===126?2:0)+(R===127?8:0),this._state.fin=g,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(g),this._state.mask=0}else if(this._state.state===2){const p=this._incomingData.read(this._state.readLen),E=p.readUInt8(1),g=(E&128)>>>7;let T=E&127,L=1;T===126?T=p.readUInt8(++L)*2**8+p.readUInt8(++L):T===127&&(T=p.readUInt8(++L)*0+p.readUInt8(++L)*0+p.readUInt8(++L)*0+p.readUInt8(++L)*0+p.readUInt8(++L)*2**24+p.readUInt8(++L)*2**16+p.readUInt8(++L)*2**8+p.readUInt8(++L));let M=0;g&&(M=p.readUInt8(++L)*2**24+p.readUInt8(++L)*2**16+p.readUInt8(++L)*2**8+p.readUInt8(++L)),this._state.state=3,this._state.readLen=T,this._state.mask=M}else if(this._state.state===3){const p=this._incomingData.read(this._state.readLen);c(p,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(p.buffer)),this._zlibInflate.write(p.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(y.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=p.byteLength,this._onData.fire(p))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function c(a,u){if(u===0)return;let p=a.byteLength>>>2;for(let R=0;R<p;R++){const W=a.readUInt32BE(R*4);a.writeUInt32BE(W^u,R*4)}let E=p*4,g=a.byteLength-E;const T=u>>>24&255,L=u>>>16&255,M=u>>>8&255;g>=1&&a.writeUInt8(a.readUInt8(E)^T,E),g>=2&&a.writeUInt8(a.readUInt8(E+1)^L,E+1),g>=3&&a.writeUInt8(a.readUInt8(E+2)^M,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function v(){const a=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):u=(0,P.join)((0,C.tmpdir)(),`vscode-ipc-${a}.sock`),h(u),u}e.createRandomIPCHandle=v;function t(a,u,p){const E=(0,m.createHash)("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${p}-${u}-sock`;let g;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?g=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${p}-${u}.sock`):g=(0,P.join)(a,`${p}-${u}.sock`),h(g),g}e.createStaticIPCHandle=t;function h(a){const u=o[i.platform];typeof u=="number"&&a.length>=u&&console.warn(`WARNING: IPC handle "${a}" is longer than ${u} chars, try a shorter --user-data-dir`)}class s extends l.IPCServer{constructor(u){super(s.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const p=_.Event.fromNodeEventEmitter(u,"connection");return _.Event.map(p,E=>({protocol:new f.Protocol(new w(E)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(a){return new Promise((u,p)=>{const E=(0,F.createServer)();E.on("error",p),E.listen(a,()=>{E.removeListener("error",p),u(new s(E))})})}e.serve=n;function r(a,u){return new Promise((p,E)=>{const g=(0,F.createConnection)(a,()=>{g.removeListener("error",E),p(f.Client.fromSocket(new w(g),u))});g.once("error",E)})}e.connect=r}),define(fe[288],me([0,1,138,280,50,40,2,200,13]),function(Y,e,m,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,f,d){this._commands=l,this.logService=f,this._ipcHandlePath=d,this._server=F.createServer((w,D)=>this.onRequest(w,D)),this.setup().catch(w=>(f.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,f){const d=[];l.setEncoding("utf8"),l.on("data",w=>d.push(w)),l.on("end",()=>{const w=JSON.parse(d.join(""));switch(w.type){case"open":this.open(w,f);break;case"openExternal":this.openExternal(w,f);break;case"status":this.getStatus(w,f);break;case"extensionManagement":this.manageExtensions(w,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${w.type}`,D=>{D&&this.logService.error(D)}),f.end();break}})}open(l,f){let{fileURIs:d,folderURIs:w,forceNewWindow:D,diffMode:I,addMode:b,forceReuseWindow:c,gotoLineMode:o,waitMarkerFilePath:v}=l;const t=[];if(Array.isArray(w))for(const h of w)try{t.push({folderUri:A.URI.parse(h)})}catch(s){}if(Array.isArray(d))for(const h of d)try{(0,_.hasWorkspaceFileExtension)(h)?t.push({workspaceUri:A.URI.parse(h)}):t.push({fileUri:A.URI.parse(h)})}catch(s){}if(t.length){const h=v?A.URI.file(v):void 0,n={forceNewWindow:D,diffMode:I,addMode:b,gotoLineMode:o,forceReuseWindow:c,preferNewWindow:!c&&!h&&!b,waitMarkerFileURI:h};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}f.writeHead(200),f.end()}async openExternal(l,f){for(const d of l.uris){const w=A.URI.parse(d),D=w.scheme==="file"?w:d;await this._commands.executeCommand("_remoteCLI.openExternal",D)}f.writeHead(200),f.end()}async manageExtensions(l,f){try{const d=I=>I?.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),w={list:l.list,install:d(l.install),uninstall:d(l.uninstall),force:l.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);f.writeHead(200),f.write(D)}catch(d){f.writeHead(500),f.write(String(d),w=>{w&&this.logService.error(w)})}f.end()}async getStatus(l,f){try{const d=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(d),f.end()}catch(d){f.writeHead(500),f.write(String(d),w=>{w&&this.logService.error(w)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let i=class extends P{constructor(l,f){super(l,f,(0,m.createRandomIPCHandle)())}};i=Ve([$e(0,y.IExtHostCommands),$e(1,S.ILogService)],i),e.CLIServer=i}),define(fe[289],me([0,1,74,276,271,5,279,41,261,2,10,7,288,106]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class d extends C.RequireInterceptor{_installInterceptor(){const I=this,b=Y.__$__nodeRequire("module"),c=b._load;b._load=function(v,t,h){for(let s of I._alternatives){let n=s(v);if(n){v=n;break}}return I._factories.has(v)?I._factories.get(v).load(v,P.URI.file((0,f.realpathSync)(t.filename)),s=>c.apply(this,[s,t,h])):c.apply(this,arguments)}}}class w extends _.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const I=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(d,I,this._registry).install(),m.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const o=process.send,v=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?o.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(I){return I.main}_loadCommonJSModule(I,b,c){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{I&&m.mark(`code/extHost/willLoadExtensionCode/${I.value}`),o=Y.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{I&&m.mark(`code/extHost/didLoadExtensionCode/${I.value}`),c.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(I){if(!!this._initData.remote.isRemote)for(const b in I){const c=I[b];c===null?delete process.env[b]:process.env[b]=c}}}e.ExtHostExtensionService=w}),define(fe[290],me([0,1,83,262,264,273,272,287,289,229,265,57,41,69,75,73,33,54,13,70,263]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D,I,b,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(l.IExtHostExtensionService,S.ExtHostExtensionService),(0,m.registerSingleton)(b.ILogService,P.ExtHostLogService),(0,m.registerSingleton)(c.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,m.registerSingleton)(k.IExtHostDebugService,A.ExtHostDebugService),(0,m.registerSingleton)(f.IExtHostOutputService,F.ExtHostOutputService2),(0,m.registerSingleton)(d.IExtHostSearch,_.NativeExtHostSearch),(0,m.registerSingleton)(w.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(D.IExtHostTerminalService,C.ExtHostTerminalService),(0,m.registerSingleton)(I.IExtHostTunnelService,i.ExtHostTunnelService)}),define(fe[291],me([0,1,127,302,74,18,108,138,193,227,274,22,104,28,106,17,115,277,290]),function(Y,e,m,F,C,y,A,_,S,P,i,k,l,f,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const I=F(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=Y.__$__nodeRequire("module"),r=n._load;n._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function c(n){process.exit=function(r){if(n)b(r);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let o=function(n){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,r)=>{let a=null,u=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const p=108e5,E=3e5,g=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),p),T=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),E);process.on("message",(M,R)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){const W=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let V;if(M.skipWebSocketFrames)V=new _.NodeSocket(R);else{const N=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));V=new _.WebSocketNodeSocket(new _.NodeSocket(R),M.permessageDeflate,N,!1)}a?(g.cancel(),T.cancel(),a.beginAcceptReconnection(V,W),a.endAcceptReconnection()):(clearTimeout(u),a=new A.PersistentProtocol(V,W),a.onDidDispose(()=>o("renderer disconnected")),n(a),a.onSocketClose(()=>{g.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;g.isScheduled()&&T.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,a)=>{const u=m.createConnection(n,()=>{u.removeListener("error",a),r(new A.PersistentProtocol(new _.NodeSocket(u)))});u.once("error",a),u.on("close",()=>{o("renderer closed the socket")})})}}async function t(){const n=await v();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(r=>{(0,P.isMessageOfType)(r,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||n.send(r)}drain(){return n.drain()}}}function h(n){return new Promise(r=>{const a=n.onMessage(u=>{a.dispose();const p=JSON.parse(u.toString()),E=p.commit,g=S.default.commit;E&&g&&E!==g&&b(55);const T=[];process.on("unhandledRejection",(R,W)=>{T.push(W),setTimeout(()=>{const V=T.indexOf(W);V>=0&&W.catch(N=>{T.splice(V,1),(0,y.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,y.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const W=T.indexOf(R);W>=0&&T.splice(W,1)}),process.on("uncaughtException",function(R){(0,y.onUnexpectedError)(R)});let L=0;setInterval(function(){try{process.kill(p.parentPid,0),L=0}catch(R){R&&R.code==="EPERM"?(L++,L>=3&&o(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${R.message} (code: ${R.code}) (errno: ${R.errno})`)):o(`parent process ${p.parentPid} does not exist anymore: ${R.message} (code: ${R.code}) (errno: ${R.errno})`)}},1e3);let M;try{M=Y.__$__nodeRequire("native-watchdog"),M.start(p.parentPid)}catch(R){(0,y.onUnexpectedError)(R)}n.send((0,P.createMessageOfType)(0)),r({protocol:n,initData:p})});n.send((0,P.createMessageOfType)(1))})}async function s(){C.mark("code/extHost/willConnectToRenderer");const n=await t();C.mark("code/extHost/didConnectToRenderer");const r=await h(n);C.mark("code/extHost/didWaitForInitData");const{initData:a}=r;c(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=I.useHostProxy!==void 0?I.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,D.boolean)(I.skipWorkspaceStorageLock,!1);const u=new class{exit(T){b(T)}exists(T){return f.Promises.exists(T)}realpath(T){return(0,d.realpath)(T)}};let p=null;if(a.remote.authority&&I.uriTransformerPath)try{const T=Y.__$__nodeRequire(I.uriTransformerPath)(a.remote.authority);p=new l.URITransformer(T)}catch(g){console.error(g)}const E=new i.ExtensionHostMain(r.protocol,a,u,p);o=g=>E.terminate(g)}e.startExtensionHostProcess=s}),define(fe[303],me([0,1,291]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(F=>console.log(F))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/284e0db6c4cac1e557a43cd6691babdaafc2e1a9/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
