/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(se){for(var e=[],d=0,M=se.length;d<M;d++)e[d]=be[se[d]];return e};define(be[42],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=d}),define(be[52],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const _=[];for(let n in t)d.call(t,n)&&_.push(t[n]);return _}e.values=M;function E(t,_){for(let n in t)if(d.call(t,n)&&_({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,_){const n=Object.create(null);for(const f of t){const s=_(f);let u=n[s];u||(u=n[s]=[]),u.push(f)}return n}e.groupBy=A;function F(t){const _=Object.create(null);return t&&t.forEach((n,f)=>{_[f]=n}),_}e.fromMap=F;function k(t,_){const n=[],f=[];for(let s of t)_.has(s)||n.push(s);for(let s of _)t.has(s)||f.push(s);return{removed:n,added:f}}e.diffSets=k;function S(t,_){const n=[],f=[];for(let[s,u]of t)_.has(s)||n.push(u);for(let[s,u]of _)t.has(s)||f.push(u);return{removed:n,added:f}}e.diffMaps=S;class T{constructor(){this.map=new Map}add(_,n){let f=this.map.get(_);f||(f=new Set,this.map.set(_,f)),f.add(n)}delete(_,n){const f=this.map.get(_);!f||(f.delete(n),f.size===0&&this.map.delete(_))}forEach(_,n){const f=this.map.get(_);!f||f.forEach(n)}}e.SetMap=T}),define(be[53],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(k,S,T)=>{let t=null,_=null;if(typeof T.value=="function"?(t="value",_=T.value):typeof T.get=="function"&&(t="get",_=T.get),!_)throw new Error("not supported");T[t]=F(_,S)}}e.createDecorator=d;function M(F,k,S){let T=null,t=null;if(typeof S.value=="function"?(T="value",t=S.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(T="get",t=S.get),!t)throw new Error("not supported");const _=`$memoize$${k}`;S[T]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[_]}}e.memoize=M;function E(F,k,S){return d((T,t)=>{const _=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...f){this[n]||(this[n]=S?S():void 0),clearTimeout(this[_]),k&&(this[n]=k(this[n],...f),f=[this[n]]),this[_]=setTimeout(()=>{T.apply(this,f),this[n]=S?S():void 0},F)}})}e.debounce=E;function A(F,k,S){return d((T,t)=>{const _=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,f=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...u){if(this[n]||(this[n]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[n]=k(this[n],...u)),this[s])return;const v=this[f]+F;v<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[n]]),this[n]=S?S():void 0):(this[s]=!0,this[_]=setTimeout(()=>{this[s]=!1,this[f]=Date.now(),T.apply(this,[this[n]]),this[n]=S?S():void 0},v-Date.now()))}})}e.throttle=A}),define(be[13],Ee([0,1,16]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(q,le=0){return q[q.length-(1+le)]}e.tail=M;function E(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=E;function A(q,le,te=(ve,Re)=>ve===Re){if(q===le)return!0;if(!q||!le||q.length!==le.length)return!1;for(let ve=0,Re=q.length;ve<Re;ve++)if(!te(q[ve],le[ve]))return!1;return!0}e.equals=A;function F(q,le,te){let ve=0,Re=q.length-1;for(;ve<=Re;){const Fe=(ve+Re)/2|0,Oe=te(q[Fe],le);if(Oe<0)ve=Fe+1;else if(Oe>0)Re=Fe-1;else return Fe}return-(ve+1)}e.binarySearch=F;function k(q,le){let te=0,ve=q.length;if(ve===0)return 0;for(;te<ve;){const Re=Math.floor((te+ve)/2);le(q[Re])?ve=Re:te=Re+1}return te}e.findFirstInSorted=k;function S(q,le,te){if(q=q|0,q>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Re=[],Fe=[],Oe=[];for(let Ke of le){const je=te(Ke,ve);je<0?Re.push(Ke):je>0?Fe.push(Ke):Oe.push(Ke)}return q<Re.length?S(q,Re,te):q<Re.length+Oe.length?Oe[0]:S(q-(Re.length+Oe.length),Fe,te)}e.quickSelect=S;function T(q,le){const te=[];let ve;for(const Re of q.slice(0).sort(le))!ve||le(ve[0],Re)!==0?(ve=[Re],te.push(ve)):ve.push(Re);return te}e.groupBy=T;function t(q,le,te){const ve=[];function Re(Ke,je,Ve){if(je===0&&Ve.length===0)return;const U=ve[ve.length-1];U&&U.start+U.deleteCount===Ke?(U.deleteCount+=je,U.toInsert.push(...Ve)):ve.push({start:Ke,deleteCount:je,toInsert:Ve})}let Fe=0,Oe=0;for(;;){if(Fe===q.length){Re(Fe,0,le.slice(Oe));break}if(Oe===le.length){Re(Fe,q.length-Fe,[]);break}const Ke=q[Fe],je=le[Oe],Ve=te(Ke,je);Ve===0?(Fe+=1,Oe+=1):Ve<0?(Re(Fe,1,[]),Fe+=1):Ve>0&&(Re(Fe,0,[je]),Oe+=1)}return ve}e.sortedDiff=t;function _(q,le,te){const ve=t(q,le,te),Re=[],Fe=[];for(const Oe of ve)Re.push(...q.slice(Oe.start,Oe.start+Oe.deleteCount)),Fe.push(...Oe.toInsert);return{removed:Re,added:Fe}}e.delta=_;function n(q,le,te){if(te===0)return[];const ve=q.slice(0,te).sort(le);return s(q,le,ve,te,q.length),ve}e.top=n;function f(q,le,te,ve,Re){return te===0?Promise.resolve([]):new Promise((Fe,Oe)=>{(async()=>{const Ke=q.length,je=q.slice(0,te).sort(le);for(let Ve=te,U=Math.min(te+ve,Ke);Ve<Ke;Ve=U,U=Math.min(U+ve,Ke)){if(Ve>te&&await new Promise(Q=>setTimeout(Q)),Re&&Re.isCancellationRequested)throw(0,d.canceled)();s(q,le,je,Ve,U)}return je})().then(Fe,Oe)})}e.topAsync=f;function s(q,le,te,ve,Re){for(const Fe=te.length;ve<Re;ve++){const Oe=q[ve];if(le(Oe,te[Fe-1])<0){te.pop();const Ke=k(te,je=>le(Oe,je)<0);te.splice(Ke,0,Oe)}}}function u(q){return q.filter(le=>!!le)}e.coalesce=u;function v(q){let le=0;for(let te=0;te<q.length;te++)q[te]&&(q[le]=q[te],le+=1);q.length=le}e.coalesceInPlace=v;function D(q,le,te){q.splice(te,0,q.splice(le,1)[0])}e.move=D;function y(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=y;function o(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=o;function h(q,le=te=>te){const te=new Set;return q.filter(ve=>{const Re=le(ve);return te.has(Re)?!1:(te.add(Re),!0)})}e.distinct=h;function C(q){const le=Object.create(null);return te=>{const ve=q(te);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=C;function i(q,le){const te=p(q,le);if(te!==-1)return q[te]}e.findLast=i;function p(q,le){for(let te=q.length-1;te>=0;te--){const ve=q[te];if(le(ve))return te}return-1}e.lastIndex=p;function a(q,le){return q.length>0?q[0]:le}e.firstOrDefault=a;function r(q,le,te=(ve,Re)=>ve===Re){let ve=0;for(let Re=0,Fe=Math.min(q.length,le.length);Re<Fe&&te(q[Re],le[Re]);Re++)ve++;return ve}e.commonPrefixLength=r;function c(q){return[].concat(...q)}e.flatten=c;function l(q,le){let te=typeof le=="number"?q:0;typeof le=="number"?te=q:(te=0,le=q);const ve=[];if(te<=le)for(let Re=te;Re<le;Re++)ve.push(Re);else for(let Re=te;Re>le;Re--)ve.push(Re);return ve}e.range=l;function m(q,le,te){return q.reduce((ve,Re)=>(ve[le(Re)]=te?te(Re):Re,ve),Object.create(null))}e.index=m;function b(q,le){return q.push(le),()=>P(q,le)}e.insert=b;function P(q,le){const te=q.indexOf(le);if(te>-1)return q.splice(te,1),le}e.remove=P;function g(q,le,te){const ve=q.slice(0,le),Re=q.slice(le);return ve.concat(te,Re)}e.arrayInsert=g;function I(q,le){let te;if(typeof le=="number"){let ve=le;te=()=>{const Re=Math.sin(ve++)*179426549;return Re-Math.floor(Re)}}else te=Math.random;for(let ve=q.length-1;ve>0;ve-=1){const Re=Math.floor(te()*(ve+1)),Fe=q[ve];q[ve]=q[Re],q[Re]=Fe}}e.shuffle=I;function R(q,le){const te=q.indexOf(le);te>-1&&(q.splice(te,1),q.unshift(le))}e.pushToStart=R;function L(q,le){const te=q.indexOf(le);te>-1&&(q.splice(te,1),q.push(le))}e.pushToEnd=L;function w(q,le){return Array.isArray(q)?q.map(le):le(q)}e.mapArrayOrNot=w;function x(q){return Array.isArray(q)?q:[q]}e.asArray=x;function $(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=$;function B(q,le){for(const te of q){const ve=le(te);if(ve!==void 0)return ve}}e.mapFind=B;function K(q,le,te){const ve=W(q,le),Re=q.length,Fe=te.length;q.length=Re+Fe;for(let Oe=Re-1;Oe>=ve;Oe--)q[Oe+Fe]=q[Oe];for(let Oe=0;Oe<Fe;Oe++)q[Oe+ve]=te[Oe]}e.insertInto=K;function H(q,le,te,ve){const Re=W(q,le),Fe=q.splice(Re,te);return K(q,Re,ve),Fe}e.splice=H;function W(q,le){return le<0?Math.max(le+q.length,0):Math.min(le,q.length)}function ne(q,le){let te=Number.MAX_SAFE_INTEGER,ve=0;return q.forEach((Re,Fe)=>{const Oe=le(Re);Oe<te&&(te=Oe,ve=Fe)}),ve}e.minIndex=ne;function V(q,le){let te=Number.MIN_SAFE_INTEGER,ve=0;return q.forEach((Re,Fe)=>{const Oe=le(Re);Oe>te&&(te=Oe,ve=Fe)}),ve}e.maxIndex=V;class X{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let te=this.firstIdx;for(;te<this.items.length&&le(this.items[te]);)te++;const ve=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,ve}takeFromEndWhile(le){let te=this.lastIdx;for(;te>=0&&le(this.items[te]);)te--;const ve=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,ve}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=X}),define(be[54],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,p=!1){let a=0,r=i.length,c="",l=0,m=16,b=0;function P($){let B=0,K=0;for(;B<$;){const H=i.charCodeAt(a);if(H>=48&&H<=57)K=K*16+H-48;else if(H>=65&&H<=70)K=K*16+H-65+10;else if(H>=97&&H<=102)K=K*16+H-97+10;else break;a++,B++}return B<$&&(K=-1),K}function g($){a=$,c="",l=0,m=16,b=0}function I(){const $=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&T(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&T(i.charCodeAt(a)))for(a++;a<i.length&&T(i.charCodeAt(a));)a++;else return b=3,i.substring($,a);let B=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&T(i.charCodeAt(a))){for(a++;a<i.length&&T(i.charCodeAt(a));)a++;B=a}else b=3;return i.substring($,B)}function R(){let $="",B=a;for(;;){if(a>=r){$+=i.substring(B,a),b=2;break}const K=i.charCodeAt(a);if(K===34){$+=i.substring(B,a),a++;break}if(K===92){if($+=i.substring(B,a),a++,a>=r){b=2;break}switch(i.charCodeAt(a++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const W=P(4);W>=0?$+=String.fromCharCode(W):b=4;break;default:b=5}B=a;continue}if(K>=0&&K<=31)if(S(K)){$+=i.substring(B,a),b=2;break}else b=6;a++}return $}function L(){if(c="",b=0,l=a,a>=r)return l=r,m=17;let $=i.charCodeAt(a);if(k($)){do a++,c+=String.fromCharCode($),$=i.charCodeAt(a);while(k($));return m=15}if(S($))return a++,c+=String.fromCharCode($),$===13&&i.charCodeAt(a)===10&&(a++,c+=`
`),m=14;switch($){case 123:return a++,m=1;case 125:return a++,m=2;case 91:return a++,m=3;case 93:return a++,m=4;case 58:return a++,m=6;case 44:return a++,m=5;case 34:return a++,c=R(),m=10;case 47:const B=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!S(i.charCodeAt(a));)a++;return c=i.substring(B,a),m=12}if(i.charCodeAt(a+1)===42){a+=2;const K=r-1;let H=!1;for(;a<K;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,b=1),c=i.substring(B,a),m=13}return c+=String.fromCharCode($),a++,m=16;case 45:if(c+=String.fromCharCode($),a++,a===r||!T(i.charCodeAt(a)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=I(),m=11;default:for(;a<r&&w($);)a++,$=i.charCodeAt(a);if(l!==a){switch(c=i.substring(l,a),c){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return c+=String.fromCharCode($),a++,m=16}}function w($){if(k($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let $;do $=L();while($>=12&&$<=15);return $}return{setPosition:g,getPosition:()=>a,scan:p?x:L,getToken:()=>m,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>b}}e.createScanner=F;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function _(i,p){const a=[],r=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function b(P,g,I,R){l.value=P,l.offset=g,l.length=I,l.type=R,l.colonOffset=void 0,c=l}try{o(i,{onObjectBegin:(P,g)=>{if(p<=P)throw r;c=void 0,m=p>P,a.push("")},onObjectProperty:(P,g,I)=>{if(p<g||(b(P,g,I,"property"),a[a.length-1]=P,p<=g+I))throw r},onObjectEnd:(P,g)=>{if(p<=P)throw r;c=void 0,a.pop()},onArrayBegin:(P,g)=>{if(p<=P)throw r;c=void 0,a.push(0)},onArrayEnd:(P,g)=>{if(p<=P)throw r;c=void 0,a.pop()},onLiteralValue:(P,g,I)=>{if(p<g||(b(P,g,I,C(P)),p<=g+I))throw r},onSeparator:(P,g,I)=>{if(p<=g)throw r;if(P===":"&&c&&c.type==="property")c.colonOffset=g,m=!1,c=void 0;else if(P===","){const R=a[a.length-1];typeof R=="number"?a[a.length-1]=R+1:(m=!0,a[a.length-1]=""),c=void 0}}})}catch(P){if(P!==r)throw P}return{path:a,previousNode:c,isAtPropertyKey:m,matches:P=>{let g=0;for(let I=0;g<P.length&&I<a.length;I++)if(P[g]===a[I]||P[g]==="*")g++;else if(P[g]!=="**")return!1;return g===P.length}}}e.getLocation=_;function n(i,p=[],a=A.DEFAULT){let r=null,c=[];const l=[];function m(P){Array.isArray(c)?c.push(P):r!==null&&(c[r]=P)}return o(i,{onObjectBegin:()=>{const P={};m(P),l.push(c),c=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const P=[];m(P),l.push(c),c=P,r=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:m,onError:(P,g,I)=>{p.push({error:P,offset:g,length:I})}},a),c[0]}e.parse=n;function f(i,p=[],a=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(P){r.type==="property"&&(r.length=P-r.offset,r=r.parent)}function l(P){return r.children.push(P),P}o(i,{onObjectBegin:P=>{r=l({type:"object",offset:P,length:-1,parent:r,children:[]})},onObjectProperty:(P,g,I)=>{r=l({type:"property",offset:g,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:P,offset:g,length:I,parent:r})},onObjectEnd:(P,g)=>{r.length=P+g-r.offset,r=r.parent,c(P+g)},onArrayBegin:(P,g)=>{r=l({type:"array",offset:P,length:-1,parent:r,children:[]})},onArrayEnd:(P,g)=>{r.length=P+g-r.offset,r=r.parent,c(P+g)},onLiteralValue:(P,g,I)=>{l({type:C(P),offset:g,length:I,parent:r,value:P}),c(g+I)},onSeparator:(P,g,I)=>{r.type==="property"&&(P===":"?r.colonOffset=g:P===","&&c(g))},onError:(P,g,I)=>{p.push({error:P,offset:g,length:I})}},a);const b=r.children[0];return b&&delete b.parent,b}e.parseTree=f;function s(i,p){if(!i)return;let a=i;for(let r of p)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===r){a=l.children[1],c=!0;break}if(!c)return}else{const c=r;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=s;function u(i){if(!i.parent||!i.parent.children)return[];const p=u(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;p.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&p.push(a)}return p}e.getNodePath=u;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const p=Object.create(null);for(let a of i.children){const r=a.children[1];r&&(p[a.children[0].value]=v(r))}return p;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function D(i,p,a=!1){return p>=i.offset&&p<i.offset+i.length||a&&p===i.offset+i.length}e.contains=D;function y(i,p,a=!1){if(D(i,p,a)){const r=i.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=p;c++){const l=y(r[c],p,a);if(l)return l}return i}}e.findNodeAtOffset=y;function o(i,p,a=A.DEFAULT){const r=F(i,!1);function c(te){return te?()=>te(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(te){return te?ve=>te(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=c(p.onObjectBegin),b=l(p.onObjectProperty),P=c(p.onObjectEnd),g=c(p.onArrayBegin),I=c(p.onArrayEnd),R=l(p.onLiteralValue),L=l(p.onSeparator),w=c(p.onComment),x=l(p.onError),$=a&&a.disallowComments,B=a&&a.allowTrailingComma;function K(){for(;;){const te=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(te){case 12:case 13:$?H(10):w();break;case 16:H(1);break;case 15:case 14:break;default:return te}}}function H(te,ve=[],Re=[]){if(x(te),ve.length+Re.length>0){let Fe=r.getToken();for(;Fe!==17;){if(ve.indexOf(Fe)!==-1){K();break}else if(Re.indexOf(Fe)!==-1)break;Fe=K()}}}function W(te){const ve=r.getTokenValue();return te?R(ve):b(ve),K(),!0}function ne(){switch(r.getToken()){case 11:let te=0;try{te=JSON.parse(r.getTokenValue()),typeof te!="number"&&(H(2),te=0)}catch(ve){H(2)}R(te);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return K(),!0}function V(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(L(":"),K(),le()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function X(){m(),K();let te=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(te||H(4,[],[]),L(","),K(),r.getToken()===2&&B)break}else te&&H(6,[],[]);V()||H(4,[],[2,5]),te=!0}return P(),r.getToken()!==2?H(7,[2],[]):K(),!0}function q(){g(),K();let te=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(te||H(4,[],[]),L(","),K(),r.getToken()===4&&B)break}else te&&H(6,[],[]);le()||H(4,[],[4,5]),te=!0}return I(),r.getToken()!==4?H(8,[4],[]):K(),!0}function le(){switch(r.getToken()){case 3:return q();case 1:return X();case 10:return W(!0);default:return ne()}}return K(),r.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):le()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=o;function h(i,p){let a=F(i),r=[],c,l=0,m;do switch(m=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:l!==m&&r.push(i.substring(l,m)),p!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,p)),l=a.getPosition();break}while(c!==17);return r.join("")}e.stripComments=h;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(be[103],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new d(()=>E(this.getValue()))}}e.Lazy=d}),function(se,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(se=typeof globalThis!="undefined"?globalThis:se||self,se.marked=e())}(this,function(){"use strict";function se(Pe,ye){for(var De=0;De<ye.length;De++){var ee=ye[De];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Pe,ee.key,ee)}}function e(Pe,ye,De){return ye&&se(Pe.prototype,ye),De&&se(Pe,De),Pe}function d(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,ee=new Array(ye);De<ye;De++)ee[De]=Pe[De];return ee}function E(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=d(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var ee=0;return function(){return ee>=Pe.length?{done:!0}:{done:!1,value:Pe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Pe){A.exports.defaults=Pe}A.exports={defaults:F(),getDefaults:F,changeDefaults:k};var S=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return n[ye]};function s(Pe,ye){if(ye){if(S.test(Pe))return Pe.replace(T,f)}else if(t.test(Pe))return Pe.replace(_,f);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(u,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var D=/(^|[^\[])\^/g;function y(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(ue,ge){return ge=ge.source||ge,ge=ge.replace(D,"$1"),Pe=Pe.replace(ue,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var o=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Pe,ye,De){if(Pe){var ee;try{ee=decodeURIComponent(v(De)).replace(o,"").toLowerCase()}catch(ue){return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ye&&!h.test(De)&&(De=c(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var i={},p=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Pe,ye){i[" "+Pe]||(p.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=P(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(a,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(r,"$1")+ye:Pe+ye}var l={exec:function(){}};function m(Pe){for(var ye=1,De,ee;ye<arguments.length;ye++){De=arguments[ye];for(ee in De)Object.prototype.hasOwnProperty.call(De,ee)&&(Pe[ee]=De[ee])}return Pe}function b(Pe,ye){var De=Pe.replace(/\|/g,function(ge,fe,Ie){for(var xe=!1,Ne=fe;--Ne>=0&&Ie[Ne]==="\\";)xe=!xe;return xe?"|":" |"}),ee=De.split(/ \|/),ue=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>ye)ee.splice(ye);else for(;ee.length<ye;)ee.push("");for(;ue<ee.length;ue++)ee[ue]=ee[ue].trim().replace(/\\\|/g,"|");return ee}function P(Pe,ye,De){var ee=Pe.length;if(ee===0)return"";for(var ue=0;ue<ee;){var ge=Pe.charAt(ee-ue-1);if(ge===ye&&!De)ue++;else if(ge!==ye&&De)ue++;else break}return Pe.substr(0,ee-ue)}function g(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,ee=0,ue=0;ue<De;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===ye[0])ee++;else if(Pe[ue]===ye[1]&&(ee--,ee<0))return ue;return-1}function I(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var L={escape:s,unescape:v,edit:y,cleanUrl:C,resolveUrl:c,noopTest:l,merge:m,splitCells:b,rtrim:P,findClosingBracket:g,checkSanitizeDeprecation:I,repeatString:R},w=A.exports.defaults,x=L.rtrim,$=L.splitCells,B=L.escape,K=L.findClosingBracket;function H(Pe,ye,De,ee){var ue=ye.href,ge=ye.title?B(ye.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){ee.state.inLink=!0;var Ie={type:"link",raw:De,href:ue,title:ge,text:fe,tokens:ee.inlineTokens(fe,[])};return ee.state.inLink=!1,Ie}else return{type:"image",raw:De,href:ue,title:ge,text:B(fe)}}function W(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var ee=De[1];return ye.split(`
`).map(function(ue){var ge=ue.match(/^\s+/);if(ge===null)return ue;var fe=ge[0];return fe.length>=ee.length?ue.slice(ee.length):ue}).join(`
`)}var ne=function(){function Pe(De){this.options=De||w}var ye=Pe.prototype;return ye.space=function(ee){var ue=this.rules.block.newline.exec(ee);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(ee){var ue=this.rules.block.code.exec(ee);if(ue){var ge=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:x(ge,`
`)}}},ye.fences=function(ee){var ue=this.rules.block.fences.exec(ee);if(ue){var ge=ue[0],fe=W(ge,ue[3]||"");return{type:"code",raw:ge,lang:ue[2]?ue[2].trim():ue[2],text:fe}}},ye.heading=function(ee){var ue=this.rules.block.heading.exec(ee);if(ue){var ge=ue[2].trim();if(/#$/.test(ge)){var fe=x(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(ee){var ue=this.rules.block.hr.exec(ee);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ee){var ue=this.rules.block.blockquote.exec(ee);if(ue){var ge=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(ee){var ue=this.rules.block.list.exec(ee);if(ue){var ge,fe,Ie,xe,Ne,Ge,tt,Le,de,pe,Y=ue[1].trim(),z=Y.length>1,we={type:"list",raw:"",ordered:z,start:z?+Y.slice(0,-1):"",loose:!1,items:[]};Y=z?"\\d{1,9}\\"+Y.slice(-1):"\\"+Y,this.options.pedantic&&(Y=z?Y:"[*+-]");for(var ke=new RegExp("^( {0,3}"+Y+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(ue=ke.exec(ee)));){de=ue[2].split(`
`),this.options.pedantic?(xe=2,pe=de[0].trimLeft()):(xe=ue[2].search(/[^ ]/),xe=ue[1].length+(xe>4?1:xe),pe=de[0].slice(xe-ue[1].length)),Ge=!1,ge=ue[0],!de[0]&&/^ *$/.test(de[1])&&(ge=ue[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ne=1;Ne<de.length;Ne++){if(Le=de[Ne],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){ge=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}if(!Ge){Le.trim()||(Ge=!0),Le.search(/[^ ]/)>=xe?pe+=`
`+Le.slice(xe):pe+=`
`+Le;continue}if(Le.search(/[^ ]/)>=xe||!Le.trim()){pe+=`
`+Le.slice(xe);continue}else{ge=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}}we.loose||(tt?we.loose=!0:/\n *\n *$/.test(ge)&&(tt=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(pe),fe&&(Ie=fe[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:ge,task:!!fe,checked:Ie,loose:!1,text:pe}),we.raw+=ge,ee=ee.slice(ge.length)}we.items[we.items.length-1].raw=ge.trimRight(),we.items[we.items.length-1].text=pe.trimRight(),we.raw=we.raw.trimRight();var Ue=we.items.length;for(Ne=0;Ne<Ue;Ne++)this.lexer.state.top=!1,we.items[Ne].tokens=this.lexer.blockTokens(we.items[Ne].text,[]),we.items[Ne].tokens.some(function(dt){return dt.type==="space"})&&(we.loose=!0,we.items[Ne].loose=!0);return we}},ye.html=function(ee){var ue=this.rules.block.html.exec(ee);if(ue){var ge={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(ee){var ue=this.rules.block.def.exec(ee);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ge=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ee){var ue=this.rules.block.table.exec(ee);if(ue){var ge={type:"table",header:$(ue[1]).map(function(tt){return{text:tt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ue[0];var fe=ge.align.length,Ie,xe,Ne,Ge;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(fe=ge.rows.length,Ie=0;Ie<fe;Ie++)ge.rows[Ie]=$(ge.rows[Ie],ge.header.length).map(function(tt){return{text:tt}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ge=ge.rows[xe],Ne=0;Ne<Ge.length;Ne++)Ge[Ne].tokens=[],this.lexer.inlineTokens(Ge[Ne].text,Ge[Ne].tokens);return ge}}},ye.lheading=function(ee){var ue=this.rules.block.lheading.exec(ee);if(ue){var ge={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(ee){var ue=this.rules.block.paragraph.exec(ee);if(ue){var ge={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(ee){var ue=this.rules.block.text.exec(ee);if(ue){var ge={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(ee){var ue=this.rules.inline.escape.exec(ee);if(ue)return{type:"escape",raw:ue[0],text:B(ue[1])}},ye.tag=function(ee){var ue=this.rules.inline.tag.exec(ee);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]):ue[0]}},ye.link=function(ee){var ue=this.rules.inline.link.exec(ee);if(ue){var ge=ue[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=x(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Ie=K(ue[2],"()");if(Ie>-1){var xe=ue[0].indexOf("!")===0?5:4,Ne=xe+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Ne).trim(),ue[3]=""}}var Ge=ue[2],tt="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ge);Le&&(Ge=Le[1],tt=Le[3])}else tt=ue[3]?ue[3].slice(1,-1):"";return Ge=Ge.trim(),/^</.test(Ge)&&(this.options.pedantic&&!/>$/.test(ge)?Ge=Ge.slice(1):Ge=Ge.slice(1,-1)),H(ue,{href:Ge&&Ge.replace(this.rules.inline._escapes,"$1"),title:tt&&tt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ee,ue){var ge;if((ge=this.rules.inline.reflink.exec(ee))||(ge=this.rules.inline.nolink.exec(ee))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=ue[fe.toLowerCase()],!fe||!fe.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(ee,ue,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(ee);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Ne,Ge,tt=xe,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*ee.length+xe);(fe=de.exec(ue))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ge=Ne.length,fe[3]||fe[4]){tt+=Ge;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ge)%3)){Le+=Ge;continue}if(tt-=Ge,!(tt>0)){if(Ge=Math.min(Ge,Ge+tt+Le),Math.min(xe,Ge)%2){var pe=ee.slice(1,xe+fe.index+Ge);return{type:"em",raw:ee.slice(0,xe+fe.index+Ge+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var Y=ee.slice(2,xe+fe.index+Ge-1);return{type:"strong",raw:ee.slice(0,xe+fe.index+Ge+1),text:Y,tokens:this.lexer.inlineTokens(Y,[])}}}}}},ye.codespan=function(ee){var ue=this.rules.inline.code.exec(ee);if(ue){var ge=ue[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return fe&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=B(ge,!0),{type:"codespan",raw:ue[0],text:ge}}},ye.br=function(ee){var ue=this.rules.inline.br.exec(ee);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ee){var ue=this.rules.inline.del.exec(ee);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ye.autolink=function(ee,ue){var ge=this.rules.inline.autolink.exec(ee);if(ge){var fe,Ie;return ge[2]==="@"?(fe=B(this.options.mangle?ue(ge[1]):ge[1]),Ie="mailto:"+fe):(fe=B(ge[1]),Ie=fe),{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(ee,ue){var ge;if(ge=this.rules.inline.url.exec(ee)){var fe,Ie;if(ge[2]==="@")fe=B(this.options.mangle?ue(ge[0]):ge[0]),Ie="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=B(ge[0]),ge[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(ee,ue){var ge=this.rules.inline.text.exec(ee);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):B(ge[0]):ge[0]:fe=B(this.options.smartypants?ue(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Pe}(),V=L.noopTest,X=L.edit,q=L.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:V,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=X(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=X(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=X(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=X(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=X(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=X(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=q({},le),le.gfm=q({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=X(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=q({},le.normal,{html:X(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:V,paragraph:X(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:V,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:V,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=X(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=X(le._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=X(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=X(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=X(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=X(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=X(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=X(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=X(te.reflink).replace("label",te._label).getRegex(),te.reflinkSearch=X(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=q({},te),te.pedantic=q({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:X(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:X(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=q({},te.normal,{escape:X(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=X(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=q({},te.gfm,{br:X(te.br).replace("{2,}","*").getRegex(),text:X(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:te},Re=ne,Fe=A.exports.defaults,Oe=ve.block,Ke=ve.inline,je=L.repeatString;function Ve(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(Pe){var ye="",De,ee,ue=Pe.length;for(De=0;De<ue;De++)ee=Pe.charCodeAt(De),Math.random()>.5&&(ee="x"+ee.toString(16)),ye+="&#"+ee+";";return ye}var Q=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Fe,this.options.tokenizer=this.options.tokenizer||new Re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:Oe.normal,inline:Ke.normal};this.options.pedantic?(ee.block=Oe.pedantic,ee.inline=Ke.pedantic):this.options.gfm&&(ee.block=Oe.gfm,this.options.breaks?ee.inline=Ke.breaks:ee.inline=Ke.gfm),this.tokenizer.rules=ee}Pe.lex=function(ee,ue){var ge=new Pe(ue);return ge.lex(ee)},Pe.lexInline=function(ee,ue){var ge=new Pe(ue);return ge.inlineTokens(ee)};var ye=Pe.prototype;return ye.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ee,ue){var ge=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var fe,Ie,xe,Ne;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(tt){return(fe=tt.call({lexer:ge},ee,ue))?(ee=ee.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.space(ee)){ee=ee.substring(fe.raw.length),fe.type&&ue.push(fe);continue}if(fe=this.tokenizer.code(ee)){ee=ee.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(fe=this.tokenizer.fences(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.heading(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.hr(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.blockquote(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.list(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.html(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.def(ee)){ee=ee.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.lheading(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(xe=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var tt=Infinity,Le=ee.slice(1),de=void 0;ge.options.extensions.startBlock.forEach(function(pe){de=pe.call({lexer:this},Le),typeof de=="number"&&de>=0&&(tt=Math.min(tt,de))}),tt<Infinity&&tt>=0&&(xe=ee.substring(0,tt+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Ie=ue[ue.length-1],Ne&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe),Ne=xe.length!==ee.length,ee=ee.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(ee)){ee=ee.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(ee){var Ge="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return this.state.top=!0,ue},ye.inline=function(ee,ue){this.inlineQueue.push({src:ee,tokens:ue})},ye.inlineTokens=function(ee,ue){var ge=this;ue===void 0&&(ue=[]);var fe,Ie,xe,Ne=ee,Ge,tt,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Ge=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)de.includes(Ge[0].slice(Ge[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ge=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ge=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ge.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(tt||(Le=""),tt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(fe=Y.call({lexer:ge},ee,ue))?(ee=ee.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.tag(ee)){ee=ee.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.link(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.emStrong(ee,Ne,Le)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.codespan(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.br(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.del(ee)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.autolink(ee,U)){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(ee,U))){ee=ee.substring(fe.raw.length),ue.push(fe);continue}if(xe=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=Infinity,z=ee.slice(1),we=void 0;ge.options.extensions.startInline.forEach(function(ke){we=ke.call({lexer:this},z),typeof we=="number"&&we>=0&&(Y=Math.min(Y,we))}),Y<Infinity&&Y>=0&&(xe=ee.substring(0,Y+1))}(),fe=this.tokenizer.inlineText(xe,Ve)){ee=ee.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),tt=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(ee){var pe="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ke}}}]),Pe}(),ie=A.exports.defaults,ae=L.cleanUrl,G=L.escape,oe=function(){function Pe(De){this.options=De||ie}var ye=Pe.prototype;return ye.code=function(ee,ue,ge){var fe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(ee,fe);Ie!=null&&Ie!==ee&&(ge=!0,ee=Ie)}return ee=ee.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+G(fe,!0)+'">'+(ge?ee:G(ee,!0))+`</code></pre>
`:"<pre><code>"+(ge?ee:G(ee,!0))+`</code></pre>
`},ye.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ye.html=function(ee){return ee},ye.heading=function(ee,ue,ge,fe){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+ee+"</h"+ue+`>
`:"<h"+ue+">"+ee+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ee,ue,ge){var fe=ue?"ol":"ul",Ie=ue&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Ie+`>
`+ee+"</"+fe+`>
`},ye.listitem=function(ee){return"<li>"+ee+`</li>
`},ye.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ee){return"<p>"+ee+`</p>
`},ye.table=function(ee,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ye.tablecell=function(ee,ue){var ge=ue.header?"th":"td",fe=ue.align?"<"+ge+' align="'+ue.align+'">':"<"+ge+">";return fe+ee+"</"+ge+`>
`},ye.strong=function(ee){return"<strong>"+ee+"</strong>"},ye.em=function(ee){return"<em>"+ee+"</em>"},ye.codespan=function(ee){return"<code>"+ee+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ee){return"<del>"+ee+"</del>"},ye.link=function(ee,ue,ge){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ge;var fe='<a href="'+G(ee)+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(ee,ue,ge){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ge;var fe='<img src="'+ee+'" alt="'+ge+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(ee){return ee},Pe}(),he=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(ee){return ee},ye.em=function(ee){return ee},ye.codespan=function(ee){return ee},ye.del=function(ee){return ee},ye.html=function(ee){return ee},ye.text=function(ee){return ee},ye.link=function(ee,ue,ge){return""+ge},ye.image=function(ee,ue,ge){return""+ge},ye.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ee,ue){var ge=ee,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[ee];do fe++,ge=ee+"-"+fe;while(this.seen.hasOwnProperty(ge))}return ue||(this.seen[ee]=fe,this.seen[ge]=0),ge},ye.slug=function(ee,ue){ue===void 0&&(ue={});var ge=this.serialize(ee);return this.getNextSafeSlug(ge,ue.dryrun)},Pe}(),Be=oe,He=he,Qe=Te,it=A.exports.defaults,Ce=L.unescape,Ze=function(){function Pe(De){this.options=De||it,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Qe}Pe.parse=function(ee,ue){var ge=new Pe(ue);return ge.parse(ee)},Pe.parseInline=function(ee,ue){var ge=new Pe(ue);return ge.parseInline(ee)};var ye=Pe.prototype;return ye.parse=function(ee,ue){ue===void 0&&(ue=!0);var ge="",fe,Ie,xe,Ne,Ge,tt,Le,de,pe,Y,z,we,ke,Je,Ue,dt,gt,lt,ft,ut=ee.length;for(fe=0;fe<ut;fe++){if(Y=ee[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(ft=this.options.extensions.renderers[Y.type].call({parser:this},Y),ft!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){ge+=ft||"";continue}switch(Y.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,Ce(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(de="",Le="",Ne=Y.header.length,Ie=0;Ie<Ne;Ie++)Le+=this.renderer.tablecell(this.parseInline(Y.header[Ie].tokens),{header:!0,align:Y.align[Ie]});for(de+=this.renderer.tablerow(Le),pe="",Ne=Y.rows.length,Ie=0;Ie<Ne;Ie++){for(tt=Y.rows[Ie],Le="",Ge=tt.length,xe=0;xe<Ge;xe++)Le+=this.renderer.tablecell(this.parseInline(tt[xe].tokens),{header:!1,align:Y.align[xe]});pe+=this.renderer.tablerow(Le)}ge+=this.renderer.table(de,pe);continue}case"blockquote":{pe=this.parse(Y.tokens),ge+=this.renderer.blockquote(pe);continue}case"list":{for(z=Y.ordered,we=Y.start,ke=Y.loose,Ne=Y.items.length,pe="",Ie=0;Ie<Ne;Ie++)Ue=Y.items[Ie],dt=Ue.checked,gt=Ue.task,Je="",Ue.task&&(lt=this.renderer.checkbox(dt),ke?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=lt+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=lt+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:lt}):Je+=lt),Je+=this.parse(Ue.tokens,ke),pe+=this.renderer.listitem(Je,gt,dt);ge+=this.renderer.list(pe,z,we);continue}case"html":{ge+=this.renderer.html(Y.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(pe=Y.tokens?this.parseInline(Y.tokens):Y.text;fe+1<ut&&ee[fe+1].type==="text";)Y=ee[++fe],pe+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);ge+=ue?this.renderer.paragraph(pe):pe;continue}default:{var pt='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return ge},ye.parseInline=function(ee,ue){ue=ue||this.renderer;var ge="",fe,Ie,xe,Ne=ee.length;for(fe=0;fe<Ne;fe++){if(Ie=ee[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(xe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=xe||"";continue}switch(Ie.type){case"escape":{ge+=ue.text(Ie.text);break}case"html":{ge+=ue.html(Ie.text);break}case"link":{ge+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{ge+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{ge+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{ge+=ue.codespan(Ie.text);break}case"br":{ge+=ue.br();break}case"del":{ge+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{ge+=ue.text(Ie.text);break}default:{var Ge='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Ge);return}else throw new Error(Ge)}}}return ge},Pe}(),j=Q,J=Ze,me=ne,We=oe,Ye=he,st=Te,ot=L.merge,Et=L.checkSanitizeDeprecation,mt=L.escape,Dt=A.exports.getDefaults,Pt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=ot({},Xe.defaults,ye||{}),Et(ye),De){var ee=ye.highlight,ue;try{ue=j.lex(Pe,ye)}catch(xe){return De(xe)}var ge=function(Ne){var Ge;if(!Ne)try{ye.walkTokens&&Xe.walkTokens(ue,ye.walkTokens),Ge=J.parse(ue,ye)}catch(tt){Ne=tt}return ye.highlight=ee,Ne?De(Ne):De(null,Ge)};if(!ee||ee.length<3||(delete ye.highlight,!ue.length))return ge();var fe=0;Xe.walkTokens(ue,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){ee(xe.text,xe.lang,function(Ne,Ge){if(Ne)return ge(Ne);Ge!=null&&Ge!==xe.text&&(xe.text=Ge,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Ie=j.lex(Pe,ye);return ye.walkTokens&&Xe.walkTokens(Ie,ye.walkTokens),J.parse(Ie,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+mt(xe.message+"",!0)+"</pre>";throw xe}}Xe.options=Xe.setOptions=function(Pe){return ot(Xe.defaults,Pe),Pt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=It,Xe.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),ee=0;ee<ye;ee++)De[ee]=arguments[ee];var ue=ot.apply(void 0,[{}].concat(De)),ge=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;De.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var Ge=ge.renderers?ge.renderers[Ne.name]:null;Ge?ge.renderers[Ne.name]=function(){for(var tt=arguments.length,Le=new Array(tt),de=0;de<tt;de++)Le[de]=arguments[de];var pe=Ne.renderer.apply(this,Le);return pe===!1&&(pe=Ge.apply(this,Le)),pe}:ge.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Ne.level]?ge[Ne.level].unshift(Ne.tokenizer):ge[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?ge.startBlock?ge.startBlock.push(Ne.start):ge.startBlock=[Ne.start]:Ne.level==="inline"&&(ge.startInline?ge.startInline.push(Ne.start):ge.startInline=[Ne.start]))}Ne.childTokens&&(ge.childTokens[Ne.name]=Ne.childTokens)})),Ie.renderer&&function(){var Ne=Xe.defaults.renderer||new We,Ge=function(de){var pe=Ne[de];Ne[de]=function(){for(var Y=arguments.length,z=new Array(Y),we=0;we<Y;we++)z[we]=arguments[we];var ke=Ie.renderer[de].apply(Ne,z);return ke===!1&&(ke=pe.apply(Ne,z)),ke}};for(var tt in Ie.renderer)Ge(tt);ue.renderer=Ne}(),Ie.tokenizer&&function(){var Ne=Xe.defaults.tokenizer||new me,Ge=function(de){var pe=Ne[de];Ne[de]=function(){for(var Y=arguments.length,z=new Array(Y),we=0;we<Y;we++)z[we]=arguments[we];var ke=Ie.tokenizer[de].apply(Ne,z);return ke===!1&&(ke=pe.apply(Ne,z)),ke}};for(var tt in Ie.tokenizer)Ge(tt);ue.tokenizer=Ne}(),Ie.walkTokens){var xe=Xe.defaults.walkTokens;ue.walkTokens=function(Ne){Ie.walkTokens.call(Pe,Ne),xe&&xe(Ne)}}fe&&(ue.extensions=ge),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,ye){for(var De=function(){var fe=ue.value;switch(ye(fe),fe.type){case"table":{for(var Ie=E(fe.header),xe;!(xe=Ie()).done;){var Ne=xe.value;Xe.walkTokens(Ne.tokens,ye)}for(var Ge=E(fe.rows),tt;!(tt=Ge()).done;)for(var Le=tt.value,de=E(Le),pe;!(pe=de()).done;){var Y=pe.value;Xe.walkTokens(Y.tokens,ye)}break}case"list":{Xe.walkTokens(fe.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],ye)}):fe.tokens&&Xe.walkTokens(fe.tokens,ye)}},ee=E(Pe),ue;!(ue=ee()).done;)De()},Xe.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=ot({},Xe.defaults,ye||{}),Et(ye);try{var De=j.lexInline(Pe,ye);return ye.walkTokens&&Xe.walkTokens(De,ye.walkTokens),J.parseInline(De,ye)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+mt(ee.message+"",!0)+"</pre>";throw ee}},Xe.Parser=J,Xe.parser=J.parse,Xe.Renderer=We,Xe.TextRenderer=Ye,Xe.Lexer=j,Xe.lexer=j.lex,Xe.Tokenizer=me,Xe.Slugger=st,Xe.parse=Xe;var St=Xe;return St}),define(be[76],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,k,S){return Math.min(Math.max(F,k),S)}e.clamp=d;function M(F,k){return(k+F%k)%k}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function se(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function F(S){A.push(S,Date.now())}function k(){const S=[];for(let T=0;T<A.length;T+=2)S.push({name:A[T],startTime:A[T+1]});return S}return{mark:F,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(E+F.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function d(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[104],Ee([0,1]),function(se,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,S,T){this.level=k,this.key=S,this.value=T,this.forward=[]}}const E=void 0;class A{constructor(k,S=2**16){this.comparator=k,this[d]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new M(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,E,E)}has(k){return Boolean(A._search(this,k,this.comparator))}get(k){return A._search(this,k,this.comparator)?.value}set(k,S){return A._insert(this,k,S,this.comparator)&&(this._size+=1),this}delete(k){const S=A._delete(this,k,this.comparator);return S&&(this._size-=1),S}forEach(k,S){let T=this._header.forward[0];for(;T;)k.call(S,T.value,T.key,this),T=T.forward[0]}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",S=this._header.forward[0];for(;S;)k+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return k}static _search(k,S,T){let t=k._header;for(let _=k._level-1;_>=0;_--)for(;t.forward[_]&&T(t.forward[_].key,S)<0;)t=t.forward[_];if(t=t.forward[0],t&&T(t.key,S)===0)return t}static _insert(k,S,T,t){let _=[],n=k._header;for(let f=k._level-1;f>=0;f--){for(;n.forward[f]&&t(n.forward[f].key,S)<0;)n=n.forward[f];_[f]=n}if(n=n.forward[0],n&&t(n.key,S)===0)return n.value=T,!1;{let f=A._randomLevel(k);if(f>k._level){for(let s=k._level;s<f;s++)_[s]=k._header;k._level=f}n=new M(f,S,T);for(let s=0;s<f;s++)n.forward[s]=_[s].forward[s],_[s].forward[s]=n;return!0}}static _randomLevel(k,S=.5){let T=1;for(;Math.random()<S&&T<k._maxLevel;)T+=1;return T}static _delete(k,S,T){let t=[],_=k._header;for(let n=k._level-1;n>=0;n--){for(;_.forward[n]&&T(_.forward[n].key,S)<0;)_=_.forward[n];t[n]=_}if(_=_.forward[0],!_||T(_.key,S)!==0)return!1;for(let n=0;n<k._level&&t[n].forward[n]===_;n++)t[n].forward[n]=_.forward[n];for(;k._level>0&&k._header.forward[k._level-1]===E;)k._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(_){const n=this._icons.get(_.id);n?_.description?n.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,_){return new k(t,_)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(_,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class k{constructor(_,n,f){this.id=_,this.definition=n,this.description=f,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function S(t,_){const n=["codicon","codicon-"+t];return _&&n.push("codicon-modifier-"+_),n}e.getClassNamesArray=S;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(u){if(u instanceof k)return["codicon","codicon-"+u.id];const v=_.exec(u.id);if(!v)return n(k.error);let[,D,y]=v;const o=["codicon","codicon-"+D];return y&&o.push("codicon-modifier-"+y.substr(1)),o}t.asClassNameArray=n;function f(u){return n(u).join(" ")}t.asClassName=f;function s(u){return"."+n(u).join(".")}t.asCSSSelector=s})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",{fontCharacter:"\\eb0f"}),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(o){const h=o;return h?[h.on,h.pause,h.resume,h.destroy].every(C=>typeof C=="function"):!1}e.isReadableStream=E;function A(o){const h=o;return h?E(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(o,h){return new k(o,h)}e.newWriteableStream=F;class k{constructor(h,C){this.reducer=h,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(C=>C(h))}emitError(h){this.listeners.error.length===0?(0,d.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(C=>C(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,C){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(h,C){if(this.state.destroyed)return;let i;switch(h){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const p=i.indexOf(C);p>=0&&i.splice(p,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(o,h){const C=[];let i;for(;(i=o.read())!==null;)C.push(i);return h(C)}e.consumeReadable=S;function T(o,h,C){const i=[];let p;for(;(p=o.read())!==null&&i.length<C;)i.push(p);return p===null&&i.length>0?h(i):{read:()=>{if(i.length>0)return i.shift();if(typeof p!="undefined"){const a=p;return p=void 0,a}return o.read()}}}e.peekReadable=T;function t(o,h){return new Promise((C,i)=>{const p=[];_(o,{onData:a=>{h&&p.push(a)},onError:a=>{h?i(a):C(void 0)},onEnd:()=>{C(h?h(p):void 0)}})})}e.consumeStream=t;function _(o,h){o.on("error",C=>h.onError(C)),o.on("end",()=>h.onEnd()),o.on("data",C=>h.onData(C))}e.listenStream=_;function n(o,h){return new Promise((C,i)=>{const p=new M.DisposableStore,a=[],r=m=>{if(a.push(m),a.length>h)return p.dispose(),o.pause(),C({stream:o,buffer:a,ended:!1})},c=m=>i(m),l=()=>C({stream:o,buffer:a,ended:!0});p.add((0,M.toDisposable)(()=>o.removeListener("error",c))),o.on("error",c),p.add((0,M.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),p.add((0,M.toDisposable)(()=>o.removeListener("data",r))),o.on("data",r)})}e.peekStream=n;function f(o,h){const C=F(h);return C.end(o),C}e.toStream=f;function s(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=s;function u(o){let h=!1;return{read:()=>h?null:(h=!0,o)}}e.toReadable=u;function v(o,h,C){const i=F(C);return _(o,{onData:p=>i.write(h.data(p)),onError:p=>i.error(h.error?h.error(p):p),onEnd:()=>i.end()}),i}e.transform=v;function D(o,h,C){let i=!1;return{read:()=>{const p=h.read();return i?p:(i=!0,p!==null?C([o,p]):o)}}}e.prefixedReadable=D;function y(o,h,C){let i=!1;const p=F(C);return _(h,{onData:a=>i?p.write(a):(i=!0,p.write(C([o,a]))),onError:a=>p.error(a),onEnd:()=>{i||(i=!0,p.write(o)),p.end()}}),p}e.prefixedStream=y}),define(be[22],Ee([0,1,105]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return M?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return M&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,c){return!(c?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(r)):(E||(E=new TextEncoder),new F(E.encode(r)))}static concat(r,c){if(typeof c=="undefined"){c=0;for(let b=0,P=r.length;b<P;b++)c+=r[b].byteLength}const l=F.alloc(c);let m=0;for(let b=0,P=r.length;b<P;b++){const g=r[b];l.set(g,m),m+=g.byteLength}return l}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,c){return new F(this.buffer.subarray(r,c))}set(r,c){r instanceof F?this.buffer.set(r.buffer,c):this.buffer.set(r,c)}readUInt32BE(r){return T(this.buffer,r)}writeUInt32BE(r,c){t(this.buffer,r,c)}readUInt32LE(r){return _(this.buffer,r)}writeUInt32LE(r,c){n(this.buffer,r,c)}readUInt8(r){return f(this.buffer,r)}writeUInt8(r,c){s(this.buffer,r,c)}}e.VSBuffer=F;function k(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}e.readUInt16LE=k;function S(a,r,c){a[c+0]=r&255,r=r>>>8,a[c+1]=r&255}e.writeUInt16LE=S;function T(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}e.readUInt32BE=T;function t(a,r,c){a[c+3]=r,r=r>>>8,a[c+2]=r,r=r>>>8,a[c+1]=r,r=r>>>8,a[c]=r}e.writeUInt32BE=t;function _(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}e.readUInt32LE=_;function n(a,r,c){a[c+0]=r&255,r=r>>>8,a[c+1]=r&255,r=r>>>8,a[c+2]=r&255,r=r>>>8,a[c+3]=r&255}e.writeUInt32LE=n;function f(a,r){return a[r]}e.readUInt8=f;function s(a,r,c){a[c]=r}e.writeUInt8=s;function u(a){return d.consumeReadable(a,r=>F.concat(r))}e.readableToBuffer=u;function v(a){return d.toReadable(a)}e.bufferToReadable=v;function D(a){return d.consumeStream(a,r=>F.concat(r))}e.streamToBuffer=D;async function y(a){return a.ended?F.concat(a.buffer):F.concat([...a.buffer,await D(a.stream)])}e.bufferedStreamToBuffer=y;function o(a){return d.toStream(a,r=>F.concat(r))}e.bufferToStream=o;function h(a){return d.transform(a,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}e.streamToBufferReadableStream=h;function C(a){return d.newWriteableStream(r=>F.concat(r),a)}e.newWriteableBufferStream=C;function i(a,r){return d.prefixedReadable(a,r,c=>F.concat(c))}e.prefixedBufferReadable=i;function p(a,r){return d.prefixedStream(a,r,c=>F.concat(c))}e.prefixedBufferStream=p}),define(be[35],Ee([0,1,9]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",F="warning",k="warn",S="info",T="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?E.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(k,n)?E.Warning:d.equalsIgnoreCase(S,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(n){switch(n){case E.Error:return A;case E.Warning:return F;case E.Info:return S;default:return T}}E.toString=_}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(a){return a===47||a===92}e.isPathSeparator=F;function k(a){return a.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=k;function S(a){return a.indexOf("/")===-1&&(a=k(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function T(a,r=d.posix.sep){if(!a)return"";const c=a.length,l=a.charCodeAt(0);if(F(l)){if(F(a.charCodeAt(1))&&!F(a.charCodeAt(2))){let b=3;const P=b;for(;b<c&&!F(a.charCodeAt(b));b++);if(P!==b&&!F(a.charCodeAt(b+1))){for(b+=1;b<c;b++)if(F(a.charCodeAt(b)))return a.slice(0,b+1).replace(/[\\/]/g,r)}}return r}else if(D(l)&&a.charCodeAt(1)===58)return F(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let m=a.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(F(a.charCodeAt(m)))return a.slice(0,m+1)}return""}e.getRoot=T;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let c=2;const l=c;for(;c<a.length&&(r=a.charCodeAt(c),r!==92);c++);return!(l===c||(r=a.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(a,r=M.isWindows){const c=r?_:n;return!(!a||a.length===0||/^\s+$/.test(a)||(c.lastIndex=0,c.test(a))||r&&f.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=s;function u(a,r,c){const l=a===r;return!c||l?l:!a||!r?!1:(0,E.equalsIgnoreCase)(a,r)}e.isEqual=u;function v(a,r,c,l=d.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(c){if(!(0,E.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let b=r.length;return r.charAt(r.length-1)===l&&b--,a.charAt(b)===l}return r.charAt(r.length-1)!==l&&(r+=l),a.indexOf(r)===0}e.isEqualOrParent=v;function D(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=D;function y(a,r){return M.isWindows&&a.endsWith(":")&&(a+=d.sep),(0,d.isAbsolute)(a)||(a=(0,d.join)(r,a)),a=(0,d.normalize)(a),M.isWindows?(a=(0,E.rtrim)(a,d.sep),a.endsWith(":")&&(a+=d.sep)):(a=(0,E.rtrim)(a,d.sep),a||(a=d.sep)),a}e.sanitizeFilePath=y;function o(a){const r=(0,d.normalize)(a);return M.isWindows?a.length>3?!1:h(r)&&(a.length===2||r.charCodeAt(2)===92):r===d.posix.sep}e.isRootOrDriveLetter=o;function h(a){return M.isWindows?D(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function C(a){return h(a)?a[0]:void 0}e.getDriveLetter=C;function i(a,r,c){return r.length>a.length?-1:a===r?0:(c&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=i;function p(a){const r=a.split(":");let c,l,m;if(r.forEach(b=>{const P=Number(b);(0,A.isNumber)(P)?l===void 0?l=P:m===void 0&&(m=P):c=c?[c,b].join(":"):b}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:m!==void 0?m:l!==void 0?1:void 0}}e.parseLineAndColumnAware=p}),define(be[23],Ee([0,1,10]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.keys(u).forEach(D=>{u[D]&&typeof u[D]=="object"?v[D]=M(u[D]):v[D]=u[D]}),v}e.deepClone=M;function E(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const D=v.shift();Object.freeze(D);for(const y in D)if(A.call(D,y)){const o=D[y];typeof o=="object"&&!Object.isFrozen(o)&&v.push(o)}}return u}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function F(u,v){return k(u,v,new Set)}e.cloneAndChange=F;function k(u,v,D){if((0,d.isUndefinedOrNull)(u))return u;const y=v(u);if(typeof y!="undefined")return y;if((0,d.isArray)(u)){const o=[];for(const h of u)o.push(k(h,v,D));return o}if((0,d.isObject)(u)){if(D.has(u))throw new Error("Cannot clone recursive data-structure");D.add(u);const o={};for(let h in u)A.call(u,h)&&(o[h]=k(u[h],v,D));return D.delete(u),o}return u}function S(u,v,D=!0){return(0,d.isObject)(u)?((0,d.isObject)(v)&&Object.keys(v).forEach(y=>{y in u?D&&((0,d.isObject)(u[y])&&(0,d.isObject)(v[y])?S(u[y],v[y],D):u[y]=v[y]):u[y]=v[y]}),u):v}e.mixin=S;function T(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let D,y;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(D=0;D<u.length;D++)if(!T(u[D],v[D]))return!1}else{const o=[];for(y in u)o.push(y);o.sort();const h=[];for(y in v)h.push(y);if(h.sort(),!T(o,h))return!1;for(D=0;D<o.length;D++)if(!T(u[o[D]],v[o[D]]))return!1}return!0}e.equals=T;function t(u){const v=new Set;return JSON.stringify(u,(D,y)=>{if((0,d.isObject)(y)||Array.isArray(y)){if(v.has(y))return"[Circular]";v.add(y)}return y})}e.safeStringify=t;function _(u,v,D){const y=v(u);return typeof y=="undefined"?D:y}e.getOrDefault=_;function n(u,v){const D=Object.create(null);return!u||!v||Object.keys(v).forEach(o=>{const h=u[o],C=v[o];T(h,C)||(D[o]=C)}),D}e.distinct=n;function f(u,v){const D=v.toLowerCase(),y=Object.keys(u).find(o=>o.toLowerCase()===D);return y?u[y]:u[v]}e.getCaseInsensitive=f;function s(u,v){const D=Object.create(null);for(const y of Object.keys(u))v(y,u[y])&&(D[y]=u[y]);return D}e.filter=s});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[20],Ee([0,1,13,9,2]),function(se,e,d,M,E){"use strict";var A,F,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(a,r,c){let l=a.get(r);return l===void 0&&(l=c,a.set(r,l)),l}e.getOrSet=S;function T(a){const r=[];return a.forEach((c,l)=>{r.push(`${l} => ${c}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=T;function t(a){const r=[];return a.forEach(c=>{r.push(c)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class _{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const c=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return c-l}value(){return this._value[this._pos]}}e.StringIterator=_;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class f{constructor(r=!0,c=!0){this._splitOnBackslash=r,this._caseSensitive=c}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var s;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(s||(s={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(D||(D={}));class y{constructor(r){this._iter=r}static forUris(r=()=>!1){return new y(new u(r))}static forPaths(){return new y(new f)}static forStrings(){return new y(new _)}static forConfigKeys(){return new y(new n)}clear(){this._root=void 0}fill(r,c){if(c){const l=c.slice(0);(0,d.shuffle)(l);for(let m of l)this.set(m,r)}else{const l=r.slice(0);(0,d.shuffle)(l);for(let m of l)this.set(m[0],m[1])}}set(r,c){const l=this._iter.reset(r);let m;this._root||(this._root=new v,this._root.segment=l.value());const b=[];for(m=this._root;;){const g=l.cmp(m.segment);if(g>0)m.left||(m.left=new v,m.left.segment=l.value()),b.push([-1,m]),m=m.left;else if(g<0)m.right||(m.right=new v,m.right.segment=l.value()),b.push([1,m]),m=m.right;else if(l.hasNext())l.next(),m.mid||(m.mid=new v,m.mid.segment=l.value()),b.push([0,m]),m=m.mid;else break}const P=m.value;m.value=c,m.key=r;for(let g=b.length-1;g>=0;g--){const I=b[g][1];I.updateHeight();const R=I.balanceFactor();if(R<-1||R>1){const L=b[g][0],w=b[g+1][0];if(L===1&&w===1)b[g][1]=I.rotateLeft();else if(L===-1&&w===-1)b[g][1]=I.rotateRight();else if(L===1&&w===-1)I.right=b[g+1][1]=b[g+1][1].rotateRight(),b[g][1]=I.rotateLeft();else if(L===-1&&w===1)I.left=b[g+1][1]=b[g+1][1].rotateLeft(),b[g][1]=I.rotateRight();else throw new Error;if(g>0)switch(b[g-1][0]){case-1:b[g-1][1].left=b[g][1];break;case 1:b[g-1][1].right=b[g][1];break;case 0:b[g-1][1].mid=b[g][1];break}else this._root=b[0][1]}}return P}get(r){return this._getNode(r)?.value}_getNode(r){const c=this._iter.reset(r);let l=this._root;for(;l;){const m=c.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else break}return l}has(r){const c=this._getNode(r);return!(c?.value===void 0&&c?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,c){const l=this._iter.reset(r),m=[];let b=this._root;for(;b;){const P=l.cmp(b.segment);if(P>0)m.push([-1,b]),b=b.left;else if(P<0)m.push([1,b]),b=b.right;else if(l.hasNext())l.next(),m.push([0,b]),b=b.mid;else break}if(!!b){if(c?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const P=this._min(b.right),{key:g,value:I,segment:R}=P;this._delete(P.key,!1),b.key=g,b.value=I,b.segment=R}else{const P=b.left??b.right;if(m.length>0){const[g,I]=m[m.length-1];switch(g){case-1:I.left=P;break;case 0:I.mid=P;break;case 1:I.right=P;break}}else this._root=P}for(let P=m.length-1;P>=0;P--){const g=m[P][1];g.updateHeight();const I=g.balanceFactor();if(I>1?(g.right.balanceFactor()>=0||(g.right=m[P+1][1]=m[P+1][1].rotateRight()),m[P][1]=g.rotateLeft()):I<-1&&(g.left.balanceFactor()<=0||(g.left=m[P+1][1]=m[P+1][1].rotateLeft()),m[P][1]=g.rotateRight()),P>0)switch(m[P-1][0]){case-1:m[P-1][1].left=m[P][1];break;case 1:m[P-1][1].right=m[P][1];break;case 0:m[P-1][1].mid=m[P][1];break}else this._root=m[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const c=this._iter.reset(r);let l=this._root,m;for(;l;){const b=c.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(c.hasNext())c.next(),m=l.value||m,l=l.mid;else break}return l&&l.value||m}findSuperstr(r){const c=this._iter.reset(r);let l=this._root;for(;l;){const m=c.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[c,l]of this)r(l,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=c=>{if(!c)return!0;const l=c.balanceFactor();return l<-1||l>1?!1:r(c.left)&&r(c.right)};return r(this._root)}}e.TernarySearchTree=y;class o{constructor(r,c){this[A]="ResourceMap",r instanceof o?(this.map=new Map(r.map),this.toKey=c??o.defaultToKey):(this.map=new Map,this.toKey=r??o.defaultToKey)}set(r,c){return this.map.set(this.toKey(r),c),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,c){typeof c!="undefined"&&(r=r.bind(c));for(let[l,m]of this.map)r(m,E.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=o,o.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class C{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,c=0){const l=this._map.get(r);if(!!l)return c!==0&&this.touch(l,c),l.value}set(r,c,l=0){let m=this._map.get(r);if(m)m.value=c,l!==0&&this.touch(m,l);else{switch(m={key:r,value:c,next:void 0,previous:void 0},l){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const c=this._map.get(r);if(!!c)return this._map.delete(r),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,c){const l=this._state;let m=this._head;for(;m;){if(c?r.bind(c)(m.value,m.key,this):r(m.value,m.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,c=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return m}values(){const r=this,c=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return m}entries(){const r=this,c=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return m}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let c=this._head,l=this.size;for(;c&&l>r;)this._map.delete(c.key),c=c.next,l--;this._head=c,this._size=l,c&&(c.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const c=r.next,l=r.previous;if(!c||!l)throw new Error("Invalid list");c.previous=l,l.next=c}r.next=void 0,r.previous=void 0,this._state++}touch(r,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(r===this._head)return;const l=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(l.previous=m,m.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(c===2){if(r===this._tail)return;const l=r.next,m=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=m,m.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((c,l)=>{r.push([l,c])}),r}fromJSON(r){this.clear();for(const[c,l]of r)this.set(c,l)}}e.LinkedMap=C;class i extends C{constructor(r,c=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,c=2){return super.get(r,c)}peek(r){return super.get(r,0)}set(r,c){return super.set(r,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class p{constructor(r){k.set(this,void 0),et(this,k,r,"f")}get size(){return Ae(this,k,"f").size}forEach(r,c){Ae(this,k,"f").forEach(r,c)}get(r){return Ae(this,k,"f").get(r)}has(r){return Ae(this,k,"f").has(r)}entries(){return Ae(this,k,"f").entries()}keys(){return Ae(this,k,"f").keys()}values(){return Ae(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ae(this,k,"f").entries()}}e.ReadonlyMapView=p}),define(be[106],Ee([0,1,20,9]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...G){return function(oe,he){for(let Te=0,Be=G.length;Te<Be;Te++){const He=G[Te](oe,he);if(He)return He}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,oe,he){if(!he||he.length<oe.length)return null;let Te;return G?Te=M.startsWithIgnoreCase(he,oe):Te=he.indexOf(oe)===0,Te?oe.length>0?[{start:0,end:oe.length}]:[]:null}function F(G,oe){const he=oe.toLowerCase().indexOf(G.toLowerCase());return he===-1?null:[{start:he,end:he+G.length}]}e.matchesContiguousSubString=F;function k(G,oe){return S(G.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=k;function S(G,oe,he,Te){if(he===G.length)return[];if(Te===oe.length)return null;if(G[he]===oe[Te]){let Be=null;return(Be=S(G,oe,he+1,Te+1))?D({start:Te,end:Te+1},Be):null}return S(G,oe,he,Te+1)}function T(G){return 97<=G&&G<=122}function t(G){return 65<=G&&G<=90}e.isUpper=t;function _(G){return 48<=G&&G<=57}function n(G){return G===32||G===9||G===10||G===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(G=>f.add(G.charCodeAt(0)));function s(G){return n(G)||f.has(G)}function u(G,oe){return G===oe||s(G)&&s(oe)}function v(G){return T(G)||t(G)||_(G)}function D(G,oe){return oe.length===0?oe=[G]:G.end===oe[0].start?oe[0].start=G.start:oe.unshift(G),oe}function y(G,oe){for(let he=oe;he<G.length;he++){const Te=G.charCodeAt(he);if(t(Te)||_(Te)||he>0&&!v(G.charCodeAt(he-1)))return he}return G.length}function o(G,oe,he,Te){if(he===G.length)return[];if(Te===oe.length)return null;if(G[he]!==oe[Te].toLowerCase())return null;{let Be=null,He=Te+1;for(Be=o(G,oe,he+1,Te+1);!Be&&(He=y(oe,He))<oe.length;)Be=o(G,oe,he+1,He),He++;return Be===null?null:D({start:Te,end:Te+1},Be)}}function h(G){let oe=0,he=0,Te=0,Be=0,He=0;for(let j=0;j<G.length;j++)He=G.charCodeAt(j),t(He)&&oe++,T(He)&&he++,v(He)&&Te++,_(He)&&Be++;const Qe=oe/G.length,it=he/G.length,Ce=Te/G.length,Ze=Be/G.length;return{upperPercent:Qe,lowerPercent:it,alphaPercent:Ce,numericPercent:Ze}}function C(G){const{upperPercent:oe,lowerPercent:he}=G;return he===0&&oe>.6}function i(G){const{upperPercent:oe,lowerPercent:he,alphaPercent:Te,numericPercent:Be}=G;return he>.2&&oe<.8&&Te>.6&&Be<.2}function p(G){let oe=0,he=0,Te=0,Be=0;for(let He=0;He<G.length;He++)Te=G.charCodeAt(He),t(Te)&&oe++,T(Te)&&he++,n(Te)&&Be++;return(oe===0||he===0)&&Be===0?G.length<=30:oe<=5}function a(G,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!p(G)||oe.length>60)return null;const he=h(oe);if(!i(he)){if(!C(he))return null;oe=oe.toLowerCase()}let Te=null,Be=0;for(G=G.toLowerCase();Be<oe.length&&(Te=o(G,oe,0,Be))===null;)Be=y(oe,Be+1);return Te}e.matchesCamelCase=a;function r(G,oe,he=!1){if(!oe||oe.length===0)return null;let Te=null,Be=0;for(G=G.toLowerCase(),oe=oe.toLowerCase();Be<oe.length&&(Te=c(G,oe,0,Be,he))===null;)Be=l(oe,Be+1);return Te}e.matchesWords=r;function c(G,oe,he,Te,Be){if(he===G.length)return[];if(Te===oe.length)return null;if(u(G.charCodeAt(he),oe.charCodeAt(Te))){let He=null,Qe=Te+1;if(He=c(G,oe,he+1,Te+1,Be),!Be)for(;!He&&(Qe=l(oe,Qe))<oe.length;)He=c(G,oe,he+1,Qe,Be),Qe++;return He===null?null:D({start:Te,end:Te+1},He)}else return null}function l(G,oe){for(let he=oe;he<G.length;he++)if(s(G.charCodeAt(he))||he>0&&s(G.charCodeAt(he-1)))return he;return G.length}const m=E(e.matchesPrefix,a,F),b=E(e.matchesPrefix,a,k),P=new d.LRUCache(1e4);function g(G,oe,he=!1){if(typeof G!="string"||typeof oe!="string")return null;let Te=P.get(G);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(G),"i"),P.set(G,Te));const Be=Te.exec(oe);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?b(G,oe):m(G,oe)}e.matchesFuzzy=g;function I(G,oe){const he=Ke(G,G.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=I;function R(G,oe,he,Te,Be,He){const Qe=Math.min(13,G.length);for(;he<Qe;he++){const it=Ke(G,oe,he,Te,Be,He,!1);if(it)return it}return[0,He]}e.anyScore=R;function L(G){if(typeof G=="undefined")return[];const oe=[],he=G[1];for(let Te=G.length-1;Te>1;Te--){const Be=G[Te]+he,He=oe[oe.length-1];He&&He.end===Be?He.end=Be+1:oe.push({start:Be,end:Be+1})}return oe}e.createMatches=L;const w=128;function x(){const G=[],oe=[];for(let he=0;he<=w;he++)oe[he]=0;for(let he=0;he<=w;he++)G.push(oe.slice(0));return G}function $(G){const oe=[];for(let he=0;he<=G;he++)oe[he]=0;return oe}const B=$(2*w),K=$(2*w),H=x(),W=x(),ne=x(),V=!1;function X(G,oe,he,Te,Be){function He(it,Ce,Ze=" "){for(;it.length<Ce;)it=Ze+it;return it}let Qe=` |   |${Te.split("").map(it=>He(it,3)).join("|")}
`;for(let it=0;it<=he;it++)it===0?Qe+=" |":Qe+=`${oe[it-1]}|`,Qe+=G[it].slice(0,Be+1).map(Ce=>He(Ce.toString(),3)).join("|")+`
`;return Qe}function q(G,oe,he,Te){G=G.substr(oe),he=he.substr(Te),console.log(X(W,G,G.length,he,he.length)),console.log(X(ne,G,G.length,he,he.length)),console.log(X(H,G,G.length,he,he.length))}function le(G,oe){if(oe<0||oe>=G.length)return!1;const he=G.codePointAt(oe);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function te(G,oe){if(oe<0||oe>=G.length)return!1;switch(G.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(G,oe,he){return oe[G]!==he[G]}function Re(G,oe,he,Te,Be,He,Qe=!1){for(;oe<he&&Be<He;)G[oe]===Te[Be]&&(Qe&&(B[oe]=Be),oe+=1),Be+=1;return oe===he}e.isPatternInWord=Re;var Fe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Oe;(function(G){G.Default=[-100,0];function oe(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}G.isDefault=oe})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ke(G,oe,he,Te,Be,He,Qe){const it=G.length>w?w:G.length,Ce=Te.length>w?w:Te.length;if(he>=it||He>=Ce||it-he>Ce-He||!Re(oe,he,it,Be,He,Ce,!0))return;je(it,Ce,he,He,oe,Be);let Ze=1,j=1,J=he,me=He;const We=[!1];for(Ze=1,J=he;J<it;Ze++,J++){const mt=B[J],Dt=K[J],Pt=J+1<it?K[J+1]:Ce;for(j=mt-He+1,me=mt;me<Pt;j++,me++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;me<=Dt&&(It=Ve(G,oe,J,he,Te,Be,me,Ce,He,H[Ze-1][j-1]===0,We));let St=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,St=It+W[Ze-1][j-1]);const Pe=me>mt,ye=Pe?W[Ze][j-1]+(H[Ze][j-1]>0?-5:0):0,De=me>mt+1&&H[Ze][j-1]>0,ee=De?W[Ze][j-2]+(H[Ze][j-2]>0?-5:0):0;if(De&&(!Pe||ee>=ye)&&(!Xe||ee>=St))W[Ze][j]=ee,ne[Ze][j]=3,H[Ze][j]=0;else if(Pe&&(!Xe||ye>=St))W[Ze][j]=ye,ne[Ze][j]=2,H[Ze][j]=0;else if(Xe)W[Ze][j]=St,ne[Ze][j]=1,H[Ze][j]=H[Ze-1][j-1]+1;else throw new Error("not possible")}}if(V&&q(G,he,Te,He),!We[0]&&!Qe)return;Ze--,j--;const Ye=[W[Ze][j],He];let st=0,ot=0;for(;Ze>=1;){let mt=j;do{const Dt=ne[Ze][mt];if(Dt===3)mt=mt-2;else if(Dt===2)mt=mt-1;else break}while(mt>=1);st>1&&oe[he+Ze-1]===Be[He+j-1]&&!ve(mt+He-1,Te,Be)&&st+1>H[Ze][mt]&&(mt=j),mt===j?st++:st=1,ot||(ot=mt),Ze--,j=mt-1,Ye.push(j)}Ce===it&&(Ye[0]+=2);const Et=ot-it;return Ye[0]-=Et,Ye}e.fuzzyScore=Ke;function je(G,oe,he,Te,Be,He){let Qe=G-1,it=oe-1;for(;Qe>=he&&it>=Te;)Be[Qe]===He[it]&&(K[Qe]=it,Qe--),it--}function Ve(G,oe,he,Te,Be,He,Qe,it,Ce,Ze,j){if(oe[he]!==He[Qe])return Number.MIN_SAFE_INTEGER;let J=1,me=!1;return Qe===he-Te?J=G[he]===Be[Qe]?7:5:ve(Qe,Be,He)&&(Qe===0||!ve(Qe-1,Be,He))?(J=G[he]===Be[Qe]?7:5,me=!0):le(He,Qe)&&(Qe===0||!le(He,Qe-1))?J=5:(le(He,Qe-1)||te(He,Qe-1))&&(J=5,me=!0),J>1&&he===Te&&(j[0]=!0),me||(me=ve(Qe,Be,He)||le(He,Qe-1)||te(He,Qe-1)),he===Te?Qe>Ce&&(J-=me?3:5):Ze?J+=me?2:0:J+=me?0:1,Qe+1===it&&(J-=me?3:5),J}function U(G,oe,he,Te,Be,He,Qe){return ie(G,oe,he,Te,Be,He,!0,Qe)}e.fuzzyScoreGracefulAggressive=U;function Q(G,oe,he,Te,Be,He,Qe){return ie(G,oe,he,Te,Be,He,!1,Qe)}e.fuzzyScoreGraceful=Q;function ie(G,oe,he,Te,Be,He,Qe,it){let Ce=Ke(G,oe,he,Te,Be,He,it);if(Ce&&!Qe)return Ce;if(G.length>=3){const Ze=Math.min(7,G.length-1);for(let j=he+1;j<Ze;j++){const J=ae(G,j);if(J){const me=Ke(J,J.toLowerCase(),he,Te,Be,He,it);me&&(me[0]-=3,(!Ce||me[0]>Ce[0])&&(Ce=me))}}}return Ce}function ae(G,oe){if(oe+1>=G.length)return;const he=G[oe],Te=G[oe+1];if(he!==Te)return G.slice(0,oe)+Te+he+G.slice(oe+2)}}),define(be[107],Ee([0,1,34,106,9]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function k(u){return u.replace(F,(v,D)=>D?v:`\\${v}`)}e.escapeIcons=k;const S=new RegExp(`\\\\${A.source}`,"g");function T(u){return u.replace(S,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(t,(v,D,y,o)=>y?v:D||o||"")}e.stripIcons=_;function n(u){const v=u.indexOf(e.iconStartMarker);return v===-1?{text:u}:f(u,v)}e.parseLabelWithIcons=n;function f(u,v){const D=[];let y="";function o(l){if(l){y+=l;for(const m of l)D.push(i)}}let h=-1,C="",i=0,p,a,r=v;const c=u.length;for(o(u.substr(0,v));r<c;)p=u[r],a=u[r+1],p===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(h=r,o(C),C=e.iconStartMarker,r++):p===")"&&h!==-1?(i+=r-h+1,h=-1,C=""):h!==-1?/^[a-z0-9\-]$/i.test(p)?C+=p:(o(C),h=-1,C=""):o(p),r++;return o(C),{text:y,iconOffsets:D}}function s(u,v,D=!1){const{text:y,iconOffsets:o}=v;if(!o||o.length===0)return(0,M.matchesFuzzy)(u,y,D);const h=(0,E.ltrim)(y," "),C=y.length-h.length,i=(0,M.matchesFuzzy)(u,h,D);if(i)for(const p of i){const a=o[p.start+C]+C;p.start+=a,p.end+=a}return i}e.matchesFuzzyIconAware=s}),define(be[77],Ee([0,1,16,107]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(f="",s=!1){if(this.value=f,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(f,s=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(f):f).replace(/([ \t]+)/g,(u,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,s){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return k(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function k(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=S;function T(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(n){const f=[],s=n.split("|").map(v=>v.trim());n=s[0];const u=s[1];if(u){const v=/height=(\d+)/.exec(u),D=/width=(\d+)/.exec(u),y=v?v[1]:"",o=D?D[1]:"",h=isFinite(parseInt(o)),C=isFinite(parseInt(y));h&&f.push(`width="${o}"`),C&&f.push(`height="${y}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=_}),define(be[55],Ee([0,1,22,9,2]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,S)}e.stringify=A;function F(t){let _=JSON.parse(t);return _=T(_),_}e.parse=F;var k;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function T(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],_+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],_+1))}return t}e.revive=T}),define(be[11],Ee([0,1,25,2]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,T,t){this._hosts[S]=T,this._ports[S]=t}setConnectionToken(S,T){this._connectionTokens[S]=T}rewrite(S){if(this._delegate)return this._delegate(S);const T=S.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[T],n=this._connectionTokens[T];let f=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new A;class F{asBrowserUri(S,T){const t=this.toUri(S,T);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(S,T){const t=this.toUri(S,T);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(S,T){return M.URI.isUri(S)?S:M.URI.parse(T.toUrl(S))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,k.uriToFsPath)(f,!0)}e.originalFSPath=S;class T{constructor(s){this._ignorePathCasing=s}compare(s,u,v=!1){return s===u?0:(0,F.compare)(this.getComparisonKey(s,v),this.getComparisonKey(u,v))}isEqual(s,u,v=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,v)===this.getComparisonKey(u,v)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,v=!1){if(s.scheme===u.scheme){if(s.scheme===M.Schemas.file)return d.isEqualOrParent(S(s),S(u),this._ignorePathCasing(s))&&s.query===u.query&&(v||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return d.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(v||s.fragment===u.fragment)}return!1}joinPath(s,...u){return k.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return E.posix.basename(s.path)}extname(s){return E.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===M.Schemas.file?u=k.URI.file(E.dirname(S(s))).path:(u=E.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===M.Schemas.file?u=k.URI.file(E.normalize(S(s))).path:u=E.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))return;if(s.scheme===M.Schemas.file){const y=E.relative(S(s),S(u));return A.isWindows?d.toSlashes(y):y}let v=s.path||"/",D=u.path||"/";if(this._ignorePathCasing(s)){let y=0;for(const o=Math.min(v.length,D.length);y<o&&!(v.charCodeAt(y)!==D.charCodeAt(y)&&v.charAt(y).toLowerCase()!==D.charAt(y).toLowerCase());y++);v=D.substr(0,y)+v.substr(y)}return E.posix.relative(v,D)}resolvePath(s,u){if(s.scheme===M.Schemas.file){const v=k.URI.file(E.resolve(S(s),u));return s.with({authority:v.authority,path:v.path})}return u=d.toPosixPath(u),s.with({path:E.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||(0,F.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=E.sep){if(s.scheme===M.Schemas.file){const v=S(s);return v.length>d.getRoot(v).length&&v[v.length-1]===u}else{const v=s.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=E.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=E.sep){let v=!1;if(s.scheme===M.Schemas.file){const D=S(s);v=D!==void 0&&D.length===d.getRoot(D).length&&D[D.length-1]===u}else{u="/";const D=s.path;v=D.length===1&&D.charCodeAt(D.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(f,s){const u=[];for(let v=0;v<f.length;v++){const D=s(f[v]);f.some((y,o)=>o===v?!1:(0,e.isEqualOrParent)(D,s(y)))||u.push(f[v])}return u}e.distinctParents=t;var _;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function s(u){const v=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(o=>{const[h,C]=o.split(":");h&&C&&v.set(h,C)});const y=u.path.substring(0,u.path.indexOf(";"));return y&&v.set(f.META_DATA_MIME,y),v}f.parseMetaData=s})(_=e.DataUri||(e.DataUri={}));function n(f,s,u){if(s){let v=f.path;return v&&v[0]!==E.posix.sep&&(v=E.posix.sep+v),f.with({scheme:u,authority:s,path:v})}return f.with({scheme:u})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(H){return!!H&&typeof H.then=="function"}e.isThenable=k;function S(H){const W=new d.CancellationTokenSource,ne=H(W.token),V=new Promise((X,q)=>{const le=W.token.onCancellationRequested(()=>{le.dispose(),W.dispose(),q((0,M.canceled)())});Promise.resolve(ne).then(te=>{le.dispose(),W.dispose(),X(te)},te=>{le.dispose(),W.dispose(),q(te)})});return new class{cancel(){W.cancel()}then(X,q){return V.then(X,q)}catch(X){return this.then(void 0,X)}finally(X){return V.finally(X)}}}e.createCancelablePromise=S;function T(H,W,ne){return Promise.race([H,new Promise(V=>W.onCancellationRequested(()=>V(ne)))])}e.raceCancellation=T;async function t(H){let W=-1;const ne=H.map((X,q)=>X.then(le=>(W=q,le))),V=await Promise.race(ne);return H.forEach((X,q)=>{q!==W&&X.cancel()}),V}e.raceCancellablePromises=t;function _(H,W,ne){let V;const X=setTimeout(()=>{V?.(void 0),ne?.()},W);return Promise.race([H.finally(()=>clearTimeout(X)),new Promise(q=>V=q)])}e.raceTimeout=_;function n(H){return new Promise((W,ne)=>{const V=H();k(V)?V.then(W,ne):W(V)})}e.asPromise=n;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ne=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(ne,ne).then(V)})}return new Promise((ne,V)=>{this.queuedPromise.then(ne,V)})}return this.activePromise=W(),new Promise((ne,V)=>{this.activePromise.then(X=>{this.activePromise=null,ne(X)},X=>{this.activePromise=null,V(X)})})}}e.Throttler=f;class s{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=s;class u{constructor(){this.promiseMap=new Map}queue(W,ne){const X=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(W)===X&&this.promiseMap.delete(W)});return this.promiseMap.set(W,X),X}}e.SequencerByKey=u;class v{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ne=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,X)=>{this.doResolve=V,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ne),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class D{constructor(W){this.delayer=new v(W),this.throttler=new f}trigger(W,ne){return this.delayer.trigger(()=>this.throttler.queue(W),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class y{constructor(){this._isOpen=!1,this._promise=new Promise((W,ne)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class o extends y{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function h(H,W){return W?new Promise((ne,V)=>{const X=setTimeout(()=>{q.dispose(),ne()},H),q=W.onCancellationRequested(()=>{clearTimeout(X),q.dispose(),V((0,M.canceled)())})}):S(ne=>h(H,ne))}e.timeout=h;function C(H,W=0){const ne=setTimeout(H,W);return(0,A.toDisposable)(()=>clearTimeout(ne))}e.disposableTimeout=C;function i(H){const W=[];let ne=0;const V=H.length;function X(){return ne<V?H[ne++]():null}function q(le){le!=null&&W.push(le);const te=X();return te?te.then(q):Promise.resolve(W)}return Promise.resolve(null).then(q)}e.sequence=i;function p(H,W=V=>!!V,ne=null){let V=0;const X=H.length,q=()=>{if(V>=X)return Promise.resolve(ne);const le=H[V++];return Promise.resolve(le()).then(ve=>W(ve)?Promise.resolve(ve):q())};return q()}e.first=p;function a(H,W=V=>!!V,ne=null){if(H.length===0)return Promise.resolve(ne);let V=H.length;const X=()=>{V=-1;for(const q of H)q.cancel?.()};return new Promise((q,le)=>{for(const te of H)te.then(ve=>{--V>=0&&W(ve)?(X(),q(ve)):V===0&&q(ne)}).catch(ve=>{--V>=0&&(X(),le(ve))})})}e.firstParallel=a;class r{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((ne,V)=>{this.outstandingPromises.push({factory:W,c:ne,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ne=W.factory();ne.then(W.c,W.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class c extends r{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor(W,ne=F.extUri){const V=ne.getComparisonKey(W);let X=this.queues.get(V);return X||(X=new c,E.Event.once(X.onFinished)(()=>{X?.dispose(),this.queues.delete(V)}),this.queues.set(V,X)),X}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=l;class m{constructor(W,ne){this._token=-1,typeof W=="function"&&typeof ne=="number"&&this.setIfNotSet(W,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ne)}setIfNotSet(W,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ne))}}e.TimeoutTimer=m;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setInterval(()=>{W()},ne)}}e.IntervalTimer=b;class P{constructor(W,ne){this.timeoutToken=-1,this.runner=W,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class g{constructor(W,ne){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class I extends P{constructor(W,ne){super(W,ne);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=I;class R extends A.Disposable{constructor(W,ne,V,X){super();this.maxWorkChunkSize=W,this.maxPendingWork=ne,this.throttleDelay=V,this.handler=X,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const W=setTimeout(()=>{const V=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0,clearTimeout(W))}}}:e.runWhenIdle=(H,W)=>{const ne=requestIdleCallback(H,typeof W=="number"?{timeout:W}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(ne))}}}}();class L{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function w(H,W,ne){let V;for(let X=0;X<ne;X++)try{return await H()}catch(q){V=q,await h(W)}throw V}e.retry=w;class x{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,ne,V){return this._pending={taskId:W,cancel:()=>V?.(),promise:ne},ne.then(()=>this.donePending(W),()=>this.donePending(W)),ne}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let ne,V;const X=new Promise((q,le)=>{ne=q,V=le});this._next={run:W,promise:X,promiseResolve:ne,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=x;class ${constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,ne)=>{this.completeCallback=W,this.errorCallback=ne})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(ne=>{this.completeCallback(W),this.resolved=!0,ne()})}error(W){return new Promise(ne=>{this.errorCallback(W),this.rejected=!0,ne()})}cancel(){new Promise(W=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=B;var K;(function(H){async function W(V){let X;const q=await Promise.all(V.map(le=>le.then(te=>te,te=>{X||(X=te)})));if(typeof X!="undefined")throw X;return q}H.settled=W;function ne(V){return new Promise(async(X,q)=>{try{await V(X,q)}catch(le){q(le)}})}H.withAsyncBody=ne})(K=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new d.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(P,g,I=!1){const R=P||"",L=g||"",w=E.value.collator.compare(R,L);return E.value.collatorIsNumeric&&w===0&&R!==L?R<L?-1:1:w}e.compareFileNames=k;function S(P,g){const I=A.value.collator;return P=P||"",g=g||"",C(I,P,g)}e.compareFileNamesDefault=S;function T(P,g){const I=A.value.collator;return P=P||"",g=g||"",r(P,g)||C(I,P,g)}e.compareFileNamesUpper=T;function t(P,g){const I=A.value.collator;return P=P||"",g=g||"",a(P,g)||C(I,P,g)}e.compareFileNamesLower=t;function _(P,g){return P=P||"",g=g||"",P===g?0:P<g?-1:1}e.compareFileNamesUnicode=_;function n(P,g,I=!1){I||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase());const[R,L]=o(P),[w,x]=o(g);return R!==w?R<w?-1:1:L===x?0:L<x?-1:1}e.noIntlCompareFileNames=n;function f(P,g){const[I,R]=o(P),[L,w]=o(g);let x=E.value.collator.compare(R,w);if(x===0){if(E.value.collatorIsNumeric&&R!==w)return R<w?-1:1;if(x=E.value.collator.compare(I,L),E.value.collatorIsNumeric&&x===0&&I!==L)return I<L?-1:1}return x}e.compareFileExtensions=f;function s(P,g){P=P||"",g=g||"";const I=h(P),R=h(g),L=A.value.collator,w=F.value.collator;return C(w,I,R)||C(L,P,g)}e.compareFileExtensionsDefault=s;function u(P,g){P=P||"",g=g||"";const I=h(P),R=h(g),L=A.value.collator,w=F.value.collator;return C(w,I,R)||r(P,g)||C(L,P,g)}e.compareFileExtensionsUpper=u;function v(P,g){P=P||"",g=g||"";const I=h(P),R=h(g),L=A.value.collator,w=F.value.collator;return C(w,I,R)||a(P,g)||C(L,P,g)}e.compareFileExtensionsLower=v;function D(P,g){P=P||"",g=g||"";const I=h(P).toLowerCase(),R=h(g).toLowerCase();return I!==R?I<R?-1:1:P!==g?P<g?-1:1:0}e.compareFileExtensionsUnicode=D;const y=/^(.*?)(\.([^.]*))?$/;function o(P,g=!1){const I=P?y.exec(P):[];let R=[I&&I[1]||"",I&&I[3]||""];return g&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function h(P){const g=P?y.exec(P):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function C(P,g,I){let R=P.compare(g,I);return R!==0?R:g.length!==I.length?g.length<I.length?-1:1:0}function i(P){const g=P.charAt(0);return g.toLocaleUpperCase()!==g}function p(P){const g=P.charAt(0);return g.toLocaleLowerCase()!==g}function a(P,g){return i(P)&&p(g)?-1:p(P)&&i(g)?1:0}function r(P,g){return p(P)&&i(g)?-1:i(P)&&p(g)?1:0}function c(P,g,I=!1){return I||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase()),P===g?0:P<g?-1:1}function l(P,g,I=!1){const R=P.split(M.sep),L=g.split(M.sep),w=R.length-1,x=L.length-1;let $,B;for(let K=0;;K++){if($=w===K,B=x===K,$&&B)return k(R[K],L[K],I);if($)return-1;if(B)return 1;const H=c(R[K],L[K],I);if(H!==0)return H}}e.comparePaths=l;function m(P,g,I){const R=P.toLowerCase(),L=g.toLowerCase(),w=b(P,g,I);if(w)return w;const x=R.endsWith(I),$=L.endsWith(I);if(x!==$)return x?-1:1;const B=k(R,L);return B!==0?B:R.localeCompare(L)}e.compareAnything=m;function b(P,g,I){const R=P.toLowerCase(),L=g.toLowerCase(),w=R.startsWith(I),x=L.startsWith(I);if(w!==x)return w?-1:1;if(w&&x){if(R.length<L.length)return-1;if(R.length>L.length)return 1}return 0}e.compareByPrefix=b}),define(be[27],Ee([0,1,14,43,20,17,9]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",T="/",t="[/\\\\]",_="[^/\\\\]",n=/\//g;function f(V){switch(V){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function s(V,X){if(!V)return[];const q=[];let le=!1,te=!1,ve="";for(const Re of V){switch(Re){case X:if(!le&&!te){q.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":te=!0;break;case"]":te=!1;break}ve+=Re}return ve&&q.push(ve),q}e.splitGlobAware=s;function u(V){if(!V)return"";let X="";const q=s(V,T);if(q.every(le=>le===S))X=".*";else{let le=!1;q.forEach((te,ve)=>{if(te===S){le||(X+=f(2),le=!0);return}let Re=!1,Fe="",Oe=!1,Ke="";for(const je of te){if(je!=="}"&&Re){Fe+=je;continue}if(Oe&&(je!=="]"||!Ke)){let Ve;je==="-"?Ve=je:(je==="^"||je==="!")&&!Ke?Ve="^":je===T?Ve="":Ve=F.escapeRegExpCharacters(je),Ke+=Ve;continue}switch(je){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":X+=`(?:${s(Fe,",").map(Q=>u(Q)).join("|")})`,Re=!1,Fe="";break;case"]":X+="["+Ke+"]",Oe=!1,Ke="";break;case"?":X+=_;continue;case"*":X+=f(1);continue;default:X+=F.escapeRegExpCharacters(je)}}ve<q.length-1&&(q[ve+1]!==S||ve+2<q.length)&&(X+=t),le=!1})}return X}const v=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),p=function(){return!1},a=function(){return null};function r(V,X){if(!V)return a;let q;typeof V!="string"?q=V.pattern:q=V,q=q.trim();const le=`${q}_${!!X.trimForExclusions}`;let te=i.get(le);if(te)return c(te,V);let ve;if(v.test(q)){const Re=q.substr(4);te=function(Fe,Oe){return typeof Fe=="string"&&Fe.endsWith(Re)?q:null}}else(ve=D.exec(l(q,X)))?te=m(ve[1],q):(X.trimForExclusions?o:y).test(q)?te=b(q,X):(ve=h.exec(l(q,X)))?te=P(ve[1].substr(1),q,!0):(ve=C.exec(l(q,X)))?te=P(ve[1],q,!1):te=g(q);return i.set(le,te),c(te,V)}function c(V,X){return typeof X=="string"?V:function(q,le){return M.isEqualOrParent(q,X.base)?V(A.relative(X.base,q),le):null}}function l(V,X){return X.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function m(V,X){const q=`/${V}`,le=`\\${V}`,te=function(Re,Fe){return typeof Re!="string"?null:Fe?Fe===V?X:null:Re===V||Re.endsWith(q)||Re.endsWith(le)?X:null},ve=[V];return te.basenames=ve,te.patterns=[X],te.allBasenames=ve,te}function b(V,X){const q=ne(V.slice(1,-1).split(",").map(Fe=>r(Fe,X)).filter(Fe=>Fe!==a),V),le=q.length;if(!le)return a;if(le===1)return q[0];const te=function(Fe,Oe){for(let Ke=0,je=q.length;Ke<je;Ke++)if(q[Ke](Fe,Oe))return V;return null},ve=q.find(Fe=>!!Fe.allBasenames);ve&&(te.allBasenames=ve.allBasenames);const Re=q.reduce((Fe,Oe)=>Oe.allPaths?Fe.concat(Oe.allPaths):Fe,[]);return Re.length&&(te.allPaths=Re),te}function P(V,X,q){const le=A.sep===A.posix.sep,te=le?V:V.replace(n,A.sep),ve=A.sep+te,Re=A.posix.sep+V,Fe=q?function(Oe,Ke){return typeof Oe=="string"&&(Oe===te||Oe.endsWith(ve)||!le&&(Oe===V||Oe.endsWith(Re)))?X:null}:function(Oe,Ke){return typeof Oe=="string"&&(Oe===te||!le&&Oe===V)?X:null};return Fe.allPaths=[(q?"*/":"./")+V],Fe}function g(V){try{const X=new RegExp(`^${u(V)}$`);return function(q){return X.lastIndex=0,typeof q=="string"&&X.test(q)?V:null}}catch(X){return a}}function I(V,X,q){return!V||typeof X!="string"?!1:R(V)(X,void 0,q)}e.match=I;function R(V,X={}){if(!V)return p;if(typeof V=="string"||$(V)){const q=r(V,X);if(q===a)return p;const le=function(te,ve){return!!q(te,ve)};return q.allBasenames&&(le.allBasenames=q.allBasenames),q.allPaths&&(le.allPaths=q.allPaths),le}return H(V,X)}e.parse=R;function L(V){if(!V)return;let X;return q=>(X||(X=(V()||Promise.resolve([])).then(le=>le?x(le):{})),X.then(le=>!!le[q]))}e.hasSiblingPromiseFn=L;function w(V){if(!V)return;let X;return q=>{if(!X){const le=V();X=le?x(le):{}}return!!X[q]}}e.hasSiblingFn=w;function x(V){const X={};for(const q of V)X[q]=!0;return X}function $(V){const X=V;return X&&typeof X.base=="string"&&typeof X.pattern=="string"}e.isRelativePattern=$;function B(V){return V.allBasenames||[]}e.getBasenameTerms=B;function K(V){return V.allPaths||[]}e.getPathTerms=K;function H(V,X){const q=ne(Object.getOwnPropertyNames(V).map(Fe=>W(Fe,V[Fe],X)).filter(Fe=>Fe!==a)),le=q.length;if(!le)return a;if(!q.some(Fe=>!!Fe.requiresSiblings)){if(le===1)return q[0];const Fe=function(je,Ve){for(let U=0,Q=q.length;U<Q;U++){const ie=q[U](je,Ve);if(ie)return ie}return null},Oe=q.find(je=>!!je.allBasenames);Oe&&(Fe.allBasenames=Oe.allBasenames);const Ke=q.reduce((je,Ve)=>Ve.allPaths?je.concat(Ve.allPaths):je,[]);return Ke.length&&(Fe.allPaths=Ke),Fe}const te=function(Fe,Oe,Ke){let je;for(let Ve=0,U=q.length;Ve<U;Ve++){const Q=q[Ve];Q.requiresSiblings&&Ke&&(Oe||(Oe=A.basename(Fe)),je||(je=Oe.substr(0,Oe.length-A.extname(Fe).length)));const ie=Q(Fe,Oe,je,Ke);if(ie)return ie}return null},ve=q.find(Fe=>!!Fe.allBasenames);ve&&(te.allBasenames=ve.allBasenames);const Re=q.reduce((Fe,Oe)=>Oe.allPaths?Fe.concat(Oe.allPaths):Fe,[]);return Re.length&&(te.allPaths=Re),te}function W(V,X,q){if(X===!1)return a;const le=r(V,q);if(le===a)return a;if(typeof X=="boolean")return le;if(X){const te=X.when;if(typeof te=="string"){const ve=(Re,Fe,Oe,Ke)=>{if(!Ke||!le(Re,Fe))return null;const je=te.replace("$(basename)",Oe),Ve=Ke(je);return(0,d.isThenable)(Ve)?Ve.then(U=>U?V:null):Ve?V:null};return ve.requiresSiblings=!0,ve}}return le}function ne(V,X){const q=V.filter(Fe=>!!Fe.basenames);if(q.length<2)return V;const le=q.reduce((Fe,Oe)=>{const Ke=Oe.basenames;return Ke?Fe.concat(Ke):Fe},[]);let te;if(X){te=[];for(let Fe=0,Oe=le.length;Fe<Oe;Fe++)te.push(X)}else te=q.reduce((Fe,Oe)=>{const Ke=Oe.patterns;return Ke?Fe.concat(Ke):Fe},[]);const ve=function(Fe,Oe){if(typeof Fe!="string")return null;if(!Oe){let je;for(je=Fe.length;je>0;je--){const Ve=Fe.charCodeAt(je-1);if(Ve===47||Ve===92)break}Oe=Fe.substr(je)}const Ke=le.indexOf(Oe);return Ke!==-1?te[Ke]:null};ve.basenames=le,ve.patterns=te,ve.allBasenames=le;const Re=V.filter(Fe=>!Fe.basenames);return Re.push(ve),Re}}),define(be[78],Ee([0,1,43,11,17,25,24,9,2]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(r,c,l){if(typeof r=="string"&&(r=S.URI.file(r)),l){const b=l.getWorkspaceFolder(r);if(b){const P=l.getWorkspace().folders.length>1;let g;if((0,F.isEqual)(b.uri,r)?g="":g=(0,F.relativePath)(b.uri,r),P){const I=b.name?b.name:(0,F.basename)(b.uri);g=g?I+" \u2022 "+g:I}return g}}if(r.scheme!==M.Schemas.file&&r.scheme!==M.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(r.fsPath))return(0,E.normalize)(_(r.fsPath));let m=(0,E.normalize)(r.fsPath);return!A.isWindows&&c?.userHome&&(m=f(m,c.userHome.fsPath)),m}e.getPathLabel=T;function t(r){if(!r)return;typeof r=="string"&&(r=S.URI.file(r));const c=(0,F.basename)(r)||(r.scheme===M.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(c)?_(c):c}e.getBaseLabel=t;function _(r){return(0,d.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=_;let n=Object.create(null);function f(r,c){if(A.isWindows||!r||!c)return r;let l=n.original===c?n.normalized:void 0;return l||(l=`${(0,k.rtrim)(c,E.posix.sep)}${E.posix.sep}`,n={original:c,normalized:l}),(A.isLinux?r.startsWith(l):(0,k.startsWithIgnoreCase)(r,l))&&(r=`~/${r.substr(l.length)}`),r}e.tildify=f;function s(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=s;const u="\u2026",v="\\\\",D="~";function y(r,c=E.sep){const l=new Array(r.length);let m=!1;for(let b=0;b<r.length;b++){let P=r[b];if(P===""){l[b]=`.${c}`;continue}if(!P){l[b]=P;continue}m=!0;let g="";P.indexOf(v)===0?(g=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length)):P.indexOf(c)===0?(g=P.substr(0,P.indexOf(c)+c.length),P=P.substr(P.indexOf(c)+c.length)):P.indexOf(D)===0&&(g=P.substr(0,P.indexOf(D)+D.length),P=P.substr(P.indexOf(D)+D.length));const I=P.split(c);for(let R=1;m&&R<=I.length;R++)for(let L=I.length-R;m&&L>=0;L--){m=!1;let w=I.slice(L,L+R).join(c);for(let x=0;!m&&x<r.length;x++)if(x!==b&&r[x]&&r[x].indexOf(w)>-1){const $=L+R===I.length,B=L>0&&r[x].indexOf(c)>-1?c+w:w,K=r[x].endsWith(B);m=!$||K}if(!m){let x="";(I[0].endsWith(":")||g!=="")&&(L===1&&(L=0,R++,w=I[0]+c+w),L>0&&(x=I[0]+c),x=g+x),L>0&&(x=x+u+c),x=x+w,L+R<I.length&&(x=x+c+u),l[b]=x}}m&&(l[b]=P)}return l}e.shorten=y;var o;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function h(r,c=Object.create(null)){const l=[];let m=!1,b="";for(const P of r)if(P==="$"||m&&P==="{")b&&l.push({value:b,type:o.TEXT}),b="",m=!0;else if(P==="}"&&m){const g=c[b];if(typeof g=="string")g.length&&l.push({value:g,type:o.VARIABLE});else if(g){const I=l[l.length-1];(!I||I.type!==o.SEPARATOR)&&l.push({value:g.label,type:o.SEPARATOR})}b="",m=!1}else b+=P;return b&&!m&&l.push({value:b,type:o.TEXT}),l.filter((P,g)=>{if(P.type===o.SEPARATOR){const I=l[g-1],R=l[g+1];return[I,R].every(L=>L&&(L.type===o.VARIABLE||L.type===o.TEXT)&&L.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=h;function C(r,c){return A.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function i(r,c){return A.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function p(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=p;function a(r){const c=r.indexOf("/")!==-1?E.posix:E.win32,l=c.basename(r),m=c.dirname(r);return l.length?{name:l,parentPath:m}:{name:m,parentPath:""}}e.splitName=a}),define(be[79],Ee([0,1,27,11,17,24,9]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],T=[],t=[];function _(r,c=!1){const l=n(r);S.push(l),l.userConfigured?t.push(l):T.push(l),c&&!l.userConfigured&&S.forEach(m=>{m.mime===l.mime||m.userConfigured||(l.extension&&m.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&m.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&m.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&m.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=_;function n(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,d.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(E.posix.sep)>=0:!1}}function f(r){r?(S=S.filter(c=>!c.userConfigured),t=[]):(S=[],T=[],t=[])}e.clearTextMimes=f;function s(r,c){let l;if(r)switch(r.scheme){case M.Schemas.file:l=r.fsPath;break;case M.Schemas.data:l=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[k.unknown];l=l.toLowerCase();const m=(0,E.basename)(l),b=u(l,m,t);if(b)return[b,k.text];const P=u(l,m,T);if(P)return[P,k.text];if(c){const g=v(c);if(g)return[g,k.text]}return[k.unknown]}e.guessMimeTypes=s;function u(r,c,l){let m=null,b=null,P=null;for(let g=l.length-1;g>=0;g--){const I=l[g];if(c===I.filenameLowercase){m=I;break}if(I.filepattern&&(!b||I.filepattern.length>b.filepattern.length)){const R=I.filepatternOnPath?r:c;I.filepatternLowercase?.(R)&&(b=I)}I.extension&&(!P||I.extension.length>P.extension.length)&&c.endsWith(I.extensionLowercase)&&(P=I)}return m?m.mime:b?b.mime:P?P.mime:null}function v(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let c=S.length-1;c>=0;c--){const l=S[c];if(!l.firstline)continue;const m=r.match(l.firstline);if(m&&m.length>0)return l.mime}return null}function D(r){return r?typeof r=="string"?r===k.binary||r===k.text||r===k.unknown:r.length===1&&D(r[0]):!0}e.isUnspecific=D;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(r){const c=(0,E.extname)(r),l=y[c.toLowerCase()];return l!==void 0?l:C(r)}e.getMediaOrTextMime=h;function C(r){const c=(0,E.extname)(r);return o[c.toLowerCase()]}e.getMediaMime=C;function i(r){for(const c in o)if(o[c]===r)return c}e.getExtensionForMimeType=i;const p=/^(.+)\/(.+?)(;.+)?$/;function a(r,c){const l=p.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:c?void 0:r}e.normalizeMimeType=a}),define(be[109],Ee([0,1,2]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(d.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(d.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:d.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,_,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return _.transformOutgoing(t);for(let f in t)if(Object.hasOwnProperty.call(t,f)){const s=A(t[f],_,n+1);s!==null&&(t[f]=s)}}return null}function F(t,_){const n=A(t,_,0);return n===null?t:n}e.transformOutgoingURIs=F;function k(t,_,n,f){if(!t||f>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const u=k(t[s],_,n,f+1);u!==null&&(t[s]=u)}}return null}function S(t,_){const n=k(t,_,!1,0);return n===null?t:n}e.transformIncomingURIs=S;function T(t,_){const n=k(t,_,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(be[36],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(S){return d.test(S)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(S){for(let T=0;T<S.length;T++)S[T]=Math.floor(Math.random()*256);return S};function k(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let S=0,T="";return T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T}e.generateUuid=k}),define(be[110],Ee([0,1,227]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends d.CharacterClassifier{constructor(k){super(0);for(let S=0,T=k.length;S<T;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(F){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=F(S)),k[S])}e.getMapForWordSeparators=A(F=>new E(F))}),define(be[80],Ee([0,1,23]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPair=e.IndentGuide=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(D){D[D.Left=1]="Left",D[D.Center=2]="Center",D[D.Right=4]="Right",D[D.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(D){D[D.Inline=1]="Inline",D[D.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(D){D[D.TextDefined=0]="TextDefined",D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(D){D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(D){D[D.LF=0]="LF",D[D.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),this.indentSize=y.tabSize|0,this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class T{constructor(y,o){this._findMatchBrand=void 0,this.range=y,this.matches=o}}e.FindMatch=T;var t;(function(D){D[D.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",D[D.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",D[D.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",D[D.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));class _{constructor(y,o){this.visibleColumn=y,this.className=o}}e.IndentGuide=_;class n{constructor(y,o,h,C){this.range=y,this.openingBracketRange=o,this.closingBracketRange=h,this.nestingLevel=C}}e.BracketPair=n;var f;(function(D){D[D.Left=0]="Left",D[D.Right=1]="Right",D[D.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var s;(function(D){D[D.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(s=e.ModelConstants||(e.ModelConstants={}));class u{constructor(y,o,h,C,i,p){this.identifier=y,this.range=o,this.text=h,this.forceMoveMarkers=C,this.isAutoWhitespaceEdit=i,this._isTracked=p}}e.ValidAnnotatedEditOperation=u;class v{constructor(y,o,h){this.reverseEdits=y,this.changes=o,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=v}),define(be[111],Ee([0,1,9,110,112,44,80]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(o,h,C,i){this.searchString=o,this.isRegex=h,this.matchCase=C,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let h=null;try{h=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!h)return null;let C=!this.isRegex&&!o;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new t(h,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=S;function T(y){if(!y||y.length===0)return!1;for(let o=0,h=y.length;o<h;o++)if(y.charCodeAt(o)===92){if(o++,o>=h)break;const i=y.charCodeAt(o);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(o,h,C){this.regex=o,this.wordSeparators=h,this.simpleSearch=C}}e.SearchData=t;function _(y,o,h){if(!h)return new F.FindMatch(y,null);let C=[];for(let i=0,p=o.length;i<p;i++)C[i]=o[i];return new F.FindMatch(y,C)}e.createFindMatch=_;class n{constructor(o){let h=[],C=0;for(let i=0,p=o.length;i<p;i++)o.charCodeAt(i)===10&&(h[C++]=i);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(o){const h=this._lineFeedsOffsets;let C=0,i=h.length-1;if(i===-1||o<=h[0])return 0;for(;C<i;){const p=C+((i-C)/2>>0);h[p]>=o?i=p-1:h[p+1]>=o?(C=p,i=p):C=p+1}return C+1}}class f{static findMatches(o,h,C,i,p){const a=h.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,C,new D(a.wordSeparators,a.regex),i,p):this._doFindMatchesLineByLine(o,C,a,i,p):[]}static _getMultilineMatchRange(o,h,C,i,p,a){let r,c=0;i?(c=i.findLineFeedCountBeforeOffset(p),r=h+p+c):r=h+p;let l;if(i){let g=i.findLineFeedCountBeforeOffset(p+a.length)-c;l=r+a.length+g}else l=r+a.length;const m=o.getPositionAt(r),b=o.getPositionAt(l);return new A.Range(m.lineNumber,m.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,h,C,i,p){const a=o.getOffsetAt(h.getStartPosition()),r=o.getValueInRange(h,1),c=o.getEOL()===`\r
`?new n(r):null,l=[];let m=0,b;for(C.reset(0);b=C.next(r);)if(l[m++]=_(this._getMultilineMatchRange(o,a,r,c,b.index,b[0]),b,i),m>=p)return l;return l}static _doFindMatchesLineByLine(o,h,C,i,p){const a=[];let r=0;if(h.startLineNumber===h.endLineNumber){const l=o.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(C,l,h.startLineNumber,h.startColumn-1,r,a,i,p),a}const c=o.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(C,c,h.startLineNumber,h.startColumn-1,r,a,i,p);for(let l=h.startLineNumber+1;l<h.endLineNumber&&r<p;l++)r=this._findMatchesInLine(C,o.getLineContent(l),l,0,r,a,i,p);if(r<p){const l=o.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(C,l,h.endLineNumber,0,r,a,i,p)}return a}static _findMatchesInLine(o,h,C,i,p,a,r,c){const l=o.wordSeparators;if(!r&&o.simpleSearch){const P=o.simpleSearch,g=P.length,I=h.length;let R=-g;for(;(R=h.indexOf(P,R+g))!==-1;)if((!l||v(l,h,I,R,g))&&(a[p++]=new F.FindMatch(new A.Range(C,R+1+i,C,R+1+g+i),null),p>=c))return p;return p}const m=new D(o.wordSeparators,o.regex);let b;m.reset(0);do if(b=m.next(h),b&&(a[p++]=_(new A.Range(C,b.index+1+i,C,b.index+1+b[0].length+i),b,r),p>=c))return p;while(b);return p}static findNextMatch(o,h,C,i){const p=h.parseSearchRequest();if(!p)return null;const a=new D(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindNextMatchMultiline(o,C,a,i):this._doFindNextMatchLineByLine(o,C,a,i)}static _doFindNextMatchMultiline(o,h,C,i){const p=new E.Position(h.lineNumber,1),a=o.getOffsetAt(p),r=o.getLineCount(),c=o.getValueInRange(new A.Range(p.lineNumber,p.column,r,o.getLineMaxColumn(r)),1),l=o.getEOL()===`\r
`?new n(c):null;C.reset(h.column-1);let m=C.next(c);return m?_(this._getMultilineMatchRange(o,a,c,l,m.index,m[0]),m,i):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(o,new E.Position(1,1),C,i):null}static _doFindNextMatchLineByLine(o,h,C,i){const p=o.getLineCount(),a=h.lineNumber,r=o.getLineContent(a),c=this._findFirstMatchInLine(C,r,a,h.column,i);if(c)return c;for(let l=1;l<=p;l++){const m=(a+l-1)%p,b=o.getLineContent(m+1),P=this._findFirstMatchInLine(C,b,m+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(o,h,C,i,p){o.reset(i-1);const a=o.next(h);return a?_(new A.Range(C,a.index+1,C,a.index+1+a[0].length),a,p):null}static findPreviousMatch(o,h,C,i){const p=h.parseSearchRequest();if(!p)return null;const a=new D(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindPreviousMatchMultiline(o,C,a,i):this._doFindPreviousMatchLineByLine(o,C,a,i)}static _doFindPreviousMatchMultiline(o,h,C,i){const p=this._doFindMatchesMultiline(o,new A.Range(1,1,h.lineNumber,h.column),C,i,10*k);if(p.length>0)return p[p.length-1];const a=o.getLineCount();return h.lineNumber!==a||h.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new E.Position(a,o.getLineMaxColumn(a)),C,i):null}static _doFindPreviousMatchLineByLine(o,h,C,i){const p=o.getLineCount(),a=h.lineNumber,r=o.getLineContent(a).substring(0,h.column-1),c=this._findLastMatchInLine(C,r,a,i);if(c)return c;for(let l=1;l<=p;l++){const m=(p+a-l-1)%p,b=o.getLineContent(m+1),P=this._findLastMatchInLine(C,b,m+1,i);if(P)return P}return null}static _findLastMatchInLine(o,h,C,i){let p=null,a;for(o.reset(0);a=o.next(h);)p=_(new A.Range(C,a.index+1,C,a.index+1+a[0].length),a,i);return p}}e.TextModelSearch=f;function s(y,o,h,C,i){if(C===0)return!0;const p=o.charCodeAt(C-1);if(y.get(p)!==0||p===13||p===10)return!0;if(i>0){const a=o.charCodeAt(C);if(y.get(a)!==0)return!0}return!1}function u(y,o,h,C,i){if(C+i===h)return!0;const p=o.charCodeAt(C+i);if(y.get(p)!==0||p===13||p===10)return!0;if(i>0){const a=o.charCodeAt(C+i-1);if(y.get(a)!==0)return!0}return!1}function v(y,o,h,C,i){return s(y,o,h,C,i)&&u(y,o,h,C,i)}e.isValidMatch=v;class D{constructor(o,h){this._wordSeparators=o,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const h=o.length;let C;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(C=this._searchRegex.exec(o),!C))return null;const i=C.index,p=C[0].length;if(i===this._prevMatchStartIndex&&p===this._prevMatchLength){if(p===0){d.getNextCodePoint(o,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=p,!this._wordSeparators||v(this._wordSeparators,o,h,i,p))return C}while(C);return null}}e.Searcher=D}),define(be[113],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,T=k.notIn.length;S<T;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=E;function A(F,k,S){F.has(k)?F.get(k).push(S):F.set(k,[S])}}),define(be[56],Ee([0,1,27,17]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,F,k,S){if(Array.isArray(A)){let T=0;for(const t of A){const _=E(t,F,k,S);if(_===10)return _;_>T&&(T=_)}return T}else{if(typeof A=="string")return S?A==="*"?5:A===k?10:0:0;if(A){const{language:T,pattern:t,scheme:_,hasAccessToAllModels:n}=A;if(!S&&!n)return 0;let f=0;if(_)if(_===F.scheme)f=10;else if(_==="*")f=5;else return 0;if(T)if(T===k)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===F.fsPath||(0,d.match)(s,F.fsPath))f=10;else return 0}return f}else return 0}}e.score=E}),define(be[114],Ee([0,1,3,6]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,k){return this._map.set(F,k),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===k&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,k){let S=null,T=!1;return this._promises.set(F,k.then(t=>{this._promises.delete(F),!(T||!t)&&(S=this.register(F,t))})),(0,M.toDisposable)(()=>{T=!0,S&&S.dispose()})}getPromise(F){const k=this.get(F);if(k)return Promise.resolve(k);const S=this._promises.get(F);return S?S.then(T=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[81],Ee([0,1,22,25]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function A(_){for(let n=0,f=_.length;n<f;n+=4){const s=_[n+0],u=_[n+1],v=_[n+2],D=_[n+3];_[n+0]=D,_[n+1]=v,_[n+2]=u,_[n+3]=s}}function F(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function k(_){const n=_.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(_){const n=new Uint32Array(T(_));let f=0;if(n[f++]=_.id,_.type==="full")n[f++]=1,n[f++]=_.data.length,n.set(_.data,f),f+=_.data.length;else{n[f++]=2,n[f++]=_.deltas.length;for(const s of _.deltas)n[f++]=s.start,n[f++]=s.deleteCount,s.data?(n[f++]=s.data.length,n.set(s.data,f),f+=s.data.length):n[f++]=0}return F(n)}e.encodeSemanticTokensDto=S;function T(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const f of _.deltas)f.data&&(n+=f.data.length)}return n}function t(_){const n=k(_);let f=0;const s=n[f++];if(n[f++]===1){const y=n[f++],o=n.subarray(f,f+y);return f+=y,{id:s,type:"full",data:o}}const v=n[f++];let D=[];for(let y=0;y<v;y++){const o=n[f++],h=n[f++],C=n[f++];let i;C>0&&(i=n.subarray(f,f+C),f+=C),D[y]={start:o,deleteCount:h,data:i}}return{id:s,type:"delta",deltas:D}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(be[45],Ee([0,1,13,10,115]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?E.localize(0,null,k(T),F(T.stack)||F(T.stacktrace)):k(T)}function F(T){return Array.isArray(T)?T.join(`
`):T}function k(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?E.localize(1,null,T.message):T.message||E.localize(2,null)}function S(T=null,t=!1){if(!T)return E.localize(3,null);if(Array.isArray(T)){const _=d.coalesce(T),n=S(_[0],t);return _.length>1?E.localize(4,null,n,_.length):n}if(M.isString(T))return T;if(T.detail){const _=T.detail;if(_.error)return A(_.error,t);if(_.exception)return A(_.exception,t)}return T.stack?A(T,t):T.message?T.message:E.localize(5,null)}e.toErrorMessage=S}),define(be[116],Ee([18,19]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,25,118]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class k{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=k;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class T{constructor(J,me,We,Ye){this.id=J,this.name=me,this.defaultValue=We,this.schema=Ye}compute(J,me,We){return We}}class t{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class _{constructor(J,me,We,Ye){this.id=J,this.name=me,this.defaultValue=We,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,We){return We}}function n(j,J){return typeof j=="undefined"?J:j==="false"?!1:Boolean(j)}e.boolean=n;class f extends _{constructor(J,me,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=We),super(J,me,We,Ye)}validate(J){return n(J,this.defaultValue)}}function s(j,J,me,We){if(typeof j=="undefined")return J;let Ye=parseInt(j,10);return isNaN(Ye)?J:(Ye=Math.max(me,Ye),Ye=Math.min(We,Ye),Ye|0)}e.clampedInt=s;class u extends _{constructor(J,me,We,Ye,st,ot=void 0){typeof ot!="undefined"&&(ot.type="integer",ot.default=We,ot.minimum=Ye,ot.maximum=st),super(J,me,We,ot),this.minimum=Ye,this.maximum=st}static clampedInt(J,me,We,Ye){return s(J,me,We,Ye)}validate(J){return u.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class v extends _{constructor(J,me,We,Ye,st){typeof st!="undefined"&&(st.type="number",st.default=We),super(J,me,We,st),this.validationFn=Ye}static clamp(J,me,We){return J<me?me:J>We?We:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const We=parseFloat(J);return isNaN(We)?me:We}validate(J){return this.validationFn(v.float(J,this.defaultValue))}}class D extends _{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=We),super(J,me,We,Ye)}validate(J){return D.string(J,this.defaultValue)}}function y(j,J,me){return typeof j!="string"||me.indexOf(j)===-1?J:j}e.stringSet=y;class o extends _{constructor(J,me,We,Ye,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=Ye,st.default=We),super(J,me,We,st),this._allowedValues=Ye}validate(J){return y(J,this.defaultValue,this._allowedValues)}}class h extends T{constructor(J,me,We,Ye,st,ot,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=st,Et.default=Ye),super(J,me,We,Et),this._allowedValues=st,this._convert=ot}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function C(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,We){return We===0?J.accessibilitySupport:We}}class p extends T{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:d.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(j){switch(j){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function m(j){switch(j){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class b extends t{constructor(){super(126,[65,33])}compute(J,me,We){const Ye=["monaco-editor"];return me.get(33)&&Ye.push(me.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),me.get(65)==="default"?Ye.push("mouse-default"):me.get(65)==="copy"&&Ye.push("mouse-copy"),me.get(99)&&Ye.push("showUnused"),me.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class P extends f{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(J,me,We){return We&&J.emptySelectionClipboard}}class g extends T{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:d.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":y(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":y(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class I extends T{constructor(){super(44,"fontLigatures",I.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?I.OFF:J==="true"?I.ON:J:Boolean(J)?I.ON:I.OFF}}e.EditorFontLigatures=I,I.OFF='"liga" off, "calt" off',I.ON='"liga" on, "calt" on';class R extends t{constructor(){super(43)}compute(J,me,We){return J.fontInfo}}class L extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(J){let me=v.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(me,6,100)}compute(J,me,We){return J.fontInfo.fontSize}}class w extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:w.MINIMUM_VALUE,maximum:w.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:w.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(u.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,w.MINIMUM_VALUE,w.MAXIMUM_VALUE))}}w.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],w.MINIMUM_VALUE=1,w.MAXIMUM_VALUE=1e3;class x extends T{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:We,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:We,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:We,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:We,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:We,description:d.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:y(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??y(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??y(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??y(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??y(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??y(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends T{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:d.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:u.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky)}}}var B;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class K extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,me,We){return K.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,We=J.scrollBeyondLastLine?me-1:0,Ye=(J.viewLineCount+We)/(J.pixelRatio*J.height),st=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:We,desiredRatio:Ye,minimapLineCount:st}}static _computeMinimapLayout(J,me){const We=J.outerWidth,Ye=J.outerHeight,st=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ot=me.stableMinimapLayoutInput,Et=ot&&J.outerHeight===ot.outerHeight&&J.lineHeight===ot.lineHeight&&J.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&J.pixelRatio===ot.pixelRatio&&J.scrollBeyondLastLine===ot.scrollBeyondLastLine&&J.minimap.enabled===ot.minimap.enabled&&J.minimap.side===ot.minimap.side&&J.minimap.size===ot.minimap.size&&J.minimap.showSlider===ot.minimap.showSlider&&J.minimap.renderCharacters===ot.minimap.renderCharacters&&J.minimap.maxColumn===ot.minimap.maxColumn&&J.minimap.scale===ot.minimap.scale&&J.verticalScrollbarWidth===ot.verticalScrollbarWidth&&J.isViewportWrapping===ot.isViewportWrapping,mt=J.lineHeight,Dt=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let Xe=st>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const St=J.minimap.maxColumn,Pe=J.minimap.size,ye=J.minimap.side,De=J.verticalScrollbarWidth,ee=J.viewLineCount,ue=J.remainingWidth,ge=J.isViewportWrapping,fe=It?2:3;let Ie=Math.floor(st*Ye);const xe=Ie/st;let Ne=!1,Ge=!1,tt=fe*Xe,Le=Xe/st,de=1;if(Pe==="fill"||Pe==="fit"){const{typicalViewportLineCount:Ue,extraLinesBeyondLastLine:dt,desiredRatio:gt,minimapLineCount:lt}=K.computeContainedMinimapLineCount({viewLineCount:ee,scrollBeyondLastLine:Pt,height:Ye,lineHeight:mt,pixelRatio:st});if(ee/lt>1)Ne=!0,Ge=!0,Xe=1,tt=1,Le=Xe/st;else{let ut=!1,pt=Xe+1;if(Pe==="fit"){const bt=Math.ceil((ee+dt)*tt);ge&&Et&&ue<=me.stableFitRemainingWidth?(ut=!0,pt=me.stableFitMaxMinimapScale):ut=bt>Ie}if(Pe==="fill"||ut){Ne=!0;const bt=Xe;tt=Math.min(mt*st,Math.max(1,Math.floor(1/gt))),ge&&Et&&ue<=me.stableFitRemainingWidth&&(pt=me.stableFitMaxMinimapScale),Xe=Math.min(pt,Math.max(1,Math.floor(tt/fe))),Xe>bt&&(de=Math.min(2,Xe/bt)),Le=Xe/st/de,Ie=Math.ceil(Math.max(Ue,ee+dt)*tt),ge?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=ue,me.stableFitMaxMinimapScale=Xe):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(St*Le),Y=Math.min(pe,Math.max(0,Math.floor((ue-De-2)*Le/(Dt+Le)))+e.MINIMAP_GUTTER_WIDTH);let z=Math.floor(st*Y);const we=z/st;z=Math.floor(z*de);const ke=It?1:2,Je=ye==="left"?0:We-Y-De;return{renderMinimap:ke,minimapLeft:Je,minimapWidth:Y,minimapHeightIsEditorHeight:Ne,minimapIsSampling:Ge,minimapScale:Xe,minimapLineHeight:tt,minimapCanvasInnerWidth:z,minimapCanvasInnerHeight:Ie,minimapCanvasOuterWidth:we,minimapCanvasOuterHeight:xe}}static computeLayout(J,me){const We=me.outerWidth|0,Ye=me.outerHeight|0,st=me.lineHeight|0,ot=me.lineNumbersDigitCount|0,Et=me.typicalHalfwidthCharacterWidth,mt=me.maxDigitWidth,Dt=me.pixelRatio,Pt=me.viewLineCount,It=J.get(121),Xe=It==="inherit"?J.get(120):It,St=Xe==="inherit"?J.get(116):Xe,Pe=J.get(119),ye=J.get(2),De=me.isDominatedByLongLines,ee=J.get(49),ue=J.get(59).renderType!==0,ge=J.get(60),fe=J.get(93),Ie=J.get(64),xe=J.get(91),Ne=xe.verticalScrollbarSize,Ge=xe.verticalHasArrows,tt=xe.arrowSize,Le=xe.horizontalScrollbarSize,de=J.get(57),pe=J.get(37);let Y;if(typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)){const yt=parseFloat(de.substr(0,de.length-2));Y=u.clampedInt(yt*Et,0,0,1e3)}else Y=u.clampedInt(de,0,0,1e3);pe&&(Y+=16);let z=0;if(ue){const yt=Math.max(ot,ge);z=Math.round(yt*mt)}let we=0;ee&&(we=st);let ke=0,Je=ke+we,Ue=Je+z,dt=Ue+Y;const gt=We-we-z-Y;let lt=!1,ft=!1,ut=-1;ye!==2&&(Xe==="inherit"&&De?(lt=!0,ft=!0):St==="on"||St==="bounded"?ft=!0:St==="wordWrapColumn"&&(ut=Pe));const pt=K._computeMinimapLayout({outerWidth:We,outerHeight:Ye,lineHeight:st,typicalHalfwidthCharacterWidth:Et,pixelRatio:Dt,scrollBeyondLastLine:fe,minimap:Ie,verticalScrollbarWidth:Ne,viewLineCount:Pt,remainingWidth:gt,isViewportWrapping:ft},me.memory||new S);pt.renderMinimap!==0&&pt.minimapLeft===0&&(ke+=pt.minimapWidth,Je+=pt.minimapWidth,Ue+=pt.minimapWidth,dt+=pt.minimapWidth);const bt=gt-pt.minimapWidth,Ut=Math.max(1,Math.floor((bt-Ne-2)/Et)),Vt=Ge?tt:0;return ft&&(ut=Math.max(1,Ut),St==="bounded"&&(ut=Math.min(ut,Pe))),{width:We,height:Ye,glyphMarginLeft:ke,glyphMarginWidth:we,lineNumbersLeft:Je,lineNumbersWidth:z,decorationsLeft:Ue,decorationsWidth:Y,contentLeft:dt,contentWidth:bt,minimap:pt,viewportColumn:Ut,isWordWrapMinified:lt,isViewportWrapping:ft,wrappingColumn:ut,verticalScrollbarWidth:Ne,horizontalScrollbarHeight:Le,overviewRuler:{top:Vt,width:Ne,height:Ye-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=K;class H extends T{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:d.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class W extends T{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:d.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(me.fontFamily,this.defaultValue.fontFamily)}}}class ne extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>v.clamp(J,0,150),{markdownDescription:d.localize(46,null)})}compute(J,me,We){return J.fontInfo.lineHeight}}class V extends T{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:J.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:d.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),size:y(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:y(me.side,this.defaultValue.side,["right","left"]),showSlider:y(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(me.scale,1,1,3),maxColumn:u.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function X(j){return j==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:u.clampedInt(me.top,0,0,1e3),bottom:u.clampedInt(me.bottom,0,0,1e3)}}}class le extends T{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:d.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class te extends t{constructor(){super(127)}compute(J,me,We){return J.pixelRatio}}class ve extends T{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:d.localize(61,null)},comments:{type:"boolean",default:J.comments,description:d.localize(62,null)},other:{type:"boolean",default:J.other,description:d.localize(63,null)}}}],default:J,description:d.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,We={other:n(me.other,this.defaultValue.other),comments:n(me.comments,this.defaultValue.comments),strings:n(me.strings,this.defaultValue.strings)};return We.other&&We.comments&&We.strings?!0:!We.other&&!We.comments&&!We.strings?!1:We}return this.defaultValue}}var Re;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,We=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:We}}}function Oe(j){const J=j.get(86);return J==="editable"?j.get(80):J!=="on"}e.filterValidationDecorations=Oe;class Ke extends T{constructor(){const J=[],me={type:"number",description:d.localize(70,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:J,description:d.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let We of J)if(typeof We=="number")me.push({column:u.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ye=We;me.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return me.sort((We,Ye)=>We.column-Ye.column),me}return this.defaultValue}}function je(j,J){if(typeof j!="string")return J;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends T{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:d.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,We=u.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(me.vertical,this.defaultValue.vertical),horizontal:je(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:u.clampedInt(me.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(me.verticalSliderSize,Ye,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}class U extends T{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:d.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:y(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends T{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:d.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class ie extends T{constructor(){const J={bracketPairs:!1,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:"boolean",default:J.bracketPairs,description:d.localize(86,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:d.localize(87,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:d.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{bracketPairs:n(me.bracketPairs,this.defaultValue.bracketPairs),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class ae extends T{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(89,null),d.localize(90,null)],default:J.insertMode,description:d.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:d.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:d.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:d.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:d.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:d.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:d.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:d.localize(98,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:d.localize(99,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(100,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(101,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(102,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(103,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(104,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(105,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:y(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:y(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class G extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(131,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends t{constructor(){super(128,[80])}compute(J,me,We){return me.get(80)?!0:J.tabFocusMode}}var he;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(he=e.WrappingIndent||(e.WrappingIndent={}));function Te(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends t{constructor(){super(130,[129])}compute(J,me,We){const Ye=me.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const He="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",it="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?Qe:M.isLinux?it:He,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ce(j){return e.editorOptionsRegistry[j.id]=j,j}var Ze;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=42]="fontFamily",j[j.fontInfo=43]="fontInfo",j[j.fontLigatures=44]="fontLigatures",j[j.fontSize=45]="fontSize",j[j.fontWeight=46]="fontWeight",j[j.formatOnPaste=47]="formatOnPaste",j[j.formatOnType=48]="formatOnType",j[j.glyphMargin=49]="glyphMargin",j[j.gotoLocation=50]="gotoLocation",j[j.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",j[j.hover=52]="hover",j[j.inDiffEditor=53]="inDiffEditor",j[j.inlineSuggest=54]="inlineSuggest",j[j.letterSpacing=55]="letterSpacing",j[j.lightbulb=56]="lightbulb",j[j.lineDecorationsWidth=57]="lineDecorationsWidth",j[j.lineHeight=58]="lineHeight",j[j.lineNumbers=59]="lineNumbers",j[j.lineNumbersMinChars=60]="lineNumbersMinChars",j[j.linkedEditing=61]="linkedEditing",j[j.links=62]="links",j[j.matchBrackets=63]="matchBrackets",j[j.minimap=64]="minimap",j[j.mouseStyle=65]="mouseStyle",j[j.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=67]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",j[j.multiCursorModifier=69]="multiCursorModifier",j[j.multiCursorPaste=70]="multiCursorPaste",j[j.occurrencesHighlight=71]="occurrencesHighlight",j[j.overviewRulerBorder=72]="overviewRulerBorder",j[j.overviewRulerLanes=73]="overviewRulerLanes",j[j.padding=74]="padding",j[j.parameterHints=75]="parameterHints",j[j.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",j[j.quickSuggestions=78]="quickSuggestions",j[j.quickSuggestionsDelay=79]="quickSuggestionsDelay",j[j.readOnly=80]="readOnly",j[j.renameOnType=81]="renameOnType",j[j.renderControlCharacters=82]="renderControlCharacters",j[j.renderFinalNewline=83]="renderFinalNewline",j[j.renderLineHighlight=84]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=86]="renderValidationDecorations",j[j.renderWhitespace=87]="renderWhitespace",j[j.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",j[j.roundedSelection=89]="roundedSelection",j[j.rulers=90]="rulers",j[j.scrollbar=91]="scrollbar",j[j.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=93]="scrollBeyondLastLine",j[j.scrollPredominantAxis=94]="scrollPredominantAxis",j[j.selectionClipboard=95]="selectionClipboard",j[j.selectionHighlight=96]="selectionHighlight",j[j.selectOnLineNumbers=97]="selectOnLineNumbers",j[j.showFoldingControls=98]="showFoldingControls",j[j.showUnused=99]="showUnused",j[j.snippetSuggestions=100]="snippetSuggestions",j[j.smartSelect=101]="smartSelect",j[j.smoothScrolling=102]="smoothScrolling",j[j.stickyTabStops=103]="stickyTabStops",j[j.stopRenderingLineAfter=104]="stopRenderingLineAfter",j[j.suggest=105]="suggest",j[j.suggestFontSize=106]="suggestFontSize",j[j.suggestLineHeight=107]="suggestLineHeight",j[j.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",j[j.suggestSelection=109]="suggestSelection",j[j.tabCompletion=110]="tabCompletion",j[j.tabIndex=111]="tabIndex",j[j.unusualLineTerminators=112]="unusualLineTerminators",j[j.useShadowDOM=113]="useShadowDOM",j[j.useTabStops=114]="useTabStops",j[j.wordSeparators=115]="wordSeparators",j[j.wordWrap=116]="wordWrap",j[j.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=119]="wordWrapColumn",j[j.wordWrapOverride1=120]="wordWrapOverride1",j[j.wordWrapOverride2=121]="wordWrapOverride2",j[j.wrappingIndent=122]="wrappingIndent",j[j.wrappingStrategy=123]="wrappingStrategy",j[j.showDeprecated=124]="showDeprecated",j[j.inlayHints=125]="inlayHints",j[j.editorClassName=126]="editorClassName",j[j.pixelRatio=127]="pixelRatio",j[j.tabFocusMode=128]="tabFocusMode",j[j.layoutInfo=129]="layoutInfo",j[j.wrappingInfo=130]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ce(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(132,null)})),acceptSuggestionOnEnter:Ce(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(133,null),""],markdownDescription:d.localize(134,null)})),accessibilitySupport:Ce(new i),accessibilityPageSize:Ce(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(135,null)})),ariaLabel:Ce(new D(4,"ariaLabel",d.localize(136,null))),autoClosingBrackets:Ce(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(137,null),d.localize(138,null),""],description:d.localize(139,null)})),autoClosingDelete:Ce(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(140,null),""],description:d.localize(141,null)})),autoClosingOvertype:Ce(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(142,null),""],description:d.localize(143,null)})),autoClosingQuotes:Ce(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(144,null),d.localize(145,null),""],description:d.localize(146,null)})),autoIndent:Ce(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],C,{enumDescriptions:[d.localize(147,null),d.localize(148,null),d.localize(149,null),d.localize(150,null),d.localize(151,null)],description:d.localize(152,null)})),automaticLayout:Ce(new f(10,"automaticLayout",!1)),autoSurround:Ce(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(153,null),d.localize(154,null),d.localize(155,null),""],description:d.localize(156,null)})),bracketPairColorization:Ce(new Q),bracketPairGuides:Ce(new ie),stickyTabStops:Ce(new f(103,"stickyTabStops",!1,{description:d.localize(157,null)})),codeLens:Ce(new f(14,"codeLens",!0,{description:d.localize(158,null)})),codeLensFontFamily:Ce(new D(15,"codeLensFontFamily","",{description:d.localize(159,null)})),codeLensFontSize:Ce(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(160,null)})),colorDecorators:Ce(new f(17,"colorDecorators",!0,{description:d.localize(161,null)})),columnSelection:Ce(new f(18,"columnSelection",!1,{description:d.localize(162,null)})),comments:Ce(new p),contextmenu:Ce(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ce(new f(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(163,null)})),cursorBlinking:Ce(new h(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:d.localize(164,null)})),cursorSmoothCaretAnimation:Ce(new f(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(165,null)})),cursorStyle:Ce(new h(24,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:d.localize(166,null)})),cursorSurroundingLines:Ce(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(167,null)})),cursorSurroundingLinesStyle:Ce(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(168,null),d.localize(169,null)],description:d.localize(170,null)})),cursorWidth:Ce(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(171,null)})),disableLayerHinting:Ce(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ce(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ce(new f(30,"domReadOnly",!1)),dragAndDrop:Ce(new f(31,"dragAndDrop",!0,{description:d.localize(172,null)})),emptySelectionClipboard:Ce(new P),extraEditorClassName:Ce(new D(33,"extraEditorClassName","")),fastScrollSensitivity:Ce(new v(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:d.localize(173,null)})),find:Ce(new g),fixedOverflowWidgets:Ce(new f(36,"fixedOverflowWidgets",!1)),folding:Ce(new f(37,"folding",!0,{description:d.localize(174,null)})),foldingStrategy:Ce(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(175,null),d.localize(176,null)],description:d.localize(177,null)})),foldingHighlight:Ce(new f(39,"foldingHighlight",!0,{description:d.localize(178,null)})),foldingImportsByDefault:Ce(new f(40,"foldingImportsByDefault",!1,{description:d.localize(179,null)})),unfoldOnClickAfterEndOfLine:Ce(new f(41,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(180,null)})),fontFamily:Ce(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(181,null)})),fontInfo:Ce(new R),fontLigatures2:Ce(new I),fontSize:Ce(new L),fontWeight:Ce(new w),formatOnPaste:Ce(new f(47,"formatOnPaste",!1,{description:d.localize(182,null)})),formatOnType:Ce(new f(48,"formatOnType",!1,{description:d.localize(183,null)})),glyphMargin:Ce(new f(49,"glyphMargin",!0,{description:d.localize(184,null)})),gotoLocation:Ce(new x),hideCursorInOverviewRuler:Ce(new f(51,"hideCursorInOverviewRuler",!1,{description:d.localize(185,null)})),hover:Ce(new $),inDiffEditor:Ce(new f(53,"inDiffEditor",!1)),letterSpacing:Ce(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>v.clamp(j,-5,20),{description:d.localize(186,null)})),lightbulb:Ce(new H),lineDecorationsWidth:Ce(new _(57,"lineDecorationsWidth",10)),lineHeight:Ce(new ne),lineNumbers:Ce(new Fe),lineNumbersMinChars:Ce(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ce(new f(61,"linkedEditing",!1,{description:d.localize(187,null)})),links:Ce(new f(62,"links",!0,{description:d.localize(188,null)})),matchBrackets:Ce(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(189,null)})),minimap:Ce(new V),mouseStyle:Ce(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ce(new v(66,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:d.localize(190,null)})),mouseWheelZoom:Ce(new f(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(191,null)})),multiCursorMergeOverlapping:Ce(new f(68,"multiCursorMergeOverlapping",!0,{description:d.localize(192,null)})),multiCursorModifier:Ce(new h(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],X,{markdownEnumDescriptions:[d.localize(193,null),d.localize(194,null)],markdownDescription:d.localize(195,null)})),multiCursorPaste:Ce(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(196,null),d.localize(197,null)],markdownDescription:d.localize(198,null)})),occurrencesHighlight:Ce(new f(71,"occurrencesHighlight",!0,{description:d.localize(199,null)})),overviewRulerBorder:Ce(new f(72,"overviewRulerBorder",!0,{description:d.localize(200,null)})),overviewRulerLanes:Ce(new u(73,"overviewRulerLanes",3,0,3)),padding:Ce(new q),parameterHints:Ce(new le),peekWidgetDefaultFocus:Ce(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(201,null),d.localize(202,null)],description:d.localize(203,null)})),definitionLinkOpensInPeek:Ce(new f(77,"definitionLinkOpensInPeek",!1,{description:d.localize(204,null)})),quickSuggestions:Ce(new ve),quickSuggestionsDelay:Ce(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(205,null)})),readOnly:Ce(new f(80,"readOnly",!1)),renameOnType:Ce(new f(81,"renameOnType",!1,{description:d.localize(206,null),markdownDeprecationMessage:d.localize(207,null)})),renderControlCharacters:Ce(new f(82,"renderControlCharacters",!1,{description:d.localize(208,null)})),renderFinalNewline:Ce(new f(83,"renderFinalNewline",!0,{description:d.localize(209,null)})),renderLineHighlight:Ce(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(210,null)],description:d.localize(211,null)})),renderLineHighlightOnlyWhenFocus:Ce(new f(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(212,null)})),renderValidationDecorations:Ce(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ce(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(213,null),d.localize(214,null),d.localize(215,null),""],description:d.localize(216,null)})),revealHorizontalRightPadding:Ce(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ce(new f(89,"roundedSelection",!0,{description:d.localize(217,null)})),rulers:Ce(new Ke),scrollbar:Ce(new Ve),scrollBeyondLastColumn:Ce(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(218,null)})),scrollBeyondLastLine:Ce(new f(93,"scrollBeyondLastLine",!0,{description:d.localize(219,null)})),scrollPredominantAxis:Ce(new f(94,"scrollPredominantAxis",!0,{description:d.localize(220,null)})),selectionClipboard:Ce(new f(95,"selectionClipboard",!0,{description:d.localize(221,null),included:M.isLinux})),selectionHighlight:Ce(new f(96,"selectionHighlight",!0,{description:d.localize(222,null)})),selectOnLineNumbers:Ce(new f(97,"selectOnLineNumbers",!0)),showFoldingControls:Ce(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(223,null),d.localize(224,null)],description:d.localize(225,null)})),showUnused:Ce(new f(99,"showUnused",!0,{description:d.localize(226,null)})),showDeprecated:Ce(new f(124,"showDeprecated",!0,{description:d.localize(227,null)})),inlayHints:Ce(new W),snippetSuggestions:Ce(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(228,null),d.localize(229,null),d.localize(230,null),d.localize(231,null)],description:d.localize(232,null)})),smartSelect:Ce(new G),smoothScrolling:Ce(new f(102,"smoothScrolling",!1,{description:d.localize(233,null)})),stopRenderingLineAfter:Ce(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ce(new ae),inlineSuggest:Ce(new U),suggestFontSize:Ce(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(234,null)})),suggestLineHeight:Ce(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(235,null)})),suggestOnTriggerCharacters:Ce(new f(108,"suggestOnTriggerCharacters",!0,{description:d.localize(236,null)})),suggestSelection:Ce(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(237,null),d.localize(238,null),d.localize(239,null)],description:d.localize(240,null)})),tabCompletion:Ce(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(241,null),d.localize(242,null),d.localize(243,null)],description:d.localize(244,null)})),tabIndex:Ce(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ce(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null)],description:d.localize(248,null)})),useShadowDOM:Ce(new f(113,"useShadowDOM",!0)),useTabStops:Ce(new f(114,"useTabStops",!0,{description:d.localize(249,null)})),wordSeparators:Ce(new D(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:d.localize(250,null)})),wordWrap:Ce(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(251,null),d.localize(252,null),d.localize(253,null),d.localize(254,null)],description:d.localize(255,null)})),wordWrapBreakAfterCharacters:Ce(new D(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ce(new D(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ce(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(256,null)})),wordWrapOverride1:Ce(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ce(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ce(new h(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Te,{enumDescriptions:[d.localize(257,null),d.localize(258,null),d.localize(259,null),d.localize(260,null)],description:d.localize(261,null)})),wrappingStrategy:Ce(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(262,null),d.localize(263,null)],description:d.localize(264,null)})),editorClassName:Ce(new b),pixelRatio:Ce(new te),tabFocusMode:Ce(new oe),layoutInfo:Ce(new K),wrappingInfo:Ce(new Be)}}),define(be[119],Ee([18,19]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(se,e){return se.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(se,e){return se.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(se,e){return se.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(se,e){return se.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(M);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=F;function k(n){if(!n)return null;let f=n.majorBase,s=n.majorMustEqual,u=n.minorBase,v=n.minorMustEqual,D=n.patchBase,y=n.patchMustEqual;n.hasCaret&&(f===0||(v=!1),y=!1);let o=0;if(n.preRelease){const h=E.exec(n.preRelease);if(h){const[,C,i,p]=h;o=Date.UTC(Number(C),Number(i)-1,Number(p))}}return{majorBase:f,majorMustEqual:s,minorBase:u,minorMustEqual:v,patchBase:D,patchMustEqual:y,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function S(n,f,s){let u;typeof n=="string"?u=k(F(n)):u=n;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let D;if(typeof s=="string"?D=k(F(s)):D=s,!u||!D)return!1;let y=u.majorBase,o=u.minorBase,h=u.patchBase,C=D.majorBase,i=D.minorBase,p=D.patchBase,a=D.notBefore,r=D.majorMustEqual,c=D.minorMustEqual,l=D.patchMustEqual;return D.isMinimum?y>C?!0:y<C?!1:o>i?!0:o<i||v&&v<a?!1:h>=p:(y===1&&C===0&&(!r||!c||!l)&&(C=1,i=0,p=0,r=!0,c=!1,l=!1),y<C?!1:y>C?!r:o<i?!1:o>i?!c:h<p?!1:h>p?!l:!(v&&v<a))}e.isValidVersion=S;function T(n,f,s,u){return s.isBuiltin||typeof s.main=="undefined"?!0:_(n,f,s.engines.vscode,u)}e.isValidExtensionVersion=T;function t(n,f,s){return n==="*"||_(f,s,n)}e.isEngineValid=t;function _(n,f,s,u=[]){let v=k(F(s));if(!v)return u.push(d.localize(0,null,s)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return u.push(d.localize(1,null,s)),!1}else if(!v.majorMustEqual)return u.push(d.localize(2,null,s)),!1;return S(n,f,v)?!0:(u.push(d.localize(3,null,n,s)),!1)}}),define(be[82],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(E,A=[],F=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,82]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,k,S){k instanceof d.SyncDescriptor||(k=new d.SyncDescriptor(k,[],S)),M.push([F,k])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const k=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(F);k.outgoing.set(this._hashFn(F),S),S.incoming.set(this._hashFn(A),k)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let k of this._nodes.values())k.outgoing.delete(F),k.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let k=this._nodes.get(F);return k||(k=new d(A),this._nodes.set(F,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,k]of this._nodes)A.push(`${F}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const k=new Set([A]),S=this._findCycle(F,k);if(S)return S}}_findCycle(A,F){for(let[k,S]of A.outgoing){if(F.has(k))return[...F,k].join(" -> ");F.add(k);const T=this._findCycle(S,F);if(T)return T;F.delete(k)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function S(T){return T[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=S})(d=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(k,S,T,t){S[d.DI_TARGET]===S?S[d.DI_DEPENDENCIES].push({id:k,index:T,optional:t}):(S[d.DI_DEPENDENCIES]=[{id:k,index:T,optional:t}],S[d.DI_TARGET]=S)}function E(k){if(d.serviceIds.has(k))return d.serviceIds.get(k);const S=function(T,t,_){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(S,T,_,!1)};return S.toString=()=>k,d.serviceIds.set(k,S),S}e.createDecorator=E;function A(k){return k}e.refineServiceDecorator=A;function F(k){return function(S,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(k,S,t,!0)}}e.optional=F}),define(be[140],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,76,56,140]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(T):!!u.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(v,D){let y={selector:v,provider:D,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(y){let o=this._entries.indexOf(y);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const D=[];for(let y of this._entries)y._score>0&&D.push(y.provider);return D}ordered(v){const D=[];return this._orderedForEach(v,y=>D.push(y.provider)),D}orderedGroups(v){const D=[];let y,o;return this._orderedForEach(v,h=>{y&&o===h._score?y.push(h.provider):(o=h._score,y=[h.provider],D.push(y))}),D}_orderedForEach(v,D){if(!!v){this._updateScores(v);for(const y of this._entries)y._score>0&&D(y)}}_updateScores(v){let D={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let y of this._entries)if(y._score=(0,k.score)(y.selector,v.uri,v.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(v)),T(y.selector)&&y._score>0){for(let o of this._entries)o._score=0;y._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,D){return v._score<D._score?1:v._score>D._score?-1:v._time<D._time?1:v._time>D._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let n=0;function f(u){let v=_.get(u);return v===void 0&&(v=++n,_.set(u,v)),v}class s{constructor(v,D,y=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=D,this.max=y,this._cache=new A.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((D,y)=>(0,M.doHash)(f(y),D),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const D=this._key(v),y=this._cache.get(D);return this._clamp(y?.value)}update(v,D){const y=this._key(v);let o=this._cache.get(y);return o||(o=new F.MovingAverage,this._cache.set(y,o)),o.update(D),this.get(v)}}e.LanguageFeatureRequestDelays=s}),define(be[59],Ee([0,1,2,44,141,114,34]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class S{constructor(I,R){this.language=I,this.id=R}}e.LanguageIdentifier=S;var T;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var _;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(_=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(I){return(I&255)>>>0}static getTokenType(I){return(I&1792)>>>8}static getFontStyle(I){return(I&14336)>>>11}static getForeground(I){return(I&8372224)>>>14}static getBackground(I){return(I&4286578688)>>>23}static getClassNameFromMetadata(I){let R=this.getForeground(I),L="mtk"+R,w=this.getFontStyle(I);return w&1&&(L+=" mtki"),w&2&&(L+=" mtkb"),w&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(I,R){const L=this.getForeground(I),w=this.getFontStyle(I);let x=`color: ${R[L]};`;return w&1&&(x+="font-style: italic;"),w&2&&(x+="font-weight: bold;"),w&4&&(x+="text-decoration: underline;"),x}}e.TokenMetadata=f;var s;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(I){const R=g[I];let L=R&&F.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+I),L=F.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(I,R){let L=g[I];return typeof L=="undefined"&&!R&&(L=9),L}}();var u;(function(g){g[g.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var C;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(C=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&d.URI.isUri(g.uri)&&M.Range.isIRange(g.range)&&(M.Range.isIRange(g.originSelectionRange)||M.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var p;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var a;(function(g){g[g.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var r;(function(g){const I=new Map;I.set("file",0),I.set("module",1),I.set("namespace",2),I.set("package",3),I.set("class",4),I.set("method",5),I.set("property",6),I.set("field",7),I.set("constructor",8),I.set("enum",9),I.set("interface",10),I.set("function",11),I.set("variable",12),I.set("constant",13),I.set("string",14),I.set("number",15),I.set("boolean",16),I.set("array",17),I.set("object",18),I.set("key",19),I.set("null",20),I.set("enum-member",21),I.set("struct",22),I.set("event",23),I.set("operator",24),I.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L($){return I.get($)}g.fromString=L;function w($){return R.get($)}g.toString=w;function x($,B){const K=R.get($);let H=K&&F.iconRegistry.get("symbol-"+K);return H||(console.info("No codicon found for SymbolKind "+$),H=F.Codicon.symbolProperty),`${B?"inline":"block"} ${H.classNames}`}g.toCssClassName=x})(r=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(I){this.value=I}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var l;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var b;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var P;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[46],Ee([0,1,25,9,4]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return n.INSTANCE}static true(){return f.INSTANCE}static has(w){return s.create(w)}static equals(w,x){return u.create(w,x)}static notEquals(w,x){return y.create(w,x)}static regex(w,x){return a.create(w,x)}static in(w,x){return v.create(w,x)}static not(w){return o.create(w)}static and(...w){return l.create(w,null)}static or(...w){return m.create(w,null,!0)}static greater(w,x){return h.create(w,x)}static less(w,x){return i.create(w,x)}static deserialize(w,x=!1){if(!!w)return this._deserializeOrExpression(w,x)}static _deserializeOrExpression(w,x){let $=w.split("||");return m.create($.map(B=>this._deserializeAndExpression(B,x)),null,!0)}static _deserializeAndExpression(w,x){let $=w.split("&&");return l.create($.map(B=>this._deserializeOne(B,x)),null)}static _deserializeOne(w,x){if(w=w.trim(),w.indexOf("!=")>=0){let $=w.split("!=");return y.create($[0].trim(),this._deserializeValue($[1],x))}if(w.indexOf("==")>=0){let $=w.split("==");return u.create($[0].trim(),this._deserializeValue($[1],x))}if(w.indexOf("=~")>=0){let $=w.split("=~");return a.create($[0].trim(),this._deserializeRegexValue($[1],x))}if(w.indexOf(" in ")>=0){let $=w.split(" in ");return v.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const $=w.split(">=");return C.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const $=w.split(">");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const $=w.split("<=");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const $=w.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(w)?o.create(w.substr(1).trim()):s.create(w)}static _deserializeValue(w,x){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let $=/^'([^']*)'$/.exec(w);return $?$[1].trim():w}static _deserializeRegexValue(w,x){if((0,M.isFalsyOrWhitespace)(w)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=w.indexOf("/"),B=w.lastIndexOf("/");if($===B||$<0){if(x)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let K=w.slice($+1,B),H=w[B+1]==="i"?"i":"";try{return new RegExp(K,H)}catch(W){if(x)throw new Error(`bad regexp-value '${w}', parse error: ${W}`);return console.warn(`bad regexp-value '${w}', parse error: ${W}`),null}}}e.ContextKeyExpr=T;function t(L,w){const x=L?L.substituteConstants():void 0,$=w?w.substituteConstants():void 0;return!x&&!$?!0:!x||!$?!1:x.equals($)}e.expressionsAreEqualWithConstantSubstitution=t;function _(L,w){return L.cmp(w)}class n{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class f{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class s{constructor(w,x){this.key=w,this.negated=x,this.type=2}static create(w,x=null){const $=F.get(w);return typeof $=="boolean"?$?f.INSTANCE:n.INSTANCE:new s(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=F.get(this.key);return typeof w=="boolean"?w?f.INSTANCE:n.INSTANCE:this}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class u{constructor(w,x,$){this.key=w,this.value=x,this.negated=$,this.type=4}static create(w,x,$=null){if(typeof x=="boolean")return x?s.create(w,$):o.create(w,$);const B=F.get(w);return typeof B=="boolean"?x===(B?"true":"false")?f.INSTANCE:n.INSTANCE:new u(w,x,$)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=F.get(this.key);if(typeof w=="boolean"){const x=w?"true":"false";return this.value===x?f.INSTANCE:n.INSTANCE}return this}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class v{constructor(w,x){this.key=w,this.valueKey=x,this.type=10,this.negated=null}static create(w,x){return new v(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}substituteConstants(){return this}evaluate(w){const x=w.getValue(this.valueKey),$=w.getValue(this.key);return Array.isArray(x)?x.indexOf($)>=0:typeof $=="string"&&typeof x=="object"&&x!==null?k.call(x,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=v;class D{constructor(w){this._actual=w,this.type=11}static create(w){return new D(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new D(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class y{constructor(w,x,$){this.key=w,this.value=x,this.negated=$,this.type=5}static create(w,x,$=null){if(typeof x=="boolean")return x?o.create(w,$):s.create(w,$);const B=F.get(w);return typeof B=="boolean"?x===(B?"true":"false")?n.INSTANCE:f.INSTANCE:new y(w,x,$)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=F.get(this.key);if(typeof w=="boolean"){const x=w?"true":"false";return this.value===x?n.INSTANCE:f.INSTANCE}return this}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class o{constructor(w,x){this.key=w,this.negated=x,this.type=3}static create(w,x=null){const $=F.get(w);return typeof $=="boolean"?$?n.INSTANCE:f.INSTANCE:new o(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=F.get(this.key);return typeof w=="boolean"?w?n.INSTANCE:f.INSTANCE:this}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;class h{constructor(w,x,$){this.key=w,this.value=x,this.negated=$,this.type=12}static create(w,x,$=null){return new h(w,x,$)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=h;class C{constructor(w,x,$){this.key=w,this.value=x,this.negated=$,this.type=13}static create(w,x,$=null){return new C(w,x,$)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=C;class i{constructor(w,x,$){this.key=w,this.value=x,this.negated=$,this.type=14}static create(w,x,$=null){return new i(w,x,$)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class p{constructor(w,x,$){this.key=w,this.value=x,this.negated=$,this.type=15}static create(w,x,$=null){return new p(w,x,$)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=p;class a{constructor(w,x){this.key=w,this.regexp=x,this.type=7,this.negated=null}static create(w,x){return new a(w,x)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const x=this.regexp?this.regexp.source:"",$=w.regexp?w.regexp.source:"";return x<$?-1:x>$?1:0}equals(w){if(w.type===this.type){const x=this.regexp?this.regexp.source:"",$=w.regexp?w.regexp.source:"";return this.key===w.key&&x===$}return!1}substituteConstants(){return this}evaluate(w){let x=w.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{constructor(w){this._actual=w,this.type=8}static create(w){return new r(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new r(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function c(L){let w=null;for(let x=0,$=L.length;x<$;x++){const B=L[x].substituteConstants();if(L[x]!==B&&w===null){w=[];for(let K=0;K<x;K++)w[K]=L[K]}w!==null&&(w[x]=B)}return w===null?L:w}class l{constructor(w,x){this.expr=w,this.negated=x,this.type=6}static create(w,x){return l._normalizeArr(w,x)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let x=0,$=this.expr.length;x<$;x++){const B=_(this.expr[x],w.expr[x]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let x=0,$=this.expr.length;x<$;x++)if(!this.expr[x].equals(w.expr[x]))return!1;return!0}return!1}substituteConstants(){const w=c(this.expr);return w===this.expr?this:l.create(w,this.negated)}evaluate(w){for(let x=0,$=this.expr.length;x<$;x++)if(!this.expr[x].evaluate(w))return!1;return!0}static _normalizeArr(w,x){const $=[];let B=!1;for(const K of w)if(!!K){if(K.type===1){B=!0;continue}if(K.type===0)return n.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&B)return f.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(_);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const H=$.pop(),W=$.length===0,ne=m.create(K.expr.map(V=>l.create([V,H],null)),null,W);ne&&($.push(ne),$.sort(_))}return $.length===1?$[0]:new l($,x)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let x of this.expr)w.push(...x.keys());return w}map(w){return new l(this.expr.map(x=>x.map(w)),null)}negate(){if(!this.negated){const w=[];for(let x of this.expr)w.push(x.negate());this.negated=m.create(w,this,!0)}return this.negated}}class m{constructor(w,x){this.expr=w,this.negated=x,this.type=9}static create(w,x,$){return m._normalizeArr(w,x,$)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let x=0,$=this.expr.length;x<$;x++){const B=_(this.expr[x],w.expr[x]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let x=0,$=this.expr.length;x<$;x++)if(!this.expr[x].equals(w.expr[x]))return!1;return!0}return!1}substituteConstants(){const w=c(this.expr);return w===this.expr?this:m.create(w,this.negated,!1)}evaluate(w){for(let x=0,$=this.expr.length;x<$;x++)if(this.expr[x].evaluate(w))return!0;return!1}static _normalizeArr(w,x,$){let B=[],K=!1;if(w){for(let H=0,W=w.length;H<W;H++){const ne=w[H];if(!!ne){if(ne.type===0){K=!0;continue}if(ne.type===1)return f.INSTANCE;if(ne.type===9){B=B.concat(ne.expr);continue}B.push(ne)}}if(B.length===0&&K)return n.INSTANCE;B.sort(_)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if($){for(let H=0;H<B.length;H++)for(let W=H+1;W<B.length;W++)I(B[H],B[W])&&(B.splice(W,1),W--);if(B.length===1)return B[0]}return new m(B,x)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let x of this.expr)w.push(...x.keys());return w}map(w){return new m(this.expr.map(x=>x.map(w)),null)}negate(){if(!this.negated){let w=[];for(let x of this.expr)w.push(x.negate());for(;w.length>1;){const x=w.shift(),$=w.shift(),B=[];for(const H of R(x))for(const W of R($))B.push(l.create([H,W],null));const K=w.length===0;w.unshift(m.create(B,null,K))}this.negated=w[0]}return this.negated}}class b extends s{constructor(w,x,$){super(w,null);this._defaultValue=x,typeof $=="object"?b._info.push({...$,key:w}):$!==!0&&b._info.push({key:w,description:$,type:x!=null?typeof x:void 0})}static all(){return b._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return u.create(this.key,w)}notEqualsTo(w){return y.create(this.key,w)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(L,w){return L<w?-1:L>w?1:0}function g(L,w,x,$){return L<x?-1:L>x?1:w<$?-1:w>$?1:0}function I(L,w){if(w.type===6&&L.type!==9&&L.type!==6){for(const B of w.expr)if(L.equals(B))return!0}const x=L.negate(),$=R(x).concat(R(w));$.sort(_);for(let B=0;B<$.length;B++){const H=$[B].negate();for(let W=B+1;W<$.length;W++){const ne=$[W];if(H.equals(ne))return!0}}return!1}e.implies=I;function R(L){return L.type===9?L.expr:[L]}}),define(be[142],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function T(B){return B.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(B){B[B.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=f;function s(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function v(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=v;var D;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(K,H){super(K);this.code=H}}e.FileSystemProviderError=y;function o(B,K){const H=new y(B.toString(),K);return C(H,K),H}e.createFileSystemProviderError=o;function h(B){return B||o((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=h;function C(B,K){return B.name=K?`${K} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=C;function i(B){if(!B)return D.Unknown;if(B instanceof y)return B.code;const K=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!K)return D.Unknown;switch(K[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=i;function p(B){if(B instanceof b)return B.fileOperationResult;switch(i(B)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=p;var a;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(K,H,W){this.resource=K,this.operation=H,this.target=W}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var c;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(K,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const ne of K){const V=W.get(ne.type);V?V.push([ne.resource,ne]):W.set(ne.type,[[ne.resource,ne]])}for(const[ne,V]of W)switch(ne){case 1:this.added=d.TernarySearchTree.forUris(()=>H),this.added.fill(V);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>H),this.updated.fill(V);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>H),this.deleted.fill(V);break}}contains(K,...H){return this.doContains(K,{includeChildren:!1},...H)}affects(K,...H){return this.doContains(K,{includeChildren:!0},...H)}doContains(K,H,...W){if(!K)return!1;const ne=W.length>0;return!!((!ne||W.includes(1))&&(this.added?.get(K)||H.includeChildren&&this.added?.findSuperstr(K))||(!ne||W.includes(0))&&(this.updated?.get(K)||H.includeChildren&&this.updated?.findSuperstr(K))||(!ne||W.includes(2))&&(this.deleted?.findSubstr(K)||H.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function m(B,K,H){return!B||!K||B===K||K.length>B.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),H?(0,E.startsWithIgnoreCase)(B,K):B.indexOf(K)===0)}e.isParent=m;class b extends Error{constructor(K,H,W){super(K);this.fileOperationResult=H,this.options=W}}e.FileOperationError=b;class P extends b{constructor(K,H,W){super(K,2,W);this.stat=H}}e.NotModifiedSinceFileOperationError=P;var g;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=R;async function L(B,K){if(!K.hasProvider(F.URI.from({scheme:B.scheme})))return new Promise(H=>{const W=K.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===B.scheme&&ne.added&&(W.dispose(),H())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class w{static formatSize(K){return(0,A.isNumber)(K)||(K=0),K<w.KB?(0,k.localize)(1,null,K.toFixed(0)):K<w.MB?(0,k.localize)(2,null,(K/w.KB).toFixed(2)):K<w.GB?(0,k.localize)(3,null,(K/w.MB).toFixed(2)):K<w.TB?(0,k.localize)(4,null,(K/w.GB).toFixed(2)):(0,k.localize)(5,null,(K/w.TB).toFixed(2))}}e.ByteSize=w,w.KB=1024,w.MB=w.KB*w.KB,w.GB=w.MB*w.KB,w.TB=w.GB*w.KB;var x;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function $(B){return{maxFileSize:B===0?300*w.MB:16*w.GB,maxHeapSize:B===0?700*w.MB:2*700*w.MB}}e.getPlatformLimits=$}),define(be[61],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...E){this._entries=new Map;for(let[A,F]of E)this.set(A,F)}set(E,A){const F=this._entries.get(E);return this._entries.set(E,A),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=d}),define(be[143],Ee([0,1,14,16,82,139,4,61]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class T extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new k.ServiceCollection,u=!1,v){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=v,this._services.set(F.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...u){let v=n.traceInvocation(s),D=!1;try{return s({get:(o,h)=>{if(D)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const C=this._getOrCreateServiceInstance(o,v);if(!C&&h!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return C}},...u)}finally{D=!0,v.stop()}}createInstance(s,...u){let v,D;return s instanceof E.SyncDescriptor?(v=n.traceCreation(s.ctor),D=this._createInstance(s.ctor,s.staticArguments.concat(u),v)):(v=n.traceCreation(s),D=this._createInstance(s,u,v)),v.stop(),D}_createInstance(s,u=[],v){let D=F._util.getServiceDependencies(s).sort((h,C)=>h.index-C.index),y=[];for(const h of D){let C=this._getOrCreateServiceInstance(h.id,v);if(!C&&this._strict&&!h.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${h.id}.`);y.push(C)}let o=D.length>0?D[0].index:u.length;if(u.length!==o){console.warn(`[createInstance] First service dependency of ${s.name} at position ${o+1} conflicts with ${u.length} static arguments`);let h=o-u.length;h>0?u=u.concat(new Array(h)):u=u.slice(0,o)}return new s(...[...u,...y])}_setServiceInstance(s,u){if(this._services.get(s)instanceof E.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let v=this._getServiceInstanceOrDescriptor(s);return v instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,v,u.branch(s,!0)):(u.branch(s,!1),v)}_safeCreateAndCacheServiceInstance(s,u,v){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,v)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,v){const D=new A.Graph(h=>h.id.toString());let y=0;const o=[{id:s,desc:u,_trace:v}];for(;o.length;){const h=o.pop();if(D.lookupOrInsertNode(h),y++>1e3)throw new T(D);for(let C of F._util.getServiceDependencies(h.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(C.id);if(!i&&!C.optional&&console.warn(`[createInstance] ${s} depends on ${C.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const p={id:C.id,desc:i,_trace:h._trace.branch(C.id,!0)};D.insertEdge(h,p),o.push(p)}}}for(;;){const h=D.roots();if(h.length===0){if(!D.isEmpty())throw new T(D);break}for(const{data:C}of h){if(this._getServiceInstanceOrDescriptor(C.id)instanceof E.SyncDescriptor){const p=this._createServiceInstanceWithOwner(C.id,C.desc.ctor,C.desc.staticArguments,C.desc.supportsDelayedInstantiation,C._trace);this._setServiceInstance(C.id,p)}D.removeNode(C)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,v=[],D,y){if(this._services.get(s)instanceof E.SyncDescriptor)return this._createServiceInstance(u,v,D,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,v,D,y);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],v,D){if(v){const y=new d.IdleValue(()=>this._createInstance(s,u,D));return new Proxy(Object.create(null),{get(o,h){if(h in o)return o[h];let C=y.value,i=C[h];return typeof i!="function"||(i=i.bind(C),o[h]=i),i},set(o,h,C){return y.value[h]=C,!0}})}else return this._createInstance(s,u,D)}}e.InstantiationService=t;var _;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(_||(_={}));class n{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return S?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return S?new n(0,s.name):n._None}branch(s,u){let v=new n(2,s.toString());return this._dep.push([s,u,v]),v}stop(){let s=Date.now()-this._start;n._totals+=s;let u=!1;function v(y,o){let h=[],C=new Array(y+1).join("	");for(const[i,p,a]of o._dep)if(p&&a){u=!0,h.push(`${C}CREATES -> ${i}`);let r=v(y+1,a);r&&h.push(r)}else h.push(`${C}uses -> ${i}`);return h.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,45,3,6,25,4]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class T extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...p){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([i,...p]))}debug(i,...p){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([i,...p]))}info(i,...p){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([i,...p]))}warn(i,...p){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([i,...p]))}error(i,...p){if(this.checkLogLevel(S.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(S.Error,this.format(a))}else this.log(S.Error,this.format([i,...p]))}critical(i,...p){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([i,...p]))}flush(){}format(i){let p="";for(let a=0;a<i.length;a++){let r=i[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}p+=(a>0?" ":"")+r}return p}}e.AbstractMessageLogger=t;class _ extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...p){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...p):console.log(`[main ${k()}]`,i,...p))}debug(i,...p){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...p):console.log(`[main ${k()}]`,i,...p))}info(i,...p){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...p):console.log(`[main ${k()}]`,i,...p))}warn(i,...p){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...p):console.warn(`[main ${k()}]`,i,...p))}error(i,...p){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...p):console.error(`[main ${k()}]`,i,...p))}critical(i,...p){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...p):console.error(`[main ${k()}]`,i,...p))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...p){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...p)}debug(i,...p){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...p)}info(i,...p){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...p)}warn(i,...p){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...p)}error(i,...p){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...p)}critical(i,...p){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...p)}dispose(){}flush(){}}e.ConsoleLogger=n;class f extends T{constructor(i,p=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(p)}trace(i,...p){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...p])}debug(i,...p){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...p])}info(i,...p){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...p])}warn(i,...p){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...p])}error(i,...p){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...p])}critical(i,...p){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...p])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class s extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const p of this.logServices)p.setLevel(i);super.setLevel(i)}trace(i,...p){for(const a of this.logServices)a.trace(i,...p)}debug(i,...p){for(const a of this.logServices)a.debug(i,...p)}info(i,...p){for(const a of this.logServices)a.info(i,...p)}warn(i,...p){for(const a of this.logServices)a.warn(i,...p)}error(i,...p){for(const a of this.logServices)a.error(i,...p)}critical(i,...p){for(const a of this.logServices)a.critical(i,...p)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class u extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...p){this.logger.trace(i,...p)}debug(i,...p){this.logger.debug(i,...p)}info(i,...p){this.logger.info(i,...p)}warn(i,...p){this.logger.warn(i,...p)}error(i,...p){this.logger.error(i,...p)}critical(i,...p){this.logger.critical(i,...p)}flush(){this.logger.flush()}}e.LogService=u;class v extends E.Disposable{constructor(i,p){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(p(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,p){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,p?.always?S.Trace:this.logLevel,p),this.loggers.set(i.toString(),a),p?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class D{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...p){}debug(i,...p){}info(i,...p){}warn(i,...p){}error(i,...p){}critical(i,...p){}dispose(){}flush(){}}e.NullLogService=D;function y(C){if(C.verbose)return S.Trace;if(typeof C.logLevel=="string"){const i=o(C.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function o(C){switch(C){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=o;function h(C){switch(C){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=h}),define(be[83],Ee([0,1,35,122,4]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function T(s,u){return u-s}S.compare=T;const t=Object.create(null);t[S.Error]=(0,M.localize)(0,null),t[S.Warning]=(0,M.localize)(1,null),t[S.Info]=(0,M.localize)(2,null);function _(s){return t[s]||""}S.toString=_;function n(s){switch(s){case d.default.Error:return S.Error;case d.default.Warning:return S.Warning;case d.default.Info:return S.Info;case d.default.Ignore:return S.Hint}}S.fromSeverity=n;function f(s){switch(s){case S.Error:return d.default.Error;case S.Warning:return d.default.Warning;case S.Info:return d.default.Info;case S.Hint:return d.default.Ignore}}S.toSeverity=f}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const T="";function t(n){return _(n,!0)}S.makeKey=t;function _(n,f){let s=[T];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(T),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(T),n.severity!==void 0&&n.severity!==null?s.push(F.toString(n.severity)):s.push(T),n.message&&f?s.push(n.message.replace("\xA6","\\\xA6")):s.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(T),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(T),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(T),s.push(T),s.join("\xA6")}S.makeKeyOptionalMessage=_})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[144],Ee([0,1,3,35,4]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=S}),define(be[145],Ee([0,1,6,9,2,4]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function F(k,S){return E.URI.isUri(k)?(0,M.equalsIgnoreCase)(k.scheme,S):(0,M.startsWithIgnoreCase)(k,S+":")}e.matchesScheme=F});var $e=this&&this.__decorate||function(se,e,d,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,d,M);else for(var k=se.length-1;k>=0;k--)(F=se[k])&&(A=(E<3?F(A):E>3?F(e,d,A):F(e,d))||A);return E>3&&A&&Object.defineProperty(e,d,A),A},ze=this&&this.__param||function(se,e){return function(d,M){e(d,M,se)}};define(be[146],Ee([0,1,14,21,6,4]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends E.Disposable{constructor(_,n){super();this.deferred=new d.DeferredPromise,n.withProgress(_,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};S=$e([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class T extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,f=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,k){d.ok(M.isString(F)),d.ok(M.isObject(k)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,k)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(be[84],Ee([0,1,3,28]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,T){this.schemasById[E(S)]=T,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,13,3,10,119,84,28]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=k.Registry.as(F.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,h=!0){this.registerConfigurations([o],h)}registerConfigurations(o,h=!0){const C=this.doRegisterConfigurations(o,h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterConfigurations(o){const h=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}updateConfigurations({add:o,remove:h}){const C=[];C.push(...this.doDeregisterConfigurations(h)),C.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(C))}registerDefaultConfigurations(o){const h=[],C=[];for(const i of o)for(const p in i)if(h.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]={...this.defaultValues[p]||{},...i[p]};const a={type:"object",default:this.defaultValues[p],description:A.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};C.push(f(p)),this.configurationProperties[p]=a,this.defaultLanguageConfigurationOverridesNode.properties[p]=a}else{this.defaultValues[p]=i[p];const a=this.configurationProperties[p];a&&(this.updatePropertyDefaultValue(p,a),this.updateSchema(p,a))}this.registerOverrideIdentifiers(C),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(o){const h=[];for(const C of o)for(const i in C)if(h.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const p=this.configurationProperties[i];p&&(this.updatePropertyDefaultValue(i,p),this.updateSchema(i,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const h of o)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,h){const C=[];return o.forEach(i=>{C.push(...this.validateAndRegisterProperties(i,h,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),C}doDeregisterConfigurations(o){const h=[],C=i=>{if(i.properties)for(const p in i.properties)h.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,i.properties[p]);i.allOf&&i.allOf.forEach(p=>C(p))};for(const i of o){C(i);const p=this.configurationContributors.indexOf(i);p!==-1&&this.configurationContributors.splice(p,1)}return h}validateAndRegisterProperties(o,h=!0,C,i=3){i=E.isUndefinedOrNull(o.scope)?i:o.scope;let p=[],a=o.properties;if(a)for(let c in a){if(h&&v(c)){delete a[c];continue}const l=a[c];if(this.updatePropertyDefaultValue(c,l),e.OVERRIDE_PROPERTY_PATTERN.test(c)?l.scope=void 0:(l.scope=E.isUndefinedOrNull(l.scope)?i:l.scope,l.restricted=E.isUndefinedOrNull(l.restricted)?!!C?.restrictedConfigurations?.includes(c):l.restricted),a[c].hasOwnProperty("included")&&!a[c].included){this.excludedConfigurationProperties[c]=a[c],delete a[c];continue}else this.configurationProperties[c]=a[c];!a[c].deprecationMessage&&a[c].markdownDeprecationMessage&&(a[c].deprecationMessage=a[c].markdownDeprecationMessage),p.push(c)}let r=o.allOf;if(r)for(let c of r)p.push(...this.validateAndRegisterProperties(c,h,C,i));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const h=C=>{let i=C.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let p=C.allOf;p&&p.forEach(h)};h(o)}updateSchema(o,h){switch(e.allSettings.properties[o]=h,h.scope){case 1:e.applicationSettings.properties[o]=h;break;case 2:e.machineSettings.properties[o]=h;break;case 6:e.machineOverridableSettings.properties[o]=h;break;case 3:e.windowSettings.properties[o]=h;break;case 4:e.resourceSettings.properties[o]=h;break;case 5:e.resourceSettings.properties[o]=h,this.resourceLanguageSettingsSchema.properties[o]=h;break}}removeFromSchema(o,h){switch(delete e.allSettings.properties[o],h.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const h=`[${o}]`,C={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,C),e.allSettings.properties[h]=C,e.applicationSettings.properties[h]=C,e.machineSettings.properties[h]=C,e.machineOverridableSettings.properties[h]=C,e.windowSettings.properties[h]=C,e.resourceSettings.properties[h]=C}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,h){let C=this.defaultValues[o];E.isUndefined(C)&&(C=h.default),E.isUndefined(C)&&(C=s(h.type)),h.default=C}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=f;function s(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const u=new _;k.Registry.add(e.Extensions.Configuration,u);function v(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?A.localize(5,null,y):u.getConfigurationProperties()[y]!==void 0?A.localize(6,null,y):null:A.localize(4,null)}e.validateProperty=v;function D(){const y=[],o=u.getConfigurationProperties();for(const h of Object.keys(o))y.push([h,o[h].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=D}),define(be[85],Ee([0,1,23,10,2,62,4,28]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function S(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof E.URI)}e.isConfigurationOverrides=S;var T;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(p,a){const r=a?p?a.keys.filter(I=>p.keys.indexOf(I)===-1):[...a.keys]:[],c=p?a?p.keys.filter(I=>a.keys.indexOf(I)===-1):[...p.keys]:[],l=[];if(a&&p){for(const I of p.keys)if(a.keys.indexOf(I)!==-1){const R=D(p.contents,I),L=D(a.contents,I);d.equals(R,L)||l.push(I)}}const m=[],b=I=>{const R={};for(const L of I)for(const w of L.identifiers)R[C(w)]=L;return R},P=a?b(a.overrides):{},g=p?b(p.overrides):{};if(Object.keys(P).length)for(const I of r){const R=P[I];R&&m.push([(0,A.overrideIdentifierFromKey)(I),R.keys])}if(Object.keys(g).length)for(const I of c){const R=g[I];R&&m.push([(0,A.overrideIdentifierFromKey)(I),R.keys])}if(Object.keys(P).length&&Object.keys(g).length)for(const I of l){const R=g[I],L=P[I];if(R&&L){const w=_({contents:R.contents,keys:R.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});m.push([(0,A.overrideIdentifierFromKey)(I),[...w.added,...w.removed,...w.updated]])}}return{added:r,removed:c,updated:l,overrides:m}}e.compare=_;function n(p,a){const r=[];for(const c of Object.keys(p))if(A.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const m in p[c])l[m]=p[c][m];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:f(l,a)})}return r}e.toOverrides=n;function f(p,a){const r=Object.create(null);for(let c in p)s(r,c,p[c],a);return r}e.toValuesTree=f;function s(p,a,r,c){const l=a.split("."),m=l.pop();let b=p;for(let P=0;P<l.length;P++){let g=l[P],I=b[g];switch(typeof I){case"undefined":I=b[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${a} as ${l.slice(0,P+1).join(".")} is ${JSON.stringify(I)}`);return}b=I}if(typeof b=="object"&&b!==null)try{b[m]=r}catch(P){c(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}else c(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=s;function u(p,a){const r=a.split(".");v(p,r)}e.removeFromValueTree=u;function v(p,a){const r=a.shift();if(a.length===0){delete p[r];return}if(Object.keys(p).indexOf(r)!==-1){const c=p[r];typeof c=="object"&&!Array.isArray(c)&&(v(c,a),Object.keys(c).length===0&&delete p[r])}}function D(p,a,r){function c(b,P){let g=b;for(const I of P){if(typeof g!="object"||g===null)return;g=g[I]}return g}const l=a.split("."),m=c(p,l);return typeof m=="undefined"?r:m}e.getConfigurationValue=D;function y(p,a,r){Object.keys(a).forEach(c=>{c!=="__proto__"&&(c in p?M.isObject(p[c])&&M.isObject(a[c])?y(p[c],a[c],r):r&&(p[c]=a[c]):p[c]=a[c])})}e.merge=y;function o(){const p=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(p)}e.getConfigurationKeys=o;function h(){const p=Object.create(null),a=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let c=a[r].default;s(p,r,c,l=>console.error(`Conflict in default settings: ${l}`))}return p}e.getDefaultValues=h;function C(p){return`[${p}]`}e.keyFromOverrideIdentifier=C;function i(p,a,r){const c=p.inspect(a),l=p.inspect(r);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=i}),define(be[147],Ee([0,1,13,3,102,6,20,23,10,2,85,62,28]),function(se,e,d,M,E,A,F,k,S,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(i={},p=[],a=[]){this._contents=i,this._keys=p,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,p){const a=this.getContentsForOverrideIdentifer(p);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const p of this.overrides)if(p.identifiers.indexOf(i)!==-1)return p.keys;return[]}override(i){let p=this.overrideConfigurations.get(i);return p||(p=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,p)),p}merge(...i){const p=k.deepClone(this.contents),a=k.deepClone(this.overrides),r=[...this.keys];for(const c of i){this.mergeContents(p,c.contents);for(const l of c.overrides){const[m]=a.filter(b=>d.equals(b.identifiers,l.identifiers));m?this.mergeContents(m.contents,l.contents):a.push(k.deepClone(l))}for(const l of c.keys)r.indexOf(l)===-1&&r.push(l)}return new f(p,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const p=this.getContentsForOverrideIdentifer(i);if(!p||typeof p!="object"||!Object.keys(p).length)return this;let a={};for(const r of d.distinct([...Object.keys(this.contents),...Object.keys(p)])){let c=this.contents[r],l=p[r];l&&(typeof c=="object"&&typeof l=="object"?(c=k.deepClone(c),this.mergeContents(c,l)):c=l),a[r]=c}return new f(a,this.keys,this.overrides)}mergeContents(i,p){for(const a of Object.keys(p)){if(a in i&&S.isObject(i[a])&&S.isObject(p[a])){this.mergeContents(i[a],p[a]);continue}i[a]=k.deepClone(p[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const p of this.overrides)if(p.identifiers.indexOf(i)!==-1)return p.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,p){this.addKey(i),(0,t.addToValueTree)(this.contents,i,p,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let p=this.keys.length;for(let a=0;a<p;a++)i.indexOf(this.keys[a])===0&&(p=a);this.keys.splice(p,1,i)}removeKey(i){let p=this.keys.indexOf(i);return p!==-1?(this.keys.splice(p,1),!0):!1}}e.ConfigurationModel=f;class s extends f{constructor(){const i=(0,t.getDefaultValues)(),p=(0,t.getConfigurationKeys)(),a=[];for(const r of Object.keys(i))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,_.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],c=>console.error(`Conflict in default settings file: ${c}`))});super(i,p,a)}}e.DefaultConfigurationModel=s;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,p){if(!S.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,p)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,p){this._raw=i;const{contents:a,keys:r,overrides:c,restricted:l}=this.doParseRaw(i,p);this._configurationModel=new f(a,r,c),this._restrictedConfigurations=l||[]}doParseContent(i){let p={},a=null,r=[],c=[],l=[];function m(P){Array.isArray(r)?r.push(P):a!==null&&(r[a]=P)}let b={onObjectBegin:()=>{let P={};m(P),c.push(r),r=P,a=null},onObjectProperty:P=>{a=P},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{let P=[];m(P),c.push(r),r=P,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:m,onError:(P,g,I)=>{l.push({error:P,offset:g,length:I})}};if(i)try{E.visit(i,b),p=r[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return p}doParseRaw(i,p){const a=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,p);i=r.raw;const c=(0,t.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(i),m=(0,t.toOverrides)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:c,keys:l,overrides:m,restricted:r.restricted}}filter(i,p,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const c={},l=[];for(let m in i)if(_.OVERRIDE_PROPERTY_PATTERN.test(m)&&a){const b=this.filter(i[m],p,!1,r);c[m]=b.raw,l.push(...b.restricted)}else{const b=p[m],P=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(m),(P===void 0||r.scopes===void 0||r.scopes.includes(P))&&(r.skipRestricted&&b?.restricted||(c[m]=i[m]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=u;class v extends A.Disposable{constructor(i,p,a,r){super();this.userSettingsResource=i,this.scopes=p,this.fileService=r,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class D{constructor(i,p,a=new f,r=new f,c=new F.ResourceMap,l=new f,m=new F.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=p,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=m,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,p,a){return this.getConsolidateConfigurationModel(p,a).getValue(i)}updateValue(i,p,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new f,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,p===void 0?r.removeValue(i):r.setValue(i,p),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,p,a){const r=this.getConsolidateConfigurationModel(p,a),c=this.getFolderConfigurationModelForResource(p.resource,a),l=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,m=p.overrideIdentifier?this._defaultConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=p.overrideIdentifier?this.userConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),P=p.overrideIdentifier?this.localUserConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=p.overrideIdentifier?this.remoteUserConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),I=a?p.overrideIdentifier?this._workspaceConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,R=c?p.overrideIdentifier?c.freeze().override(p.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,L=p.overrideIdentifier?l.override(p.overrideIdentifier).getValue(i):l.getValue(i),w=r.getValue(i),x=d.distinct(d.flatten(r.overrides.map($=>$.identifiers))).filter($=>r.getOverrideValue(i,$)!==void 0);return{defaultValue:m,userValue:b,userLocalValue:P,userRemoteValue:g,workspaceValue:I,workspaceFolderValue:R,memoryValue:L,value:w,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:c?.freeze().getValue(i),override:p.overrideIdentifier?c?.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:l.getValue(i),override:p.overrideIdentifier?l.getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(i){const p=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:p?p.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,p){this._folderConfigurations.set(i,p),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,p){const a=p.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const c=(0,_.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=i.getKeysForOverrideIdentifier(c),b=[...m.filter(P=>l.indexOf(P)===-1),...l.filter(P=>m.indexOf(P)===-1),...l.filter(P=>!k.equals(this._defaultConfiguration.override(c).getValue(P),i.override(c).getValue(P)))];return[c,b]});return this.updateDefaultConfiguration(i),{keys:p,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:p,updated:a,removed:r,overrides:c}=(0,t.compare)(this.localUserConfiguration,i),l=[...p,...a,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:p,updated:a,removed:r,overrides:c}=(0,t.compare)(this.remoteUserConfiguration,i);let l=[...p,...a,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:p,updated:a,removed:r,overrides:c}=(0,t.compare)(this.workspaceConfiguration,i);let l=[...p,...a,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(i,p){const a=this.folderConfigurations.get(i),{added:r,updated:c,removed:l,overrides:m}=(0,t.compare)(a,p);let b=[...r,...c,...l];return(b.length||!a)&&this.updateFolderConfiguration(i,p),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(i){const p=this.folderConfigurations.get(i);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:c,overrides:l}=(0,t.compare)(p,void 0);return{keys:[...a,...r,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,p){let a=this.getConsolidatedConfigurationModelForResource(i,p);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},p){let a=this.getWorkspaceConsolidatedConfiguration();if(p&&i){const r=p.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const c=this._memoryConfigurationByResource.get(i);c&&(a=a.merge(c))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let p=this._foldersConsolidatedConfigurations.get(i);if(!p){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(p=a.merge(r),this._freeze&&(p=p.freeze()),this._foldersConsolidatedConfigurations.set(i,p)):p=a}return p}getFolderConfigurationModelForResource(i,p){if(p&&i){const a=p.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,p)=>{const{contents:a,overrides:r,keys:c}=this._folderConfigurations.get(p);return i.push([p,{contents:a,overrides:r,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(p=>i.add(p)),this.userConfiguration.freeze().keys.forEach(p=>i.add(p)),this._workspaceConfiguration.freeze().keys.forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>p.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>p.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>p.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>p.add(r))),[...p.values()]}static parse(i){const p=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((l,m)=>(l.set(T.URI.revive(m[0]),this.parseConfigurationModel(m[1])),l),new F.ResourceMap);return new D(p,a,new f,r,c,new f,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new f(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=D;function y(...C){if(C.length===0)return{keys:[],overrides:[]};if(C.length===1)return C[0];const i=new Set,p=new Map;for(const r of C)r.keys.forEach(c=>i.add(c)),r.overrides.forEach(([c,l])=>{const m=(0,F.getOrSet)(p,c,new Set);l.forEach(b=>m.add(b))});const a=[];return p.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=y;class o{constructor(i,p,a,r){this.change=i,this.previous=p,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(m=>c.add(m)),i.overrides.forEach(([,m])=>m.forEach(b=>c.add(b))),this.affectedKeys=[...c.values()];const l=new f;this.affectedKeys.forEach(m=>l.setValue(m,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,p){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(p){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,p,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,p,this.currentWorkspace);return!k.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,p){let a=(0,t.toValuesTree)({[p]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=o;class h extends o{constructor(i,p,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,p);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=h}),define(be[86],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,k=M.Unknown,S){super(F);this._message=F,this._code=k,this._detail=S,this.isHandled=k===M.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[63],Ee([0,1,11]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function E(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=E;function A(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function F(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=F;function k(T){return F(T)?.scheme}e.getVirtualWorkspaceScheme=k;function S(T){return F(T)!==void 0}e.isVirtualWorkspace=S}),define(be[26],Ee([0,1,9,4,63]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f=="undefined"||f===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){let u=typeof f=="string"?f:f.value,v=typeof s=="string"?s:s.value;return d.equalsIgnoreCase(u,v)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=S;function T(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function t(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function _(n,f){if(f&&n.enableProposedApi){const s=`onResolveRemoteAuthority:${(0,E.getRemoteName)(f)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[148],Ee([0,1,9,26]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(s,u){return s.uuid&&u.uuid?s.uuid===u.uuid:s.id===u.id?!0:(0,d.compareIgnoreCase)(s.id,u.id)===0}e.areSameExtensions=E;class A{constructor(u,v){this.version=v,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof A?E(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(s,u){return`${s}.${u}`}e.getExtensionId=F;function k(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(s,u){return k(F(s,u))}e.getGalleryExtensionId=S;function T(s,u){const v=[],D=y=>{for(const o of v)if(o.some(h=>E(u(h),u(y))))return o;return null};for(const y of s){const o=D(y);o?o.push(y):v.push([y])}return v}e.groupByExtension=T;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const u=new Set;for(const v of s)v.malicious&&u.add(v.id.id);return u}e.getMaliciousExtensionsSet=n;function f(s,u){const v=[],D=u.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const y=D.shift();if(y&&v.every(o=>!E(o.identifier,{id:y}))){const o=s.filter(h=>E(h.identifier,{id:y}));o.length===1&&(v.push(o[0]),D.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=f}),define(be[149],Ee([0,1,3,25,4,15]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService");var F;(function(s){s.Http="http",s.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=_;function n(s,u){return u?u!==1&&s<1024:!M.isWindows&&s<1024}e.isPortPrivileged=n;let f=class{constructor(u){this.logService=u,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,v){return this._tunnelProvider=u,u?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async u=>{const v=[],D=Array.from(this._tunnels.values());for(let y of D){const o=Array.from(y.values());for(let h of o){const C=await h.value;C&&v.push(C)}}u(v)})}async dispose(){for(const u of this._tunnels.values()){for(const{value:v}of u.values())await v.then(D=>D?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,v,D,y,o=!1,h=k.Private,C){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${D} on local port ${y}.`),!u)return;v||(v="localhost");const i=this.retainOrCreateTunnel(u,v,D,y,o,h,C);return i?i.then(p=>{if(!p){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(p);return(p.tunnelRemoteHost!==v||p.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const v=this._tunnels.get(u.tunnelRemoteHost);if(v){const D=v.get(u.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,D))}}}}async tryDisposeTunnel(u,v,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${v}.`);const y=D.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(v),y}}async closeTunnel(u,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${v} `);const D=this._tunnels.get(u);if(D&&D.has(v)){const y=D.get(v);y.refcount=0,await this.tryDisposeTunnel(u,v,y)}}addTunnelToMap(u,v,D){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(v,{refcount:1,value:D})}async removeEmptyTunnelFromMap(u,v){const D=this._tunnels.get(u);D&&(await D.get(v)||D.delete(v),D.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,v){let D=[u];t(u)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(u)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const y=D.map(o=>this._tunnels.get(o));for(const o of y){const h=o?.get(v);if(h)return h}}canTunnel(u){return!!T(u)}createWithProvider(u,v,D,y,o,h,C){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${D} on local port ${y}.`);const p={elevationRequired:o?n(y===void 0?D:y):!1},a={remoteAddress:{host:v,port:D},localAddressPort:y,privacy:h,public:h!==k.Private,protocol:C},r=u.forwardPort(a,p);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(v,D,r),r}};f=$e([ze(0,A.ILogService)],f),e.AbstractTunnelService=f}),define(be[150],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,F=5){let k;return k=A(S=>{const T=typeof S=="string"?S:S.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(T);return}const _=setTimeout(()=>this.flushBuffer(E),F);t={data:[T],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),k.dispose()}},this._terminalBufferMap.set(E,t)}),k}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=d}),define(be[151],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[47],Ee([0,1,34,3,6,4,28,151]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(v){function D(y){return y&&typeof y=="object"&&typeof y.id=="string"}v.isThemeColor=D})(S=e.ThemeColor||(e.ThemeColor={}));function T(v){return{id:v}}e.themeColorFromId=T;var t;(function(v){function D(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color=="undefined"||S.isThemeColor(p.color))}v.isThemeIcon=D;const y=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(p){const a=y.exec(p);if(!a)return;let[,r]=a;return{id:r}}v.fromString=o;function h(p,a){let r=p.id;const c=r.lastIndexOf("~");return c!==-1&&(r=r.substring(0,c)),a&&(r=`${r}~${a}`),{id:r}}v.modify=h;function C(p,a){return p.id===a.id&&p.color?.id===a.color?.id}v.isEqual=C;function i(p,a){return{id:p.id,color:a?T(a):void 0}}v.asThemeIcon=i,v.asClassNameArray=d.CSSIcon.asClassNameArray,v.asClassName=d.CSSIcon.asClassName,v.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function _(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,E.toDisposable)(()=>{const y=this.themingParticipants.indexOf(D);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;F.Registry.add(e.Extensions.ThemingContribution,f);function s(v){return f.onColorThemeChange(v)}e.registerThemingParticipant=s;class u extends E.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,y){let o=this.theme.getColor(D);return o&&y&&(o=y(o,this.theme)),o?o.toString():null}}e.Themable=u}),define(be[152],Ee([0,1,14,34,3,123,84,28,47]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(D,y,o,h){const C=this.iconsById[D];if(C){if(o&&!C.description){C.description=o,this.iconSchema.properties[D].markdownDescription=`${o} $(${D})`;const a=this.iconReferenceSchema.enum.indexOf(D);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return C}let i={id:D,description:o,defaults:y,deprecationMessage:h};this.iconsById[D]=i;let p={$ref:"#/definitions/icons"};return h&&(p.deprecationMessage=h),o&&(p.markdownDescription=`${o}: $(${D})`),this.iconSchema.properties[D]=p,this.iconReferenceSchema.enum.push(D),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:D}}deregisterIcon(D){delete this.iconsById[D],delete this.iconSchema.properties[D];const y=this.iconReferenceSchema.enum.indexOf(D);y!==-1&&(this.iconReferenceSchema.enum.splice(y,1),this.iconReferenceSchema.enumDescriptions.splice(y,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(D=>this.iconsById[D])}getIcon(D){return this.iconsById[D]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(D,y){const o=this.iconFontsById[D];if(o)return o;let h={id:D,definition:y};return this.iconFontsById[D]=h,this._onDidChange.fire(),h}deregisterIconFont(D){delete this.iconFontsById[D]}getIconFonts(){return Object.keys(this.iconFontsById).map(D=>this.iconFontsById[D])}getIconFont(D){return this.iconFontsById[D]}toString(){const D=(C,i)=>C.id.localeCompare(i.id),y=C=>{for(;S.ThemeIcon.isThemeIcon(C.defaults);)C=this.iconsById[C.defaults.id];return`codicon codicon-${C?C.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(C=>this.iconsById[C]);for(const C of h.filter(i=>!!i.description).sort(D))o.push(`|<i class="${y(C)}"></i>|${C.id}|${S.ThemeIcon.isThemeIcon(C.defaults)?C.defaults.id:C.id}|${C.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const C of h.filter(i=>!S.ThemeIcon.isThemeIcon(i.defaults)).sort(D))o.push(`|<i class="${y(C)}"></i>|${C.id}|`);return o.join(`
`)}}const t=new T;k.Registry.add(e.Extensions.IconContribution,t);function _(v,D,y,o){return t.registerIcon(v,D,y,o)}e.registerIcon=_;function n(){return t}e.getIconRegistry=n;function f(){for(const v of M.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);M.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let s=k.Registry.as(F.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const u=new d.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=S.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[48],Ee([0,1,20,24,2,4]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function k(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=k;function S(n){const f=n;return!!(f&&typeof f=="object"&&E.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class T{constructor(f,s,u,v,D){this._id=f,this._transient=u,this._configuration=v,this._ignorePathCasing=D,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class t{constructor(f,s){this.raw=s,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(be[64],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,14]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,k,S){this._deferredPromises=new Map,this._id=F,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const _ of T.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,k){let S=this._value[F];return typeof S=="undefined"&&(S=k),S}update(F,k){this._value[F]=k;let S=this._deferredPromises.get(F);if(S!==void 0)return S.p;const T=new d.DeferredPromise;return this._deferredPromises.set(F,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,k){super(F.identifier.value,!0,k);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(be[154],Ee([0,1,3,2,15]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptModelChanged(S.value,T)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));T.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=$e([ze(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[155],Ee([0,1,26,3]),function(se,e,d,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,S){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(k.identifier),et(this,E,S,"f"),Ae(this,E,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(k){return Ae(this,E,"f").get(this._id,k)}store(k,S){return Ae(this,E,"f").store(this._id,k,S)}delete(k){return Ae(this,E,"f").delete(this._id,k)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[49],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(y,o)=>{const h={controllerId:o};return M.set(y,h),h};e.createPrivateApiFor=E;const A=y=>M.get(y);e.getPrivateApiFor=A;const F=(y,o,h,C)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(p){if(!C(i,p)){const a=i;i=p,y.listener?.({op:3,key:o,value:p,previous:a})}}}},k=(y,o)=>y===o,S={range:(y,o)=>y===o?!0:!y||!o?!1:y.isEqual(o),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(y,o)=>!(y.length!==o.length||y.some(h=>!o.find(C=>h.id===C.id)))},T=Object.keys(S),t=(y,o)=>({range:F(y,"range",void 0,S.range),label:F(y,"label",o,S.label),description:F(y,"description",void 0,S.description),canResolveChildren:F(y,"canResolveChildren",!1,S.canResolveChildren),busy:F(y,"busy",!1,S.busy),error:F(y,"error",void 0,S.error),tags:F(y,"tags",[],S.tags)}),_=(y,o)=>{const h=new Map;for(const C of T)S[C](y[C],o[C])||h.set(C,o[C]);return h};e.diffTestItems=_;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class s extends Error{constructor(o,h,C){super(`TestItem with ID "${o}" is from controller "${h}" and cannot be added as a child of an item from controller "${C}".`)}}e.MixedTestItemController=s;const u=y=>{const o=(0,e.getPrivateApiFor)(y);let h=new Map;return{get size(){return h.size},forEach(C,i){for(const p of h.values())C.call(i,p,this)},replace(C){const i=new Map,p=new Set(h.keys()),a={op:4,ops:[]};for(const r of C){if(!(r instanceof v))throw new f(r.id);const c=(0,e.getPrivateApiFor)(r).controllerId;if(c!==o.controllerId)throw new s(r.id,c,o.controllerId);if(i.has(r.id))throw new n(r.id);i.set(r.id,r),p.delete(r.id),a.ops.push({op:0,item:r})}for(const r of p.keys())a.ops.push({op:1,id:r});o.listener?.(a),h=i},add(C){if(!(C instanceof v))throw new f(C.id);h.set(C.id,C),o.listener?.({op:0,item:C})},delete(C){h.delete(C)&&o.listener?.({op:1,id:C})},get(C){return h.get(C)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class v{constructor(o,h,C,i){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const p=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return p.parent instanceof D?void 0:p.parent}},children:{value:u(this),enumerable:!0,writable:!1},...t(p,C)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class D extends v{constructor(o,h){super(o,o,h,void 0)}}e.TestItemRootImpl=D}),define(be[65],Ee([0,1,4,149,3,12]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(S){function T(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}S.fromApiTunnel=T;function t(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}S.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let k=class{constructor(T){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,t){return{dispose:()=>{}}}async $providePortAttributes(T,t,_,n,f){return[]}async $forwardPort(T,t){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([ze(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[7],Ee([0,1,13,16,77,20,79,10,2,36,60,86]),function(se,e,d,M,E,A,F,k,S,T,t,_){"use strict";var n,f,s,u,v,D,y,o,h,C,i,p,a,r,c,l,m,b,P,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let R=v=class{constructor(O){n.set(this,void 0),et(this,n,O,"f")}static from(...O){let re=O;return new v(function(){if(re){for(const _e of re)_e&&typeof _e.dispose=="function"&&_e.dispose();re=void 0}})}dispose(){typeof Ae(this,n,"f")=="function"&&(Ae(this,n,"f").call(this),et(this,n,void 0,"f"))}};n=new WeakMap,R=v=$e([I],R),e.Disposable=R;let L=D=class{constructor(O,re){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(re<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=re}static Min(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let _e=1;_e<O.length;_e++){const qe=O[_e];qe.isBefore(re)&&(re=qe)}return re}static Max(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let _e=1;_e<O.length;_e++){const qe=O[_e];qe.isAfter(re)&&(re=qe)}return re}static isPosition(O){if(!O)return!1;if(O instanceof D)return!0;let{line:re,character:_e}=O;return typeof re=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,re=0){if(O===null||re===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,re=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&re===0?this:new D(this.line+_e,this.character+re)}with(O,re=this.character){if(O===null||re===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,re=typeof O.character=="number"?O.character:this.character),_e===this.line&&re===this.character?this:new D(_e,re)}toJSON(){return{line:this.line,character:this.character}}};L=D=$e([I],L),e.Position=L;let w=y=class{constructor(O,re,_e,qe){let nt,at;if(typeof O=="number"&&typeof re=="number"&&typeof _e=="number"&&typeof qe=="number"?(nt=new L(O,re),at=new L(_e,qe)):O instanceof L&&re instanceof L&&(nt=O,at=re),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof y?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof y?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const re=L.Max(O.start,this._start),_e=L.Min(O.end,this._end);if(!re.isAfter(_e))return new y(re,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const re=L.Min(O.start,this._start),_e=L.Max(O.end,this.end);return new y(re,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,re=this.end){if(O===null||re===null)throw(0,M.illegalArgument)();let _e;return O?L.isPosition(O)?_e=O:(_e=O.start||this.start,re=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&re.isEqual(this.end)?this:new y(_e,re)}toJSON(){return[this.start,this.end]}};w=y=$e([I],w),e.Range=w;let x=o=class extends w{constructor(O,re,_e,qe){let nt,at;if(typeof O=="number"&&typeof re=="number"&&typeof _e=="number"&&typeof qe=="number"?(nt=new L(O,re),at=new L(_e,qe)):O instanceof L&&re instanceof L&&(nt=O,at=re),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof o?!0:O?w.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=o=$e([I],x),e.Selection=x;class ${constructor(O,re,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(re),this.connectionToken=_e}}e.ResolvedAuthority=$;class B extends Error{constructor(O,re=_.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=re,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(O,re){return new B(O,_.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(O){return new B(O,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var H;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=h=class{constructor(O,re){this._range=O,this._newText=re}static isTextEdit(O){return O instanceof h?!0:O?w.isRange(O)&&typeof O.newText=="string":!1}static replace(O,re){return new h(O,re)}static insert(O,re){return h.replace(new w(O,O),re)}static delete(O){return h.replace(O,"")}static setEndOfLine(O){const re=new h(new w(new L(0,0),new L(0,0)),"");return re.newEol=O,re}get range(){return this._range}set range(O){if(O&&!w.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=h=$e([I],W),e.TextEdit=W;var ne;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(ne=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,re,_e,qe){this._edits.push({_type:1,from:O,to:re,options:_e,metadata:qe})}createFile(O,re,_e){this._edits.push({_type:1,from:void 0,to:O,options:re,metadata:_e})}deleteFile(O,re,_e){this._edits.push({_type:1,from:O,to:void 0,options:re,metadata:_e})}replaceNotebookMetadata(O,re,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(O,re,_e,qe,nt){let at,ct,Ct=[],At;if(zt.isNotebookRange(re)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(qe)?(at=re.start,ct=re.end,Ct=_e,At=qe):typeof re=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(qe)&&(at=re,ct=_e,Ct=qe,At=nt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ct-at,cells:Ct,metadata:At})}replaceNotebookCellMetadata(O,re,_e,qe){this._edits.push({_type:3,metadata:qe,uri:O,edit:{editType:8,index:re,metadata:_e}})}replace(O,re,_e,qe){this._edits.push({_type:2,uri:O,edit:new W(re,_e),metadata:qe})}insert(O,re,_e,qe){this.replace(O,new w(re,re),_e,qe)}delete(O,re,_e){this.replace(O,re,"",_e)}has(O){return this._edits.some(re=>re._type===2&&re.uri.toString()===O.toString())}set(O,re){if(re)for(const _e of re)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const qe=this._edits[_e];qe._type===2&&qe.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const re=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&re.push(_e.edit);return re}entries(){const O=new A.ResourceMap;for(let re of this._edits)if(re._type===2){let _e=O.get(re.uri);_e||(_e=[re.uri,[]],O.set(re.uri,_e)),_e[1].push(re.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=$e([I],V),e.WorkspaceEdit=V;let X=C=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof C?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=C._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,re=this._tabstop++){if(typeof O=="function"){const _e=new C;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=C._escape(O);return this.value+="${",this.value+=re,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,re=this._tabstop++){const _e=O.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,re){if(typeof re=="function"){const _e=new C;_e._tabstop=this._tabstop,re(_e),this._tabstop=_e._tabstop,re=_e.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,re&&(this.value+=":",this.value+=re),this.value+="}",this}};X=C=$e([I],X),e.SnippetString=X;var q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let te=i=class{constructor(O,re){if(this.uri=O,re)if(re instanceof w)this.range=re;else if(re instanceof L)this.range=new w(re,re);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?w.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};te=i=$e([I],te),e.Location=te;let ve=class{constructor(O,re){this.location=O,this.message=re}static is(O){return O?typeof O.message=="string"&&O.location&&w.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.location.range.isEqual(re.location.range)&&O.location.uri.toString()===re.location.uri.toString()}};ve=$e([I],ve),e.DiagnosticRelatedInformation=ve;let Re=class{constructor(O,re,_e=le.Error){if(!w.isRange(O))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=O,this.message=re,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.severity===re.severity&&O.code===re.code&&O.severity===re.severity&&O.source===re.source&&O.range.isEqual(re.range)&&(0,d.equals)(O.tags,re.tags)&&(0,d.equals)(O.relatedInformation,re.relatedInformation,ve.isEqual)}};Re=$e([I],Re),e.Diagnostic=Re;let Fe=class{constructor(O,re){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=re}};Fe=$e([I],Fe),e.Hover=Fe;var Oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ke=class{constructor(O,re=Oe.Text){this.range=O,this.kind=re}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Ke=$e([I],Ke),e.DocumentHighlight=Ke;var je;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var Ve;(function(N){N[N.Deprecated=1]="Deprecated"})(Ve=e.SymbolTag||(e.SymbolTag={}));let U=p=class{constructor(O,re,_e,qe,nt){this.name=O,this.kind=re,this.containerName=nt,typeof _e=="string"&&(this.containerName=_e),qe instanceof te?this.location=qe:_e instanceof w&&(this.location=new te(qe,_e)),p.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};U=p=$e([I],U),e.SymbolInformation=U;let Q=a=class{constructor(O,re,_e,qe,nt){this.name=O,this.detail=re,this.kind=_e,this.range=qe,this.selectionRange=nt,this.children=[],a.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(a.validate)}};Q=a=$e([I],Q),e.DocumentSymbol=Q;var ie;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,re){this.title=O,this.kind=re}};ae=$e([I],ae),e.CodeAction=ae;let G=r=class{constructor(O){this.value=O}append(O){return new r(this.value?this.value+r.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+r.sep)}};G.sep=".",G=r=$e([I],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let oe=class{constructor(O,re){if(this.range=O,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=$e([I],oe),e.SelectionRange=oe;class he{constructor(O,re,_e,qe,nt,at){this.kind=O,this.name=re,this.detail=_e,this.uri=qe,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=he;class Te{constructor(O,re){this.fromRanges=re,this.from=O}}e.CallHierarchyIncomingCall=Te;class Be{constructor(O,re){this.fromRanges=re,this.to=O}}e.CallHierarchyOutgoingCall=Be;var He;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,re){this.range=O,this.command=re}get isResolved(){return!!this.command}};Qe=$e([I],Qe),e.CodeLens=Qe;let it=c=class{constructor(O,re=!1){f.set(this,void 0),et(this,f,new E.MarkdownString(O,{supportThemeIcons:re}),"f")}static isMarkdownString(O){return O instanceof c?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,f,"f").value}set value(O){Ae(this,f,"f").value=O}get isTrusted(){return Ae(this,f,"f").isTrusted}set isTrusted(O){Ae(this,f,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,f,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,f,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,f,"f").supportHtml}set supportHtml(O){Ae(this,f,"f").supportHtml=O}appendText(O){return Ae(this,f,"f").appendText(O),this}appendMarkdown(O){return Ae(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,re){return Ae(this,f,"f").appendCodeblock(re??"",O),this}};f=new WeakMap,it=c=$e([I],it),e.MarkdownString=it;let Ce=class{constructor(O,re){this.label=O,this.documentation=re}};Ce=$e([I],Ce),e.ParameterInformation=Ce;let Ze=class{constructor(O,re){this.label=O,this.documentation=re,this.parameters=[]}};Ze=$e([I],Ze),e.SignatureInformation=Ze;let j=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};j=$e([I],j),e.SignatureHelp=j;var J;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(O,re,_e){this.text=O,this.position=re,this.kind=_e}};We=$e([I],We),e.InlayHint=We;var Ye;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var st;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(st=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(N){N[N.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let Et=class{constructor(O,re){this.label=O,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Et=$e([I],Et),e.CompletionItem=Et;let mt=class{constructor(O=[],re=!1){this.items=O,this.isIncomplete=re}};mt=$e([I],mt),e.CompletionList=mt;let Dt=class{constructor(O,re,_e){this.text=O,this.range=re,this.command=_e}};Dt=$e([I],Dt),e.InlineSuggestion=Dt;let Pt=class{constructor(O){this.items=O}};Pt=$e([I],Pt),e.InlineSuggestions=Pt;var It;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(It=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ee;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ee=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(re){switch(re){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,re){if(re&&!S.URI.isUri(re))throw(0,M.illegalArgument)("target");if(!w.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=re}};ge=$e([I],ge),e.DocumentLink=ge;let fe=class{constructor(O,re,_e,qe){this.red=O,this.green=re,this.blue=_e,this.alpha=qe}};fe=$e([I],fe),e.Color=fe;let Ie=class{constructor(O,re){if(re&&!(re instanceof fe))throw(0,M.illegalArgument)("color");if(!w.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=re}};Ie=$e([I],Ie),e.ColorInformation=Ie;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=$e([I],xe),e.ColorPresentation=xe;var Ne;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Ne=e.ColorFormat||(e.ColorFormat={}));var Ge;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ge=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class tt{constructor(O,re,_e){if(this.startIndex=O,this.length=re,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=tt;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var pe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let z=l=class{constructor(O,re){if(this.label=re,typeof O!="string"||typeof re!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};z.Clean=new l("clean","Clean"),z.Build=new l("build","Build"),z.Rebuild=new l("rebuild","Rebuild"),z.Test=new l("test","Test"),z=l=$e([I],z),e.TaskGroup=z;function we(N){let O="";for(let re=0;re<N.length;re++)O+=N[re].replace(/,/g,",,")+",";return O}let ke=class{constructor(O,re,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=_e):this._options=re)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let re of this._args)O.push(re);return we(O)}};ke=$e([I],ke),e.ProcessExecution=ke;let Je=class{constructor(O,re,_e){if(this._args=[],Array.isArray(re)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=re,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=re}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)O.push(typeof re=="string"?re:re.value);return we(O)}};Je=$e([I],Je),e.ShellExecution=Je;var Ue;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ue=e.ShellQuoting||(e.ShellQuoting={}));var dt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(dt=e.TaskScope||(e.TaskScope={}));class gt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=gt;let lt=m=class{constructor(O,re,_e,qe,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof re=="string"?(this._name=this.name=re,this._source=this.source=_e,this.execution=qe,ct=nt,this.__deprecated=!0):re===dt.Global||re===dt.Workspace?(this.target=re,this._name=this.name=_e,this._source=this.source=qe,this.execution=nt,ct=at):(this.target=re,this._name=this.name=_e,this._source=this.source=qe,this.execution=nt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ke?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const re=this._definition.type;(m.EmptyType===re||m.ProcessType===re||m.ShellType===re||m.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=m=$e([I],lt),e.Task=lt;var ft;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,re=pt.None){this.collapsibleState=re,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=$e([I],ut),e.TreeItem=ut;var pt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let bt=class{constructor(O,re){this.id=O,this.color=re}};bt=$e([I],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Ut=class{constructor(O){this.id=O}};Ut=$e([I],Ut),e.ThemeColor=Ut;var Vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let yt=class{constructor(O,re){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof re!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=re}};yt=$e([I],yt),e.RelativePattern=yt;let $t=class{constructor(O,re,_e,qe){this.enabled=typeof O=="boolean"?O:!0,typeof re=="string"&&(this.condition=re),typeof _e=="string"&&(this.hitCondition=_e),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};$t=$e([I],$t),e.Breakpoint=$t;let ei=class extends $t{constructor(O,re,_e,qe,nt){super(re,_e,qe,nt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=$e([I],ei),e.SourceBreakpoint=ei;let vt=class extends $t{constructor(O,re,_e,qe,nt){super(re,_e,qe,nt);this.functionName=O}};vt=$e([I],vt),e.FunctionBreakpoint=vt;let Qt=class extends $t{constructor(O,re,_e,qe,nt,at,ct){super(qe,nt,at,ct);if(!re)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=re,this.canPersist=_e}};Qt=$e([I],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,re,_e){this.command=O,this.args=re||[],this.options=_e}};jt=$e([I],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,re){this.port=O,this.host=re}};ti=$e([I],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=$e([I],ii),e.DebugAdapterNamedPipeServer=ii;let Tt=class{constructor(O){this.implementation=O}};Tt=$e([I],Tt),e.DebugAdapterInlineImplementation=Tt;let Yt=class{constructor(O,re){this.range=O,this.expression=re}};Yt=$e([I],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,re){this.range=O,this.text=re}};Wt=$e([I],Wt),e.InlineValueText=Wt;let Ht=class{constructor(O,re,_e=!0){this.range=O,this.variableName=re,this.caseSensitiveLookup=_e}};Ht=$e([I],Ht),e.InlineValueVariableLookup=Ht;let ht=class{constructor(O,re){this.range=O,this.expression=re}};ht=$e([I],ht),e.InlineValueEvaluatableExpression=ht;let ni=class{constructor(O,re){this.frameId=O,this.stoppedLocation=re}};ni=$e([I],ni),e.InlineValueContext=ni;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=b=class extends Error{constructor(O,re=t.FileSystemProviderErrorCode.Unknown,_e){super(S.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new b(O,t.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(O){return new b(O,t.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(O){return new b(O,t.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(O){return new b(O,t.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(O){return new b(O,t.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(O){return new b(O,t.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Nt=b=$e([I],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,re,_e){this.start=O,this.end=re,this.kind=_e}};Jt=$e([I],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,re=[]){this.tokenTypes=O,this.tokenModifiers=re}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,k.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let re=0,_e=O.tokenTypes.length;re<_e;re++)this._tokenTypeStrToInt.set(O.tokenTypes[re],re);for(let re=0,_e=O.tokenModifiers.length;re<_e;re++)this._tokenModifierStrToInt.set(O.tokenModifiers[re],re)}}push(O,re,_e,qe,nt){if(typeof O=="number"&&typeof re=="number"&&typeof _e=="number"&&typeof qe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,re,_e,qe,nt);if(w.isRange(O)&&typeof re=="string"&&ri(_e))return this._push(O,re,_e);throw(0,M.illegalArgument)()}_push(O,re,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const qe=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(re);let Ct=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);Ct|=1<<Ft>>>0}this._pushEncoded(qe,nt,at,ct,Ct)}_pushEncoded(O,re,_e,qe,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<Ct;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let at=O,ct=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=re}static _sortAndDeltaEncode(O){let re=[];const _e=O.length/5|0;for(let ct=0;ct<_e;ct++)re[ct]=ct;re.sort((ct,Ct)=>{const At=O[5*ct],Ft=O[5*Ct];if(At===Ft){const Lt=O[5*ct+1],xt=O[5*Ct+1];return Lt-xt}return At-Ft});const qe=new Uint32Array(O.length);let nt=0,at=0;for(let ct=0;ct<_e;ct++){const Ct=5*re[ct],At=O[Ct+0],Ft=O[Ct+1],Lt=O[Ct+2],xt=O[Ct+3],ci=O[Ct+4],xi=At-nt,qi=xi===0?Ft-at:Ft,di=5*ct;qe[di+0]=xi,qe[di+1]=qi,qe[di+2]=Lt,qe[di+3]=xt,qe[di+4]=ci,nt=At,at=Ft}return qe}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,re){this.resultId=re,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,re,_e){this.start=O,this.deleteCount=re,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,re){this.resultId=re,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new bt("arrow-left")},Xt=$e([I],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,re,_e){this.badge=O,this.tooltip=re,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=$e([I],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,re){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(re<0)throw(0,M.illegalArgument)("end must be positive");O<=re?(this._start=O,this._end=re):(this._start=re,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let re=this._start,_e=this._end;return O.start!==void 0&&(re=O.start),O.end!==void 0&&(_e=O.end),re===this._start&&_e===this._end?this:new zt(re,_e)}}e.NotebookRange=zt;class Mt{constructor(O,re,_e,qe,nt,at,ct){this.kind=O,this.value=re,this.languageId=_e,this.mime=qe,this.outputs=nt??[],this.metadata=at,this.executionSummary=ct,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(re=>Mt.isNotebookCellData(re))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Me{constructor(O){this.cells=O}}e.NotebookData=Me;class Rt{constructor(O,re){this.data=O,this.mime=re;const _e=(0,F.normalizeMimeType)(re,!0);if(!_e)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const re={name:O.name,message:O.message,stack:O.stack};return Rt.json(re,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,re="application/octet-stream"){return new Rt(O,re)}static text(O,re=F.Mimes.text){const _e=Ae(Rt,s,"f",u).encode(String(O));return new Rt(_e,re)}static json(O,re="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,re)}}e.NotebookCellOutputItem=Rt,s=Rt,u={value:new TextEncoder};class Kt{constructor(O,re,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof re=="string"?(this.id=re,this.metadata=_e):(this.id=(0,T.generateUuid)(),this.metadata=re??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,k.isArray)(O.items)}static ensureUniqueMimeTypes(O,re=!1){const _e=new Set,qe=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],ct=(0,F.normalizeMimeType)(at.mime);if(!_e.has(ct)){_e.add(ct);continue}qe.add(nt),re&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?O:O.filter((nt,at)=>!qe.has(at))}}e.NotebookCellOutput=Kt;var wt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(wt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,re){this.text=O,this.alignment=re}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,re=[]){this.uri=O,this.provides=(0,d.asArray)(re)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,re){this.label=O,this.timestamp=re}};ui=$e([I],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,re){this.ranges=O,this.wordPattern=re}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,re){this._port=O,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Z=class{constructor(O,re,_e){this.include=O,this.exclude=re,this.profile=_e}};Z=$e([I],Z),e.TestRunRequest=Z;let ce=P=class{constructor(O){this.message=O}static diff(O,re,_e){const qe=new P(O);return qe.expectedOutput=re,qe.actualOutput=_e,qe}};ce=P=$e([I],ce),e.TestMessage=ce;let Se=class{constructor(O){this.id=O}};Se=$e([I],Se),e.TestTag=Se;let rt=class{constructor(O,re){this.covered=O,this.total=re}};rt=$e([I],rt),e.CoveredCount=rt;let _t=g=class{constructor(O,re,_e,qe){this.uri=O,this.statementCoverage=re,this.branchCoverage=_e,this.functionCoverage=qe}static fromDetails(O,re){const _e=new rt(0,0),qe=new rt(0,0),nt=new rt(0,0);for(const ct of re)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)qe.total+=1,qe.covered+=Ct.executionCount>0?1:0}else nt.total+=1,nt.covered+=ct.executionCount>0?1:0;const at=new g(O,_e,qe.total>0?qe:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=re,at}};_t=g=$e([I],_t),e.FileCoverage=_t;let kt=class{constructor(O,re,_e=[]){this.executionCount=O,this.location=re,this.branches=_e}};kt=$e([I],kt),e.StatementCoverage=kt;let Oi=class{constructor(O,re){this.executionCount=O,this.location=re}};Oi=$e([I],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,re){this.executionCount=O,this.location=re}};Ni=$e([I],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,re,_e,qe,nt,at){this.kind=O,this.name=re,this.detail=_e,this.uri=qe,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,228,118,7,13]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(s,u){u?T.set(s,u):T.delete(s)}e.setWordDefinitionFor=t;function _(s){return T.get(s)}e.getWordDefinitionFor=_;class n extends A.MirrorTextModel{constructor(u,v,D,y,o,h,C,i){super(v,D,y,o);this._proxy=u,this._languageId=h,this._isDirty=C,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,S.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===M.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(v){return v?u._getTextInRange(v):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(v){return u._lineAt(v)},offsetAt(v){return u._offsetAt(v)},positionAt(v){return u._positionAt(v)},validateRange(v){return u._validateRange(v)},validatePosition(v){return u._validatePosition(v)},getWordRangeAtPosition(v,D){return u._getWordRangeAtPosition(v,D)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,d.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,d.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const v=this._validateRange(u);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const D=this._eol,y=v.start.line,o=v.end.line,h=[];h.push(this._lines[y].substring(v.start.character));for(let C=y+1;C<o;C++)h.push(this._lines[C]);return h.push(this._lines[o].substring(0,v.end.character)),h.join(D)}_lineAt(u){let v;if(u instanceof k.Position?v=u.line:typeof u=="number"&&(v=u),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new f(v,this._lines[v],v===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(u),D=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,D))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(u.start),D=this._validatePosition(u.end);return v===u.start&&D===u.end?u:new k.Range(v.line,v.character,D.line,D.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:v,character:D}=u,y=!1;if(v<0)v=0,D=0,y=!0;else if(v>=this._lines.length)v=this._lines.length-1,D=this._lines[v].length,y=!0;else{const o=this._lines[v].length;D<0?(D=0,y=!0):D>o&&(D=o,y=!0)}return y?new k.Position(v,D):u}_getWordRangeAtPosition(u,v){const D=this._validatePosition(u);if(!v)v=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const y=(0,F.getWordAtText)(D.character+1,(0,F.ensureValidWordDefinition)(v),this._lines[D.line],0);if(y)return new k.Range(D.line,y.startColumn-1,D.line,y.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(u,v,D){this._line=u,this._text=v,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[156],Ee([0,1,7,3,229,6,56,20,2,36]),function(se,e,d,M,E,A,F,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,f,s,u){this._notebook=s,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(D=>{const y=this._cellUris.get(D.document.uri);y!==void 0&&(this._cellLengths.changeValue(y,this._cells[y].document.getText().length+1),this._cellLines.changeValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>v(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const n=[],f=[];for(const s of this._notebook.getCells())s.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),f.push(s.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let y="";for(const o of this._cells)y+=o.document.getText()+`
`;return y=y.slice(0,-1),y}if(n.isEmpty)return"";const f=this.locationAt(n.start),s=this.locationAt(n.end),u=this._cellUris.get(f.uri),v=this._cellUris.get(s.uri);if(u===void 0||v===void 0)return"";if(u===v)return this._cells[u].document.getText(new d.Range(f.range.start,s.range.end));const D=[this._cells[u].document.getText(new d.Range(f.range.start,new d.Position(this._cells[u].document.lineCount,0)))];for(let y=u+1;y<v;y++)D.push(this._cells[y].document.getText());return D.push(this._cells[v].document.getText(new d.Range(new d.Position(0,0),s.range.end))),D.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(f.index-1),u=this._cells[f.index].document.offsetAt(n.with(f.remainder));return s+u}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const f=this._cellUris.get(n.uri);if(f!==void 0){const s=this._cellLines.getPrefixSum(f-1);return new d.Position(s+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let s=f;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const u=new d.Position(f.remainder,n.start.character),v=new d.Position(s.remainder,n.end.character),D=new d.Range(u,v),y=this._cells[f.index];return new d.Location(y.document.uri,y.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(f,s)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),s=new d.Position(f.remainder,n.character),u=this._cells[f.index].document.validatePosition(s),v=this._cellLines.getPrefixSum(f.index-1);return new d.Position(v+u.line,u.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,12,3]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?d.ColorThemeKind.Light:k==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[66],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[158],Ee([0,1,22]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(S){let T=this.buffers.indexOf(S);return T<0&&(T=this.buffers.length,this.buffers.push(S)),T}}function E(k,S){if(S.serializeBuffersForPostMessage){const T=new M,t=(f,s)=>{if(s instanceof ArrayBuffer){const u=T.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=A(s);if(u){const v=T.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},_=JSON.stringify(k,t),n=T.buffers.map(f=>{const s=new Uint8Array(f);return d.VSBuffer.wrap(s)});return{message:_,buffers:n}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=E;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(k,S){const T=S.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),t=S.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const s=f,{index:u}=s,v=T[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(v,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return f}:void 0;return{message:JSON.parse(k,t),arrayBuffers:T}}e.deserializeWebviewMessage=F}),define(be[159],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function E(F){const k={items:new Map};return F.types.forEach((S,T)=>{k.items.set(S,{asString:async()=>F.items[T].asString})}),k}M.toITreeDataTransfer=E;async function A(F){const k={types:[],items:[]},S=Array.from(F.items.entries());for(const T of S)k.types.push(T[0]),k.items.push({asString:await T[1].asString()});return k}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[67],Ee([0,1,11,2]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(k,S){return k.scheme===d.Schemas.http||k.scheme===d.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===d.Schemas.file&&(k=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:S.authority,path:k.path})),M.URI.from({scheme:d.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=E;function A(k){return k.replace(/./g,S=>{const T=S.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?S:"-"+T.toString(16).padStart(4,"0")})}function F(k){return k.replace(/-([0-9a-f]{4})/g,(S,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=F}),define(be[160],Ee([0,1,3,6,67]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,S,T){this._proxy=k,this._editors=S,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const t=S.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,T,t,_){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){n=o;break}if(!n)throw new Error("not a visible editor");const f=this,s=this._handlePool++,u=new d.Emitter,v=new d.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,E.asWebviewUri)(o,f._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(o){this._options=o,f._proxy.$setOptions(s,o)}get options(){return this._options}set html(o){this._html=o,f._proxy.$setHtml(s,o)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(o){return f._proxy.$postMessage(s,o)}},y=new class{constructor(){this.editor=k,this.line=S,this.height=T,this.webview=D,this.onDidDispose=v.event}dispose(){f._insets.has(s)&&(f._insets.delete(s),f._proxy.$disposeEditorInset(s),v.fire(),v.dispose(),u.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,S+1,T,t||{},_.identifier,_.extensionLocation),this._insets.set(s,{editor:k,inset:y,onDidReceiveMessage:u}),y}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const T=this._insets.get(k);T&&T.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,46,28,13,11]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function _(L,w,x){for(const $ of x.visibleEditorPanes)if($.group.id===w&&L.matches($.input))return $.getViewState()}e.findViewStateForEditor=_;function n(L){if(h(L))return!1;const w=L;return E.URI.isUri(w?.resource)}e.isResourceEditorInput=n;function f(L){if(h(L))return!1;const w=L;return w?.original!==void 0&&w.modified!==void 0}e.isResourceDiffEditorInput=f;function s(L){if(h(L)||f(L))return!1;const w=L;return w?.primary!==void 0&&w.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function u(L){if(h(L))return!1;const w=L;return w?w.resource===void 0||w.resource.scheme===t.Schemas.untitled||w.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var v;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var D;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(D=e.SaveReason||(e.SaveReason={}));var y;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(y=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends A.Disposable{}e.AbstractEditorInput=o;function h(L){return L instanceof o}e.isEditorInput=h;function C(L){const w=L;return E.URI.isUri(w?.preferredResource)}function i(L){const w=L;return h(w?.primary)&&h(w?.secondary)}e.isSideBySideEditorInput=i;function p(L){const w=L;return h(w?.modified)&&h(w?.original)}e.isDiffEditorInput=p;function a(L){return h(L?.editor)}e.isEditorInputWithOptions=a;function r(L){const w=L;return a(L)&&w?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function c(L){const w=L;return typeof w?.groupId=="number"&&h(w.editor)}e.isEditorIdentifier=c;var l;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class b{getOriginalUri(w,x){if(!w)return;if(x?.supportSideBySide){const{primary:B,secondary:K}=this.getSideEditors(w);if(B&&K){if(x?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===m.ANY)return this.getOriginalUri(B,{filterByScheme:x.filterByScheme})??this.getOriginalUri(K,{filterByScheme:x.filterByScheme});w=x.supportSideBySide===m.PRIMARY?B:K}}if(f(w)||s(w))return;const $=C(w)?w.preferredResource:w.resource;return!$||!x||!x.filterByScheme?$:this.filterUri($,x.filterByScheme)}getSideEditors(w){return i(w)||s(w)?{primary:w.primary,secondary:w.secondary}:p(w)||f(w)?{primary:w.modified,secondary:w.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(w,x){if(!w)return;if(x?.supportSideBySide){const{primary:B,secondary:K}=this.getSideEditors(w);if(B&&K){if(x?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===m.ANY)return this.getCanonicalUri(B,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:x.filterByScheme});w=x.supportSideBySide===m.PRIMARY?B:K}}if(f(w)||s(w))return;const $=w.resource;return!$||!x||!x.filterByScheme?$:this.filterUri($,x.filterByScheme)}filterUri(w,x){if(Array.isArray(x)){if(x.some($=>w.scheme===$))return w}else if(x===w.scheme)return w}}e.EditorResourceAccessor=new b;var P;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(P=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(w){const x=this.instantiationService=w.get(F.IInstantiationService);for(const[$,B]of this.editorSerializerConstructors)this.createEditorSerializer($,B,x);this.editorSerializerConstructors.clear()}createEditorSerializer(w,x,$){const B=$.createInstance(x);this.editorSerializerInstances.set(w,B)}registerFileEditorFactory(w){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=w}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(w,x){if(this.editorSerializerConstructors.has(w)||this.editorSerializerInstances.has(w))throw new Error(`A editor serializer with type ID '${w}' was already registered.`);return this.instantiationService?this.createEditorSerializer(w,x,this.instantiationService):this.editorSerializerConstructors.set(w,x),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(w),this.editorSerializerInstances.delete(w)})}getEditorSerializer(w){return this.editorSerializerInstances.get(typeof w=="string"?w:w.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new g);async function I(L,w){if(!L||!L.length)return[];const x=await Promise.all(L.map(async $=>{const B=E.URI.revive($.fileUri);if(!B||!await w.canHandleResource(B))return;const H=typeof $.exists=="boolean"?$.exists:await w.exists(B);if(!H&&$.openOnlyIfExists)return;const W={selection:H?$.selection:void 0,pinned:!0,override:$.editorOverrideId};let ne;return H?ne={resource:B,options:W}:ne={resource:B,options:W,forceUntitled:!0},ne}));return(0,T.coalesce)(x)}e.pathsToEditors=I;var R;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,46,132,4,6,20,28,13,52,23,34,152]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var s;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var u;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel",c[c.AuxiliaryBar=2]="AuxiliaryBar"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function v(c){switch(c){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=v;function D(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=D;class y extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,m,b){const P=this.get(l.id);if(P)return P;const g=l;return g.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,k.getOrSet)(this.viewContainers,m,[]).push(g),b?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:m}),g}deregisterViewContainer(l){for(const m of this.viewContainers.keys()){const b=this.viewContainers.get(m),P=b?.indexOf(l);if(P!==-1){b?.splice(P,1),b.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:m});return}}}get(l){return this.all.filter(m=>m.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===l)}}S.Registry.add(s.ViewContainersRegistry,new y);var o;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function h(c,l){const m=c.group??o.More,b=l.group??o.More;return m!==b?m.localeCompare(b):(c.order??5)-(l.order??5)}class C extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(l,m){this.registerViews2([{views:l,viewContainer:m}])}registerViews2(l){l.forEach(({views:m,viewContainer:b})=>this.addViews(m,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,m){const b=this.removeViews(l,m);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:m})}moveViews(l,m){for(const b of this._views.keys())if(b!==m){const P=this.removeViews(l,b);P.length&&(this.addViews(P,m),this._onDidChangeContainer.fire({views:P,from:b,to:m}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const m of this._viewContainers){const b=(this._views.get(m)||[]).filter(P=>P.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(P=>P.id===l)[0])return m;return null}registerViewWelcomeContent(l,m){return this._viewWelcomeContents.add(l,m),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,m),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,m){const b=new Map;for(const[P,g]of m)this._viewWelcomeContents.add(l,g),b.set(P,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,g),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const m=[];return this._viewWelcomeContents.forEach(l,b=>m.push(b)),m.sort(h)}addViews(l,m){let b=this._views.get(m);b||(b=[],this._views.set(m,b),this._viewContainers.push(m));for(const P of l){if(this.getView(P.id)!==null)throw new Error((0,E.localize)(1,null,P.id));b.push(P)}}removeViews(l,m){const b=this._views.get(m);if(!b)return[];const P=[],g=[];for(const I of b)l.includes(I)?P.push(I):g.push(I);return P.length&&(g.length?this._views.set(m,g):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),P}}S.Registry.add(s.ViewsRegistry,new C),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(c){return`view.${c}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var p;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(p=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(l,m){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,l),this._hasResolve=!!m,this.resolve=async b=>{if(m&&!this.resolved){const P=await m(b);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,14,133]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,T,t){const _={command:k};if(S&&Object.keys(S).length>0&&(_.arguments=S),this.internalSend("request",_),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(_.seq);if(f){this.pendingRequests.delete(_.seq);const s={type:"response",seq:0,request_seq:_.seq,success:!1,command:k,message:(0,E.localize)(0,null,t,k)};f(s)}},t)}return T&&this.pendingRequests.set(_.seq,T),_.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,M.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,T=this.pendingRequests.get(S.request_seq);T&&(this.pendingRequests.delete(S.request_seq),T(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,T)=>k.set(T,S)),await(0,M.timeout)(500),k.forEach((S,T)=>{S({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,23,11]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(a,r,c){return a.replace(k,function(l,m){return r&&m.length>0&&m[0]!=="_"?l:c&&c.hasOwnProperty(m)?c[m]:l})}e.formatPII=S;function T(a){const r={};for(const c of Object.keys(a))c.startsWith("!")||(r[c]=a[c]);return r}e.filterExceptionsFromTelemetry=T;function t(a){return a.configuration.request==="attach"&&!_(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function _(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(r,"extensionhost")||(0,d.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?_(a.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function f(a,r,c){let l,m=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=b.exec(a);){let g=P.index+1,I=g+P[0].length;if(g<=r&&I>=c){l=P[0],m=g;break}}if(l){let g=/\w+/g,I=null;for(;(I=g.exec(l))&&!(I.index+1+m+I[0].length>=c););I&&(l=l.substring(0,g.lastIndex))}return l?{start:m,end:m+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(a){return!!(a&&a.match(s))}e.isUri=u;function v(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(u(a.path))return M.URI.parse(a.path);if((0,E.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function D(a){if(typeof a.path=="object"){const r=M.URI.revive(a.path);if(r)return r.scheme===F.Schemas.file?r.fsPath:r.toString()}return a.path}function y(a,r){const c=r?v:D,l=(0,A.deepClone)(a);return h(l,(m,b)=>{m&&b&&(b.path=c(b))}),l}e.convertToDAPaths=y;function o(a,r){const c=r?v:D,l=(0,A.deepClone)(a);return h(l,(m,b)=>{!m&&b&&(b.path=c(b))}),l}e.convertToVSCPaths=o;function h(a,r){switch(a.type){case"event":const c=a;switch(c.event){case"output":r(!1,c.body.source);break;case"loadedSource":r(!1,c.body.source);break;case"breakpoint":r(!1,c.body.breakpoint.source);break;default:break}break;case"request":const l=a;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>r(!1,b));break;default:break}break;case"response":const m=a;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(b=>r(!1,b.source));break;case"loadedSources":m.body.sources.forEach(b=>r(!1,b));break;case"scopes":m.body.scopes.forEach(b=>r(!1,b.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(b=>r(!1,b.source));break;case"setBreakpoints":m.body.breakpoints.forEach(b=>r(!1,b.source));break;default:break}break}}function C(a){return a.filter(r=>!r.presentation?.hidden).sort((r,c)=>r.presentation?c.presentation?r.presentation.group?c.presentation.group?r.presentation.group!==c.presentation.group?r.presentation.group.localeCompare(c.presentation.group):i(r.presentation.order,c.presentation.order):-1:c.presentation.group?1:i(r.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=C;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function p(a,r){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorMode});if(c!=="none"&&(await r.saveAll(),c==="allEditorsInActiveGroup")){const l=r.activeEditorPane;l&&await r.save({editor:l.input,groupId:l.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(be[89],Ee([0,1,27,79,11,17,25,46]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var v;(function(g){g.scheme=E.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function R(B,K){return B.with({scheme:g.scheme,fragment:`ch${K.toString().padStart(7,"0")}${B.scheme!==E.Schemas.file?B.scheme:""}`})}g.generate=R;function L(B){if(B.scheme!==g.scheme)return;const K=I.exec(B.fragment);return K?{handle:Number(K[1]),notebook:B.with({scheme:B.fragment.substr(K[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parse=L;function w(B){if(B.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const K=I.exec(B.fragment);return K?{handle:Number(K[1]),notebook:B.with({scheme:B.fragment.substr(K[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=w;function x(B,K,H){return B.with({scheme:H,fragment:`ch${K.toString().padStart(7,"0")}${B.scheme!==E.Schemas.file?B.scheme:""}`})}g.generateCellUri=x;function $(B,K){if(B.scheme!==K)return;const H=I.exec(B.fragment);return H?{handle:Number(H[1]),notebook:B.with({scheme:B.fragment.substr(H[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parseCellUri=$})(v=e.CellUri||(e.CellUri={}));const D=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function y(g){return D.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=y;function o(g){return D.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function h(g){return D.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=h;function C(g,I){return F.isWindows&&(g=g.replace(/\//g,"\\"),I=I.replace(/\//g,"\\")),d.match(g,I)}function i(g,I,R){let L=0;for(let w=0;w<I.length;w++){if(C(I[w],g))return L;L++}for(let w=0;w<R.length;w++){if(C(R[w],g))return L;L++}return L}function p(g,I,R){return g.sort((L,w)=>i(L,I,R)-i(w,I,R))}e.sortMimeTypes=p;function a(g,I,R,L=(w,x)=>w===x){const w=[];function x(K,H,W){if(H===0&&W.length===0)return;const ne=w[w.length-1];ne&&ne.start+ne.deleteCount===K?(ne.deleteCount+=H,ne.toInsert.push(...W)):w.push({start:K,deleteCount:H,toInsert:W})}let $=0,B=0;for(;;){if($===g.length){x($,0,I.slice(B));break}if(B===I.length){x($,g.length-$,[]);break}const K=g[$],H=I[B];if(L(K,H)){$+=1,B+=1;continue}R(H)?(x($,1,[]),$+=1):(x($,0,[H]),B+=1)}return w}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(g){g.default="default",g.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(g){const I=g;return!!((typeof I.include=="string"||d.isRelativePattern(I.include))&&(typeof I.exclude=="string"||d.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=c;function l(g,I,R){if(Array.isArray(g.viewType)&&g.viewType.indexOf(I)>=0||g.viewType===I)return!0;if(g.filenamePattern){let L=c(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,w=c(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(d.match(L,(0,A.basename)(R.fsPath).toLowerCase()))return!(w&&d.match(w,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class m{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)I[R]=this.textModel.cells[R].getHashValue();return I}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(I){return`${P._prefix}${I}`}static parse(I){if(I.startsWith(P._prefix))return I.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,46]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=d;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=F;var k;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const u=s[1];if(u.parent){if(this.items.has(u.parent)){const v=this.items.get(u.parent);v.children.add(u.item.extId);const D=this.createItem(u,v);this.items.set(u.item.extId,D),f.add(D)}}else{const v=this.createItem(u);this.roots.add(v),this.items.set(u.item.extId,v),f.add(v)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=s[1],v=this.items.get(u.extId);if(!v)break;u.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,u),f.update(v);break}case 2:{const u=this.items.get(s[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const v=[[s[1]]];for(;v.length;)for(const D of v.pop()){const y=this.items.get(D);y&&(v.push(y.children),this.items.delete(D),f.remove(y,y!==u),y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(be[68],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,k=F.length){if(this.path=F,this.viewEnd=k,F.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,k,S=F.parent){if(F.id===k)return new E([k]);let T=[F.id];for(let t=S;t&&t.id!==k;t=t.parent)T.push(t.id);return T.push(k),new E(T.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,k){return new E([...F.path,k])}static joinToString(F,k){return F.toString()+"\0"+k}static compare(F,k){return F===k?0:k.startsWith(F+"\0")?2:F.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let k=0;k<F.viewEnd&&k<this.viewEnd;k++)if(F.path[k]!==this.path[k])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,23,25,78,136]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(_,n,f){this._contributedVariables=new Map,this._context=_,this._labelService=n,f&&(this._envVariablesPromise=f.then(s=>this.prepareEnv(s)))}prepareEnv(_){if(F.isWindows){const n=Object.create(null);return Object.keys(_).forEach(f=>{n[f.toLowerCase()]=_[f]}),n}return _}resolveWithEnvironment(_,n,f){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,f)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,f,s){const u=A.deepClone(n);return F.isWindows&&u.windows?Object.keys(u.windows).forEach(v=>u[v]=u.windows[v]):F.isMacintosh&&u.osx?Object.keys(u.osx).forEach(v=>u[v]=u.osx[v]):F.isLinux&&u.linux&&Object.keys(u.linux).forEach(v=>u[v]=u.linux[v]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,u,f,s)}async resolveAnyAsync(_,n,f){return this.resolveAnyBase(_,n,f)}async resolveAnyMap(_,n,f){const s=new Map;return{newConfig:await this.resolveAnyBase(_,n,f,s),resolvedVariables:s}}resolveWithInteractionReplace(_,n,f,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,f,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,f,s,u){if(E.isString(f))return this.resolveString(_,n,f,s,u);if(E.isArray(f))return f.map(v=>this.recursiveResolve(_,n,v,s,u));if(E.isObject(f)){let v=Object.create(null);return Object.keys(f).forEach(D=>{const y=this.resolveString(_,n,D,s,u);v[y]=this.recursiveResolve(_,n,f[D],s,u)}),v}return f}resolveString(_,n,f,s,u){return f.replace(T.VARIABLE_REGEXP,(D,y)=>{if(y.includes(T.VARIABLE_LHS))return D;let o=this.evaluateSingleVariable(_,D,y,n,s);return u&&u.set(y,o),o!==D&&E.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(_,n,o,s,u)),o})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,f,s,u){let v;const D=f.split(":");D.length>1&&(f=D[0],v=D[1]);const y=()=>{const C=this._context.getFilePath();if(C)return C;throw new Error((0,S.localize)(0,null,n))},o=()=>{const C=y();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,S.localize)(1,null,n,d.basename(C)))},h=()=>{if(v){const C=this._context.getFolderUri(v);if(C)return C;throw new Error((0,S.localize)(2,null,n,v))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(f){case"env":if(v){if(_){const C=_[F.isWindows?v.toLowerCase():v];if(E.isString(C))return C}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(v){const C=this._context.getConfigurationValue(s,v);if(E.isUndefinedOrNull(C))throw new Error((0,S.localize)(6,null,n,v));if(E.isObject(C))throw new Error((0,S.localize)(7,null,n,v));return C}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,u,"command");case"input":return this.resolveFromMap(n,v,u,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return s||v?(0,k.normalizeDriveLetter)(this.fsPath(h())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(h()));case"lineNumber":const C=this._context.getLineNumber();if(C)return C;throw new Error((0,S.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,S.localize)(10,null,n));case"file":return y();case"fileWorkspaceFolder":return o();case"relativeFile":return s||v?d.relative(this.fsPath(h()),y()):y();case"relativeFileDirname":const p=d.dirname(y());if(s||v){const l=d.relative(this.fsPath(h()),p);return l.length===0?".":l}return p;case"fileDirname":return d.dirname(y());case"fileExtname":return d.extname(y());case"fileBasename":return d.basename(y());case"fileBasenameNoExtension":const a=d.basename(y());return a.slice(0,a.length-d.extname(a).length);case"fileDirnameBasename":return d.basename(d.dirname(y()));case"execPath":const r=this._context.getExecPath();return r||n;case"execInstallFolder":const c=this._context.getAppRoot();return c||n;case"pathSeparator":return d.sep;default:try{const l=v?`${f}:${v}`:f;return this.resolveFromMap(n,l,u,void 0)}catch(l){return n}}}}resolveFromMap(_,n,f,s){if(n&&f){const u=s===void 0?f[n]:f[s+":"+n];if(typeof u=="string")return u;throw new Error((0,S.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var E;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var k;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function T(u){const v=u;return(0,M.isEditorInput)(v?.editor)&&(0,M.isEditorInput)(v?.replacement)}e.isEditorReplacement=T;var t;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(u){const v=u;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=f;function s(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(be[169],Ee([0,1,4,92]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,13,22,77,230,55,23,10,2,44,59,137,83,49,89,68,169,7]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(de){function pe(z){const{selectionStartLineNumber:we,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:Ue}=z,dt=new y.Position(we-1,ke-1),gt=new y.Position(Je-1,Ue-1);return new y.Selection(dt,gt)}de.to=pe;function Y(z){const{anchor:we,active:ke}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=Y})(o=e.Selection||(e.Selection={}));var h;(function(de){function pe(z){if(!z)return;const{start:we,end:ke}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=pe;function Y(z){if(!z)return;const{startLineNumber:we,startColumn:ke,endLineNumber:Je,endColumn:Ue}=z;return new y.Range(we-1,ke-1,Je-1,Ue-1)}de.to=Y})(h=e.Range||(e.Range={}));var C;(function(de){function pe(Y){switch(Y){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 4:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}de.to=pe})(C=e.TokenType||(e.TokenType={}));var i;(function(de){function pe(z){return new y.Position(z.lineNumber-1,z.column-1)}de.to=pe;function Y(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=Y})(i=e.Position||(e.Position={}));var p;(function(de){function pe(we,ke){return(0,d.coalesce)((0,d.asArray)(we).map(Je=>Y(Je,ke)))}de.from=pe;function Y(we,ke){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,ke),pattern:typeof we.pattern=="undefined"?void 0:ot.from(we.pattern),exclusive:we.exclusive}}function z(we,ke){return ke&&typeof we=="string"?ke.transformOutgoingScheme(we):we}})(p=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(de){function pe(z){switch(z){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}de.from=pe;function Y(z){switch(z){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}de.to=Y})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(de){function pe(z){let we;return z.code&&((0,S.isString)(z.code)||(0,S.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...h.from(z.range),message:z.message,source:z.source,code:we,severity:l.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(c.from),tags:Array.isArray(z.tags)?(0,d.coalesce)(z.tags.map(a.from)):void 0}}de.from=pe;function Y(z){const we=new y.Diagnostic(h.to(z),z.message,l.to(z.severity));return we.source=z.source,we.code=(0,S.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(c.to),we.tags=z.tags&&(0,d.coalesce)(z.tags.map(a.to)),we}de.to=Y})(r=e.Diagnostic||(e.Diagnostic={}));var c;(function(de){function pe(z){return{...h.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=pe;function Y(z){return new y.DiagnosticRelatedInformation(new y.Location(z.resource,h.to(z)),z.message)}de.to=Y})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(de){function pe(z){switch(z){case y.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}de.from=pe;function Y(z){switch(z){case f.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}de.to=Y})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(de){function pe(z){return typeof z=="number"&&z>=y.ViewColumn.One?z-1:z===y.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}de.from=pe;function Y(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=Y})(m=e.ViewColumn||(e.ViewColumn={}));function b(de){return typeof de.range!="undefined"}function P(de){return de.length===0?!0:!!b(de[0])}e.isDecorationOptionsArr=P;var g;(function(de){function pe(Ue){return Ue.map(de.from)}de.fromMany=pe;function Y(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function z(Ue){let dt;if(Y(Ue)){const{language:ut,value:pt}=Ue;dt={value:"```"+ut+`
`+pt+"\n```\n"}}else y.MarkdownString.isMarkdownString(Ue)?dt={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?dt={value:Ue}:dt={value:""};const gt=Object.create(null);dt.uris=gt;const lt=ut=>{try{let pt=T.URI.parse(ut,!0);pt=pt.with({query:we(pt.query,gt)}),gt[ut]=pt}catch(pt){}return""},ft=new A.Renderer;return ft.link=lt,ft.image=ut=>lt(E.parseHrefAndDimensions(ut).href),A(dt.value,{renderer:ft}),dt}de.from=z;function we(Ue,dt){if(!Ue)return Ue;let gt;try{gt=(0,F.parse)(Ue)}catch(ft){}if(!gt)return Ue;let lt=!1;return gt=(0,k.cloneAndChange)(gt,ft=>{if(T.URI.isUri(ft)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ut]=ft,lt=!0,ut}else return}),lt?JSON.stringify(gt):Ue}function ke(Ue){const dt=new y.MarkdownString(Ue.value,Ue.supportThemeIcons);return dt.isTrusted=Ue.isTrusted,dt.supportHtml=Ue.supportHtml,dt}de.to=ke;function Je(Ue){if(!!Ue)return typeof Ue=="string"?Ue:de.from(Ue)}de.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function I(de){return P(de)?de.map(pe=>({range:h.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?g.fromMany(pe.hoverMessage):pe.hoverMessage?g.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):de.map(pe=>({range:h.from(pe)}))}e.fromRangeOrRangeWithMessage=I;function R(de){return typeof de=="undefined"?de:typeof de=="string"?T.URI.file(de):de}e.pathOrURIToURI=R;var L;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?R(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}de.from=pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?R(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?L.from(Y.before):void 0,after:Y.after?L.from(Y.after):void 0}}de.from=pe})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(de){function pe(Y){if(typeof Y=="undefined")return Y;switch(Y){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=pe})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(de){function pe(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?x.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?w.from(Y.light):void 0,dark:Y.dark?w.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?R(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?L.from(Y.before):void 0,after:Y.after?L.from(Y.after):void 0}}de.from=pe})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(de){function pe(z){return{text:z.newText,eol:z.newEol&&J.from(z.newEol),range:h.from(z.range)}}de.from=pe;function Y(z){const we=new y.TextEdit(h.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:J.to(z.eol),we}de.to=Y})(B=e.TextEdit||(e.TextEdit={}));var K;(function(de){function pe(z,we,ke){const Je={edits:[]};if(z instanceof y.WorkspaceEdit)for(let Ue of z._allEntries())if(Ue._type===1)Je.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const dt=we?.getDocument(Ue.uri);Je.edits.push({_type:2,resource:Ue.uri,edit:B.from(Ue.edit),modelVersionId:dt?.version,metadata:Ue.metadata})}else Ue._type===3?Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:ke?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}});return Je}de.from=pe;function Y(z){const we=new y.WorkspaceEdit;for(const ke of z.edits)ke.edit?we.replace(T.URI.revive(ke.resource),h.to(ke.edit.range),ke.edit.text):we.renameFile(T.URI.revive(ke.oldUri),T.URI.revive(ke.newUri),ke.options);return we}de.to=Y})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const pe=Object.create(null);pe[y.SymbolKind.File]=0,pe[y.SymbolKind.Module]=1,pe[y.SymbolKind.Namespace]=2,pe[y.SymbolKind.Package]=3,pe[y.SymbolKind.Class]=4,pe[y.SymbolKind.Method]=5,pe[y.SymbolKind.Property]=6,pe[y.SymbolKind.Field]=7,pe[y.SymbolKind.Constructor]=8,pe[y.SymbolKind.Enum]=9,pe[y.SymbolKind.Interface]=10,pe[y.SymbolKind.Function]=11,pe[y.SymbolKind.Variable]=12,pe[y.SymbolKind.Constant]=13,pe[y.SymbolKind.String]=14,pe[y.SymbolKind.Number]=15,pe[y.SymbolKind.Boolean]=16,pe[y.SymbolKind.Array]=17,pe[y.SymbolKind.Object]=18,pe[y.SymbolKind.Key]=19,pe[y.SymbolKind.Null]=20,pe[y.SymbolKind.EnumMember]=21,pe[y.SymbolKind.Struct]=22,pe[y.SymbolKind.Event]=23,pe[y.SymbolKind.Operator]=24,pe[y.SymbolKind.TypeParameter]=25;function Y(we){return typeof pe[we]=="number"?pe[we]:6}de.from=Y;function z(we){for(const ke in pe)if(pe[ke]===we)return Number(ke);return y.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var W;(function(de){function pe(z){switch(z){case y.SymbolTag.Deprecated:return 1}}de.from=pe;function Y(z){switch(z){case 1:return y.SymbolTag.Deprecated}}de.to=Y})(W=e.SymbolTag||(e.SymbolTag={}));var ne;(function(de){function pe(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(W.from),containerName:z.containerName,location:te.from(z.location)}}de.from=pe;function Y(z){const we=new y.SymbolInformation(z.name,H.to(z.kind),z.containerName,te.to(z.location));return we.tags=z.tags&&z.tags.map(W.to),we}de.to=Y})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(de){function pe(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:h.from(z.range),selectionRange:h.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(W.from)??[]};return z.children&&(we.children=z.children.map(pe)),we}de.from=pe;function Y(z){const we=new y.DocumentSymbol(z.name,z.detail,H.to(z.kind),h.to(z.range),h.to(z.selectionRange));return(0,d.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(W.to)),z.children&&(we.children=z.children.map(Y)),we}de.to=Y})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(de){function pe(z){const we=new y.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),h.to(z.range),h.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=pe;function Y(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:h.from(z.range),selectionRange:h.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=Y})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(de){function pe(Y){return new y.CallHierarchyIncomingCall(X.to(Y.from),Y.fromRanges.map(z=>h.to(z)))}de.to=pe})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function pe(Y){return new y.CallHierarchyOutgoingCall(X.to(Y.to),Y.fromRanges.map(z=>h.to(z)))}de.to=pe})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var te;(function(de){function pe(z){return{range:z.range&&h.from(z.range),uri:z.uri}}de.from=pe;function Y(z){return new y.Location(T.URI.revive(z.uri),h.to(z.range))}de.to=Y})(te=e.location||(e.location={}));var ve;(function(de){function pe(z){const we=z,ke=z;return{originSelectionRange:we.originSelectionRange?h.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ke.uri,range:h.from(we.targetRange?we.targetRange:ke.range),targetSelectionRange:we.targetSelectionRange?h.from(we.targetSelectionRange):void 0}}de.from=pe;function Y(z){return{targetUri:T.URI.revive(z.uri),targetRange:h.to(z.range),targetSelectionRange:z.targetSelectionRange?h.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?h.to(z.originSelectionRange):void 0}}de.to=Y})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(de){function pe(z){return{range:h.from(z.range),contents:g.fromMany(z.contents)}}de.from=pe;function Y(z){return new y.Hover(z.contents.map(g.to),h.to(z.range))}de.to=Y})(Re=e.Hover||(e.Hover={}));var Fe;(function(de){function pe(z){return{range:h.from(z.range),expression:z.expression}}de.from=pe;function Y(z){return new y.EvaluatableExpression(h.to(z.range),z.expression)}de.to=Y})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Oe;(function(de){function pe(z){if(z instanceof y.InlineValueText)return{type:"text",range:h.from(z.range),text:z.text};if(z instanceof y.InlineValueVariableLookup)return{type:"variable",range:h.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=pe;function Y(z){switch(z.type){case"text":return{range:h.to(z.range),text:z.text};case"variable":return{range:h.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:h.to(z.range),expression:z.expression}}}de.to=Y})(Oe=e.InlineValue||(e.InlineValue={}));var Ke;(function(de){function pe(z){return{frameId:z.frameId,stoppedLocation:h.from(z.stoppedLocation)}}de.from=pe;function Y(z){return new y.InlineValueContext(z.frameId,h.to(z.stoppedLocation))}de.to=Y})(Ke=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function pe(z){return{range:h.from(z.range),kind:z.kind}}de.from=pe;function Y(z){return new y.DocumentHighlight(h.to(z.range),z.kind)}de.to=Y})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(de){function pe(Y){switch(Y){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}de.to=pe})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var U;(function(de){function pe(Y){return{triggerKind:Ve.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}de.to=pe})(U=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function pe(z){switch(z){case y.CompletionItemTag.Deprecated:return 1}}de.from=pe;function Y(z){switch(z){case 1:return y.CompletionItemTag.Deprecated}}de.to=Y})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var ie;(function(de){const pe=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function Y(ke){return pe.get(ke)??9}de.from=Y;const z=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function we(ke){return z.get(ke)??y.CompletionItemKind.Property}de.to=we})(ie=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function pe(Y,z){const we=new y.CompletionItem(Y.label);return we.insertText=Y.insertText,we.kind=ie.to(Y.kind),we.tags=Y.tags?.map(Q.to),we.detail=Y.detail,we.documentation=E.isMarkdownString(Y.documentation)?g.to(Y.documentation):Y.documentation,we.sortText=Y.sortText,we.filterText=Y.filterText,we.preselect=Y.preselect,we.commitCharacters=Y.commitCharacters,t.Range.isIRange(Y.range)?we.range=h.to(Y.range):typeof Y.range=="object"&&(we.range={inserting:h.to(Y.range.insert),replacing:h.to(Y.range.replace)}),we.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?we.insertText=new y.SnippetString(Y.insertText):(we.insertText=Y.insertText,we.textEdit=we.range instanceof y.Range?new y.TextEdit(we.range,we.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(we.additionalTextEdits=Y.additionalTextEdits.map(ke=>B.to(ke))),we.command=z&&Y.command?z.fromInternal(Y.command):void 0,we}de.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var G;(function(de){function pe(z){return{label:z.label,documentation:z.documentation?g.fromStrict(z.documentation):void 0}}de.from=pe;function Y(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?g.to(z.documentation):z.documentation}}de.to=Y})(G=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(de){function pe(z){return{label:z.label,documentation:z.documentation?g.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(G.from):[],activeParameter:z.activeParameter}}de.from=pe;function Y(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?g.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(G.to):[],activeParameter:z.activeParameter}}de.to=Y})(oe=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function pe(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(oe.from):[]}}de.from=pe;function Y(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(oe.to):[]}}de.to=Y})(he=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(de){function pe(z){return{text:z.text,position:i.from(z.position),kind:Be.from(z.kind??y.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=pe;function Y(z){const we=new y.InlayHint(z.text,i.to(z.position),Be.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=Y})(Te=e.InlayHint||(e.InlayHint={}));var Be;(function(de){function pe(z){return z}de.from=pe;function Y(z){return z}de.to=Y})(Be=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function pe(z){return{range:h.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=pe;function Y(z){let we;if(z.url)try{we=typeof z.url=="string"?T.URI.parse(z.url,!0):T.URI.revive(z.url)}catch(ke){}return new y.DocumentLink(h.to(z.range),we)}de.to=Y})(He=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function pe(z){const we=new y.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=B.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(ke=>B.to(ke))),we}de.to=pe;function Y(z){return{label:z.label,textEdit:z.textEdit?B.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>B.from(we)):void 0}}de.from=Y})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(de){function pe(z){return new y.Color(z[0],z[1],z[2],z[3])}de.to=pe;function Y(z){return[z.red,z.green,z.blue,z.alpha]}de.from=Y})(it=e.Color||(e.Color={}));var Ce;(function(de){function pe(z){return{range:h.from(z.range)}}de.from=pe;function Y(z){return new y.SelectionRange(h.to(z.range))}de.to=Y})(Ce=e.SelectionRange||(e.SelectionRange={}));var Ze;(function(de){function pe(Y){switch(Y){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}de.to=pe})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(de){function pe(z){switch(z){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}de.from=pe;function Y(z){switch(z){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}de.to=Y})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(de){function pe(z){if(z===y.EndOfLine.CRLF)return 1;if(z===y.EndOfLine.LF)return 0}de.from=pe;function Y(z){if(z===1)return y.EndOfLine.CRLF;if(z===0)return y.EndOfLine.LF}de.to=Y})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(de){function pe(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var We;(function(de){function pe(Y){const z={start:Y.start+1,end:Y.end+1};return Y.kind&&(z.kind=Ye.from(Y.kind)),z}de.from=pe})(We=e.FoldingRange||(e.FoldingRange={}));var Ye;(function(de){function pe(Y){if(Y)switch(Y){case y.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}de.from=pe})(Ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(de){function pe(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?h.from(Y.selection):void 0,override:typeof Y.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=pe})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ot;(function(de){function pe(z){return z instanceof y.RelativePattern||typeof z=="string"?z:Y(z)?new y.RelativePattern(z.base,z.pattern):z}de.from=pe;function Y(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(ot=e.GlobPattern||(e.GlobPattern={}));var Et;(function(de){function pe(Y){if(Y){if(Array.isArray(Y))return Y.map(pe);if(typeof Y=="string")return Y;{const z=Y;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:ot.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=pe})(Et=e.LanguageSelector||(e.LanguageSelector={}));var mt;(function(de){function pe(z){return{start:z.start,end:z.end}}de.from=pe;function Y(z){return new y.NotebookRange(z.start,z.end)}de.to=Y})(mt=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(de){function pe(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=pe;function Y(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=Y})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Pt;(function(de){function pe(z){switch(z){case y.NotebookCellKind.Markup:return u.CellKind.Markup;case y.NotebookCellKind.Code:default:return u.CellKind.Code}}de.from=pe;function Y(z){switch(z){case u.CellKind.Markup:return y.NotebookCellKind.Markup;case u.CellKind.Code:default:return y.NotebookCellKind.Code}}de.to=Y})(Pt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function pe(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let ke of z.cells)y.NotebookCellData.validate(ke),we.cells.push(Xe.from(ke));return we}de.from=pe;function Y(z){const we=new y.NotebookData(z.cells.map(Xe.to));return(0,S.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=Y})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function pe(z){return{cellKind:Pt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:Dt.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Pe.from):[]}}de.from=pe;function Y(z){return new y.NotebookCellData(Pt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Pe.to):void 0,z.metadata,z.internalMetadata?Dt.to(z.internalMetadata):void 0)}de.to=Y})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(de){function pe(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=pe;function Y(z){return new y.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=Y})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function pe(z){return{outputId:z.id,items:z.items.map(St.from),metadata:z.metadata}}de.from=pe;function Y(z){const we=z.items.map(St.to);return new y.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=Y})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(de){function pe(ke){if(ke!=null){if(ke instanceof y.RelativePattern||typeof ke=="string")return ke;if(we(ke))return new y.RelativePattern(ke.base,ke.pattern);if(z(ke))return{include:ot.from(ke.include)||void 0,exclude:ot.from(ke.exclude)||void 0}}}de.from=pe;function Y(ke){return typeof ke=="string"?ke:we(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=Y;function z(ke){const Je=ke,Ue=ot.from(Je.include);if(!(Ue&&Ue instanceof y.RelativePattern||typeof Ue=="string"))return!1;const dt=ot.from(Je.exclude);return!!(dt&&dt instanceof y.RelativePattern||typeof dt=="string")}function we(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(de){function pe(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?L.from(Y.top):void 0}}de.from=pe})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ee;(function(de){function pe(Y,z,we){const ke=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===y.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(ke,we),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}de.from=pe})(ee=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function pe(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}de.from=pe})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ge;(function(de){function pe(z){return{uri:z.uri,provides:z.provides}}de.from=pe;function Y(z){return new y.NotebookRendererScript(T.URI.revive(z.uri),z.provides)}de.to=Y})(ge=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function pe(z){return{message:g.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?te.from(z.location):void 0}}de.from=pe;function Y(z){const we=new y.TestMessage(typeof z.message=="string"?z.message:g.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?te.to(z.location):void 0,we}de.to=Y})(fe=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let pe;(function(Y){Y.Delimiter="\0"})(pe||(pe={})),de.namespace=(Y,z)=>Y+"\0"+z,de.denamespace=Y=>{const z=Y.indexOf("\0");return{ctrlId:Y.slice(0,z),tagId:Y.slice(z+1)}}})(Ie=e.TestTag||(e.TestTag={}));var xe;(function(de){function pe(ke){const Je=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:v.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(Ue=>Ie.namespace(Je,Ue.id)),range:h.from(ke.range)||null,description:ke.description||null,error:ke.error&&g.fromStrict(ke.error)||null}}de.from=pe;function Y(ke){return{id:v.TestId.fromString(ke.extId).localId,label:ke.label,uri:T.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:Ue}=Ie.denamespace(Je);return new y.TestTag(Ue)}),range:h.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=Y;function z(ke){const Je=v.TestId.fromString(ke.extId),Ue=new s.TestItemImpl(Je.controllerId,Je.localId,ke.label,T.URI.revive(ke.uri));return Ue.range=h.to(ke.range||void 0),Ue.description=ke.description||void 0,Ue}function we(ke){let Je;for(const Ue of ke.tests){const dt=z(Ue.item);(0,s.getPrivateApiFor)(dt).parent=Je,Je=dt}return Je}de.toItemFromContext=we})(xe=e.TestItem||(e.TestItem={})),function(de){function pe(z){return{id:z.id}}de.from=pe;function Y(z){return new y.TestTag(z.id)}de.to=Y}(Ie=e.TestTag||(e.TestTag={}));var Ne;(function(de){const pe=(z,we)=>{const ke={...xe.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ue=>Ue.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(S.isDefined).map(Je=>pe(Je,we))};for(const Je of ke.children)Je.parent=ke;return ke};function Y(z){const we=[],ke=new Map;for(const Je of z.items)ke.set(Je.item.extId,Je),z.request.targets.some(Ue=>Ue.controllerId===Je.controllerId&&Ue.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>pe(Je,ke))}}de.to=Y})(Ne=e.TestResults||(e.TestResults={}));var Ge;(function(de){function pe(ke){return{covered:ke.covered,total:ke.covered}}function Y(ke){return"line"in ke?i.from(ke):h.from(ke)}function z(ke){return"branches"in ke?{count:ke.executionCount,location:Y(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Y(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:Y(ke.location)}}de.fromDetailed=z;function we(ke){return{uri:ke.uri,statement:pe(ke.statementCoverage),branch:ke.branchCoverage&&pe(ke.branchCoverage),function:ke.functionCoverage&&pe(ke.functionCoverage),details:ke.detailedCoverage?.map(z)}}de.fromFile=we})(Ge=e.TestCoverage||(e.TestCoverage={}));var tt;(function(de){function pe(Y){switch(Y){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}de.to=pe})(tt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function pe(z){const we=new y.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),h.to(z.range),h.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=pe;function Y(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:h.from(z.range),selectionRange:h.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=Y})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(T,t,_,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,_,n)=>{const s={dispose:this._callbacks.push([t,_,T])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(T,t){const _=d.URI.revive(T);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(u,{document:v,reason:A.TextDocumentSaveReason.to(t)});s.push(D)}}finally{clearTimeout(f)}return s}_deliverEventAsyncAndBlameBadListeners([T,t,_],n){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,T,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(T);this._badListeners.set(T,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,_,n){const f=[],s=Date.now(),{document:u,reason:v}=n,{version:D}=u,y=Object.freeze({document:u,reason:v,waitUntil(o){if(Object.isFrozen(f))throw(0,M.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(o))}});try{t.apply(_,[y])}catch(o){return Promise.reject(o)}return Object.freeze(f),new Promise((o,h)=>{const C=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(C),o(i)}).catch(i=>{clearTimeout(C),h(i)})}).then(o=>{const h={edits:[]};for(const C of o)if(Array.isArray(C)&&C.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:p,range:a}of C)h.edits.push({_type:2,resource:u.uri,edit:{range:a&&A.Range.from(a),text:i,eol:p&&A.EndOfLine.from(p)}});if(h.edits.length!==0)return D===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(be[171],Ee([0,1,3,27,2,8,7]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(t,_,n,f,s){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),s&&(this._config+=4);const u=(0,M.parse)(_),v=t(D=>{if(!n)for(let y of D.created){const o=E.URI.revive(y);u(o.fsPath)&&this._onDidCreate.fire(o)}if(!f)for(let y of D.changed){const o=E.URI.revive(y);u(o.fsPath)&&this._onDidChange.fire(o)}if(!s)for(let y of D.deleted){const o=E.URI.revive(y);u(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(t,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,n,f){return new k(this._onFileSystemEvent.event,t,_,n,f)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(n,f,s)=>{const u=function(D){n.call(f,D)};return u.extension=t,_.event(u,void 0,s)}}async $onWillRunFileOperation(t,_,n,f){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(s=>({oldUri:E.URI.revive(s.source),newUri:E.URI.revive(s.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(s=>E.URI.revive(s.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(s=>E.URI.revive(s.target))},n,f)}}async _fireWillEvent(t,_,n,f){const s=new Set,u=[];if(await t.fireAsync(_,f,async(D,y)=>{const o=Date.now(),h=await Promise.resolve(D);h instanceof F.WorkspaceEdit&&(u.push(h),s.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),f.isCancellationRequested||u.length===0)return;const v={edits:[]};for(let D of u){let{edits:y}=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(y)}return{edit:v,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=S}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,f,s,u){this.start=n,this.deletedCount=f,this.deletedItems=s,this.items=u}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(s=>s.apiCell)}))}}class T{constructor(n,f,s){this.notebook=n,this._extHostDocument=f,this._cellData=s,this.handle=s.handle,this.uri=E.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,f,s){const u=s.map(A.NotebookCellOutputItem.to),v=this._outputs.find(D=>D.id===n);v&&(f||(v.items.length=0),v.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,f,s,u,v,D){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=s,this._emitter=u,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const s of n.rawEvents)s.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===k.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,s=n.end|0;return f<0&&(f=0),s>this._cells.length&&(s=this._cells.length),n.with({start:f,end:s})}_getCells(n){n=this._validateRange(n);const f=[];for(let s=n.start;s<n.end;s++)f.push(this._cells[s]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const s=[],u=[],v=[];n.reverse().forEach(D=>{const o=D[2].map(i=>{const p=new T(this,this._textDocumentsAndEditors,i);return f||u.push(T.asModelAddData(this.apiNotebook,i)),p}),h=new S(D[0],D[1],[],o),C=this._cells.splice(D[0],D[1],...o);for(const i of C)v.push(i.uri),h.deletedItems.push(i.apiCell);s.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:v}),f||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(s)}))}_moveCell(n,f){const s=this._cells.splice(n,1);this._cells.splice(f,0,...s);const u=[new S(n,1,s.map(v=>v.apiCell),[]),new S(f,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(u)}))}_setCellOutputs(n,f){const s=this._cells[n];s.setOutputs(f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,f,s,u){const v=this._cells[n];v.setOutputItems(f,s,u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,f){const s=this._cells[n];s.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(s.uri,f)}_changeCellMime(n,f){const s=this._cells[n];s.apiCell.mime=f}_changeCellMetadata(n,f){const s=this._cells[n],u=s.apiCell.metadata;s.setMetadata(f);const v=s.apiCell.metadata;(0,M.equals)(u,v)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,f){const s=this._cells[n],u=s.internalMetadata;if(s.setInternalMetadata(f),u.runState!==f.runState){const v=f.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:T})}replaceCells(S,T,t){this._throwIfFinalized(),!(S===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:S,count:T-S,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(S,T,t,_,n,f){this.id=S,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=f}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");S._selections=T,S._trySetSelections(T)},get visibleRanges(){return S._visibleRanges},revealRange(T,t){S._proxy.$tryRevealRange(S.id,M.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(T){const t=new A(this.document.version);return T(t),S._applyEdit(t.finalize())},setDecorations(T,t){return S.setDecorations(T,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(M.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let _=0;_<S.cellEdits.length;_++){if(t<0){T.push(S.cellEdits[_]),t++;continue}const f=T[t],s=S.cellEdits[_];if(f.editType===1&&s.editType===1&&f.index===s.index){f.cells.push(...S.cellEdits[_].cells),f.count+=S.cellEdits[_].count;continue}T.push(S.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,T)}setDecorations(S,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return T.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),S.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,146,126,21,53]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}withProgress(_,n,f){const s=this._handles++,{title:u,location:v,cancellable:D}=n,y={label:(0,E.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(s,{location:d.ProgressLocation.from(v),title:u,source:y,cancellable:D},_),this._withProgress(s,f,!!D)}_withProgress(_,n,f){let s;f&&(s=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,s));const u=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),s&&s.dispose()};let v;try{v=n(new T(this._proxy,_),f&&s?s.token:A.CancellationToken.None)}catch(D){throw u(_),D}return v.then(D=>u(_),D=>u(_)),v}$acceptProgressCanceled(_){const n=this._mapHandleToCancellationSource.get(_);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=k;function S(t,_){return t.message=_.message,typeof _.increment=="number"&&(typeof t.increment=="number"?t.increment+=_.increment:t.increment=_.increment),t}class T extends M.Progress{constructor(_,n){super(f=>this.throttledReport(f));this._proxy=_,this._handle=n}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}$e([(0,F.throttle)(100,(t,_)=>S(t,_),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,54,8,7]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(n,f,s){const u=k._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,u,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=k,k._Keys=new E.IdGenerator("TextEditorDecorationType");class S{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let s=null;if(n instanceof F.Position)s=new F.Range(n,n);else if(n instanceof F.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof F.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,s){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:f,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class T{constructor(n,f,s,u){this._proxy=n,this._id=f,this._accept(s),this._logService=u;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(D){v._setTabSize(D)},get insertSpaces(){return v._insertSpaces},set insertSpaces(D){v._setInsertSpaces(D)},get cursorStyle(){return v._cursorStyle},set cursorStyle(D){v._setCursorStyle(D)},get lineNumbers(){return v._lineNumbers},set lineNumbers(D){v._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let s=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(s=!0,f.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,f.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(s=!0,f.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,f.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,f.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(n){n.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,f,s,u,v,D,y,o){this.id=n,this._proxy=f,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new T(this._proxy,this.id,D,s),this._visibleRanges=y,this._viewColumn=o;const h=this;this.value=Object.freeze({get document(){return u.getValue()},set document(C){throw(0,M.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(C){if(!(C instanceof F.Selection))throw(0,M.illegalArgument)("selection");h._selections=[C],h._trySetSelection()},get selections(){return h._selections},set selections(C){if(!Array.isArray(C)||C.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");h._selections=C,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(C){throw(0,M.readonly)("visibleRanges")},get options(){return h._options.value},set options(C){h._disposed||h._options.assign(C)},get viewColumn(){return h._viewColumn},set viewColumn(C){throw(0,M.readonly)("viewColumn")},edit(C,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new S(u.getValue(),i);return C(p),h._applyEdit(p)},insertSnippet(C,i,p={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=h._selections.map(r=>A.Range.from(r));else if(i instanceof F.Position){const{lineNumber:r,column:c}=A.Position.from(i);a=[{startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c}]}else if(i instanceof F.Range)a=[A.Range.from(i)];else{a=[];for(const r of i)if(r instanceof F.Range)a.push(A.Range.from(r));else{const{lineNumber:c,column:l}=A.Position.from(r);a.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return f.$tryInsertSnippet(n,C.value,a,p)},setDecorations(C,i){const p=i.length===0;p&&!h._hasDecorationsForKey.has(C.key)||(p?h._hasDecorationsForKey.delete(C.key):h._hasDecorationsForKey.add(C.key),h._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return f.$trySetDecorations(n,C.key,A.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,c=i.length;r<c;r++){const l=i[r];a[4*r]=l.start.line+1,a[4*r+1]=l.start.character+1,a[4*r+2]=l.end.line+1,a[4*r+3]=l.end.character+1}return f.$trySetDecorationsFast(n,C.key,a)}}))},revealRange(C,i){h._runOnProxy(()=>f.$tryRevealRange(n,A.Range.from(C),i||F.TextEditorRevealType.Default))},show(C){f.$tryShowEditor(n,A.ViewColumn.from(C))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const s=f.edits.map(v=>v.range);s.sort((v,D)=>v.end.line===D.end.line?v.end.character===D.end.character?v.start.line===D.start.line?v.start.character-D.start.character:v.start.line-D.start.line:v.end.character-D.end.character:v.end.line-D.end.line);for(let v=0,D=s.length-1;v<D;v++){const y=s[v].end;if(s[v+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=f.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,u,{setEndOfLine:typeof f.setEndOfLine=="number"?A.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,14,7,10,13,8,21,159]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(y,o){if((0,t.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let h;return Array.isArray(y.highlights)&&(h=y.highlights.filter(C=>C.length===2&&typeof C[0]=="number"&&typeof C[1]=="number"),h=h.length?h:void 0),{label:y.label,highlights:h}}}class v{constructor(o,h,C){this._proxy=o,this.commands=h,this.logService=C,this.treeViews=new Map;function i(p){return p&&p.$treeViewId&&p.$treeItemHandle}h.registerArgumentProcessor({processArgument:p=>i(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(a=>i(a)?this.convertArgument(a):a):p})}registerTreeDataProvider(o,h,C){const i=this.createTreeView(o,{treeDataProvider:h},C);return{dispose:()=>i.dispose()}}createTreeView(o,h,C){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=h.dragAndDropController!==void 0,p=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(o,h,C);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},reveal:(r,c)=>a.reveal(r,c),dispose:async()=>{await p,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,h){const C=this.treeViews.get(o);return C?C.getChildren(h):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,h,C){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const p=s.TreeDataTransferConverter.toITreeDataTransfer(h);if(p.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const r=JSON.parse(await p.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>i.getExtensionElement(c)).filter(c=>!!c);r.length>0?p.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(r)}):p.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(p,C)}async $hasResolve(o){const h=this.treeViews.get(o);if(!h)throw new Error((0,d.localize)(2,null,o));return h.hasResolve}$resolve(o,h,C){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(h,C)}$setExpanded(o,h,C){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(h,C)}$setSelection(o,h){const C=this.treeViews.get(o);if(!C)throw new Error((0,d.localize)(5,null,o));C.setSelection(h)}$setVisible(o,h){const C=this.treeViews.get(o);if(!C)throw new Error((0,d.localize)(6,null,o));C.setVisible(h)}createExtHostTreeView(o,h,C){const i=new D(o,h,this._proxy,this.commands.converter,this.logService,C);return this.treeViews.set(o,i),i}convertArgument(o){const h=this.treeViews.get(o.$treeViewId);return h?h.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=v;class D extends F.Disposable{constructor(o,h,C,i,p,a){super();if(this.viewId=o,this.proxy=C,this.commands=i,this.logService=p,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,a.contributes&&a.contributes.views)for(const l in a.contributes.views)for(const m of a.contributes.views[l])m.id===o&&(this._title=m.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,c;this._register(A.Event.debounce(this._onDidChangeData.event,(l,m)=>(l||(l={message:!1,elements:[]}),m.element!==!1&&(r||(r=new Promise(b=>c=b),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(m.element)?l.elements.push(...m.element):l.elements.push(m.element)),m.message&&(l.message=!0),l),200,!0)(({message:l,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=c;return r=null,this.refresh(m).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const h=o?this.getExtensionElement(o):void 0;if(o&&!h)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let C=this.getChildrenNodes(o);return C||(C=await this.fetchChildrenNodes(h)),C?C.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,h){h=h||{select:!0,focus:!1};const C=(0,t.isUndefinedOrNull)(h.select)?!0:h.select,i=(0,t.isUndefinedOrNull)(h.focus)?!1:h.focus,p=(0,t.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:a.map(c=>c.item)},{select:C,focus:i,expand:p})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:C,focus:i,expand:p})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,h){const C=this.getExtensionElement(o);C&&(h?this._onDidExpandElement.fire(Object.freeze({element:C})):this._onDidCollapseElement.fire(Object.freeze({element:C})))}setSelection(o){(0,_.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,h){const C=this.getExtensionElement(h);if(!!C)return(0,S.asPromise)(()=>this.dndController?.onDrop(o,C))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,h){if(!this.dataProvider.resolveTreeItem)return;const C=this.elements.get(o);if(C){const i=this.nodes.get(C);if(i){const p=await this.dataProvider.resolveTreeItem(i.extensionItem,C,h)??i.extensionItem;return i.item.tooltip=this.getTooltip(p.tooltip),i.item.command=this.getCommand(i.disposableStore,p.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(h=>h?this.resolveUnknownParentChain(h).then(C=>this.resolveTreeNode(h,C[C.length-1]).then(i=>(C.push(i),C))):Promise.resolve([]))}resolveParent(o){const h=this.nodes.get(o);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,h){const C=this.nodes.get(o);return C?Promise.resolve(C):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,h,!0)).then(i=>this.getChildren(h?h.item.handle:void 0).then(()=>{const p=this.getExtensionElement(i);if(p){const a=this.nodes.get(p);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let h;if(typeof o=="string"){const C=this.getExtensionElement(o);h=C?this.nodes.get(C):void 0}else h=o;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const h=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const C=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(h.token.isCancellationRequested)return;const p=await Promise.all((0,_.coalesce)(i||[]).map(async a=>{const r=await this.dataProvider.getTreeItem(a);return r&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(a,r,C):null}));return h.token.isCancellationRequested?void 0:(0,_.coalesce)(p)}finally{h.dispose()}}refresh(o){if(o.some(C=>!C))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const C=this.getHandlesToRefresh(o);if(C.length)return this.refreshHandles(C)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const h=new Set,C=o.map(p=>this.nodes.get(p));for(const p of C)if(p&&!h.has(p.item.handle)){let a=p;for(;a&&a.parent&&C.findIndex(r=>a&&a.parent&&r&&r.item.handle===a.parent.item.handle)===-1;){const r=this.elements.get(a.parent.item.handle);a=r?this.nodes.get(r):void 0}a&&!a.parent&&h.add(p.item.handle)}const i=[];return h.forEach(p=>{const a=this.elements.get(p);if(a){const r=this.nodes.get(a);r&&(!r.parent||!h.has(r.parent.item.handle))&&i.push(p)}}),i}refreshHandles(o){const h={};return Promise.all(o.map(C=>this.refreshNode(C).then(i=>{i&&(h[C]=i.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(o){const h=this.getExtensionElement(o);if(h){const C=this.nodes.get(h);if(C)return this.clearChildren(h),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(i=>{if(i){const p=this.createTreeNode(h,i,C.parent);return this.updateNodeCache(h,p,C,C.parent),C.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,h,C){const i=this.createTreeNode(o,h,C);if(h.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,h.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,C),i}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,h){return h?this.commands.toInternal(h,o):void 0}createTreeNode(o,h,C){const i=new F.DisposableStore,p=this.createHandle(o,h,C),a=this.getLightIconPath(h);return{item:{handle:p,parentHandle:C?C.item.handle:void 0,label:u(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(i,h.command),contextValue:h.contextValue,icon:a,iconDark:this.getDarkIconPath(h)||a,themeIcon:this.getThemeIcon(h),collapsibleState:(0,t.isUndefinedOrNull)(h.collapsibleState)?T.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:C,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:h,label:C,resourceUri:i},p,a){if(h)return`${D.ID_HANDLE_PREFIX}/${h}`;const r=u(C,this.extension),c=p?p.item.handle:D.LABEL_HANDLE_PREFIX;let l=r?r.label:i?(0,M.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const m=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(p)||[];let P,g=0;do{if(P=`${c}/${g}:${l}`,a||!this.elements.has(P)||m===P)break;g++}while(g<=b.length);return P}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||E.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return E.URI.isUri(o)?o:E.URI.file(o)}addNodeToCache(o,h){this.elements.set(h.item.handle,o),this.nodes.set(o,h)}updateNodeCache(o,h,C,i){this.elements.delete(h.item.handle),this.nodes.delete(o),h.item.handle!==C.item.handle&&this.elements.delete(C.item.handle),this.addNodeToCache(o,h);const p=this.getChildrenNodes(i)||[],a=p.filter(r=>r.item.handle===C.item.handle)[0];a&&p.splice(p.indexOf(a),1,h)}addNodeToParentCache(o,h){h?(h.children||(h.children=[]),h.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const h=this.nodes.get(o);if(h){if(h.children)for(const C of h.children){const i=this.elements.get(C.item.handle);i&&this.clear(i)}h.children=void 0}}else this.clearAll()}clear(o){const h=this.nodes.get(o);if(h){if(h.children)for(const C of h.children){const i=this.elements.get(C.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}D.LABEL_HANDLE_PREFIX="0",D.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,14,3,6,10,49,8,90,68]),function(se,e,d,M,E,A,F,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||f>s.expandLevels)&&(s.expandLevels=f),s.expand===1){const u=this.resolveChildren(s);return u.isOpen()?this.expandChildren(s,f-1):u.wait().then(()=>this.expandChildren(s,f-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,f-1)):this.expandChildren(s,f-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const y of f.ops)this.onTestItemEvent(n,y);break;case 3:const{key:s,value:u,previous:v}=f,D=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,v,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:k.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:k.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[s]:u??null}}]);break}break;default:(0,A.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=T.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),u=(0,F.getPrivateApiFor)(n);u.parent&&u.parent!==f?.actual&&u.parent.children.delete(n.id);let v=this.tree.get(s.toString());if(!v){v={fullId:s,actual:n,parent:f?s.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,f),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:k.TestItem.from(n)}]),this.connectItemAndChildren(n,v,f);return}if(v.actual===n){this.connectItem(n,v,f);return}const D=v.actual.children,y=v.actual,o=(0,F.diffTestItems)(y,n);(0,F.getPrivateApiFor)(y).listener=void 0,v.actual=n,v.expand=0;for(const[h,C]of o)this.onTestItemEvent(v,{op:3,key:h,value:C,previous:y[h]});this.connectItemAndChildren(n,v,f);for(const h of D)n.children.get(h.id)||this.removeItem(T.TestId.joinToString(s,h.id))}diffTagRefs(n,f,s){const u=new Set(f.map(v=>v.id));for(const v of n)u.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:s,item:{tags:n.map(v=>k.TestTag.namespace(this.controllerId,v.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,k.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,F.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,s){this.setItemParent(n,s);const u=(0,F.getPrivateApiFor)(n);u.parent=s?.actual,u.listener=v=>this.onTestItemEvent(f,v),this.updateExpandability(f)}connectItemAndChildren(n,f,s){this.connectItem(n,f,s);for(const u of n.children)this.upsertItem(u,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const s=[];for(const u of n.actual.children){const v=this.expand(T.TestId.joinToString(n.fullId,u.id),f);(0,d.isThenable)(v)&&s.push(v)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new d.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new d.Barrier,s=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){s(v)}return(0,d.isThenable)(u)?u.catch(s).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[f];for(;s.length;){const u=s.pop();if(!!u){(0,F.getPrivateApiFor)(u.actual).listener=void 0;for(const v of u.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(u.fullId.toString());for(const v of u.actual.children)s.push(this.tree.get(T.TestId.joinToString(u.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(n=>_.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(f=>f.identifier)),_.length>0){const f=new Set;_.forEach(s=>f.add(d.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!f.has(d.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,D){this.addNode(v),this.addNode(D),this._arcs.has(v)?this._arcs.get(v).push(D):this._arcs.set(v,[D])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,D){const y=_.getArcs(v);for(let o=0;o<y.length;o++)if(!D.has(y[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const D=d.ExtensionIdentifier.toKey(v.identifier);if(n.set(D,v),v.extensionDependencies)for(let y of v.extensionDependencies){const o=d.ExtensionIdentifier.toKey(y);_.addArc(D,o)}}let f=new Set;_.getNodes().filter(v=>_.getArcs(v).length===0).forEach(v=>f.add(v));let s=_.getNodes().filter(v=>!f.has(v)),u;do{u=!1;for(let v=0;v<s.length;v++){const D=s[v];_.hasOnlyGoodArcs(D,f)&&(s.splice(v,1),v--,f.add(D),u=!0)}}while(u);return s.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=F;var k;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(k||(k={}));function S(T,t){const _=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==n)return _-n;const f=E.posix.basename(T.extensionLocation.path),s=E.posix.basename(t.extensionLocation.path);return f<s?-1:f>s?1:0}}),define(be[178],Ee([0,1,22]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(k){const S=d.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function F(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,26,148]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var k;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class T{constructor(C){this.dependency=C}}e.MissingExtensionDependency=T;var t;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;class n{constructor(C,i,p,a){this.codeLoadingTime=C,this.activateCallTime=i,this.activateResolvedTime=p,this.activationReason=a}}e.ActivationTimes=n;class f{constructor(C,i){this.description=C,this.value=i}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var s;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(h){h.enableProposedApi||v(h)}e.checkProposedApiEnabled=u;function v(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=v;function D(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=D;function y(h,C){return{identifier:new A.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!C,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=y;class o{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(C){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(C){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(C,i){return Promise.resolve()}_onWillActivateExtension(C){}_onDidActivateExtension(C,i,p,a,r){}_onDidActivateExtensionError(C,i){}_onExtensionRuntimeError(C,i){}_onExtensionHostExit(C){}}e.NullExtensionService=o}),define(be[179],Ee([0,1,26,30,15]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(s,u,v,D){this.startup=s,this.codeLoadingTime=u,this.activateCallTime=v,this.activateResolvedTime=D}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class k{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,u){return s===-1||u===-1?-1:u-s}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class S{constructor(s,u,v,D,y,o){this.activationFailed=s,this.activationFailedError=u,this.activationTimes=v,this.module=D,this.exports=y,this.subscriptions=o}}e.ActivatedExtension=S;class T extends S{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends S{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends S{constructor(s){super(!0,s,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let n=class{constructor(s,u,v,D,y){this._logService=y,this._registry=s,this._resolvedExtensionsSet=new Set,u.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,v.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const u=d.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(u)}getActivatedExtension(s){const u=d.ExtensionIdentifier.toKey(s),v=this._activatedExtensions.get(u);if(!v)throw new Error("Extension `"+s.value+"` is not known or not activated");return v}activateByEvent(s,u){if(this._alreadyActivatedEvents[s])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(v.map(D=>({id:D.identifier,reason:{startup:u,extensionId:D.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,u){const v=this._registry.getExtensionDescription(s);if(!v)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:v.identifier,reason:u}])}_handleActivateRequest(s,u,v){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(s.id))){u[d.ExtensionIdentifier.toKey(s.id)]=s;return}const D=this._registry.getExtensionDescription(s.id);if(!D){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,h,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(s.id),new _(h));return}const y=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let o=!0;for(let h=0,C=y.length;h<C;h++){const i=y[h];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const p=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(p&&!p.activationFailed)continue;if(p&&p.activationFailed){const l=D.displayName||D.identifier.value,m=this._registry.getExtensionDescription(i),b=m&&m.displayName||i,P=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);P.detail=p.activationFailedError,this._host.onExtensionActivationError(D.identifier,P,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(D.identifier),new _(P));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){if(!a.main&&!a.browser)continue;o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}const r=D.displayName||D.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(D.identifier,c,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(D.identifier),new _(c));return}o?u[d.ExtensionIdentifier.toKey(D.identifier)]=s:v.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(y=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(y.id))),s.length===0))return Promise.resolve(void 0);const u=Object.create(null),v=[];for(let y=0,o=s.length;y<o;y++)this._handleActivateRequest(s[y],u,v);for(let y=0,o=v.length;y<o;y++){const h=d.ExtensionIdentifier.toKey(v[y].id);u[h]&&delete u[h]}const D=Object.keys(u).map(y=>u[y]);return v.length===0?Promise.all(D.map(y=>this._activateExtension(y.id,y.reason))).then(y=>{}):this._activateExtensions(D).then(y=>this._activateExtensions(v))}_activateExtension(s,u){const v=d.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const D=this._activatingExtensions.get(v);if(D)return D;const y=this._host.actualActivateExtension(s,u).then(void 0,o=>{const h=new Error;return o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${s.value}' failed: ${o.message}.`:h.message=`Activating extension '${s.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this._host.onExtensionActivationError(s,h,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(o),new _(o)}).then(o=>{this._activatedExtensions.set(v,o),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,y),y}};n=$e([ze(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function E(S){const T=new d(!0,S);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=E;function A(S){const T=new d(!1,S);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function F(S){return M[S].sid}e.getStringIdentifierForProxy=F;class k{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=k}),define(be[5],Ee([0,1,55,2,38]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function h(i,p){return Object.defineProperty(i,o.name,{value:p,enumerable:!0}),i}o.mixin=h;function C(i){return i[o.name]}o.of=C})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(h){return h._id=f._n++,h}}e.IdObject=f,f._n=0;var s;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(o){if(o&&o.edits)for(const h of o.edits)typeof h.resource=="object"?h.resource=M.URI.revive(h.resource):(h.newUri=M.URI.revive(h.newUri),h.oldUri=M.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,d.revive)(h.metadata));return o}e.reviveWorkspaceEditDto=D;var y;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,T){return this._proxy.$setPassword(k,S,T)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,12]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(S,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(E.MainContext.MainThreadTelemetry)}report(S,T,t){const _=this.getUsageKey(S,T);this._reportedUsages.has(_)||(this._reportedUsages.add(_),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:S}))}getUsageKey(S,T){return`${S}-${T.identifier.value}`}};F=$e([ze(0,A.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,T){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,T,t,_={}){const n=A.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let u=f.find(v=>v.scopes===s);if(u)return u.result;{const v=this._getSession(S,n,T,t,_);u={scopes:s,result:v},f.push(u),this._inFlightRequests.set(n,f);try{await v}finally{const D=f.findIndex(y=>y.scopes===s);D>-1&&(f.splice(D),this._inFlightRequests.set(n,f))}return v}}async _getSession(S,T,t,_,n={}){await this._proxy.$ensureProvider(t);const f=S.displayName||S.name;return this._proxy.$getSession(t,_,T,f,n)}async removeSession(S,T){const t=this._authenticationProviders.get(S);return t?t.provider.removeSession(T):this._proxy.$removeSession(S,T)}registerAuthenticationProvider(S,T,t,_){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:T,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===S)||this._providers.push({id:S,label:T});const n=t.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(S,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,T,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const f=this._providers.findIndex(s=>s.id===S);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,T){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,T){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,T){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,T){return this._onDidChangeSessions.fire({provider:{id:S,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,12,8]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=E.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(k){return F.$writeText(k)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,13,15,55,44,112,2,6,4,12,49,22,38,45]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{constructor(c,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=c.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new C(this,m=>{const b=this._apiCommands.get(m);return b?.result===p.Void?b:void 0},l),this._argumentProcessors=[{processArgument(m){return(0,T.revive)(m)}},{processArgument(m){return(0,A.cloneAndChange)(m,function(b){if(t.Range.isIRange(b))return E.Range.to(b);if(_.Position.isIPosition(b))return E.Position.to(b);if(t.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return E.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const l=this.registerCommand(!1,c.id,async(...m)=>{const b=c.args.map((g,I)=>{if(!g.validate(m[I]))throw new Error(`Invalid argument '${g.name}' when running '${c.id}', received: ${m[I]}`);return g.convert(m[I])}),P=await this.executeCommand(c.internalId,...b);return c.result.convert(P,m,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,l,m,b,P,g){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:m,thisArg:b,description:P,extension:g}),c&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&c&&this._proxy.$unregisterCommand(l)})}executeCommand(c,...l){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,l,!0)}async _doExecuteCommand(c,l,m){if(this._commands.has(c))return this._executeContributedCommand(c,l,!1);{let b=!1;const P=(0,A.cloneAndChange)(l,function(g){if(g instanceof M.Position)return E.Position.from(g);if(g instanceof M.Range)return E.Range.from(g);if(g instanceof M.Location)return E.location.from(g);if(M.NotebookRange.isNotebookRange(g))return E.NotebookRange.from(g);if(g instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(g));if(g instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(g);if(!Array.isArray(g))return g});try{const g=await this._proxy.$executeCommand(c,b?new y.SerializableObjectWithBuffers(P):P,m);return(0,T.revive)(g)}catch(g){if(g instanceof Error&&g.message==="$executeCommand:retry")return this._doExecuteCommand(c,l,!1);throw g}}}async _executeContributedCommand(c,l,m){const b=this._commands.get(c);if(!b)throw new Error("Unknown command");let{callback:P,thisArg:g,description:I}=b;if(I)for(let R=0;R<I.args.length;R++)try{(0,d.validateConstraint)(l[R],I.args[R].constraint)}catch(L){throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${I.args[R].name}' - ${I.args[R].description}`)}try{return await P.apply(g,l)}catch(R){if(c===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...l);L&&(c=L.command)}throw this._logService.error(R,c,b.extension?.identifier),m?new class extends Error{constructor(){super((0,o.toErrorMessage)(R));this.id=c,this.source=b.extension?.displayName??b.extension?.name}}:R}}$executeContributedCommand(c,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(l=l.map(m=>this._argumentProcessors.reduce((b,P)=>P.processArgument(b),m)),this._executeContributedCommand(c,l,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),this._proxy.$getCommands().then(l=>(c&&(l=l.filter(m=>m[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[l,m]of this._commands){let{description:b}=m;b&&(c[l]=b)}return Promise.resolve(c)}};h=$e([ze(0,u.IExtHostRpcService),ze(1,S.ILogService)],h),e.ExtHostCommands=h,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class C{constructor(c,l,m){this._commands=c,this._lookupApiCommand=l,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,l){if(!c)return;const m={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return m;const b=this._lookupApiCommand(c.command);if(b)m.id=b.internalId,m.arguments=b.args.map((P,g)=>P.convert(c.arguments&&c.arguments[g]));else if((0,k.isNonEmptyArray)(c.arguments)){const P=++this._cachIdPool;this._cache.set(P,c),l.add((0,f.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this._logService.trace("CommandsConverter#CREATE",c.command,P)}return m}fromInternal(c){const l=F.ObjectIdentifier.of(c);return typeof l=="number"?this._cache.get(l):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const l=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=C;class i{constructor(c,l,m,b){this.name=c,this.description=l,this.validate=m,this.convert=b}optional(){return new i(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,l){return new i(c??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),i.Position=new i("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),i.Range=new i("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),i.Selection=new i("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),i.Number=new i("number","",r=>typeof r=="number",r=>r),i.String=new i("string","",r=>typeof r=="string",r=>r),i.CallHierarchyItem=new i("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,E.TestItem.from);class p{constructor(c,l){this.description=c,this.convert=l}}e.ApiCommandResult=p,p.Void=new p("no result",r=>r);class a{constructor(c,l,m,b,P){this.id=c,this.internalId=l,this.description=m,this.args=b,this.result=P}}e.ApiCommand=a}),define(be[184],Ee([0,1,8,7,59,39,13,81]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,F.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(v){const D=new s(v.name,d.SymbolKind.to(v.kind),v.containerName||"",new M.Location(f[0],d.Range.to(v.range)));return D.detail=v.detail,D.range=D.location.range,D.selectionRange=d.Range.to(v.selectionRange),D.children=v.children?v.children.map(s.to):[],D}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>M.Position.isPosition(f)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let s;for(const u of f.reverse())s=new M.SelectionRange(d.Range.to(u),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const f=[];if(Array.isArray(n))for(let s of n)f.push(...s[1].map(d.WorkspaceSymbol.to));return f})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:d.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,k.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,k.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,s)=>{if(!n)return new M.CompletionList([]);const u=n.suggestions.map(v=>d.CompletionItem.to(v,s));return new M.CompletionList(u,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,s)=>t(u=>new M.CodeLens(d.Range.to(u.range),u.command&&s.fromInternal(u.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,s)=>t(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(u.command)}else{const v=new M.CodeAction(u.title,u.kind?new M.CodeActionKind(u.kind):void 0);return u.edit&&(v.edit=d.WorkspaceEdit.to(u.edit)),u.command&&(v.command=s.fromInternal(u.command)),v.isPreferred=u.isPreferred,v}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new M.ColorInformation(d.Range.to(f.range),d.Color.to(f.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>d.NotebookExclusiveDocumentPattern.to(f))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(f){S.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function t(n){return f=>{if(Array.isArray(f))return f.map(n)}}function _(n){if(!Array.isArray(n))return;const f=[];for(const s of n)E.isLocationLink(s)?f.push(d.DefinitionLink.to(s)):f.push(d.location.to(s));return f}}),define(be[185],Ee([0,1,14,53,3,6,2,59,26,8,7,5]),function(se,e,d,M,E,A,F,k,S,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,s,u){const v=f.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const c=this._commentControllers.get(r.handle);return c||r}else if(r&&r.$mid===7){const c=this._commentControllers.get(r.commentControlHandle);if(!c)return r;const l=c.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const l=c.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const l=c.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let m=r.commentUniqueId,b=l.getCommentByUniqueId(m);return b||r}else if(r&&r.$mid===10){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const l=c.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let m=r.text,b=r.commentUniqueId,P=l.getCommentByUniqueId(b);return P?(P.body=m,P):r}return r}})}createCommentController(r,c,l){const m=D.handlePool++,b=new o(r,m,c,l);this._commentControllers.set(b.handle,b);const P=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(r.identifier))||[];return P.push(b),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(r.identifier),P),b.value}$createCommentThreadTemplate(r,c,l){const m=this._commentControllers.get(r);!m||m.$createCommentThreadTemplate(c,l)}async $updateCommentThreadTemplate(r,c,l){const m=this._commentControllers.get(r);!m||m.$updateCommentThreadTemplate(c,l)}$deleteCommentThread(r,c){const l=this._commentControllers.get(r);l&&l.$deleteCommentThread(c)}$provideCommentingRanges(r,c,l){const m=this._commentControllers.get(r);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const b=u.getDocument(F.URI.revive(c));return(0,d.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(b,l)).then(P=>P?P.map(g=>T.Range.from(g)):void 0)}$toggleReaction(r,c,l,m,b){const P=this._commentControllers.get(r);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const g=P.getCommentThread(c);if(g){const I=g.getCommentByUniqueId(m.uniqueIdInThread);if(P!==void 0&&I&&P.reactionHandler)return P.reactionHandler(I,i(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class y{constructor(r,c,l,m,b,P,g){this._commentControllerHandle=c,this._id=l,this._uri=m,this._range=b,this._comments=P,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),v.$createCommentThread(c,this.handle,this._id,this._uri,T.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(c,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(R){I.range=R},get comments(){return I.comments},set comments(R){I.comments=R},get collapsibleState(){return I.collapsibleState},set collapsibleState(R){I.collapsibleState=R},get canReply(){return I.canReply},set canReply(R){I.canReply=R},get contextValue(){return I.contextValue},set contextValue(R){I.contextValue=R},get label(){return I.label},set label(R){I.label=R},dispose:()=>{I.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),c={};r("range")&&(c.range=T.Range.from(this._range)),r("label")&&(c.label=this.label),r("contextValue")&&(c.contextValue=this.contextValue),r("comments")&&(c.comments=this._comments.map(l=>h(this,l,this._commentsMap))),r("collapsibleState")&&(c.collapseState=p(this._collapseState)),r("canReply")&&(c.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(r){for(let c of this._commentsMap){let l=c[0],m=c[1];if(r===m)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}y._handlePool=0,$e([(0,M.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(r,c,l,m){this._extension=r,this._handle=c,this._id=l,this._label=m,this._threads=new Map,v.$registerCommentController(this.handle,l,m);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(P){b.options=P},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(P){b.commentingRangeProvider=P},get reactionHandler(){return b.reactionHandler},set reactionHandler(P){b.reactionHandler=P},createCommentThread(P,g,I){return b.createCommentThread(P,g,I).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,c,l,m){if(typeof r=="string"){const b=new y(this.id,this.handle,r,c,l,m,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new y(this.id,this.handle,void 0,r,c,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(r,c){const l=new y(this.id,this.handle,void 0,F.URI.revive(r),T.Range.to(c),[],this._extension.identifier);return l.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(r,c){let l=this._threads.get(r);l&&(l.range=T.Range.to(c))}$deleteCommentThread(r){let c=this._threads.get(r);c&&c.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function h(a,r,c){let l=c.get(r);l||(l=++a.commentHandle,c.set(r,l));const m=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(r.body),userName:r.author.name,userIconPath:m,label:r.label,commentReactions:r.reactions?r.reactions.map(b=>C(b)):void 0}}function C(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?F.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function p(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class vi{constructor(f,s){this._logService=s,this._provider=new Map,this._proxy=f.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,s){const u=vi._handlePool++;this._provider.set(u,{provider:f,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const v=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(u,null);return}let y=(0,S.asArray)(D);if(y.length<=vi._maxEventSize){this._proxy.$onDidChange(u,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,y.length);const o=y.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),h=(0,S.groupBy)(o,(i,p)=>i.rank-p.rank||(0,T.compare)(i.uri.path,p.uri.path));let C=[];e:for(let i of h){let p;for(let a of i){let r=(0,t.dirname)(a.uri.path);if(p!==r&&(p=r,C.push(a.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(u,C)});return new E.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(f,s,u){if(!this._provider.has(f))return Object.create(null);const v=Object.create(null),{provider:D,extensionId:y}=this._provider.get(f);return await Promise.all(s.map(async o=>{try{const{uri:h,id:C}=o,i=await Promise.resolve(D.provideFileDecoration(d.URI.revive(h),u));if(!i)return;try{E.FileDecoration.validate(i),v[C]=[i.propagate,i.tooltip,i.badge,i.color]}catch(p){this._logService.warn(`INVALID decoration from extension '${y.value}': ${p}`)}}catch(h){this._logService.error(h)}})),v}};_._handlePool=0,_._maxEventSize=250,_=$e([ze(0,F.IExtHostRpcService),ze(1,k.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[186],Ee([0,1,124,83,2,5,7,8,3,15,20,37,104]),function(se,e,d,M,E,A,F,k,S,T,t,_,n){"use strict";var f,s,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(o,h,C,i,p,a){this._name=o,this._owner=h,this._maxDiagnosticsPerFile=C,f.set(this,void 0),s.set(this,void 0),u.set(this,void 0),this._isDisposed=!1,et(this,u,new n.SkipList((r,c)=>i.compare(r,c)),"f"),et(this,f,p,"f"),et(this,s,a,"f")}dispose(){this._isDisposed||(Ae(this,s,"f").fire([...Ae(this,u,"f").keys()]),Ae(this,f,"f")&&Ae(this,f,"f").$clear(this._owner),Ae(this,u,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,h){if(!o){this.clear();return}this._checkDisposed();let C=[];if(E.URI.isUri(o)){if(!h){this.delete(o);return}Ae(this,u,"f").set(o,h.slice()),C=[o]}else if(Array.isArray(o)){C=[];let p;o=[...o].sort(v._compareIndexedTuplesByUri);for(const a of o){const[r,c]=a;if((!p||r.toString()!==p.toString())&&(p&&Ae(this,u,"f").get(p).length===0&&Ae(this,u,"f").delete(p),p=r,C.push(r),Ae(this,u,"f").set(r,[])),c){const l=Ae(this,u,"f").get(r);l&&l.push(...c)}else{const l=Ae(this,u,"f").get(r);l&&(l.length=0)}}}if(Ae(this,s,"f").fire(C),!Ae(this,f,"f"))return;const i=[];for(let p of C){let a=[];const r=Ae(this,u,"f").get(p);if(r)if(r.length>this._maxDiagnosticsPerFile){a=[];const c=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let m of r)if(m.severity===c[l]&&a.push(k.Diagnostic.from(m))===this._maxDiagnosticsPerFile)break e;a.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(c=>k.Diagnostic.from(c));i.push([p,a])}Ae(this,f,"f").$changeMany(this._owner,i)}delete(o){this._checkDisposed(),Ae(this,s,"f").fire([o]),Ae(this,u,"f").delete(o),Ae(this,f,"f")&&Ae(this,f,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Ae(this,s,"f").fire([...Ae(this,u,"f").keys()]),Ae(this,u,"f").clear(),Ae(this,f,"f")&&Ae(this,f,"f").$clear(this._owner)}forEach(o,h){this._checkDisposed();for(let C of Ae(this,u,"f").keys())o.apply(h,[C,this.get(C),this])}get(o){this._checkDisposed();const h=Ae(this,u,"f").get(o);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Ae(this,u,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,h){return o[0].toString()<h[0].toString()?-1:o[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=v,f=new WeakMap,s=new WeakMap,u=new WeakMap;let D=class Zt{constructor(o,h,C){this._logService=h,this._fileSystemInfoService=C,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=o.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(o){const h=new t.ResourceMap;for(const C of o)h.set(C,C);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(o,h){const{_collections:C,_proxy:i,_onDidChangeDiagnostics:p,_logService:a,_fileSystemInfoService:r}=this,c=new class{$changeMany(b,P){i.$changeMany(b,P),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,b,P.length===0?"CLEARING":P)}$clear(b){i.$clear(b),a.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,b)}dispose(){i.dispose()}};let l;if(!h)h="_generated_diagnostic_collection_name_#"+Zt._idPool++,l=h;else if(!C.has(h))l=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do l=h+Zt._idPool++;while(C.has(l))}return new class extends v{constructor(){super(h,l,Zt._maxDiagnosticsPerFile,r.extUri,c,p);C.set(l,this)}dispose(){super.dispose(),C.delete(l)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const h=new Map,C=[];for(const i of this._collections.values())i.forEach((p,a)=>{let r=h.get(p.toString());typeof r=="undefined"&&(r=C.length,h.set(p.toString(),r),C.push([p,[]])),C[r][1]=C[r][1].concat(...a)});return C}}_getDiagnostics(o){let h=[];for(let C of this._collections.values())C.has(o)&&(h=h.concat(C.get(o)));return h}$acceptMarkersChange(o){if(!this._mirrorCollection){const h="_generated_mirror",C=new v(h,h,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,C),this._mirrorCollection=C}for(const[h,C]of o)this._mirrorCollection.set(E.URI.revive(h),C.map(k.Diagnostic.to))}};D._idPool=0,D._maxDiagnosticsPerFile=1e3,D=$e([ze(1,T.ILogService),ze(2,_.IExtHostFileSystemInfo)],D),e.ExtHostDiagnostics=D}),define(be[187],Ee([0,1,2,5]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(k=>k?k.map(S=>d.URI.revive(S)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(k=>k?d.URI.revive(k):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(_,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(F.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,_);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(u=>{if(u.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(f,u).then(v=>{if(!v&&typeof v!="string")return;const D=this._documentsAndEditors.getDocument(u);if(!D)return;const y=(0,S.splitLines)(v);if(!D.equalLines(y))return this._proxy.$onVirtualDocumentChange(u,v)},d.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(_,n){const f=this._documentContentProviders.get(_);return f?Promise.resolve(f.provideTextDocumentContent(M.URI.revive(n),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(f,s){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const v of u)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const v of u)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const s=this._documentsAndEditors.getDocument(f);if(s)return s}getDocument(f){const s=this.getDocumentData(f);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return s.document}ensureDocumentData(f){const s=this._documentsAndEditors.getDocument(f);if(s)return Promise.resolve(s);let u=this._documentLoader.get(f.toString());return u||(u=this._proxy.$tryOpenDocument(f).then(v=>{this._documentLoader.delete(f.toString());const D=E.URI.revive(v);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(D))},v=>(this._documentLoader.delete(f.toString()),Promise.reject(v))),this._documentLoader.set(f.toString(),u)),u}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(s=>E.URI.revive(s))}$acceptModelModeChanged(f,s){const u=E.URI.revive(f),v=this._documentsAndEditors.getDocument(u);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(s),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(f){const s=E.URI.revive(f),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(f,s){const u=E.URI.revive(f),v=this._documentsAndEditors.getDocument(u);if(!v)throw new Error("unknown document");v._acceptIsDirty(s),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,s,u){const v=E.URI.revive(f),D=this._documentsAndEditors.getDocument(v);if(!D)throw new Error("unknown document");D._acceptIsDirty(u),D.onEvents(s);let y;s.isUndoing?y=t.TextDocumentChangeReason.Undo:s.isRedoing&&(y=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:D.document,contentChanges:s.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:y}))}setWordDefinitionFor(f,s){(0,F.setWordDefinitionFor)(f,s)}}e.ExtHostDocuments=_}),define(be[50],Ee([0,1,42,3,6,2,4,5,88,12,94,8,15,20,11,232,103]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(h,C){this._extHostRpc=h,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const C=[],i=[],p=[];if(h.removedDocuments)for(const a of h.removedDocuments){const r=A.URI.revive(a),c=this._documents.get(r);c?.unref()&&(this._documents.delete(r),C.push(c.value))}if(h.addedDocuments)for(const a of h.addedDocuments){const r=A.URI.revive(a.uri);let c=this._documents.get(r);if(c&&r.scheme!==s.Schemas.vscodeNotebookCell&&r.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);c||(c=new D(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(r,c),i.push(c.value)),c.ref()}if(h.removedEditors)for(const a of h.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&p.push(r)}if(h.addedEditors)for(const a of h.addedEditors){const r=A.URI.revive(a.documentUri);d.ok(this._documents.has(r),`document '${r}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const c=this._documents.get(r).value,l=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>c.document),a.selections.map(_.Selection.to),a.options,a.visibleRanges.map(m=>_.Range.to(m)),typeof a.editorPosition=="number"?_.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,l)}h.newActiveEditor!==void 0&&(d.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,E.dispose)(C),(0,E.dispose)(p),h.removedDocuments&&this._onDidRemoveDocuments.fire(C),h.addedDocuments&&this._onDidAddDocuments.fire(i),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return h?C:C?.value}allEditors(){return[...this._editors.values()]}};y=$e([ze(0,T.IExtHostRpcService),ze(1,n.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[71],Ee([0,1,8,5,2,3,4,12,14]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let T=class{constructor(_){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((s,u)=>(s.isActive&&(n=u),Object.freeze({label:s.label,viewColumn:d.ViewColumn.to(s.viewColumn),index:u,resource:E.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:v,viewId:D})=>({resource:E.URI.revive(v),viewId:D})),viewId:s.editorId,isActive:s.isActive,move:async(v,D)=>{this._proxy.$moveTab(s,v,d.ViewColumn.from(D)),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,u)=>s.viewColumn===u.viewColumn?s.index-u.index:s.viewColumn-u.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=$e([ze(0,k.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,22]),function(se,e,d,M,E,A,F,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const s=this._schemes.indexOf(f);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),s=[];let u,v,D=14,y=14;for(const o of f){let h=u?(0,S.commonPrefixLength)(u,o):0;for(h===0?v=1:v=y;h<o.length;h++)h+1===o.length?(D=y,y=9):y+=1,s.push([v,o.toUpperCase().charCodeAt(h),y]),s.push([v,o.toLowerCase().charCodeAt(h),y]),v=y;u=o,y=D}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(f){this._initStateMachine();const s=[],u=k.LinkComputer.computeLinks({getLineContent(v){return f.lineAt(v-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const v of u){const D=F.DocumentLink.to(v);D.target&&s.push(D)}return s}}class _{constructor(f,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,s,u,v={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const D=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(D,u);let y=2;v.isCaseSensitive&&(y+=1024),v.isReadonly&&(y+=2048),typeof u.copy=="function"&&(y+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(y+=4),this._proxy.$registerFileSystemProvider(D,s,y).catch(h=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${s}`),console.error(h)});const o=u.onDidChangeFile(h=>{const C=[];for(const i of h){let{uri:p,type:a}=i;if(p.scheme!==s)continue;let r;switch(a){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}C.push({resource:p,type:r})}this._proxy.$onFileSystemChange(D,C)});return(0,E.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(f){const{type:s,ctime:u,mtime:v,size:D,permissions:y}=f;return{type:s,ctime:u,mtime:v,size:D,permissions:y}}$stat(f,s){return Promise.resolve(this._getFsProvider(f).stat(d.URI.revive(s))).then(u=>_._asIStat(u))}$readdir(f,s){return Promise.resolve(this._getFsProvider(f).readDirectory(d.URI.revive(s)))}$readFile(f,s){return Promise.resolve(this._getFsProvider(f).readFile(d.URI.revive(s))).then(u=>T.VSBuffer.wrap(u))}$writeFile(f,s,u,v){return Promise.resolve(this._getFsProvider(f).writeFile(d.URI.revive(s),u.buffer,v))}$delete(f,s,u){return Promise.resolve(this._getFsProvider(f).delete(d.URI.revive(s),u))}$rename(f,s,u,v){return Promise.resolve(this._getFsProvider(f).rename(d.URI.revive(s),d.URI.revive(u),v))}$copy(f,s,u,v){const D=this._getFsProvider(f);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(d.URI.revive(s),d.URI.revive(u),v))}$mkdir(f,s){return Promise.resolve(this._getFsProvider(f).createDirectory(d.URI.revive(s)))}$watch(f,s,u,v){const D=this._getFsProvider(f).watch(d.URI.revive(u),v);this._watches.set(s,D)}$unwatch(f,s){const u=this._watches.get(s);u&&(u.dispose(),this._watches.delete(s))}$open(f,s,u){const v=this._getFsProvider(f);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(d.URI.revive(s),u))}$close(f,s){const u=this._getFsProvider(f);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(s))}$read(f,s,u,v){const D=this._getFsProvider(f);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const y=T.VSBuffer.alloc(v);return Promise.resolve(D.read(s,u,y.buffer,0,v)).then(o=>y.slice(0,o))}$write(f,s,u,v){const D=this._getFsProvider(f);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(s,u,v.buffer,0,v.byteLength))}_getFsProvider(f){const s=this._fsProvider.get(f);if(!s){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return s}}e.ExtHostFileSystem=_}),define(be[72],Ee([0,1,5,60,7,22,4,12,37]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Bt{constructor(_,n){const f=_.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return f.$stat(s).catch(Bt._handleError)},readDirectory(s){return f.$readdir(s).catch(Bt._handleError)},createDirectory(s){return f.$mkdir(s).catch(Bt._handleError)},async readFile(s){return f.$readFile(s).then(u=>u.buffer).catch(Bt._handleError)},writeFile(s,u){return f.$writeFile(s,A.VSBuffer.wrap(u)).catch(Bt._handleError)},delete(s,u){return f.$delete(s,{recursive:!1,useTrash:!1,...u}).catch(Bt._handleError)},rename(s,u,v){return f.$rename(s,u,{overwrite:!1,...v}).catch(Bt._handleError)},copy(s,u,v){return f.$copy(s,u,{overwrite:!1,...v}).catch(Bt._handleError)},isWritableFileSystem(s){const u=n.getCapabilities(s);if(typeof u=="number")return!(u&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};T=$e([ze(0,k.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,k,S,T){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,k,S,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:S,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(se,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,13,10,234,6,81,54,64,194,16,3]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentSymbols(U,Q){const ie=this._documents.getDocument(U),ae=await this._provider.provideDocumentSymbols(ie,Q);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((ae,G)=>{let oe=ae.location.range.start.compareTo(G.location.range.start);return oe===0&&(oe=G.location.range.end.compareTo(ae.location.range.end)),oe});const Q=[],ie=[];for(const ae of U){const G={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(ie.length===0){ie.push(G),Q.push(G);break}const oe=ie[ie.length-1];if(S.Range.containsRange(oe.range,G.range)&&!S.Range.equalsRange(oe.range,G.range)){oe.children&&oe.children.push(G),ie.push(G);break}ie.pop()}}return Q}}class h{constructor(U,Q,ie){this._documents=U,this._commands=Q,this._provider=ie,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,Q){const ie=this._documents.getDocument(U),ae=await this._provider.provideCodeLenses(ie,Q);if(!ae||Q.isCancellationRequested)return;const G=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(G,oe);const he={cacheId:G,lenses:[]};for(let Te=0;Te<ae.length;Te++)he.lenses.push({cacheId:[G,Te],range:E.Range.from(ae[Te].range),command:this._commands.toInternal(ae[Te].command,oe)});return he}async resolveCodeLens(U,Q){const ie=U.cacheId&&this._cache.get(...U.cacheId);if(!ie)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?ae=ie:ae=await this._provider.resolveCodeLens(ie,Q),ae||(ae=ie),Q.isCancellationRequested)return;const G=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!G)return U.command=this._commands.toInternal(ae.command??h._badCmd,G),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function C(Ve){return Array.isArray(Ve)?Ve.map(E.DefinitionLink.from):Ve?[E.DefinitionLink.from(Ve)]:[]}class i{constructor(U,Q){this._documents=U,this._provider=Q}async provideDefinition(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideDefinition(ae,G,ie);return C(oe)}}class p{constructor(U,Q){this._documents=U,this._provider=Q}async provideDeclaration(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideDeclaration(ae,G,ie);return C(oe)}}class a{constructor(U,Q){this._documents=U,this._provider=Q}async provideImplementation(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideImplementation(ae,G,ie);return C(oe)}}class r{constructor(U,Q){this._documents=U,this._provider=Q}async provideTypeDefinition(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideTypeDefinition(ae,G,ie);return C(oe)}}class c{constructor(U,Q){this._documents=U,this._provider=Q}async provideHover(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideHover(ae,G,ie);if(!(!oe||(0,T.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(G)),oe.range||(oe.range=new A.Range(G,G)),E.Hover.from(oe)}}class l{constructor(U,Q){this._documents=U,this._provider=Q}async provideEvaluatableExpression(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideEvaluatableExpression(ae,G,ie);if(oe)return E.EvaluatableExpression.from(oe)}}class m{constructor(U,Q){this._documents=U,this._provider=Q}async provideInlineValues(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=await this._provider.provideInlineValues(G,E.Range.to(Q),E.InlineValueContext.to(ie),ae);if(Array.isArray(oe))return oe.map(he=>E.InlineValue.from(he))}}class b{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentHighlights(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideDocumentHighlights(ae,G,ie);if(Array.isArray(oe))return oe.map(E.DocumentHighlight.from)}}class P{constructor(U,Q){this._documents=U,this._provider=Q}async provideLinkedEditingRanges(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideLinkedEditingRanges(ae,G,ie);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,T.coalesce)(oe.ranges.map(E.Range.from)),wordPattern:oe.wordPattern}}}class g{constructor(U,Q){this._documents=U,this._provider=Q}async provideReferences(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=await this._provider.provideReferences(G,oe,ie,ae);if(Array.isArray(he))return he.map(E.location.from)}}class I{constructor(U,Q,ie,ae,G,oe,he){this._documents=U,this._commands=Q,this._diagnostics=ie,this._provider=ae,this._logService=G,this._extension=oe,this._apiDeprecation=he,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=_.Selection.isISelection(Q)?E.Selection.to(Q):E.Range.to(Q),he=[];for(const Ce of this._diagnostics.getDiagnostics(U))if(oe.intersection(Ce.range)&&he.push(Ce)>I._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:ie.only?new A.CodeActionKind(ie.only):void 0,triggerKind:E.CodeActionTriggerKind.to(ie.trigger)},Be=await this._provider.provideCodeActions(G,oe,Te,ae);if(!(0,T.isNonEmptyArray)(Be)||ae.isCancellationRequested)return;const He=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set(He,Qe);const it=[];for(let Ce=0;Ce<Be.length;Ce++){const Ze=Be[Ce];!Ze||(I._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,Qe)})):(Te.only&&(Ze.kind?Te.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[He,Ce],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,Qe),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(E.Diagnostic.from),edit:Ze.edit&&E.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:He,actions:it}}async resolveCodeAction(U,Q){const[ie,ae]=U,G=this._cache.get(ie,ae);if(!G||I._isCommand(G)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(G,Q)??G;return oe?.edit?E.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}I._maxCodeActionsPerFile=1e3;class R{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentFormattingEdits(U,Q,ie){const ae=this._documents.getDocument(U),G=await this._provider.provideDocumentFormattingEdits(ae,Q,ie);if(Array.isArray(G))return G.map(E.TextEdit.from)}}class L{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentRangeFormattingEdits(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=E.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(G,oe,ie,ae);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class w{constructor(U,Q){this._documents=U,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Q,ie,ae,G){const oe=this._documents.getDocument(U),he=E.Position.to(Q),Te=await this._provider.provideOnTypeFormattingEdits(oe,he,ie,ae,G);if(Array.isArray(Te))return Te.map(E.TextEdit.from)}}class x{constructor(U,Q){this._provider=U,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,Q){const ie=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(U,Q);if((0,T.isNonEmptyArray)(ae))for(const G of ae){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const oe=F.IdObject.mixin(E.WorkspaceSymbol.from(G));this._symbolCache.set(oe._id,G),ie.symbols.push(oe)}return ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie}async resolveWorkspaceSymbol(U,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const ie=this._symbolCache.get(U._id);if(ie){const ae=await this._provider.resolveWorkspaceSymbol(ie,Q);return ae&&(0,M.mixin)(U,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(U){const Q=this._resultCache.get(U);if(Q){for(let[ie,ae]=Q;ie<=ae;ie++)this._symbolCache.delete(ie);this._resultCache.delete(U)}}}class ${constructor(U,Q,ie){this._documents=U,this._provider=Q,this._logService=ie}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q);try{const he=await this._provider.provideRenameEdits(G,oe,ie,ae);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Te=$._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(U,Q,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(U),G=E.Position.to(Q);try{const oe=await this._provider.prepareRename(ae,G,ie);let he,Te;if(A.Range.isRange(oe)?(he=oe,Te=ae.getText(oe)):(0,t.isObject)(oe)&&(he=oe.range,Te=oe.placeholder),!he||!Te)return;if(he.start.line>G.line||he.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Te}}catch(oe){const he=$._asMessage(oe);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class B{constructor(U,Q){this.resultId=U,this.tokens=Q}}class K{constructor(U,Q){this._documents=U,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,Q,ie){const ae=this._documents.getDocument(U),G=Q!==0?this._previousResults.get(Q):null;let oe=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,G.resultId,ie):await this._provider.provideDocumentSemanticTokens(ae,ie);return G&&this._previousResults.delete(Q),oe?(oe=K._fixProvidedSemanticTokens(oe),this._send(K._convertToEdits(G,oe),oe)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return K._isSemanticTokens(U)?K._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):K._isSemanticTokensEdits(U)?K._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(Q=>new A.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const Q of U.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,Q){if(!K._isSemanticTokens(Q)||!U||!U.tokens)return Q;const ie=U.tokens,ae=ie.length,G=Q.data,oe=G.length;let he=0;const Te=Math.min(ae,oe);for(;he<Te&&ie[he]===G[he];)he++;if(he===ae&&he===oe)return new A.SemanticTokensEdits([],Q.resultId);let Be=0;const He=Te-he;for(;Be<He&&ie[ae-Be-1]===G[oe-Be-1];)Be++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Be,data:G.subarray(he,oe-Be)}],Q.resultId)}_send(U,Q){if(K._isSemanticTokens(U)){const ie=this._nextResultId++;return this._previousResults.set(ie,new B(U.resultId,U.data)),(0,f.encodeSemanticTokensDto)({id:ie,type:"full",data:U.data})}if(K._isSemanticTokensEdits(U)){const ie=this._nextResultId++;return K._isSemanticTokens(Q)?this._previousResults.set(ie,new B(Q.resultId,Q.data)):this._previousResults.set(ie,new B(U.resultId)),(0,f.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(U.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class H{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentRangeSemanticTokens(U,Q,ie){const ae=this._documents.getDocument(U),G=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(Q),ie);return G?this._send(G):null}_send(U){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=H;class W{constructor(U,Q,ie,ae,G){this._documents=U,this._commands=Q,this._provider=ie,this._apiDeprecation=ae,this._extension=G,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=G.getWordRangeAtPosition(oe)||new A.Range(oe,oe),Te=he.with({end:oe}),Be=new v.StopWatch(!0),He=await this._provider.provideCompletionItems(G,oe,ae,E.CompletionContext.to(ie));if(!He||ae.isCancellationRequested)return;const Qe=Array.isArray(He)?new A.CompletionList(He):He,it=W.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),Ce=new n.DisposableStore;this._disposables.set(it,Ce);const Ze=[],j={x:it,b:Ze,a:{replace:E.Range.from(he),insert:E.Range.from(Te)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let J=0;J<Qe.items.length;J++){const me=Qe.items[J],We=this._convertCompletionItem(me,[it,J],Te,he);Ze.push(We)}return j}async resolveCompletionItem(U,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...U);if(!ie)return;const ae=await this._provider.resolveCompletionItem(ie,Q);if(!!ae)return this._convertCompletionItem(ae,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,Q,ie,ae){const G=this._disposables.get(Q[0]);if(!G)throw Error("DisposableStore is missing...");const oe={x:Q,a:U.label,b:U.kind!==void 0?E.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(E.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(U.command,G)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=U.textEdit.newText):typeof U.insertText=="string"?oe.h=U.insertText:U.insertText instanceof A.SnippetString&&(oe.h=U.insertText.value,oe.i|=4);let he;return U.textEdit?he=U.textEdit.range:U.range&&(he=U.range),A.Range.isRange(he)?oe.j=E.Range.from(he):he&&(!ie?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(oe.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),oe}}class ne{constructor(U,Q,ie){this._documents=U,this._provider=Q,this._commands=ie,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=await this._provider.provideInlineCompletionItems(G,oe,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:E.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:ie.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Te.items);let He;return{pid:Be,items:Te.items.map((Qe,it)=>{let Ce;return Qe.command&&(He||(He=new n.DisposableStore,this._disposables.set(Be,He)),Ce=this._commands.toInternal(Qe.command,He)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:Ce,idx:it}})}}disposeCompletions(U){this._cache.delete(U);const Q=this._disposables.get(U);Q&&Q.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,Q){const ie=this._cache.get(U,Q);ie&&V.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class V{constructor(){this._onDidShowCompletionItemEmitter=new y.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let Q=V.map.get(U);return Q||(Q=new V,V.map.set(U,Q)),Q}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=V,V.map=new WeakMap;class X{constructor(U,Q){this._documents=U,this._provider=Q,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(U,Q,ie,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=this.reviveContext(ie),Te=await this._provider.provideSignatureHelp(G,oe,ae,he);if(Te){const Be=this._cache.add([Te]);return{...E.SignatureHelp.from(Te),id:Be}}}reviveContext(U){let Q;if(U.activeSignatureHelp){const ie=E.SignatureHelp.to(U.activeSignatureHelp),ae=this._cache.get(U.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=ie.activeSignature,Q.activeParameter=ie.activeParameter):Q=ie}return{...U,activeSignatureHelp:Q}}releaseSignatureHelp(U){this._cache.delete(U)}}class q{constructor(U,Q){this._documents=U,this._provider=Q}async provideInlayHints(U,Q,ie){const ae=this._documents.getDocument(U),G=await this._provider.provideInlayHints(ae,E.Range.to(Q),ie);return G?{hints:G.map(E.InlayHint.from)}:void 0}}class le{constructor(U,Q){this._documents=U,this._provider=Q,this._cache=new u.Cache("DocumentLink")}async provideLinks(U,Q){const ie=this._documents.getDocument(U),ae=await this._provider.provideDocumentLinks(ie,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(E.DocumentLink.from)};{const G=this._cache.add(ae),oe={links:[],id:G};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Te=E.DocumentLink.from(ae[he]);Te.cacheId=[G,he],oe.links.push(Te)}return oe}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...U);if(!ie)return;const ae=await this._provider.resolveDocumentLink(ie,Q);if(!(!ae||!le._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks(U){this._cache.delete(U)}}class te{constructor(U,Q){this._documents=U,this._provider=Q}async provideColors(U,Q){const ie=this._documents.getDocument(U),ae=await this._provider.provideDocumentColors(ie,Q);return Array.isArray(ae)?ae.map(oe=>({color:E.Color.from(oe.color),range:E.Range.from(oe.range)})):[]}async provideColorPresentations(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Range.to(Q.range),oe=E.Color.to(Q.color),he=await this._provider.provideColorPresentations(oe,{document:ae,range:G},ie);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor(U,Q){this._documents=U,this._provider=Q}async provideFoldingRanges(U,Q,ie){const ae=this._documents.getDocument(U),G=await this._provider.provideFoldingRanges(ae,Q,ie);if(!!Array.isArray(G))return G.map(E.FoldingRange.from)}}class Re{constructor(U,Q,ie){this._documents=U,this._provider=Q,this._logService=ie}async provideSelectionRanges(U,Q,ie){const ae=this._documents.getDocument(U),G=Q.map(E.Position.to),oe=await this._provider.provideSelectionRanges(ae,G,ie);if(!(0,T.isNonEmptyArray)(oe))return[];if(oe.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<G.length;Te++){const Be=[];he.push(Be);let He=G[Te],Qe=oe[Te];for(;;){if(!Qe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(E.SelectionRange.from(Qe)),!Qe.parent)break;He=Qe.range,Qe=Qe.parent}}return he}}class Fe{constructor(U,Q){this._documents=U,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.prepareCallHierarchy(ae,G,ie);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideCallsTo(U,Q,ie){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(ae,ie);if(!!G)return G.map(oe=>({from:this._cacheAndConvertItem(U,oe.from),fromRanges:oe.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom(U,Q,ie){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(ae,ie);if(!!G)return G.map(oe=>({to:this._cacheAndConvertItem(U,oe.to),fromRanges:oe.fromRanges.map(he=>E.Range.from(he))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,Q){const ie=this._cache.get(U),ae=E.CallHierarchyItem.from(Q,U,ie.size.toString(36));return ie.set(ae._itemId,Q),ae}_itemFromCache(U,Q){return this._cache.get(U)?.get(Q)}}class Oe{constructor(U,Q){this._documents=U,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,Q,ie){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.prepareTypeHierarchy(ae,G,ie);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideSupertypes(U,Q,ie){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(ae,ie);if(!!G)return G.map(oe=>this._cacheAndConvertItem(U,oe))}async provideSubtypes(U,Q,ie){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(ae,ie);if(!!G)return G.map(oe=>this._cacheAndConvertItem(U,oe))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,Q){const ie=this._cache.get(U),ae=E.TypeHierarchyItem.from(Q,U,ie.size.toString(36));return ie.set(ae._itemId,Q),ae}_itemFromCache(U,Q){return this._cache.get(U)?.get(Q)}}class Ke{constructor(U,Q){this.adapter=U,this.extension=Q}}class je{constructor(U,Q,ie,ae,G,oe,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=U.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=ae,this._diagnostics=G,this._logService=oe,this._apiDeprecation=he}_transformDocumentSelector(U){return E.DocumentSelector.from(U,this._uriTransformer)}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return je._handlePool++}_withAdapter(U,Q,ie,ae,G=!1){const oe=this._adapter.get(U);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Q){let he;oe.extension&&(he=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Te=ie(oe.adapter,oe.extension),Be=oe.extension;return Be&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{G&&He instanceof D.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,Q){const ie=this._nextHandle();return this._adapter.set(ie,new Ke(U,Q)),ie}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Q,ie,ae){const G=this._addNewAdapter(new o(this._documents,ie),U),oe=ae&&ae.label||je._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(Q),oe),this._createDisposable(G)}$provideDocumentSymbols(U,Q,ie){return this._withAdapter(U,o,ae=>ae.provideDocumentSymbols(d.URI.revive(Q),ie),void 0)}registerCodeLensProvider(U,Q,ie){const ae=this._nextHandle(),G=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new h(this._documents,this._commands.converter,ie),U)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),G);let oe=this._createDisposable(ae);if(G!==void 0){const he=ie.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(G));oe=A.Disposable.from(oe,he)}return oe}$provideCodeLenses(U,Q,ie){return this._withAdapter(U,h,ae=>ae.provideCodeLenses(d.URI.revive(Q),ie),void 0)}$resolveCodeLens(U,Q,ie){return this._withAdapter(U,h,ae=>ae.resolveCodeLens(Q,ie),void 0)}$releaseCodeLenses(U,Q){this._withAdapter(U,h,ie=>Promise.resolve(ie.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(U,Q,ie){const ae=this._addNewAdapter(new i(this._documents,ie),U);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(U,Q,ie,ae){return this._withAdapter(U,i,G=>G.provideDefinition(d.URI.revive(Q),ie,ae),[])}registerDeclarationProvider(U,Q,ie){const ae=this._addNewAdapter(new p(this._documents,ie),U);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(U,Q,ie,ae){return this._withAdapter(U,p,G=>G.provideDeclaration(d.URI.revive(Q),ie,ae),[])}registerImplementationProvider(U,Q,ie){const ae=this._addNewAdapter(new a(this._documents,ie),U);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(U,Q,ie,ae){return this._withAdapter(U,a,G=>G.provideImplementation(d.URI.revive(Q),ie,ae),[])}registerTypeDefinitionProvider(U,Q,ie){const ae=this._addNewAdapter(new r(this._documents,ie),U);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(U,Q,ie,ae){return this._withAdapter(U,r,G=>G.provideTypeDefinition(d.URI.revive(Q),ie,ae),[])}registerHoverProvider(U,Q,ie,ae){const G=this._addNewAdapter(new c(this._documents,ie),U);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(Q)),this._createDisposable(G)}$provideHover(U,Q,ie,ae){return this._withAdapter(U,c,G=>G.provideHover(d.URI.revive(Q),ie,ae),void 0)}registerEvaluatableExpressionProvider(U,Q,ie,ae){const G=this._addNewAdapter(new l(this._documents,ie),U);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(Q)),this._createDisposable(G)}$provideEvaluatableExpression(U,Q,ie,ae){return this._withAdapter(U,l,G=>G.provideEvaluatableExpression(d.URI.revive(Q),ie,ae),void 0)}registerInlineValuesProvider(U,Q,ie,ae){const G=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new m(this._documents,ie),U);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Q),G);let he=this._createDisposable(oe);if(G!==void 0){const Te=ie.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(G));he=A.Disposable.from(he,Te)}return he}$provideInlineValues(U,Q,ie,ae,G){return this._withAdapter(U,m,oe=>oe.provideInlineValues(d.URI.revive(Q),ie,ae,G),void 0)}registerDocumentHighlightProvider(U,Q,ie){const ae=this._addNewAdapter(new b(this._documents,ie),U);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(U,Q,ie,ae){return this._withAdapter(U,b,G=>G.provideDocumentHighlights(d.URI.revive(Q),ie,ae),void 0)}registerLinkedEditingRangeProvider(U,Q,ie){const ae=this._addNewAdapter(new P(this._documents,ie),U);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(U,Q,ie,ae){return this._withAdapter(U,P,async G=>{const oe=await G.provideLinkedEditingRanges(d.URI.revive(Q),ie,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?je._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(U,Q,ie){const ae=this._addNewAdapter(new g(this._documents,ie),U);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(U,Q,ie,ae,G){return this._withAdapter(U,g,oe=>oe.provideReferences(d.URI.revive(Q),ie,ae,G),void 0)}registerCodeActionProvider(U,Q,ie,ae){const G=new n.DisposableStore,oe=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,G)}))},je._extLabel(U),Boolean(ie.resolveCodeAction)),G.add(this._createDisposable(oe)),G}$provideCodeActions(U,Q,ie,ae,G){return this._withAdapter(U,I,oe=>oe.provideCodeActions(d.URI.revive(Q),ie,ae,G),void 0)}$resolveCodeAction(U,Q,ie){return this._withAdapter(U,I,ae=>ae.resolveCodeAction(Q,ie),void 0)}$releaseCodeActions(U,Q){this._withAdapter(U,I,ie=>Promise.resolve(ie.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(U,Q,ie){const ae=this._addNewAdapter(new R(this._documents,ie),U);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(U,Q,ie,ae){return this._withAdapter(U,R,G=>G.provideDocumentFormattingEdits(d.URI.revive(Q),ie,ae),void 0)}registerDocumentRangeFormattingEditProvider(U,Q,ie){const ae=this._addNewAdapter(new L(this._documents,ie),U);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(U,Q,ie,ae,G){return this._withAdapter(U,L,oe=>oe.provideDocumentRangeFormattingEdits(d.URI.revive(Q),ie,ae,G),void 0)}registerOnTypeFormattingEditProvider(U,Q,ie,ae){const G=this._addNewAdapter(new w(this._documents,ie),U);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(Q),ae,U.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(U,Q,ie,ae,G,oe){return this._withAdapter(U,w,he=>he.provideOnTypeFormattingEdits(d.URI.revive(Q),ie,ae,G,oe),void 0)}registerWorkspaceSymbolProvider(U,Q){const ie=this._addNewAdapter(new x(Q,this._logService),U);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(U,Q,ie){return this._withAdapter(U,x,ae=>ae.provideWorkspaceSymbols(Q,ie),{symbols:[]})}$resolveWorkspaceSymbol(U,Q,ie){return this._withAdapter(U,x,ae=>ae.resolveWorkspaceSymbol(Q,ie),void 0)}$releaseWorkspaceSymbols(U,Q){this._withAdapter(U,x,ie=>ie.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(U,Q,ie){const ae=this._addNewAdapter(new $(this._documents,ie,this._logService),U);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),$.supportsResolving(ie)),this._createDisposable(ae)}$provideRenameEdits(U,Q,ie,ae,G){return this._withAdapter(U,$,oe=>oe.provideRenameEdits(d.URI.revive(Q),ie,ae,G),void 0)}$resolveRenameLocation(U,Q,ie,ae){return this._withAdapter(U,$,G=>G.resolveRenameLocation(d.URI.revive(Q),ie,ae),void 0)}registerDocumentSemanticTokensProvider(U,Q,ie,ae){const G=this._nextHandle(),oe=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Ke(new K(this._documents,ie),U)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(Q),ae,oe);let he=this._createDisposable(G);if(oe){const Te=ie.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(oe));he=A.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(U,Q,ie,ae){return this._withAdapter(U,K,G=>G.provideDocumentSemanticTokens(d.URI.revive(Q),ie,ae),null,!0)}$releaseDocumentSemanticTokens(U,Q){this._withAdapter(U,K,ie=>ie.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(U,Q,ie,ae){const G=this._addNewAdapter(new H(this._documents,ie),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(Q),ae),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(U,Q,ie,ae){return this._withAdapter(U,H,G=>G.provideDocumentRangeSemanticTokens(d.URI.revive(Q),ie,ae),null,!0)}registerCompletionItemProvider(U,Q,ie,ae){const G=this._addNewAdapter(new W(this._documents,this._commands.converter,ie,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(Q),ae,W.supportsResolving(ie),`${U.identifier.value}(${ae.join("")})`),this._createDisposable(G)}$provideCompletionItems(U,Q,ie,ae,G){return this._withAdapter(U,W,oe=>oe.provideCompletionItems(d.URI.revive(Q),ie,ae,G),void 0)}$resolveCompletionItem(U,Q,ie){return this._withAdapter(U,W,ae=>ae.resolveCompletionItem(Q,ie),void 0)}$releaseCompletionItems(U,Q){this._withAdapter(U,W,ie=>ie.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(U,Q,ie){const ae=this._addNewAdapter(new ne(this._documents,ie,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions(U,Q,ie,ae,G){return this._withAdapter(U,ne,oe=>oe.provideInlineCompletions(d.URI.revive(Q),ie,ae,G),void 0)}$handleInlineCompletionDidShow(U,Q,ie){this._withAdapter(U,ne,async ae=>{ae.handleDidShowCompletionItem(Q,ie)},void 0)}$freeInlineCompletionsList(U,Q){this._withAdapter(U,ne,async ie=>{ie.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(U,Q,ie,ae){const G=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new X(this._documents,ie),U);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Q),G),this._createDisposable(oe)}$provideSignatureHelp(U,Q,ie,ae,G){return this._withAdapter(U,X,oe=>oe.provideSignatureHelp(d.URI.revive(Q),ie,ae,G),void 0)}$releaseSignatureHelp(U,Q){this._withAdapter(U,X,ie=>ie.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(U,Q,ie){const ae=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new q(this._documents,ie),U);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(Q),ae);let oe=this._createDisposable(G);if(ae!==void 0){const he=ie.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ae));oe=A.Disposable.from(oe,he)}return oe}$provideInlayHints(U,Q,ie,ae){return this._withAdapter(U,q,G=>G.provideInlayHints(d.URI.revive(Q),ie,ae),void 0)}registerDocumentLinkProvider(U,Q,ie){const ae=this._addNewAdapter(new le(this._documents,ie),U);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof ie.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(U,Q,ie){return this._withAdapter(U,le,ae=>ae.provideLinks(d.URI.revive(Q),ie),void 0)}$resolveDocumentLink(U,Q,ie){return this._withAdapter(U,le,ae=>ae.resolveLink(Q,ie),void 0)}$releaseDocumentLinks(U,Q){this._withAdapter(U,le,ie=>ie.releaseLinks(Q),void 0)}registerColorProvider(U,Q,ie){const ae=this._addNewAdapter(new te(this._documents,ie),U);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(U,Q,ie){return this._withAdapter(U,te,ae=>ae.provideColors(d.URI.revive(Q),ie),[])}$provideColorPresentations(U,Q,ie,ae){return this._withAdapter(U,te,G=>G.provideColorPresentations(d.URI.revive(Q),ie,ae),void 0)}registerFoldingRangeProvider(U,Q,ie){const ae=this._nextHandle(),G=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new ve(this._documents,ie),U)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),G);let oe=this._createDisposable(ae);if(G!==void 0){const he=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));oe=A.Disposable.from(oe,he)}return oe}$provideFoldingRanges(U,Q,ie,ae){return this._withAdapter(U,ve,G=>G.provideFoldingRanges(d.URI.revive(Q),ie,ae),void 0)}registerSelectionRangeProvider(U,Q,ie){const ae=this._addNewAdapter(new Re(this._documents,ie,this._logService),U);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(U,Q,ie,ae){return this._withAdapter(U,Re,G=>G.provideSelectionRanges(d.URI.revive(Q),ie,ae),[])}registerCallHierarchyProvider(U,Q,ie){const ae=this._addNewAdapter(new Fe(this._documents,ie),U);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(U,Q,ie,ae){return this._withAdapter(U,Fe,G=>Promise.resolve(G.prepareSession(d.URI.revive(Q),ie,ae)),void 0)}$provideCallHierarchyIncomingCalls(U,Q,ie,ae){return this._withAdapter(U,Fe,G=>G.provideCallsTo(Q,ie,ae),void 0)}$provideCallHierarchyOutgoingCalls(U,Q,ie,ae){return this._withAdapter(U,Fe,G=>G.provideCallsFrom(Q,ie,ae),void 0)}$releaseCallHierarchy(U,Q){this._withAdapter(U,Fe,ie=>Promise.resolve(ie.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(U,Q,ie){const ae=this._addNewAdapter(new Oe(this._documents,ie),U);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy(U,Q,ie,ae){return this._withAdapter(U,Oe,G=>Promise.resolve(G.prepareSession(d.URI.revive(Q),ie,ae)),void 0)}$provideTypeHierarchySupertypes(U,Q,ie,ae){return this._withAdapter(U,Oe,G=>G.provideSupertypes(Q,ie,ae),void 0)}$provideTypeHierarchySubtypes(U,Q,ie,ae){return this._withAdapter(U,Oe,G=>G.provideSubtypes(Q,ie,ae),void 0)}$releaseTypeHierarchy(U,Q){this._withAdapter(U,Oe,ie=>Promise.resolve(ie.releaseSession(Q)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,k.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:je._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?je._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?je._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:je._serializeRegExp(U.beforeText),afterText:U.afterText?je._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?je._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(je._serializeOnEnterRule)}setLanguageConfiguration(U,Q,ie){let{wordPattern:ae}=ie;if(ae&&(0,k.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const G=this._nextHandle(),oe={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?je._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?je._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?je._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,Q,oe),this._createDisposable(G)}$setWordDefinitions(U){for(const Q of U)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,14,6]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(t,_,n,f){this._documents=_,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,_){await this._proxy.$changeLanguage(t,_);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,_){const n=t.version,f=M.Position.from(_),s=await this._proxy.$tokensAtPosition(t.uri,f),u={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!s)return u;const v={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!v.range.contains(_)||n!==t.version?u:v}createLanguageStatusItem(t,_,n){const f=this._handlePool++,s=this._proxy,u=this._ids,v=`${t.identifier.value}/${_}`;if(u.has(v))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);u.add(v);const D={selector:n,id:_,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let y,o=new k.DisposableStore;const h=()=>{y?.dispose(),y=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(f,{id:v,name:D.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===E.LanguageStatusSeverity.Error?A.default.Error:D.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:D.command&&this._commands.toInternal(D.command,o),accessibilityInfo:D.accessibilityInformation})},0)},C={dispose(){o.dispose(),y?.dispose(),s.$removeLanguageStatus(f),u.delete(v)},get id(){return D.id},get name(){return D.name},set name(i){D.name=i,h()},get selector(){return D.selector},set selector(i){D.selector=i,h()},get text(){return D.text},set text(i){D.text=i,h()},get detail(){return D.detail},set detail(i){D.detail=i,h()},get severity(){return D.severity},set severity(i){D.severity=i,h()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(i){D.accessibilityInformation=i,h()},get command(){return D.command},set command(i){D.command=i,h()}};return h(),C}}e.ExtHostLanguages=S}),define(be[196],Ee([0,1,5,15,30]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let F=class{constructor(S,T){this._logService=T,this._proxy=S.getProxy(d.MainContext.MainThreadMessageService)}showMessage(S,T,t,_,n){const f={extension:S};let s;typeof _=="string"||A(_)?s=[_,...n]:(f.modal=_?.modal,f.useCustom=_?.useCustom,f.detail=_?.detail,s=n),f.useCustom&&(0,E.checkProposedApiEnabled)(S);const u=[];for(let v=0;v<s.length;v++){const D=s[v];if(typeof D=="string")u.push({title:D,handle:v,isCloseAffordance:!1});else if(typeof D=="object"){let{title:y,isCloseAffordance:o}=D;u.push({title:y,isCloseAffordance:!!o,handle:v})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(T,t,f,u).then(v=>{if(typeof v=="number")return s[v]})}};F=$e([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,64,5,8,7,38,172,93]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(o,h,C,i,p){this._textDocumentsAndEditors=C,this._textDocuments=i,this._extensionStoragePaths=p,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const r=a.notebookEditor?.notebookUri,c=a.cell.handle,m=this._documents.get(r)?.getCell(c);if(m)return m.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const h=this._editors.get(o);if(!h)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(o){for(const[h,C]of this._editors)if(C.apiEditor===o)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,h){const C=this._documents.get(o);if(!C&&!h)throw new Error(`NO notebook document for '${o}'`);return C}_getProviderData(o){const h=this._notebookContentProviders.get(o);if(!h)throw new Error(`NO provider for '${o}'`);return h}registerNotebookContentProvider(o,h,C,i,p){if((0,k.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:o,provider:C});let a;return C.onDidChangeNotebookContentOptions&&(a=C.onDidChangeNotebookContentOptions(()=>{const r=n.NotebookDocumentContentOptions.from(C.options);this._notebookProxy.$updateNotebookProviderOptions(h,r)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),D._convertNotebookRegistrationData(o,p)),new f.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(o,h){if(!h)return;const C=h.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(h.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:h.displayName,filenamePattern:C,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,h,C){const i=D._notebookStatusBarItemProviderHandlePool++,p=typeof C.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,p,h);let a;return p!==void 0&&(a=C.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(p))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,p),a&&a.dispose()})}async createNotebookDocument(o){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return T.URI.revive(h)}async openNotebookDocument(o){const h=this._documents.get(o);if(h)return h.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(T.URI.revive(C));return(0,S.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,h){T.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let C;typeof h=="object"?C={position:n.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(n.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:C={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,C),p=i&&this._editors.get(i)?.apiEditor;if(p)return p;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,h,C,i){const p=this._notebookStatusBarItemProviders.get(o),a=T.URI.revive(h),r=this._documents.get(a);if(!r||!p)return;const c=r.getCellFromIndex(C);if(!c)return;const l=await p.provideCellStatusBarItems(c.apiCell,i);if(!l)return;const m=new A.DisposableStore,b=this._statusBarCache.add([m]),g=(Array.isArray(l)?l:[l]).map(I=>n.NotebookStatusBarItem.from(I,this._commandsConverter,m));return{cacheId:b,items:g}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,h,C,i,p){if((0,k.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,C),this._notebookProxy.$registerNotebookSerializer(a,{id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),D._convertNotebookRegistrationData(o,p)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(o,h,C){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const p=await i.deserializeNotebook(h.buffer,C);return new s.SerializableObjectWithBuffers(n.NotebookData.from(p))}async $notebookToData(o,h,C){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const p=await i.serializeNotebook(n.NotebookData.to(h.value),C);return d.VSBuffer.wrap(p)}async $openNotebook(o,h,C,i,p){const{provider:a}=this._getProviderData(o),r=await a.openNotebook(T.URI.revive(h),{backupId:C,untitledDocumentData:i?.buffer},p);return new s.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,h,C){const i=this.getNotebookDocument(T.URI.revive(h)),{provider:p}=this._getProviderData(o);return await p.saveNotebook(i.apiNotebook,C),!0}async $saveNotebookAs(o,h,C,i){const p=this.getNotebookDocument(T.URI.revive(h)),{provider:a}=this._getProviderData(o);return await a.saveNotebookAs(T.URI.revive(C),p.apiNotebook,i),!0}async $backupNotebook(o,h,C){const i=this.getNotebookDocument(T.URI.revive(h)),p=this._getProviderData(o),a=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension),r=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),c=T.URI.joinPath(a,r),l=await p.provider.backupNotebook(i.apiNotebook,{destination:c},C);return i.updateBackup(l),l.id}_createExtHostEditor(o,h,C){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const i=new v.ExtHostNotebookEditor(h,this._notebookEditorsProxy,o,C.visibleRanges.map(n.NotebookRange.to),C.selections.map(n.NotebookRange.to),typeof C.viewColumn=="number"?n.ViewColumn.to(C.viewColumn):void 0);this._editors.set(h,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const C of o.value.removedDocuments){const i=T.URI.revive(C),p=this._documents.get(i);p&&(p.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(o.value.addedDocuments){const C=[];for(const i of o.value.addedDocuments){const p=T.URI.revive(i.uri);if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const a=this,r=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){a._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){a._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){a._onDidChangeCellMetadata.fire(c)},emitCellExecutionStateChange(c){a._onDidChangeCellExecutionState.fire(c)}},p,i);C.push(...i.cells.map(c=>u.ExtHostCell.asModelAddData(r.apiNotebook,c))),this._documents.get(p)?.dispose(),this._documents.set(p,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(o.value.addedEditors)for(const C of o.value.addedEditors){if(this._editors.has(C.id))return;const i=T.URI.revive(C.documentUri),p=this._documents.get(i);p&&this._createExtHostEditor(p,C.id,C)}const h=[];if(o.value.removedEditors)for(const C of o.value.removedEditors){const i=this._editors.get(C);i&&(this._editors.delete(C),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),h.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const C=new Set;this._visibleNotebookEditors.forEach(i=>C.add(i.id));for(const i of this._editors.values()){const p=C.has(i.id);i._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,54,15,5,12,8]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(_,n){const f=S._Keys.nextId();_.$registerNotebookEditorDecorationType(f,k.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){_.$removeNotebookEditorDecorationType(f)}}}}S._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(_,n,f){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const f=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(k.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(k.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(k.ViewColumn.to(_[n]))}};T=$e([ze(0,E.ILogService),ze(1,F.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(be[199],Ee([0,1,13,14,21,3,6,20,2,26,15,5,39,8,7,67,165,30,38]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(a,r,c,l,m){this._initData=r,this._extHostNotebook=c,this._commands=l,this._logService=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const g=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:g}}else if(P&&"notebookEditor"in P){const g=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(g===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.document.uri.toString()}`);return{notebookEditorId:g}}return P})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(a,r,c,l,m,b){for(let X of this._kernelData.values())if(X.controller.id===r&&T.ExtensionIdentifier.equals(a.identifier,X.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const P=this._handlePool++,g=this;this._logService.trace(`NotebookController[${P}], CREATED by ${a.identifier.value}, ${r}`);const I=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${a.identifier}'`);let R=!1;const L=new F.DisposableStore,w=new A.Emitter,x=new A.Emitter,$={id:`${a.identifier.value}/${r}`,notebookType:c,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:l||a.identifier.value,preloads:b?b.map(f.NotebookRendererScript.from):[]};let B=m??I,K;this._proxy.$addKernel(P,$).catch(X=>{console.log(X),R=!0});let H=0;const W=()=>{if(R)return;const X=++H;Promise.resolve().then(()=>{X===H&&this._proxy.$updateKernel(P,$)})},ne=new k.ResourceMap,V={get id(){return r},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:w.event,get label(){return $.label},set label(X){$.label=X??a.displayName??a.name,W()},get detail(){return $.detail??""},set detail(X){$.detail=X,W()},get description(){return $.description??""},set description(X){$.description=X,W()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(X){$.supportedLanguages=X,W()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(X){$.supportsExecutionOrder=X,W()},get rendererScripts(){return $.preloads?$.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(X){B=X??I},get interruptHandler(){return K},set interruptHandler(X){K=X,$.supportsInterrupt=Boolean(X),W()},createNotebookCellExecution(X){if(R)throw new Error("notebook controller is DISPOSED");if(!ne.has(X.notebook.uri))throw g._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(q=>q.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.notebook.uri.toString()}`);return g._createNotebookCellExecution(X)},dispose:()=>{R||(this._logService.trace(`NotebookController[${P}], DISPOSED`),R=!0,this._kernelData.delete(P),L.dispose(),w.dispose(),x.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(X,q){g._proxy.$updateNotebookPriority(P,X.uri,q)},onDidReceiveMessage:x.event,postMessage(X,q){return(0,D.checkProposedApiEnabled)(a),g._proxy.$postMessage(P,q&&g._extHostNotebook.getIdByEditor(q),X)},asWebviewUri(X){return(0,D.checkProposedApiEnabled)(a),(0,u.asWebviewUri)(X,g._initData.remote)}};return this._kernelData.set(P,{extensionId:a.identifier,controller:V,onDidReceiveMessage:x,onDidChangeSelection:w,associatedNotebooks:ne}),V}$acceptNotebookAssociation(a,r,c){const l=this._kernelData.get(a);if(l){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));c?l.associatedNotebooks.set(m.uri,!0):l.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,m.uri.toString(),c),l.onDidChangeSelection.fire({selected:c,notebook:m.apiNotebook})}}async $executeCells(a,r,c){const l=this._kernelData.get(a);if(!l)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),b=[];for(let P of c){const g=m.getCell(P);g&&b.push(g.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,m.uri.toString(),b.length),await l.controller.executeHandler.call(l.controller,b,m.apiNotebook,l.controller)}catch(P){this._logService.error(`NotebookController[${a}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(a,r,c){const l=this._kernelData.get(a);if(!l)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,m.apiNotebook);else for(let b of c){const P=m.getCell(b);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,c){const l=this._kernelData.get(a);if(!l)return;const m=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:c}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const l=new C(c.notebook,c,this._proxy);this._activeExecutions.set(c.uri,l);const m=l.onDidChangeState(()=>{l.state===h.Resolved&&(l.dispose(),m.dispose(),this._activeExecutions.delete(c.uri))});return l.asApiObject()}};o=$e([ze(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class C extends F.Disposable{constructor(a,r,c){super();this._document=a,this._cell=r,this._proxy=c,this._handle=C.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new y.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const c=s.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return c===r.items?f.NotebookCellOutput.from(r):f.NotebookCellOutput.from({items:c,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,c){const l=this.cellIndexToHandle(r),m=this.validateAndConvertOutputs((0,d.asArray)(a));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:c,outputs:m})}async updateOutputItems(a,r,c){return a=s.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(a),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(f.NotebookCellOutputItem.from),outputId:r.id,append:c})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(c){a._executionOrder=c,a.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(c){if(a._state===h.Resolved||a._state===h.Started)throw new Error("Cannot call start again");a._state=h.Started,a._onDidChangeState.fire(),a.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:c})},end(c,l){if(a._state===h.Resolved)throw new Error("Cannot call resolve twice");a._state=h.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:l,lastRunSuccess:c}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(c){return a.verifyStateForOutput(),a.updateOutputs([],c,!1)},appendOutput(c,l){return a.verifyStateForOutput(),a.updateOutputs(c,l,!0)},replaceOutput(c,l){return a.verifyStateForOutput(),a.updateOutputs(c,l,!1)},appendOutputItems(c,l){return a.verifyStateForOutput(),a.updateOutputItems(c,l,!0)},replaceOutputItems(c,l){return a.verifyStateForOutput(),a.updateOutputItems(c,l,!1)}})}}C.HANDLE=0;class i{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,S,T){const t=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(S)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(k,S){if(!k.contributes?.notebookRenderer?.some(n=>n.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const T=!!k.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,f,s)=>{const u=T?n:v=>{const D={};t.set(D,v.editor),n({editor:D,message:v.message})};return this.getOrCreateEmitterFor(S).event(u,f,s)},postMessage:(n,f)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,f]=[f,n]);const s=T?f:t.get(f),u=s&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(u?.id,S,n)}}}getOrCreateEmitterFor(k){let S=this._rendererMessageEmitters.get(k);return S||(S=new d.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,S),S)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,12]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends E.Disposable{constructor(s,u,v,D,y){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=y,this._id=y.$register(this.name,u,v,D),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(u=>this._proxy.$clear(u,s))}show(s,u){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof s=="boolean"?s:u)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class T extends S{constructor(s,u,v){super(s,!1,void 0,u,v)}append(s){super.append(s),this._id.then(u=>this._proxy.$append(u,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends S{constructor(s,u,v){super(s,!0,u,void 0,v)}append(s){throw new Error("Not supported")}}class _{constructor(s,u){this.name=s,this._channel=u}append(s){this._channel.then(u=>u.append(s))}appendLine(s){this._channel.then(u=>u.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,u){this._channel.then(v=>v.show(s,u))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=_;let n=class{constructor(s){this._proxy=s.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new T(s,u.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new t(s,u,this._proxy)}};n=$e([ze(0,k.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,14,21,3,6,5,2,7,16,13,35,47]),function(se,e,d,M,E,A,F,k,S,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(s,u,v){const D=s.getProxy(F.MainContext.MainThreadQuickOpen);class y{constructor(l,m){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=m}showQuickPick(l,m,b,P=M.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(l),I=++this._instances,R=D.$show(I,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},P),L={},w=R.then(()=>L);return Promise.race([w,g]).then(x=>{if(x!==L)return g.then($=>{const B=[];for(let K=0;K<$.length;K++){const H=$[K];let W,ne,V,X,q;typeof H=="string"?W=H:(W=H.label,ne=H.description,V=H.detail,X=H.picked,q=H.alwaysShow),B.push({label:W,description:ne,handle:K,detail:V,picked:X,alwaysShow:q})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{b.onDidSelectItem($[K])}),D.$setItems(I,B),R.then(K=>{if(typeof K=="number")return $[K];if(Array.isArray(K))return K.map(H=>$[H])})})}).then(void 0,x=>{if(!(0,T.isPromiseCanceledError)(x))return D.$setError(I,x),Promise.reject(x)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,m=M.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,D.$input(l,typeof this._validateInput=="function",m).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,m=M.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(g=>g.uri.toString()===b.uri.toString())}createQuickPick(l,m){const b=new a(l,m,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const m=new r(l,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(l,m){const b=this._sessions.get(l);b&&b._fireDidChangeValue(m)}$onDidAccept(l){const m=this._sessions.get(l);m&&m._fireDidAccept()}$onDidChangeActive(l,m){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeActive(m)}$onDidChangeSelection(l,m){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeSelection(m)}$onDidTriggerButton(l,m){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(m)}$onDidTriggerItemButton(l,m,b){const P=this._sessions.get(l);P instanceof a&&P._fireDidTriggerItemButton(m,b)}$onDidHide(l){const m=this._sessions.get(l);m&&m._fireDidHide()}}class o{constructor(l,m){this._extensionId=l,this._onDidDispose=m,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((m,b)=>{const P=m===S.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(P,m)}),this.update({buttons:l.map((m,b)=>({...p(m),tooltip:m.tooltip,handle:m===S.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const m=this._handlesToButtons.get(l);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),D.$dispose(this._id))}update(l){if(!this._disposed){for(const m of Object.keys(l)){const b=l[m];this._pendingUpdate[m]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){D.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function h(c){if(c instanceof S.ThemeIcon)return{id:c.id};const l=i(c),m=C(c);return{dark:typeof l=="string"?k.URI.file(l):l,light:typeof m=="string"?k.URI.file(m):m}}function C(c){return typeof c=="object"&&"light"in c?c.light:c}function i(c){return typeof c=="object"&&"dark"in c?c.dark:c}function p(c){const l=h(c.iconPath);let m,b;return"id"in l?b=n.ThemeIcon.asClassName(l):m=l,{iconPath:m,iconClass:b}}class a extends o{constructor(l,m,b){super(l,b);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((m,b)=>{this._handlesToItems.set(b,m),this._itemsToHandles.set(m,b)}),this.update({items:l.map((m,b)=>({label:m.label,description:m.description,handle:b,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((P,g)=>({...p(P),tooltip:P.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(l){const m=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(l){const m=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(l,m){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const P=b.buttons[m];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:b})}}class r extends o{constructor(l,m){super(l,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?_.default.Error:_.default.Ignore})}}return new y(u,v)}e.createExtHostQuickOpen=f}),define(be[202],Ee([0,1,2,3,53,6,14,5,13,108,15,26,30,47,8]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?d.URI.file(l.iconPath):d.URI.isUri(l.iconPath)||f.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function v(l,m){if(!l.iconPath&&!m.iconPath)return 0;if(l.iconPath){if(!m.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:d.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,P=typeof m.iconPath=="string"?m.iconPath:d.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,T.comparePaths)(b,P)}function D(l,m){let b=0;if(l.strikeThrough!==m.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==m.faded)return l.faded?1:-1;if(l.tooltip!==m.tooltip)return(l.tooltip||"").localeCompare(m.tooltip||"");if(b=v(l,m),b!==0)return b;if(l.light&&m.light)b=v(l.light,m.light);else{if(l.light)return 1;if(m.light)return-1}if(b!==0)return b;if(l.dark&&m.dark)b=v(l.dark,m.dark);else{if(l.dark)return 1;if(m.dark)return-1}return b}function y(l,m){if(l.command!==m.command)return l.command<m.command?-1:1;if(l.title!==m.title)return l.title<m.title?-1:1;if(l.tooltip!==m.tooltip){if(l.tooltip!==void 0&&m.tooltip!==void 0)return l.tooltip<m.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(l.arguments===m.arguments)return 0;if(l.arguments)if(m.arguments){if(l.arguments.length!==m.arguments.length)return l.arguments.length-m.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const P=l.arguments[b],g=m.arguments[b];if(P!==g)return P<g?-1:1}return 0}function o(l,m){let b=(0,T.comparePaths)(l.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&m.command)b=y(l.command,m.command);else{if(l.command)return 1;if(m.command)return-1}if(b!==0)return b;if(l.decorations&&m.decorations)b=D(l.decorations,m.decorations);else{if(l.decorations)return 1;if(m.decorations)return-1}return b}function h(l,m){for(let b=0;b<l.length;b++)if(l[b]!==m[b])return!1;return!0}function C(l,m){return l.command===m.command&&l.title===m.title&&l.tooltip===m.tooltip&&(l.arguments&&m.arguments?h(l.arguments,m.arguments):l.arguments===m.arguments)}function i(l,m){return(0,S.equals)(l,m,C)}class p{constructor(m,b,P){this._extension=m,this._proxy=b,this._sourceControlHandle=P,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,n.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,b){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,b)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=p;class a{constructor(m,b,P,g,I){this._proxy=m,this._commands=b,this._sourceControlHandle=P,this._id=g,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,b){const P=this._resourceStatesCommandsMap.get(m);return P?(0,F.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(o),P=(0,S.sortedDiff)(this._resourceSnapshot,m,o).map(R=>{const L=R.toInsert.map(w=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,w);const $=w.resourceUri;let B;if(w.command)if(w.command.command==="vscode.open"||w.command.command==="vscode.diff"){const ve=new A.DisposableStore;B=this._commands.converter.toInternal(w.command,ve),this._resourceStatesDisposablesMap.set(x,ve)}else this._resourceStatesCommandsMap.set(x,w.command);const K=u(w.decorations),H=w.decorations&&u(w.decorations.light)||K,W=w.decorations&&u(w.decorations.dark)||K,ne=[H,W],V=w.decorations&&w.decorations.tooltip||"",X=w.decorations&&!!w.decorations.strikeThrough,q=w.decorations&&!!w.decorations.faded,le=w.contextValue||"";return{rawResource:[x,$,ne,V,X,q,le,B],handle:x}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),g=P.map(({start:R,deleteCount:L,toInsert:w})=>[R,L,w.map(x=>x.rawResource)]),I=P.reverse();for(const{start:R,deleteCount:L,toInsert:w}of I){const x=w.map(B=>B.handle),$=this._handlesSnapshot.splice(R,L,...x);for(const B of $)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=m,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class r{constructor(m,b,P,g,I,R){this._extension=m,this._proxy=b,this._commands=P,this._id=g,this._label=I,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,I,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=m;const b=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(m){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=m;const b=m!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=m;const b=(m||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(m,b){const P=new a(this._proxy,this._commands,this.handle,m,b),g=M.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,g),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const m=[],b=[];for(const[P,g]of this.createdResourceGroups){g.dispose();const I=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});M.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),I.dispose(),this._groups.delete(P.handle),this._proxy.$unregisterGroup(this.handle,P.handle)}),m.push([P.handle,P.id,P.label,P.features]);const R=P._takeResourceStateSnapshot();R.length>0&&b.push([P.handle,R]),this._groups.set(P.handle,P)}this._proxy.$registerGroups(this.handle,m,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(b=>{const P=b._takeResourceStateSnapshot();P.length!==0&&m.push([b.handle,P])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,$e([(0,E.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),$e([(0,E.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let c=class Bi{constructor(m,b,P){this._commands=b,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=m.getProxy(k.MainContext.MainThreadSCM),this._telemetry=m.getProxy(k.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const I=this._sourceControls.get(g.sourceControlHandle);if(!I)return g;const R=I.getResourceGroup(g.groupHandle);return R?R.getResourceState(g.handle):g}else if(g&&g.$mid===4){const I=this._sourceControls.get(g.sourceControlHandle);return I?I.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const I=this._sourceControls.get(g.handle);return I||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,b,P,g){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,b,P,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const I=Bi._handlePool++,R=new r(m,this._proxy,this._commands,b,P,g);this._sourceControls.set(I,R);const L=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(m.identifier))||[];return L.push(R),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(m.identifier),L),R}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(m.identifier)),P=b&&b[b.length-1];return P&&P.inputBox}$provideOriginalResource(m,b,P){const g=d.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,g.toString());const I=this._sourceControls.get(m);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(g,P)).then(R=>R||null)}$onInputBoxValueChange(m,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const P=this._sourceControls.get(m);return P&&P.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(m,b,P,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,b,P);const I=this._sourceControls.get(m);if(!I)return Promise.resolve(void 0);const R=I.getResourceGroup(b);return R?R.$executeResourceCommand(P,g):Promise.resolve(void 0)}$validateInput(m,b,P){this.logService.trace("ExtHostSCM#$validateInput",m);const g=this._sourceControls.get(m);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>g.inputBox.validateInput(b,P)).then(I=>{if(!I)return Promise.resolve(void 0);const R=s.MarkdownString.fromStrict(I.message);return R?Promise.resolve([R,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};c._handlePool=0,c=$e([ze(2,t.ILogService)],c),e.ExtHostSCM=c});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[203],Ee([0,1,7,5,127,6,8,10]),function(se,e,d,M,E,A,F,k){"use strict";var S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(s,u,v,D,y=d.StatusBarAlignment.Left,o){S.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,S,s,"f"),et(this,T,u,"f"),this._entryId=t.ID_GEN++,this._extension=v,this._id=D,this._alignment=y,this._priority=this.validatePriority(o)}validatePriority(s){if(!!(0,k.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!t.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Ae(this,T,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Ae(this,T,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let u;this._name?u=this._name:u=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,S,"f").$setEntry(this._entryId,s,u,this._text,D,this._command?.internal,v,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,S=new WeakMap,T=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const u={message:s};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const v=this._messages.indexOf(u);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,u){this._proxy=s.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new _(this)}createStatusBarEntry(s,u,v,D){return new t(this._proxy,this._commands,s,u,v,D)}setStatusBarMessage(s,u){const v=this._statusMessage.setMessage(s);let D;return typeof u=="number"?D=setTimeout(()=>v.dispose(),u):typeof u!="undefined"&&u.then(()=>v.dispose(),()=>v.dispose()),new d.Disposable(()=>{v.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(be[73],Ee([0,1,5,3,4]),function(se,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,T){return this._proxy.$getValue(k,S).then(t=>t||T)}setValue(k,S,T){return this._proxy.$setValue(k,S,T)}$acceptValue(k,S,T){this._onDidChangeStorage.fire({shared:k,key:S,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,29,15,72,2]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let k=class{constructor(T,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return F.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(T){if(this._value)return F.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return F.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([ze(0,M.IExtHostInitDataService),ze(1,E.ILogService),ze(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(be[40],Ee([0,1,3,5,4,2,12,6,7,128,16,167,21,36,150,47,10]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class D{constructor(c,l,m,b){this._proxy=c,this._id=l,this._creationOptions=m,this._name=b,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},sendText(g,I=!0){P._checkDisposed(),P._proxy.$sendText(P._id,g,I)},show(g){P._checkDisposed(),P._proxy.$show(P._id,g)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}async create(c,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,v.withNullAsUndefined)(c.shellPath),shellArgs:(0,v.withNullAsUndefined)(c.shellArgs),cwd:(0,v.withNullAsUndefined)(c.cwd),env:(0,v.withNullAsUndefined)(c.env),icon:(0,v.withNullAsUndefined)(p(c.iconPath)),color:u.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,v.withNullAsUndefined)(c.message),strictEnv:(0,v.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(c.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(c,l,m,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:u.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(c,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,l){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in c?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,l){return c===this._cols&&l===this._rows||c===0||l===0?!1:(this._cols=c,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=D;class y{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(c){return Promise.resolve("")}async updateProperty(c,l){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,l){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:l})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose&&this._pty.onDidClose((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(l=>this._onProcessOverrideDimensions.fire(l&&{cols:l.columns,rows:l.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(l=>this._onProcessTitleChanged.fire(l)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=y;let o=1,h=class extends k.Disposable{constructor(c,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[m,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,l){const m=new D(this._proxy,(0,f.generateUuid)(),c,c.name),b=new y(c.pty);return m.createExtensionTerminal(c.location,this._serializeParentTerminal(c,l).resolvedExtHostIdentifier,p(c.iconPath),a(c.color)).then(P=>{const g=this._setupExtHostProcessListeners(P,b);this._terminalProcessDisposables[P]=g}),this._terminals.push(m),m.value}_serializeParentTerminal(c,l){if(l=l||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const m=c.location.parentTerminal;if(m){const b=this._terminals.find(P=>P.value===m);b&&(l.resolvedExtHostIdentifier=b._id)}}else c.location&&typeof c.location!="object"?l.location=c.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(c,l){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const b=new y(l),P=this._setupExtHostProcessListeners(c,b);this._terminalProcessDisposables[c]=P}async $acceptActiveTerminalChanged(c){const l=this._activeTerminal;if(c===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(c);m&&(this._activeTerminal=m,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,l){const m=this._getTerminalById(c);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:l})}async $acceptTerminalDimensions(c,l,m){const b=this._getTerminalById(c);b&&b.setDimensions(l,m)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(c,l,m){this._terminalProcesses.get(c)?.resize(l,m)}async $acceptTerminalTitleChange(c,l){const m=this._getTerminalById(c);m&&(m.name=l)}async $acceptTerminalClosed(c,l){const m=this._getTerminalObjectIndexById(this._terminals,c);if(m!==null){const b=this._terminals.splice(m,1)[0];b.setExitCode(l),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(c,l,m,b){if(l){const I=this._getTerminalObjectIndexById(this._terminals,l);if(I!==null){this._terminals[I]._id=c,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const P={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:A.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},g=new D(this._proxy,c,P,m);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(c,l){const m=this._getTerminalById(c);m&&m._setProcessId(l)}async $startExtensionTerminal(c,l){const m=this._getTerminalById(c);if(!m)return{message:(0,T.localize)(0,null,c)};m.isOpen||await new Promise(P=>{const g=this.onDidOpenTerminal(async I=>{I===m.value&&(g.dispose(),P())})});const b=this._terminalProcesses.get(c);b?b.startSendingEvents(l):this._extensionTerminalAwaitingStart[c]={initialDimensions:l}}_setupExtHostProcessListeners(c,l){const m=new k.DisposableStore;m.add(l.onProcessReady(P=>this._proxy.$sendProcessReady(c,P.pid,P.cwd))),m.add(l.onProcessTitleChanged(P=>this._proxy.$sendProcessTitle(c,P))),this._bufferer.startBuffering(c,l.onProcessData),m.add(l.onProcessExit(P=>this._onProcessExit(c,P))),l.onProcessOverrideDimensions&&m.add(l.onProcessOverrideDimensions(P=>this._proxy.$sendOverrideDimensions(c,P))),this._terminalProcesses.set(c,l);const b=this._extensionTerminalAwaitingStart[c];return b&&l instanceof y&&(l.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),m}$acceptProcessAckDataEvent(c,l){this._terminalProcesses.get(c)?.acknowledgeDataEvent(l)}$acceptProcessInput(c,l){this._terminalProcesses.get(c)?.input(l)}$acceptTerminalInteraction(c){const l=this._getTerminalById(c);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(c,l,m){try{this._terminalProcesses.get(c)?.resize(l,m)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(c,l){this._terminalProcesses.get(c)?.shutdown(l)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(c,l))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(l=>this._proxy.$sendProcessCwd(c,l))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,l,m){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,m),this._proxy.$registerProfileProvider(l,c.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(c,l){const m=new n.CancellationTokenSource().token,b=await this._profileProviders.get(c)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,l);return}this.createTerminalFromOptions(b.options,l)}}async $provideLinks(c,l){const m=this._getTerminalById(c);if(!m)return[];this._terminalLinkCache.delete(c);const b=this._terminalLinkCancellationSource.get(c);b&&b.dispose(!0);const P=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,P);const g=[],I={terminal:m.value,line:l},R=[];for(const x of this._linkProviders)R.push(new Promise(async $=>{P.token.onCancellationRequested(()=>$({provider:x,links:[]}));const B=await x.provideTerminalLinks(I,P.token)||[];P.token.isCancellationRequested||$({provider:x,links:B})}));const L=await Promise.all(R);if(P.token.isCancellationRequested)return[];const w=new Map;for(const x of L)x&&x.links.length>0&&g.push(...x.links.map($=>{const B={id:o++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return w.set(B.id,{provider:x.provider,link:$}),B}));return this._terminalLinkCache.set(c,w),g}$activateLink(c,l){const m=this._terminalLinkCache.get(c)?.get(l);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(c,l){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const m=this._terminalProcessDisposables[c];m&&(m.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,l)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,l){const m=this._getTerminalObjectIndexById(c,l);return m!==null?c[m]:null}_getTerminalObjectIndexById(c,l){let m=null;return c.some((b,P)=>b._id===l?(m=P,!0):!1),m}getEnvironmentVariableCollection(c){let l=this._environmentVariableCollections.get(c.identifier.value);return l||(l=new C,this._setEnvironmentVariableCollection(c.identifier.value,l)),l}_syncEnvironmentVariableCollection(c,l){const m=(0,_.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(c,l.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(c){c.forEach(l=>{const m=l[0],b=new C(l[1]);this._setEnvironmentVariableCollection(m,b)})}$acceptDefaultProfile(c,l){this._defaultProfile=c,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(c,l){this._environmentVariableCollections.set(c,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,l)})}};h=$e([ze(1,F.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class C{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,l){this._setIfDiffers(c,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(c,l){this._setIfDiffers(c,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(c,l){this._setIfDiffers(c,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,l){const m=this.map.get(c);(!m||m.value!==l.value||m.type!==l.type)&&(this.map.set(c,l),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,l){this.map.forEach((m,b)=>c.call(l,b,m,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=C;let i=class extends h{constructor(c){super(!1,c)}createTerminal(c,l,m){throw new t.NotSupportedError}createTerminalFromOptions(c,l){throw new t.NotSupportedError}};i=$e([ze(0,F.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function p(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function a(r){return u.ThemeColor.isThemeColor(r)?r:void 0}});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[204],Ee([0,1,13,22,21,3,235,58,6,23,10,36,5,12,49,8,7,175,90,68]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let C=class{constructor(R,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new p(this.proxy),L.registerArgumentProcessor({processArgument:w=>w?.$mid===13?u.TestItem.toItemFromContext(w):w})}createTestController(R,L){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const w=new S.DisposableStore,x=w.add(new D.SingleUseTestCollection(R));x.root.label=L;const $=new Map,B=this.proxy,K={items:x.root.children,get label(){return L},set label(W){L=W,x.root.label=W,B.$updateControllerLabel(R,L)},get id(){return R},createRunProfile:(W,ne,V,X,q)=>{let le=(0,k.hash)(W);for(;$.has(le);)le++;const te=new P(this.proxy,R,le,W,ne,V,X,q);return $.set(le,te),te},createTestItem(W,ne,V){return new s.TestItemImpl(R,W,ne,V)},createTestRun:(W,ne,V=!0)=>this.runTracker.createTestRun(R,x,W,ne,V),set resolveHandler(W){x.resolveHandler=W},get resolveHandler(){return x.resolveHandler},dispose:()=>{w.dispose()}};K.createRunConfiguration=K.createRunProfile,B.$registerTestController(R,L),w.add((0,S.toDisposable)(()=>B.$unregisterTestController(R)));const H={controller:K,collection:x,profiles:$};return this.controllers.set(R,H),w.add((0,S.toDisposable)(()=>this.controllers.delete(R))),w.add(x.onDidGenerateDiff(W=>B.$publishDiff(R,W))),K}createTestObserver(){return this.observer.checkout()}async runTests(R,L=E.CancellationToken.None){const w=a(R);if(!w)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const x=this.controllers.get(w.controllerId);if(!x)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[x.collection.root.id],profileGroup:g[w.kind],profileId:w.profileId,controllerId:w.controllerId}],exclude:R.exclude?.map($=>$.id)},L)}$provideFileCoverage(R,L,w){return(0,d.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(L):void 0)?.provideFileCoverage(w)??Promise.resolve([])}$resolveFileCoverage(R,L,w,x){return(0,d.mapFind)(this.runTracker.trackers,B=>B.id===R?B.getCoverage(L):void 0)?.resolveFileCoverage(w,x)??Promise.resolve([])}$configureRunProfile(R,L){this.controllers.get(R)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(L=>(0,T.deepFreeze)(u.TestResults.to(L))).concat(this.results).sort((L,w)=>w.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,L){const w=this.controllers.get(o.TestId.fromString(R).controllerId)?.collection;w&&(await w.expand(R,L<0?Infinity:L),w.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,L){const w=this.controllers.get(R.controllerId);if(!w)return;const{collection:x,profiles:$}=w,B=$.get(R.profileId);if(!B)return;const K=R.testIds.map(V=>x.tree.get(V)).filter(t.isDefined),H=R.excludeExtIds.map(V=>w.collection.tree.get(V)).filter(t.isDefined).filter(V=>K.some(X=>X.fullId.compare(V.fullId)===2));if(!K.length)return;const W=new v.TestRunRequest(K.some(V=>V.actual instanceof s.TestItemRootImpl)?void 0:K.map(V=>V.actual),H.map(V=>V.actual),B),ne=this.runTracker.prepareForMainThreadTestRun(W,r.fromInternal(R,w.collection),L);try{await B.runHandler(W,L)}finally{ne.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(ne.onEnd),ne.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};C=$e([ze(0,f.IExtHostRpcService)],C),e.ExtHostTesting=C;class i extends S.Disposable{constructor(R,L,w){super();this.dto=R,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(w)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:x}of this.tasks.values())x.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const L=this.dto.id,w=this.dto.controllerId,x=(0,_.generateUuid)(),$=new c(this.proxy,L,x),B=ne=>(V,...X)=>{if(H){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),ne(V,...X))},K=(ne,V)=>{const X=V instanceof Array?V.map(u.TestMessage.from):[u.TestMessage.from(V)];if(ne.uri&&ne.range){const q={range:u.Range.from(ne.range),uri:ne.uri};for(const le of X)le.location=le.location||q}this.proxy.$appendTestMessagesInRun(L,x,o.TestId.fromExtHostTestItem(ne,w).toString(),X)};let H=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(ne){$.coverageProvider=ne},enqueued:B(ne=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,w).toString(),1)}),skipped:B(ne=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,w).toString(),5)}),started:B(ne=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,w).toString(),2)}),errored:B((ne,V,X)=>{K(ne,V),this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,w).toString(),6,X)}),failed:B((ne,V,X)=>{K(ne,V),this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,w).toString(),4,X)}),passed:B((ne,V)=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,this.dto.controllerId).toString(),3,V)}),appendOutput:(ne,V,X)=>{H||(X&&(this.dto.isIncluded(X)?this.ensureTestIsKnown(X):X=void 0),this.proxy.$appendOutputToRun(L,x,M.VSBuffer.fromString(ne),V&&u.location.from(V),X&&o.TestId.fromExtHostTestItem(X,w).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(L,x),this.tasks.delete(x),this.isRunning||this.dispose())}};return this.tasks.set(x,{run:W,coverage:$}),this.proxy.$startedTestRunTask(L,{id:x,name:R,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof s.TestItemImpl))throw new s.InvalidTestItemError(R.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const L=[],w=this.dto.colllection.root;for(;;){const x=u.TestItem.from(R);if(L.unshift(x),this.sharedTestIds.has(x.extId)||(this.sharedTestIds.add(x.extId),R===w))break;R=R.parent||w}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class p{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,L,w){return this.getTracker(R,L,w)}cancelRunById(R){for(const L of this.tracked.values())if(L.id===R){L.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,L,w,x,$){const B=this.tracked.get(w);if(B)return B.createRun(x);const K=r.fromPublic(R,L,w,$),H=a(w);this.proxy.$startedExtensionTestRun({controllerId:R,profile:H&&{group:g[H.kind],id:H.profileId},exclude:w.exclude?.map(ne=>ne.id)??[],id:K.id,include:w.include?.map(ne=>ne.id)??[L.root.id],persist:$});const W=this.getTracker(w,K);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),W.createRun(x)}getTracker(R,L,w){const x=new i(L,this.proxy,w);return this.tracked.set(R,x),x.onEnd(()=>this.tracked.delete(R)),x}}e.TestRunCoordinator=p;const a=I=>{if(!!I.profile){if(!(I.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class r{constructor(R,L,w,x,$,B){this.controllerId=R,this.id=L,this.isPersisted=$,this.colllection=B,this.includePrefix=w.map(K=>K+"\0"),this.excludePrefix=x.map(K=>K+"\0")}static fromPublic(R,L,w,x){return new r(R,(0,_.generateUuid)(),w.include?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[R],w.exclude?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[],x,L)}static fromInternal(R,L){return new r(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,L)}isIncluded(R){const L=o.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const w of this.excludePrefix)if(L===w||L.startsWith(w))return!1;for(const w of this.includePrefix)if(L===w||L.startsWith(w))return!0;return!1}}e.TestRunDto=r;class c{constructor(R,L,w){this.proxy=R,this.runId=L,this.taskId=w}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(R,L){const w=await this.fileCoverage;let x=w?.[R];return!this._coverageProvider||!w||!x?[]:(x.detailedCoverage||(x=w[R]=await this._coverageProvider.resolveFileCoverage?.(x,L)??x),x.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class l extends y.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,u.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:L,removed:w}=this;return{get added(){return[...R].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...w].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,L){return{...R,revived:u.TestItem.toPlain(R.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=m;class b{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(L=>L.revived)},dispose:(0,F.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class P{constructor(R,L,w,x,$,B,K=!1,H=void 0){this.controllerId=L,this.profileId=w,this._label=x,this.kind=$,this.runHandler=B,this._isDefault=K,this._tag=H,h.set(this,void 0),et(this,h,R,"f");const W=g[$];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Ae(this,h,"f").$publishTestRunProfile({profileId:w,controllerId:L,tag:H?u.TestTag.namespace(this.controllerId,H.id):null,label:x,group:W,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?u.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ae(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=P,h=new WeakMap;const g={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,13,5,94,8,7]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(n=>n.value)}async showTextDocument(t,_,n){let f;typeof _=="number"?f={position:F.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?f={position:F.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?F.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:f={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,f),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new A.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const f=_.selections.selections.map(F.Selection.to);n._acceptSelections(f)}if(_.visibleRanges){const f=M.coalesce(_.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(f)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:F.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const f=k.TextEditorSelectionChangeKind.fromValue(_.selections.source),s=_.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:f})}if(_.visibleRanges){const f=M.coalesce(_.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(t){for(const _ in t){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const f=F.ViewColumn.to(t[_]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=S}),define(be[206],Ee([0,1,2,4,5,6,7]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class k{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(f))?.get(n.handle)}return n}})}async $getTimeline(t,_,n,f,s){return this._providers.get(t)?.provideTimeline(d.URI.revive(_),n,f,s)}registerTimelineProvider(t,_,n,f){const s=new A.DisposableStore,u=this.convertTimelineItem(_.id,f,s).bind(this);let v;_.onDidChange&&(v=_.onDidChange(y=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(y,o,h,C){C?.resetCache&&(s.clear(),D.get(_.id)?.clear());const i=await _.provideTimeline(y,o,h);if(i==null)return;const p=u(y,C);return{...i,source:_.id,items:i.items.map(p)}},dispose(){for(const y of D.values())y.get(_.id)?.clear();v?.dispose(),s.dispose()}})}convertTimelineItem(t,_,n){return(f,s)=>{let u;if(s?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const D=S(f);u=v.get(D),u===void 0&&(u=new Map,v.set(D,u))}return v=>{const{iconPath:D,...y}=v,o=`${t}|${v.id??v.timestamp}`;u?.set(o,v);let h,C,i;return v.iconPath&&(D instanceof F.ThemeIcon?i={id:D.id,color:D.color}:d.URI.isUri(D)?(h=D,C=D):{light:h,dark:C}=D),{...y,id:y.id??void 0,handle:o,source:t,command:v.command?_.toInternal(v.command,n):void 0,icon:h,iconDark:C,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=k;function S(T){return T?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,T,t,_){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=_.schemes.find(f=>!F.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,_.schemes,S,_.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(S,T,t){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener with id: ${S}`);const n=E.URI.revive(T);return _.canOpenExternalUri(n,t)}async $openUri(S,T,t){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener id: '${S}'`);return _.openExternalUri(E.URI.revive(T.resolvedUri),{sourceUri:E.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(se,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(F.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const _=k.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(T)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,T),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(T)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(T,t){const _=this.handlers.get(T);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=k,k.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[51],Ee([0,1,3,2,138,158,67,5]),function(se,e,d,M,E,A,F,k){"use strict";var S,T,t,_,n,f,s,u,v,D,y,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(m,b,P,g,I,R,L){S.set(this,void 0),T.set(this,void 0),t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),s.set(this,""),u.set(this,void 0),v.set(this,!1),D.set(this,!1),y.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new d.Emitter),this._onDidDispose=Ae(this,o,"f").event,et(this,S,m,"f"),et(this,T,b,"f"),et(this,u,P,"f"),et(this,_,g,"f"),et(this,n,I,"f"),et(this,f,R,"f"),et(this,y,C(R),"f"),et(this,t,L,"f")}dispose(){et(this,v,!0,"f"),Ae(this,o,"f").fire(),Ae(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return et(this,D,!0,"f"),(0,F.asWebviewUri)(m,Ae(this,_,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,s,"f")}set html(m){this.assertNotDisposed(),Ae(this,s,"f")!==m&&(et(this,s,m,"f"),!Ae(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(et(this,D,!0,"f"),Ae(this,t,"f").report("Webview vscode-resource: uris",Ae(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,T,"f").$setHtml(Ae(this,S,"f"),m))}get options(){return this.assertNotDisposed(),Ae(this,u,"f")}set options(m){this.assertNotDisposed(),Ae(this,T,"f").$setOptions(Ae(this,S,"f"),a(Ae(this,f,"f"),Ae(this,n,"f"),m)),et(this,u,m,"f")}async postMessage(m){if(Ae(this,v,"f"))return!1;const b=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ae(this,y,"f")});return Ae(this,T,"f").$postMessage(Ae(this,S,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Ae(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,S=new WeakMap,T=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,s=new WeakMap,u=new WeakMap,v=new WeakMap,D=new WeakMap,y=new WeakMap,o=new WeakMap;function C(l){try{const m=(0,E.normalizeVersion)((0,E.parseVersion)(l.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=C;class i{constructor(m,b,P,g,I){this.initData=b,this.workspace=P,this._logService=g,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=m.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(m,b,...P){const g=this.getWebview(m);if(g){const{message:I}=(0,A.deserializeWebviewMessage)(b,P);g._onMessageEmitter.fire(I)}}$onMissingCsp(m,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,b,P){const g=new h(m,this._webviewProxy,r(b),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(m,g),g._onDidDispose(()=>{this._webviews.delete(m)}),g}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=i;function p(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=p;function a(l,m,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||c(l,m)}}e.serializeWebviewOptions=a;function r(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(m=>M.URI.from(m))}}e.reviveOptions=r;function c(l,m){return[...(m?.getWorkspaceFolders()||[]).map(b=>b.uri),l.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,51,64,5,7]),function(se,e,d,M,E,A,F,k,S,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(i,p){this.document=i,this._storagePath=p,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,p){await this.getEdit(i).undo(),p||this.disposeBackup()}async redo(i,p){await this.getEdit(i).redo(),p||this.disposeBackup()}disposeEdits(i){for(const p of i)this._edits.delete(p)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=h(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const p=this._edits.get(i,0);if(!p)throw new Error("No edit found");return p}}class s{constructor(){this._documents=new Map}get(i,p){return this._documents.get(this.key(i,p))}add(i,p,a){const r=this.key(i,p.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${p.uri}`);const c=new f(p,a);return this._documents.set(r,c),c}delete(i,p){const a=this.key(i,p.uri);this._documents.delete(a)}key(i,p){return`${i}@@@${p}`}}var u;(function(C){C[C.Text=0]="Text",C[C.Custom=1]="Custom"})(u||(u={}));class v{constructor(){this._providers=new Map}addTextProvider(i,p,a){return this.add(0,i,p,a)}addCustomProvider(i,p,a){return this.add(1,i,p,a)}get(i){return this._providers.get(i)}add(i,p,a,r){if(this._providers.has(p))throw new Error(`Provider for viewType:${p} already registered`);return this._providers.set(p,{type:i,extension:a,provider:r}),new n.Disposable(()=>this._providers.delete(p))}}class D{constructor(i,p,a,r,c){this._extHostDocuments=p,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=c,this._editorProviders=new v,this._documents=new s,this._proxy=i.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,p,a,r){const c=new E.DisposableStore;return y(a)?(c.add(this._editorProviders.addTextProvider(p,i,a)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),p,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(c.add(this._editorProviders.addCustomProvider(p,i,a)),this.supportEditing(a)&&c.add(a.onDidChangeCustomDocument(l=>{const m=this.getCustomDocumentEntry(p,l.document.uri);if(o(l)){const b=m.addEdit(l);this._proxy.$onDidEdit(l.document.uri,p,b,l.label)}else this._proxy.$onContentChange(l.document.uri,p)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),p,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(c,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(p)}))}async $createCustomDocument(i,p,a,r,c){const l=this._editorProviders.get(p);if(!l)throw new Error(`No provider found for '${p}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${p}'`);const m=k.URI.revive(i),b=await l.provider.openCustomDocument(m,{backupId:a,untitledDocumentData:r?.buffer},c);let P;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(p,b,P),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(i,p){const a=this._editorProviders.get(p);if(!a)throw new Error(`No provider found for '${p}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${p}'`);const r=k.URI.revive(i),{document:c}=this.getCustomDocumentEntry(p,r);this._documents.delete(p,c),c.dispose()}async $resolveWebviewEditor(i,p,a,r,c,l){const m=this._editorProviders.get(a);if(!m)throw new Error(`No provider found for '${a}'`);const b=S.ViewColumn.to(c),P=this._extHostWebview.createNewWebview(p,r.webviewOptions,m.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(p,a,r.title,b,r.panelOptions,P),I=k.URI.revive(i);switch(m.type){case 1:{const{document:R}=this.getCustomDocumentEntry(a,I);return m.provider.resolveCustomEditor(R,g,l)}case 0:{const R=this._extHostDocuments.getDocument(I);return m.provider.resolveCustomTextEditor(R,g,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,p,a){this.getCustomDocumentEntry(p,i).disposeEdits(a)}async $onMoveCustomEditor(i,p,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const c=this._extHostWebviewPanels.getWebviewPanel(i);if(!c)throw new Error("No webview found");const l=k.URI.revive(p),m=this._extHostDocuments.getDocument(l);await r.provider.moveCustomTextEditor(m,c,d.CancellationToken.None)}async $undo(i,p,a,r){return this.getCustomDocumentEntry(p,i).undo(a,r)}async $redo(i,p,a,r){return this.getCustomDocumentEntry(p,i).redo(a,r)}async $revert(i,p,a){const r=this.getCustomDocumentEntry(p,i);await this.getCustomEditorProvider(p).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(i,p,a){const r=this.getCustomDocumentEntry(p,i);await this.getCustomEditorProvider(p).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(i,p,a,r){const c=this.getCustomDocumentEntry(p,i);return this.getCustomEditorProvider(p).saveCustomDocumentAs(c.document,k.URI.revive(a),r)}async $backup(i,p,a){const r=this.getCustomDocumentEntry(p,i),l=await this.getCustomEditorProvider(p).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(l),l.id}getCustomDocumentEntry(i,p){const a=this._documents.get(i,k.URI.revive(p));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function y(C){return typeof C.resolveCustomTextEditor=="function"}function o(C){return typeof C.undo=="function"&&typeof C.redo=="function"}function h(C){const i=C.scheme===A.Schemas.file||C.scheme===A.Schemas.untitled?C.fsPath:C.toString();return(0,M.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[210],Ee([0,1,3,6,2,36,8,51,5,7]),function(se,e,d,M,E,A,F,k,S,T){"use strict";var t,_,n,f,s,u,v,D,y,o,h,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class p extends M.Disposable{constructor(l,m,b,P,g,I,R){super();t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),s.set(this,void 0),u.set(this,void 0),v.set(this,void 0),D.set(this,void 0),y.set(this,!0),o.set(this,!0),h.set(this,!1),C.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,C,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,et(this,t,l,"f"),et(this,_,m,"f"),et(this,n,b,"f"),et(this,s,I,"f"),et(this,D,g,"f"),et(this,u,P,"f"),et(this,f,R,"f")}dispose(){Ae(this,h,"f")||(et(this,h,!0,"f"),Ae(this,C,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,u,"f")}set title(l){this.assertNotDisposed(),Ae(this,u,"f")!==l&&(et(this,u,l,"f"),Ae(this,_,"f").$setTitle(Ae(this,t,"f"),l))}get iconPath(){return this.assertNotDisposed(),Ae(this,v,"f")}set iconPath(l){this.assertNotDisposed(),Ae(this,v,"f")!==l&&(et(this,v,l,"f"),Ae(this,_,"f").$setIconPath(Ae(this,t,"f"),E.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ae(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,D,"f")=="number"&&Ae(this,D,"f")<0))return Ae(this,D,"f")}get active(){return this.assertNotDisposed(),Ae(this,o,"f")}get visible(){return this.assertNotDisposed(),Ae(this,y,"f")}_updateViewState(l){Ae(this,h,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(et(this,o,l.active,"f"),et(this,y,l.visible,"f"),et(this,D,l.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(l,m){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,t,"f"),{viewColumn:l?F.ViewColumn.from(l):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Ae(this,h,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,s=new WeakMap,u=new WeakMap,v=new WeakMap,D=new WeakMap,y=new WeakMap,o=new WeakMap,h=new WeakMap,C=new WeakMap,i=new WeakMap;class a{constructor(l,m,b){this.webviews=m,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(l,m,b,P,g={}){const I=typeof P=="object"?P.viewColumn:P,R={viewColumn:F.ViewColumn.from(I),preserveFocus:typeof P=="object"&&!!P.preserveFocus},L=(0,k.shouldSerializeBuffersForPostMessage)(l),w=a.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(l),w,m,{title:b,panelOptions:r(g),webviewOptions:(0,k.serializeWebviewOptions)(l,this.workspace,g),serializeBuffersForPostMessage:L},R);const x=this.webviews.createNewWebview(w,g,l);return this.createNewWebviewPanel(w,m,b,I,g,x)}$onDidChangeWebviewPanelViewStates(l){const m=Object.keys(l);m.sort((b,P)=>{const g=l[b],I=l[P];return g.active?1:I.active?-1:+g.visible-+I.visible});for(const b of m){const P=this.getWebviewPanel(b);if(!P)continue;const g=l[b];P._updateViewState({active:g.active,visible:g.visible,viewColumn:F.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,m,b){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:b,extension:l}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(l,m,b,P){const g=this._serializers.get(m);if(!g)throw new Error(`No serializer found for '${m}'`);const{serializer:I,extension:R}=g,L=this.webviews.createNewWebview(l,b.webviewOptions,R),w=this.createNewWebviewPanel(l,m,b.title,P,b.panelOptions,L);await I.deserializeWebviewPanel(w,b.state)}createNewWebviewPanel(l,m,b,P,g,I){const R=new p(l,this._proxy,m,b,P,g,I);return this._webviewPanels.set(l,R),R}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=a;function r(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[211],Ee([0,1,3,6,51,5,7]),function(se,e,d,M,E,A,F){"use strict";var k,S,T,t,_,n,f,s,u,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends M.Disposable{constructor(h,C,i,p,a,r){super();k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),t.set(this,void 0),_.set(this,!1),n.set(this,void 0),f.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ae(this,u,"f").event,v.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,v,"f").event,et(this,T,i,"f"),et(this,f,p,"f"),et(this,k,h,"f"),et(this,S,C,"f"),et(this,t,a,"f"),et(this,n,r,"f")}dispose(){Ae(this,_,"f")||(et(this,_,!0,"f"),Ae(this,v,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,f,"f")}set title(h){this.assertNotDisposed(),Ae(this,f,"f")!==h&&(et(this,f,h,"f"),Ae(this,S,"f").$setWebviewViewTitle(Ae(this,k,"f"),h))}get description(){return this.assertNotDisposed(),Ae(this,s,"f")}set description(h){this.assertNotDisposed(),Ae(this,s,"f")!==h&&(et(this,s,h,"f"),Ae(this,S,"f").$setWebviewViewDescription(Ae(this,k,"f"),h))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,T,"f")}_setVisible(h){h===Ae(this,n,"f")||Ae(this,_,"f")||(et(this,n,h,"f"),Ae(this,u,"f").fire())}show(h){this.assertNotDisposed(),Ae(this,S,"f").$show(Ae(this,k,"f"),!!h)}assertNotDisposed(){if(Ae(this,_,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,T=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,s=new WeakMap,u=new WeakMap,v=new WeakMap;class y{constructor(h,C){this._extHostWebview=C,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,C,i,p){if(this._viewProviders.has(C))throw new Error(`View provider for '${C}' already registered`);return this._viewProviders.set(C,{provider:i,extension:h}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(h),C,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(C),this._proxy.$unregisterWebviewViewProvider(C)})}async $resolveWebviewView(h,C,i,p,a){const r=this._viewProviders.get(C);if(!r)throw new Error(`No view provider found for '${C}'`);const{provider:c,extension:l}=r,m=this._extHostWebview.createNewWebview(h,{},l),b=new D(h,this._proxy,C,i,m,!0);this._webviewViews.set(h,b),await c.resolveWebviewView(b,{state:p},a)}async $onDidChangeWebviewViewVisibility(h,C){this.getWebviewView(h)._setVisible(C)}async $disposeWebviewView(h){const C=this.getWebviewView(h);this._webviewViews.delete(h),C.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const C=this._webviewViews.get(h);if(!C)throw new Error("No webview found");return C}}e.ExtHostWebviewViews=y}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Ui{constructor(_){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let f;if(typeof _=="string"){f=_;try{_=E.URI.parse(_)}catch(s){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,F.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,f,n)}async asExternalUri(_,n){if((0,F.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(_,n);return E.URI.from(f)}};T.InitialState={focused:!0},T=$e([ze(0,S.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,12]),function(se,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(S,T){super();this._proxy=S.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(S,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(S,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(S,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(S,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(S,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=$e([ze(0,A.IExtHostRpcService),ze(1,E.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,14,22,21,16,3,6,109,180,38]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,I){try{return JSON.stringify(g,I)}catch(R){return"null"}}const f="$$ref$$",s={[f]:-1};class u{constructor(I,R){this.jsonString=I,this.referencedBuffers=R}}function v(g,I=null,R=!1){const L=[];return{jsonString:(R?n:JSON.stringify)(g,(x,$)=>{if(typeof $=="undefined")return s;if(typeof $=="object"){if($ instanceof M.VSBuffer){const B=L.push($)-1;return{[f]:B}}if(I)return I(x,$)}return $}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=v;function D(g,I,R){return JSON.parse(g,(L,w)=>{if(w){const x=w[f];if(typeof x=="number")return I[x];if(R&&w.$mid===1)return R.transformIncoming(w)}return w})}e.parseJsonAndRestoreBufferRefs=D;function y(g,I){return JSON.stringify(g,I)}function o(g){return g?(I,R)=>R&&R.$mid===1?g.transformOutgoing(R):R:null}var h;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},p=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends k.Disposable{constructor(I,R=null,L=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=R,this._uriTransformer=L,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,x=t.ProxyIdentifier.count;w<x;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,S.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:R,sid:L}=I;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,L)),this._proxies[R]}_createProxy(I,R){let L={get:(w,x)=>(typeof x=="string"&&!w[x]&&x.charCodeAt(0)===36&&(w[x]=(...$)=>this._remoteCall(I,x,$)),x===a?R:w[x])};return new Proxy(Object.create(null),L)}set(I,R){return this._locals[I.nid]=R,R}assertRegistered(I){for(let R=0,L=I.length;R<L;R++){const w=I[R];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const R=I.byteLength,L=c.read(I,0),w=L.readUInt8(),x=L.readUInt32();switch(w){case 1:case 2:{let{rpcId:$,method:B,args:K}=m.deserializeRequestJSONArgs(L);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(R,x,$,B,K,w===2);break}case 3:case 4:{let{rpcId:$,method:B,args:K}=m.deserializeRequestMixedArgs(L);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(R,x,$,B,K,w===4);break}case 5:{this._logger&&this._logger.logIncoming(R,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(R,x);break}case 7:{this._receiveReply(R,x,void 0);break}case 9:{let $=m.deserializeReplyOKJSON(L);this._uriTransformer&&($=(0,S.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,x,$);break}case 10:{const $=m.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(R,x,$);break}case 8:{let $=m.deserializeReplyOKVSBuffer(L);this._receiveReply(R,x,$);break}case 11:{let $=m.deserializeReplyErrError(L);this._uriTransformer&&($=(0,S.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,x,$);break}case 12:{this._receiveReplyErr(R,x,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,R,L,w,x,$){this._logger&&this._logger.logIncoming(I,R,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${w}(`,x);const B=String(R);let K,H;if($){const ne=new E.CancellationTokenSource;x.push(ne.token),K=this._invokeHandler(L,w,x),H=()=>ne.cancel()}else K=this._invokeHandler(L,w,x),H=i;this._cancelInvokedHandlers[B]=H;const W=m.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(W.byteLength,R,1,"ack"),this._protocol.send(W),K.then(ne=>{delete this._cancelInvokedHandlers[B];const V=m.serializeReplyOK(R,ne,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,R,1,"reply:",ne),this._protocol.send(V)},ne=>{delete this._cancelInvokedHandlers[B];const V=m.serializeReplyErr(R,ne);this._logger&&this._logger.logOutgoing(V.byteLength,R,1,"replyErr:",ne),this._protocol.send(V)})}_receiveCancel(I,R){this._logger&&this._logger.logIncoming(I,R,1,"receiveCancel");const L=String(R);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(I,R,L){this._logger&&this._logger.logIncoming(I,R,0,"receiveReply:",L);const w=String(R);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const x=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],x.resolveOk(L)}_receiveReplyErr(I,R,L){this._logger&&this._logger.logIncoming(I,R,0,"receiveReplyErr:",L);const w=String(R);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const x=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let $;L&&(L.$isError?($=new Error,$.name=L.name,$.message=L.message,$.stack=L.stack):$=L),x.resolveErr($)}_invokeHandler(I,R,L){try{return Promise.resolve(this._doInvokeHandler(I,R,L))}catch(w){return Promise.reject(w)}}_doInvokeHandler(I,R,L){const w=this._locals[I];if(!w)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(I));let x=w[R];if(typeof x!="function")throw new Error("Unknown method "+R+" on actor "+(0,t.getStringIdentifierForProxy)(I));return x.apply(w,L)}_remoteCall(I,R,L){if(this._isDisposed)return Promise.reject(A.canceled());let w=null;if(L.length>0&&E.CancellationToken.isCancellationToken(L[L.length-1])&&(w=L.pop()),w&&w.isCancellationRequested)return Promise.reject(A.canceled());const x=m.serializeRequestArguments(L,this._uriReplacer),$=++this._lastMessageId,B=String($),K=new T.LazyPromise;w&&w.onCancellationRequested(()=>{const W=m.serializeCancel($);this._logger&&this._logger.logOutgoing(W.byteLength,$,0,"cancel"),this._protocol.send(m.serializeCancel($))}),this._pendingRPCReplies[B]=K,this._onWillSendRequest($);const H=m.serializeRequest($,I,R,x,!!w);return this._logger&&this._logger.logOutgoing(H.byteLength,$,0,`request: ${(0,t.getStringIdentifierForProxy)(I)}.${R}(`,L),this._protocol.send(H),K}}e.RPCProtocol=r,_=p,r.UNRESPONSIVE_TIME=3*1e3;class c{constructor(I,R){this._buff=I,this._offset=R}static alloc(I,R,L){let w=new c(M.VSBuffer.alloc(L+1+4),0);return w.writeUInt8(I),w.writeUInt32(R),w}static read(I,R){return new c(I,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,L}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,L}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,R}static sizeMixedArray(I){let R=0;R+=1;for(let L=0,w=I.length;L<w;L++){const x=I[L];switch(R+=1,x.type){case 1:R+=this.sizeLongString(x.value);break;case 2:R+=this.sizeVSBuffer(x.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(x.value);for(let $=0;$<x.buffers.length;++$)R+=this.sizeVSBuffer(x.buffers[$]);break;case 4:break}}return R}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let R=0,L=I.length;R<L;R++){const w=I[R];switch(w.type){case 1:this.writeUInt8(1),this.writeLongString(w.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(w.value);break;case 3:this.writeUInt8(3),this.writeUInt32(w.buffers.length),this.writeLongString(w.value);for(let x=0;x<w.buffers.length;++x)this.writeBuffer(w.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(I);for(let L=0;L<I;L++)switch(this.readUInt8()){case 1:R[L]=this.readLongString();break;case 2:R[L]=this.readVSBuffer();break;case 3:const x=this.readUInt32(),$=this.readLongString(),B=[];for(let K=0;K<x;++K)B.push(this.readVSBuffer());R[L]=new t.SerializableObjectWithBuffers(D($,B,null));break;case 4:R[L]=void 0;break}return R}}c.sizeUInt32=4;var l;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(l||(l={}));class m{static _useMixedArgSerialization(I){for(let R=0,L=I.length;R<L;R++)if(I[R]instanceof M.VSBuffer||I[R]instanceof t.SerializableObjectWithBuffers||typeof I[R]=="undefined")return!0;return!1}static serializeRequestArguments(I,R){if(this._useMixedArgSerialization(I)){const L=[];for(let w=0,x=I.length;w<x;w++){const $=I[w];if($ instanceof M.VSBuffer)L[w]={type:2,value:$};else if(typeof $=="undefined")L[w]={type:4};else if($ instanceof t.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:K}=v($.value,R);L[w]={type:3,value:M.VSBuffer.fromString(B),buffers:K}}else L[w]={type:1,value:M.VSBuffer.fromString(y($,R))}}return{type:1,args:L}}return{type:0,args:y(I,R)}}static serializeRequest(I,R,L,w,x){switch(w.type){case 0:return this._requestJSONArgs(I,R,L,w.args,x);case 1:return this._requestMixedArgs(I,R,L,w.args,x)}}static _requestJSONArgs(I,R,L,w,x){const $=M.VSBuffer.fromString(L),B=M.VSBuffer.fromString(w);let K=0;K+=c.sizeUInt8(),K+=c.sizeShortString($),K+=c.sizeLongString(B);let H=c.alloc(x?2:1,I,K);return H.writeUInt8(R),H.writeShortString($),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(I){const R=I.readUInt8(),L=I.readShortString(),w=I.readLongString();return{rpcId:R,method:L,args:JSON.parse(w)}}static _requestMixedArgs(I,R,L,w,x){const $=M.VSBuffer.fromString(L);let B=0;B+=c.sizeUInt8(),B+=c.sizeShortString($),B+=c.sizeMixedArray(w);let K=c.alloc(x?4:3,I,B);return K.writeUInt8(R),K.writeShortString($),K.writeMixedArray(w),K.buffer}static deserializeRequestMixedArgs(I){const R=I.readUInt8(),L=I.readShortString(),w=I.readMixedArray(),x=new Array(w.length);for(let $=0,B=w.length;$<B;$++){const K=w[$];typeof K=="string"?x[$]=JSON.parse(K):x[$]=K}return{rpcId:R,method:L,args:x}}static serializeAcknowledged(I){return c.alloc(5,I,0).buffer}static serializeCancel(I){return c.alloc(6,I,0).buffer}static serializeReplyOK(I,R,L){if(typeof R=="undefined")return this._serializeReplyOKEmpty(I);if(R instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(I,R);if(R instanceof t.SerializableObjectWithBuffers){const{jsonString:w,referencedBuffers:x}=v(R.value,L,!0);return this._serializeReplyOKJSONWithBuffers(I,w,x)}else return this._serializeReplyOKJSON(I,n(R,L))}static _serializeReplyOKEmpty(I){return c.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,R){let L=0;L+=c.sizeVSBuffer(R);let w=c.alloc(8,I,L);return w.writeVSBuffer(R),w.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,R){const L=M.VSBuffer.fromString(R);let w=0;w+=c.sizeLongString(L);let x=c.alloc(9,I,w);return x.writeLongString(L),x.buffer}static _serializeReplyOKJSONWithBuffers(I,R,L){const w=M.VSBuffer.fromString(R);let x=0;x+=c.sizeUInt32,x+=c.sizeLongString(w);for(const B of L)x+=c.sizeVSBuffer(B);let $=c.alloc(10,I,x);$.writeUInt32(L.length),$.writeLongString(w);for(const B of L)$.writeBuffer(B);return $.buffer}static deserializeReplyOKJSON(I){const R=I.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(I,R){const L=I.readUInt32(),w=I.readLongString(),x=[];for(let $=0;$<L;++$)x.push(I.readVSBuffer());return new t.SerializableObjectWithBuffers(D(w,x,R))}static serializeReplyErr(I,R){return R?this._serializeReplyErrEror(I,R):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,R){const L=M.VSBuffer.fromString(n(A.transformErrorForSerialization(R),null));let w=0;w+=c.sizeLongString(L);let x=c.alloc(11,I,w);return x.writeLongString(L),x.buffer}static deserializeReplyErrError(I){const R=I.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(I){return c.alloc(12,I,0).buffer}}var b;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var P;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(P||(P={}))}),define(be[214],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const F=k=>{self.removeEventListener("message",F);const S=k.data;Object.defineProperties(self,{postMessage:{value(T,t){S.postMessage(T,t)}},onmessage:{get(){return S.onmessage},set(T){S.onmessage=T}}}),S.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${d})('${F}'))`,T=new Blob([S],{type:"application/javascript"}),t=URL.createObjectURL(T),_=new MessageChannel,n=t,f={type:"_newWorker",id:n,port:_.port2,url:t,options:k};A(f,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};_.port1.postMessage(s),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(s){_.port1.onmessage=s}},onmessageerror:{get(){return _.port1.onmessageerror},set(s){_.port1.onmessageerror=s}}}),_.port1.addEventListener("messageerror",s=>{const u=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(u)}),_.port1.addEventListener("message",s=>{const u=new MessageEvent("message",{data:s.data});this.dispatchEvent(u)}),_.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(se,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,63,48,176,215]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let _=class $i{constructor(f,s,u,v){this.localUserHome=f,this.remoteAgentService=s,this.environmentService=u,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||f})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return d.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const v=s.getWorkspace().folders[0];if(v)return v.uri.scheme;const D=s.getWorkspace().configuration;return D?D.scheme:d.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?M.win32:M.posix)}async fileURI(f){let s="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const v=f.indexOf("/",2);v===-1?(s=f.substring(2),f="/"):(s=f.substring(2,v),f=f.substring(v)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:s,path:f,query:"",fragment:""})}};_=$e([ze(1,t.IRemoteAgentService),ze(2,T.IWorkbenchEnvironmentService),ze(3,S.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(be[98],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,k){this.line=F,this.character=k}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,k){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,k,S,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,k),this.end=new d(S,T)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,13,27,23,43,9,4,17,16,98,10]),function(se,e,d,M,E,A,F,k,S,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",s=(n.length+f.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var u;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function D(W){return!!W.preview}e.resultIsMatch=D;function y(W){return!!W.resource}e.isFileMatch=y;function o(W){return!!W.message}e.isProgressMessage=o;var h;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=C;class i{constructor(ne,V,X){this.ranges=V;const q=Array.isArray(V)?V:[V];if(X&&X.matchLines===1&&p(q)){ne=(0,F.getNLines)(ne,X.matchLines);let le="",te=0,ve=0;const Re=Math.floor(X.charsPerLine/5),Fe=[];for(const Oe of q){const Ke=Math.max(Oe.startColumn-Re,0),je=Oe.startColumn+X.charsPerLine;if(Ke>ve+Re+s){const Ve=n+(Ke-ve)+f;le+=Ve+ne.slice(Ke,je),te+=Ke-(ve+Ve.length)}else le+=ne.slice(ve,je);Fe.push(new r(0,Oe.startColumn-te,Oe.endColumn-te)),ve=je}this.preview={text:le,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const le=Array.isArray(V)?V[0].startLineNumber:V.startLineNumber;this.preview={text:ne,matches:(0,d.mapArrayOrNot)(V,te=>new a(te.startLineNumber-le,te.startColumn,te.endLineNumber-le,te.endColumn))}}}}e.TextSearchMatch=i;function p(W){const ne=W[0].startLineNumber;for(const V of W)if(V.startLineNumber!==ne||V.endLineNumber!==ne)return!1;return!0}class a{constructor(ne,V,X,q){this.startLineNumber=ne,this.startColumn=V,this.endLineNumber=X,this.endColumn=q}}e.SearchRange=a;class r extends a{constructor(ne,V,X){super(ne,V,ne,X)}}e.OneLineRange=r;var c;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function l(W,ne=!0){const V=W&&W.files&&W.files.exclude,X=ne&&W&&W.search&&W.search.exclude;if(!V&&!X)return;if(!V||!X)return V||X;let q=Object.create(null);return q=E.mixin(q,E.deepClone(V)),q=E.mixin(q,E.deepClone(X),!0),q}e.getExcludes=l;function m(W,ne){return W.excludePattern&&M.match(W.excludePattern,ne)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&M.match(W.includePattern,ne)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(V=>{const X=V.folder.fsPath;if(A.isEqualOrParent(ne,X)){const q=S.relative(X,ne);return!V.includePattern||!!M.match(V.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var b;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(ne,V){super(ne);this.code=V}}e.SearchError=P;function g(W){const ne=W.message;if((0,T.isPromiseCanceledError)(W))return new P(ne,b.canceled);try{const V=JSON.parse(ne);return new P(V.message,V.code)}catch(V){return new P(ne,b.other)}}e.deserializeSearchError=g;function I(W){const ne={message:W.message,code:W.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=I;function R(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=R;function L(W){return W.type==="success"}e.isSerializedSearchSuccess=L;function w(W){return!!W.path}e.isSerializedFileMatch=w;function x(W,ne){const V=W.searchPath?W.searchPath:W.relativePath;return(0,F.fuzzyContains)(V,ne)}e.isFilePatternMatch=x;class ${constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function B(W,ne){const V={...W||{},...ne||{}};return Object.keys(V).filter(X=>{const q=V[X];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=B;class K{constructor(ne,V){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...V.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let X=ne.includePattern;V.includePattern&&(X?X={...X,...V.includePattern}:X=V.includePattern),X&&(this._parsedIncludeExpression=M.parse(X))}matchesExcludesSync(ne,V,X){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,X))}includedInQuerySync(ne,V,X){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,X)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,V,X))}includedInQuery(ne,V,X){const q=this._parsedExcludeExpression(ne,V,X),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,V,X):!0;return(0,_.isPromise)(q)?q.then(te=>te?!1:le()):le()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=K;function H(W){for(const ne in W)if(typeof W[ne]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,76,24,9,10,2,130,4,15,144,48,37,29,12,7,41,5]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o,h,C,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(I,R,L){return new T.ExtUri(w=>m(w,L)).isEqual(I,R)}function r(I,R,L){return a(I.uri,R.uri,L)?0:(0,t.compare)(I.uri.toString(),R.uri.toString())}function c(I,R,L){return I.index!==R.index?I.index<R.index?-1:1:a(I.uri,R.uri,L)?(0,t.compare)(I.name,R.name):(0,t.compare)(I.uri.toString(),R.uri.toString())}function l(I,R,L,w){const x=I.slice(0).sort((B,K)=>L(B,K,w)),$=R.slice(0).sort((B,K)=>L(B,K,w));return(0,d.delta)(x,$,(B,K)=>L(B,K,w))}function m(I,R){const L=R.getCapabilities(I.scheme);return!(L&&L&1024)}class b extends D.Workspace{constructor(R,L,w,x,$,B,K){super(R,w.map(H=>new D.WorkspaceFolder(H)),x,$,K);this._name=L,this._isUntitled=B,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(K),w.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(R,L,w,x){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:B,folders:K,configuration:H,transient:W,isUntitled:ne}=R,V=[],X=L;L?K.forEach((ve,Re)=>{const Fe=n.URI.revive(ve.uri),Oe=b._findFolder(w||L,Fe,x);Oe?(Oe.name=ve.name,Oe.index=ve.index,V.push(Oe)):V.push({uri:Fe,name:ve.name,index:Re})}):V.push(...K.map(({uri:ve,name:Re,index:Fe})=>({uri:n.URI.revive(ve),name:Re,index:Fe}))),V.sort((ve,Re)=>ve.index<Re.index?-1:1);const q=new b($,B,V,!!W,H?n.URI.revive(H):null,!!ne,ve=>m(ve,x)),{added:le,removed:te}=l(X?X.workspaceFolders:[],q.workspaceFolders,r,x);return{workspace:q,added:le,removed:te}}static _findFolder(R,L,w){for(let x=0;x<R.folders.length;x++){const $=R.workspaceFolders[x];if(a($.uri,L,w))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,L){return L&&this._structure.get(R)&&(R=(0,T.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let P=class{constructor(R,L,w,x){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=w,this._requestIdProvider=new S.Counter,this._barrier=new M.Barrier,this._proxy=R.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(p.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new b($.id,$.name,[],!!$.transient,$.configuration?n.URI.revive($.configuration):null,!!$.isUntitled,B=>m(B,w)):void 0}$initializeWorkspace(R,L){this._trusted=L,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:k.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,L,w,...x){const $=[];if(Array.isArray(x)&&x.forEach(ne=>{n.URI.isUri(ne.uri)&&!$.some(V=>a(V.uri,ne.uri,this._extHostFileSystemInfo))&&$.push({uri:ne.uri,name:ne.name||(0,T.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[L,w].some(ne=>typeof ne!="number"||ne<0)||w===0&&$.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+w>B.length)return!1;const K=B.slice(0);K.splice(L,w,...$.map(ne=>({uri:ne.uri,name:ne.name||(0,T.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<K.length;ne++){const V=K[ne];if(K.some((X,q)=>q!==ne&&a(V.uri,X.uri,this._extHostFileSystemInfo)))return!1}K.forEach((ne,V)=>ne.index=V);const{added:H,removed:W}=l(B,K,c,this._extHostFileSystemInfo);if(H.length===0&&W.length===0)return!1;if(this._proxy){const ne=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(ne,L,w,$).then(void 0,V=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,f.localize)(0,null,ne,V.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(R,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,L)}async getWorkspaceFolder2(R,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,L)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,L){let w,x="";if(typeof R=="string"?(w=n.URI.file(R),x=R):typeof R!="undefined"&&(w=R,x=R.fsPath),!w)return x;const $=this.getWorkspaceFolder(w,!0);if(!$)return x;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let B=(0,T.relativePath)($.uri,w);return L&&$.name&&(B=`${$.name}/${B}`),B}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:L,added:w,removed:x}=b.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:w,removed:x}))}findFiles(R,L,w,x,$=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let B;if(L===null?B=!1:L&&(typeof L=="string"?B=L:B=L.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:H}=g(R);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(K),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(B),(0,_.withUndefinedAsNull)(w),$).then(W=>Array.isArray(W)?W.map(ne=>n.URI.revive(ne)):[])}async findTextInFiles(R,L,w,x,$=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),K=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:H,folder:W}=g(L.include),ne=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,V={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:K,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:H,excludePattern:ne},X=!1;if(this._activeSearchCallbacks[B]=q=>{if(X)return;const le=n.URI.revive(q.resource);q.results.forEach(te=>{(0,i.resultIsMatch)(te)?w({uri:le,preview:{text:te.preview.text,matches:(0,d.mapArrayOrNot)(te.preview.matches,ve=>new C.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(te.ranges,ve=>new C.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):w({uri:le,text:te.text,lineNumber:te.lineNumber})})},$.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(R,(0,_.withUndefinedAsNull)(W),V,B,$);return delete this._activeSearchCallbacks[B],q||{}}catch(q){throw delete this._activeSearchCallbacks[B],q}}$handleTextSearchResult(R,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=$e([ze(0,h.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,y.IExtHostFileSystemInfo),ze(3,u.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function g(I){let R,L;return I&&(typeof I=="string"?R=I:(R=I.pattern,L=I.baseFolder||n.URI.file(I.base))),{includePattern:R,folder:L}}}),define(be[32],Ee([0,1,23,3,31,5,7,147,62,10,14,4,12,15,2]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(p,a){if(a){const r=a.split(".");let c=p;for(let l=0;c&&l<r.length;l++)c=c[r[l]];return c}}function v(p){return p instanceof s.URI}function D(p){return p&&p.uri instanceof s.URI&&p.languageId&&typeof p.languageId=="string"}function y(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function o(p){return p&&p.uri instanceof s.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function h(p){if(v(p))return{resource:p};if(D(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(y(p))return{overrideIdentifier:p.languageId};if(o(p))return{resource:p.uri};if(p===null)return{resource:null}}let C=class{constructor(a,r,c){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=c,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,r))}};C=$e([ze(0,n.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,f.ILogService)],C),e.ExtHostConfiguration=C;class i{constructor(a,r,c,l){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=l,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,c))}getConfiguration(a,r,c){const l=h(r)||{},m=this._toReadonlyValue(a?u(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,l,c?.identifier);function b(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(g){return typeof u(m,g)!="undefined"},get:(g,I)=>{this._validateConfigurationAccess(a?`${a}.${g}`:g,l,c?.identifier);let R=u(m,g);if(typeof R=="undefined")R=I;else{let L;const w=(x,$)=>{let B;const K=()=>{L=L||(0,d.deepClone)(m),B=B||u(L,$)};return(0,T.isObject)(x)?new Proxy(x,{get:(H,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return K(),()=>B;if(L)return B=B||u(L,$),B[W];const ne=H[W];return typeof W=="string"?w(ne,`${$}.${W}`):ne},set:(H,W,ne)=>(K(),B&&(B[W]=ne),!0),deleteProperty:(H,W)=>(K(),B&&delete B[W],!0),defineProperty:(H,W,ne)=>(K(),B&&Object.defineProperty(B,W,ne),!0)}):x};R=w(R,g)}return R},update:(g,I,R,L)=>{g=a?`${a}.${g}`:g;const w=b(R);return I!==void 0?this._proxy.$updateConfigurationOption(w,g,I,l,L):this._proxy.$removeConfigurationOption(w,g,l,L)},inspect:g=>{g=a?`${a}.${g}`:g;const I=(0,d.deepClone)(this._configuration.inspect(g,l,this._extHostWorkspace.workspace));if(I)return{key:g,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof m=="object"&&(0,d.mixin)(P,m,!1),Object.freeze(P)}_toReadonlyValue(a){const r=c=>(0,T.isObject)(c)?new Proxy(c,{get:(l,m)=>r(l[m]),set:(l,m,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(l,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(l,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return r(a)}_validateConfigurationAccess(a,r,c){const l=S.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),m=c?`[${c.value}] `:"";if(l===4){typeof r?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){r?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const c=new k.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,m)=>c.affectsConfiguration(l,h(m))})}_toMap(a){return a.reduce((r,c)=>(r.set(c[0],c[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[99],Ee([0,1,2,14,3,5,7,31,50,32,21,40,12,29,4,11,25,15,70,166,16]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o,h){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function($){function B(H){if(H!=null)return H}$.from=B;function K(H){if(H!=null)return H}$.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var p;(function($){function B(H){if(H!=null)return H}$.from=B;function K(H){if(H!=null)return H}$.to=K})(p=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function($){function B(H){if(H!=null)return H}$.from=B;function K(H){if(H!=null)return H}$.to=K})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function($){function B(W){if(W){const ne=W;return ne&&!!ne.process}else return!1}$.is=B;function K(W){if(W==null)return;const ne={process:W.process,args:W.args};return W.options&&(ne.options=a.from(W.options)),ne}$.from=K;function H(W){if(W!=null)return new F.ProcessExecution(W.process,W.args,W.options)}$.to=H})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function($){function B(H){if(H!=null)return H}$.from=B;function K(H){if(H!=null)return H}$.to=K})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function($){function B(W){if(W){const ne=W;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}$.is=B;function K(W){if(W==null)return;const ne={};return W.commandLine!==void 0?ne.commandLine=W.commandLine:(ne.command=W.command,ne.args=W.args),W.options&&(ne.options=c.from(W.options)),ne}$.from=K;function H(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new F.ShellExecution(W.commandLine,W.options):new F.ShellExecution(W.command,W.args?W.args:[],W.options)}$.to=H})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function($){function B(W){if(W){let ne=W;return ne&&ne.customExecution==="customExecution"}else return!1}$.is=B;function K(W){return{customExecution:"customExecution"}}$.from=K;function H(W,ne){return ne.get(W)}$.to=H})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function($){function B(K,H){let W;return K.scope!==void 0&&typeof K.scope!="number"?W=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===F.TaskScope.Workspace&&H&&H.workspaceFile?W=H.workspaceFile:W=o.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:W}}$.from=B})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var P;(function($){function B(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}$.from=B})(P=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function($){function B(W,ne){if(W==null)return[];const V=[];for(let X of W){const q=K(X,ne);q&&V.push(q)}return V}$.fromMany=B;function K(W,ne){if(W==null)return;let V;W.execution instanceof F.ProcessExecution?V=r.from(W.execution):W.execution instanceof F.ShellExecution?V=l.from(W.execution):W.execution&&W.execution instanceof F.CustomExecution&&(V=m.from(W.execution));const X=i.from(W.definition);let q;return W.scope?typeof W.scope=="number"?q=W.scope:q=W.scope.uri:q=F.TaskScope.Workspace,!X||!q?void 0:{_id:W._id,definition:X,name:W.name,source:{extensionId:ne.identifier.value,label:W.source,scope:q},execution:V,isBackground:W.isBackground,group:P.from(W.group),presentationOptions:p.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}$.from=K;async function H(W,ne,V){if(W==null)return;let X;r.is(W.execution)?X=r.to(W.execution):l.is(W.execution)?X=l.to(W.execution):m.is(W.execution)&&(X=m.to(W._id,V));const q=i.to(W.definition);let le;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?le=W.source.scope:le=await ne.resolveWorkspaceFolder(d.URI.revive(W.source.scope)):le=F.TaskScope.Workspace),!q||!le)return;const te=new F.Task(q,le,W.name,W.source.label,X,W.problemMatchers);return W.isBackground!==void 0&&(te.isBackground=W.isBackground),W.group!==void 0&&(te.group=F.TaskGroup.from(W.group._id),te.group&&W.group.isDefault&&(te.group=new F.TaskGroup(te.group.id,te.group.label),W.group.isDefault&&(te.group.isDefault=W.group.isDefault))),W.presentationOptions&&(te.presentationOptions=p.to(W.presentationOptions)),W._id&&(te._id=W._id),W.detail&&(te.detail=W.detail),te}$.to=H})(g=e.TaskDTO||(e.TaskDTO={}));var I;(function($){function B(H){return H}$.from=B;function K(H){if(!!H)return Object.assign(Object.create(null),H)}$.to=K})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(B,K,H){this._id=K,this._task=H,C.set(this,void 0),et(this,C,B,"f")}get task(){return this._task}terminate(){Ae(this,C,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}C=new WeakMap;var L;(function($){function B(K){return{id:K._id,task:void 0}}$.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let w=class{constructor(B,K,H,W,ne,V,X,q){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=W,this._configurationService=ne,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=X,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,K,H){if(!H)return new F.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:K,provider:H,extension:B}),this._proxy.$registerTaskProvider(W,K),new F.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(B,K){this._proxy.$registerTaskSystem(B,K)}fetchTasks(B){return this._proxy.$fetchTasks(I.from(B)).then(async K=>{const H=[];for(let W of K){const ne=await g.to(W,this._workspaceProvider,this._providedCustomExecutions2);ne&&H.push(ne)}return H})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(K=>B.push(K)),B}terminateTask(B){if(!(B instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,K,H){const W=this._providedCustomExecutions2.get(B.id);if(W){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,W),this._terminalService.attachPtyToTerminal(K,await W.callback(H))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const K=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const K=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:K,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const K=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:B.exitCode})}$provideTasks(B,K){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));const W=[],ne=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(V=>this.provideTasksInternal(K,W,H,V));return new Promise(V=>{ne.then(X=>{Promise.all(W).then(()=>{V(X)})})})}async $resolveTask(B,K){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));if(K.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${H.type}].`);const W=await g.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ne=await H.provider.resolveTask(W,t.CancellationToken.None);if(!ne)return;this.checkDeprecation(ne,H);const V=g.from(ne,H.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(V.execution)&&await this.addCustomExecution(V,ne,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,K,H){const W=await this._proxy.$createTaskId(B);!H&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,K.execution)}async getTaskExecution(B,K){if(typeof B=="string"){const ne=this._taskExecutionPromises.get(B);if(!ne)throw new Error("Unexpected: The specified task is missing an execution");return ne}let H=this._taskExecutionPromises.get(B.id);if(H)return H;const W=new Promise(async(ne,V)=>{const X=K||await g.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);X?ne(new R(this,B.id,X)):V("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,W),W.then(ne=>(this._taskExecutions.set(B.id,ne),ne),ne=>Promise.reject(ne))}checkDeprecation(B,K){B._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let H=this._notProvidedCustomExecutions.values(),W=H.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=H.next()}};w=$e([ze(0,n.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,_.IExtHostTerminalService),ze(6,D.ILogService),ze(7,y.IExtHostApiDeprecationService)],w),e.ExtHostTaskBase=w;let x=class extends w{constructor(B,K,H,W,ne,V,X,q){super(B,K,H,W,ne,V,X,q);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(B,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const H=g.from(K,B);if(H===void 0)throw new Error("Task is not valid");if(m.is(H.execution))await this.addCustomExecution(H,K,!1);else throw new h.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),K);return this._proxy.$executeTask(H).catch(ne=>{throw new Error(ne)}),W}provideTasksInternal(B,K,H,W){const ne=[];if(W)for(let V of W){this.checkDeprecation(V,H),(!V.definition||!B[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const X=g.from(V,H.extension);X&&m.is(X.execution)?(ne.push(X),K.push(this.addCustomExecution(X,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:H.extension}}async resolveTaskInternal(B){if(m.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,K,H){}};x=$e([ze(0,n.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,_.IExtHostTerminalService),ze(6,D.ILogService),ze(7,y.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,13,52,27,78,20,11,17,24,9,10,2,111,134,85,48,92,216,41]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(b,P,g,I){this.configurationService=b,this.workspaceContextService=P,this.editorGroupsService=g,this.pathService=I}text(b,P,g={}){b=this.getContentPattern(b,g);const I=this.configurationService.getValue(),R=P&&P.some(w=>!this.configurationService.getValue({resource:w}).search.useRipgrep);return{...this.commonQuery(P?.map(v.toWorkspaceFolder),g),type:2,contentPattern:b,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:I.search.usePCRE2||R||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(b,P){const g=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const I={...b,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(b,P)&&(I.isCaseSensitive=!0),this.isMultiline(b)&&(I.isMultiline=!0),I}file(b,P={}){return{...this.commonQuery(b,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(b,P){return b?(b=Array.isArray(b)?b.map(r):r(b),P?this.parseSearchPaths(b):{pattern:i(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],P={}){const g=this.handleIncludeExclude(P.includePattern,P.expandPatterns),I=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),R=b.length>1,L=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map($=>this.getFolderQueryForSearchPath($,P,I)):b.map($=>this.getFolderQueryForRoot($,P,I,R))).filter($=>!!$),w={_reason:P._reason,folderQueries:L,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:I.pattern,includePattern:g.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const B=d.coalesce(d.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(W=>W.resource)))).filter(H=>(0,o.pathIncludedInQuery)(w,H.fsPath)),K=this.commonQueryFromFileList(B);return{...w,...K}}const x=P.extraFileResources&&P.extraFileResources.filter($=>(0,o.pathIncludedInQuery)(w,$.fsPath));return w.extraFileResources=x&&x.length?x:void 0,w}commonQueryFromFileList(b){const P=[],g=new F.ResourceMap,I={};let R=!1;return b.forEach(L=>{if(L.scheme===k.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const x=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:S.dirname(L.fsPath)});let $=g.get(x);$||(R=!0,$={folder:x,includePattern:{}},P.push($),g.set(x,$));const B=S.relative(x.fsPath,L.fsPath);(0,_.assertIsDefined)($.includePattern)[B.replace(/\\/g,"/")]=!0}else L.fsPath&&(R=!0,I[L.fsPath]=!0)}),{folderQueries:P,includePattern:I,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(b,P){if(P.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,f.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const P=K=>S.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),I=(Array.isArray(b)?b:p(b)).map(K=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(K,H.scheme===k.Schemas.file?H.fsPath:H.path):K}),R=M.groupBy(I,K=>P(K)?"searchPaths":"exprSegments"),L=(R.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),a(K))),w={},x=this.expandSearchPathPatterns(R.searchPaths||[]);x&&x.length&&(w.searchPaths=x);const $=d.flatten(L),B=i(...$);return B&&(w.pattern=B),w}getExcludesForFolder(b,P){return P.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const P=d.flatten(b.map(I=>{let{pathPortion:R,globPortion:L}=C(I);L&&(L=c(L));const w=this.expandOneSearchPath(R);return d.flatten(w.map(x=>this.resolveOneSearchPathPattern(x,L)))})),g=new Map;return P.forEach(I=>{const R=I.searchPath.toString(),L=g.get(R);L?I.pattern&&(L.pattern=L.pattern||{},L.pattern[I.pattern]=!0):g.set(R,{searchPath:I.searchPath,pattern:I.pattern?i(I.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(b){if(S.isAbsolute(b)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==k.Schemas.file?[{searchPath:P[0].uri.with({path:b})}]:[{searchPath:n.URI.file(S.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=r(b),b.startsWith("../")||b===".."){const I=S.posix.resolve(P.path,b);return[{searchPath:P.with({path:I})}]}const g=c(b);return[{searchPath:P,pattern:g}]}else{if(b==="./"||b===".\\")return[];{const P=b.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(R=>{const L=P.match(new RegExp(`^${t.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return L?{match:L,folder:R}:null}).filter(_.isDefined);if(I.length)return I.map(R=>{const L=R.match[1];return{searchPath:R.folder.uri,pattern:L&&c(L)}});{const R=b.match(/\.[\/\\](.+)[\/\\]?/),L=R?R[1]:b,w=s.localize(0,null,L);throw new Error(w)}}}}resolveOneSearchPathPattern(b,P){const g=b.pattern&&P?`${b.pattern}/${P}`:b.pattern||P,I=[{searchPath:b.searchPath,pattern:g}];return g&&!g.endsWith("**")&&I.push({searchPath:b.searchPath,pattern:g+"/**"}),I}getFolderQueryForSearchPath(b,P,g){const I=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(b.searchPath),P,g,!1);return I?{...I,includePattern:b.pattern}:null}getFolderQueryForRoot(b,P,g,I){let R;const L=n.URI.isUri(b)?b:b.uri;if(g.searchPaths){const K=g.searchPaths.filter(H=>(0,T.isEqual)(H.searchPath,L))[0];if(K&&!K.pattern)return null;K&&(R=K.pattern)}const w=this.configurationService.getValue({resource:L}),$={...this.getExcludesForFolder(w,P)||{},...R||{}},B=n.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:L,folderName:I?B:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:w.files&&w.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!w.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!w.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!w.search.followSymlinks}}};h=$e([ze(0,u.IConfigurationService),ze(1,v.IWorkspaceContextService),ze(2,D.IEditorGroupsService),ze(3,y.IPathService)],h),e.QueryBuilder=h;function C(m){const b=m.match(/[\*\{\}\(\)\[\]\?]/);if(b){const P=b.index,g=m.substr(0,P).match(/[/|\\][^/\\]*$/);if(g){let I=m.substr(0,g.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:m.substr((g.index||0)+1)}}}return{pathPortion:m}}function i(...m){return m.length?m.reduce((b,P)=>(b[P]=!0,b),Object.create(null)):void 0}function p(m){return E.splitGlobAware(m,",").map(b=>b.trim()).filter(b=>!!b.length)}function a(m){return[`**/${m}/**`,`**/${m}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function c(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(m,b){m=d.distinct(m,I=>I.toString());const P=[],g=b.getWorkspace();return m&&m.forEach(I=>{let R;if(b.getWorkbenchState()===2)R=(0,T.relativePath)(g.folders[0].uri,I),R&&R!=="."&&(R="./"+R);else{const L=b.getWorkspaceFolder(I);if(L){const w=L.name;if(g.folders.filter($=>$.name===w).length===1){const $=(0,T.relativePath)(L.uri,I);$===""?R=`./${L.name}`:R=`./${L.name}/${$}`}else R=I.fsPath}}R&&P.push(R)}),P}e.resolveResourcesForSearchIncludes=l}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,48]),function(se,e,d,M,E,A,F,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(u,v){const D=v.activationEvents;if(!D)return Promise.resolve(void 0);const y=[],o=[];for(const r of D)if(/^workspaceContains:/.test(r)){const c=r.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||u.forceUsingSearch?o.push(c):y.push(c)}if(y.length===0&&o.length===0)return Promise.resolve(void 0);let h;const C=new Promise((r,c)=>{h=r}),i=r=>h({activationEvent:r}),p=Promise.all(y.map(r=>n(u,r,i))).then(()=>{}),a=f(u,v.identifier,o,i);return Promise.all([p,a]).then(()=>{h(void 0)}),C}e.checkActivateWorkspaceContainsExtension=_;async function n(u,v,D){for(const y of u.folders)if(await u.exists(d.joinPath(M.URI.revive(y),v))){D(`workspaceContains:${v}`);return}}async function f(u,v,D,y){if(D.length===0)return Promise.resolve(void 0);const o=new E.CancellationTokenSource,h=u.checkExists(u.folders,D,o.token),C=setTimeout(async()=>{o.cancel(),y(`workspaceContainsTimeout:${D.join(",")}`)},t);let i=!1;try{i=await h}catch(p){A.isPromiseCanceledError(p)||A.onUnexpectedError(p)}o.dispose(),clearTimeout(C),i&&y(`workspaceContains:${D.join(",")}`)}function s(u,v,D,y){const o=u.get(F.IInstantiationService),h=u.get(S.ISearchService),i=o.createInstance(k.QueryBuilder).file(v.map(p=>(0,T.toWorkspaceFolder)(M.URI.revive(p))),{_reason:"checkExists",includePattern:D,exists:!0});return h.fileSearch(i,y).then(p=>!!p.limitHit,p=>A.isPromiseCanceledError(p)?!1:Promise.reject(p))}e.checkGlobFileExists=s});var et=this&&this.__classPrivateFieldSet||function(se,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,d):E?E.value=d:e.set(se,d),d},Ae=this&&this.__classPrivateFieldGet||function(se,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(se):M?M.value:e.get(se)};define(be[33],Ee([0,1,125,17,75,24,14,6,20,2,15,5,32,179,73,31,30,177,16,26,22,153,7,86,4,29,74,12,61,65,40,3,218,69,155,11]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o,h,C,i,p,a,r,c,l,m,b,P,g,I,R,L,w){"use strict";var x,$,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let K=class Wi extends k.Disposable{constructor(V,X,q,le,te,ve,Re,Fe,Oe,Ke){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=X,this._extHostContext=q,this._initData=Re,this._extHostWorkspace=le,this._extHostConfiguration=te,this._logService=ve,this._extHostTunnelService=Oe,this._extHostTerminalService=Ke,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=V.createChild(new m.ServiceCollection([s.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Ve=>je.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,U,Q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,y.transformErrorForSerialization(U),Q)},actualActivateExtension:async(Ve,U)=>{if(je.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,U),new f.HostExtension;const Q=this._registry.getExtensionDescription(Ve);return this._activateExtension(Q,U)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){y.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch(X){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,X){return this._activator.activateByEvent(V,X)}_activateById(V,X){return this._activator.activateById(V,X)}activateByIdWithErrors(V,X){return this._activateById(V,X).then(()=>{const q=this._activator.getActivatedExtension(V);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==w.Schemas.file)return V;const X=await this._hostUtils.realpath(V.fsPath);return T.URI.file(X)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=S.TernarySearchTree.forUris(X=>A.extUriBiasedIgnorePathCase.ignorePathCasing(X));for(const X of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(X)){const q=await this._realPathExtensionUri(X.extensionLocation);V.set(q,X)}return V})()),this._extensionPathIndex}_deactivate(V){let X=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return X;const q=this._activator.getActivatedExtension(V);if(!q)return X;try{typeof q.module.deactivate=="function"&&(X=Promise.resolve(q.module.deactivate()).then(void 0,le=>(this._logService.error(le),Promise.resolve(void 0))))}catch(le){this._logService.error(le)}try{(0,k.dispose)(q.subscriptions)}catch(le){this._logService.error(le)}return X}async _activateExtension(V,X){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,X).then(q=>{const le=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,X),this._logExtensionActivationTimes(V,X,"success",le),q},q=>{throw this._logExtensionActivationTimes(V,X,"failure"),q})}_logExtensionActivationTimes(V,X,q,le){const te=H(V,X);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...le||{},outcome:q})}_doActivateExtension(V,X){const q=H(V,X);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const le=this._getEntryPoint(V);if(!le)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${V.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this._logService.flush();const te=new f.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,le),te),this._loadExtensionContext(V)]).then(ve=>(E.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Wi._callActivate(this._logService,V.identifier,ve[0],ve[1],te))).then(ve=>(E.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),ve))}_loadExtensionContext(V){const X=new C.ExtensionGlobalMemento(V,this._storage),q=new C.ExtensionMemento(V.identifier.value,!1,this._storage),le=new L.ExtensionSecrets(V,this._secretState),te=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([X.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let Fe;return Object.freeze({globalState:X,workspaceState:q,secrets:le,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Oe){return M.join(V.extensionLocation.fsPath,Oe)},get storagePath(){return Re._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(V).fsPath},get logPath(){return M.join(Re._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return T.URI.joinPath(Re._initData.logsLocation,V.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(V)},get globalStorageUri(){return Re._storagePath.globalValue(V)},get extensionMode(){return te},get extension(){return Fe===void 0&&(Fe=new W(Re,V.identifier,V,ve)),Fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(V),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,X,q,le,te){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,X,q,le,te).then(ve=>new f.ActivatedExtension(!1,null,te.build(),q,ve,le.subscriptions))}static _callActivateOptional(V,X,q,le,te){if(typeof q.activate=="function")try{te.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${X.value}`);const ve=typeof global=="object"?global:self,Re=q.activate.apply(ve,[le]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(Re).then(Fe=>(te.activateResolveStop(),Fe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}_activateOneStartupFinished(V,X){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:X}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const X of V.activationEvents)X==="onStartupFinished"&&this._activateOneStartupFinished(V,X)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const X=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(X),le=Promise.all([V,q]).then(()=>{});return Promise.race([le,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),le}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(X=>this._handleWorkspaceContainsEagerExtension(V,X))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,X){if(this.isActivated(X.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,le={folders:V.map(ve=>ve.uri),forceUsingSearch:q,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Re,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Re,Fe)},te=await(0,I.checkActivateWorkspaceContainsExtension)(le,X);if(!!te)return this._activateById(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:te.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:X}=this._initData.environment;if(!V||!X)throw new Error(d.localize(0,null));const q=await this._loadCommonJSModule(null,X,new f.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(d.localize(1,null,X.toString()));return new Promise((le,te)=>{const ve=(Oe,Ke)=>{Oe?te(Oe):le(typeof Ke=="number"&&Ke>0?1:0)},Re=(0,A.originalFSPath)(X),Fe=q.run(Re,ve);Fe&&Fe.then&&Fe.then(()=>{le(0)}).catch(Oe=>{te(Oe.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,X){return this._resolvers[V]=X,(0,k.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const X=V.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const q=V.substr(0,X);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(V,X){const{authorityPrefix:q,resolver:le}=await this._activateAndGetResolver(V);if(!le)return{type:"error",error:{code:p.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(le)),E.mark(`code/extHost/willResolveAuthority/${q}`);const te=await le.resolve(V,{resolveAttempt:X});E.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ve={authority:V,host:te.host,port:te.port,connectionToken:te.connectionToken},Re={extensionHostEnv:te.extensionHostEnv,isTrusted:te.isTrusted};return{type:"ok",value:{authority:ve,options:Re,tunnelInformation:{environmentTunnels:te.environmentTunnels}}}}catch(te){if(E.mark(`code/extHost/didResolveAuthorityError/${q}`),te instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te}}async $getCanonicalURI(V,X){const{authorityPrefix:q,resolver:le}=await this._activateAndGetResolver(V);if(!le)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const te=T.URI.revive(X);if(typeof le.getCanonicalURI=="undefined")return te;const ve=await(0,F.asPromise)(()=>le.getCanonicalURI(te));return ve||te}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,X){return X===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(V,!1))}async $activate(V,X){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,X),!0):!1}async $deltaExtensions(V,X){V.forEach(le=>le.extensionLocation=T.URI.revive(le.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(X.map(async le=>{const te=this._registry.getExtensionDescription(le);te&&q.delete(await this._realPathExtensionUri(te.extensionLocation))})),await Promise.all(V.map(async le=>{const te=await this._realPathExtensionUri(le.extensionLocation);q.set(te,le)})),this._registry.deltaExtensions(V,X),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let X=h.VSBuffer.alloc(V),q=Math.random()%256;for(let le=0;le<V;le++)X.writeUInt8(q,le);return X}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};K=$e([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,l.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,r.IExtHostInitDataService),ze(7,c.IExtensionStoragePaths),ze(8,b.IExtHostTunnelService),ze(9,P.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function H(ne,V){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor(V,X,q,le){x.set(this,void 0),$.set(this,void 0),B.set(this,void 0),et(this,x,V,"f"),et(this,$,X,"f"),et(this,B,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=le}get isActive(){return Ae(this,x,"f").isActivated(Ae(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,x,"f").getExtensionExports(Ae(this,B,"f"))}activate(){return Ae(this,x,"f").activateByIdWithErrors(Ae(this,B,"f"),{startup:!1,extensionId:Ae(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,x=new WeakMap,$=new WeakMap,B=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,163,31,33,50,168,32,164,12,4,10,91,71]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let h=class{constructor(m,b,P,g,I,R){this._workspaceService=b,this._extensionService=P,this._editorsService=g,this._configurationService=I,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=m.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(w=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,b){const P=m;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let g=`debug:${encodeURIComponent(P.path||"")}`,I="?";return b&&(g+=`${I}session=${encodeURIComponent(b.id)}`,I="&"),g+=`${I}ref=${P.sourceReference}`,M.URI.parse(g)}else{if(P.path)return M.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const b=[];for(const P of m.getAllExtensionDescriptions())if(P.contributes){const g=P.contributes.debuggers;if(g&&g.length>0)for(const I of g)(0,s.isDebuggerMainContribution)(I)&&b.push(I.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(b=>m.push(b)),m}addBreakpoints(m){this.startBreakpoints();const b=m.filter(I=>{const R=I.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,I),!0)});this.fireBreakpointChanges(b,[],[]);const P=[],g=new Map;for(const I of b)if(I instanceof k.SourceBreakpoint){let R=g.get(I.location.uri.toString());R||(R={type:"sourceMulti",uri:I.location.uri,lines:[]},g.set(I.location.uri.toString(),R),P.push(R)),R.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof k.FunctionBreakpoint&&P.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(m){this.startBreakpoints();const b=m.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],b,[]);const P=b.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),g=b.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),I=b.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(P,g,I)}startDebugging(m,b,P){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,b,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,debugUI:P.debugUI,suppressSaveBeforeStart:P.suppressSaveBeforeStart})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,b,P){if(!b)return new k.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:g,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,P,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,g),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(m,b,P){if(!P)return new k.Disposable(()=>{});if(!this.definesDebugType(m,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:g,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,g),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(m,b){if(!b)return new k.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:P,factory:b}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==b)})}async $runInTerminal(m,b){return Promise.resolve(void 0)}async $substituteVariables(m,b){if(!this._variableResolver){const[I,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,R)}let P;const g=await this.getFolder(m);return g&&(P={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,b)}createDebugAdapter(m,b){if(m.type==="implementation")return new r(m.implementation)}createSignService(){}async $startDASession(m,b){const P=this,g=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const R=this.convertToDto(I),L=this.createDebugAdapter(R,g);if(!L)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const w=L;return this._debugAdapters.set(m,w),this.getDebugAdapterTrackers(g).then(x=>(x&&this._debugAdaptersTrackers.set(m,x),w.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const B=$,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(B.arguments.value);K.body={signature:H},w.sendResponse(K)}else throw new Error("no signer")}catch(H){K.success=!1,K.message=H.message,w.sendResponse(K)}}else x&&x.onDidSendMessage&&x.onDidSendMessage($),$=(0,s.convertToVSCPaths)($,!0),P._debugServiceProxy.$acceptDAMessage(m,$)}),w.onError($=>{x&&x.onError&&x.onError($),this._debugServiceProxy.$acceptDAError(m,$.name,$.message,$.stack)}),w.onExit($=>{x&&x.onExit&&x.onExit((0,D.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,D.withNullAsUndefined)($),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),w.startSession()))})}$sendDAMessage(m,b){b=(0,s.convertToDAPaths)(b,!1);const P=this._debugAdaptersTrackers.get(m);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(b);const g=this._debugAdapters.get(m);g&&g.sendMessage(b)}$stopDASession(m){const b=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),b&&b.onWillStopSession&&b.onWillStopSession();const P=this._debugAdapters.get(m);return this._debugAdapters.delete(m),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const b=[],P=[],g=[];if(m.added)for(const I of m.added){const R=I.id;if(R&&!this._breakpoints.has(R)){let L;if(I.type==="function")L=new k.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")L=new k.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const w=M.URI.revive(I.uri);L=new k.SourceBreakpoint(new k.Location(w,new k.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}L._id=R,this._breakpoints.set(R,L),b.push(L)}}if(m.removed)for(const I of m.removed){const R=this._breakpoints.get(I);R&&(this._breakpoints.delete(I),P.push(R))}if(m.changed){for(const I of m.changed)if(I.id){const R=this._breakpoints.get(I.id);if(R){if(R instanceof k.FunctionBreakpoint&&I.type==="function"){const L=R;L.enabled=I.enabled,L.condition=I.condition,L.hitCondition=I.hitCondition,L.logMessage=I.logMessage,L.functionName=I.functionName}else if(R instanceof k.SourceBreakpoint&&I.type==="source"){const L=R;L.enabled=I.enabled,L.condition=I.condition,L.hitCondition=I.hitCondition,L.logMessage=I.logMessage,L.location=new k.Location(M.URI.revive(I.uri),new k.Position(I.line,I.character))}g.push(R)}}}this.fireBreakpointChanges(b,P,g)}$provideDebugConfigurations(m,b,P){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(m);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(b);return g.provideDebugConfigurations(I,P)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(m,b,P,g){return(0,A.asPromise)(async()=>{const I=this.getConfigProviderByHandle(m);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(b);return I.resolveDebugConfiguration(R,P,g)})}$resolveDebugConfigurationWithSubstitutedVariables(m,b,P,g){return(0,A.asPromise)(async()=>{const I=this.getConfigProviderByHandle(m);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(b);return I.resolveDebugConfigurationWithSubstitutedVariables(R,P,g)})}async $provideDebugAdapter(m,b){const P=this.getAdapterDescriptorFactoryByHandle(m);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(b);return this.getAdapterDescriptor(P,g).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(m){const b=await this.getSession(m);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(m){const b=await this.getSession(m);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,b){const P=await this.getSession(m);P&&P._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(m,b){const g={session:await this.getSession(m),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(m){if(m instanceof k.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof k.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const b=this._adapterFactories.filter(P=>P.type===m);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(m){const b=this._adapterFactories.filter(P=>P.handle===m);if(b.length>0)return b[0].factory}getConfigProviderByHandle(m){const b=this._configProviders.filter(P=>P.handle===m);if(b.length>0)return b[0].provider}definesDebugType(m,b){if(m.contributes){const P=m.contributes.debuggers;if(P&&P.length>0){for(const g of P)if(g.label&&g.type&&g.type===b)return!0}}return!1}getDebugAdapterTrackers(m){const P=m.configuration.type,g=this._trackerFactories.filter(I=>I.type===P||I.type==="*").map(I=>(0,A.asPromise)(()=>I.factory.createDebugAdapterTracker(m)).then(R=>R,R=>null));return Promise.race([Promise.all(g).then(I=>{const R=I.filter(L=>!!L);if(R.length>0)return new a(R)}),new Promise((I,R)=>{const L=setTimeout(()=>{clearTimeout(L),R(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(m,b){const P=b.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new k.DebugAdapterServer(P));if(m){const I=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>m.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,I))).then(R=>{if(R)return R})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,g))}daExecutableFromPackage(m,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,b,P){(m.length>0||b.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:b,changed:P}))}async getSession(m){if(m)if(typeof m=="string"){const b=this._debugSessions.get(m);if(b)return b}else{let b=this._debugSessions.get(m.id);if(!b){const P=await this.getFolder(m.folderUri),g=m.parent?this._debugSessions.get(m.parent):void 0;b=new C(this._debugServiceProxy,m.id,m.type,m.name,P,m.configuration,g),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(m){if(m){const b=M.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};h=$e([ze(0,u.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class C{constructor(m,b,P,g,I,R,L){this._debugServiceProxy=m,this._id=b,this._type=P,this._name=g,this._workspaceFolder=I,this._configuration=R,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,b)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=C;class i{constructor(m){this.value=Object.freeze({append(b){m.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=i;class p extends n.AbstractVariableResolverService{constructor(m,b,P,g,I){function R(){if(b){const L=b.activeEditor();if(L)return L.document.uri;const w=g.tabs.filter(x=>x.isActive);if(w.length>0){const x=w[0].resource;return x&&(x.primary||x.secondary)?x.primary??x.secondary:w[0].resource}}}super({getFolderUri:L=>{const w=m.filter(x=>x.name===L);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(L,w)=>P.getConfiguration(void 0,L).get(w),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=R();if(L)return d.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const L=R();if(L){const w=I.getWorkspaceFolder(L);if(w)return d.normalize(w.uri.fsPath)}}},getSelectedText:()=>{if(b){const L=b.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(b){const L=b.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=p;class a{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(b=>b.onError?b.onError(m):void 0)}onExit(m,b){this.trackers.forEach(P=>P.onExit?P.onExit(m,b):void 0)}}class r extends S.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends h{constructor(m,b,P,g,I,R){super(m,b,P,g,I,R)}createVariableResolver(m,b,P){return new p(m,b,P,this._editorTabs)}};c=$e([ze(0,u.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(be[219],Ee([0,1,75,2,5,32,30,26,12,29,4,33,91,15]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(o,h,C,i,p,a,r){this._apiFactory=o,this._extensionRegistry=h,this._instaService=C,this._extHostConfiguration=i,this._extHostExtensionService=p,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,h,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,h,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let h of o.nodeModuleName)this._factories.set(h,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(h=>o.alternativeModuleName(h))}};s=$e([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,_.IExtHostExtensionService),ze(5,T.IExtHostInitDataService),ze(6,f.ILogService)],s),e.RequireInterceptor=s;class u{constructor(o,h,C,i,p){this._apiFactory=o,this._extensionPaths=h,this._extensionRegistry=C,this._configProvider=i,this._logService=p,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,h){const C=this._extensionPaths.findSubstr(h);if(C){let i=this._extApiImpl.get(k.ExtensionIdentifier.toKey(C.identifier));return i||(i=this._apiFactory(C,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(C.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((p,a)=>i+=`	${a} -> ${p.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(o,h){this.nodeModuleName="keytar";const{environment:C}=h,i=o.getProxy(E.MainContext.MainThreadKeytar);if(C.appRoot){let p=C.appRoot.fsPath;n.platform==="win32"&&(p=p.replace(/\\/g,"/")),p[p.length-1]==="/"&&(p=p.substr(0,p.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${p}/node_modules.asar/keytar`),this.alternativeNames.add(`${p}/node_modules/keytar`)}this._impl={getPassword:(p,a)=>i.$getPassword(p,a),setPassword:(p,a,r)=>i.$setPassword(p,a,r),deletePassword:(p,a)=>i.$deletePassword(p,a),findPassword:p=>i.$findPassword(p),findCredentials(p){return i.$findCredentials(p)}}}load(o,h){return this._impl}alternativeModuleName(o){const h=o.length;if(h<=7||!this.alternativeNames)return;const C=h-7;if((o.charAt(C)==="/"||o.charAt(C)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};v=$e([ze(0,S.IExtHostRpcService),ze(1,T.IExtHostInitDataService)],v);let D=class{constructor(o,h,C){this._extensionPaths=o,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=C.getProxy(E.MainContext.MainThreadTelemetry);const i=C.getProxy(E.MainContext.MainThreadWindow);this._impl=(p,a)=>{const r=M.URI.parse(p);return a?this.callOriginal(p,a):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,p,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,p,{}):this.callOriginal(p,a)}}load(o,h,C){const i=this._extensionPaths.findSubstr(h);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=C(o),this._impl}callOriginal(o,h){return this.sendNoForwardTelemetry(),this._original(o,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=$e([ze(2,S.IExtHostRpcService)],D)}),define(be[220],Ee([0,1,14,16,75,6,2,5,213,15,57,61,29,143,12,66,33,40]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(h,C,i,p){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new S.RPCProtocol(h,null,p),C=y._transform(C,this._rpcProtocol);const a=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...C}),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),a.set(u.IURITransformerService,new u.URITransformerService(p)),a.set(v.IHostUtils,i);const r=new f.InstantiationService(a,!0),c=r.invokeFunction(P=>P.get(D.IExtHostTerminalService));this._disposables.add(c),this._logService=r.invokeFunction(P=>P.get(T.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",C),this._extensionService=r.invokeFunction(P=>P.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(g,I)=>{let R="",L,w;for(const x of I)R+=`
	at ${x.toString()}`,w=x.getFileName(),!L&&w&&(L=P.findSubstr(F.URI.file(w)));return l.set(g,L),`${g.name||"Error"}: ${g.message||""}${R}`}});const m=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(P=>{const g=M.transformErrorForSerialization(P),I=l.get(P);I?m.$onExtensionRuntimeError(I.identifier,g):b.$onUnexpectedError(g)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const C=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),C]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,C){h.extensions.forEach(p=>p.extensionLocation=F.URI.revive(C.transformIncomingURIs(p.extensionLocation))),h.environment.appRoot=F.URI.revive(C.transformIncomingURIs(h.environment.appRoot));const i=h.environment.extensionDevelopmentLocationURI;return i&&(h.environment.extensionDevelopmentLocationURI=i.map(p=>F.URI.revive(C.transformIncomingURIs(p)))),h.environment.extensionTestsLocationURI=F.URI.revive(C.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=F.URI.revive(C.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=F.URI.revive(C.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=F.URI.revive(C.transformIncomingURIs(h.logsLocation)),h.logFile=F.URI.revive(C.transformIncomingURIs(h.logFile)),h.workspace=C.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=y}),define(be[221],Ee([0,1,17,21,45,27,24,194,41]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,f,s){this.config=n,this.provider=f,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((s,u)=>{const v=D=>{this.resultCount++,n(D)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const y=D.toString(),o=d.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,o)||this.matchFile(v,{base:D,basename:o})}),Promise.all(f.map(D=>this.searchInFolder(D,v))).then(D=>{s({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{u(new Error((0,E.toErrorMessage)(D)))})})}async searchInFolder(n,f){const s=new M.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),D=new S.QueryGlobTester(this.config,n),y=!D.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(s),o=k.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),C=o.elapsed(),i=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(p=>{const a=d.posix.relative(n.folder.path,p.path);if(y){const r=d.basename(p.path);this.matchFile(f,{base:n.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(v,n.folder,a,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,D,f),{providerTime:C,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,s,u){if(s===this.filePattern){const D=d.basename(this.filePattern);this.matchFile(u,{base:f,relativePath:this.filePattern,basename:D})}function v(D){const y=d.basename(D),o=d.dirname(D);let h=n[o];h||(h=n[o]=[],v(o)),h.push({base:f,relativePath:D,basename:y})}v(s)}matchDirectoryTree({rootEntries:n,pathToEntries:f},s,u){const v=this,D=this.filePattern;function y(o){const h=A.hasSiblingFn(()=>o.map(C=>C.basename));for(let C=0,i=o.length;C<i;C++){const p=o[C],{relativePath:a,basename:r}=p;if(s.matchesExcludesSync(a,r,D!==r?h:void 0))continue;const c=f[a];if(c)y(c);else{if(a===D)continue;v.matchFile(u,p)}if(v.isLimitHit)break}}y(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class t{constructor(){this.sessions=new Map}fileSearch(n,f,s,u){const v=this.getSessionTokenSource(n.cacheKey),D=new T(n,f,v&&v.token);let y=0;const o=h=>{y+=h.length,s(h.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(D,t.BATCH_SIZE,o,u).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:h.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,s,u){u.onCancellationRequested(()=>{n.cancel()});const v=y=>{y&&(D.push(y),f>0&&D.length>=f&&(s(D),D=[]))};let D=[];return n.search(v).then(y=>(D.length&&s(D),y),y=>(D.length&&s(D),Promise.reject(y)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,13,21,45,27,11,17,24,10,2,41]),function(se,e,d,M,E,A,F,k,S,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,h,C,i){this.query=o,this.provider=h,this.fileUtils=C,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,h){const C=this.query.folderQueries||[],i=new M.CancellationTokenSource;return h.onCancellationRequested(()=>i.cancel()),new Promise((p,a)=>{this.collector=new s(o);let r=!1;const c=(l,m)=>{if(!r&&!this.isLimitHit){const b=this.resultSize(l);v(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,r=!0,i.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const P=this.resultSize(l);this.resultCount+=P,(P>0||!v(l))&&this.collector.add(l,m)}};Promise.all(C.map((l,m)=>this.searchInFolder(l,b=>c(b,m),i.token))).then(l=>{i.dispose(),this.collector.flush();const m=l.some(b=>!!b&&!!b.limitHit);p({limitHit:this.isLimitHit||m,messages:(0,d.flatten)(l.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{i.dispose();const m=(0,E.toErrorMessage)(l);a(new Error(m))})})}resultSize(o){return v(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,h){const C=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:C.slice(0,h),preview:{matches:i.slice(0,h),text:o.preview.text},uri:o.uri}}async searchInFolder(o,h,C){const i=new _.QueryGlobTester(this.query,o),p=[],a={report:l=>{if(!this.validateProviderResult(l))return;const m=o.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(l.uri))):void 0,b=S.relativePath(o.folder,l.uri);if(b){const P=i.includedInQuery(b,k.basename(b),m);(0,T.isPromise)(P)?p.push(P.then(g=>{g&&h(l)})):P&&h(l)}}},r=this.getSearchOptionsForFolder(o),c=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,a,C);return p.length&&await Promise.all(p),c}validateProviderResult(o){if(v(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const h=(0,_.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),C=(0,_.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:C,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function f(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class s{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,h=>this.sendItems(h))}add(o,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!S.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(u(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=s;function u(y){return v(y)?{preview:{matches:(0,d.mapArrayOrNot)(y.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:y.preview.text},ranges:(0,d.mapArrayOrNot)(y.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function v(y){return!!y.preview}e.extensionResultIsMatch=v;class D{constructor(o,h){this.maxBatchSize=o,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,h){!o||this.addItemToBatch(o,h)}addItems(o,h){!o||this.addItemsToBatch(o,h)}addItemToBatch(o,h){this.batch.push(o),this.batchSize+=h,this.onUpdate()}addItemsToBatch(o,h){this.batch=this.batch.concat(o),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,12,66,15,2,222]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(u,v,D){this.extHostRpc=u,this._uriTransformer=v,this._logService=D,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,v){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const D=this._handlePool++;return this._textSearchProvider.set(D,v),this._proxy.$registerTextSearchProvider(D,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(u,v){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const D=this._handlePool++;return this._fileSearchProvider.set(D,v),this._proxy.$registerFileSearchProvider(D,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(u,v,D,y){const o=n(D),h=this._fileSearchProvider.get(u);if(h)return this._fileSearchManager.fileSearch(o,h,C=>{this._proxy.$handleFileMatch(u,v,C.map(i=>i.resource))},y);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,v,D,y){const o=this._textSearchProvider.get(u);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const h=n(D);return this.createTextSearchManager(h,o).search(i=>this._proxy.$handleTextMatch(u,v,i),y)}$enableExtensionHostSearch(){}createTextSearchManager(u,v){return new t.TextSearchManager(u,v,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=$e([ze(0,F.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,S.ILogService)],_),e.ExtHostSearch=_;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(f),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>T.URI.revive(u))}}e.reviveQuery=n;function f(s){return{...s,folder:T.URI.revive(s.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,80,113,56,60,5,184,183,39,185,32,186,187,188,170,189,50,33,190,171,193,195,196,96,173,201,202,203,73,40,205,174,8,7,208,51,97,31,30,52,160,192,63,95,99,100,101,15,66,12,29,197,157,65,70,181,206,156,74,72,211,209,210,182,37,204,207,69,71,87,199,98,200,11,145,198,154,191]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o,h,C,i,p,a,r,c,l,m,b,P,g,I,R,L,w,x,$,B,K,H,W,ne,V,X,q,le,te,ve,Re,Fe,Oe,Ke,je,Ve,U,Q,ie,ae,G,oe,he,Te,Be,He,Qe,it,Ce,Ze,j,J,me,We,Ye,st,ot,Et,mt,Dt,Pt,It,Xe,St,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(ee){const ue=ee.get(ie.IExtHostInitDataService),ge=ee.get(me.IExtHostFileSystemInfo),fe=ee.get(it.IExtHostConsumerFileSystem),Ie=ee.get(a.IExtHostExtensionService),xe=ee.get(X.IExtHostWorkspace),Ne=ee.get(Et.IExtHostTelemetry),Ge=ee.get(D.IExtHostConfiguration),tt=ee.get(U.IURITransformerService),Le=ee.get(Q.IExtHostRpcService),de=ee.get(w.IExtHostStorage),pe=ee.get(Qe.IExtensionStoragePaths),Y=ee.get(Ve.ILogService),z=ee.get(oe.IExtHostTunnelService),we=ee.get(he.IExtHostApiDeprecationService),ke=ee.get(V.IExtHostWindow),Je=ee.get(st.IExtHostSecretState),Ue=ee.get(ot.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),Le.set(n.ExtHostContext.ExtHostLogService,Y),Le.set(n.ExtHostContext.ExtHostWorkspace,xe),Le.set(n.ExtHostContext.ExtHostConfiguration,Ge),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Ne),Le.set(n.ExtHostContext.ExtHostEditorTabs,Ue);const dt=Le.set(n.ExtHostContext.ExtHostDecorations,ee.get(Fe.IExtHostDecorations)),gt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ee.get(p.IExtHostDocumentsAndEditors)),lt=Le.set(n.ExtHostContext.ExtHostCommands,ee.get(u.IExtHostCommands)),ft=Le.set(n.ExtHostContext.ExtHostTerminalService,ee.get(x.IExtHostTerminalService)),ut=Le.set(n.ExtHostContext.ExtHostDebugService,ee.get(Ke.IExtHostDebugService)),pt=Le.set(n.ExtHostContext.ExtHostSearch,ee.get(je.IExtHostSearch)),bt=Le.set(n.ExtHostContext.ExtHostTask,ee.get(Oe.IExtHostTask)),Ut=Le.set(n.ExtHostContext.ExtHostOutputService,ee.get(P.IExtHostOutputService)),Vt=Le.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(Le)),yt=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,gt)),$t=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Le,gt,Y)),ei=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new C.ExtHostDocumentSaveParticipant(Y,yt,Le.getProxy(n.MainContext.MainThreadBulkEdits))),vt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,lt,gt,yt,pe)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(Y,vt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new St.ExtHostNotebookEditors(Y,Le,vt)),ti=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new mt.ExtHostNotebookKernels(Le,ue,vt,lt,Y)),ii=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Pt.ExtHostNotebookRenderers(Le,vt)),Tt=Le.set(n.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(Le,gt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),lt,Y)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,ue)),Wt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Le,Y,ge)),Ht=Le.set(n.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(Le,yt,lt.converter,tt)),ht=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Le,tt,yt,lt,Wt,Y,we)),ni=Le.set(n.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Le,ht)),Ot=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Le,Y,gt)),Nt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(Le,xe,lt)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(Le,lt,Y)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(Le,lt,yt)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(Le)),ri=Le.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(Le,lt)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new ne.ExtHostWebviews(Le,{remote:ue.remote},xe,Y,we)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new j.ExtHostWebviewPanels(Le,qt,xe)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new Ze.ExtHostCustomEditors(Le,yt,pe,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new Ce.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Le,lt)),Xt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new Ye.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Le,vt,gt,lt));const Si=(0,le.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new J.ExtHostBulkEdits(Le,gt),ai=new s.ExtHostClipboard(Le),li=new b.ExtHostMessageService(Le,Y),zt=new o.ExtHostDialogs(Le),Mt=new L.ExtHostStatusBar(Le,lt.converter);return f.ExtHostApiCommands.register(lt),function(Me,Rt,Kt){const wt=function(){let Z=!Me.isUnderDevelopment;function ce(Se){Z||(Y.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Se(rt){if(Array.isArray(rt))rt.forEach(Se);else if(typeof rt=="string")ce(rt);else{const _t=rt;typeof _t.scheme=="undefined"&&ce(rt),!Me.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,q.throwProposedApiError)(Me)}return rt}}(),Ci={getSession(Z,ce,Se){return Se?.forceNewSession&&(0,q.checkProposedApiEnabled)(Me),ri.getSession(Me,Z,ce,Se)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,ce,Se,rt){return ri.registerAuthenticationProvider(Z,ce,Se,rt)}},ki={registerCommand(Z,ce,Se){return lt.registerCommand(!0,Z,ce,Se,void 0,Me)},registerTextEditorCommand(Z,ce,Se){return lt.registerCommand(!0,Z,(...rt)=>{const _t=Tt.getActiveTextEditor();if(!_t){Y.warn("Cannot execute "+Z+" because there is no active text editor.");return}return _t.edit(kt=>{ce.apply(Se,[_t,kt,...rt])}).then(kt=>{kt||Y.warn("Edits from command "+Z+" were not applied.")},kt=>{Y.warn("An error occurred while running command "+Z,kt)})},void 0,void 0,Me)},registerDiffInformationCommand:(Z,ce,Se)=>((0,q.checkProposedApiEnabled)(Me),lt.registerCommand(!0,Z,async(...rt)=>{const _t=gt.activeEditor(!0);if(!_t){Y.warn("Cannot execute "+Z+" because there is no active text editor.");return}const kt=await Tt.getDiffInformation(_t.id);ce.apply(Se,[kt,...rt])},void 0,void 0,Me)),executeCommand(Z,...ce){return lt.executeCommand(Z,...ce)},getCommands(Z=!1){return lt.getCommands(Z)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return Ne.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ne.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ce){return ke.openUri(Z,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ue.environment.appUriScheme)return Vt.createAppUri(Z);try{return await ke.asExternalUri(Z,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(Z,It.Schemas.http)||(0,Xe.matchesScheme)(Z,It.Schemas.https))return Z;throw ce}},get remoteName(){return(0,Re.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,q.checkProposedApiEnabled)(Me),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(Z,ce){return Gt.createTestController(Z,ce)},createTestObserver(){return(0,q.checkProposedApiEnabled)(Me),Gt.createTestObserver()},runTests(Z){return(0,q.checkProposedApiEnabled)(Me),Gt.runTests(Z)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Me),Gt.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Me),Gt.results}},Pi={getExtension(Z){const ce=Rt.getExtensionDescription(Z);if(ce)return new a.Extension(Ie,Me.identifier,ce,gi)},get all(){return Rt.getAllExtensionDescriptions().map(Z=>new a.Extension(Ie,Me.identifier,Z,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(Z){return Wt.createDiagnosticCollection(Me.identifier,Z)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:Z=>Wt.getDiagnostics(Z),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Z,ce){return Ht.changeLanguage(Z.uri,ce)},match(Z,ce){return(0,t.score)(K.LanguageSelector.from(Z),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Z,ce,Se){return ht.registerCodeActionProvider(Me,wt(Z),ce,Se)},registerCodeLensProvider(Z,ce){return ht.registerCodeLensProvider(Me,wt(Z),ce)},registerDefinitionProvider(Z,ce){return ht.registerDefinitionProvider(Me,wt(Z),ce)},registerDeclarationProvider(Z,ce){return ht.registerDeclarationProvider(Me,wt(Z),ce)},registerImplementationProvider(Z,ce){return ht.registerImplementationProvider(Me,wt(Z),ce)},registerTypeDefinitionProvider(Z,ce){return ht.registerTypeDefinitionProvider(Me,wt(Z),ce)},registerHoverProvider(Z,ce){return ht.registerHoverProvider(Me,wt(Z),ce,Me.identifier)},registerEvaluatableExpressionProvider(Z,ce){return ht.registerEvaluatableExpressionProvider(Me,wt(Z),ce,Me.identifier)},registerInlineValuesProvider(Z,ce){return ht.registerInlineValuesProvider(Me,wt(Z),ce,Me.identifier)},registerDocumentHighlightProvider(Z,ce){return ht.registerDocumentHighlightProvider(Me,wt(Z),ce)},registerLinkedEditingRangeProvider(Z,ce){return ht.registerLinkedEditingRangeProvider(Me,wt(Z),ce)},registerReferenceProvider(Z,ce){return ht.registerReferenceProvider(Me,wt(Z),ce)},registerRenameProvider(Z,ce){return ht.registerRenameProvider(Me,wt(Z),ce)},registerDocumentSymbolProvider(Z,ce,Se){return ht.registerDocumentSymbolProvider(Me,wt(Z),ce,Se)},registerWorkspaceSymbolProvider(Z){return ht.registerWorkspaceSymbolProvider(Me,Z)},registerDocumentFormattingEditProvider(Z,ce){return ht.registerDocumentFormattingEditProvider(Me,wt(Z),ce)},registerDocumentRangeFormattingEditProvider(Z,ce){return ht.registerDocumentRangeFormattingEditProvider(Me,wt(Z),ce)},registerOnTypeFormattingEditProvider(Z,ce,Se,...rt){return ht.registerOnTypeFormattingEditProvider(Me,wt(Z),ce,[Se].concat(rt))},registerDocumentSemanticTokensProvider(Z,ce,Se){return ht.registerDocumentSemanticTokensProvider(Me,wt(Z),ce,Se)},registerDocumentRangeSemanticTokensProvider(Z,ce,Se){return ht.registerDocumentRangeSemanticTokensProvider(Me,wt(Z),ce,Se)},registerSignatureHelpProvider(Z,ce,Se,...rt){return typeof Se=="object"?ht.registerSignatureHelpProvider(Me,wt(Z),ce,Se):ht.registerSignatureHelpProvider(Me,wt(Z),ce,typeof Se=="undefined"?[]:[Se,...rt])},registerCompletionItemProvider(Z,ce,...Se){return ht.registerCompletionItemProvider(Me,wt(Z),ce,Se)},registerInlineCompletionItemProvider(Z,ce){return(0,q.checkProposedApiEnabled)(Me),ht.registerInlineCompletionsProvider(Me,wt(Z),ce)},registerDocumentLinkProvider(Z,ce){return ht.registerDocumentLinkProvider(Me,wt(Z),ce)},registerColorProvider(Z,ce){return ht.registerColorProvider(Me,wt(Z),ce)},registerFoldingRangeProvider(Z,ce){return ht.registerFoldingRangeProvider(Me,wt(Z),ce)},registerSelectionRangeProvider(Z,ce){return ht.registerSelectionRangeProvider(Me,Z,ce)},registerCallHierarchyProvider(Z,ce){return ht.registerCallHierarchyProvider(Me,Z,ce)},registerTypeHierarchyProvider(Z,ce){return ht.registerTypeHierarchyProvider(Me,Z,ce)},setLanguageConfiguration:(Z,ce)=>ht.setLanguageConfiguration(Me,Z,ce),getTokenInformationAtPosition(Z,ce){return(0,q.checkProposedApiEnabled)(Me),Ht.tokenAtPosition(Z,ce)},registerInlayHintsProvider(Z,ce){return(0,q.checkProposedApiEnabled)(Me),ht.registerInlayHintsProvider(Me,Z,ce)},createLanguageStatusItem(Z,ce){return(0,q.checkProposedApiEnabled)(Me),Ht.createLanguageStatusItem(Me,Z,ce)}},Ti={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(Z,ce,Se){const rt=await(F.URI.isUri(Z)?Promise.resolve(pi.openTextDocument(Z)):Promise.resolve(Z));return Tt.showTextDocument(rt,ce,Se)},createTextEditorDecorationType(Z){return Tt.createTextEditorDecorationType(Me,Z)},onDidChangeActiveTextEditor(Z,ce,Se){return Tt.onDidChangeActiveTextEditor(Z,ce,Se)},onDidChangeVisibleTextEditors(Z,ce,Se){return Tt.onDidChangeVisibleTextEditors(Z,ce,Se)},onDidChangeTextEditorSelection(Z,ce,Se){return Tt.onDidChangeTextEditorSelection(Z,ce,Se)},onDidChangeTextEditorOptions(Z,ce,Se){return Tt.onDidChangeTextEditorOptions(Z,ce,Se)},onDidChangeTextEditorVisibleRanges(Z,ce,Se){return Tt.onDidChangeTextEditorVisibleRanges(Z,ce,Se)},onDidChangeTextEditorViewColumn(Z,ce,Se){return Tt.onDidChangeTextEditorViewColumn(Z,ce,Se)},onDidCloseTerminal(Z,ce,Se){return ft.onDidCloseTerminal(Z,ce,Se)},onDidOpenTerminal(Z,ce,Se){return ft.onDidOpenTerminal(Z,ce,Se)},onDidChangeActiveTerminal(Z,ce,Se){return ft.onDidChangeActiveTerminal(Z,ce,Se)},onDidChangeTerminalDimensions(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(Z,ce,Se)},onDidChangeTerminalState(Z,ce,Se){return ft.onDidChangeTerminalState(Z,ce,Se)},onDidWriteTerminalData(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(Z,ce,Se)},get state(){return ke.state},onDidChangeWindowState(Z,ce,Se){return ke.onDidChangeWindowState(Z,ce,Se)},showInformationMessage(Z,...ce){return li.showMessage(Me,A.default.Info,Z,ce[0],ce.slice(1))},showWarningMessage(Z,...ce){return li.showMessage(Me,A.default.Warning,Z,ce[0],ce.slice(1))},showErrorMessage(Z,...ce){return li.showMessage(Me,A.default.Error,Z,ce[0],ce.slice(1))},showQuickPick(Z,ce,Se){return Nt.showQuickPick(Z,!!Me.enableProposedApi,ce,Se)},showWorkspaceFolderPick(Z){return Nt.showWorkspaceFolderPick(Z)},showInputBox(Z,ce){return Nt.showInput(Z,ce)},showOpenDialog(Z){return zt.showOpenDialog(Z)},showSaveDialog(Z){return zt.showSaveDialog(Z)},createStatusBarItem(Z,ce,Se){let rt,_t,kt;return typeof Z=="string"?(rt=Z,_t=ce,kt=Se):(_t=Z,kt=ce),Mt.createStatusBarEntry(Me,rt,_t,kt)},setStatusBarMessage(Z,ce){return Mt.setStatusBarMessage(Z,ce)},withScmProgress(Z){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),hi.withProgress(Me,{location:H.ProgressLocation.SourceControl},(ce,Se)=>Z({report(rt){}}))},withProgress(Z,ce){return hi.withProgress(Me,Z,ce)},createOutputChannel(Z){return Ut.createOutputChannel(Z,Me)},createWebviewPanel(Z,ce,Se,rt){return oi.createWebviewPanel(Me,Z,ce,Se,rt)},createWebviewTextEditorInset(Z,ce,Se,rt){return(0,q.checkProposedApiEnabled)(Me),wi.createWebviewEditorInset(Z,ce,Se,rt,Me)},createTerminal(Z,ce,Se){return typeof Z=="object"?("location"in Z&&(0,q.checkProposedApiEnabled)(Me),"pty"in Z?ft.createExtensionTerminal(Z):ft.createTerminalFromOptions(Z)):ft.createTerminal(Z,ce,Se)},registerTerminalLinkProvider(Z){return ft.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,ce){return ft.registerProfileProvider(Me,Z,ce)},registerTreeDataProvider(Z,ce){return Yt.registerTreeDataProvider(Z,ce,Me)},createTreeView(Z,ce){return Yt.createTreeView(Z,ce,Me)},registerWebviewPanelSerializer:(Z,ce)=>oi.registerWebviewPanelSerializer(Me,Z,ce),registerCustomEditorProvider:(Z,ce,Se={})=>_i.registerCustomEditorProvider(Me,Z,ce,Se),registerFileDecorationProvider(Z){return dt.registerFileDecorationProvider(Z,Me.identifier)},registerUriHandler(Z){return Vt.registerUriHandler(Me.identifier,Z)},createQuickPick(){return Nt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Nt.createInputBox(Me.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(Z,ce,Se){return fi.onDidChangeActiveColorTheme(Z,ce,Se)},registerWebviewViewProvider(Z,ce,Se){return yi.registerWebviewViewProvider(Me,Z,ce,Se?.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Me),vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),vt.onDidChangeActiveNotebookEditor(Z,ce,Se)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Me),vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Me),vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorSelection(Z,ce,Se)},onDidChangeNotebookEditorVisibleRanges(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorVisibleRanges(Z,ce,Se)},showNotebookDocument(Z,ce){return(0,q.checkProposedApiEnabled)(Me),vt.showNotebookDocument(Z,ce)},registerExternalUriOpener(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),Xt.registerExternalUriOpener(Me.identifier,Z,ce,Se)},get tabs(){return(0,q.checkProposedApiEnabled)(Me),Ue.tabs},get activeTab(){return(0,q.checkProposedApiEnabled)(Me),Ue.activeTab},get onDidChangeTabs(){return(0,q.checkProposedApiEnabled)(Me),Ue.onDidChangeTabs},get onDidChangeActiveTab(){return(0,q.checkProposedApiEnabled)(Me),Ue.onDidChangeActiveTab},getInlineCompletionItemController(Z){return(0,q.checkProposedApiEnabled)(Me),l.InlineCompletionController.get(Z)}},pi={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(Z){throw M.readonly()},getWorkspaceFolder(Z){return xe.getWorkspaceFolder(Z)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(Z){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(Z){throw M.readonly()},updateWorkspaceFolders:(Z,ce,...Se)=>xe.updateWorkspaceFolders(Me,Z,ce||0,...Se),onDidChangeWorkspaceFolders:function(Z,ce,Se){return xe.onDidChangeWorkspace(Z,ce,Se)},asRelativePath:(Z,ce)=>xe.getRelativePath(Z,ce),findFiles:(Z,ce,Se,rt)=>xe.findFiles(K.GlobPattern.from(Z),K.GlobPattern.from(ce),Se,Me.identifier,rt),findTextInFiles:(Z,ce,Se,rt)=>{let _t,kt;return typeof ce=="object"?(_t=ce,kt=Se):(_t={},kt=ce,rt=Se),xe.findTextInFiles(Z,_t||{},kt,Me.identifier,rt)},saveAll:Z=>xe.saveAll(Z),applyEdit(Z){return Di.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ce,Se,rt)=>Ot.createFileSystemWatcher(K.GlobPattern.from(Z),ce,Se,rt),get textDocuments(){return yt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw M.readonly()},openTextDocument(Z){let ce;const Se=Z;if(typeof Z=="string")ce=Promise.resolve(F.URI.file(Z));else if(F.URI.isUri(Z))ce=Promise.resolve(Z);else if(!Se||typeof Se=="object")ce=yt.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(rt=>yt.ensureDocumentData(rt).then(_t=>_t.document))},onDidOpenTextDocument:(Z,ce,Se)=>yt.onDidAddDocument(Z,ce,Se),onDidCloseTextDocument:(Z,ce,Se)=>yt.onDidRemoveDocument(Z,ce,Se),onDidChangeTextDocument:(Z,ce,Se)=>yt.onDidChangeDocument(Z,ce,Se),onDidSaveTextDocument:(Z,ce,Se)=>yt.onDidSaveDocument(Z,ce,Se),onWillSaveTextDocument:(Z,ce,Se)=>ei.getOnWillSaveTextDocumentEvent(Me)(Z,ce,Se),get notebookDocuments(){return vt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,ce){let Se;if(F.URI.isUri(Z))Se=Z,await vt.openNotebookDocument(Z);else if(typeof Z=="string")Se=F.URI.revive(await vt.createNotebookDocument({viewType:Z,content:ce}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,ce,Se,rt){return vt.registerNotebookSerializer(Me,Z,ce,Se,Me.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(Z,ce,Se,rt)=>((0,q.checkProposedApiEnabled)(Me),vt.registerNotebookContentProvider(Me,Z,ce,Se,Me.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(Z,ce,Se)=>Kt.onDidChangeConfiguration(Z,ce,Se),getConfiguration(Z,ce){return ce=arguments.length===1?void 0:ce,Kt.getConfiguration(Z,ce,Me)},registerTextDocumentContentProvider(Z,ce){return $t.registerTextDocumentContentProvider(Z,ce)},registerTaskProvider:(Z,ce)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Me,Z,ce)),registerFileSystemProvider(Z,ce,Se){return ni.registerFileSystemProvider(Me.identifier,Z,ce,Se)},get fs(){return fe.value},registerFileSearchProvider:(Z,ce)=>((0,q.checkProposedApiEnabled)(Me),pt.registerFileSearchProvider(Z,ce)),registerTextSearchProvider:(Z,ce)=>((0,q.checkProposedApiEnabled)(Me),pt.registerTextSearchProvider(Z,ce)),registerRemoteAuthorityResolver:(Z,ce)=>((0,q.checkProposedApiEnabled)(Me),Ie.registerRemoteAuthorityResolver(Z,ce)),registerResourceLabelFormatter:Z=>((0,q.checkProposedApiEnabled)(Me),Ei.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ce,Se)=>Ot.onDidCreateFile(Z,ce,Se),onDidDeleteFiles:(Z,ce,Se)=>Ot.onDidDeleteFile(Z,ce,Se),onDidRenameFiles:(Z,ce,Se)=>Ot.onDidRenameFile(Z,ce,Se),onWillCreateFiles:(Z,ce,Se)=>Ot.getOnWillCreateFileEvent(Me)(Z,ce,Se),onWillDeleteFiles:(Z,ce,Se)=>Ot.getOnWillDeleteFileEvent(Me)(Z,ce,Se),onWillRenameFiles:(Z,ce,Se)=>Ot.getOnWillRenameFileEvent(Me)(Z,ce,Se),openTunnel:Z=>((0,q.checkProposedApiEnabled)(Me),z.openTunnel(Me,Z).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,q.checkProposedApiEnabled)(Me),z.getTunnels()},onDidChangeTunnels:(Z,ce,Se)=>((0,q.checkProposedApiEnabled)(Me),z.onDidChangeTunnels(Z,ce,Se)),registerPortAttributesProvider:(Z,ce)=>((0,q.checkProposedApiEnabled)(Me),z.registerPortsAttributesProvider(Z,ce)),registerTimelineProvider:(Z,ce)=>((0,q.checkProposedApiEnabled)(Me),si.registerTimelineProvider(Z,ce,Me.identifier,lt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:Z=>((0,q.checkProposedApiEnabled)(Me),xe.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ce,Se)=>xe.onDidGrantWorkspaceTrust(Z,ce,Se)},Ai={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(Z,ce,Se){return Jt.createSourceControl(Me,Z,ce,Se)}},Ri={createCommentController(Z,ce){return bi.createCommentController(Me,Z,ce)}},Fi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(Z,ce,Se){return ut.onDidStartDebugSession(Z,ce,Se)},onDidTerminateDebugSession(Z,ce,Se){return ut.onDidTerminateDebugSession(Z,ce,Se)},onDidChangeActiveDebugSession(Z,ce,Se){return ut.onDidChangeActiveDebugSession(Z,ce,Se)},onDidReceiveDebugSessionCustomEvent(Z,ce,Se){return ut.onDidReceiveDebugSessionCustomEvent(Z,ce,Se)},onDidChangeBreakpoints(Z,ce,Se){return ut.onDidChangeBreakpoints(Z,ce,Se)},registerDebugConfigurationProvider(Z,ce,Se){return ut.registerDebugConfigurationProvider(Z,ce,Se||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ce){return ut.registerDebugAdapterDescriptorFactory(Me,Z,ce)},registerDebugAdapterTrackerFactory(Z,ce){return ut.registerDebugAdapterTrackerFactory(Z,ce)},startDebugging(Z,ce,Se){return!Se||typeof Se=="object"&&"configuration"in Se?ut.startDebugging(Z,ce,{parentSession:Se}):ut.startDebugging(Z,ce,Se||{})},stopDebugging(Z){return ut.stopDebugging(Z)},addBreakpoints(Z){return ut.addBreakpoints(Z)},removeBreakpoints(Z){return ut.removeBreakpoints(Z)},asDebugSourceUri(Z,ce){return ut.asDebugSourceUri(Z,ce)}},Mi={registerTaskProvider:(Z,ce)=>bt.registerTaskProvider(Me,Z,ce),fetchTasks:Z=>bt.fetchTasks(Z),executeTask:Z=>bt.executeTask(Me,Z),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(Z,ce,Se)=>bt.onDidStartTask(Z,ce,Se),onDidEndTask:(Z,ce,Se)=>bt.onDidEndTask(Z,ce,Se),onDidStartTaskProcess:(Z,ce,Se)=>bt.onDidStartTaskProcess(Z,ce,Se),onDidEndTaskProcess:(Z,ce,Se)=>bt.onDidEndTaskProcess(Z,ce,Se)},Li={createNotebookController(Z,ce,Se,rt,_t){return ti.createNotebookController(Me,Z,ce,Se,rt,Me.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(Z,ce)=>vt.registerNotebookCellStatusBarItemProvider(Me,Z,ce),get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Me),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,q.checkProposedApiEnabled)(Me),jt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return ii.createRendererMessaging(Me,Z)},onDidChangeNotebookDocumentMetadata(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),Qt.onDidChangeNotebookDocumentMetadata(Z,ce,Se)},onDidChangeNotebookCells(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCells(Z,ce,Se)},onDidChangeNotebookCellExecutionState(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCellExecutionState(Z,ce,Se)},onDidChangeCellOutputs(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),vt.onDidChangeCellOutputs(Z,ce,Se)},onDidChangeCellMetadata(Z,ce,Se){return(0,q.checkProposedApiEnabled)(Me),vt.onDidChangeCellMetadata(Z,ce,Se)},createConcatTextDocument(Z,ce){return(0,q.checkProposedApiEnabled)(Me),new He.ExtHostNotebookConcatDocument(vt,yt,Z,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:T.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(be[224],Ee([0,1,57,96,31,95,32,39,50,40,99,100,101,73,65,70,97,72,37,69,87,71]),function(se,e,d,M,E,A,F,k,S,T,t,_,n,f,s,u,v,D,y,o,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,d.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,d.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,d.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,d.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,d.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,14,5,11]),function(se,e,d,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(s){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,...y)=>{y.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=y.slice(0,-1).join(","),h=y.pop().toString();return`(function anonymous(${o}) {${h}
})`}});function v(...D){return u?self.eval(u.createScript("",...D)):new Function(...D)}s.create=v})(T||(T={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(u,v){for(let D of this._alternatives){let y=D(u);if(y){u=y;break}}if(this._factories.has(u))return this._factories.get(u).load(u,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);f(u,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,v,D){v=v.with({path:n(v.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const y=await fetch(S.FileAccess.asBrowserUri(v).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),y.status!==200)throw new Error(y.statusText);const o=await y.text(),h=`${v.toString(!0)}#vscode-extension`,C=`${o}
//# sourceURL=${h}`;let i;try{i=T.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(C)??C)}catch(c){throw console.error(u?`Loading code for extension ${u.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${v.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const p={},a={exports:p},r=c=>{const l=this._fakeModules.getModule(c,v);if(l===void 0)throw new Error(`Cannot load module '${c}'`);return l};try{return D.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),i(a,p,r),a.exports!==p?a.exports:p}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+u;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,u){return s.endsWith(u)?s:s+u}function f(s,u){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(o,h){const C=console[o];console[o]=function(){s.$logExtensionHostMessage({type:"__$console",severity:h,arguments:y(arguments)}),u&&C.apply(console,arguments)}}const D=1e5;function y(o){const h=[],C=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const p=o[i];p.stack?o[i]=p.stack:o[i]=p.toString()}C.push(o[i])}try{const i=JSON.stringify(C,function(p,a){if(a&&typeof a=="object"){if(h.indexOf(a)!==-1)return"[Circular]";h.push(a)}return a});return i.length>D?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,74,225,212]),function(se,e,d,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,k.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,22,3,178,220,214,17,75,11,2,224,226]),function(se,e,d,M,E,A,F,k,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(o,h){return o instanceof Request||/^file:/i.test(String(o))&&(o=T.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),f(o,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,h,C,i,p){return/^file:/i.test(h.toString())&&(h=T.FileAccess.asBrowserUri(t.URI.parse(h.toString())).toString(!0)),super.open(o,h,C??!0,i,p)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:C=>C}),h=self.Worker;Worker=function(C,i){/^file:/i.test(C.toString())&&(C=T.FileAccess.asBrowserUri(t.URI.parse(C.toString())).toString(!0));const a=`(${function(m){function b(R){return typeof R=="string"||R instanceof URL?String(R).replace(/^file:\/\//i,"vscode-file://vscode-app"):R}const P=fetch.bind(self);self.fetch=function(R,L){return R instanceof Request?P(R,L):P(b(R),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(R,L,w,x,$){return super.open(R,b(L),w??!0,x,$)}};const g=importScripts.bind(self);self.importScripts=(...R)=>{g(...R.map(b))};const I=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:R=>R}):void 0;g(I?I.createScriptURL(m):m)}.toString()}('${C}'))`;i=i||{},i.name=i.name||k.basename(C.toString());const r=new Blob([a],{type:"application/javascript"}),c=URL.createObjectURL(r);return new h(o?o.createScriptURL(c):c,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,h){super(n,o,{name:k.basename(o.toString()),...h})}};const s=new class{exit(o){_()}async exists(o){return!0}async realpath(o){return o}};class u{constructor(){const h=new MessageChannel,C=new M.Emitter;let i=!1;n(h.port2,[h.port2]),h.port1.onmessage=p=>{const{data:a}=p;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const r=d.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,E.isMessageOfType)(r,2)){i=!0,D("received terminate message from renderer");return}C.fire(r)},this.protocol={onMessage:C.event,send:p=>{if(!i){const a=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);h.port1.postMessage(a,[a])}}}}}function v(o){return new Promise(h=>{const C=o.onMessage(i=>{C.dispose();const p=JSON.parse(i.toString());o.send((0,E.createMessageOfType)(0)),h({protocol:o,initData:p})});o.send((0,E.createMessageOfType)(1))})}let D=o=>_();function y(){const o=new u;S.mark("code/extHost/willConnectToRenderer"),v(o.protocol).then(h=>{S.mark("code/extHost/didWaitForInitData");const C=new A.ExtensionHostMain(h.protocol,h.initData,s,null);D=i=>C.terminate(i)})}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/284e0db6c4cac1e557a43cd6691babdaafc2e1a9/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
